<img src="https://github.com/JuliaSIMD/LoopVectorization.jl/blob/main/docs/src/assets/logo.svg" width="300">

---

# LoopVectorization

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://JuliaSIMD.github.io/LoopVectorization.jl/stable)
[![Latest](https://img.shields.io/badge/docs-latest-blue.svg)](https://JuliaSIMD.github.io/LoopVectorization.jl/latest)
[![CI](https://github.com/JuliaSIMD/LoopVectorization.jl/workflows/CI/badge.svg)](https://github.com/JuliaSIMD/LoopVectorization.jl/actions?query=workflow%3ACI)
[![CI (Julia nightly)](https://github.com/JuliaSIMD/LoopVectorization.jl/workflows/CI%20(Julia%20nightly)/badge.svg)](https://github.com/JuliaSIMD/LoopVectorization.jl/actions?query=workflow%3A%22CI+%28Julia+nightly%29%22)
[![Codecov](https://codecov.io/gh/JuliaSIMD/LoopVectorization.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaSIMD/LoopVectorization.jl)

[![LoopVectorization Downloads](https://shields.io/endpoint?url=https://pkgs.genieframework.com/api/v1/badge/LoopVectorization)](https://pkgs.genieframework.com?packages=LoopVectorization)

## Maintanence
The plan is for `LoopVectorization.jl` to be maintained through the [SciML Small Grants](https://sciml.ai/small_grants/#update_loopvectorization_to_support_changes_in_julia_v112_200) program.
If you would like to see an issue fixed, or support extended to another Julia patch release, please consider:
1. Donating to the SciML Small Grants program, with a note on the purpose of your donation.
2. Create (a) PR(s) fixing the issue yourself. Apply for the small grant program first to claim the grant. Note that the small grants program is not a mentorship program; you would be expected to complete the tasks without guidance from maintainers, past or present.

Note that `LoopVectorization.jl` currently has deprecation warnings on Julia's 1.12 branch, causing test failures whenever `dep-warn=error`.

## Installation

```julia
using Pkg
Pkg.add("LoopVectorization")
```
LoopVectorization is supported on Julia 1.1 and later. It is tested on Julia 1.5 and nightly.

## Warning

Misusing LoopVectorization can have [serious consequences](http://catb.org/jargon/html/N/nasal-demons.html). Like `@inbounds`, misusing it can lead to segfaults and memory corruption.
We expect that any time you use the `@turbo` macro with a given block of code that you:
1. Are not indexing an array out of bounds. `@turbo` does not perform any bounds checking.
2. Are not iterating over an empty collection. Iterating over an empty loop such as `for i ∈ eachindex(Float64[])` is undefined behavior, and will likely result in the out of bounds memory accesses. Ensure that loops behave correctly.
3. Are not relying on a specific execution order. `@turbo` can and will re-order operations and loops inside its scope, so the correctness cannot depend on a particular order. You cannot implement `cumsum` with `@turbo`.
4. Are not using multiple loops at the same level in nested loops.

## Usage

This library provides the `@turbo` macro, which may be used to prefix a `for` loop or broadcast statement.
It then tries to vectorize the loop to improve runtime performance.

The macro assumes that loop iterations can be reordered. It also currently supports simple nested loops, where loop bounds of inner loops are constant across iterations of the outer loop, and only a single loop at each level of loop nest. These limitations should be removed in a future version.

## Benchmarks

Please see the documentation for benchmarks versus base Julia, Clang, icc, ifort, gfortran, and Eigen. If you believe any code or compiler flags can be improved, would like to submit your own benchmarks, or have Julia code using LoopVectorization that you would like to be tested for performance regressions on a semi-regular basis, please feel free to file an issue or PR with the code sample.

## Examples
### Dot Product

LLVM/Julia by default generate essentially optimal code for a primary vectorized part of this loop. In many cases -- such as the dot product -- this vectorized part of the loop computes 4*SIMD-vector-width iterations at a time.
On the CPU I'm running these benchmarks on with `Float64` data, the SIMD-vector-width is 8, meaning it will compute 32 iterations at a time.
However, LLVM is very slow at handling the tails, `length(iterations) % 32`. For this reason, [in benchmark plots](https://JuliaSIMD.github.io/LoopVectorization.jl/latest/examples/dot_product/) you can see performance drop as the size of the remainder increases.

For simple loops like a dot product, LoopVectorization.jl's most important optimization is to handle these tails more efficiently:
<details>
 <summaryClick me! ></summary>
<p>
 
 ```julia
julia> using LoopVectorization, BenchmarkTools

julia> function mydot(a, b)
           s = 0.0
           @inbounds @simd for i ∈ eachindex(a,b)
               s += a[i]*b[i]
           end
           s
       end
mydot (generic function with 1 method)

julia> function mydotavx(a, b)
           s = 0.0
           @turbo for i ∈ eachindex(a,b)
               s += a[i]*b[i]
           end
           s
       end
mydotavx (generic function with 1 method)

julia> a = rand(256); b = rand(256);

julia> @btime mydot($a, $b)
  12.220 ns (0 allocations: 0 bytes)
62.67140864639772

julia> @btime mydotavx($a, $b) # performance is similar
  12.104 ns (0 allocations: 0 bytes)
62.67140864639772

julia> a = rand(255); b = rand(255);

julia> @btime mydot($a, $b) # with loops shorter by 1, the remainder is now 32, and it is slow
  36.530 ns (0 allocations: 0 bytes)
61.25056244423578

julia> @btime mydotavx($a, $b) # performance remains mostly unchanged.
  12.226 ns (0 allocations: 0 bytes)
61.250562444235776
```
</p>
</details>



### Matrix Multiply
<details>
 <summaryClick me! ></summary>
<p>

We can also vectorize fancier loops. A likely familiar example to dive into:
```julia
julia> function mygemm!(C, A, B)
           @inbounds @fastmath for m ∈ axes(A,1), n ∈ axes(B,2)
               Cmn = zero(eltype(C))
               for k ∈ axes(A,2)
                   Cmn += A[m,k] * B[k,n]
               end
               C[m,n] = Cmn
           end
       end
mygemm! (generic function with 1 method)

julia> function mygemmavx!(C, A, B)
           @turbo for m ∈ axes(A,1), n ∈ axes(B,2)
               Cmn = zero(eltype(C))
               for k ∈ axes(A,2)
                   Cmn += A[m,k] * B[k,n]
               end
               C[m,n] = Cmn
           end
       end
mygemmavx! (generic function with 1 method)

julia> M, K, N = 191, 189, 171;

julia> C1 = Matrix{Float64}(undef, M, N); A = randn(M, K); B = randn(K, N);

julia> C2 = similar(C1); C3 = similar(C1);

julia> @benchmark mygemmavx!($C1, $A, $B)
BenchmarkTools.Trial:
  memory estimate:  0 bytes
  allocs estimate:  0
  --------------
  minimum time:     111.722 μs (0.00% GC)
  median time:      112.528 μs (0.00% GC)
  mean time:        112.673 μs (0.00% GC)
  maximum time:     189.400 μs (0.00% GC)
  --------------
  samples:          10000
  evals/sample:     1

julia> @benchmark mygemm!($C2, $A, $B)
BenchmarkTools.Trial:
  memory estimate:  0 bytes
  allocs estimate:  0
  --------------
  minimum time:     4.891 ms (0.00% GC)
  median time:      4.899 ms (0.00% GC)
  mean time:        4.899 ms (0.00% GC)
  maximum time:     5.049 ms (0.00% GC)
  --------------
  samples:          1021
  evals/sample:     1

julia> using LinearAlgebra, Test

julia> @test all(C1 .≈ C2)
Test Passed

julia> BLAS.set_num_threads(1); BLAS.vendor()
:mkl

julia> @benchmark mul!($C3, $A, $B)
BenchmarkTools.Trial:
  memory estimate:  0 bytes
  allocs estimate:  0
  --------------
  minimum time:     117.221 μs (0.00% GC)
  median time:      118.745 μs (0.00% GC)
  mean time:        118.892 μs (0.00% GC)
  maximum time:     193.826 μs (0.00% GC)
  --------------
  samples:          10000
  evals/sample:     1

julia> @test all(C1 .≈ C3)
Test Passed

julia> 2e-9M*K*N ./ (111.722e-6, 4.891e-3, 117.221e-6)
(110.50516460500171, 2.524199141279902, 105.32121377568868)
```
It can produce a good macro kernel. An implementation of matrix multiplication able to handle large matrices would need to perform blocking and packing of arrays to prevent the operations from being memory bottle-necked.
Some day, LoopVectorization may itself try to model the costs of memory movement in the L1 and L2 cache, and use these to generate loops around the macro kernel following the work of [Low, et al. (2016)](http://www.cs.utexas.edu/users/flame/pubs/TOMS-BLIS-Analytical.pdf).

But for now, you should view it as a tool for generating efficient computational kernels, leaving tasks of parallelization and cache efficiency to you.


<!-- ```julia -->


<!-- ``` -->

</p>
</details>

### Broadcasting
<details>
 <summaryClick me! ></summary>
<p>

Another example, a straightforward operation expressed well via broadcasting and `*ˡ` (which is typed `*\^l`), the lazy matrix multiplication operator:
```julia
julia> using LoopVectorization, LinearAlgebra, BenchmarkTools, Test; BLAS.set_num_threads(1)

julia> A = rand(5,77); B = rand(77, 51); C = rand(51,49); D = rand(49,51);

julia> X1 =      view(A,1,:) .+ B  *  (C .+ D');

julia> X2 = @turbo view(A,1,:) .+ B .*ˡ (C .+ D');

julia> @test X1 ≈ X2
Test Passed

julia> buf1 = Matrix{Float64}(undef, size(C,1), size(C,2));

julia> buf2 = similar(X1);

julia> @btime $X1 .= view($A,1,:) .+ mul!($buf2, $B, ($buf1 .= $C .+ $D'));
  9.188 μs (0 allocations: 0 bytes)

julia> @btime @turbo $X2 .= view($A,1,:) .+ $B .*ˡ ($C .+ $D');
  6.751 μs (0 allocations: 0 bytes)

julia> @test X1 ≈ X2
Test Passed

julia> AmulBtest!(X1, B, C, D, view(A,1,:))

julia> AmulBtest2!(X2, B, C, D, view(A,1,:))

julia> @test X1 ≈ X2
Test Passed
```
The lazy matrix multiplication operator `*ˡ` escapes broadcasts and fuses, making it easy to write code that avoids intermediates. However, I would recommend always checking if splitting the operation into pieces, or at least isolating the matrix multiplication, increases performance. That will often be the case, especially if the matrices are large, where a separate multiplication can leverage BLAS (and perhaps take advantage of threads).
This may improve as the optimizations within LoopVectorization improve.

Note that loops will be faster than broadcasting in general. This is because the behavior of broadcasts is determined by runtime information (i.e., dimensions other than the leading dimension of size `1` will be broadcasted; it is not known which these will be at compile time).
```julia
julia> function AmulBtest!(C,A,Bk,Bn,d)
          @turbo for m ∈ axes(A,1), n ∈ axes(Bk,2)
             ΔCmn = zero(eltype(C))
             for k ∈ axes(A,2)
                ΔCmn += A[m,k] * (Bk[k,n] + Bn[n,k])
             end
             C[m,n] = ΔCmn + d[m]
          end
       end
AmulBtest! (generic function with 1 method)

julia> AmulBtest!(X2, B, C, D, view(A,1,:))

julia> @test X1 ≈ X2
Test Passed

julia> @benchmark AmulBtest!($X2, $B, $C, $D, view($A,1,:))
BenchmarkTools.Trial:
  memory estimate:  0 bytes
  allocs estimate:  0
  --------------
  minimum time:     5.793 μs (0.00% GC)
  median time:      5.816 μs (0.00% GC)
  mean time:        5.824 μs (0.00% GC)
  maximum time:     14.234 μs (0.00% GC)
  --------------
  samples:          10000
  evals/sample:     6
```

Note: `@turbo` does not support passing of kwargs to function calls to which it is applied, e.g:
```julia
julia> @turbo round.(rand(10))

julia> @turbo round.(rand(10); digits = 3)
ERROR: TypeError: in typeassert, expected Expr, got a value of type GlobalRef
```

You can work around this by creating a anonymous function before applying `@turbo` as follows:
```julia
struct KwargCall{F,T}
    f::F
    x::T
end
@inline (f::KwargCall)(args...) = f.f(args...; f.x...)

f = KwargCall(round, (digits = 3,));
@turbo f.(rand(10))
10-element Vector{Float64}:
 0.763
 ⋮
 0.851
```

</p>
</details>


### Dealing with structs
<details>
 <summaryClick me! ></summary>
<p>

The key to the `@turbo` macro's performance gains is leveraging knowledge of exactly how data like `Float64`s and `Int`s are handled by a CPU. As such, it is not strightforward to generalize the `@turbo` macro to work on arrays containing structs such as `Matrix{Complex{Float64}}`. Instead, it is currently recommended that users wishing to apply `@turbo` to arrays of structs use packages such as [StructArrays.jl](https://github.com/JuliaArrays/StructArrays.jl) which transform an array where each element is a struct into a struct where each element is an array. Using StructArrays.jl, we can write a matrix multiply (gemm) kernel that works on matrices of `Complex{Float64}`s and `Complex{Int}`s:
```julia 
using LoopVectorization, LinearAlgebra, StructArrays, BenchmarkTools, Test

BLAS.set_num_threads(1); @show BLAS.vendor()

const MatrixFInt64 = Union{Matrix{Float64}, Matrix{Int}}

function mul_avx!(C::MatrixFInt64, A::MatrixFInt64, B::MatrixFInt64)
    @turbo for m ∈ 1:size(A,1), n ∈ 1:size(B,2)
        Cmn = zero(eltype(C))
        for k ∈ 1:size(A,2)
            Cmn += A[m,k] * B[k,n]
        end
        C[m,n] = Cmn
    end
end

function mul_add_avx!(C::MatrixFInt64, A::MatrixFInt64, B::MatrixFInt64, factor=1)
    @turbo for m ∈ 1:size(A,1), n ∈ 1:size(B,2)
        ΔCmn = zero(eltype(C))
        for k ∈ 1:size(A,2)
            ΔCmn += A[m,k] * B[k,n]
        end
        C[m,n] += factor * ΔCmn
    end
end

const StructMatrixComplexFInt64 = Union{StructArray{ComplexF64,2}, StructArray{Complex{Int},2}}

function mul_avx!(C:: StructMatrixComplexFInt64, A::StructMatrixComplexFInt64, B::StructMatrixComplexFInt64)
    mul_avx!(    C.re, A.re, B.re)     # C.re = A.re * B.re
    mul_add_avx!(C.re, A.im, B.im, -1) # C.re = C.re - A.im * B.im
    mul_avx!(    C.im, A.re, B.im)     # C.im = A.re * B.im
    mul_add_avx!(C.im, A.im, B.re)     # C.im = C.im + A.im * B.re
end
```
this `mul_avx!` kernel can now accept `StructArray` matrices of complex numbers and multiply them efficiently:
```julia
julia> M, K, N = 56, 57, 58
(56, 57, 58)

julia> A  = StructArray(randn(ComplexF64, M, K));

julia> B  = StructArray(randn(ComplexF64, K, N));

julia> C1 = StructArray(Matrix{ComplexF64}(undef, M, N));

julia> C2 = collect(similar(C1));

julia> @btime mul_avx!($C1, $A, $B)
  13.525 μs (0 allocations: 0 bytes)

julia> @btime mul!(    $C2, $(collect(A)), $(collect(B))); # collect turns the StructArray into a regular Array
  14.003 μs (0 allocations: 0 bytes)

julia> @test C1 ≈ C2
Test Passed
```

Similar approaches can be taken to make kernels working with a variety of numeric struct types such as [dual numbers](https://github.com/JuliaDiff/DualNumbers.jl), [DoubleFloats](https://github.com/JuliaMath/DoubleFloats.jl), etc. 

</p>
</details>

## Packages using LoopVectorization

* [Gaius.jl](https://github.com/MasonProtter/Gaius.jl)
* [MaBLAS.jl](https://github.com/YingboMa/MaBLAS.jl)
* [Octavian.jl](https://github.com/JuliaLinearAlgebra/Octavian.jl)
* [PaddedMatrices.jl](https://github.com/JuliaSIMD/PaddedMatrices.jl)
* [RecursiveFactorization.jl](https://github.com/YingboMa/RecursiveFactorization.jl)
* [SnpArrays.jl](https://github.com/OpenMendel/SnpArrays.jl)
* [Tullio.jl](https://github.com/mcabbott/Tullio.jl)
* [DianoiaML.jl](https://github.com/SkyWorld117/DianoiaML.jl)
* [TropicalGEMM.jl](https://github.com/TensorBFS/TropicalGEMM.jl)
* [Trixi.jl](https://github.com/trixi-framework/Trixi.jl)
* [VectorizedStatistics.jl](https://github.com/JuliaSIMD/VectorizedStatistics.jl)
* [NaNStatistics.jl](https://github.com/brenhinkeller/NaNStatistics.jl)
* [VectorizedReduction.jl](https://github.com/andrewjradcliffe/VectorizedReduction.jl)
* [DynamicExpressions.jl](https://github.com/SymbolicML/SymbolicRegression.jl)
* [PySR](https://github.com/MilesCranmer/PySR) and [SymbolicRegression.jl](https://github.com/MilesCranmer/SymbolicRegression.jl)
* [Lux.jl](https://github.com/LuxDL/Lux.jl) and [LuxLib.jl](https://github.com/LuxDL/LuxLib.jl)

If you're using LoopVectorization, please feel free to file a PR adding yours to the list!

function selector!(z, x)
  @inbounds for i ∈ eachindex(x)
    z[i] = x[i] > 0.5 ? i : x[i]
  end
  z
end
function selector_turbo!(z, x)
  @turbo for i ∈ eachindex(x)
    z[i] = x[i] > 0.5 ? i : x[i]
  end
  z
end

# testset for using them in loops
@testset "Loop Induction Variables" begin
  @show @__LINE__
  f(x) = cos(x) * log(x)
  function avxmax(v)
    max_x = -Inf
    @turbo for i ∈ eachindex(v)
      x = f(i)
      max_x = max(max_x, x)
    end
    max_x
  end
  function avxextrema(v)
    max_x = -Inf
    min_x = Inf
    @turbo for i ∈ eachindex(v)
      x = f(i)
      max_x = max(max_x, x)
      min_x = min(min_x, x)
    end
    min_x, max_x
  end

  v = 1:19
  minref, maxref = extrema(f, v)
  @test maxref ≈ avxmax(v)
  minavx, maxavx = avxextrema(v)
  @test minref ≈ minavx
  @test maxref ≈ maxavx

  x = rand(119)
  y0 = similar(x)
  y1 = similar(y0)
  @test selector!(y0, x) == selector_turbo!(y1, x)
end

using LoopVectorization, Test

function tuptestturbo(x, y, t)
  s = 0.0
  @turbo for i in eachindex(x, y)
    s += x[i] * t[1] - y[i] * t[2]
  end
  s
end
function tuptest(x, y, t)
  s = 0.0
  @inbounds @fastmath for i in eachindex(x, y)
    s += x[i] * t[1] - y[i] * t[2]
  end
  s
end
x = rand(127);
y = rand(127);
t = (rand(), rand());
@test tuptestturbo(x, y, t) ≈ tuptest(x, y, t)

## Currently, if/else will create its own local scope
## Assignments will not register in the loop's main scope
## although stores and return values will.
negateop!(ls::LoopSet, condop::Operation, elementbytes::Int) =
  add_compute!(ls, gensym!(ls, "negated#mask"), :~, [condop], elementbytes)

function add_if!(
  ls::LoopSet,
  LHS::Symbol,
  RHS::Expr,
  elementbytes::Int,
  position::Int,
  mpref::Union{Nothing,ArrayReferenceMetaPosition} = nothing
)
  # for now, just simple 1-liners
  @assert length(RHS.args) == 3 "if statements without an else cannot be assigned to a variable."
  condition = first(RHS.args)
  condop = if condition isa Symbol
    getop(ls, condition, elementbytes)
  elseif mpref === nothing
    add_operation!(ls, gensym!(ls, "mask"), condition, elementbytes, position)
  else
    add_operation!(
      ls,
      gensym!(ls, "mask"),
      condition,
      mpref,
      elementbytes,
      position
    )
  end
  iftrue = RHS.args[2]
  if iftrue isa Expr
    trueop =
      add_operation!(ls, gensym!(ls, "iftrue"), iftrue, elementbytes, position)
    if iftrue.head === :ref &&
       all(ld -> ld ∈ loopdependencies(trueop), loopdependencies(condop)) &&
       !search_tree(parents(condop), trueop)
      trueop.instruction = Instruction(:conditionalload)
      if parents(trueop) !== NOPARENTS
        push!(parents(trueop), condop)
      else
        trueop.parents = [condop]
      end
    end
  else
    trueop = getop(ls, iftrue, elementbytes)
  end
  iffalse = RHS.args[3]
  if trueop.instruction === Instruction(:conditionalload)
    if ((iffalse isa Number) && (iffalse == 0)) ||
       (Meta.isexpr(iffalse, :call, 2) && (iffalse.args[1] === :zero))
      trueop.variable = LHS
      ls.opdict[LHS] = trueop
      return trueop
    end
  end
  if iffalse isa Expr
    falseop = add_operation!(
      ls,
      gensym!(ls, "iffalse"),
      iffalse,
      elementbytes,
      position
    )
    if iffalse.head === :ref &&
       all(ld -> ld ∈ loopdependencies(falseop), loopdependencies(condop)) &&
       !search_tree(parents(condop), falseop)
      falseop.instruction = Instruction(:conditionalload)
      negop = negateop!(ls, condop, elementbytes)
      if parents(falseop) !== NOPARENTS
        push!(parents(falseop), negop)
      else
        falseop.parents = [negop]
      end
      if (any(==(identifier(trueop)), Iterators.map(first, ls.preamble_zeros)))
        falseop.variable = LHS
        ls.opdict[LHS] = falseop
        return falseop
      end
    end
  else
    falseop = getop(ls, iffalse, elementbytes)
  end
  add_compute_ifelse!(ls, LHS, condop, trueop, falseop, elementbytes)
end

function add_andblock!(
  ls::LoopSet,
  condop::Operation,
  LHS,
  rhsop::Operation,
  elementbytes::Int,
  position::Int
)
  if LHS isa Symbol
    altop = getop(ls, LHS, elementbytes)
    return add_compute_ifelse!(ls, LHS, condop, rhsop, altop, elementbytes)
  elseif LHS isa Expr && LHS.head === :ref
    return add_conditional_store!(ls, LHS, condop, rhsop, elementbytes)
  else
    throw("Don't know how to assign onto $LHS.")
  end
end
function add_andblock!(
  ls::LoopSet,
  condop::Operation,
  LHS,
  RHS::Expr,
  elementbytes::Int,
  position::Int
)
  rhsop =
    add_compute!(ls, gensym!(ls, "iftruerhs"), RHS, elementbytes, position)
  add_andblock!(ls, condop, LHS, rhsop, elementbytes, position)
end
function add_andblock!(
  ls::LoopSet,
  condop::Operation,
  LHS,
  RHS,
  elementbytes::Int,
  position::Int
)
  rhsop = getop(ls, RHS, elementbytes)
  add_andblock!(ls, condop, LHS, rhsop, elementbytes, position)
end
function add_andblock!(
  ls::LoopSet,
  condexpr::Expr,
  condeval::Expr,
  elementbytes::Int,
  position::Int
)
  condop =
    add_operation!(ls, gensym!(ls, "mask"), condexpr, elementbytes, position)
  add_andblock!(ls, condop, condeval, elementbytes, position)
end
function add_andblock!(
  ls::LoopSet,
  condop::Operation,
  condeval::Expr,
  elementbytes::Int,
  position::Int
)
  if condeval.head === :call
    @assert first(condeval.args) === :setindex!
    array, raw_indices = ref_from_setindex!(ls, condeval)
    ref = Expr(:ref, array)
    append!(ref.args, raw_indices)
    return add_andblock!(
      ls,
      condop,
      ref,
      condeval.args[3],
      elementbytes,
      position
    )
  end
  @assert condeval.head === :(=)
  @assert length(condeval.args) == 2
  LHS = condeval.args[1]
  RHS = condeval.args[2]
  add_andblock!(ls, condop, LHS, RHS, elementbytes, position)
end
function add_andblock!(ls::LoopSet, ex::Expr, elementbytes::Int, position::Int)
  condexpr = first(ex.args)
  if condexpr isa Expr
    add_andblock!(ls, condexpr, last(ex.args)::Expr, elementbytes, position)
  else
    add_andblock!(
      ls,
      getop(ls, condexpr, elementbytes),
      last(ex.args)::Expr,
      elementbytes,
      position
    )
  end
end

function add_orblock!(
  ls::LoopSet,
  condop::Operation,
  LHS,
  rhsop::Operation,
  elementbytes::Int,
  position::Int
)
  negatedcondop = negateop!(ls, condop, elementbytes)
  if LHS isa Symbol
    altop = getop(ls, LHS, elementbytes)
    # return add_compute!(ls, LHS, :ifelse, [condop, altop, rhsop], elementbytes)
    # Placing altop second seems to let LLVM fuse operations; but as of LLVM 9.0.1 it will not if altop is first
    # therefore, we negate the condition and switch order so that the altop is second.
    return add_compute_ifelse!(
      ls,
      LHS,
      negatedcondop,
      rhsop,
      altop,
      elementbytes
    )
  elseif LHS isa Expr && LHS.head === :ref
    # negatedcondop = add_compute!(ls, gensym(:negated_mask), :~, [condop], elementbytes)
    return add_conditional_store!(ls, LHS, negatedcondop, rhsop, elementbytes)
  else
    throw("Don't know how to assign onto $LHS.")
  end
end
function add_orblock!(
  ls::LoopSet,
  condop::Operation,
  LHS,
  RHS::Expr,
  elementbytes::Int,
  position::Int
)
  rhsop =
    add_compute!(ls, gensym!(ls, "iffalserhs"), RHS, elementbytes, position)
  add_orblock!(ls, condop, LHS, rhsop, elementbytes, position)
end
function add_orblock!(
  ls::LoopSet,
  condop::Operation,
  LHS,
  RHS,
  elementbytes::Int,
  position::Int
)
  rhsop = getop(ls, RHS, elementbytes)
  add_orblock!(ls, condop, LHS, rhsop, elementbytes, position)
end
function add_orblock!(
  ls::LoopSet,
  condexpr::Expr,
  condeval::Expr,
  elementbytes::Int,
  position::Int
)
  condop =
    add_operation!(ls, gensym!(ls, "mask"), condexpr, elementbytes, position)
  if condeval.head === :call
    @assert first(condeval.args) === :setindex!
    array, raw_indices = ref_from_setindex!(ls, condeval)
    ref = Expr(:ref, array)
    append!(ref.args, raw_indices)
    return add_orblock!(
      ls,
      condop,
      ref,
      condeval.args[3],
      elementbytes,
      position
    )
  end
  @assert condeval.head === :(=)
  @assert length(condeval.args) == 2
  LHS = condeval.args[1]
  RHS = condeval.args[2]
  add_orblock!(ls, condop, LHS, RHS, elementbytes, position)
end
function add_orblock!(ls::LoopSet, ex::Expr, elementbytes::Int, position::Int)
  add_orblock!(
    ls,
    first(ex.args)::Expr,
    last(ex.args)::Expr,
    elementbytes,
    position
  )
end

struct MaybeKnown
  hint::Int
  sym::Symbol
  known::Bool
end
struct Loop
  itersymbol::Symbol
  start::MaybeKnown
  stop::MaybeKnown
  step::MaybeKnown
  rangesym::Symbol # === Symbol("") means loop is static
  lensym::Symbol
end

struct UnrollSymbols
  u₁loopsym::Symbol
  u₂loopsym::Symbol
  vloopsym::Symbol
end
struct UnrollArgs
  u₁loop::Loop
  u₂loop::Loop
  vloop::Loop
  u₁::Int
  u₂max::Int
  suffix::Int # -1 means not tiled
end
UnPack.unpack(ua::UnrollArgs, ::Val{:u₁loopsym}) =
  getfield(getfield(ua, :u₁loop), :itersymbol)
UnPack.unpack(ua::UnrollArgs, ::Val{:u₂loopsym}) =
  getfield(getfield(ua, :u₂loop), :itersymbol)
UnPack.unpack(ua::UnrollArgs, ::Val{:vloopsym}) =
  getfield(getfield(ua, :vloop), :itersymbol)
UnPack.unpack(ua::UnrollArgs, ::Val{:u₁step}) =
  getfield(getfield(ua, :u₁loop), :step)
UnPack.unpack(ua::UnrollArgs, ::Val{:u₂step}) =
  getfield(getfield(ua, :u₂loop), :step)
UnPack.unpack(ua::UnrollArgs, ::Val{:vstep}) =
  getfield(getfield(ua, :vloop), :step)

struct UnrollSpecification
  u₁loopnum::Int
  u₂loopnum::Int
  vloopnum::Int
  u₁::Int
  u₂::Int
end
# UnrollSpecification(ls::LoopSet, u₁loop::Loop, vloopsym::Symbol, u₁, u₂) = UnrollSpecification(ls, u₁loop.itersymbol, vloopsym, u₁, u₂)
function UnrollSpecification(us::UnrollSpecification, u₁, u₂)
  @unpack u₁loopnum, u₂loopnum, vloopnum = us
  UnrollSpecification(u₁loopnum, u₂loopnum, vloopnum, u₁, u₂)
end
# function UnrollSpecification(us::UnrollSpecification; u₁ = us.u₁, u₂ = us.u₂)
#     @unpack u₁loopnum, u₂loopnum, vloopnum = us
#     UnrollSpecification(u₁loopnum, u₂loopnum, vloopnum, u₁, u₂)
# end
isunrolled1(us::UnrollSpecification, n::Int) = us.u₁loopnum == n
isunrolled2(us::UnrollSpecification, n::Int) =
  !isunrolled1(us, n) && us.u₂loopnum == n
isvectorized(us::UnrollSpecification, n::Int) = us.vloopnum == n
function unrollfactor(us::UnrollSpecification, n::Int)
  @unpack u₁loopnum, u₂loopnum, u₁, u₂ = us
  (u₁loopnum == n) ? u₁ : ((u₂loopnum == n) ? u₂ : 1)
end
function pushexpr!(ex::Expr, mk::MaybeKnown)
  if isknown(mk)
    push!(ex.args, staticexpr(gethint(mk)))
  else
    push!(ex.args, getsym(mk))
  end
  nothing
end
pushexpr!(ex::Expr, x::Union{Symbol,Expr}) = (push!(ex.args, x); nothing)
pushexpr!(ex::Expr, x::Integer) =
  (push!(ex.args, staticexpr(convert(Int, x))); nothing)
pushexpr!(ex::Expr, @nospecialize(x::StaticInt)) = (push!(ex.args, x); nothing)
MaybeKnown(x::Integer) =
  MaybeKnown(convert(Int, x), Symbol("##UNDEFINED##"), true)
MaybeKnown(x::Integer, ::Int) = MaybeKnown(x)
MaybeKnown(x::Symbol, default::Int) = MaybeKnown(default, x, false)

isknown(mk::MaybeKnown) = getfield(mk, :known)
getsym(mk::MaybeKnown) = getfield(mk, :sym)
gethint(mk::MaybeKnown) = getfield(mk, :hint)
Base.isone(mk::MaybeKnown) = isknown(mk) && isone(gethint(mk))
Base.iszero(mk::MaybeKnown) = isknown(mk) && iszero(gethint(mk))
gethint(a::Integer) = a

function Loop(
  itersymbol::Symbol,
  start::Union{Int,Symbol},
  stop::Union{Int,Symbol},
  step::Union{Int,Symbol},
  rangename::Symbol,
  lensym::Symbol
)
  Loop(
    itersymbol,
    MaybeKnown(start, 1),
    MaybeKnown(stop, 1024),
    MaybeKnown(step, 1),
    rangename,
    lensym
  )
end
startstopΔ(loop::Loop) = gethint(last(loop)) - gethint(first(loop))
function Base.length(loop::Loop)
  l = startstopΔ(loop)
  s = gethint(step(loop))
  (isone(s) ? l : cld(l, s)) + 1
end
Base.first(l::Loop) = getfield(l, :start)
Base.last(l::Loop) = getfield(l, :stop)
Base.step(l::Loop) = getfield(l, :step)

isstaticloop(l::Loop) = isknown(first(l)) & isknown(last(l)) & isknown(step(l))
unitstep(l::Loop) = isone(step(l))

function startloop(loop::Loop, itersymbol, staticinit::Bool = false)
  start = first(loop)
  if isknown(start)
    if staticinit
      Expr(:(=), itersymbol, staticexpr(gethint(start)))
    else
      Expr(:(=), itersymbol, gethint(start))
    end
  else
    Expr(:(=), itersymbol, Expr(:call, lv(:Int), getsym(start)))
  end
end

pushmulexpr!(q, a, b) = (push!(q.args, mulexpr(a, b)); nothing)
function pushmulexpr!(q, a, b::Integer)
  isone(b) ? push!(q.args, a) : push!(q.args, mulexpr(a, b))
  nothing
end

# function arithmetic_expr(f, a, b)
#     call = Expr(:call, lv(f))
#     if isa(a, MaybeKnown)
#         pushexpr!(
# end
isknown(x::Union{Symbol,Expr}) = false
isknown(x::Integer) = true
addexpr(a, b) = arithmeticexpr(+, :vadd_nsw, a, b)
subexpr(a, b) = arithmeticexpr(-, :vsub_nsw, a, b)
mulexpr(a, b) = arithmeticexpr(*, :vmul_nsw, a, b)
lazymulexpr(a, b) = arithmeticexpr(*, :lazymul, a, b)
function arithmeticexpr(
  op,
  f,
  a::Union{Integer,MaybeKnown},
  b::Union{Integer,MaybeKnown}
)
  if isknown(a) & isknown(b)
    return staticexpr(op(gethint(a), gethint(b)))
  else
    return _arithmeticexpr(f, a, b)
  end
end
arithmeticexpr(_, f, a, b) = _arithmeticexpr(f, a, b)
function _arithmeticexpr(f, a, b)
  ex = Expr(:call, lv(f))
  pushexpr!(ex, a)
  pushexpr!(ex, b)
  return ex
end
mulexpr(a, b, c) = arithmeticexpr(*, 1, :vmul_nsw, a, b, c)
addexpr(a, b, c) = arithmeticexpr(+, 0, :vadd_nsw, a, b, c)
function arithmeticexpr(op, init, f, a, b, c)
  ex = Expr(:call, lv(f))
  p = init
  if isknown(a)
    p = op(p, gethint(a))
    known = 1
  else
    pushexpr!(ex, a)
    known = 0
  end
  if isknown(b)
    p = op(p, gethint(b))
    known += 1
  else
    pushexpr!(ex, b)
  end
  if isknown(c)
    p = op(p, gethint(c))
    known += 1
  else
    if known == 0
      ex = Expr(:call, lv(f), ex)
    end
    pushexpr!(ex, c)
  end
  if known == 3
    return staticexpr(p)
  else
    if known == 2
      pushexpr!(ex, p)
      return ex
    elseif known == 1
      if ((op === (+)) && (p == 0)) || ((op === (*)) && (p == 1))
        return ex
      else
        return Expr(:call, lv(f), ex, staticexpr(p))
      end
    else#known == 0
      return ex
    end
  end
end

function addexpr(ex, incr::Integer)
  if incr > 0
    f = :vadd_nsw
  else
    f = :vsub_nsw
    incr = -incr
  end
  expr = Expr(:call, lv(f))
  pushexpr!(expr, ex)
  pushexpr!(expr, convert(Int, incr))
  expr
end
staticmulincr(ptr, incr) =
  Expr(:call, lv(:staticmul), Expr(:call, :eltype, ptr), incr)

@inline cmpend(i::Int, r::AbstractCloseOpen) = i < getfield(r, :upper)
@inline cmpend(i::Int, r::AbstractUnitRange) = i ≤ last(r)
@inline cmpend(i::Int, r::AbstractRange) = i ≤ last(r)

@inline vcmpend(i::Int, r::AbstractCloseOpen, ::StaticInt{W}) where {W} =
  i ≤ vsub_nsw((getfield(r, :upper) % Int), W)
@inline vcmpendzs(i::Int, r::AbstractCloseOpen, ::StaticInt{W}) where {W} =
  i ≠ ((getfield(r, :upper) % Int) & (-W))
@inline vcmpend(i::Int, r::AbstractUnitRange, ::StaticInt{W}) where {W} =
  i ≤ vsub_nsw(last(r), W - 1)
@inline vcmpendzs(i::Int, r::AbstractUnitRange, ::StaticInt{W}) where {W} =
  i ≠ (length(r) & (-W))
@inline vcmpend(i::Int, r::AbstractRange, ::StaticInt{W}) where {W} =
  i ≤ vsub_nsw(last(r), vmul_nsw(vsub_nsw(W, 1), step(r)))
@inline vcmpendzs(i::Int, r::AbstractRange, ::StaticInt{W}) where {W} =
  i ≤ vsub_nsw(last(r), vmul_nsw(vsub_nsw(W, 1), step(r)))

function staticloopexpr(loop::Loop)
  f = first(loop)
  s = step(loop)
  l = last(loop)
  if isone(s)
    Expr(
      :call,
      GlobalRef(Base, :(:)),
      staticexpr(gethint(f)),
      staticexpr(gethint(l))
    )
  else
    Expr(
      :call,
      GlobalRef(Base, :(:)),
      staticexpr(gethint(f)),
      staticexpr(gethint(s)),
      staticexpr(gethint(l))
    )
  end
end
function vec_looprange(loop::Loop, UF::Int, mangledname)
  fast = ispow2(UF) && iszero(first(loop))
  if loop.rangesym === Symbol("") # means loop is static
    vec_looprange(UF, mangledname, staticloopexpr(loop), fast)
  else
    vec_looprange(UF, mangledname, loop.rangesym, fast)
  end
end
function vec_looprange(
  UF::Int,
  mangledname,
  r::Union{Expr,Symbol},
  zerostart::Bool
)
  cmp = zerostart ? lv(:vcmpendzs) : lv(:vcmpend)
  if isone(UF)
    Expr(:call, cmp, mangledname, r, VECTORWIDTHSYMBOL)
  else
    Expr(:call, cmp, mangledname, r, mulexpr(VECTORWIDTHSYMBOL, UF))
  end
end
function looprange(loop::Loop, UF::Int, mangledname)
  if loop.rangesym === Symbol("") # means loop is static
    looprange(UF, mangledname, staticloopexpr(loop))
  else
    looprange(UF, mangledname, loop.rangesym)
  end
end
function looprange(UF::Int, mangledname, r::Union{Expr,Symbol})
  if isone(UF)
    Expr(:call, lv(:cmpend), mangledname, r)
  else
    Expr(:call, lv(:vcmpend), mangledname, r, staticexpr(UF))
  end
end

function terminatecondition(
  loop::Loop,
  us::UnrollSpecification,
  n::Int,
  mangledname::Symbol,
  inclmask::Bool,
  UF::Int = unrollfactor(us, n)
)
  if !isvectorized(us, n)
    looprange(loop, UF, mangledname)
  elseif inclmask
    looprange(loop, 1, mangledname)
  else
    vec_looprange(loop, UF, mangledname) # may not be u₂loop
  end
end

function incrementloopcounter(
  us::UnrollSpecification,
  n::Int,
  mangledname::Symbol,
  UF::Int,
  l::Loop
)
  incr = step(l)
  if isknown(incr)
    incrementloopcounter(us, n, mangledname, UF * gethint(incr))
  else
    incrementloopcounter(us, n, mangledname, UF, getsym(incr))
  end
end
function incrementloopcounter(
  us::UnrollSpecification,
  n::Int,
  mangledname::Symbol,
  UF::Int
)
  if isvectorized(us, n)
    if isone(UF)
      Expr(:(=), mangledname, addexpr(VECTORWIDTHSYMBOL, mangledname))
    else
      Expr(
        :(=),
        mangledname,
        addexpr(mulexpr(VECTORWIDTHSYMBOL, staticexpr(UF)), mangledname)
      )
    end
  else
    Expr(:(=), mangledname, addexpr(mangledname, UF))
  end
end
function incrementloopcounter(
  us::UnrollSpecification,
  n::Int,
  mangledname::Symbol,
  UF::Int,
  incr::Symbol
)
  if isvectorized(us, n)
    if isone(UF)
      Expr(
        :(=),
        mangledname,
        addexpr(mulexpr(VECTORWIDTHSYMBOL, incr), mangledname)
      )
    else
      Expr(
        :(=),
        mangledname,
        addexpr(
          mulexpr(mulexpr(VECTORWIDTHSYMBOL, staticexpr(UF)), incr),
          mangledname
        )
      )
    end
  else
    Expr(:(=), mangledname, addexpr(mangledname, mulexpr(incr, UF)))
  end
end

function incrementloopcounter!(
  q,
  us::UnrollSpecification,
  n::Int,
  UF::Int,
  l::Loop
)
  incr = step(l)
  if isknown(incr)
    incrementloopcounter!(q, us, n, UF * gethint(incr))
  else
    incrementloopcounter!(q, us, n, UF, getsym(incr))
  end
end
function incrementloopcounter!(q, us::UnrollSpecification, n::Int, UF::Int)
  if isvectorized(us, n)
    if isone(UF)
      push!(q.args, VECTORWIDTHSYMBOL)
    else
      push!(q.args, mulexpr(VECTORWIDTHSYMBOL, staticexpr(UF)))
    end
  else
    push!(q.args, staticexpr(UF))
  end
end
function incrementloopcounter!(
  q,
  us::UnrollSpecification,
  n::Int,
  UF::Int,
  incr::Symbol
)
  if isvectorized(us, n)
    if isone(UF)
      push!(q.args, mulexpr(VECTORWIDTHSYMBOL, incr))
    else
      push!(q.args, mulexpr(mulexpr(VECTORWIDTHSYMBOL, staticexpr(UF)), incr))
    end
  else
    push!(q.args, mulexpr(staticexpr(UF), incr))
  end
end

# load/compute/store × isunrolled × istiled × pre/post loop × Loop number
struct LoopOrder <: AbstractArray{Vector{Operation},5}
  oporder::Vector{Vector{Operation}}
  loopnames::Vector{Symbol}
  bestorder::Vector{Symbol}
end
# function LoopOrder(N::Int)
#     LoopOrder(
#         [ Operation[] for _ ∈ 1:8N ],
#         Vector{Symbol}(undef, N), Vector{Symbol}(undef, N)
#     )
# end
LoopOrder() = LoopOrder(Vector{Operation}[], Symbol[], Symbol[])
Base.empty!(lo::LoopOrder) = foreach(empty!, lo.oporder)
function Base.resize!(lo::LoopOrder, N::Int)
  Nold = length(lo.loopnames)
  resize!(lo.oporder, 8N)
  for n ∈ 8Nold+1:8N
    lo.oporder[n] = Operation[]
  end
  resize!(lo.loopnames, N)
  resize!(lo.bestorder, N)
  lo
end
Base.size(lo::LoopOrder) = (2, 2, 2, length(lo.loopnames))
Base.@propagate_inbounds Base.getindex(lo::LoopOrder, i::Int) = lo.oporder[i]
Base.@propagate_inbounds Base.getindex(
  lo::LoopOrder,
  i::Vararg{Int,K}
) where {K} = lo.oporder[LinearIndices(size(lo))[i...]]

@enum NumberType::Int8 HardInt HardFloat IntOrFloat INVALID

struct LoopStartStopManager
  terminators::Vector{Int}
  incrementedptrs::Vector{Vector{ArrayReferenceMeta}}
  uniquearrayrefs::Vector{ArrayReferenceMeta}
end
# Must make it easy to iterate
# outer_reductions is a vector of indices (within operation vectors) of the reduction operation, eg the vmuladd op in a dot product
# O(N) search is faster at small sizes
mutable struct LoopSet
  loopsymbols::Vector{Symbol}
  loopsymbol_offsets::Vector{Int}  # symbol loopsymbols[i] corresponds to loops[lso[i]+1:lso[i+1]] (CartesianIndex handling)
  loops::Vector{Loop}
  opdict::Dict{Symbol,Operation}
  operations::Vector{Operation} # Split them to make it easier to iterate over just a subset
  operation_offsets::Vector{Int}
  outer_reductions::Vector{Int} # IDs of reduction operations that need to be reduced at end.
  loop_order::LoopOrder
  preamble::Expr
  prepreamble::Expr # performs extractions that must be performed first, and don't need further registering
  preamble_symsym::Vector{Tuple{Int,Symbol}}
  preamble_symint::Vector{Tuple{Int,Tuple{Int,Int32,Bool}}} # (id,(intval,intsz,signed))
  preamble_symfloat::Vector{Tuple{Int,Float64}}
  preamble_zeros::Vector{Tuple{Int,NumberType}}
  preamble_funcofeltypes::Vector{Tuple{Int,Float64}}
  includedarrays::Vector{Symbol}
  includedactualarrays::Vector{Symbol}
  syms_aliasing_refs::Vector{Symbol}
  refs_aliasing_syms::Vector{ArrayReferenceMeta}
  cost_vec::Matrix{Float64}
  reg_pres::Matrix{Float64}
  included_vars::Vector{Bool}
  place_after_loop::Vector{Bool}
  unrollspecification::UnrollSpecification
  loadelimination::Bool
  lssm::LoopStartStopManager
  vector_width::Int
  symcounter::Int
  isbroadcast::Bool
  register_size::Int
  register_count::Int
  cache_linesize::Int
  ureduct::Int
  equalarraydims::Vector{Tuple{Vector{Symbol},Vector{Int}}}
  omop::OffsetLoadCollection
  loopordermap::Vector{Int}
  loopindexesbit::Vector{Bool}
  validreorder::Vector{UInt8}
  mod::Symbol
  LoopSet() = new()
end

function UnrollArgs(
  ls::LoopSet,
  u₁::Int,
  unrollsyms::UnrollSymbols,
  u₂max::Int,
  suffix::Int
)
  @unpack u₁loopsym, u₂loopsym, vloopsym = unrollsyms
  u₁loop = getloop(ls, u₁loopsym)
  u₂loop =
    u₂loopsym === Symbol("##undefined##") ? u₁loop : getloop(ls, u₂loopsym)
  vloop = getloop(ls, vloopsym)
  UnrollArgs(u₁loop, u₂loop, vloop, u₁, u₂max, suffix)
end

function cost_vec_buf(ls::LoopSet)
  cv = @view(ls.cost_vec[:, 2])
  @inbounds for i ∈ 1:4
    cv[i] = 0.0
  end
  cv
end
function reg_pres_buf(ls::LoopSet)
  ps = @view(ls.reg_pres[:, 2])
  @inbounds for i ∈ 1:4
    ps[i] = 0
  end
  ps[4] = reg_count(ls)
  ps
end
function save_tilecost!(ls::LoopSet)
  @inbounds for i ∈ 1:4
    ls.cost_vec[i, 1] = ls.cost_vec[i, 2]
    ls.reg_pres[i, 1] = ls.reg_pres[i, 2]
  end
  # ls.reg_pres[5,1] = ls.reg_pres[5,2]
end
function set_hw!(ls::LoopSet, rs::Int, rc::Int, cls::Int)
  ls.register_size = rs
  ls.register_count = rc
  ls.cache_linesize = cls
  # ls.cache_size = (l1, l2, l3)
  # ls.opmask_register[] = omr
  nothing
end
available_registers() =
  ifelse(has_opmask_registers(), register_count(), register_count() - One())
function set_hw!(ls::LoopSet)
  set_hw!(
    ls,
    Int(register_size()),
    Int(available_registers()),
    Int(cache_linesize())
  )
end
reg_size(ls::LoopSet) = ls.register_size
reg_count(ls::LoopSet) = ls.register_count
cache_lnsze(ls::LoopSet) = ls.cache_linesize

pushprepreamble!(ls::LoopSet, ex) = push!(ls.prepreamble.args, ex)
function pushpreamble!(ls::LoopSet, op::Operation, v::Symbol)
  if v !== mangledvar(op)
    push!(ls.preamble_symsym, (identifier(op), v))
  end
  nothing
end

function integer_description(@nospecialize(v::Integer))::Tuple{Int,Int32,Bool}
  if v isa Bool
    ((v % Int)::Int, one(Int32), false)
  else
    ((v % Int)::Int, ((8sizeof(v)) % Int32)::Int32, (v isa Signed)::Bool)
  end
end

function pushpreamble!(ls::LoopSet, op::Operation, v::Number)
  typ = v isa Integer ? HardInt : HardFloat
  id = identifier(op)
  if iszero(v)
    push!(ls.preamble_zeros, (id, typ))
  elseif v isa Integer
    push!(ls.preamble_symint, (id, integer_description(v)))
  else
    push!(ls.preamble_symfloat, (id, convert(Float64, v)))
  end
end
pushpreamble!(ls::LoopSet, ex::Expr) = push!(ls.preamble.args, ex)
# function pushpreamble!(ls::LoopSet, op::Operation, RHS::Expr)
#     c = gensym(:licmconst)
#     if RHS.head === :call && first(RHS.args) === :zero
#         push!(ls.preamble_zeros, (identifier(op), IntOrFloat))
#     elseif RHS.head === :call && first(RHS.args) === :one
#         push!(ls.preamble_funcofeltypes, (identifier(op), MULTIPLICATIVE_IN_REDUCTIONS))
#     else
#         pushpreamble!(ls, Expr(:(=), c, RHS))
#         pushpreamble!(ls, op, c)
#     end
#     nothing
# end
function zerotype(ls::LoopSet, op::Operation)
  opid = identifier(op)
  for (id, typ) ∈ ls.preamble_zeros
    id == opid && return typ
  end
  INVALID
end

includesarray(ls::LoopSet, array::Symbol) = array ∈ ls.includedarrays

function LoopSet(mod::Symbol)
  ls = LoopSet()
  ls.loopsymbols = Symbol[]
  ls.loopsymbol_offsets = [0]
  ls.loops = Loop[]
  ls.opdict = Dict{Symbol,Operation}()
  ls.operations = Operation[]
  ls.operation_offsets = Int[0]
  ls.outer_reductions = Int[]
  ls.loop_order = LoopOrder()
  ls.preamble = Expr(:block)
  ls.prepreamble = Expr(:block)
  ls.preamble_symsym = Tuple{Int,Symbol}[]
  ls.preamble_symint = Tuple{Int,Tuple{Int,Int32,Bool}}[]
  ls.preamble_symfloat = Tuple{Int,Float64}[]
  ls.preamble_zeros = Tuple{Int,NumberType}[]
  ls.preamble_funcofeltypes = Tuple{Int,Float64}[]
  ls.includedarrays = Symbol[]
  ls.includedactualarrays = Symbol[]
  ls.syms_aliasing_refs = Symbol[]
  ls.refs_aliasing_syms = ArrayReferenceMeta[]
  ls.cost_vec = Matrix{Float64}(undef, 4, 2)
  ls.reg_pres = Matrix{Float64}(undef, 4, 2)
  ls.included_vars = Bool[]
  ls.place_after_loop = Bool[]
  ls.unrollspecification
  ls.loadelimination = false
  ls.vector_width = 0
  ls.symcounter = 0
  ls.isbroadcast = 0
  ls.register_size = 0
  ls.register_count = 0
  ls.cache_linesize = 0
  ls.ureduct = -1
  ls.equalarraydims = Tuple{Vector{Symbol},Vector{Int}}[]
  ls.omop = OffsetLoadCollection()
  ls.loopordermap = Int[]
  ls.loopindexesbit = Bool[]
  ls.validreorder = UInt8[]
  ls.mod = mod
  ls
end

"""
Used internally to create symbols unique for this loopset.
This is used so that identical loops will create identical `_turbo_!` calls in the macroexpansions, hopefully reducing recompilation.
"""
gensym!(ls::LoopSet, s) = Symbol("###$(s)###$(ls.symcounter += 1)###")

fill_children!(ls::LoopSet) =
  for op ∈ operations(ls)
    empty!(children(op))
    for opp ∈ parents(op)
      @assert children(opp) !== NOPARENTS
      push!(children(opp), op)
    end
  end
function rejectinterleave!(
  ls::LoopSet,
  op::Operation,
  u₁loop::Symbol,
  u₂loop::Symbol,
  vloopsym::Symbol,
  vloop::Loop
)
  setunrolled!(ls, op, u₁loop, u₂loop, vloopsym)
  if accesses_memory(op)
    rc = rejectcurly(ls, op, u₁loop, vloopsym)
    # @show rc, op
    op.rejectcurly = rc
    if rc
      op.rejectinterleave = true
    else
      omop = ls.omop
      batchid, _ = omop.batchedcollectionmap[identifier(op)]
      op.rejectinterleave =
        ((batchid == 0) || (!isvectorized(op))) ||
        rejectinterleave(ls, op, vloop, omop.batchedcollections[batchid])
    end
  end
end
function cacheunrolled!(
  ls::LoopSet,
  u₁loop::Symbol,
  u₂loop::Symbol,
  vloopsym::Symbol
)
  vloop = getloop(ls, vloopsym)
  for op ∈ operations(ls)
    rejectinterleave!(ls, op, u₁loop, u₂loop, vloopsym, vloop)
  end
end
function setunrolled!(
  ls::LoopSet,
  op::Operation,
  u₁loopsym::Symbol,
  u₂loopsym::Symbol,
  vectorized::Symbol
)
  u₁::Bool = u₂::Bool = v::Bool = false
  for ld ∈ loopdependencies(op)
    u₁ |= ld === u₁loopsym
    u₂ |= ld === u₂loopsym
    v |= ld === vectorized
  end
  if isconstant(op)
    for opp ∈ children(op)
      u₁ = u₁ && u₁loopsym ∈ loopdependencies(opp)
      u₂ = u₂ && u₂loopsym ∈ loopdependencies(opp)
      v = v && vectorized ∈ loopdependencies(opp)
    end
    if isouterreduction(ls, op) ≠ -1 && !all((u₁, u₂, v))
      opv = true
      for opp ∈ parents(op)
        if iscompute(opp) && instruction(opp).instr ≢ :identity
          opv = false
          break
        end
      end
      if opv
        if !u₁ && u₁loopsym ∈ reduceddependencies(op)
          u₁ = true
        end
        if !u₂ && u₂loopsym ∈ reduceddependencies(op)
          u₂ = true
        end
        if !v && vectorized ∈ reduceddependencies(op)
          v = true
        end
      end
    end
  end
  op.u₁unrolled = u₁
  op.u₂unrolled = u₂
  op.vectorized = v
  nothing
end

rejectcurly(op::Operation) = op.rejectcurly
rejectinterleave(op::Operation) = op.rejectinterleave
num_loops(ls::LoopSet) = length(ls.loops)
function oporder(ls::LoopSet)
  N = length(ls.loop_order.loopnames)
  reshape(ls.loop_order.oporder, (2, 2, 2, N))
end
names(ls::LoopSet) = ls.loop_order.loopnames
reversenames(ls::LoopSet) = ls.loop_order.bestorder
function getloopid_or_nothing(ls::LoopSet, s::Symbol)
  for (loopnum, sym) ∈ enumerate(ls.loopsymbols)
    s === sym && return loopnum
  end
end

getloopid(ls::LoopSet, s::Symbol) = getloopid_or_nothing(ls, s)::Int
getloop(ls::LoopSet, i::Integer) = ls.loops[ls.loopordermap[i]] # takes nest level after reordering
getloop_from_id(ls::LoopSet, i::Integer) = ls.loops[i] # takes w/ respect to original loop order.
getloop(ls::LoopSet, s::Symbol) = getloop_from_id(ls, getloopid(ls, s))
getloopsym(ls::LoopSet, i::Integer) = ls.loopsymbols[i]
Base.length(ls::LoopSet, s::Symbol) = length(getloop(ls, s))
function init_loop_map!(ls::LoopSet)
  @unpack loopordermap = ls
  order = names(ls)
  resize!(loopordermap, length(order))
  for (i, o) ∈ enumerate(order)
    loopordermap[i] = getloopid(ls, o)
  end
  nothing
end

# isstaticloop(ls::LoopSet, s::Symbol) = isstaticloop(getloop(ls,s))
# looprangehint(ls::LoopSet, s::Symbol) = length(getloop(ls, s))
# looprangesym(ls::LoopSet, s::Symbol) = getloop(ls, s).rangesym

"""
getop only works while construction a LoopSet object. You cannot use it while lowering.
"""
getop(ls::LoopSet, var::Number, elementbytes) =
  add_constant!(ls, var, elementbytes)
function getop(ls::LoopSet, var::Symbol, elementbytes::Int)
  get!(ls.opdict, var) do
    add_constant!(ls, var, elementbytes)
  end
end
function getop(ls::LoopSet, var::Symbol, deps, elementbytes::Int)
  get!(ls.opdict, var) do
    add_constant!(ls, var, deps, gensym!(ls, "constant"), elementbytes)
  end
end
getop(ls::LoopSet, i::Int) = ls.operations[i]

findop(ls::LoopSet, s::Symbol) = findop(operations(ls), s)
function findop(ops::Vector{Operation}, s::Symbol)
  for op ∈ ops
    name(op) === s && return op
  end
  throw(ArgumentError("Symbol $s not found."))
end

# """
# Returns an operation with the same name as `s`.
# """
# function getoperation(ls::LoopSet, s::Symbol)
#     for op ∈ Iterators.Reverse(operations(ls))
#         name(op) === s && return op
#     end
#     throw("Symbol $s not found among operations(ls).")
# end

function Operation(
  ls::LoopSet,
  variable,
  elementbytes,
  instruction,
  node_type,
  dependencies,
  reduced_deps,
  parents,
  ref = NOTAREFERENCE
)
  Operation(
    length(operations(ls)),
    variable,
    elementbytes,
    instruction,
    node_type,
    dependencies,
    reduced_deps,
    parents,
    ref
  )
end
function Operation(
  ls::LoopSet,
  variable,
  elementbytes,
  instr,
  optype,
  mpref::ArrayReferenceMetaPosition
)
  Operation(
    length(operations(ls)),
    variable,
    elementbytes,
    instr,
    optype,
    mpref
  )
end

operations(ls::LoopSet) = ls.operations

function getconstvalues(
  ls::LoopSet,
  opparents::Vector{Operation}
)::Tuple{Bool,Vector{Any}}
  vals = sizehint!(Any[], length(opparents))
  for i ∈ eachindex(opparents)
    pushconstvalue!(vals, ls, opparents[i]) && return true, vals
  end
  false, vals
end

function add_constant_compute!(
  ls::LoopSet,
  op::Operation,
  var::Symbol
)::Operation
  op.node_type = constant
  instr = instruction(op)
  opparents = parents(op)
  if Base.sym_in(
    instr.instr,
    (
      :add_fast,
      :mul_fast,
      :sub_fast,
      :div_fast,
      :(//),
      :vfmadd_fast,
      :vfnmadd_fast,
      :vfmsub_fast,
      :vfnmsub_fast
    )
  )
    getconstfailed, vals = getconstvalues(ls, opparents)
    if !getconstfailed
      f = instr.instr
      if f === :add_fast
        # use init explicitly to prevent invalidations
        return add_constant!(ls, sum(vals; init = false), 8)::Operation
      elseif f === :mul_fast
        return add_constant!(ls, prod(vals), 8)::Operation
      elseif f === :sub_fast
        if length(opparents) == 2
          return add_constant!(ls, vals[1] - vals[2], 8)::Operation
        elseif length(opparents) == 1
          return add_constant!(ls, -vals[1], 8)::Operation
        end
      elseif (f === :div_fast) || (f === :(//))
        if length(opparents) == 2
          return add_constant!(ls, vals[1] / vals[2], 8)::Operation
        end
      elseif length(opparents) == 3
        # use init explicitly to prevent invalidations
        T = typeof(sum(vals; init = false))
        if f === :vfmadd_fast
          return add_constant!(
            ls,
            T((big(vals[1]) * big(vals[2]) + big(vals[3]))),
            8
          )::Operation
        elseif f === :vfnmadd_fast
          return add_constant!(
            ls,
            T(big(vals[3]) - big(vals[1]) * big(vals[2])),
            8
          )::Operation
        elseif f === :vfmsub_fast
          return add_constant!(
            ls,
            T((big(vals[1]) * big(vals[2]) - big(vals[3]))),
            8
          )::Operation
        elseif f === :vfnmsub_fast
          return add_constant!(
            ls,
            T(-(big(vals[1]) * big(vals[2]) + big(vals[3]))),
            8
          )::Operation
        end
      end
    end
  end
  opdef = callexpr(instr)
  mangledname = Symbol('#', instruction(op).instr, '#')
  while length(opparents) > 0
    oppname = name(popfirst!(opparents))
    mangledname = Symbol(mangledname, oppname, '#')
    push!(opdef.args, oppname)
  end
  op.mangledvariable = mangledname
  pushpreamble!(ls, Expr(:(=), name(op), opdef))
  op.instruction = LOOPCONSTANT
  push!(ls.preamble_symsym, (identifier(op), name(op)))
  _pushop!(ls, op, var)
end

function _pushop!(ls::LoopSet, op::Operation, var::Symbol)
  for opp ∈ operations(ls)
    if matches(op, opp)
      ls.opdict[var] = opp
      return opp
    end
  end
  push!(ls.operations, op)
  ls.opdict[var] = op
  op
end
function pushop!(ls::LoopSet, op::Operation, var::Symbol = name(op))
  if (iscompute(op) && length(loopdependencies(op)) == 0)
    add_constant_compute!(ls, op, var)
  else
    _pushop!(ls, op, var)
  end
end

function add_block!(ls::LoopSet, ex::Expr, elementbytes::Int, position::Int)
  for x ∈ ex.args
    x isa Expr || continue # be that general?
    x.head === :inbounds && continue
    _push!(ls, x, elementbytes, position)
  end
end
function makestatic!(expr)
  expr isa Expr || return expr
  for i in eachindex(expr.args)
    ex = expr.args[i]
    if ex isa Int
      expr.args[i] = staticexpr(ex)
    elseif ex isa Symbol
      j = findfirst(==(ex), (:axes, :size, :length))
      if j !== nothing
        expr.args[i] = GlobalRef(
          ArrayInterface,
          (:static_axes, :static_size, :static_length)[j]
        )
      end
    elseif ex isa Expr
      makestatic!(ex)
    end
  end
  expr
end
add_loop_bound!(
  ::LoopSet,
  itersym::Symbol,
  bound::Union{Integer,Symbol},
  upper::Bool,
  step::Bool
)::MaybeKnown = MaybeKnown(bound, upper ? 1024 : 1)
function add_loop_bound!(
  ls::LoopSet,
  itersym::Symbol,
  bound::Expr,
  upper::Bool,
  step::Bool
)::MaybeKnown
  makestatic!(bound)
  N = gensym!(
    ls,
    string(itersym) * (
      upper ? "_loop_upper_bound" : (step ? "_loop_step" : "_loop_lower_bound")
    )
  )
  pushprepreamble!(ls, Expr(:(=), N, bound))
  MaybeKnown(N, upper ? 1024 : 1)
end
function range_loop!(
  ls::LoopSet,
  itersym::Symbol,
  l::MaybeKnown,
  u::MaybeKnown,
  s::MaybeKnown
)
  rangename = gensym!(ls, "range")
  lenname = gensym!(ls, "length")
  range = Expr(:call, :(:))
  pushexpr!(range, l)
  isone(s) || pushexpr!(range, s)
  pushexpr!(range, u)
  pushprepreamble!(ls, Expr(:(=), rangename, range))
  pushprepreamble!(
    ls,
    Expr(
      :(=),
      lenname,
      Expr(:call, GlobalRef(ArrayInterface, :static_length), rangename)
    )
  )
  Loop(itersym, l, u, s, rangename, lenname)
end
function range_loop!(ls::LoopSet, r::Expr, itersym::Symbol)::Loop
  lower = r.args[2]
  if length(r.args) == 3
    step = 1
    upper = r.args[3]
  elseif length(r.args) == 4
    step = r.args[3]
    upper = r.args[4]
  else
    throw("Literal ranges must have either 2 or 3 arguments.")
  end
  l::MaybeKnown = add_loop_bound!(ls, itersym, lower, false, false)
  u::MaybeKnown = add_loop_bound!(ls, itersym, upper, true, false)
  s::MaybeKnown = add_loop_bound!(ls, itersym, step, false, true)
  range_loop!(ls, itersym, l, u, s)
end
function oneto_loop!(ls::LoopSet, r::Expr, itersym::Symbol)::Loop
  otN = r.args[2]
  l = MaybeKnown(1, 0)
  s = MaybeKnown(1, 0)
  u::MaybeKnown = if otN isa Integer
    rangename = lensym = Symbol("")
    MaybeKnown(convert(Int, otN)::Int, 0)
  else
    otN isa Expr && makestatic!(otN)
    lensym = N = gensym!(ls, "loop" * string(itersym))
    rangename = gensym!(ls, "range")
    pushprepreamble!(ls, Expr(:(=), N, otN))
    pushprepreamble!(
      ls,
      Expr(:(=), rangename, Expr(:call, :(:), staticexpr(1), N))
    )
    MaybeKnown(N, 1024)
  end
  Loop(itersym, l, u, s, rangename, lensym)
end

@inline _reverse(r) = maybestaticlast(r):-static_step(r):maybestaticfirst(r)
@inline canonicalize_range(r::OptionallyStaticUnitRange) = r
@inline function canonicalize_range(
  r::OptionallyStaticRange,
  ::StaticInt{S}
) where {S}
  S > 0 ? r : _reverse(r)
end
@inline canonicalize_range(r::OptionallyStaticRange, s::Integer) =
  s > 0 ? r : _reverse(r)
@inline canonicalize_range(r::AbstractCloseOpen) = r
@inline canonicalize_range(r::AbstractUnitRange) =
  maybestaticfirst(r):maybestaticlast(r)
@inline canonicalize_range(r::OptionallyStaticRange) =
  canonicalize_range(r, static_step(r))
@inline canonicalize_range(r::AbstractRange) =
  canonicalize_range(maybestaticfirst(r):static_step(r):maybestaticlast(r))
@inline canonicalize_range(r::StepRange{T,T}) where {T<:Base.BitInteger} = r
@inline canonicalize_range(r::CartesianIndices) =
  CartesianIndices(map(canonicalize_range, r.indices))
@inline canonicalize_range(r::Base.OneTo{U}) where {U<:Unsigned} =
  One():(last(r)%Int)

function canonicalize_range(x)
  throw(
    ArgumentError(
      """
  `@turbo` only supports loops iterating over ranges, and not objects of type `$(typeof(x))`.
  It is recommended to instead iterate over `eachindex(...)` and then index the object in the loop.
  For example, rewrite
  ```julia
    @turbo for xᵢ in x
      ...
    end
  ```
  as
  ```julia
    @turbo for i in eachindex(x)
      xᵢ = x[i]
      ...
    end
  ```
"""
    )
  )
end

function misc_loop!(
  ls::LoopSet,
  r::Union{Expr,Symbol},
  itersym::Symbol,
  staticstepone::Bool
)::Loop
  rangename = gensym!(ls, "looprange" * string(itersym))
  lenname = gensym!(ls, "looplen" * string(itersym))
  pushprepreamble!(
    ls,
    Expr(
      :(=),
      rangename,
      Expr(:call, lv(:canonicalize_range), :(@inbounds $(makestatic!(r))))
    )
  )
  pushprepreamble!(
    ls,
    Expr(
      :(=),
      lenname,
      Expr(:call, GlobalRef(ArrayInterface, :static_length), rangename)
    )
  )
  L = add_loop_bound!(
    ls,
    itersym,
    Expr(:call, lv(:maybestaticfirst), rangename),
    false,
    false
  )
  U = add_loop_bound!(
    ls,
    itersym,
    Expr(:call, lv(:maybestaticlast), rangename),
    true,
    false
  )
  if staticstepone
    Loop(itersym, L, U, MaybeKnown(1), rangename, lenname)
  else
    S = add_loop_bound!(
      ls,
      itersym,
      Expr(:call, lv(:static_step), rangename),
      false,
      true
    )
    Loop(itersym, L, U, S, rangename, lenname)
  end
end

function indices_loop!(ls::LoopSet, r::Expr, itersym::Symbol)::Loop
  if length(r.args) == 3
    arrays = r.args[2]
    dims = r.args[3]
    if isexpr(arrays, :tuple) &&
       length(arrays.args) > 1 &&
       all(s -> s isa Symbol, arrays.args)
      narrays = length(arrays.args)::Int
      axessyms = Vector{Symbol}(undef, narrays)
      if dims isa Integer
        # ids = Vector{NTuple{2,Int}}(undef, narrays)
        vptrs = Vector{Symbol}(undef, narrays)
        mdims = fill(dims::Int, narrays)
        # _d::Int = dims
        for n ∈ 1:narrays
          a_s::Symbol = arrays.args[n]
          vptrs[n] = vptr(a_s)
          axessyms[n] = axsym = gensym!(ls, "#axes#$(a_s)#")
          pushprepreamble!(
            ls,
            Expr(
              :(=),
              axsym,
              Expr(
                :call,
                GlobalRef(ArrayInterface, :static_axes),
                a_s,
                staticexpr(dims::Int)
              )
            )
          )
          if n > 1
            axsym_prev = axessyms[n-1]
            pushprepreamble!(
              ls,
              Expr(
                :call,
                GlobalRef(VectorizationBase, :assume),
                Expr(
                  :call,
                  GlobalRef(Base, :(==)),
                  Expr(:call, GlobalRef(ArrayInterface, :static_first), axsym),
                  Expr(
                    :call,
                    GlobalRef(ArrayInterface, :static_first),
                    axsym_prev
                  )
                )
              )
            )
            pushprepreamble!(
              ls,
              Expr(
                :call,
                GlobalRef(VectorizationBase, :assume),
                Expr(
                  :call,
                  GlobalRef(Base, :(==)),
                  Expr(:call, GlobalRef(ArrayInterface, :static_last), axsym),
                  Expr(
                    :call,
                    GlobalRef(ArrayInterface, :static_last),
                    axsym_prev
                  )
                )
              )
            )
          end
        end
        push!(ls.equalarraydims, (vptrs, mdims))
      elseif isexpr(dims, :tuple) &&
             length(dims.args) == narrays &&
             all(i -> i isa Integer, dims.args)
        # ids = Vector{NTuple{2,Int}}(undef, narrays)
        vptrs = Vector{Symbol}(undef, narrays)
        mdims = Vector{Int}(undef, narrays)
        axessyms = Vector{Symbol}(undef, narrays)
        for n ∈ 1:narrays
          a_s::Symbol = arrays.args[n]
          vptrs[n] = vptr(a_s)
          mdim::Int = dims.args[n]
          mdims[n] = mdim
          axessyms[n] = axsym = gensym!(ls, "#axes#$(a_s)#")
          pushprepreamble!(
            ls,
            Expr(
              :(=),
              axsym,
              Expr(
                :call,
                GlobalRef(ArrayInterface, :static_axes),
                a_s,
                staticexpr(mdim)
              )
            )
          )
          if n > 1
            axsym_prev = axessyms[n-1]
            pushprepreamble!(
              ls,
              Expr(
                :call,
                GlobalRef(VectorizationBase, :assume),
                Expr(
                  :call,
                  GlobalRef(Base, :(==)),
                  Expr(:call, GlobalRef(ArrayInterface, :static_first), axsym),
                  Expr(
                    :call,
                    GlobalRef(ArrayInterface, :static_first),
                    axsym_prev
                  )
                )
              )
            )
            pushprepreamble!(
              ls,
              Expr(
                :call,
                GlobalRef(VectorizationBase, :assume),
                Expr(
                  :call,
                  GlobalRef(Base, :(==)),
                  Expr(:call, GlobalRef(ArrayInterface, :static_last), axsym),
                  Expr(
                    :call,
                    GlobalRef(ArrayInterface, :static_last),
                    axsym_prev
                  )
                )
              )
            )
          end
        end
        push!(ls.equalarraydims, (vptrs, mdims))
      end
    end
  end
  misc_loop!(ls, r, itersym, true)
end

"""
This function creates a loop, while switching from 1 to 0 based indices
"""
function register_single_loop!(ls::LoopSet, looprange::Expr)
  itersym = (looprange.args[1])::Symbol
  r = looprange.args[2]
  loop = if isexpr(r, :call)
    r = r::Expr        # julia#37342
    f = first(r.args)
    if f === :(:)
      range_loop!(ls, r, itersym)
    elseif f === :OneTo || isscopedname(f, :Base, :OneTo)
      oneto_loop!(ls, r, itersym)
    elseif f === :indices || (
      isexpr(f, :(.), 2) &&
      (f.args[2] === QuoteNode(:indices)) &&
      ((f.args[1] === :ArrayInterface) || (f.args[1] === :LoopVectorization))
    )
      indices_loop!(ls, r, itersym)
    else
      (f === :axes) && (r.args[1] = lv(:static_axes))
      misc_loop!(ls, r, itersym, (f === :eachindex) | (f === :axes))
    end
  elseif isa(r, Symbol)
    misc_loop!(ls, r, itersym, false)
  else
    throw(LoopError("Unrecognized loop range type: $r."))
  end
  add_loop!(ls, loop, itersym)
  nothing
end
function register_loop!(ls::LoopSet, looprange::Expr)
  if looprange.head === :block # multiple loops
    for lr ∈ looprange.args
      register_single_loop!(ls, lr::Expr)
    end
  else
    @assert looprange.head === :(=)
    register_single_loop!(ls, looprange)
  end
end
function add_loop!(ls::LoopSet, q::Expr, elementbytes::Int)
  register_loop!(ls, q.args[1]::Expr)
  body = q.args[2]::Expr
  position = length(ls.loopsymbols)
  if body.head === :block
    add_block!(ls, body, elementbytes, position)
  else
    _push!(ls, q, elementbytes, position)
  end
end
function add_loop!(ls::LoopSet, loop::Loop, itersym::Symbol = loop.itersymbol)
  push!(ls.loopsymbols, itersym)
  push!(ls.loops, loop)
  nothing
end

# function instruction(x)
#     x isa Symbol ? x : last(x.args).value
# end
# instruction(ls::LoopSet, f::Symbol) = instruction!(ls, f)
function instruction!(ls::LoopSet, x::Expr)
  # x isa Symbol && return x
  if x.head === :$
    _x = only(x.args)
    _x isa Symbol && return instruction!(ls, _x)
    @assert _x isa Expr
    x = _x
  end
  # if x.head ≢ :(->)
  instr = last(x.args).value
  isa(instr, Symbol) &&
    instr ∈ keys(COST) &&
    return Instruction(:LoopVectorization, instr)
  # end
  instr = gensym!(ls, "f")
  pushprepreamble!(ls, Expr(:(=), instr, x))
  Instruction(Symbol(""), instr)
end
instruction!(::LoopSet, x::Symbol) = instruction(x)
function instruction!(ls::LoopSet, f::F) where {F<:Function}
  get(FUNCTIONSYMBOLS, F) do
    instr = gensym!(ls, "f")
    pushpreamble!(ls, Expr(:(=), instr, f))
    Instruction(Symbol(""), instr)
  end
end

function maybe_const_compute!(
  ls::LoopSet,
  LHS::Symbol,
  op::Operation,
  elementbytes::Int,
  position::Int
)
  # return op
  if iscompute(op) && iszero(length(loopdependencies(op)))
    ls.opdict[LHS] = add_constant!(
      ls,
      LHS,
      ls.loopsymbols[1:position],
      gensym!(ls, instruction(op).instr),
      elementbytes,
      :numericconstant
    )
  else
    # op.dependencies = ls.loopsymbols[1:position]
    op
  end
end
strip_op_linenumber_nodes(q::Expr) =
  only(filter(x -> !isa(x, LineNumberNode), q.args))

function add_operation!(
  ls::LoopSet,
  LHS::Symbol,
  RHS::Symbol,
  elementbytes::Int,
  position::Int
)
  add_constant!(ls, RHS, ls.loopsymbols[1:position], LHS, elementbytes)
end
function add_comparison!(
  ls::LoopSet,
  LHS::Symbol,
  RHS::Expr,
  elementbytes::Int,
  position::Int
)
  Nargs = length(RHS.args)
  @assert (Nargs ≥ 5) & isodd(Nargs)
  p1 = add_assignment!(
    ls,
    gensym!(ls, "leftcmp"),
    RHS.args[1],
    elementbytes,
    position
  )::Operation
  p2 = add_assignment!(
    ls,
    gensym!(ls, "middlecmp"),
    RHS.args[3],
    elementbytes,
    position
  )::Operation
  cmpname = Nargs == 3 ? LHS : gensym!(ls, "cmp")
  cmp = add_compute!(
    ls,
    cmpname,
    RHS.args[2],
    Operation[p1, p2],
    elementbytes
  )::Operation
  for i ∈ 5:2:Nargs
    pnew = add_assignment!(
      ls,
      gensym!(ls, "rightcmp"),
      RHS.args[i],
      elementbytes,
      position
    )::Operation
    cmpchain = add_compute!(
      ls,
      gensym!(ls, "cmpchain"),
      RHS.args[i-1],
      Operation[p2, pnew],
      elementbytes
    )::Operation
    cmpname = Nargs == i ? LHS : gensym!(ls, "cmp")
    cmp =
      add_compute!(ls, cmpname, :&, [cmp, cmpchain], elementbytes)::Operation
    p2 = pnew
  end
  return cmp
end
function add_operation!(
  ls::LoopSet,
  LHS::Symbol,
  RHS::Expr,
  elementbytes::Int,
  position::Int
)
  if RHS.head === :ref
    add_load_ref!(ls, LHS, RHS, elementbytes)
  elseif RHS.head === :call
    f = first(RHS.args)
    if f === :getindex
      add_load_getindex!(ls, LHS, RHS, elementbytes)
    elseif f isa Symbol && Base.sym_in(f, (:zero, :one, :typemin, :typemax))
      c = gensym!(ls, f)
      op = add_constant!(
        ls,
        c,
        ls.loopsymbols[1:position],
        LHS,
        elementbytes,
        :numericconstant
      )
      if f === :zero
        push!(ls.preamble_zeros, (identifier(op), IntOrFloat))
      else
        push!(
          ls.preamble_funcofeltypes,
          (identifier(op), reduction_zero_class(f))
        )
      end
      op
    else
      # maybe_const_compute!(ls, add_compute!(ls, LHS, RHS, elementbytes, position), elementbytes, position)
      add_compute!(ls, LHS, RHS, elementbytes, position)
    end
  elseif RHS.head === :if
    add_if!(ls, LHS, RHS, elementbytes, position)
  elseif RHS.head === :block
    add_operation!(
      ls,
      LHS,
      strip_op_linenumber_nodes(RHS),
      elementbytes,
      position
    )
  elseif RHS.head === :(.)
    c = gensym!(ls, "getproperty")
    pushprepreamble!(ls, Expr(:(=), c, RHS))
    add_constant!(ls, c, elementbytes)
    # op = add_constant!(ls, c, ls.loopsymbols[1:position], LHS, elementbytes, :numericconstant)
    # pushpreamble!(ls, op, c)
    # op
  elseif Meta.isexpr(RHS, :comparison)
    add_comparison!(ls, LHS, RHS, elementbytes, position)
  else
    throw(LoopError("Expression not recognized.", RHS))
  end
end
add_operation!(ls::LoopSet, RHS::Expr, elementbytes::Int, position::Int) =
  add_operation!(ls, gensym!(ls, "LHS"), RHS, elementbytes, position)
function add_operation!(
  ls::LoopSet,
  LHS_sym::Symbol,
  RHS::Expr,
  LHS_ref::ArrayReferenceMetaPosition,
  elementbytes::Int,
  position::Int
)
  if RHS.head === :ref# || (RHS.head === :call && first(RHS.args) === :getindex)
    array, rawindices = ref_from_expr!(ls, RHS)
    RHS_ref = array_reference_meta!(
      ls,
      array,
      rawindices,
      elementbytes,
      gensym!(ls, LHS_sym)
    )
    op = add_load!(ls, RHS_ref, elementbytes)
    add_compute!(ls, LHS_sym, :identity, [op], elementbytes)
    # pushfirst!(LHS_ref.parents, iop)
  elseif RHS.head === :call
    f = first(RHS.args)
    if f === :getindex
      add_load_getindex!(ls, LHS_sym, RHS, elementbytes)
    elseif f isa Symbol && Base.sym_in(f, (:zero, :one, :typemin, :typemax))
      c = gensym!(ls, f)
      op = add_constant!(
        ls,
        c,
        ls.loopsymbols[1:position],
        LHS_sym,
        elementbytes,
        :numericconstant
      )
      # op = add_constant!(ls, c, Symbol[], LHS_sym, elementbytes, :numericconstant)
      if f === :zero
        push!(ls.preamble_zeros, (identifier(op), IntOrFloat))
      else
        push!(
          ls.preamble_funcofeltypes,
          (identifier(op), reduction_zero_class(f))
        )
      end
      op
    else
      add_compute!(ls, LHS_sym, RHS, elementbytes, position, LHS_ref)
    end
  elseif RHS.head === :if
    add_if!(ls, LHS_sym, RHS, elementbytes, position, LHS_ref)
  elseif RHS.head === :block
    add_operation!(
      ls,
      LHS_sym,
      strip_op_linenumber_nodes(RHS),
      elementbytes,
      position
    )
  elseif RHS.head === :(.)
    c = gensym!(ls, "getproperty")
    pushpreamble!(ls, Expr(:(=), c, RHS))
    add_constant!(ls, c, elementbytes)
    # op = add_constant!(ls, c, ls.loopsymbols[1:position], LHS_sym, elementbytes, :numericconstant)
    # pushpreamble!(ls, op, c)
    # op
  elseif Meta.isexpr(RHS, :comparison, 5)
    add_comparison!(ls, LHS_sym, RHS, elementbytes, position)
  else
    throw(LoopError("Expression not recognized.", RHS))
  end
end

function prepare_rhs_for_storage!(
  ls::LoopSet,
  RHS::Union{Symbol,Expr},
  array,
  rawindices,
  elementbytes::Int,
  position::Int
)::Operation
  RHS isa Symbol && return add_store!(ls, RHS, array, rawindices, elementbytes)
  mpref = array_reference_meta!(ls, array, rawindices, elementbytes)
  cachedparents = copy(mpref.parents)
  lrhs = gensym!(ls, "RHS")
  mpref.varname = lrhs
  add_operation!(ls, lrhs, RHS, mpref, elementbytes, position)
  mpref.parents = cachedparents
  op = add_store!(ls, mpref, elementbytes)
  if lrhs ∈ keys(ls.opdict)
    ls.syms_aliasing_refs[findfirst(==(mpref.mref), ls.refs_aliasing_syms)] =
      lrhs
  end
  return op
end

function unpack_tuple!(
  ls::LoopSet,
  LHS::Expr,
  RHS,
  elementbytes::Int,
  position::Int
)
  if Meta.isexpr(RHS, :tuple)
    for i ∈ eachindex(LHS.args)
      add_assignment!(ls, LHS.args[i], RHS.args[i], elementbytes, position)
    end
    return last(operations(ls)) # FIXME: dummy
  end
  @assert length(LHS.args) ≤ length(EXTRACTFUNS) "Functions returning more than $(length(EXTRACTFUNS)) values aren't currently supported."
  lhstemp = gensym!(ls, "lhstuple")
  vparents = Operation[maybe_const_compute!(
    ls,
    lhstemp,
    add_operation!(ls, lhstemp, RHS, elementbytes, position),
    elementbytes,
    position
  )]
  unpack_tuple!(ls, LHS, vparents, elementbytes, position)
end

function unpack_tuple!(
  ls::LoopSet,
  LHS::Expr,
  vparents::Vector{Operation},
  elementbytes::Int,
  position::Int
)
  for i ∈ eachindex(LHS.args)
    f = EXTRACTFUNS[i]
    lhsi = LHS.args[i]
    if lhsi isa Symbol
      add_compute!(ls, lhsi, f, vparents, elementbytes)
      continue
    elseif lhsi isa Expr
      if lhsi.head === :ref
        tempunpacksym = gensym!(ls, "tempunpack")
        add_compute!(ls, tempunpacksym, f, vparents, elementbytes)
        add_store_ref!(ls, tempunpacksym, lhsi, elementbytes)
        continue
      elseif lhsi.head === :tuple
        lhstemp = gensym!(ls, "lhstuple")
        op = add_compute!(ls, lhstemp, f, vparents, elementbytes)
        unpack_tuple!(ls, lhsi, [op], elementbytes, position)
        continue
      end
    end
    throw(
      LoopError(
        "Unpacking the above expression in the left hand side was not understood/supported.",
        lhsi
      )
    )
  end
  first(vparents)
end

function add_assignment!(
  ls::LoopSet,
  LHS,
  RHS,
  elementbytes::Int,
  position::Int
)
  if LHS isa Symbol
    if RHS isa Expr
      maybe_const_compute!(
        ls,
        LHS,
        add_operation!(ls, LHS, RHS, elementbytes, position),
        elementbytes,
        position
      )
    else
      add_constant!(ls, RHS, ls.loopsymbols[1:position], LHS, elementbytes)
    end
  elseif LHS isa Expr
    if LHS.head === :ref
      if RHS isa Symbol
        add_store_ref!(ls, RHS, LHS, elementbytes)
      elseif RHS isa Expr
        # need to check if LHS appears in RHS
        # assign RHS to lrhs
        array, rawindices = ref_from_expr!(ls, LHS)
        prepare_rhs_for_storage!(
          ls,
          RHS,
          array,
          rawindices,
          elementbytes,
          position
        )
      else
        add_store_ref!(ls, RHS, LHS, elementbytes)  # is this necessary? (Extension API?)
      end
    elseif LHS.head === :tuple
      unpack_tuple!(ls, LHS, RHS, elementbytes, position)
    else
      throw(
        LoopError(
          "LHS not understood; only `:ref`s and `:tuple`s are currently supported.",
          LHS
        )
      )
    end
  else
    throw(LoopError("LHS not understood.", LHS))
  end
end

function push_op!(
  ls::LoopSet,
  ex::Expr,
  elementbytes::Int,
  position::Int,
  mpref::Union{Nothing,ArrayReferenceMetaPosition} = nothing
)::Operation
  if ex.head === :call
    finex = first(ex.args)::Symbol
    if finex === :setindex!
      array, rawindices = ref_from_setindex!(ls, ex)
      prepare_rhs_for_storage!(
        ls,
        ex.args[3]::Union{Symbol,Expr},
        array,
        rawindices,
        elementbytes,
        position
      )
    else
      throw(LoopError("Don't know how to handle expression.", finex))
    end
  elseif ex.head === :(=)
    add_assignment!(ls, ex.args[1], ex.args[2], elementbytes, position)
  elseif ex.head === :&&
    add_andblock!(ls, ex, elementbytes, position)
  elseif ex.head === :||
    add_orblock!(ls, ex, elementbytes, position)
  elseif ex.head === :local # Handle locals introduced by `@inbounds`; using `local` with `@turbo` is not recommended (nor is `@inbounds`; which applies automatically regardless)
    @assert length(ex.args) == 1 # TODO replace assert + first with "only" once support for Julia < 1.4 is dropped
    localbody = first(ex.args)
    @assert localbody.head === :(=)
    @assert length(localbody.args) == 2
    LHS = (localbody.args[1])::Symbol
    RHS_1 = localbody.args[2]
    if RHS_1 isa Symbol
      return push_op!(ls, localbody, elementbytes, position, mpref)
    elseif Meta.isexpr(RHS_1, :(=), 2)
      RHS = push_op!(ls, RHS_1, elementbytes, position, mpref)
      if isstore(RHS)
        RHS
      else
        add_compute!(ls, LHS, :identity, [RHS], elementbytes)
      end
    else
      _push!(ls, localbody, elementbytes, position, mpref)
    end
  else
    throw(LoopError("Don't know how to handle expression.", ex))
  end
end

function _push!(
  ls::LoopSet,
  ex::Expr,
  elementbytes::Int,
  position::Int,
  mpref::Union{Nothing,ArrayReferenceMetaPosition} = nothing
)
  if ex.head === :block
    add_block!(ls, ex, elementbytes, position)
  elseif ex.head === :for
    add_loop!(ls, ex, elementbytes)
  else
    push_op!(ls, ex, elementbytes, position, mpref)
  end
end

function UnrollSpecification(
  ls::LoopSet,
  u₁loop::Symbol,
  u₂loop::Symbol,
  vloopsym::Symbol,
  u₁,
  u₂
)
  order = names(ls)
  nu₁ = findfirst(Base.Fix2(===, u₁loop), order)::Int
  nu₂ = u₂ == -1 ? nu₁ : findfirst(Base.Fix2(===, u₂loop), order)::Int
  nv = findfirst(Base.Fix2(===, vloopsym), order)::Int
  UnrollSpecification(nu₁, nu₂, nv, u₁, u₂)
end

"""
looplengthprod(ls::LoopSet)

Convert to `Float64` for the sake of non-64 bit platforms.
"""
function looplengthprod(ls::LoopSet)
  l = 1.0
  for loop ∈ ls.loops
    l *= Float64(length(loop))
  end
  l
end
# prod(Float64 ∘ length, ls.loops)

function looplength(ls::LoopSet, s::Symbol)
  # search_tree(parents(operations(ls)[i]), name(op)) && return true
  id = getloopid_or_nothing(ls, s)
  if id === nothing
    l = 0.0
    # TODO: we could double count a loop.
    for op ∈ operations(ls)
      name(op) === s || continue
      for opp ∈ parents(op)
        if isloopvalue(opp)
          oppname = first(loopdependencies(opp))
          l += looplength(ls, oppname)
        elseif iscompute(opp)
          oppname = name(opp)
          l += looplength(ls, oppname)
          # TODO elseif isconstant(opp)
        end
      end
      l += 1 - length(parents(op))
    end
    l
  else
    Float64(length(ls.loops[id]))
  end
end

function accept_reorder_according_to_tracked_reductions(
  ls::LoopSet,
  reordered::Symbol
)
  for op ∈ operations(ls)
    if (reordered ∈ loopdependencies(op)) &&
       !(iscompute(op) & iszero(length(children(op))))
      for opp ∈ parents(op)
        (iscompute(opp) && isanouterreduction(ls, opp)) && return 0x00
      end
    end
  end
  0x03
end
function check_valid_reorder_dims!(ls::LoopSet)
  validreorder = ls.validreorder
  resize!(validreorder, num_loops(ls))
  fill!(validreorder, 0x03)
  omop = offsetloadcollection(ls)
  @unpack opids = omop
  ops = operations(ls)
  for i ∈ eachindex(opids)
    opidsᵢ = opids[i]
    opi = ops[first(opidsᵢ)]
    opiref = opi.ref.ref
    isl = isload(opi)
    for j ∈ 1:i-1
      opidsⱼ = opids[j]
      opj = ops[first(opidsⱼ)]
      (isl ⊻ isload(opj)) || continue # try and find load/store combo
      opjref = opj.ref.ref
      sameref(opiref, opjref) || continue
      # possible they have shared offsets in certain directions
      for k ∈ eachindex(ls.loops)
        validreorder[k] == 0x03 || continue# if already demoted, don't need to check again
        loopk = ls.loops[k]
        itersym = loopk.itersymbol
        for (l, isym) ∈ enumerate(getindicesonly(opi))
          isym === itersym || continue
          # we match, now we check if this load is offset
          # we'll require all offsets in this index be equal, across both loads and stores
          firstoff = opiref.offsets[l]
          maxdiff = max(
            checkmismatch(ops, opidsᵢ, l, firstoff, 2:length(opidsᵢ)),
            checkmismatch(ops, opidsⱼ, l, firstoff, 1:length(opidsⱼ))
          )
          if maxdiff ≥ (isknown(step(loopk)) ? abs(gethint(step(loopk))) : 1)
            validreorder[k] = 0x00#0x01
          end
        end
      end
    end
  end
  length(ls.outer_reductions) == 0 && return
  for i ∈ eachindex(validreorder)
    validreorder[i] &=
      accept_reorder_according_to_tracked_reductions(ls, ls.loops[i].itersymbol)
  end
end
function checkmismatch(
  ops::Vector{Operation},
  opids::Vector{Int},
  l::Int,
  firstoff::Int8,
  checkrange::UnitRange{Int}
)
  maxabsdiff = 0
  for m ∈ checkrange
    diff = ops[opids[m]].ref.ref.offsets[l] - firstoff
    maxabsdiff = max(maxabsdiff, abs(diff % Int))
  end
  return maxabsdiff
end

offsetloadcollection(ls::LoopSet) = ls.omop
function fill_offset_memop_collection!(ls::LoopSet)
  fill_children!(ls)
  omop = offsetloadcollection(ls)
  ops = operations(ls)
  num_ops = length(ops)
  @unpack opids, opidcollectionmap, batchedcollections, batchedcollectionmap =
    omop
  length(opidcollectionmap) == 0 || return
  resize!(opidcollectionmap, num_ops)
  fill!(opidcollectionmap, (0, 0))
  resize!(batchedcollectionmap, num_ops)
  fill!(batchedcollectionmap, (0, 0))
  empty!(opids)# empty!(offsets);
  for i ∈ 1:num_ops
    op = ops[i]
    isconditionalmemop(op) && continue # not supported yet
    opref = op.ref.ref
    opisload = isload(op)
    (opisload | isstore(op)) || continue
    opidcollectionmap[i] === (0, 0) || continue # if not -1, we already handled
    isdiscontiguous(op) && continue
    collectionsize = 0
    for j ∈ i+1:num_ops
      opp = ops[j]
      isconditionalmemop(opp) && continue # not supported yet
      if opisload # Each collection is either entirely loads or entirely stores
        isload(opp) || continue
      else
        isstore(opp) || continue
      end
      oppref = opp.ref.ref
      sameref(opref, oppref) || continue
      if collectionsize == 0
        push!(opids, [identifier(op), identifier(opp)])
        # push!(offsets, [opref.offsets, oppref.offsets])
        opidcollectionmap[identifier(op)] = (length(opids), 1)
      else
        push!(last(opids), identifier(opp))
        # push!(last(offsets), oppref.offsets)
      end
      opidcollectionmap[identifier(opp)] = (length(opids), length(last(opids)))
      collectionsize += 1
    end
  end
  for opidc ∈ opids
    length(opidc) > 1 || continue
    # we check if we can turn the offsets into an unroll
    # we have up to `length(opidc)` loads to do, so we allocate that many "base" vectors
    # then we iterate through them, adding them to collections as appropriate
    # inner vector tuple is of (op_pos_w/in collection,o)
    unroll_collections = Vector{Vector{Tuple{Int,Int}}}(undef, length(opidc))
    num_unroll_collections = 0
    # num_ops_considered = length(opidc)
    r = 2:length(getindices(ops[first(opidc)]))

    for (i, opid) ∈ enumerate(opidc)
      op = ops[opid]
      offset = getoffsets(op)
      o = offset[1]
      v = view(offset, r)
      found_match = false
      for j ∈ 1:num_unroll_collections
        collectionⱼ = unroll_collections[j]
        # giet id (`first`) of first item in collection to get base offsets for comparison
        if view(getoffsets(ops[opidc[first(first(collectionⱼ))]]), r) == v
          found_match = true
          push!(collectionⱼ, (i, o))
        end
      end
      if !found_match
        num_unroll_collections += 1 # the `i` points to position within `opidc`
        unroll_collections[num_unroll_collections] = [(i, o)]
      end
    end
    for j ∈ 1:num_unroll_collections
      collectionⱼ = unroll_collections[j]
      collen = length(collectionⱼ)
      collen ≤ 1 && continue
      # we have multiple, easiest to process if we sort them
      sort!(collectionⱼ; by = last)
      istart = 1
      ostart = last(first(collectionⱼ))
      oprev = ostart
      for i ∈ 2:collen
        onext = last(collectionⱼ[i])
        if onext == oprev + 1
          oprev = onext
          continue
        end
        # we skipped one, so we must now lower all previous
        if oprev ≠ ostart # it's just 1
          pushbatchedcollection!(
            batchedcollections,
            batchedcollectionmap,
            opidc,
            ops,
            collectionⱼ,
            istart,
            i - 1
          )
        end
        # restart istart and ostart
        istart = i
        ostart = onext
        oprev = onext
      end
      if istart ≠ collen
        pushbatchedcollection!(
          batchedcollections,
          batchedcollectionmap,
          opidc,
          ops,
          collectionⱼ,
          istart,
          collen
        )
      end
    end
  end
  check_valid_reorder_dims!(ls)
end

function pushbatchedcollection!(
  batchedcollections,
  batchedcollectionmap,
  opidc,
  ops,
  collectionⱼ,
  istart,
  istop
)
  colview = view(collectionⱼ, istart:istop)
  push!(batchedcollections, colview)
  bclen = length(batchedcollections)
  for (i, (k, _)) ∈ enumerate(colview)
    # batchedcollectionmap[identifier(op)] gives index into `batchedcollections` containing `colview`
    batchedcollectionmap[identifier(ops[opidc[k]])] = (bclen, i)
  end
end

"""
Returns `0` if the op is the declaration of the constant outerreduction variable.
Returns `n`, where `n` is the constant declarations's index among parents(op), if op is an outer reduction.
Returns `-1` if not an outerreduction.
"""
function isouterreduction(ls::LoopSet, op::Operation)
  if isconstant(op) # equivalent to checking if length(loopdependencies(op)) == 0
    instr = op.instruction
    instr == LOOPCONSTANT &&
      return Core.ifelse(length(loopdependencies(op)) == 0, 0, -1)
    instr.mod === GLOBALCONSTANT && return -1
    ops = operations(ls)
    for or ∈ ls.outer_reductions
      name(op) === name(ops[or]) && return 0
    end
    -1
  elseif iscompute(op)
    var = op.variable
    for opid ∈ ls.outer_reductions
      rop = operations(ls)[opid]
      if rop === op
        for (n, opp) ∈ enumerate(parents(op))
          opp.variable === var && return n
          search_tree(parents(opp), var) && return n
        end
      else
        for (n, opp) ∈ enumerate(parents(op))
          opp === rop && return n
          search_tree(parents(opp), rop.variable) && return n
        end
      end
    end
    -1
  else
    -1
  end
end

struct LoopError <: Exception
  msg::Any
  ex::Any
  LoopError(msg, ex = nothing) = new(msg, ex)
end

function Base.showerror(io::IO, err::LoopError)
  printstyled(io, err.msg; color = :red)
  err.ex === nothing || printstyled(io, '\n', err.ex)
end

function compute_update0!(H2, dHdtau, H, min_dxy2, _dx, _dy, dx, dy)
  @inbounds @fastmath for iy = 1:size(dHdtau, 2)
    for ix = 1:size(dHdtau, 1)
      dHdtau[ix, iy] =
        (
          -((
            -((H[(ix+1)+1, iy+1] - H[ix+1, iy+1])) * _dx -
            -((H[ix+1, iy+1] - H[ix, iy+1])) * _dx
          )) * _dx -
          (
            -((H[ix+1, (iy+1)+1] - H[ix+1, iy+1])) * _dy -
            -((H[ix+1, iy+1] - H[ix+1, iy])) * _dy
          ) * _dy
        ) + 0.6 * dHdtau[ix, iy]
      H2[ix+1, iy+1] = H[ix+1, iy+1] + min_dxy2 / 4.1 * dHdtau[ix, iy]  # sets the BC as H[1]=H[end]=0
    end
  end
  return
end
function compute_update1!(H2, dHdtau, H, min_dxy2, _dx, _dy, dx, dy)
  @turbo for iy = 1:size(dHdtau, 2)
    for ix = 1:size(dHdtau, 1)
      dHdtau[ix, iy] =
        (
          -((
            -((H[(ix+1)+1, iy+1] - H[ix+1, iy+1])) * _dx -
            -((H[ix+1, iy+1] - H[ix, iy+1])) * _dx
          )) * _dx -
          (
            -((H[ix+1, (iy+1)+1] - H[ix+1, iy+1])) * _dy -
            -((H[ix+1, iy+1] - H[ix+1, iy])) * _dy
          ) * _dy
        ) + 0.6 * dHdtau[ix, iy]
      H2[ix+1, iy+1] = H[ix+1, iy+1] + min_dxy2 / 4.1 * dHdtau[ix, iy]  # sets the BC as H[1]=H[end]=0
    end
  end
  return
end

@testset "conv" begin
  lx, ly = 10.0, 10.0   # domain size
  nx, ny = 12, 12     # number of grid points
  nt = 1e3          # max number of iterations
  dx, dy = lx / nx, ly / ny
  xc, yc = LinRange(dx / 2, lx - dx / 2, nx), LinRange(dy / 2, ly - dy / 2, ny)
  dHdtau = zeros(nx - 2, ny - 2)
  dHdtau2 = zeros(nx - 2, ny - 2)
  H = exp.(.-(xc .- lx / 2) .^ 2 .- (yc .- ly / 2)' .^ 2)
  H1 = copy(H)
  H2 = copy(H)
  min_dxy2 = min(dx, dy)^2
  _dx, _dy = 1.0 / dx, 1.0 / dy
  compute_update0!(H1, dHdtau, H, min_dxy2, _dx, _dy, dx, dy)
  compute_update1!(H2, dHdtau2, H, min_dxy2, _dx, _dy, dx, dy)
  @test H1 ≈ H2
  @test dHdtau ≈ dHdtau2
end

function multiindexreverse(n, m)
  A = zeros(n, 2m)
  @turbo for i = 1:n÷2, j = 1:m
    a = 1.23
    b = 3.21
    A[i, j] = a
    A[i, m+j] = b
    r = n + 1 - i
    A[r, j] = a
    A[r, m+j] = b
  end
  return A
end
function multiindexreverse_ref(n, m)
  A = zeros(n, 2m)
  @turbo for i = 1:n÷2, j = 1:m
    a = 1.23
    b = 3.21
    A[i, j] = a
    A[i, m+j] = b
    r = n + 1 - i
    A[r, j] = a
    A[r, m+j] = b
  end
  return A
end

@testset "Multiple indices" begin
  for m = 1:10, n = 1:20
    @test multiindexreverse(n, m) == multiindexreverse_ref(n, m)
  end
end

module ForwardDiffNNlibExt
import ForwardDiff
using LoopVectorization, VectorizationBase, SLEEFPirates, ForwardDiff, NNlib

@generated function NNlib.relu(
  x::ForwardDiff.Dual{T,<:LoopVectorization.AbstractSIMD,N}
) where {T,S,N}
  quote
    $(Expr(:meta, :inline))
    v = x.value
    z = zero(v)
    cmp = v < z
    r = ifelse(cmp, z, v)
    p = x.partials
    ForwardDiff.Dual{T}(
      r,
      ForwardDiff.Partials(Base.Cartesian.@ntuple $N n -> ifelse(cmp, z, p[n]))
    )
  end
end

@generated function NNlib.leakyrelu(
  x::ForwardDiff.Dual{T,<:LoopVectorization.AbstractSIMD,N},
  a = 0.01
) where {T,S,N}
  quote
    $(Expr(:meta, :inline))
    v = x.value
    z = zero(v)

    α = convert(typeof(v), a)
    cmp = v < z
    r = ifelse(cmp, α * v, v)
    p = x.partials
    ForwardDiff.Dual{T}(
      r,
      ForwardDiff.Partials(Base.Cartesian.@ntuple $N n -> ifelse(cmp, α * p[n], p[n]))
    )
  end
end

end

function addsetv!(s::AbstractVector{T}, v::T) where {T}
  for sᵢ ∈ s
    sᵢ === v && return nothing
  end
  push!(s, v)
  nothing
end
function mergesetv!(s1::AbstractVector{T}, s2::AbstractVector{T}) where {T}
  for s ∈ s2
    addsetv!(s1, s)
  end
  nothing
end
function mergesetdiffv!(
  s1::AbstractVector{T},
  s2::AbstractVector{T},
  s3::AbstractVector{T}
) where {T}
  for s ∈ s2
    s ∉ s3 && addsetv!(s1, s)
  end
  nothing
end
# Everything in arg2 (s1) that isn't in arg3 (s2) is added to arg1 (s3)
function setdiffv!(
  s3::AbstractVector{T},
  s1::AbstractVector{T},
  s2::AbstractVector{T}
) where {T}
  for s ∈ s1
    (s ∈ s2) || (s ∉ s3 && push!(s3, s))
  end
end
function setdiffv!(
  s4::AbstractVector{T},
  s3::AbstractVector{T},
  s1::AbstractVector{T},
  s2::AbstractVector{T}
) where {T}
  for s ∈ s1
    (s ∈ s2) ? (s ∉ s4 && push!(s4, s)) : (s ∉ s3 && push!(s3, s))
  end
end
function update_deps!(
  deps::Vector{Symbol},
  reduceddeps::Vector{Symbol},
  parent::Operation
)
  mergesetv!(deps, loopdependencies(parent))#, reduceddependencies(parent))
  if !(isload(parent) || isconstant(parent)) #&& !isreductcombineinstr(parent)
    mergesetv!(reduceddeps, reduceddependencies(parent))
  end
  nothing
end

function pushparent!(
  parents::Vector{Operation},
  deps::Vector{Symbol},
  reduceddeps::Vector{Symbol},
  parent::Operation
)
  @assert parents !== NOPARENTS
  push!(parents, parent)
  update_deps!(deps, reduceddeps, parent)
end
# function pushparent!(mpref::ArrayReferenceMetaPosition, parent::Operation)
#     pushparent!(mpref.parents, mpref.loopdependencies, mpref.reduceddeps, parent)
# end
function add_parent!(
  vparents::Vector{Operation},
  deps::Vector{Symbol},
  reduceddeps::Vector{Symbol},
  ls::LoopSet,
  var,
  elementbytes::Int,
  position::Int
)
  parent = if var isa Symbol
    # if var === :kern_1_1
    #     @show operations(ls) ls.preamble_symsym
    # end
    opp = getop(ls, var, elementbytes)
    # if var === :kern_1_1
    #     @show operations(ls) ls.preamble_symsym
    # end
    # @show var opp first(operations(ls)) opp === first(operations(ls))
    if iscompute(opp) &&
       instruction(opp).instr === :identity &&
       length(loopdependencies(opp)) < position &&
       isone(length(parents(opp))) &&
       name(opp) === name(first(parents(opp)))
      first(parents(opp))
    else
      opp
    end
  elseif var isa Expr #CSE candidate
    add_operation!(ls, gensym!(ls, "temp"), var, elementbytes, position)
  else # assumed constant
    add_constant!(ls, var, elementbytes)
    # add_constant!(ls, var, deps, gensym(:loopredefconst), elementbytes)
  end
  pushparent!(vparents, deps, reduceddeps, parent)
end
# function add_reduction!(
#     vparents::Vector{Operation}, deps::Vector{Symbol}, reduceddeps::Vector{Symbol}, ls::LoopSet, var::Symbol, elementbytes::Int
# )
#     get!(ls.opdict, var) do
#         add_constant!(ls, var, elementbytes)
#     end
# end
function search_tree(opv::Vector{Operation}, var::Symbol) # relies on cycles being forbidden
  for opp ∈ opv
    name(opp) === var && return true
    search_tree(parents(opp), var) && return true
  end
  false
end

search_tree_for_ref(::LoopSet, ::Vector{Operation}, ::Nothing, var::Symbol) =
  var, false
function search_tree_for_ref(
  ls::LoopSet,
  opv::Vector{Operation},
  mpref::ArrayReferenceMetaPosition,
  var::Symbol
) # relies on cycles being forbidden
  for opp ∈ opv
    if opp.ref == mpref.mref
      if varname(mpref) === var
        id = findfirst(==(mpref.mref), ls.refs_aliasing_syms)
        mpref.varname = var = id === nothing ? var : ls.syms_aliasing_refs[id]
        return var, true
      end
    end
    var, found = search_tree_for_ref(ls, parents(opp), mpref, var)
    found && return (var, found)
  end
  var, false
end
function search_tree(opv::Vector{Operation}, var::Operation) # relies on cycles being forbidden
  for opp ∈ opv
    opp === var && return true
    search_tree(parents(opp), var) && return true
  end
  false
end
function update_reduction_status!(
  parentvec::Vector{Operation},
  deps::Vector{Symbol},
  parent::Symbol
)
  for opp ∈ parentvec
    if name(opp) === parent
      mergesetv!(reducedchildren(opp), deps)
      break
    elseif search_tree(parents(opp), parent)
      mergesetv!(reducedchildren(opp), deps)
      update_reduction_status!(parents(opp), deps, parent)
      break
    end
  end
end
# function add_compute!(ls::LoopSet, op::Operation)
# @assert iscompute(op)
# pushop!(ls, child, name(op))
# end
# function isreductzero(op::Operation, ls::LoopSet, reduct_zero::Symbol)
#     isconstant(op) || return false
#     reduct_zero === op.instruction.mod && return true
#     if reduct_zero === :zero
#         iszero(ls, op) && return true
#     elseif reduct_zero === :one
#         isone(ls, op) && return true
#     end
#     false
# end
function add_reduced_deps!(op::Operation, reduceddeps::Vector{Symbol})
  # op.dependencies = copy(loopdependencies(op))
  # mergesetv!(loopdependencies(op), reduceddeps)
  reduceddepsop = reduceddependencies(op)
  if reduceddepsop === NODEPENDENCY
    op.reduced_deps = copy(reduceddeps)
  else
    mergesetv!(reduceddepsop, reduceddeps)
  end
  # reduceddepsop = reducedchildren(op)
  # if reduceddepsop === NODEPENDENCY
  #     op.reduced_children = copy(reduceddeps)
  # else
  #     mergesetv!(reduceddepsop, reduceddeps)
  # end
  nothing
end

function substitute_op_in_parents!(
  vparents::Vector{Operation},
  replacer::Operation,
  replacee::Operation,
  reduceddeps::Vector{Symbol},
  reductsym::Symbol
)
  found = false
  for i ∈ eachindex(vparents)
    opp = vparents[i]
    if opp === replacee
      vparents[i] = replacer
      found = true
    else
      fopp = substitute_op_in_parents!(
        parents(opp),
        replacer,
        replacee,
        reduceddeps,
        reductsym
      )
      if fopp
        add_reduced_deps!(opp, reduceddeps)
        # FIXME: https://github.com/JuliaSIMD/LoopVectorization.jl/issues/259
        # 
        opp.variable = reductsym
        opp.mangledvariable = Symbol("##", reductsym, :_)
      end
      found |= fopp
    end
  end
  found
end

function add_reduction_update_parent!(
  vparents::Vector{Operation},
  deps::Vector{Symbol},
  reduceddeps::Vector{Symbol},
  ls::LoopSet,
  parent::Operation,
  instr::Instruction,
  reduction_ind::Int,
  elementbytes::Int
)
  var = name(parent)
  # isouterreduction = iszero(length(loopdependencies(parent))) && (parent.instruction === LOOPCONSTANT)
  isouterreduction = parent.instruction === LOOPCONSTANT
  # @show instr, vparents, parent, reduction_ind
  # if parent is not an outer reduction...
  # if !isouterreduction && !isreductzero(parent, ls, reduct_zero)
  # @show isouterreduction, parent, length(loopdependencies(parent))
  add_reduct_instruct =
    (!isouterreduction && !isconstant(parent)) && (instr.instr ≢ :ifelse)
  if add_reduct_instruct
    # if instr.instr === :ifelse
    # @assert length(vparents) == 2
    # instrclass = reduction_instruction_class(instruction(vparents[2])) # key allows for faster lookups
    # else
    instrclass = reduction_instruction_class(instr) # key allows for faster lookups
    # end
    reduct_zero = reduction_zero(instrclass)
    # We add
    reductcombine = reduction_scalar_combine(instrclass)
    # reductcombine = :identity
    reductsym = gensym!(ls, "reduction")
    reductzero_sym = gensym!(ls, "reduction##zero")
    # reductsym = gensym(:reduction)
    reductinit = add_constant!(
      ls,
      reductzero_sym,
      loopdependencies(parent),
      reductsym,
      elementbytes,
      :numericconstant
    )
    if reduct_zero === :zero
      push!(ls.preamble_zeros, (identifier(reductinit), IntOrFloat))
    else
      push!(ls.preamble_funcofeltypes, (identifier(reductinit), instrclass))
    end
  else
    reductinit = parent
    reductsym = var
    reductcombine = :identity#Symbol("")
  end
  combineddeps = copy(deps)
  mergesetv!(combineddeps, reduceddeps)
  # directdependency && pushparent!(vparents, deps, reduceddeps, reductinit)#parent) # deps and reduced deps will not be disjoint
  if reduction_ind > 0 # if is directdependency
    insert!(vparents, reduction_ind, reductinit)
    if instr.instr ∈ (:-, :vsub!, :vsub, :/, :vfdiv!, :vfidiv!)
      update_deps!(deps, reduceddeps, reductinit)#parent) # deps and reduced deps will not be disjoint
    end
  elseif !isouterreduction && reductinit !== parent
    substitute_op_in_parents!(
      vparents,
      reductinit,
      parent,
      reduceddeps,
      reductsym
    )
  end
  update_reduction_status!(vparents, reduceddeps, name(reductinit))
  # this is the op added by add_compute
  op = Operation(
    length(operations(ls)),
    reductsym,
    elementbytes,
    instr,
    compute,
    deps,
    reduceddeps,
    vparents
  )
  isouterreduction && push!(ls.outer_reductions, identifier(op))
  opout = pushop!(ls, op, var) # note this overwrites the entry in the operations dict, but not the vector
  # isouterreduction || iszero(length(reduceddeps)) && return opout
  # return opout
  isouterreduction && return opout
  # create child op, which is the reduction combination
  childrdeps = Symbol[]
  childparents = Operation[op]#, parent ]
  if add_reduct_instruct
    @assert childparents !== NOPARENTS
    push!(childparents, parent)
  end
  childdeps = loopdependencies(reductinit)
  setdiffv!(childrdeps, loopdependencies(op), childdeps)
  child = Operation(
    length(operations(ls)),
    name(parent),
    elementbytes,
    reductcombine,
    compute,
    childdeps,
    childrdeps,
    childparents
  )
  # child = Operation(
  #     length(operations(ls)), name(parent), elementbytes, Instruction(reductcombine,:identity), compute, childdeps, childrdeps, childparents
  # )
  pushop!(ls, child, name(parent))
  opout
end

function substitute!(ex::Expr, d::Dict{Symbol,Symbol})
  for (i, arg) ∈ enumerate(ex.args)
    if arg isa Symbol
      ex.args[i] = get(d, arg, arg)
    elseif arg isa Expr
      substitute!(arg, d)
    end
  end
end
function argsymbol(
  ls::LoopSet,
  arg,
  mpref,
  elementbytes::Int,
  position::Int
)::Symbol
  argsym = gensym!(ls, "anonarg")
  if mpref === nothing
    add_operation!(ls, argsym, arg, elementbytes, position)
  else
    add_operation!(ls, argsym, arg, mpref, elementbytes, position)
  end
  return argsym
end
function add_anon_func!(
  ls::LoopSet,
  LHS::Symbol,
  f::Expr,
  ex::Expr,
  position::Int,
  mpref::Union{Nothing,ArrayReferenceMetaPosition},
  elementbytes::Int
)::Operation
  d = Dict{Symbol,Symbol}()
  anonargs = f.args[1]
  if anonargs isa Symbol
    @assert length(ex.args) == 2
    arg = ex.args[2]
    if !(arg isa Symbol)
      argsym = argsymbol(ls, arg, mpref, elementbytes, position)
    else
      argsym = arg::Symbol
    end
    d[anonargs] = argsym
  else
    @assert Meta.isexpr(anonargs, :tuple)
    callargs = @view(ex.args[2:end])
    for i ∈ eachindex(anonargs.args, callargs)
      arg = callargs[i]
      if !(arg isa Symbol)
        argsym = argsymbol(ls, arg, mpref, elementbytes, position)
      else
        argsym = arg::Symbol
      end
      d[anonargs.args[i]] = argsym
    end
  end
  anonbody = f.args[2]
  substitute!(anonbody, d)
  for i ∈ 1:length(anonbody.args)-1
    exᵢ = anonbody.args[i]
    exᵢ isa Expr && push!(ls, exᵢ, elementbytes, position, mpref)
  end
  lastline = last(anonbody.args)
  retop = if lastline isa Symbol
    add_compute!(
      ls,
      LHS,
      instruction(:identity),
      Operation[getop(ls, lastline)],
      elementbytes
    )
  elseif Meta.isexpr(lastline, :call)
    add_compute!(ls, LHS, lastline, elementbytes, position, mpref)
  elseif Meta.isexpr(lastline, :(=))
    add_compute!(ls, LHS, lastline.args[2], elementbytes, position, mpref)
  else
    throw(LoopError("Last line of anon func not understood: $lastline"))
  end
  return retop
end
# TODO: DRY, this is similar to `find_samename_constparent` in `condense_loopset.jl`
function find_inner_reduct_parent(op::Operation, opname::Symbol)
  for opp ∈ parents(op)
    (((isconstant(opp)) && (name(opp) === opname))) && return opp
    opptemp = find_samename_constparent(opp, opname)
    opptemp === opp || return opptemp
  end
  op
end

function maybe_fix_reduced_deps!(
  ::LoopSet,
  deps::Vector{Symbol},
  reduceddeps::Vector{Symbol},
  parent::Operation,
  mpref::ArrayReferenceMetaPosition,
  ::Int
)
  loopdeps_parent = loopdependencies(parent)
  reduceddeps_parent = reduceddependencies(parent)
  loopdeps_mpref = loopdependencies(mpref)
  loopdeps_new = Symbol[]
  pparent_id = findfirst(Base.Fix2(===, name(parent)) ∘ name, parents(parent))
  pparent_id === nothing && return deps, reduceddeps
  pparent = parents(parent)[pparent_id]
  @assert length(loopdependencies(pparent)) ==
          length(loopdeps_parent) + length(reduceddeps_parent)
  reduceddeps_pparent = reduceddependencies(pparent)
  for ld ∈ loopdeps_parent
    if ld ∈ loopdeps_mpref
      push!(loopdeps_new, ld)
    else
      push!(reduceddeps_parent, ld)
      push!(reduceddeps_pparent, ld)
    end
  end
  parent.dependencies = loopdeps_new
  reduct_init = find_inner_reduct_parent(pparent, name(pparent))
  reduct_init.dependencies = loopdeps_new
  reduct_init.reduced_children = reduceddeps_pparent
  # ld = loopdependencies(mpref)
  return loopdeps_new, copy(reduceddeps_parent)
end
function add_compute!(
  ls::LoopSet,
  var::Symbol,
  ex::Expr,
  elementbytes::Int,
  position::Int,
  mpref::Union{Nothing,ArrayReferenceMetaPosition} = nothing
)::Operation
  @assert ex.head === :call
  fexpr = first(ex.args)
  Meta.isexpr(fexpr, :(->)) &&
    return add_anon_func!(ls, var, fexpr, ex, position, mpref, elementbytes)
  # instr = instruction(first(ex.args))::Symbol
  instr = instruction!(ls, first(ex.args))::Instruction

  args = @view(ex.args[2:end])
  if (instr.instr === :pow_fast || instr.instr === :(^)) && length(args) == 2
    arg1 = args[1]
    arg2 = args[2]
    if arg1 isa Number && convert(Float64, arg1) === -1.0
      return add_compute!(
        ls,
        var,
        :(2iseven($arg2) - 1),
        elementbytes,
        position,
        mpref
      )
    end
    if arg2 isa Number
      return add_pow!(ls, var, args[1], arg2, elementbytes, position)
    elseif arg2 isa Val
      arg2num = Int(static(ex.args[3]))::Int
      return add_pow!(ls, var, args[1], arg2num, elementbytes, position)
    end
  elseif instr.instr === :oftype && length(args) == 2
    return get_arg!(ls, args[2], elementbytes, position)
  end
  vparents = Operation[]
  deps = Symbol[]
  reduceddeps = Symbol[]
  reduction_ind = 0
  # @show ex first(operations(ls)) === getop(ls, :kern_1_1, elementbytes) first(operations(ls)) getop(ls, :kern_1_1, elementbytes)
  for (ind, arg) ∈ enumerate(args)
    if var === arg
      reduction_ind = ind
      # add_reduction!(vparents, deps, reduceddeps, ls, arg, elementbytes)
      getop(ls, var, elementbytes)
    elseif arg isa Expr
      isref, argref = tryrefconvert(ls, arg, elementbytes, varname(mpref))
      if isref
        if mpref == argref
          if varname(mpref) === var
            id = findfirst(==(mpref.mref), ls.refs_aliasing_syms)
            mpref.varname =
              var = id === nothing ? var : ls.syms_aliasing_refs[id]
            reduction_ind = ind
            mergesetv!(
              deps,
              loopdependencies(add_load!(ls, argref, elementbytes))
            )
          else
            pushparent!(
              vparents,
              deps,
              reduceddeps,
              add_load!(ls, argref, elementbytes)
            )
          end
        else
          argref.varname = gensym!(ls, "tempload")
          pushparent!(
            vparents,
            deps,
            reduceddeps,
            add_load!(ls, argref, elementbytes)
          )
        end
      else
        add_parent!(
          vparents,
          deps,
          reduceddeps,
          ls,
          arg,
          elementbytes,
          position
        )
      end
    elseif arg ∈ ls.loopsymbols
      loopsymop = add_loopvalue!(ls, arg, elementbytes)
      pushparent!(vparents, deps, reduceddeps, loopsymop)
    else
      add_parent!(vparents, deps, reduceddeps, ls, arg, elementbytes, position)
    end
  end
  reduction = reduction_ind > 0
  loopnestview = view(ls.loopsymbols, 1:position)
  if iszero(length(deps)) && reduction
    append!(deps, loopnestview)
    append!(reduceddeps, loopnestview)
  else
    newloopdeps = Symbol[]
    newreduceddeps = Symbol[]
    setdiffv!(newloopdeps, newreduceddeps, deps, loopnestview)
    mergesetv!(newreduceddeps, reduceddeps)
    deps = newloopdeps
    reduceddeps = newreduceddeps
  end
  # fix for #347
  if (mpref ≢ nothing) &&
     (
       (reduction_ind ≠ 0) &
       (mpref.varname === var) &
       (position > length(loopdependencies(mpref)))
     ) &&
     isone(length(vparents)) &&
     (position == length(loopdependencies(only(vparents))))
    deps, reduceddeps = maybe_fix_reduced_deps!(
      ls,
      deps,
      reduceddeps,
      only(vparents),
      mpref,
      position
    )
  end
  # @show reduction, search_tree(vparents, var) ex var vparents mpref get(ls.opdict, var, nothing) search_tree_for_ref(ls, vparents, mpref, var) # relies on cycles being forbidden
  if reduction || search_tree(vparents, var)
    return add_reduction!(
      ls,
      var,
      reduceddeps,
      deps,
      vparents,
      reduction_ind,
      elementbytes,
      instr
    )
  else
    if mpref ≢ nothing && (
      (length(loopdependencies(mpref)) < position) |
      (length(reduceddependencies(mpref)) > 0)
    )
      var, found = search_tree_for_ref(ls, vparents, mpref, var)
      found && return add_reduction!(
        ls,
        var,
        reduceddeps,
        deps,
        vparents,
        reduction_ind,
        elementbytes,
        instr
      )
    end
    op = Operation(
      length(operations(ls)),
      var,
      elementbytes,
      instr,
      compute,
      deps,
      reduceddeps,
      vparents
    )
    return pushop!(ls, op, var)
  end
  # maybe_const_compute!(ls, op, elementbytes, position)
end
function add_reduction!(
  ls::LoopSet,
  var::Symbol,
  reduceddeps,
  deps,
  vparents,
  reduction_ind,
  elementbytes,
  instr
)
  parent = ls.opdict[var]
  setdiffv!(reduceddeps, deps, loopdependencies(parent))
  # parent = getop(ls, var, elementbytes)
  # if length(reduceddeps) == 0
  if all(!in(deps), reduceddeps)
    if reduction_ind != 0
      insert!(vparents, reduction_ind, parent)
      mergesetv!(deps, loopdependencies(parent))
    end
    op = Operation(
      length(operations(ls)),
      var,
      elementbytes,
      instr,
      compute,
      deps,
      reduceddeps,
      vparents
    )
    pushop!(ls, op, var)
  else
    add_reduction_update_parent!(
      vparents,
      deps,
      reduceddeps,
      ls,
      parent,
      instr,
      reduction_ind,
      elementbytes
    )
  end
end

function add_compute!(
  ls::LoopSet,
  LHS::Symbol,
  instr,
  vparents::Vector{Operation},
  elementbytes::Int
)
  deps = Symbol[]
  reduceddeps = Symbol[]
  for parent ∈ vparents
    update_deps!(deps, reduceddeps, parent)
  end
  op = Operation(
    length(operations(ls)),
    LHS,
    elementbytes,
    instr,
    compute,
    deps,
    reduceddeps,
    vparents
  )
  pushop!(ls, op, LHS)
end
# checks for reductions
function add_compute_ifelse!(
  ls::LoopSet,
  LHS::Symbol,
  cond::Operation,
  iftrue::Operation,
  iffalse::Operation,
  elementbytes::Int
)
  deps = Symbol[]
  reduceddeps = Symbol[]
  update_deps!(deps, reduceddeps, cond)
  update_deps!(deps, reduceddeps, iftrue)
  update_deps!(deps, reduceddeps, iffalse)
  if name(iftrue) === LHS
    if name(iffalse) === LHS # a = ifelse(condition, a, a) # -- why??? Let's just eliminate it.
      return iftrue
    end
    vparents = Operation[cond, iffalse]
    setdiffv!(reduceddeps, deps, loopdependencies(iftrue))
    if any(in(deps), reduceddeps)
      return add_reduction_update_parent!(
        vparents,
        deps,
        reduceddeps,
        ls,
        iftrue,
        Instruction(:LoopVectorization, :ifelse),
        2,
        elementbytes
      )
    end
  elseif name(iffalse) === LHS
    vparents = Operation[cond, iftrue]
    setdiffv!(reduceddeps, deps, loopdependencies(iffalse))
    if any(in(deps), reduceddeps)
      return add_reduction_update_parent!(
        vparents,
        deps,
        reduceddeps,
        ls,
        iffalse,
        Instruction(:LoopVectorization, :ifelse),
        3,
        elementbytes
      )
    end
  end
  vparents = Operation[cond, iftrue, iffalse]
  op = Operation(
    length(operations(ls)),
    LHS,
    elementbytes,
    :ifelse,
    compute,
    deps,
    reduceddeps,
    vparents
  )
  pushop!(ls, op, LHS)
end
function get_arg!(
  ls::LoopSet,
  @nospecialize(x),
  elementbytes::Int,
  position::Int
)::Operation
  if x isa Expr
    add_operation!(
      ls,
      Symbol("###xpow###$(length(operations(ls)))###"),
      x,
      elementbytes,
      position
    )::Operation
  elseif x isa Symbol
    if x ∈ ls.loopsymbols
      add_loopvalue!(ls, x, elementbytes)
    else
      xo = get(ls.opdict, x, nothing)
      xo === nothing && return add_constant!(ls, x, elementbytes)::Operation
      return xo
    end
  elseif x isa Number
    return add_constant!(ls, x^p, elementbytes, var)::Operation
  else
    throw("objects of type $x not supported as arg")
  end
end

# adds x ^ (p::Real)
function add_pow!(
  ls::LoopSet,
  var::Symbol,
  @nospecialize(x),
  p::Real,
  elementbytes::Int,
  position::Int
)
  xop::Operation = if x isa Expr
    add_operation!(
      ls,
      Symbol("###xpow###$(length(operations(ls)))###"),
      x,
      elementbytes,
      position
    )
  elseif x isa Symbol
    if x ∈ ls.loopsymbols
      add_loopvalue!(ls, x, elementbytes)
    else
      xo = get(ls.opdict, x, nothing)
      if xo === nothing
        if round(Int, p) ≠ p
          pushpreamble!(ls, Expr(:(=), var, Expr(:call, :(^), x, p)))
          return add_constant!(ls, var, elementbytes)
        else
          xo = add_constant!(ls, x, elementbytes)::Operation
        end
      end
      xo
    end
  elseif x isa Number
    return add_constant!(ls, x^p, elementbytes, var)::Operation
  end
  if p isa Integer
    pnum = Int(p)::Int
    pden = 1
  else
    prational = rationalize(p)
    @unpack num, den = prational
    pnum = convert(Int, num)::Int
    pden = convert(Int, den)::Int
  end
  if pden == 1
    nothing
  elseif pden == 2
    if pnum == 1
      return add_compute!(ls, var, :sqrt, [xop], elementbytes)
    else
      xop = add_compute!(ls, gensym!(ls, "root"), :sqrt, [xop], elementbytes)
    end
  elseif pden == 3
    if pnum == 1
      return add_compute!(ls, var, :cbrt, [xop], elementbytes)
    else
      xop = add_compute!(ls, gensym!(ls, "cbroot"), :cbrt, [xop], elementbytes)
    end
  elseif pden == 4
    xop = add_compute!(ls, gensym!(ls, "root"), :sqrt, [xop], elementbytes)
    if pnum == 1
      return add_compute!(ls, var, :sqrt, [xop], elementbytes)
    else
      xop = add_compute!(ls, gensym!(ls, "root"), :sqrt, [xop], elementbytes)
    end
  else
    pop = add_constant!(ls, p, elementbytes)
    return add_compute!(ls, var, :^, [xop, pop], elementbytes)
  end
  pint = pnum
  if pint == -1
    return add_compute!(ls, var, :inv, [xop], elementbytes)
  elseif pint < 0
    xop = add_compute!(ls, gensym!(ls, "inverse"), :inv, [xop], elementbytes)
    pint = -pint
  end
  if pint == 0
    op = Operation(
      length(operations(ls)),
      var,
      elementbytes,
      LOOPCONSTANT,
      constant,
      NODEPENDENCY,
      Symbol[],
      NOPARENTS
    )
    push!(
      ls.preamble_funcofeltypes,
      (identifier(op), MULTIPLICATIVE_IN_REDUCTIONS)
    )
    return pushop!(ls, op)
  elseif pint == 1#requires `pden ≠ 1`.
    return add_compute!(ls, var, :identity, [xop], elementbytes)
  elseif pint == 2
    return add_compute!(ls, var, :abs2_fast, [xop], elementbytes)
  end
  # Implementation from https://github.com/JuliaLang/julia/blob/a965580ba7fd0e8314001521df254e30d686afbf/base/intfuncs.jl#L216
  t = trailing_zeros(pint) + 1
  pint >>= t
  while (t -= 1) > 0
    varname = (iszero(pint) && isone(t)) ? var : gensym!(ls, "pbs")
    xop = add_compute!(ls, varname, :abs2_fast, [xop], elementbytes)
  end
  yop = xop
  while pint > 0
    t = trailing_zeros(pint) + 1
    pint >>= t
    while (t -= 1) >= 0
      xop =
        add_compute!(ls, gensym!(ls, "pbs"), :abs2_fast, [xop], elementbytes)
    end
    yop = add_compute!(
      ls,
      iszero(pint) ? var : gensym!(ls, "pbs"),
      :mul_fast,
      [xop, yop],
      elementbytes
    )
  end
  yop
end

using LoopVectorization
using Test
import SpecialFunctions

_f1(a) = SpecialFunctions.gamma(a)
_f2(a) = exp(a)
_f3(a, b) = a + SpecialFunctions.gamma(b)
_f4(a, b) = a + exp(b)
_f5(a, b) = a + SpecialFunctions.gamma(b)
_f6(a, b) = a + SpecialFunctions.gamma(b)

@testset "Safe @turbo" begin


  # All methods, both `can_avx` and `can_turbo`, should recognize that
  # `gamma` is not AVX-able

  @test !LoopVectorization.ArrayInterface.can_avx(SpecialFunctions.gamma)
  @test !LoopVectorization.can_turbo(SpecialFunctions.gamma, Val(1))
  @test !LoopVectorization.can_turbo(_f1, Val(1))

  # `can_avx` is not able to detect that a function `f` which is just
  # `gamma` can be AVX'd, but `can_turbo` can:

  @test LoopVectorization.ArrayInterface.can_avx(exp)
  @test !LoopVectorization.ArrayInterface.can_avx(_f2)
  @test LoopVectorization.can_turbo(exp, Val(1))
  @test LoopVectorization.can_turbo(_f2, Val(1))

  # Next, we test with multiple arguments:
  @test !LoopVectorization.can_turbo(_f3, Val(2))
  @test LoopVectorization.can_turbo(_f4, Val(2))

  x = Float32.(1.05:0.1:10)
  y = Float32.(0.55:0.1:10.5)
  z = similar(x)
  truth = similar(x)

  LoopVectorization.@turbo safe = true for i in indices(x)
    z[i] = SpecialFunctions.gamma(x[i])
  end
  for i in indices(x)
    truth[i] = SpecialFunctions.gamma(x[i])
  end
  @test z ≈ truth

  LoopVectorization.@turbo safe = true for i in indices(x)
    z[i] = _f5(x[i], y[i])
  end
  for i in indices(x)
    truth[i] = _f6(x[i], y[i])
  end
  @test z ≈ truth

end

using LoopVectorization, OffsetArrays, Test


@testset "copy" begin

  function copyavx1!(x, y)
    @turbo for i ∈ eachindex(x)
      x[i] = y[i]
    end
  end
  function copy_avx1!(x, y)
    @_avx for i ∈ eachindex(x)
      x[i] = y[i]
    end
  end
  function copyavx2!(x, y)
    @turbo for i ∈ eachindex(x)
      yᵢ = y[i]
      x[i] = yᵢ
    end
  end
  function copy_avx2!(x, y)
    @_avx for i ∈ eachindex(x)
      yᵢ = y[i]
      x[i] = yᵢ
    end
  end
  function offset_copy!(A, B)
    @inbounds for i = 1:size(A, 1), j = 1:size(B, 2)
      A[i, j+2] = B[i, j]
    end
  end
  function offset_copyavx1!(A, B)
    @turbo for i = 1:size(A, 1), j = 1:size(B, 2)
      A[i, j+2] = B[i, j]
    end
  end
  function offset_copy_avx1!(A, B)
    @_avx for i = 1:size(A, 1), j = 1:size(B, 2)
      @inbounds A[i, j+2] = B[i, j]
    end
  end
  function offset_copyavx2!(A, B)
    @turbo for i = 1:size(A, 1), j = 1:size(B, 2)
      Bᵢⱼ = B[i, j]
      A[i, j+2] = Bᵢⱼ
    end
  end
  function offset_copy_avx2!(A, B)
    @_avx for i = 1:size(A, 1), j = 1:size(B, 2)
      Bᵢⱼ = B[i, j]
      A[i, j+2] = Bᵢⱼ
    end
  end
  function make2point3avx!(x)
    a = 1.742416161578685
    b = 1.5
    @turbo for i ∈ eachindex(x)
      x[i] = a^b
    end
  end
  function make2point3_avx!(x)
    @_avx for i ∈ eachindex(x)
      x[i] = 2.3
    end
  end
  function make23avx!(x)
    @turbo for i ∈ eachindex(x)
      @inbounds x[i] = 23
    end
  end
  function make23_avx!(x)
    @_avx for i ∈ eachindex(x)
      x[i] = 23
    end
  end
  function myfillavx!(x, a)
    @turbo for i ∈ eachindex(x)
      x[i] = a
    end
  end
  function myfill_avx!(x, a)
    @_avx for i ∈ eachindex(x)
      x[i] = a
    end
  end
  function issue_256!(A)
    @turbo for i = 1:size(A, 1)
      A[i, (x = 1,).x] = 0
    end
    A
  end

  function reversecopy1!(B, A)
    for i in eachindex(A)
      B[i] = A[11-i]
    end
    B
  end
  function reversecopy1avx!(B, A)
    @turbo for i in eachindex(A)
      B[i] = A[11-i]
    end
    B
  end
  function reversecopy2!(B, A)
    for i in eachindex(B)
      B[i] = A[-i]
    end
    B
  end
  function reversecopy2avx!(B, A)
    @turbo for i in eachindex(B)
      B[i] = A[-i]
    end
    B
  end
  function reversecopy3avx!(B, A)
    n = length(A)
    @turbo for i = 1:n
      B[i] = A[n+1-i]
    end
    B
  end
  function copy3!(B, A)
    @assert (length(B) ≥ 3) && (length(A) ≥ 3)
    @turbo for i = 1:3
      B[i] = A[i]
    end
    B
  end
  function copyselfdot!(s, x)
    m = zero(eltype(x))
    @turbo for i ∈ 1:2
      sᵢ = x[i]
      s[i] = sᵢ
      m += sᵢ * sᵢ
    end
    m
  end
  function scattercopyavx!(H, a, j)
    @turbo for i ∈ eachindex(j), k ∈ eachindex(a)
      H[j[i], k] = a[k]
    end
    H
  end
  function scattercopy!(H, a, j)
    @inbounds for i ∈ eachindex(j), k ∈ eachindex(a)
      H[j[i], k] = a[k]
    end
    H
  end

  function issue279!(output, input, idx)
    @turbo for j in axes(output, 2), i in axes(output, 1)
      output[i, j, idx] = input[1, 1, i, j, idx]
    end
    output
  end

  function issue279_plain!(output, input, idx)
    for j in axes(output, 2), i in axes(output, 1)
      output[i, j, idx] = input[1, 1, i, j, idx]
    end
    output
  end
  function issue280!(dest, src)
    @turbo for i in indices((dest, src), (2, 2))
      dest[1, i] = src[2, i]
      dest[2, i] = src[1, i]
    end
  end

  function fill_with_3rd!(dest, src)
    p = 1
    @turbo for i ∈ eachindex(dest)
      dest[i] = src[3*p]
    end
  end
  function fill_with_r1c3!(dest, src::AbstractMatrix)
    p = 1
    @turbo for i ∈ eachindex(dest)
      dest[i] = src[p, 3*p]
    end
  end
  function collect_turbo(N, ::Type{T}) where {T}
    l = Vector{T}(undef, N)
    @turbo for i ∈ 1:length(l)
      l[i] = i
    end
    return l
  end
  for T ∈ (Float32, Float64, Int32, Int64)
    @show T, @__LINE__
    R = T <: Integer ? (-T(100):T(100)) : T
    x = rand(R, 237)
    q1 = similar(x)
    q2 = similar(x)

    fill!(q2, -999999)
    copyavx1!(q2, x)
    @test x == q2
    fill!(q2, -999999)
    copy_avx1!(q2, x)
    @test x == q2
    fill!(q2, -999999)
    copyavx2!(q2, x)
    @test x == q2
    fill!(q2, -999999)
    copy_avx2!(q2, x)
    @test x == q2
    fill!(q2, -999999)
    @turbo q2 .= x
    @test x == q2
    @test all(iszero, issue_256!(reshape(x, (length(x), 1))))

    B = rand(R, 79, 83)
    A1 = zeros(T, 79, 85)
    A2 = zeros(T, 79, 85)
    offset_copy!(A1, B)
    fill!(A2, 0)
    offset_copyavx1!(A2, B)
    @test A1 == A2
    fill!(A2, 0)
    offset_copyavx2!(A2, B)
    @test A1 == A2
    fill!(A2, 0)
    offset_copy_avx1!(A2, B)
    @test A1 == A2
    fill!(A2, 0)
    offset_copy_avx2!(A2, B)
    @test A1 == A2
    fill_with_3rd!(A1, B)
    @test all(==(B[3]), A1)
    fill_with_3rd!(A1, eachindex(B))
    @test all(==(3), A1)

    fill_with_r1c3!(A1, B)
    @test all(==(B[1, 3]), A1)
    fill_with_r1c3!(A1, LinearIndices(B))# check args fails
    @test all(==(LinearIndices(B)[1, 3]), A1)

    a = rand(R)
    myfillavx!(x, a)
    fill!(q2, a)
    @test x == q2
    a = rand(R)
    myfill_avx!(x, a)
    fill!(q2, a)
    @test x == q2
    a = rand(R)
    myfill_avx!(x, a)
    fill!(q2, a)
    @test x == q2
    a = rand(R)
    myfillavx!(x, a)
    fill!(q2, a)
    @test x == q2
    q2 .= 23
    fill!(q1, -99999)
    make23_avx!(q1)
    @test q2 == q1
    fill!(q1, -99999)
    make23avx!(q1)
    @test q2 == q1
    if T <: Union{Float32,Float64}
      make2point3avx!(x)
      fill!(q2, 2.3)
      @test x == q2
      fill!(x, -999999)
      make2point3_avx!(x)
      @test x == q2
    end
    a = rand(R)
    @turbo x .= a
    fill!(q2, a)
    @test x == q2
    a = rand(R)
    @turbo x .= a
    fill!(q2, a)
    @test x == q2

    @test reversecopy1!(zeros(T, 10), collect(1:10)) ==
          reversecopy1avx!(zeros(T, 10), collect(1:10))
    @test reversecopy2!(zeros(T, 10), OffsetArray(collect(1:10), -10:-1)) ==
          reversecopy2avx!(zeros(T, 10), OffsetArray(collect(1:10), -10:-1))
    @test 177:-1:1 == reversecopy3avx!(zeros(T, 177), collect(1:177))

    x = rand(R, 3)
    y = similar(x)
    @test copy3!(y, x) == x
    fill!(y, 0)
    @test copyselfdot!(y, x) ≈ x[1]^2 + x[2]^2
    @test view(x, 1:2) == view(y, 1:2)

    H0 = zeros(T, 10, 10)
    H1 = zeros(T, 10, 10)
    j = [1, 2, 5, 8]
    a = rand(R, 10)
    @test scattercopyavx!(H0, a, j) == scattercopy!(H1, a, j)

    input = rand(R, 2, 2, 5, 5, 1)
    output = Array{T}(undef, size(input)[3:end]...)
    output_plain = similar(output)

    @test issue279!(output, input, 1) ≈ issue279_plain!(output_plain, input, 1)

    src = rand(R, 2, 17)
    dest = similar(src)
    issue280!(dest, src)
    @test dest ≈ vcat(view(src, 2, :)', view(src, 1, :)')
    if VERSION ≥ v"1.6"
      src2 = reinterpret(reshape, T, Vector{Tuple{T,T}}(undef, 17))
      src2 .= src
      dest2 = reinterpret(reshape, T, Vector{Tuple{T,T}}(undef, 17))
      issue280!(dest2, src2)
      @test dest2 ≈ vcat(view(src, 2, :)', view(src, 1, :)')
    end

    rng = 10:20
    arr1 = zeros(30)
    arr2 = zeros(30)
    ifirst = 5
    @turbo for i in rng
      arr1[i-ifirst] += 1
    end
    @. arr2[rng-ifirst] += 1
    @test arr1 == arr2

    @test collect_turbo(77, T) == T.(1:77)
  end
end

using LoopVectorization, Test#, OffsetArrays

@testset "Array Wrappers" begin
  @show @__LINE__

  function addone!(y, x)
    @turbo for i ∈ eachindex(x, y)
      y[i] = x[i] + 1
    end
    y
  end

  x5 = PermutedDimsArray(rand(10, 10), (2, 1))
  y5 = PermutedDimsArray(rand(10, 10), (2, 1))
  y5t = x5 .+ 1
  @test LoopVectorization.check_args(x5)
  @test y5t == addone!(y5, x5)

  x6 = view(x5, 1:3, 1:3)
  y6 = view(y5, 1:3, 1:3)
  fill!(y6, NaN)
  @test LoopVectorization.check_args(x6)
  addone!(y6, x6) # also 
  @test y5t == y5 # Test that `NaN`s replaced with correct answers, and that other values were untouched.

  A = rand(12, 13, 14, 15)
  pA = PermutedDimsArray(A, (3, 1, 4, 2))
  @test addone!(similar(pA), pA) == pA .+ 1
  ppA = PermutedDimsArray(pA, (4, 2, 3, 1))
  @test LoopVectorization.check_args(ppA)
  @test addone!(similar(ppA), ppA) == ppA .+ 1

  x = rand(10, 10)
  xc = copy(x)
  xv = view(x, 1:2:10, 1:3)
  xcv = view(xc, 1:2:10, 1:3)
  @test LoopVectorization.check_args(xv)
  addone!(xv, xv)
  xcv .+= 1
  @test x == xc
end

using LoopVectorization, Test

const GAMMA = 1.4
@testset "Reject Unroll" begin
  function r_manual_inline!(r, u)
    @inbounds @fastmath begin
      m = size(u, 2)
      n = size(u, 3)
      fill!(r, 0.0)
      for j = 2:n-1
        for i = 1:m-1
          rl = u[1, i, j]
          rul = u[2, i, j]
          rvl = u[3, i, j]
          rEl = u[4, i, j]

          rr = u[1, i+1, j]
          rur = u[2, i+1, j]
          rvr = u[3, i+1, j]
          rEr = u[4, i+1, j]

          rr1 = 1.0 / rr
          ur = rur * rr1
          vr = rvr * rr1
          Er = rEr * rr1
          u2r = ur * ur + vr * vr
          pr = (GAMMA - 1.0) * (rEr - 0.5 * rr * u2r)
          hr = Er + pr * rr1
          unr = ur

          rhr = rEr + pr

          rl1 = 1.0 / rl
          ul = rul * rl1
          vl = rvl * rl1
          El = rEl * rl1
          u2l = ul * ul + vl * vl
          pl = (GAMMA - 1.0) * (rEl - 0.5 * rl * u2l)
          hl = El + pl * rl1
          unl = ul

          rhl = rEl + pl

          di = sqrt(rr * rl1)
          d1 = 1.0 / (di + 1.0)
          ui = (di * ur + ul) * d1
          vi = (di * vr + vl) * d1
          hi = (di * hr + hl) * d1
          ci2 = (GAMMA - 1.0) * (hi - 0.5 * (ui * ui + vi * vi))
          ci = sqrt(ci2)
          af = 0.5 * (ui * ui + vi * vi)
          uni = ui

          dr = rr - rl
          dru = rur - rul
          drv = rvr - rvl
          drE = rEr - rEl

          rlam1 = abs(uni + ci)
          rlam2 = abs(uni - ci)
          rlam3 = abs(uni)

          s1 = 0.5 * (rlam1 + rlam2)
          s2 = 0.5 * (rlam1 - rlam2)
          al1x = (GAMMA - 1.0) * (af * dr - ui * dru - vi * drv + drE)
          al2x = -uni * dr + dru
          cc1 = ((s1 - rlam3) * al1x / ci2) + (s2 * al2x / ci)
          cc2 = (s2 * al1x / ci) + (s1 - rlam3) * al2x

          f1 = 0.5 * (rr * unr + rl * unl) - 0.5 * (rlam3 * dr + cc1)
          f2 =
            0.5 * (rur * unr + rul * unl) + 0.5 * (pr + pl) -
            0.5 * (rlam3 * dru + cc1 * ui + cc2)
          f3 = 0.5 * (rvr * unr + rvl * unl) - 0.5 * (rlam3 * drv + cc1 * vi)
          f4 = 0.5 * (rhr * unr + rhl * unl) - 0.5 * (rlam3 * drE + cc1 * hi + cc2 * uni)

          r[1, i, j] -= f1
          r[2, i, j] -= f2
          r[3, i, j] -= f3
          r[4, i, j] -= f4

          r[1, i+1, j] += f1
          r[2, i+1, j] += f2
          r[3, i+1, j] += f3
          r[4, i+1, j] += f4
        end
      end
    end
    r
  end

  function r_turbo!(r, u)
    @inbounds begin
      m = size(u, 2)
      n = size(u, 3)
      fill!(r, 0.0)
      @turbo for j = 2:n-1
        for i = 1:m-1
          rl = u[1, i, j]
          rul = u[2, i, j]
          rvl = u[3, i, j]
          rEl = u[4, i, j]

          rr = u[1, i+1, j]
          rur = u[2, i+1, j]
          rvr = u[3, i+1, j]
          rEr = u[4, i+1, j]

          rr1 = 1.0 / rr
          ur = rur * rr1
          vr = rvr * rr1
          Er = rEr * rr1
          u2r = ur * ur + vr * vr
          pr = (GAMMA - 1.0) * (rEr - 0.5 * rr * u2r)
          hr = Er + pr * rr1
          unr = ur

          rhr = rEr + pr

          rl1 = 1.0 / rl
          ul = rul * rl1
          vl = rvl * rl1
          El = rEl * rl1
          u2l = ul * ul + vl * vl
          pl = (GAMMA - 1.0) * (rEl - 0.5 * rl * u2l)
          hl = El + pl * rl1
          unl = ul

          rhl = rEl + pl

          di = sqrt(rr * rl1)
          d1 = 1.0 / (di + 1.0)
          ui = (di * ur + ul) * d1
          vi = (di * vr + vl) * d1
          hi = (di * hr + hl) * d1
          ci2 = (GAMMA - 1.0) * (hi - 0.5 * (ui * ui + vi * vi))
          ci = sqrt(ci2)
          af = 0.5 * (ui * ui + vi * vi)
          uni = ui

          dr = rr - rl
          dru = rur - rul
          drv = rvr - rvl
          drE = rEr - rEl

          rlam1 = abs(uni + ci)
          rlam2 = abs(uni - ci)
          rlam3 = abs(uni)

          s1 = 0.5 * (rlam1 + rlam2)
          s2 = 0.5 * (rlam1 - rlam2)
          al1x = (GAMMA - 1.0) * (af * dr - ui * dru - vi * drv + drE)
          al2x = -uni * dr + dru
          cc1 = ((s1 - rlam3) * al1x / ci2) + (s2 * al2x / ci)
          cc2 = (s2 * al1x / ci) + (s1 - rlam3) * al2x

          f1 = 0.5 * (rr * unr + rl * unl) - 0.5 * (rlam3 * dr + cc1)
          f2 =
            0.5 * (rur * unr + rul * unl) + 0.5 * (pr + pl) -
            0.5 * (rlam3 * dru + cc1 * ui + cc2)
          f3 = 0.5 * (rvr * unr + rvl * unl) - 0.5 * (rlam3 * drv + cc1 * vi)
          f4 = 0.5 * (rhr * unr + rhl * unl) - 0.5 * (rlam3 * drE + cc1 * hi + cc2 * uni)

          r[1, i, j] -= f1
          r[2, i, j] -= f2
          r[3, i, j] -= f3
          r[4, i, j] -= f4

          r[1, i+1, j] += f1
          r[2, i+1, j] += f2
          r[3, i+1, j] += f3
          r[4, i+1, j] += f4
        end
      end
    end
    r
  end

  u = rand(4, 128, 128)
  u[[1, 4], :, :] .= 1.0
  u[[2, 3], :, :] .= 0.1
  @test r_manual_inline!(similar(u), u) ≈ r_turbo!(similar(u), u)

end

lv(x) = GlobalRef(LoopVectorization, x)

"""
    Instruction

`Instruction` represents a function via its module and symbol. It is
similar to a `GlobalRef` and may someday be replaced by `GlobalRef`.
"""
struct Instruction
  mod::Symbol
  instr::Symbol
end
# lower(instr::Instruction) = Expr(:(.), instr.mod, QuoteNode(instr.instr))
# Base.convert(::Type{Expr}, instr::Instruction) = Expr(:(.), instr.mod, QuoteNode(instr.instr))
callexpr(instr::Instruction) =
  if instr.mod === :LoopVectorization
    Expr(:call, lv(instr.instr))
  else#if instr.mod === :Main
    Expr(:call, instr.instr)
  end
function callexpr(instr::Instruction, arg)
  ce = callexpr(instr)
  append!(ce.args, arg)
  ce
end
Base.hash(instr::Instruction, h::UInt64) = hash(instr.instr, hash(instr.mod, h))
# function Base.isless(instr1::Instruction, instr2::Instruction)
#     if instr1.mod === instr2.mod
#         isless(instr1.instr, instr2.instr)
#     else
#         isless(instr1.mod, instr2.mod)
#     end
# end
Base.isequal(ins1::Instruction, ins2::Instruction) =
  (ins1.instr === ins2.instr) && (ins1.mod === ins2.mod)

"""
    InstructionCost

Store parameters related to performance for individual CPU instructions.

$(TYPEDFIELDS)
"""
struct InstructionCost
  "A flag indicating how instruction cost scales with vector width (128, 256, or 512 bits)"
  scaling::Float64 # sentinel values: -3 == no scaling; -2 == offset_scaling, -1 == linear scaling, >0 ->  == latency == reciprocal throughput
  """The number of clock cycles per operation when many of the same operation are repeated in sequence.
  Think of it as the inverse of the flow rate at steady-state. It is typically ≤ the `scalar_latency`."""
  scalar_reciprocal_throughput::Float64
  """The minimum delay, in clock cycles, associated with the instruction.
  Think of it as the delay from turning on a faucet to when water starts coming out the end of the pipe.
  See also `scalar_reciprocal_throughput`."""
  scalar_latency::Int
  "Number of floating-point registered used"
  register_pressure::Int
end
InstructionCost(sl::Int, srt::Float64, scaling::Float64 = -3.0) =
  InstructionCost(scaling, srt, sl, 0)

nocost(c::InstructionCost) = c.scalar_reciprocal_throughput == 0.0
flatcost(c::InstructionCost) = c.scaling == -3.0
offsetscaling(c::InstructionCost) = c.scaling == -2.0
linearscaling(c::InstructionCost) = c.scaling == -1.0

function scalar_cost(ic::InstructionCost)#, ::Type{T} = Float64) where {T}
  @unpack scalar_reciprocal_throughput, scalar_latency, register_pressure = ic
  scalar_reciprocal_throughput, scalar_latency, register_pressure
end
function vector_cost(ic::InstructionCost, Wshift, sizeof_T)
  srt, sl, srp = scalar_cost(ic)
  if flatcost(ic) || Wshift == 0 || nocost(ic) # No scaling
    return srt, sl, srp
  elseif offsetscaling(ic) # offset scaling
    srt *= 1 << (Wshift + VectorizationBase.intlog2(sizeof_T) - 4)
    if (sizeof_T << Wshift) == 64 # VectorizationBase.register_size() # These instructions experience double latency with zmm
      sl += sl
    end
  elseif linearscaling(ic) # linear scaling
    W = 1 << Wshift
    extra_latency = sl - srt
    srt *= W
    sl = round(Int, srt + extra_latency)
    # else # we assume custom cost, and that latency == recip_throughput
    #     scaling = ic.scaling
    #     sl, srt = round(Int,scaling), scaling
  end
  srt, sl, srp
end

const OPAQUE_INSTRUCTION = InstructionCost(-1.0, 20, 20.0, 16)

instruction_cost(instruction::Instruction) =
  instruction.mod === :LoopVectorization ? COST[instruction.instr] :
  OPAQUE_INSTRUCTION
instruction_cost(instruction::Symbol) =
  get(COST, instruction, OPAQUE_INSTRUCTION)
scalar_cost(instr::Instruction) = scalar_cost(instruction_cost(instr))
vector_cost(instr::Instruction, Wshift, sizeof_T) =
  vector_cost(instruction_cost(instr), Wshift, sizeof_T)
# function cost(instruction::InstructionCost, Wshift, sizeof_T)
#     Wshift == 0 ? scalar_cost(instruction) : vector_cost(instruction, Wshift, sizeof_T)
# end

# function cost(instruction::Instruction, Wshift, sizeof_T)
#     cost( instruction_cost(instruction), Wshift, sizeof_T )
# end

# Just a semi-reasonable assumption; should not be that sensitive to anything other than loads

# Comments on setindex!
# 1. Not a part of dependency chains, so not really twice as expensive as getindex?
# 2. getindex loads a register, not setindex!, but we place cost on setindex!
#    as a heuristic means of approximating register pressure, since many loads can be
#    consolidated into a single register. The number of LICM-ed setindex!, on the other
#    hand, should indicate how many registers we're keeping live for the sake of eventually storing.
const COST = Dict{Symbol,InstructionCost}(
  :getindex => InstructionCost(-3.0, 0.5, 3, 0),
  :conditionalload => InstructionCost(-3.0, 0.5, 3, 0),
  :setindex! => InstructionCost(-3.0, 1.0, 3, 0),
  :conditionalstore! => InstructionCost(-3.0, 1.0, 3, 0),
  :zero => InstructionCost(1, 0.5),
  :one => InstructionCost(3, 0.5),
  :(+) => InstructionCost(4, 0.5),
  :(-) => InstructionCost(4, 0.5),
  :(*) => InstructionCost(4, 0.5),
  :(/) => InstructionCost(13, 4.0, -2.0),
  :vadd => InstructionCost(4, 0.5),
  :vadd1 => InstructionCost(4, 0.5),
  :add_fast => InstructionCost(4, 0.5),
  :vsub => InstructionCost(4, 0.5),
  :sub_fast => InstructionCost(4, 0.5),
  # :vadd! => InstructionCost(4,0.5),
  # :vsub! => InstructionCost(4,0.5),
  # :vmul! => InstructionCost(4,0.5),
  :vmul => InstructionCost(4, 0.5),
  :vmul_nsw => InstructionCost(4, 0.5),
  :vadd_nsw => InstructionCost(4, 0.5),
  :vsub_nsw => InstructionCost(4, 0.5),
  :mul_fast => InstructionCost(4, 0.5),
  # :vfdiv => InstructionCost(13,4.0,-2.0),
  # :vfdiv! => InstructionCost(13,4.0,-2.0),
  :rem_fast => InstructionCost(13, 4.0, -2.0), # FIXME
  :div_fast => InstructionCost(13, 4.0, -2.0),
  :vdiv_fast => InstructionCost(20, 4.0, -2.0), # FIXME
  :÷ => InstructionCost(13, 4.0, -2.0),
  # :evadd => InstructionCost(4,0.5),
  # :evsub => InstructionCost(4,0.5),
  # :evmul => InstructionCost(4,0.5),
  # :evfdiv => InstructionCost(13,4.0,-2.0),
  :vsum => InstructionCost(6, 2.0),
  :vprod => InstructionCost(6, 2.0),
  :reduced_add => InstructionCost(4, 0.5),# ignoring reduction part of cost, might be nop
  :reduced_prod => InstructionCost(4, 0.5),# ignoring reduction part of cost, might be nop
  :reduced_max => InstructionCost(4, 0.5),# ignoring reduction part of cost, might be nop
  :reduced_min => InstructionCost(4, 0.5),# ignoring reduction part of cost, might be nop
  :reduce_to_add => InstructionCost(0, 0.0, 0.0, 0),
  :reduce_to_prod => InstructionCost(0, 0.0, 0.0, 0),
  :abs => InstructionCost(1, 0.5),
  :abs2 => InstructionCost(4, 0.5),
  :abs2_fast => InstructionCost(4, 0.5),
  :round => InstructionCost(4, 0.5),
  :(==) => InstructionCost(1, 0.5),
  :(!=) => InstructionCost(1, 0.5),
  :(≠) => InstructionCost(1, 0.5),
  :(===) => InstructionCost(1, 0.5),
  :(!==) => InstructionCost(1, 0.5),
  :(isnan) => InstructionCost(1, 0.5),
  :(isfinite) => InstructionCost(2, 1.0),
  :(isinf) => InstructionCost(2, 1.0),
  :isequal => InstructionCost(1, 0.5),
  :(!) => InstructionCost(1, 0.5),
  :(~) => InstructionCost(1, 0.5),
  :(&) => InstructionCost(1, 0.5),
  :(|) => InstructionCost(1, 0.5),
  :(⊻) => InstructionCost(1, 0.5),
  :(%) => InstructionCost(13, 4.0, -2.0),
  :(rem) => InstructionCost(13, 4.0, -2.0),
  :(>) => InstructionCost(4, 1.0),
  :(<) => InstructionCost(4, 1.0),
  :(>=) => InstructionCost(4, 1.0),
  :(<=) => InstructionCost(4, 1.0),
  :(≥) => InstructionCost(4, 1.0),
  :(≤) => InstructionCost(4, 1.0),
  :(>>) => InstructionCost(1, 0.5),
  :(>>>) => InstructionCost(1, 0.5),
  :(<<) => InstructionCost(1, 0.5),
  :isodd => InstructionCost(1, 0.5),
  :iseven => InstructionCost(1, 0.5),
  :max => InstructionCost(4, 0.5),
  :min => InstructionCost(4, 0.5),
  :max_fast => InstructionCost(4, 0.5),
  :min_fast => InstructionCost(4, 0.5),
  :relu => InstructionCost(4, 0.5),
  # Instruction(:ifelse) => InstructionCost(1, 0.5),
  :ifelse => InstructionCost(1, 0.5),
  :inv => InstructionCost(13, 4.0, -2.0, 1),
  :inv_fast => InstructionCost(10, 4.0, -2.0, 1), # FIXME
  # :vinv => InstructionCost(13,4.0,-2.0,1),
  :muladd => InstructionCost(4, 0.5), # + and * will fuse into this, so much of the time they're not twice as expensive
  :fma => InstructionCost(4, 0.5), # + and * will fuse into this, so much of the time they're not twice as expensive
  :vmuladd_fast => InstructionCost(4, 0.5), # + and * will fuse into this, so much of the time they're not twice as expensive
  :vfma_fast => InstructionCost(4, 0.5), # + and * will fuse into this, so much of the time they're not twice as expensive
  :vfmadd => InstructionCost(4, 0.5), # + and * will fuse into this, so much of the time they're not twice as expensive
  :vfmsub => InstructionCost(4, 0.5), # - and * will fuse into this, so much of the time they're not twice as expensive
  :vfnmadd => InstructionCost(4, 0.5), # + and -* will fuse into this, so much of the time they're not twice as expensive
  :vfnmsub => InstructionCost(4, 0.5), # - and -* will fuse into this, so much of the time they're not twice as expensive
  :vfmadd_fast => InstructionCost(4, 0.5), # + and * will fuse into this, so much of the time they're not twice as expensive
  :vfmsub_fast => InstructionCost(4, 0.5), # - and * will fuse into this, so much of the time they're not twice as expensive
  :vfnmadd_fast => InstructionCost(4, 0.5), # + and -* will fuse into this, so much of the time they're not twice as expensive
  :vfnmsub_fast => InstructionCost(4, 0.5), # - and -* will fuse into this, so much of the time they're not twice as expensive
  :vfmadd231 => InstructionCost(4, 0.5), # + and * will fuse into this, so much of the time they're not twice as expensive
  :vfmsub231 => InstructionCost(4, 0.5), # - and * will fuse into this, so much of the time they're not twice as expensive
  :vfnmadd231 => InstructionCost(4, 0.5), # + and -* will fuse into this, so much of the time they're not twice as expensive
  :vfnmsub231 => InstructionCost(4, 0.5), # - and -* will fuse into this, so much of the time they're not twice as expensive
  :vfmaddsub => InstructionCost(4, 0.5),
  :vfmsubadd => InstructionCost(4, 0.5),
  :sqrt => InstructionCost(15, 4.0, -2.0),
  :sqrt_fast => InstructionCost(15, 4.0, -2.0),
  :log => InstructionCost(-3.0, 15, 30, 11),
  :log2 => InstructionCost(-3.0, 15, 30, 11),
  :log10 => InstructionCost(-3.0, 15, 30, 11),
  :log_fast => InstructionCost(-3.0, 15, 30, 11),
  :log2_fast => InstructionCost(-3.0, 15, 30, 11),
  :log10_fast => InstructionCost(-3.0, 15, 30, 11),
  :log1p => InstructionCost(-3.0, 15, 30, 11),
  :exp => InstructionCost(-3.0, 13.0, 26.0, 14),
  :exp2 => InstructionCost(-3.0, 10.0, 40.0, 14),
  :exp10 => InstructionCost(-3.0, 13.0, 26.0, 14),
  :expm1 => InstructionCost(-3.0, 30.0, 60.0, 19),
  :(^) => InstructionCost(-3.0, 200.0, 400.0, 26), # FIXME
  :pow_fast => InstructionCost(-3.0, 200.0, 400.0, 26), # FIXME
  :sin => InstructionCost(-3, 30.0, 60.0, 23),
  :cos => InstructionCost(-3, 30.0, 60.0, 26),
  :sincos => InstructionCost(-3, 37.0, 85.0, 26),
  :sincos_fast => InstructionCost(-3, 30.0, 60.0, 26),
  :sinpi => InstructionCost(18, 15.0, 68.0, 23),
  :cospi => InstructionCost(18, 15.0, 68.0, 26),
  :sincospi => InstructionCost(25, 37.0, 70.0, 26),
  :log_fast => InstructionCost(20, 20.0, 40.0, 20),
  :exp_fast => InstructionCost(20, 20.0, 20.0, 18),
  :sin_fast => InstructionCost(18, 25.0, 50.0, 23),
  :cos_fast => InstructionCost(18, 25.0, 50.0, 26),
  :sinpi_fast => InstructionCost(18, 25.0, 50.0, 23),
  :cospi_fast => InstructionCost(18, 25.0, 50.0, 26),
  :sincospi_fast => InstructionCost(25, 25.0, 50.0, 26),
  :tanh => InstructionCost(-3.0, 80.0, 160.0, 26), # FIXME
  :tanh_fast => InstructionCost(-3.0, 30.0, 60.0, 20), # FIXME
  :sigmoid_fast => InstructionCost(-3.0, 16.0, 66.0, 15), # FIXME
  :identity => InstructionCost(0, 0.0, 0.0, 0),
  :adjoint => InstructionCost(0, 0.0, 0.0, 0),
  :conj => InstructionCost(0, 0.0, 0.0, 0),
  :transpose => InstructionCost(0, 0.0, 0.0, 0),
  :prefetch => InstructionCost(0, 0.0, 0.0, 0),
  :prefetch0 => InstructionCost(0, 0.0, 0.0, 0),
  :prefetch1 => InstructionCost(0, 0.0, 0.0, 0),
  :prefetch2 => InstructionCost(0, 0.0, 0.0, 0),
  :convert => InstructionCost(4, 0.5),
  :oftype => InstructionCost(4, 0.5),
  :vpermilps177 => InstructionCost(1, 1.0),
  :vmovsldup => InstructionCost(1, 1.0),
  :vmovshdup => InstructionCost(1, 1.0),
  :exponent => InstructionCost(8, 1.0),
  :significand => InstructionCost(8, 1.0)
)

for f in EXTRACTFUNS
  COST[f] = InstructionCost(0, 0.0, 0.0, 0)
end

# # @inline prefetch0(x::Ptr, i) = VectorizationBase.prefetch(x, Val{3}(), Val{0}())
# @inline prefetch0(x, i) = VectorizationBase.prefetch(gep(stridedpointer(x), (data(i),)), Val{3}(), Val{0}())
# @inline prefetch0(x, I::Tuple) = VectorizationBase.prefetch(gep(x, I), Val{3}(), Val{0}())
# @inline prefetch0(x, i, j) = VectorizationBase.prefetch(gep(stridedpointer(x), (data(i), data(j))), Val{3}(), Val{0}())
# # @inline prefetch0(x, i, j, oi, oj) = VectorizationBase.prefetch(gep(stridedpointer(x), (data(i) + data(oi) - 1, data(j) + data(oj) - 1)), Val{3}(), Val{0}())
# @inline prefetch1(x, i) = VectorizationBase.prefetch(gep(stridedpointer(x), (data(i),)), Val{2}(), Val{0}())
# @inline prefetch1(x, i, j) = VectorizationBase.prefetch(gep(stridedpointer(x), (data(i), data(j))), Val{2}(), Val{0}())
# # @inline prefetch1(x, i, j, oi, oj) = VectorizationBase.prefetch(gep(stridedpointer(x), (data(i) + data(oi) - 1, data(j) + data(oj) - 1)), Val{2}(), Val{0}())
# @inline prefetch2(x, i) = VectorizationBase.prefetch(gep(stridedpointer(x), (data(i),)), Val{1}(), Val{0}())
# @inline prefetch2(x, i, j) = VectorizationBase.prefetch(gep(stridedpointer(x), (data(i), data(j))), Val{1}(), Val{0}())
# # @inline prefetch2(x, i, j, oi, oj) = VectorizationBase.prefetch(gep(stridedpointer(x), (data(i) + data(oi) - 1, data(j) + data(oj) - 1)), Val{1}(), Val{0}())

Base.convert(::Type{Instruction}, instr::Symbol) = Instruction(instr)
# instruction(f::Symbol, m) = f ∈ keys(COST) ? Instruction(f) : Instruction(m, f)
# instruction(f::Symbol) = f ∈ keys(COST) ? Instruction(:LoopVectorization, f) : Instruction(Symbol(""), f)
function instruction(f::Symbol)
  # f === :ifelse && return Instruction(:LoopVectorization, :ifelse)
  # @assert f ∈ keys(COST)
  f ∈ keys(COST) ? Instruction(:LoopVectorization, f) :
  Instruction(Symbol(""), f)
end
# instruction(f::Symbol, m::Symbol) = f ∈ keys(COST) ? Instruction(:LoopVectorization, f) : Instruction(m, f)
Instruction(instr::Symbol) = instruction(instr)

struct IfElseOp{F}
  f::F
end
struct IfElseReducer{F}
  f::F
end
struct IfElseReduced{F}
  f::F
end
struct IfElseReduceTo{F}
  f::F
end
struct IfElseCollapser{F}
  f::F
end
@inline (ieo::IfElseOp)(a, b) = ifelse(ieo.f(a, b), a, b)

@inline (ier::IfElseReducer)(a) = VectorizationBase.ifelse_reduce(ier.f, a)
@inline function (ier::IfElseReducer)(a, b)
  f = ier.f
  r = VectorizationBase.ifelse_reduce(f, b)
  ifelse(f(a, r), a, r)
end
@inline (ier::IfElseReducer)(a::VecUnroll) =
  VecUnroll(VectorizationBase.fmap(ier, VectorizationBase.data(a)))
@inline (ier::IfElseReducer)(a::VecUnroll, b::VecUnroll) = VecUnroll(
  VectorizationBase.fmap(
    ier,
    VectorizationBase.data(a),
    VectorizationBase.data(b)
  )
)

@inline (ier::IfElseReduced)(x::NativeTypes, y::NativeTypes) =
  ifelse(ier.f(x, y), x, y)
@inline (ier::IfElseReduced)(x::AbstractSIMD{W}, y::AbstractSIMD{W}) where {W} =
  ifelse(ier.f(x, y), x, y)
@inline function (ier::IfElseReduced)(x::AbstractSIMD, y::AbstractSIMD)
  r = IfElseReduceTo(ier.f)(x, y)
  ifelse(ier.f(r, y), r, y)
end
@inline (ier::IfElseReduced)(x::VecUnroll, y::VecUnroll) =
  VecUnroll(VectorizationBase.fmap(ier, getfield(x, :data), getfield(y, :data)))
@inline function (ier::IfElseReduced)(x::AbstractSIMD, y::NativeTypes)
  f = ier.f
  r = VectorizationBase.ifelse_reduce(f, x)
  ifelse(f(r, y), r, y)
end

@inline (ier::IfElseReduceTo)(a::NativeTypes, ::NativeTypes) = a
@inline (ier::IfElseReduceTo)(a::AbstractSIMD, ::NativeTypes) =
  VectorizationBase.ifelse_reduce(ier.f, a)
@inline (ier::IfElseReduceTo)(a::AbstractSIMD{W}, ::AbstractSIMD{W}) where {W} =
  a
@inline function (ier::IfElseReduceTo)(a::AbstractSIMD, b::AbstractSIMD)
  x, y = VectorizationBase.splitvector(a) # halve recursively
  ier(ifelse(ier.f(x, y), x, y), b)
end
@inline (ier::IfElseReduceTo)(a::VecUnroll, b::VecUnroll) = VecUnroll(
  VectorizationBase.fmap(
    ier,
    VectorizationBase.data(a),
    VectorizationBase.data(b)
  )
)

@inline (iec::IfElseCollapser)(a) =
  VectorizationBase.contract(IfElseOp(iec.f), a, StaticInt{1}())
@inline (iec::IfElseCollapser)(a, ::StaticInt{C}) where {C} =
  VectorizationBase.contract(IfElseOp(iec.f), a, StaticInt{C}())

struct IfElseOpMirror{F,A,B}
  f::F
  a::A
  b::B
end
struct IfElseReducerMirror{F,A,B}
  f::F
  a::A
  b::B
end
struct IfElseReducedMirror{F,A,B}
  f::F
  a::A
  b::B
end
struct IfElseReduceToMirror{F,A}
  f::F
  a::A
end
struct IfElseCollapserMirror{F,A}
  f::F
  a::A
end
@inline (ieo::IfElseOpMirror)(a, b) = ifelse(ieo.f(ieo.a, ieo.b), a, b)

@inline _first_ifelse_reduce_mirror(f::F, a, b) where {F} =
  getfield(VectorizationBase.ifelse_reduce_mirror(f, a, b), 1)
@inline (ier::IfElseReducerMirror)(a) =
  _first_ifelse_reduce_mirror(ier.f, a, ier.a)
@inline function _ifelse_reduce_mirror(f::F, a, b, c, d) where {F}
  r, rm = VectorizationBase.ifelse_reduce_mirror(f, b, d)
  ifelse(f(c, rm), a, r)
end
@inline (ier::IfElseReducerMirror)(a, b) =
  _ifelse_reduce_mirror(ier.f, a, b, ier.a, ier.b)
@inline (ier::IfElseReducerMirror)(a::VecUnroll) = VecUnroll(
  VectorizationBase.fmap(
    _first_ifelse_reduce_mirror,
    ier.f,
    VectorizationBase.data(a),
    VectorizationBase.data(ier.a)
  )
)
@inline function (ier::IfElseReducerMirror)(a::VecUnroll, b::VecUnroll)
  VecUnroll(
    VectorizationBase.fmap(
      _ifelse_reduce_mirror,
      ier.f,
      VectorizationBase.data(a),
      VectorizationBase.data(b),
      VectorizationBase.data(ier.a),
      VectorizationBase.data(ier.b)
    )
  )
end

@inline IfElseReducedMirror(f::F, a::A) where {F,A} =
  IfElseReducedMirror{F,A,Nothing}(f, a, nothing)
@inline (ier::IfElseReducedMirror)(x::NativeTypes, y::NativeTypes) =
  ifelse(ier.f(ier.a, ier.b), x, y)
@inline (ier::IfElseReducedMirror)(
  x::AbstractSIMD{W},
  y::AbstractSIMD{W}
) where {W} = ifelse(ier.f(ier.a, ier.b), x, y)
@inline function _reduce_mirror(f::F, x, y, a, b) where {F}
  r, _ = IfElseReducedMirror(f, a, b)(x, y)
  ifelse(f(r, y), r, y)
end
@inline (ier::IfElseReducedMirror)(x::AbstractSIMD, y::AbstractSIMD) =
  _reduce_mirror(ier.f, x, y, ier.a, ier.b)
@inline (ier::IfElseReducedMirror)(x::VecUnroll, y::VecUnroll) = VecUnroll(
  VectorizationBase.fmap(
    _reduce_mirror,
    ier.f,
    getfield(x, :data),
    getfield(y, :data),
    getfield(ier.a, :data),
    getfield(ier.b, :data)
  )
)
@inline function (ier::IfElseReducedMirror)(x::AbstractSIMD, y::NativeTypes)
  f = ier.f
  r, rm = VectorizationBase.ifelse_reduce_mirror(f, x, ier.a)
  # @show rm, ier.b, r, y
  ifelse(f(rm, ier.b), r, y)
end

@inline (ier::IfElseReduceToMirror)(a::NativeTypes, ::NativeTypes) = a
@inline (ier::IfElseReduceToMirror)(a::AbstractSIMD, ::NativeTypes) =
  VectorizationBase.ifelse_reduce_mirror(ier.f, a, ier.a)
@inline (ier::IfElseReduceToMirror)(
  a::AbstractSIMD{W},
  ::AbstractSIMD{W}
) where {W} = a
@inline function (ier::IfElseReduceToMirror)(a::AbstractSIMD, b::AbstractSIMD)
  x, y = VectorizationBase.splitvector(a) # halve recursively
  w, z = VectorizationBase.splitvector(ier.a) # halve recursively
  f = ier.f
  fwz = f(w, z)
  IfElseReduceToMirror(f, ifelse(fwz, w, z))(ifelse(fwz, x, y), b)
end
@inline (ier::IfElseReduceToMirror)(a::VecUnroll, b::VecUnroll) = VecUnroll(
  VectorizationBase.fmap(
    ier,
    VectorizationBase.data(a),
    VectorizationBase.data(b)
  )
)

# @inline (iec::IfElseCollapserMirror)(a) = getfield(VectorizationBase.ifelse_collapse_mirror(iec.f, a, iec.a), 1, false)
# @inline (iec::IfElseCollapserMirror)(a, ::StaticInt{N}) where {N} = getfield(VectorizationBase.ifelse_collapse_mirror(iec.f, a, iec.a, StaticInt{N}()), 1, false)

@inline (iec::IfElseCollapserMirror)(a) =
  VectorizationBase.ifelse_collapse_mirror(iec.f, a, iec.a)
@inline (iec::IfElseCollapserMirror)(a, ::StaticInt{N}) where {N} =
  VectorizationBase.ifelse_collapse_mirror(iec.f, a, iec.a, StaticInt{N}())

# @inline function (iec::IfElseCollapserMirror)(a, ::StaticInt{C}) where {C}
#   VectorizationBase.contract(IfElseOp(iec.f), a, StaticInt{C}())
# end

const ADDITIVE_IN_REDUCTIONS = 1.0
const MULTIPLICATIVE_IN_REDUCTIONS = 2.0
const ANY = 3.0
const ALL = 4.0
const MAX = 5.0
const MIN = 6.0
const IFELSE = 7.0

const REDUCTION_CLASS = Dict{Symbol,Float64}(
  :+ => ADDITIVE_IN_REDUCTIONS,
  :- => ADDITIVE_IN_REDUCTIONS,
  :* => MULTIPLICATIVE_IN_REDUCTIONS,
  :vadd => ADDITIVE_IN_REDUCTIONS,
  :vsub => ADDITIVE_IN_REDUCTIONS,
  :add_fast => ADDITIVE_IN_REDUCTIONS,
  :sub_fast => ADDITIVE_IN_REDUCTIONS,
  :vadd_fast => ADDITIVE_IN_REDUCTIONS,
  :vsub_fast => ADDITIVE_IN_REDUCTIONS,
  # :vadd! => ADDITIVE_IN_REDUCTIONS,
  # :vsub! => ADDITIVE_IN_REDUCTIONS,
  :vmul => MULTIPLICATIVE_IN_REDUCTIONS,
  :mul_fast => MULTIPLICATIVE_IN_REDUCTIONS,
  :vmul_fast => MULTIPLICATIVE_IN_REDUCTIONS,
  # :vmul! => MULTIPLICATIVE_IN_REDUCTIONS,
  # :evadd => ADDITIVE_IN_REDUCTIONS,
  # :evsub => ADDITIVE_IN_REDUCTIONS,
  # :evmul => MULTIPLICATIVE_IN_REDUCTIONS,
  :& => ALL,
  :| => ANY,
  :muladd => ADDITIVE_IN_REDUCTIONS,
  :fma => ADDITIVE_IN_REDUCTIONS,
  :vmuladd_fast => ADDITIVE_IN_REDUCTIONS,
  :vfma_fast => ADDITIVE_IN_REDUCTIONS,
  :vfmadd => ADDITIVE_IN_REDUCTIONS,
  :vfmsub => ADDITIVE_IN_REDUCTIONS,
  :vfnmadd => ADDITIVE_IN_REDUCTIONS,
  :vfnmsub => ADDITIVE_IN_REDUCTIONS,
  :vfmadd_fast => ADDITIVE_IN_REDUCTIONS,
  :vfmsub_fast => ADDITIVE_IN_REDUCTIONS,
  :vfnmadd_fast => ADDITIVE_IN_REDUCTIONS,
  :vfnmsub_fast => ADDITIVE_IN_REDUCTIONS,
  :vfmadd231 => ADDITIVE_IN_REDUCTIONS,
  :vfmsub231 => ADDITIVE_IN_REDUCTIONS,
  :vfnmadd231 => ADDITIVE_IN_REDUCTIONS,
  :vfnmsub231 => ADDITIVE_IN_REDUCTIONS,
  # :vfmadd! => ADDITIVE_IN_REDUCTIONS,
  # :vfnmadd! => ADDITIVE_IN_REDUCTIONS,
  # :vfmsub! => ADDITIVE_IN_REDUCTIONS,
  # :vfnmsub! => ADDITIVE_IN_REDUCTIONS,
  :reduced_add => ADDITIVE_IN_REDUCTIONS,
  :reduced_prod => MULTIPLICATIVE_IN_REDUCTIONS,
  :reduced_all => ALL,
  :reduced_any => ANY,
  :max => MAX,
  :min => MIN,
  :max_fast => MAX,
  :min_fast => MIN,
  :vfmaddsub => ADDITIVE_IN_REDUCTIONS,
  :vfmsubadd => ADDITIVE_IN_REDUCTIONS
)
reduction_instruction_class(instr::Symbol) = get(REDUCTION_CLASS, instr, NaN)
reduction_instruction_class(instr::Instruction) =
  reduction_instruction_class(instr.instr)
function reduction_to_single_vector(x::Float64)
  if x == ADDITIVE_IN_REDUCTIONS
    :collapse_add
  elseif x == MULTIPLICATIVE_IN_REDUCTIONS
    :collapse_mul
  elseif x == MAX
    :collapse_max
  elseif x == MIN
    :collapse_min
  elseif x == ALL
    :collapse_and
  elseif x == ANY
    :collapse_or
  else
    throw("Reduction not found.")
  end
end
reduce_to_onevecunroll(x::Float64) =
  if x == ADDITIVE_IN_REDUCTIONS
    :+
  elseif x == MULTIPLICATIVE_IN_REDUCTIONS
    :*
  elseif x == MAX
    :max
  elseif x == MIN
    :min
  elseif x == ALL
    :&
  elseif x == ANY
    :|
  else
    throw("Reduction not found.")
  end
reduce_number_of_vectors(x::Float64) =
  if x == ADDITIVE_IN_REDUCTIONS
    :contract_add
  elseif x == MULTIPLICATIVE_IN_REDUCTIONS
    :contract_mul
  elseif x == MAX
    :contract_max
  elseif x == MIN
    :contract_min
  elseif x == ALL
    :contract_and
  elseif x == ANY
    :contract_or
  else
    throw("Reduction not found.")
  end
reduction_to_scalar(x::Float64) =
  if x == ADDITIVE_IN_REDUCTIONS
    :vsum
  elseif x == MULTIPLICATIVE_IN_REDUCTIONS
    :vprod
  elseif x == MAX
    :vmaximum
  elseif x == MIN
    :vminimum
  elseif x == ALL
    :vall
  elseif x == ANY
    :vany
  else
    throw("Reduction not found.")
  end
function reduction_scalar_combine(x::Float64)
  # x == 1.0 ? :reduced_add : x == 2.0 ? :reduced_prod : x == 3.0 ? :reduced_any : x == 4.0 ? :reduced_all : x == 5.0 ? :reduced_max : x == 6.0 ? :reduced_min : throw("Reduction not found.")
  if x == ADDITIVE_IN_REDUCTIONS
    :reduced_add
  elseif x == MULTIPLICATIVE_IN_REDUCTIONS
    :reduced_prod
  elseif x == MAX
    :reduced_max
  elseif x == MIN
    :reduced_min
  elseif x == ALL
    :reduced_all
  elseif x == ANY
    :reduced_any
  else
    throw("Reduction not found.")
  end
end

function reduction_zero(x::Float64)
  # x == 1.0 ? :zero : x == 2.0 ? :one : x == 3.0 ? :false : x == 4.0 ? :true : x == 5.0 ? :typemin : x == 6.0 ? :typemax : throw("Reduction not found.")
  if x == ADDITIVE_IN_REDUCTIONS
    :zero
  elseif x == MULTIPLICATIVE_IN_REDUCTIONS
    :one
  elseif x == MAX
    :typemin
  elseif x == MIN
    :typemax
  elseif x == ALL
    :max_mask
  elseif x == ANY
    :zero_mask
  else
    throw("Reduction not found.")
  end
end
function reduction_zero_class(x::Symbol)::Float64
  if x === :one
    MULTIPLICATIVE_IN_REDUCTIONS
  elseif x === :typemin
    MAX
  elseif x === :typemax
    MIN
  elseif x === :max_mask
    ALL
  elseif x === :zero_mask
    ANY
  elseif x === :zero#sorted last, as should go into preamble_zeros
    ADDITIVE_IN_REDUCTIONS
  else
    throw("Reduction not found.")
  end
end
reduction_zero(x) = reduction_zero(reduction_instruction_class(x))

function isreductcombineinstr(instr::Symbol)
  instr ∈ (
    :reduced_add,
    :reduced_prod,
    :reduce_to_add,
    :reduce_to_prod,
    :reduced_max,
    :reduced_min,
    :reduce_to_max,
    :reduce_to_min
  )
end
isreductcombineinstr(instr::Instruction) = isreductcombineinstr(instr.instr)

const FUNCTIONSYMBOLS = IdDict{Type{<:Function},Instruction}(
  typeof(+) => :add_fast,
  typeof(VectorizationBase.vadd) => :add_fast,
  typeof(add_fast) => :add_fast,
  typeof(-) => :sub_fast,
  typeof(VectorizationBase.vsub) => :sub_fast,
  typeof(sub_fast) => :sub_fast,
  typeof(*) => :mul_fast,
  typeof(VectorizationBase.vmul) => :mul_fast,
  typeof(mul_fast) => :mul_fast,
  typeof(/) => :div_fast,
  typeof(^) => :pow_fast,
  typeof(VectorizationBase.vdiv) => :div_fast,
  typeof(÷) => :(÷),
  typeof(div_fast) => :div_fast,
  typeof(rem_fast) => :rem_fast,
  typeof(==) => :(==),
  typeof(!=) => :(!=),
  typeof(isequal) => :isequal,
  typeof(isnan) => :isnan,
  typeof(isinf) => :isinf,
  typeof(isfinite) => :isfinite,
  typeof(abs) => :abs,
  typeof(abs2) => :abs2_fast,
  typeof(abs2_fast) => :abs2_fast,
  typeof(~) => :(~),
  typeof(!) => :(!),
  typeof(&) => :(&),
  typeof(|) => :(|),
  typeof(⊻) => :(⊻),
  typeof(>) => :(>),
  typeof(<) => :(<),
  typeof(>=) => :(>=),
  typeof(<=) => :(<=),
  typeof(inv) => :inv_fast,
  typeof(inv_fast) => :inv_fast,
  typeof(muladd) => :vmuladd_fast,
  typeof(fma) => :vfma_fast,
  typeof(VectorizationBase.vfma) => :vfma_fast,
  typeof(VectorizationBase.vmuladd) => :vmuladd_fast,
  typeof(VectorizationBase.vfmsub) => :vfmsub_fast,
  typeof(VectorizationBase.vfnmadd) => :vfnmadd_fast,
  typeof(VectorizationBase.vfnmsub) => :vfnmsub_fast,
  typeof(VectorizationBase.vfma_fast) => :vfma_fast,
  typeof(VectorizationBase.vmuladd_fast) => :vmuladd_fast,
  typeof(VectorizationBase.vfmsub_fast) => :vfmsub_fast,
  typeof(VectorizationBase.vfnmadd_fast) => :vfnmadd_fast,
  typeof(VectorizationBase.vfnmsub_fast) => :vfnmsub_fast,
  typeof(VectorizationBase.vfmadd231) => :vfmadd231,
  typeof(VectorizationBase.vfmsub231) => :vfmsub231,
  typeof(VectorizationBase.vfnmadd231) => :vfnmadd231,
  typeof(VectorizationBase.vfnmsub231) => :vfnmsub231,
  typeof(sqrt) => :sqrt_fast,
  typeof(sqrt_fast) => :sqrt_fast,
  typeof(log) => :log_fast,
  typeof(log2) => :log2_fast,
  typeof(log10) => :log10_fast,
  typeof(log_fast) => :log_fast,
  typeof(log1p) => :log1p,
  # typeof(VectorizationBase.vlog) => :log,
  typeof(SLEEFPirates.log) => :log,
  typeof(exp) => :exp,
  typeof(exp2) => :exp2,
  typeof(exp10) => :exp10,
  typeof(Base.FastMath.exp_fast) => :exp,
  typeof(expm1) => :expm1,
  # typeof(VectorizationBase.vexp) => :exp,
  typeof(SLEEFPirates.exp) => :exp,
  typeof(sin) => :sin_fast,
  typeof(Base.FastMath.sin_fast) => :sin_fast,
  typeof(SLEEFPirates.sin) => :sin_fast,
  typeof(cos) => :cos_fast,
  typeof(Base.FastMath.cos_fast) => :cos_fast,
  typeof(SLEEFPirates.cos) => :cos_fast,
  typeof(sincos) => :sincos_fast,
  typeof(Base.FastMath.sincos_fast) => :sincos_fast,
  typeof(SLEEFPirates.sincos) => :sincos_fast,
  typeof(tan) => :tan_fast,
  typeof(Base.FastMath.sincos_fast) => :sincos_fast,
  typeof(SLEEFPirates.sincos) => :sincos_fast,
  typeof(Base.tanh) => :tanh,
  typeof(tanh_fast) => :tanh_fast,
  typeof(sigmoid_fast) => :sigmoid_fast,
  typeof(max) => :max_fast,
  typeof(min) => :min_fast,
  typeof(max_fast) => :max_fast,
  typeof(min_fast) => :min_fast,
  typeof(relu) => :relu,
  typeof(<<) => :<<,
  typeof(>>) => :>>,
  typeof(>>>) => :>>>,
  typeof(%) => :(%),
  typeof(÷) => :(÷),
  typeof(Base.ifelse) => :ifelse,
  typeof(ifelse) => :ifelse,
  typeof(identity) => :identity,
  typeof(conj) => :identity,#conj,
  typeof(÷) => :vdiv_fast
  # typeof(zero) => :zero,
  # typeof(one) => :one,
  # typeof(axes) => :axes,
  # typeof(eltype) => :eltype
)

# implement whitelist for avx_support that package authors may use to conservatively guard `@turbo` application
for f ∈ keys(FUNCTIONSYMBOLS)
  @eval ArrayInterface.can_avx(::$f) = true
end

@testset "GEMM" begin
  # using LoopVectorization, LinearAlgebra, Test; T = Float64
  if LoopVectorization.cache_linesize() == 64
    Unum, Tnum =
      LoopVectorization.register_count() == 16 ? (2, 6) :
      (LoopVectorization.register_size() == 64 ? (3, 9) : (4, 6))
  else
    Unum, Tnum = LoopVectorization.register_count() == 16 ? (2, 6) : (4, 6)
  end
  Unumt, Tnumt = LoopVectorization.register_count() == 16 ? (2, 6) : (5, 5)
  if (LoopVectorization.register_count() != 8) && (
    (LoopVectorization.pick_vector_width(Float64) != 2) ||
    (LoopVectorization.register_count() != 16)
  )
    @test @inferred(LoopVectorization.matmul_params()) == (Unum, Tnum)
  end

  @test LoopVectorization.matmul_params(64, 32, 64; M = 8, K = 100, N = 100, W = 8) ==
        (1, 25)
  @test LoopVectorization.matmul_params(64, 32, 64; M = 8, K = 100, N = 96, W = 8) ==
        (1, 24)
  @test LoopVectorization.matmul_params(64, 32, 64; M = 8, K = 100, N = 92, W = 8) ==
        (1, 23)
  @test LoopVectorization.matmul_params(64, 32, 64; M = 8, K = 100, N = 95, W = 8) ==
        (1, 10)

  AmulBtq1 = :(
    for m ∈ axes(A, 1), n ∈ axes(B, 2)
      C[m, n] = zeroB
      for k ∈ axes(A, 2)
        C[m, n] += A[m, k] * B[n, k]
      end
    end
  )
  lsAmulBt1 = LoopVectorization.loopset(AmulBtq1)
  if (LoopVectorization.register_count() != 8) && (
    (LoopVectorization.pick_vector_width(Float64) != 2) ||
    (LoopVectorization.register_count() != 16)
  )
    @test LoopVectorization.choose_order(lsAmulBt1) ==
          (Symbol[:n, :m, :k], :m, :n, :m, Unum, Tnum)
  end
  AmulBq1 = :(
    for n ∈ axes(B, 2), m ∈ axes(A, 1)
      C[m, n] = 0.0
      for k ∈ axes(A, 2)
        C[m, n] += A[m, k] * B[k, n]
      end
    end
  )
  lsAmulB1 = LoopVectorization.loopset(AmulBq1)
  if (LoopVectorization.register_count() != 8) && (
    (LoopVectorization.pick_vector_width(Float64) != 2) ||
    (LoopVectorization.register_count() != 16)
  )
    @test LoopVectorization.choose_order(lsAmulB1) ==
          (Symbol[:n, :m, :k], :m, :n, :m, Unum, Tnum)
  end
  AmulBq2 = :(
    for m ∈ 1:M, n ∈ 1:N
      C[m, n] = zero(eltype(B))
      for k ∈ 1:K
        C[m, n] += A[m, k] * B[k, n]
      end
    end
  )
  lsAmulB2 = LoopVectorization.loopset(AmulBq2)
  if (LoopVectorization.register_count() != 8) && (
    (LoopVectorization.pick_vector_width(Float64) != 2) ||
    (LoopVectorization.register_count() != 16)
  )
    @test LoopVectorization.choose_order(lsAmulB2) ==
          (Symbol[:n, :m, :k], :m, :n, :m, Unum, Tnum)
  end
  AmulBq3 = :(
    for m ∈ axes(A, 1), n ∈ axes(B, 2)
      ΔCₘₙ = zero(eltype(C))
      for k ∈ axes(A, 2)
        ΔCₘₙ += A[m, k] * B[k, n]
      end
      C[m, n] += ΔCₘₙ
    end
  )
  lsAmulB3 = LoopVectorization.loopset(AmulBq3)
  if (LoopVectorization.register_count() != 8) && (
    (LoopVectorization.pick_vector_width(Float64) != 2) ||
    (LoopVectorization.register_count() != 16)
  )
    @test LoopVectorization.choose_order(lsAmulB3) ==
          (Symbol[:n, :m, :k], :m, :n, :m, Unum, Tnum)
    for (fA, fB, v, Un, Tn) ∈ [
      (identity, identity, :m, Unum, Tnum),
      (adjoint, identity, :k, Unumt, Tnumt),
      (identity, adjoint, :m, Unum, Tnum),
      (adjoint, adjoint, :n, Unum, Tnum),
    ]
      A = fA(rand(2, 2))
      B = fB(rand(2, 2))
      C = similar(A)
      ls = LoopVectorization.@turbo_debug for m ∈ axes(A, 1), n ∈ axes(B, 2)
        ΔCₘₙ = zero(eltype(C))
        for k ∈ axes(A, 2)
          ΔCₘₙ += A[m, k] * B[k, n]
        end
        C[m, n] += ΔCₘₙ
      end
      (m, n) = v === :n ? (:n, :m) : (:m, :n)
      @test LoopVectorization.choose_order(ls) == (Symbol[:n, :m, :k], m, n, v, Un, Tn)
    end
  end
  function AmulB!(C, A, B)
    C .= 0
    for k ∈ axes(A, 2), j ∈ axes(B, 2)
      @simd ivdep for i ∈ axes(A, 1)
        @inbounds C[i, j] += A[i, k] * B[k, j]
      end
    end
  end
  function AmulBavx1!(C, A, B)
    dM, rM = divrem(size(C, 1), 3)
    dN, rN = divrem(size(C, 2), 3)
    dK, rK = divrem(size(B, 1), 3)
    @turbo for m ∈ 1:3*dM+rM, n ∈ 1:3*dN+rN
      Cₘₙ = zero(eltype(C))
      for k ∈ 1:3*dK+rK
        Cₘₙ += A[m, k] * B[k, n]
      end
      C[m, n] = Cₘₙ
    end
  end
  function AmulBavx2!(C, A, B)
    z = zero(eltype(C))
    @turbo unroll = (2, 1) for m ∈ axes(A, 1), n ∈ axes(B, 2)
      C[m, n] = z
      for k ∈ axes(A, 2)
        C[m, n] += A[m, k] * B[k, n]
      end
    end
  end
  function AmulBavx3!(C, A, B)
    @turbo unroll = (2, 2) for m ∈ axes(A, 1), n ∈ axes(B, 2)
      C[m, n] = zero(eltype(C))
      for k ∈ axes(A, 2)
        C[m, n] += A[m, k] * B[k, n]
      end
    end
  end
  myzero(A) = zero(eltype(A))
  # function AmulBavx4!(C, A, B)
  #     @turbo for m ∈ axes(A,1), n ∈ axes(B,2)
  #         C[m,n] = myzero(C)
  #         for k ∈ axes(A,2)
  #             C[m,n] += A[m,k] * B[k,n]
  #         end
  #     end
  # end
  # C = Cs; A = Ats'; B = Bs; factor = 1;
  # ls = LoopVectorization.@turbo_debug for m ∈ axes(A,1), n ∈ axes(B,2)
  #         ΔCₘₙ = zero(eltype(C))
  #         for k ∈ axes(A,2)
  #             ΔCₘₙ += A[m,k] * B[k,n]
  #         end
  #         C[m,n] += ΔCₘₙ * factor
  #     end;
  function AmuladdBavx!(C, A, B, α = one(eltype(C)))
    @turbo unroll = (2, 2) for m ∈ indices((A, C), 1), n ∈ indices((B, C), 2)
      ΔCₘₙ = zero(eltype(C))
      for k ∈ indices((A, B), (2, 1))
        ΔCₘₙ += A[m, k] * B[k, n]
      end
      C[m, n] += α * ΔCₘₙ
    end
  end
  function AmuladdBavx!(C, A, B, α, β)# = zero(eltype(C)))
    @turbo unroll = (1, 1) for m ∈ axes(A, 1), n ∈ axes(B, 2)
      ΔCₘₙ = zero(eltype(C))
      for k ∈ axes(A, 2)
        ΔCₘₙ += A[m, k] * B[k, n]
      end
      C[m, n] = α * ΔCₘₙ + β * C[m, n]
    end
  end
  Amuladdq = :(
    for m ∈ axes(A, 1), n ∈ axes(B, 2)
      ΔCₘₙ = zero(eltype(C))
      for k ∈ axes(A, 2)
        ΔCₘₙ += A[m, k] * B[k, n]
      end
      C[m, n] = α * ΔCₘₙ + β * C[m, n]
    end
  )
  lsAmuladd = LoopVectorization.loopset(Amuladdq)
  if LoopVectorization.register_count() != 8 &&
     LoopVectorization.pick_vector_width(Float64) != 2
    @test LoopVectorization.choose_order(lsAmuladd) ==
          (Symbol[:n, :m, :k], :m, :n, :m, Unum, Tnum)
  end
  Atmuladdq = :(
    for m ∈ axes(A, 2), n ∈ axes(B, 2)
      ΔCₘₙ = zero(eltype(C))
      for k ∈ axes(A, 1)
        ΔCₘₙ += A[k, m] * B[k, n]
      end
      C[m, n] += α * ΔCₘₙ
    end
  )
  lsAtmuladd = LoopVectorization.loopset(Atmuladdq)
  # LoopVectorization.lower(lsAtmuladd, 2, 2)
  # lsAmuladd.operations
  # LoopVectorization.loopdependencies.(lsAmuladd.operations)
  # LoopVectorization.reduceddependencies.(lsAmuladd.operations)
  if LoopVectorization.register_count() != 8
    @test LoopVectorization.choose_order(lsAtmuladd) ==
          (Symbol[:n, :m, :k], :m, :n, :k, Unumt, Tnumt)
  end

  function AmulB_avx1!(C, A, B)
    @_avx unroll = (2, 2) for m ∈ 1:size(A, 1), n ∈ 1:size(B, 2)
      Cₘₙ = zero(eltype(C))
      for k ∈ axes(A, 2)
        Cₘₙ += A[m, k] * B[k, n]
      end
      C[m, n] = Cₘₙ
    end
  end
  fq = :(
    for m ∈ axes(A, 1), n ∈ axes(B, 2)
      Cₘₙ = zero(eltype(C))
      for k ∈ axes(A, 2)
        Cₘₙ += A[m, k] * B[k, n]
      end
      C[m, n] = Cₘₙ
    end
  )
  # exit()
  #         using LoopVectorization, Test
  #         T = Float64
  #         M = 77
  #         A = rand(M, M); B = rand(M, M); C = similar(A);
  function AmulB_avx2!(C, A, B)
    z = zero(eltype(C))
    @_avx unroll = (2, 2) for m ∈ axes(A, 1), n ∈ axes(B, 2)
      C[m, n] = z
      for k ∈ axes(A, 2)
        C[m, n] += A[m, k] * B[k, n]
      end
    end
  end
  # AmulB_avx2!(C, A, B)
  # gq = :(for m ∈ axes(A,1), n ∈ axes(B,2)
  # C[m,n] = z
  # for k ∈ axes(A,2)
  # C[m,n] += A[m,k] * B[k,n]
  # end
  # end);
  # ls = LoopVectorization.loopset(gq);
  # # ls.preamble_symsym
  # ls.operations[1]
  function AmulB_avx3!(C, A, B)
    Kmin = first(axes(A, 2))
    Kmax = last(axes(A, 2))
    @_avx unroll = (2, 2) for m ∈ axes(A, 1), n ∈ axes(B, 2)
      C[m, n] = zero(eltype(C))
      for k ∈ Kmin:Kmax
        C[m, n] += A[m, k] * B[k, n]
      end
    end
  end
  # function AmulB_avx4!(C, A, B)
  #     @_avx for m ∈ axes(A,1), n ∈ axes(B,2)
  #         C[m,n] = myzero(C)
  #         for k ∈ axes(A,2)
  #             C[m,n] += A[m,k] * B[k,n]
  #         end
  #     end
  # end
  # q = :(for m ∈ axes(A,1), n ∈ axes(B,2)
  #       C[m,n] = myzero(C)
  #       for k ∈ axes(A,2)
  #       C[m,n] += A[m,k] * B[k,n]
  #       end
  #       end)
  # ls = LoopVectorization.loopset(q);
  function AmuladdB_avx!(C, A, B, factor = 1)
    @_avx unroll = (2, 2) for m ∈ axes(A, 1), n ∈ axes(B, 2)
      ΔCₘₙ = zero(eltype(C))
      for k ∈ axes(A, 2)
        ΔCₘₙ += A[m, k] * B[k, n]
      end
      C[m, n] += ΔCₘₙ * factor
    end
  end

  function AmulB2x2avx!(C, A, B)
    @turbo unroll = (2, 2) for m ∈ axes(A, 1), n ∈ axes(B, 2)
      ΔCₘₙ = zero(eltype(C))
      for k ∈ axes(A, 2)
        ΔCₘₙ += A[m, k] * B[k, n]
      end
      C[m, n] = ΔCₘₙ
    end
  end
  function AmulB2x2_avx!(C, A, B)
    @_avx unroll = (2, 2) for m ∈ axes(A, 1), n ∈ axes(B, 2)
      ΔCₘₙ = zero(eltype(C))
      for k ∈ axes(A, 2)
        ΔCₘₙ += A[m, k] * B[k, n]
      end
      C[m, n] = ΔCₘₙ
    end
  end

  # function AtmulB!(C, A, B)
  #     for j ∈ axes(C,2), i ∈ axes(C,1)
  #         Cᵢⱼ = zero(eltype(C))
  #         @simd ivdep for k ∈ axes(A,1)
  #             @inbounds Cᵢⱼ += A[k,i] * B[k,j]
  #         end
  #         C[i,j] = Cᵢⱼ
  #     end
  # end
  AtmulBq = :(
    for n ∈ axes(C, 2), m ∈ axes(C, 1)
      Cₘₙ = zero(eltype(C))
      for k ∈ axes(A, 1)
        Cₘₙ += A[k, m] * B[k, n]
      end
      C[m, n] = Cₘₙ
    end
  )
  lsAtmulB = LoopVectorization.loopset(AtmulBq)
  if LoopVectorization.register_count() != 8
    @test LoopVectorization.choose_order(lsAtmulB) ==
          (Symbol[:n, :m, :k], :n, :m, :k, Unumt, Tnumt)
  end
  function AtmulBavx1!(C, A, B)
    @turbo for n ∈ axes(C, 2), m ∈ axes(C, 1)
      Cₘₙ = zero(eltype(C))
      for k ∈ axes(A, 1)
        Cₘₙ += A[k, m] * B[k, n]
      end
      C[m, n] = Cₘₙ
    end
  end
  Atq = :(
    for n ∈ axes(C, 2), m ∈ axes(C, 1)
      Cₘₙ = zero(eltype(C))
      for k ∈ axes(A, 1)
        Cₘₙ += A[k, m] * B[k, n]
      end
      C[m, n] += Cₘₙ * factor
    end
  )
  atls = LoopVectorization.loopset(Atq)
  # LoopVectorization.operations(atls)
  # LoopVectorization.loopdependencies.(operations(atls))
  # LoopVectorization.reduceddependencies.(operations(atls))
  function AtmulB_avx1!(C, A, B)
    @_avx unroll = (2, 2) for n ∈ axes(C, 2), m ∈ axes(C, 1)
      Cₘₙ = zero(eltype(C))
      for k ∈ axes(A, 1)
        Cₘₙ += A[k, m] * B[k, n]
      end
      C[m, n] = Cₘₙ
    end
  end
  function AtmulBavx2!(C, A, B)
    M, N = size(C)
    K = size(B, 1)
    @assert size(C, 1) == size(A, 2)
    @assert size(C, 2) == size(B, 2)
    @assert size(A, 1) == size(B, 1)
    # When the @turbo macro is available, this code is faster:
    z = zero(eltype(C))
    @turbo unroll = (2, 2) for n in axes(C, 2), m in axes(C, 1)
      Cmn = z
      for k in axes(A, 1)
        Cmn += A[k, m] * B[k, n]
      end
      C[m, n] = Cmn
    end
    return C
  end
  function AtmulB_avx2!(C, A, B)
    M, N = size(C)
    K = size(B, 1)
    @assert size(C, 1) == size(A, 2)
    @assert size(C, 2) == size(B, 2)
    @assert size(A, 1) == size(B, 1)
    # When the @turbo macro is available, this code is faster:
    z = zero(eltype(C))
    @_avx for n in axes(C, 2), m in axes(C, 1)
      Cmn = z
      for k in axes(A, 1)
        Cmn += A[k, m] * B[k, n]
      end
      C[m, n] = Cmn
    end
    return C
  end
  function rank2AmulB!(C, Aₘ, Aₖ, B)
    @inbounds for m ∈ axes(C, 1), n ∈ axes(C, 2)
      Cₘₙ = zero(eltype(C))
      @fastmath for k ∈ axes(B, 1)
        Cₘₙ += (Aₘ[m, 1] * Aₖ[1, k] + Aₘ[m, 2] * Aₖ[2, k]) * B[k, n]
      end
      C[m, n] = Cₘₙ
    end
  end
  r2ambq = :(
    for m ∈ axes(C, 1), n ∈ axes(C, 2)
      Cₘₙ = zero(eltype(C))
      for k ∈ axes(B, 1)
        Cₘₙ += (Aₘ[m, 1] * Aₖ[1, k] + Aₘ[m, 2] * Aₖ[2, k]) * B[k, n]
      end
      C[m, n] = Cₘₙ
    end
  )
  lsr2amb = LoopVectorization.loopset(r2ambq)
  if LoopVectorization.register_count() == 32
    if LoopVectorization.cache_linesize() == LoopVectorization.register_size()
      @test LoopVectorization.choose_order(lsr2amb) == ([:n, :m, :k], :m, :n, :m, 3, 7)
    else
      @test LoopVectorization.choose_order(lsr2amb) == ([:n, :m, :k], :m, :n, :m, 3, 7)
    end
  elseif LoopVectorization.register_count() == 16
    if LoopVectorization.pick_vector_width(Float64) == 4
      # @test LoopVectorization.choose_order(lsr2amb) == ([:m, :n, :k], :m, :n, :m, 1, 6)
      # @test LoopVectorization.choose_order(lsr2amb) == ([:m, :n, :k], :m, :n, :m, 2, 4)
      @test LoopVectorization.choose_order(lsr2amb) == ([:n, :m, :k], :n, :m, :m, 3, 3)
    elseif LoopVectorization.pick_vector_width(Float64) == 2
      @test LoopVectorization.choose_order(lsr2amb) == ([:m, :n, :k], :n, :m, :m, 3, 3)
    end
  end
  function rank2AmulBavx!(C, Aₘ, Aₖ, B)
    @turbo for m ∈ axes(C, 1), n ∈ axes(C, 2)
      Cₘₙ = zero(eltype(C))
      for k ∈ axes(B, 1)
        Cₘₙ += (Aₘ[m, 1] * Aₖ[1, k] + Aₘ[m, 2] * Aₖ[2, k]) * B[k, n]
      end
      C[m, n] = Cₘₙ
    end
  end
  function rank2AmulB_avx!(C, Aₘ, Aₖ, B)
    @_avx for m ∈ axes(C, 1), n ∈ axes(C, 2)
      Cₘₙ = zero(eltype(C))
      for k ∈ axes(B, 1)
        Cₘₙ += (Aₘ[m, 1] * Aₖ[1, k] + Aₘ[m, 2] * Aₖ[2, k]) * B[k, n]
      end
      C[m, n] = Cₘₙ
    end
  end
  function rank2AmulBavx_noinline!(C, Aₘ, Aₖ, B)
    @turbo inline = false for m ∈ axes(C, 1), n ∈ axes(C, 2)
      Cₘₙ = zero(eltype(C))
      for k ∈ axes(B, 1)
        Cₘₙ += (Aₘ[m, 1] * Aₖ[1, k] + Aₘ[m, 2] * Aₖ[2, k]) * B[k, n]
      end
      C[m, n] = Cₘₙ
    end
  end

  function mulCAtB_2x2blockavx!(C, A, B)
    M, N = size(C)
    K = size(B, 1)
    @assert size(C, 1) == size(A, 2)
    @assert size(C, 2) == size(B, 2)
    @assert size(A, 1) == size(B, 1)
    T = eltype(C)
    for m ∈ 1:2:(M&-2)
      m1 = m + 1
      for n ∈ 1:2:(N&-2)
        n1 = n + 1
        C11, C21, C12, C22 = zero(T), zero(T), zero(T), zero(T)
        @turbo inline = true for k ∈ 1:K
          C11 += A[k, m] * B[k, n]
          C21 += A[k, m1] * B[k, n]
          C12 += A[k, m] * B[k, n1]
          C22 += A[k, m1] * B[k, n1]
        end
        C[m, n] = C11
        C[m1, n] = C21
        C[m, n1] = C12
        C[m1, n1] = C22
      end
      if isodd(N)
        C1n = 0.0
        C2n = 0.0
        @turbo inline = true for k ∈ 1:K
          C1n += A[k, m] * B[k, N]
          C2n += A[k, m1] * B[k, N]
        end
        C[m, N] = C1n
        C[m1, N] = C2n
      end
    end
    if isodd(M)
      for n ∈ 1:2:(N&-2)
        n1 = n + 1
        Cm1, Cm2 = zero(T), zero(T)
        @turbo inline = true for k ∈ 1:K
          Cm1 += A[k, M] * B[k, n]
          Cm2 += A[k, M] * B[k, n1]
        end
        C[M, n] = Cm1
        C[M, n1] = Cm2
      end
      if isodd(N)
        Cmn = 0.0
        @turbo inline = true for k ∈ 1:K
          Cmn += A[k, M] * B[k, N]
        end
        C[M, N] = Cmn
      end
    end
    return C
  end
  function mulCAtB_2x2block_avx!(C, A, B)
    M, N = size(C)
    K = size(B, 1)
    @assert size(C, 1) == size(A, 2)
    @assert size(C, 2) == size(B, 2)
    @assert size(A, 1) == size(B, 1)
    T = eltype(C)
    for m ∈ 1:2:(M&-2)
      m1 = m + 1
      for n ∈ 1:2:(N&-2)
        n1 = n + 1
        C11, C21, C12, C22 = zero(T), zero(T), zero(T), zero(T)
        @_avx for k ∈ 1:K
          C11 += A[k, m] * B[k, n]
          C21 += A[k, m1] * B[k, n]
          C12 += A[k, m] * B[k, n1]
          C22 += A[k, m1] * B[k, n1]
        end
        C[m, n] = C11
        C[m1, n] = C21
        C[m, n1] = C12
        C[m1, n1] = C22
      end
      if isodd(N)
        C1n = 0.0
        C2n = 0.0
        @_avx for k ∈ 1:K
          C1n += A[k, m] * B[k, N]
          C2n += A[k, m1] * B[k, N]
        end
        C[m, N] = C1n
        C[m1, N] = C2n
      end
    end
    if isodd(M)
      for n ∈ 1:2:(N&-2)
        n1 = n + 1
        Cm1, Cm2 = zero(T), zero(T)
        @_avx for k ∈ 1:K
          Cm1 += A[k, M] * B[k, n]
          Cm2 += A[k, M] * B[k, n1]
        end
        C[M, n] = Cm1
        C[M, n1] = Cm2
      end
      if isodd(N)
        Cmn = 0.0
        @_avx for k ∈ 1:K
          Cmn += A[k, M] * B[k, N]
        end
        C[M, N] = Cmn
      end
    end
    return C
  end

  function mulCAtB_2x2blockavx_noinline!(C, A, B)
    M, N = size(C)
    K = size(B, 1)
    @assert size(C, 1) == size(A, 2)
    @assert size(C, 2) == size(B, 2)
    @assert size(A, 1) == size(B, 1)
    T = eltype(C)
    for m ∈ 1:2:(M&-2)
      m1 = m + 1
      for n ∈ 1:2:(N&-2)
        n1 = n + 1
        C11, C21, C12, C22 = zero(T), zero(T), zero(T), zero(T)
        @turbo inline = false for k ∈ 1:K
          C11 += A[k, m] * B[k, n]
          C21 += A[k, m1] * B[k, n]
          C12 += A[k, m] * B[k, n1]
          C22 += A[k, m1] * B[k, n1]
        end
        C[m, n] = C11
        C[m1, n] = C21
        C[m, n1] = C12
        C[m1, n1] = C22
      end
      if isodd(N)
        C1n = 0.0
        C2n = 0.0
        @turbo inline = false for k ∈ 1:K
          C1n += A[k, m] * B[k, N]
          C2n += A[k, m1] * B[k, N]
        end
        C[m, N] = C1n
        C[m1, N] = C2n
      end
    end
    if isodd(M)
      for n ∈ 1:2:(N&-2)
        n1 = n + 1
        Cm1, Cm2 = zero(T), zero(T)
        @turbo inline = false for k ∈ 1:K
          Cm1 += A[k, M] * B[k, n]
          Cm2 += A[k, M] * B[k, n1]
        end
        C[M, n] = Cm1
        C[M, n1] = Cm2
      end
      if isodd(N)
        Cmn = 0.0
        @turbo inline = false for k ∈ 1:K
          Cmn += A[k, M] * B[k, N]
        end
        C[M, N] = Cmn
      end
    end
    return C
  end
  function dense!(f::F, C, A, B) where {F}
    Kp1 = LoopVectorization.static_size(A, LoopVectorization.StaticInt(2))
    K = Kp1 - LoopVectorization.StaticInt(1)
    @turbo for n ∈ indices((B, C), 2), m ∈ indices((A, C), 1)
      Cmn = zero(eltype(C))
      for k ∈ 1:K
        Cmn += A[m, k] * B[k, n]
      end
      C[m, n] = f(Cmn + A[m, Kp1])
    end
  end

  # TODO: add fast=false option to `@turbo`
  # function gemm_accurate!(C, A, B)
  #     @turbo for n in axes(C,2), m in axes(C,1)
  #         Cmn_hi = zero(eltype(C))
  #         Cmn_lo = zero(eltype(C))
  #         for k in axes(B,1)
  #             hiprod = vmul(A[m,k], B[k,n])
  #             loprod = vfmsub(A[m,k], B[k,n], hiprod)
  #             hi_ts = vadd(hiprod, Cmn_hi)
  #             a1_ts = vsub(hi_ts, Cmn_hi)
  #             b1_ts = vsub(hi_ts, a1_ts)
  #             lo_ts = vadd(vsub(hiprod, a1_ts), vsub(Cmn_hi, b1_ts))
  #             thi = vadd(loprod, Cmn_lo)
  #             a1_t = vsub(thi, Cmn_lo)
  #             b1_t = vsub(thi, a1_t)
  #             tlo = vadd(vsub(loprod, a1_t), vsub(Cmn_lo, b1_t))
  #             c1 = vadd(lo_ts, thi)
  #             hi_ths = vadd(hi_ts, c1)
  #             lo_ths = vsub(c1, vsub(hi_ths, hi_ts))
  #             c2 = vadd(tlo, lo_ths)
  #             Cmn_hi = vadd(hi_ths, c2)
  #             Cmn_lo = vsub(c2, vsub(Cmn_hi, hi_ths))
  #         end
  #         C[m,n] = Cmn_hi
  #     end
  # end
  function AB_plus_BA!(du, u, mat)
    @assert size(u, 1) == size(u, 2) == size(mat, 1) == size(mat, 2)
    for i2 = 1:size(u, 2), i1 = 1:size(u, 1)
      for sum_idx = 1:size(u, 1)
        du[i1, i2] += mat[i1, sum_idx] * u[sum_idx, i2] + mat[i2, sum_idx] * u[i1, sum_idx]
      end
    end
    return nothing
  end

  function AB_plus_BA_avx!(du, u, mat)
    @assert size(u, 1) == size(u, 2) == size(mat, 1) == size(mat, 2)
    @turbo for i2 = 1:size(u, 2), i1 = 1:size(u, 1)
      for sum_idx = 1:size(u, 1)
        du[i1, i2] += mat[i1, sum_idx] * u[sum_idx, i2] + mat[i2, sum_idx] * u[i1, sum_idx]
      end
    end
    return nothing
  end

  function threegemms!(Ab, Bb, Cb, A, B, C)
    M, N = size(Cb)
    K = size(B, 1)
    @turbo for m = 1:M, k = 1:K, n = 1:N
      Ab[m, k] += C[m, n] * B[k, n]
      Bb[k, n] += A[m, k] * C[m, n]
      Cb[m, n] += A[m, k] * B[k, n]
    end
  end
  # M = 77;
  # A = rand(M,M); B = rand(M,M); C = similar(A);
  # mulCAtB_2x2block_avx!(C,A,B)
  # using LoopVectorization
  # mul2x2q = :(for k ∈ 1:K
  # C11 += A[k,m] * B[k,n] 
  # C21 += A[k,m1] * B[k,n] 
  # C12 += A[k,m] * B[k,n1] 
  # C22 += A[k,m1] * B[k,n1]
  # end)
  # lsmul2x2q = LoopVectorization.loopset(mul2x2q)

  lsAtmulBt8 = :(
    for m ∈ 1:8, n ∈ 1:8
      ΔCₘₙ = zero(eltype(C))
      for k ∈ 1:8
        ΔCₘₙ += A[k, m] * B[n, k]
      end
      C[m, n] = ΔCₘₙ
    end
  ) |> LoopVectorization.loopset
  if LoopVectorization.register_count() == 32
    if LoopVectorization.register_size() == 64
      @test LoopVectorization.choose_order(lsAtmulBt8) == ([:n, :m, :k], :m, :n, :m, 1, 8)
      # @test LoopVectorization.choose_order(lsAtmulBt8) == ([:n, :m, :k], :k, :n, :m, 1, 8)
    elseif LoopVectorization.register_size() == 16
      @test LoopVectorization.choose_order(lsAtmulBt8) == ([:n, :m, :k], :m, :n, :m, 2, 8)
    end
  elseif LoopVectorization.register_count() == 16
    # vectorizing `n` is better, as we unroll `m`, neaning `C` can use shuffle stores
    # as we don't unroll `k`, we can't use shuffle loads from `C`
    @test LoopVectorization.choose_order(lsAtmulBt8) == ([:n, :m, :k], :n, :m, :n, 2, 4)
  elseif LoopVectorization.register_count() == 8
    @test LoopVectorization.choose_order(lsAtmulBt8) == ([:n, :m, :k], :m, :n, :m, 1, 4)
  end

  struct TestSizedMatrix{M,N,T} <: DenseMatrix{T}
    data::Matrix{T}
    function TestSizedMatrix{M,N}(data::Matrix{T}) where {M,N,T}
      @assert (M, N) === size(data)
      new{M,N,T}(data)
    end
  end
  Base.parent(A::TestSizedMatrix) = A.data
  Base.IndexStyle(::Type{<:TestSizedMatrix}) = Base.IndexLinear()
  Base.@propagate_inbounds Base.getindex(A::TestSizedMatrix, i::Int) =
    getindex(parent(A), i)
  Base.@propagate_inbounds Base.setindex!(A::TestSizedMatrix, v, i::Int) =
    setindex!(parent(A), v, i)
  Base.@propagate_inbounds Base.getindex(A::TestSizedMatrix, i::CartesianIndex) =
    getindex(parent(A), i + oneunit(i))
  Base.@propagate_inbounds Base.setindex!(A::TestSizedMatrix, v, i::CartesianIndex) =
    setindex!(parent(A), v, i + oneunit(i))
  Base.@propagate_inbounds Base.getindex(A::TestSizedMatrix, i::Int, j::Int) =
    getindex(parent(A), i + 1, j + 1)
  Base.@propagate_inbounds Base.setindex!(A::TestSizedMatrix, v, i::Int, j::Int) =
    setindex!(parent(A), v, i + 1, j + 1)
  Base.size(::TestSizedMatrix{M,N}) where {M,N} = (M, N)
  LoopVectorization.static_size(::TestSizedMatrix{M,N}) where {M,N} =
    (LoopVectorization.StaticInt{M}(), LoopVectorization.StaticInt{N}())
  function Base.axes(::TestSizedMatrix{M,N}) where {M,N}
    (
      LoopVectorization.CloseOpen(LoopVectorization.StaticInt{M}()),
      LoopVectorization.CloseOpen(LoopVectorization.StaticInt{N}()),
    )
  end
  function LoopVectorization.ArrayInterface.axes_types(
    ::Type{TestSizedMatrix{M,N,T}},
  ) where {M,N,T}
    Tuple{
      LoopVectorization.CloseOpen{
        LoopVectorization.StaticInt{0},
        LoopVectorization.StaticInt{M},
      },
      LoopVectorization.CloseOpen{
        LoopVectorization.StaticInt{0},
        LoopVectorization.StaticInt{N},
      },
    }
  end
  Base.unsafe_convert(::Type{Ptr{T}}, A::TestSizedMatrix{M,N,T}) where {M,N,T} =
    pointer(A.data)
  LoopVectorization.static_strides(::TestSizedMatrix{M}) where {M} =
    (LoopVectorization.StaticInt{1}(), LoopVectorization.StaticInt{M}())
  LoopVectorization.ArrayInterface.contiguous_axis(::Type{<:TestSizedMatrix}) =
    LoopVectorization.One()
  LoopVectorization.ArrayInterface.contiguous_batch_size(::Type{<:TestSizedMatrix}) =
    LoopVectorization.Zero()
  LoopVectorization.ArrayInterface.stride_rank(::Type{<:TestSizedMatrix}) =
    (LoopVectorization.StaticInt(1), LoopVectorization.StaticInt(2))
  # LoopVectorization.ArrayInterface.offsets(::Type{TestSizedMatrix{M,N,T}}) where {M,N,T}  = (LoopVectorization.StaticInt{0}(), LoopVectorization.StaticInt{0}())
  LoopVectorization.ArrayInterface.offsets(::TestSizedMatrix) =
    (LoopVectorization.StaticInt{0}(), LoopVectorization.StaticInt{0}())
  LoopVectorization.ArrayInterface.dense_dims(
    ::Type{TestSizedMatrix{M,N,T}},
  ) where {M,N,T} = LoopVectorization.ArrayInterface.dense_dims(Matrix{T})


  @testset "Matmuls" begin
    for T ∈ (Float32, Float64, Int32, Int64)
      TC = sizeof(T) == 4 ? Float32 : Float64
      R = T <: Integer ? (T(-1000):T(1000)) : T
      for M ∈ 48:54
        C0 = zeros(TC, M, M)
        C1 = zeros(TC, M, M)
        A = rand(R, M, M)
        B = rand(R, M, M)
        AB_plus_BA!(C0, A, B)
        AB_plus_BA_avx!(C1, A, B)
        @test C0 ≈ C1
      end
      # let T = Int32
      # exceeds_time_limit() && break
      @show T, @__LINE__
      # M, K, N = 128, 128, 128;
      N = 69
      @time for M ∈ 72:80, K ∈ 72:80
        # @show M,K
        # M, K, N = 73, 75, 69;
        C = Matrix{TC}(undef, M, N)
        A = rand(R, M, K)
        B = rand(R, K, N)
        At = copy(A')
        Bt = copy(B')
        C2 = similar(C)
        A2 = rand(R, M, K + 1)
        dense!(LoopVectorization.relu, C, A2, B)
        @test C ≈
              LoopVectorization.relu.(@view(A2[:, begin:end-1]) * B .+ @view(A2[:, end]))
        @testset "avx $T dynamic gemm" begin
          AmulB!(C2, A, B)
          AmulBavx1!(C, A, B)
          @test C ≈ C2
          fill!(C, 999.99)
          AmulBavx1!(C, At', B)
          @test C ≈ C2
          fill!(C, 999.99)
          AmulBavx2!(C, A, B)
          @test C ≈ C2
          fill!(C, 999.99)
          AmulBavx2!(C, At', B)
          @test C ≈ C2
          fill!(C, 999.99)
          AmulBavx2!(C, A, Bt')
          @test C ≈ C2
          fill!(C, 999.99)
          AmulBavx2!(C, At', Bt')
          @test C ≈ C2
          fill!(C, 999.99)
          AmulBavx3!(C, A, B)
          @test C ≈ C2
          fill!(C, 999.99)
          AmulBavx3!(C, At', B)
          @test C ≈ C2
          fill!(C, 0.0)
          AmuladdBavx!(C, A, B)
          @test C ≈ C2
          AmuladdBavx!(C, At', B)
          @test C ≈ 2C2
          AmuladdBavx!(C, A, B, -1)
          @test C ≈ C2
          AmuladdBavx!(C, At', Bt', -2)
          @test C ≈ -C2
          AmuladdBavx!(C, At', B, 3, 2)
          @test C ≈ C2
          # How much of this can I do before rounding errors are likely to cause test failures?
          # Setting back to zero here...
          AmuladdBavx!(C, At', B, 1, 0)
          @test C ≈ C2
          AmuladdBavx!(C, At', Bt', 2, -1)
          @test C ≈ C2
          # TODO: Reimplement the ZeroInitialized wrappers
          # fill!(C, 9999.999); AmuladdBavx!(ZeroInitializedArray(C), At', Bt')
          # @test C ≈ C2
          fill!(C, 9999.999)
          AmulB2x2avx!(C, A, B)
          @test C ≈ C2
          fill!(C, 9999.999)
          AmulB2x2avx!(C, At', B)
          @test C ≈ C2
          fill!(C, 9999.999)
          AtmulBavx1!(C, At, B)
          @test C ≈ C2
          fill!(C, 9999.999)
          AtmulBavx1!(C, A', B)
          @test C ≈ C2
          fill!(C, 9999.999)
          AtmulBavx2!(C, At, B)
          @test C ≈ C2
          fill!(C, 9999.999)
          AtmulBavx2!(C, A', B)
          @test C ≈ C2
          fill!(C, 9999.999)
          mulCAtB_2x2blockavx!(C, At, B)
          @test C ≈ C2
          fill!(C, 9999.999)
          mulCAtB_2x2blockavx!(C, A', B)
          @test C ≈ C2
          fill!(C, 9999.999)
          mulCAtB_2x2blockavx_noinline!(C, At, B)
          @test C ≈ C2
          fill!(C, 9999.999)
          mulCAtB_2x2blockavx_noinline!(C, A', B)
          @test C ≈ C2
          if RUN_SLOW_TESTS
            # fill!(C, 9999.999); gemm_accurate!(C, A, B);
            # @test C ≈ C2
            # fill!(C, 9999.999); gemm_accurate!(C, At', B);
            # @test C ≈ C2
            # fill!(C, 9999.999); gemm_accurate!(C, A, Bt');
            # @test C ≈ C2
            # fill!(C, 9999.999); gemm_accurate!(C, At', Bt');
            # @test C ≈ C2
            Ab = zeros(eltype(C), size(A))
            Bb = zeros(eltype(C), size(B))
            Cb = zero(C)
            threegemms!(Ab, Bb, Cb, A, B, C)
            @test Ab ≈ C * B'
            @test Bb ≈ A' * C
            @test Cb ≈ A * B
          end
          if iszero(size(A, 1) % 8)
            Abit = A .> 0.5
            fill!(C, 9999.999)
            AmulBavx1!(C, Abit, B)
            @test C ≈ Abit * B
          end
          if iszero(size(B, 1) % 8)
            Bbit = B .> 0.5
            fill!(C, 9999.999)
            AmulBavx1!(C, A, Bbit)
            @test C ≈ A * Bbit
          end
        end
        # exceeds_time_limit() && break
        @testset "_avx $T dynamic gemm" begin
          AmulB_avx1!(C, A, B)
          @test C ≈ C2
          fill!(C, 999.99)
          AmulB_avx1!(C, At', B)
          @test C ≈ C2
          fill!(C, 999.99)
          AmulB_avx2!(C, A, B)
          @test C ≈ C2
          fill!(C, 999.99)
          AmulB_avx2!(C, At', B)
          @test C ≈ C2
          fill!(C, 999.99)
          AmulB_avx2!(C, A, Bt')
          @test C ≈ C2
          fill!(C, 999.99)
          AmulB_avx2!(C, At', Bt')
          @test C ≈ C2
          fill!(C, 999.99)
          AmulB_avx3!(C, A, B)
          @test C ≈ C2
          fill!(C, 999.99)
          AmulB_avx3!(C, At', B)
          @test C ≈ C2
          fill!(C, 0.0)
          AmuladdB_avx!(C, A, B)
          @test C ≈ C2
          AmuladdB_avx!(C, At', B)
          @test C ≈ 2C2
          AmuladdB_avx!(C, A, B, -1)
          @test C ≈ C2
          AmuladdB_avx!(C, At', B, -2)
          @test C ≈ -C2
          fill!(C, 9999.999)
          AmulB2x2_avx!(C, A, B)
          @test C ≈ C2
          fill!(C, 9999.999)
          AmulB2x2_avx!(C, At', B)
          @test C ≈ C2
          fill!(C, 9999.999)
          AtmulB_avx1!(C, At, B)
          @test C ≈ C2
          fill!(C, 9999.999)
          AtmulB_avx1!(C, A', B)
          @test C ≈ C2
          fill!(C, 9999.999)
          AtmulB_avx2!(C, At, B)
          @test C ≈ C2
          fill!(C, 9999.999)
          AtmulB_avx2!(C, A', B)
          @test C ≈ C2
          fill!(C, 9999.999)
          mulCAtB_2x2block_avx!(C, At, B)
          @test C ≈ C2
          fill!(C, 9999.999)
          mulCAtB_2x2block_avx!(C, A', B)
          @test C ≈ C2
        end
        # exceeds_time_limit() && break
        if (M, K) === (73, 77) # pick a random size, we only want to compile once
          As = TestSizedMatrix{M,K}(A)
          Ats = TestSizedMatrix{K,M}(At)
          Bs = TestSizedMatrix{K,N}(B)
          Bts = TestSizedMatrix{N,K}(Bt)
          Cs = TestSizedMatrix{M,N}(C)
          C2z = LoopVectorization.OffsetArray(C2, -1, -1)
          @testset "avx $T static gemm" begin
            # AmulBavx1!(Cs, As, Bs)
            # @test Cs ≈ C2
            # fill!(Cs, 999.99); AmulBavx1!(Cs, Ats', Bs)
            # @test Cs ≈ C2
            fill!(Cs, 999.99)
            AmulBavx2!(Cs, As, Bs)
            @test Cs ≈ C2z
            fill!(Cs, 999.99)
            AmulBavx2!(Cs, Ats', Bs)
            @test Cs ≈ C2z
            fill!(Cs, 999.99)
            AmulBavx2!(Cs, As, Bts')
            @test Cs ≈ C2z
            fill!(Cs, 999.99)
            AmulBavx2!(Cs, Ats', Bts')
            @test Cs ≈ C2z
            fill!(Cs, 999.99)
            AmulBavx3!(Cs, As, Bs)
            @test Cs ≈ C2z
            fill!(Cs, 999.99)
            AmulBavx3!(Cs, Ats', Bs)
            @test Cs ≈ C2z
            fill!(Cs, 0.0)
            AmuladdBavx!(Cs, As, Bs)
            @test Cs ≈ C2z
            AmuladdBavx!(Cs, Ats', Bs)
            @test Cs ≈ 2C2z
            AmuladdBavx!(Cs, As, Bs, -1)
            @test Cs ≈ C2z
            AmuladdBavx!(Cs, Ats', Bs, -2)
            @test Cs ≈ -C2z
            fill!(Cs, 9999.999)
            AmulB2x2avx!(Cs, As, Bs)
            @test Cs ≈ C2z
            fill!(Cs, 9999.999)
            AmulB2x2avx!(Cs, Ats', Bs)
            @test Cs ≈ C2z
            fill!(Cs, 9999.999)
            AtmulBavx1!(Cs, Ats, Bs)
            @test Cs ≈ C2z
            fill!(Cs, 9999.999)
            AtmulBavx1!(Cs, As', Bs)
            @test Cs ≈ C2z
            fill!(Cs, 9999.999)
            AtmulBavx2!(Cs, Ats, Bs)
            @test Cs ≈ C2z
            fill!(Cs, 9999.999)
            AtmulBavx2!(Cs, As', Bs)
            @test Cs ≈ C2z
            # fill!(Cs, 9999.999); mulCAtB_2x2blockavx!(Cs, Ats, Bs);
            # @test Cs ≈ C2
            # fill!(Cs, 9999.999); mulCAtB_2x2blockavx!(Cs, As', Bs);
            # @test Cs ≈ C2
            # fill!(Cs, 9999.999); mulCAtB_2x2blockavx_noinline!(Cs, Ats, Bs);
            # @test Cs ≈ C2
            # fill!(Cs, 9999.999); mulCAtB_2x2blockavx_noinline!(Cs, As', Bs);
            # @test Cs ≈ C2
          end
          # exceeds_time_limit() && break
          @testset "_avx $T static gemm" begin
            # AmulB_avx1!(Cs, As, Bs)
            # @test Cs ≈ C2
            # fill!(Cs, 999.99); AmulB_avx1!(Cs, Ats', Bs)
            # @test Cs ≈ C2
            fill!(Cs, 999.99)
            AmulB_avx2!(Cs, As, Bs)
            @test Cs ≈ C2z
            fill!(Cs, 999.99)
            AmulB_avx2!(Cs, Ats', Bs)
            @test Cs ≈ C2z
            fill!(Cs, 999.99)
            AmulB_avx2!(Cs, As, Bts')
            @test Cs ≈ C2z
            fill!(Cs, 999.99)
            AmulB_avx2!(Cs, Ats', Bts')
            @test Cs ≈ C2z
            fill!(Cs, 999.99)
            AmulB_avx3!(Cs, As, Bs)
            @test Cs ≈ C2z
            fill!(Cs, 999.99)
            AmulB_avx3!(Cs, Ats', Bs)
            @test Cs ≈ C2z
            fill!(Cs, 0.0)
            AmuladdB_avx!(Cs, As, Bs)
            @test Cs ≈ C2z
            AmuladdB_avx!(Cs, Ats', Bs)
            @test Cs ≈ 2C2z
            AmuladdB_avx!(Cs, As, Bs, -1)
            @test Cs ≈ C2z
            AmuladdB_avx!(Cs, Ats', Bs, -2)
            @test Cs ≈ -C2z
            fill!(Cs, 9999.999)
            AmulB2x2_avx!(Cs, As, Bs)
            @test Cs ≈ C2z
            fill!(Cs, 9999.999)
            AmulB2x2_avx!(Cs, Ats', Bs)
            @test Cs ≈ C2z
            fill!(Cs, 9999.999)
            AtmulB_avx1!(Cs, Ats, Bs)
            @test Cs ≈ C2z
            fill!(Cs, 9999.999)
            AtmulB_avx1!(Cs, As', Bs)
            @test Cs ≈ C2z
            fill!(Cs, 9999.999)
            AtmulB_avx2!(Cs, Ats, Bs)
            @test Cs ≈ C2z
            fill!(Cs, 9999.999)
            AtmulB_avx2!(Cs, As', Bs)
            @test Cs ≈ C2z
            # fill!(Cs, 9999.999); mulCAtB_2x2block_avx!(Cs, Ats, Bs);
            # @test Cs ≈ C2
            # fill!(Cs, 9999.999); mulCAtB_2x2block_avx!(Cs, As', Bs);
            # @test Cs ≈ C2
          end
        end
        # exceeds_time_limit() && break
        @testset "$T rank2mul" begin
          Aₘ = rand(R, M, 2)
          Aₖ = rand(R, 2, K)
          Aₖ′ = copy(Aₖ')
          rank2AmulB!(C2, Aₘ, Aₖ, B)
          rank2AmulBavx!(C, Aₘ, Aₖ, B)
          @test C ≈ C2
          fill!(C, 9999.999)
          rank2AmulB_avx!(C, Aₘ, Aₖ, B)
          @test C ≈ C2
          fill!(C, 9999.999)
          rank2AmulBavx_noinline!(C, Aₘ, Aₖ, B)
          @test C ≈ C2
          fill!(C, 9999.999)
          rank2AmulBavx!(C, Aₘ, Aₖ′', B)
          @test C ≈ C2
          fill!(C, 9999.999)
          rank2AmulB_avx!(C, Aₘ, Aₖ′', B)
          @test C ≈ C2
          fill!(C, 9999.999)
          rank2AmulBavx_noinline!(C, Aₘ, Aₖ′', B)
          @test C ≈ C2
        end
      end
    end
  end
end

function load_constrained(
  op::Operation,
  u₁loop::Symbol,
  u₂loop::Symbol,
  innermost_loop_or_vloop::Symbol,
  forprefetch::Bool = false
)
  dependsonu₁ = isu₁unrolled(op)
  dependsonu₂ = isu₂unrolled(op)
  if forprefetch
    (dependsonu₁ & dependsonu₂) || return false
  end
  unrolleddeps = Symbol[]
  if forprefetch # innermost_loop_or_vloop is innermost_loop
    push!(unrolleddeps, innermost_loop_or_vloop)
  else# if this is for `sub_fmas` instead of prefetch, then `innermost_loop_or_vloop` is `vloop`, and we only care if it isn't vectorized
    # if it is vectorized, it can't be broadcasted on AVX512 anyway, so no point trying to enable that optimization
    dependsonu₁ &= u₁loop !== innermost_loop_or_vloop
    dependsonu₂ &= u₂loop !== innermost_loop_or_vloop
  end
  dependsonu₁ && push!(unrolleddeps, u₁loop)
  dependsonu₂ && push!(unrolleddeps, u₂loop)
  length(unrolleddeps) > 0 || return false
  any(parents(op)) do opp
    isload(opp) && all(in(loopdependencies(opp)), unrolleddeps)
  end
end
function check_if_remfirst(ls::LoopSet, ua::UnrollArgs)
  usorig = ls.unrollspecification
  @unpack u₁, u₁loopsym, u₂loopsym, u₂max = ua
  u₁loop = getloop(ls, u₁loopsym)
  u₂loop = getloop(ls, u₂loopsym)
  if isstaticloop(u₁loop) && (usorig.u₁ != u₁)
    return true
  end
  if isstaticloop(u₂loop) && (usorig.u₂ != u₂max)
    return true
  end
  false
end
function sub_fmas(ls::LoopSet, op::Operation, ua::UnrollArgs)
  @unpack u₁, u₁loopsym, u₂loopsym, vloopsym, u₂max = ua
  !(
    load_constrained(op, u₁loopsym, u₂loopsym, vloopsym) ||
    check_if_remfirst(ls, ua)
  )
end

function parent_unroll_status(
  op::Operation,
  u₁loop::Symbol,
  us::UnrollSpecification
)
  parentsop = parents(op)
  u2 = fill(false, length(parentsop))
  u1 = similar(u2)
  for i ∈ eachindex(parentsop)
    u1[i] = isunrolled_sym(parentsop[i], u₁loop, us)
  end
  u1, u2
end
function parent_unroll_status(
  op::Operation,
  u₁loop::Symbol,
  u₂loop::Symbol,
  vloop::Symbol,
  u₂max::Int,
  us::UnrollSpecification
)
  u₂max == -1 && return parent_unroll_status(op, u₁loop, us)
  vparents = parents(op)
  # parent_names = Vector{Symbol}(undef, length(vparents))
  parents_u₁syms = Vector{Bool}(undef, length(vparents))
  parents_u₂syms = Vector{Bool}(undef, length(vparents))
  for i ∈ eachindex(vparents)
    parents_u₁syms[i], parents_u₂syms[i] =
      isunrolled_sym(vparents[i], u₁loop, u₂loop, vloop, us)#, u₂max)
  end
  # parent_names, parents_u₁syms, parents_u₂syms
  parents_u₁syms, parents_u₂syms
end

function _add_loopvalue!(
  ex::Expr,
  loopval::Symbol,
  vloop::Loop,
  u::Int,
  loop::Loop
)
  vloopsym = vloop.itersymbol
  if loopval === vloopsym
    if iszero(u)
      push!(ex.args, _MMind(loopval, step(vloop)))
    else
      vstep = step(vloop)
      mm = _MMind(loopval, vstep)
      if isone(u) & isone(vstep)
        push!(ex.args, Expr(:call, lv(:vadd_nsw), VECTORWIDTHSYMBOL, mm))
      else
        push!(
          ex.args,
          Expr(:call, lv(:vadd_nsw), mulexpr(VECTORWIDTHSYMBOL, u, vstep), mm)
        )
      end
    end
  elseif u == 0
    push!(ex.args, loopval)
  elseif isknown(step(loop))
    push!(
      ex.args,
      Expr(:call, lv(:vadd_nsw), loopval, staticexpr(u * gethint(step(loop))))
    )
  else
    push!(ex.args, Expr(:call, lv(:vadd_nsw), loopval, mulexpr(step(loop), u)))
  end
end
function add_loopvalue!(
  instrcall::Expr,
  loopval,
  ua::UnrollArgs,
  u₁::Int,
  loop::Loop
)
  @unpack u₁loopsym, u₂loopsym, vloopsym, vloop, suffix = ua
  if loopval === u₁loopsym #parentsunrolled[n]
    if isone(u₁)
      _add_loopvalue!(instrcall, loopval, vloop, 0, loop)
    else
      t = Expr(:tuple)
      for u ∈ 0:u₁-1
        _add_loopvalue!(t, loopval, vloop, u, loop)
      end
      push!(instrcall.args, Expr(:call, lv(:VecUnroll), t))
    end
  elseif suffix > 0 && loopval === u₂loopsym
    _add_loopvalue!(instrcall, loopval, vloop, suffix, loop)
  elseif loopval === vloopsym
    push!(instrcall.args, _MMind(loopval, step(vloop)))
  else
    push!(instrcall.args, loopval)
  end
end

vecunrolllen(::Type{VecUnroll{N,W,T,V}}) where {N,W,T,V} = (N::Int + 1)
vecunrolllen(_) = -1
function ifelselastexpr(
  hasf::Bool,
  M::Int,
  vargtypes,
  K::Int,
  S::Int,
  maskearly::Bool
)
  q = Expr(:block, Expr(:meta, :inline))
  vargs = Vector{Symbol}(undef, K)
  for k ∈ 1:K
    vargs[k] = Symbol(:varg_, k)
  end
  lengths = Vector{Int}(undef, K)
  for k ∈ 1:K
    lengths[k] = l = vecunrolllen(vargtypes[k])
    if hasf
      gfvarg = Expr(:call, GlobalRef(Core, :getfield), :vargs, k, false)
      if l ≠ -1 # VecUnroll
        gfvarg = Expr(:call, GlobalRef(Core, :getfield), gfvarg, 1, false)
      end
      push!(q.args, Expr(:(=), vargs[k], gfvarg))
    elseif l ≠ -1
      varg = vargs[k]
      vargs[k] = dvarg = Symbol(:d, varg)
      push!(q.args, :($dvarg = data($varg)))
    end
  end
  N = last(lengths)
  start = (hasf | maskearly) ? 1 : M
  Sreduced = (S > 0) && (lengths[S] == -1)
  if Sreduced
    maxlen = maximum(lengths)
    if maxlen == -1
      Sreduced = false
      t = Expr(:tuple)
    else
      hasf || throw(
        ArgumentError(
          "Argument reduction only supported for `ifelse(last/partial)(f::Function, args...)`"
        )
      )
      M = maxlen
      t = q
    end
  else
    t = Expr(:tuple)
  end
  for m ∈ 1:start-1
    push!(t.args, :(getfield($(vargs[1]), $m, false)))
  end
  for m ∈ start:M
    call = if hasf
      (maskearly | (m == M)) ?
      Expr(:call, VectorizationBase.vifelse, :f, :m) : Expr(:call, :f)
    else# m == M because !hasf
      Expr(:call, :ifelse, :m)
    end
    for k ∈ 1:K
      if lengths[k] == -1
        push!(call.args, vargs[k])
      else
        # @assert (k == K) || (lengths[k] == M)
        push!(call.args, :(getfield($(vargs[k]), $m, false)))
      end
    end
    if Sreduced
      push!(t.args, Expr(:(=), vargs[S], call))
    elseif N == -1
      push!(q.args, call)
      return q
    else
      push!(t.args, call)
    end
  end
  Sreduced && return q
  for m ∈ M+1:N
    push!(t.args, :(getfield($(vargs[K]), $m, false)))
  end
  # push!(q.args, :(VecUnroll($t)::VecUnroll{$N,$W,$T,$V}))
  # push!(q.args, Expr(:call, lv(:VecUnroll), t))
  push!(q.args, :(VecUnroll($t)))
  q
end
@generated function ifelselast(
  f::F,
  m::AbstractMask{W},
  ::StaticInt{M},
  ::StaticInt{S},
  vargs::Vararg{Any,K}
) where {F,W,K,M,S}
  ifelselastexpr(true, M, vargs, K, S, false)
end
@generated function ifelselast(
  m::AbstractMask{W},
  ::StaticInt{M},
  ::StaticInt{S},
  varg_1::V1,
  varg_2::V2
) where {W,V1,V2,M,S}
  ifelselastexpr(false, M, (V1, V2), 2, S, false)
end
@generated function ifelsepartial(
  f::F,
  m::AbstractMask{W},
  ::StaticInt{M},
  ::StaticInt{S},
  vargs::Vararg{Any,K}
) where {F,W,K,M,S}
  ifelselastexpr(true, M, vargs, K, S, true)
end
@generated function ifelsepartial(
  m::AbstractMask{W},
  ::StaticInt{M},
  ::StaticInt{S},
  varg_1::V1,
  varg_2::V2
) where {W,V1,V2,M,S}
  ifelselastexpr(false, M, (V1, V2), 2, S, true)
end
# @inline ifelselast(f::F, m::AbstractMask{W}, ::StaticInt{M}, ::StaticInt{S}, vargs::Vararg{NativeTypes,K}) where {F,W,K,M,S} = f(vargs...)
# @inline ifelsepartial(f::F, m::AbstractMask{W}, ::StaticInt{M}, ::StaticInt{S}, vargs::Vararg{NativeTypes,K}) where {F,W,K,M,S} = f(vargs...)
@generated function subset_vec_unroll(
  vu::VecUnroll{N},
  ::StaticInt{S}
) where {N,S}
  (1 ≤ S ≤ N + 1) || throw(
    ArgumentError(
      "`vu` isa `VecUnroll` of `$(N+1)` elements, but trying to subset $S of them."
    )
  )
  t = Expr(:tuple)
  gf = GlobalRef(Core, :getfield)
  S == 1 &&
    return Expr(:block, Expr(:meta, :inline), :($gf($gf(vu, 1), 1, false)))
  for s ∈ 1:S
    push!(t.args, Expr(:call, gf, :vud, s, false))
  end
  quote
    $(Expr(:meta, :inline))
    vud = $gf(vu, 1)
    VecUnroll($t)
  end
end
# `S` is the ind to replace with the return value of previous invocation ("S" for "self") if reducing
@generated function partialmap(
  f::F,
  default::D,
  ::StaticInt{M},
  ::StaticInt{S},
  vargs::Vararg{Any,K}
) where {F,M,K,D,S}
  lengths = Vector{Int}(undef, K)
  q = Expr(:block, Expr(:meta, :inline))
  syms = Vector{Symbol}(undef, K)
  isnotpartial = true
  gf = GlobalRef(Core, :getfield)
  for k ∈ 1:K
    l = vecunrolllen(vargs[k])
    # if l
    kisnotpartial = ((l ≡ -1) & (k ≢ S)) | (l ≡ M)
    isnotpartial &= kisnotpartial
    lengths[k] = l
    @assert (l == -1) || (l ≥ M)
    syms[k] = symk = Symbol(:vargs_, k)
    extractq = :($gf(vargs, $k, false))
    if l != -1
      extractq = :(data($extractq))
    end
    push!(q.args, :($symk = $extractq))
  end
  Dlen = vecunrolllen(D)
  N = maximum(lengths)
  Sreduced = (S > 0) && (lengths[S] == -1) && N != -1
  if isnotpartial & (Sreduced | (Dlen == N))
    q = Expr(:call, :f)
    for k ∈ 1:K
      push!(q.args, :($gf(vargs, $k, false)))
    end
    if VERSION >= v"1.8"
      return Expr(:block, Expr(:meta, :inline), :(@inline $q))
    else
      return Expr(:block, Expr(:meta, :inline), q)
    end
  end
  if Sreduced
    M = N
    t = q
  else
    @assert (N ≤ Dlen)
    if Dlen == -1
      @assert (M == 1)
    else
      push!(q.args, :(dd = data(default)))
    end
    t = Expr(:tuple)
  end
  for m ∈ 1:M
    call = Expr(:call, :f)
    for k ∈ 1:K
      if lengths[k] == -1
        push!(call.args, syms[k])
      else
        push!(call.args, Expr(:call, gf, syms[k], m, false))
      end
    end
    if VERSION >= v"1.8"
      call = :(@inline $call)
    end
    # minimal change in behavior to fix case when !Sreduced by N -> Dlen; TODO: what should Dlen be here?
    if Sreduced ? (N == -1) : (Dlen == -1)
      push!(q.args, call)
      return q
    end
    if Sreduced
      push!(t.args, Expr(:(=), syms[S], call))
    else
      push!(t.args, call)
    end
  end
  Sreduced && return q
  for m ∈ M+1:max(N, Dlen)
    push!(t.args, :($gf(dd, $m, false)))
  end
  push!(q.args, :(VecUnroll($t)))
  q
end

function parent_op_name!(
  q,
  ls::LoopSet,
  parents_op::Vector{Operation},
  n::Int,
  modsuffix,
  suffix,
  parents_u₁syms,
  parents_u₂syms,
  u₁,
  u₂max,
  u₂unrolledsym,
  op,
  tiledouterreduction
)
  opp = parents_op[n]
  opisvectorized = isvectorized(op)
  parent = mangledvar(opp)
  u = 0
  if n == tiledouterreduction# && isvectorized(opp)
    parent = if u₂unrolledsym #!parents_u₁syms[n]
      Symbol(parent, modsuffix)
    else
      Symbol(parent, '_', modsuffix)
    end
  else
    isouterreduct = isouterreduction(ls, opp) ≠ -1
    u = if !parents_u₁syms[n]
      1
    elseif isouterreduct
      getu₁full(ls, u₁)
    else
      getu₁forreduct(ls, opp, u₁)
    end
    if parents_u₂syms[n]
      if isu₂unrolled(op) # u₂unrolledsym ||
        parent =
          isouterreduct ? Symbol(parent, suffix) :
          Symbol(parent, suffix, '_', '_', u)
      elseif u₂max > 1
        t = Expr(:tuple)
        reduction = Expr(
          :call,
          GlobalRef(ArrayInterface, :reduce_tup),
          reduce_to_onevecunroll(opp),
          t
        )
        for u₂ ∈ 0:u₂max-1
          push!(t.args, Symbol(parent, u₂, '_', '_', u))
        end
        parent = gensym!(ls, parent)
        push!(q.args, Expr(:(=), parent, reduction))
        parent
      else
        # parent = Symbol(parent, '_', u)
        parent = Symbol(parent, 0, "__", u)
      end
    else
      parent = Symbol(parent, '_', u)
    end
  end
  if opisvectorized && isload(opp) && (!isvectorized(opp))
    parent = Symbol(parent, "##broadcasted##")
  end
  parent, u
end
function getuouterreduct(ls::LoopSet, op::Operation, suffix)
  us = ls.unrollspecification
  if us.vloopnum === us.u₁loopnum # unroll u₂
    suffix
  else # unroll u₁
    us.u₁
  end
end

function getu₁full(ls::LoopSet, u₁::Int)
  Ureduct = ureduct(ls)
  ufull = ls.unrollspecification.u₁
  ufull = Core.ifelse(Ureduct == -1, ufull, min(ufull, Ureduct))
  # ufull = if Ureduct == -1 # no reducing
  #     ls.unrollspecification.u₁
  # else
  #     Ureduct
  # end
  # max is because we may be in the extended (non-reduct) region
  return max(u₁, ufull)
end
function getu₁forreduct(ls::LoopSet, op::Operation, u₁::Int)
  !isu₁unrolled(op) && return 1
  # if `op` is u₁unrolled, we must then find out if the initialization is `u₁unrolled`
  # if it is, then op's `u₁` will be the current `u₁`
  # if it is not, then the opp is initialized once per full u₁
  while true
    selfparentid = findfirst(Base.Fix2(===, name(op)) ∘ name, parents(op))
    selfparentid === nothing && return u₁
    op = parents(op)[selfparentid]
    isreduction(op) || break
  end
  if isu₁unrolled(op)
    return u₁
  elseif (ls.unrollspecification.u₂ != -1) && length(ls.outer_reductions) > 0
    # then `ureduct` doesn't tell us what we need, so
    return ls.unrollspecification.u₁
  else # we need to find u₁-full
    return getu₁full(ls, u₁)
  end
end
isidentityop(op::Operation) =
  iscompute(op) &&
  (instruction(op).instr === :identity) &&
  (length(parents(op)) == 1)
function reduce_parent!(
  q::Expr,
  ls::LoopSet,
  op::Operation,
  opp::Operation,
  parent::Symbol
)
  isvectorized(op) && return parent
  if isvectorized(opp)
    oppt = opp
  elseif isidentityop(opp)
    oppt = parents(opp)[1]
    isvectorized(oppt) || return parent
  else
    return parent
  end
  reduct_class = reduction_instruction_class(oppt.instruction)
  if (instruction(op).instr === :mul_fast) &
     (reduct_class == ADDITIVE_IN_REDUCTIONS)
    op.vectorized = true
    return parent
  end
  newp = gensym(parent)
  if instruction(op).instr ≢ :ifelse
    push!(
      q.args,
      Expr(
        :(=),
        newp,
        Expr(:call, lv(reduction_to_scalar(reduct_class)), parent)
      )
    )#IfElseReducer
  else
    reductexpr = ifelse_reduction(:IfElseReducer, op) do opv
      throw(LoopError("Does not support storing mirrored ifelse-reductions yet"))
    end
    push!(q.args, Expr(:(=), newp, Expr(:call, reductexpr, parent)))
  end
  newp
end
if VERSION >= v"1.8"
  function inlinecall(x)
    Meta.isexpr(x, :call) || return x
    :(@inline $x)
  end
else
  const inlinecall = identity
end
function lower_compute!(
  q::Expr,
  op::Operation,
  ls::LoopSet,
  ua::UnrollArgs,
  mask::Bool
)
  @unpack u₁, u₁loopsym, u₂loopsym, vloopsym, u₂max, suffix = ua
  var = name(op)
  instr = instruction(op)
  parents_op = parents(op)
  nparents = length(parents_op)
  # __u₂max = ls.unrollspecification.u₂
  # TODO: perhaps allow for switching unrolled axis again
  mvar, u₁unrolledsym, u₂unrolledsym =
    variable_name_and_unrolled(op, u₁loopsym, u₂loopsym, vloopsym, suffix, ls)
  opunrolled = u₁unrolledsym || isu₁unrolled(op)
  us = ls.unrollspecification
  parents_u₁syms, parents_u₂syms =
    parent_unroll_status(op, u₁loopsym, u₂loopsym, vloopsym, u₂max, us)
  # tiledouterreduction = if num_loops(ls) == 1# (suffix == -1)# || (vloopsym === u₂loopsym)
  tiledouterreduction = if (suffix == -1)# || (vloopsym === u₂loopsym)
    suffix_ = Symbol("")
    -1
  else
    suffix_ = Symbol(suffix, :_)
    isouterreduction(ls, op)
  end
  if !opunrolled && any(parents_u₁syms) # TODO: Clean up this mess, refactor the naming code, putting it in one place and have everywhere else use it for easy equivalence.
    parents_op = copy(parents_op) # don't mutate the original!
    for i ∈ eachindex(parents_u₁syms)
      parents_u₁syms[i] || continue
      parents_u₁syms[i] = false
      parentop = parents_op[i]
      i == tiledouterreduction && isconstant(parentop) && continue
      newparentop = Operation(
        parentop.identifier,
        gensym(parentop.variable),
        parentop.elementbytes,
        parentop.instruction,
        parentop.node_type,
        parentop.dependencies,
        parentop.reduced_deps,
        parentop.parents,
        parentop.ref,
        parentop.reduced_children
      )
      newparentop.vectorized = false
      newparentop.u₁unrolled = false
      newparentop.u₂unrolled = parents_u₂syms[i]
      parentname = mangledvar(parentop)
      newparentname = mangledvar(newparentop)
      parents_op[i] = newparentop
      if parents_u₂syms[i]
        parentname = Symbol(parentname, suffix_)
        newparentname = Symbol(newparentname, suffix_)
      end
      if isconstant(newparentop)
        push!(
          q.args,
          Expr(:(=), Symbol(newparentname, '_', 1), Symbol(parentname, '_', 1))
        )
      else
        newpname = Symbol(newparentname, '_', u₁)
        push!(q.args, Expr(:(=), newpname, Symbol(parentname, '_', u₁)))
        reduce_expr!(q, newparentname, newparentop, u₁, -1, true, false)
        push!(
          q.args,
          Expr(
            :(=),
            Symbol(newparentname, '_', 1),
            Symbol(newparentname, "##onevec##")
          )
        )
      end
    end
  end
  # if suffix === nothing# &&
  # end
  # cache unroll and tiling check of parents
  # not broadcasted, because we use frequent checks of individual bools
  # making BitArrays inefficient.
  # parentsyms = [opp.variable for opp ∈ parents(op)]
  Uiter = opunrolled ? u₁ - 1 : 0
  isreduct = isreduction(op)
  if Base.libllvm_version < v"11.0.0" && (suffix ≠ -1) && isreduct# && (iszero(suffix) || (ls.unrollspecification.u₂ - 1 == suffix))
    # if (length(reduceddependencies(op)) > 0) | (length(reducedchildren(op)) > 0)# && (iszero(suffix) || (ls.unrollspecification.u₂ - 1 == suffix))
    # instrfid = findfirst(isequal(instr.instr), (:vfmadd, :vfnmadd, :vfmsub, :vfnmsub))
    instrfid = findfirst(
      Base.Fix2(===, instr.instr),
      (:vfmadd_fast, :vfnmadd_fast, :vfmsub_fast, :vfnmsub_fast)
    )
    # instrfid = findfirst(isequal(instr.instr), (:vfnmadd_fast, :vfmsub_fast, :vfnmsub_fast))
    # want to instcombine when parent load's deps are superset
    # also make sure opp is unrolled
    if !(instrfid === nothing) && (opunrolled && u₁ > 1) && sub_fmas(ls, op, ua)
      specific_fmas =
        Base.libllvm_version >= v"11.0.0" ?
        (:vfmadd, :vfnmadd, :vfmsub, :vfnmsub) :
        (:vfmadd231, :vfnmadd231, :vfmsub231, :vfnmsub231)
      # specific_fmas = Base.libllvm_version >= v"11.0.0" ? (:vfnmadd, :vfmsub, :vfnmsub) : (:vfnmadd231, :vfmsub231, :vfnmsub231)
      # specific_fmas = (:vfmadd231, :vfnmadd231, :vfmsub231, :vfnmsub231)
      instr = Instruction(specific_fmas[instrfid])
    end
  end
  reduceddeps = reduceddependencies(op)
  vecinreduceddeps = isreduct && vloopsym ∈ reduceddeps
  maskreduct = mask & vecinreduceddeps #any(opp -> opp.variable === var, parents_op)
  # if vecinreduceddeps && vectorized ∉ loopdependencies(op) # screen parent opps for those needing a reduction to scalar
  #     # parents_op = reduce_vectorized_parents!(q, op, parents_op, U, u₁loopsym, u₂loopsym, vectorized, suffix)
  #     isreducingidentity!(q, op, parents_op, U, u₁loopsym, u₂loopsym, vectorized, suffix) && return
  # end    
  # if a parent is not unrolled, the compiler should handle broadcasting CSE.
  # because unrolled/tiled parents result in an unrolled/tiled dependendency,
  # we handle both the tiled and untiled case here.
  # bajillion branches that go the same way on each iteration
  # but smaller function is probably worthwhile. Compiler could theoreically split anyway
  # but I suspect that the branches are so cheap compared to the cost of everything else going on
  # that smaller size is more advantageous.
  opisvectorized = isvectorized(op)
  modsuffix = 0
  # for u ∈ 0:Uiter
  isouterreduct = false
  instrcall = callexpr(instr)
  dopartialmap = false
  varsym = if tiledouterreduction > 0 # then suffix ≠ -1
    # modsuffix = ((u + suffix*(Uiter + 1)) & 7)
    isouterreduct = true
    # if u₁unrolledsym
    #     modsuffix = ls.unrollspecification.u₁#getu₁full(ls, u₁)#u₁
    #     Symbol(mangledvar(op), '_', modsuffix)
    # else
    if u₁unrolledsym
      # modsuffix = 0
      modsuffix = ls.unrollspecification.u₁
      Symbol(mangledvar(op), '_', modsuffix)
    else
      modsuffix = suffix % ls.ureduct
      Symbol(mangledvar(op), modsuffix)
    end
  elseif u₁unrolledsym
    if isreduct #(isanouterreduction(ls, op))
      # isouterreduct = true
      isouterreduct = isanouterreduction(ls, op)
      u₁reduct =
        isouterreduct ? getu₁full(ls, u₁) : getu₁forreduct(ls, op, u₁)
      dopartialmap = u₁reduct ≠ u₁
      Symbol(mvar, '_', u₁reduct)
    else
      Symbol(mvar, '_', u₁)
    end
  else
    Symbol(mvar, '_', 1)
  end
  selfopname = varsym
  selfdep = 0
  for n ∈ 1:nparents
    opp = parents_op[n]
    if isloopvalue(opp)
      loopval = first(loopdependencies(opp))
      add_loopvalue!(instrcall, loopval, ua, u₁, getloop(ls, loopval))
    elseif name(opp) === name(op)
      selfdep = n
      if ((isvectorized(opp) && !isvectorized(op))) ||
         (parents_u₁syms[n] != u₁unrolledsym) ||
         (parents_u₂syms[n] != u₂unrolledsym)
        selfopname, uₚ = parent_op_name!(
          q,
          ls,
          parents_op,
          n,
          modsuffix,
          suffix,
          parents_u₁syms,
          parents_u₂syms,
          u₁,
          u₂max,
          u₂unrolledsym,
          op,
          tiledouterreduction
        )
        push!(instrcall.args, selfopname)
      else
        push!(instrcall.args, varsym)
      end
    elseif ((!isu₂unrolled(op)) & isu₂unrolled(opp)) &&
           (parents_u₂syms[n] & (!u₂unrolledsym))
      # elseif parents_u₂syms[n] & (!u₂unrolledsym)
      #&& (isouterreduction(ls, opp) != -1)
      # this checks if the parent is u₂ unrolled but this operation is not, in which case we need to reduce it.
      reduced_u₂ = reduce_expr_u₂(mangledvar(opp), opp, u₂max, Symbol("__", u₁))#ureduct(ls))
      reducedparentname = gensym!(ls, "reducedop")
      push!(q.args, Expr(:(=), reducedparentname, reduced_u₂))
      reduced_u₂ = reduce_parent!(q, ls, op, opp, reducedparentname)
      push!(instrcall.args, reduced_u₂)
    elseif isconstant(opp) && instruction(opp).mod === GLOBALCONSTANT
      push!(instrcall.args, GlobalRef(Base, instruction(opp).instr))
    else
      # 0 for tiledouterreduction, because `name(opp) ≢ name(op)`
      parent, uₚ = parent_op_name!(
        q,
        ls,
        parents_op,
        n,
        modsuffix,
        suffix,
        parents_u₁syms,
        parents_u₂syms,
        u₁,
        u₂max,
        u₂unrolledsym,
        op,
        0
      )
      parent = reduce_parent!(q, ls, op, opp, parent)
      if (selfdep == 0) && search_tree(parents(opp), name(op))
        selfdep = n
        push!(instrcall.args, parent)
      elseif (uₚ ≠ 0) & (uₚ > u₁)
        push!(instrcall.args, :(subset_vec_unroll($parent, StaticInt{$u₁}())))
      else
        push!(instrcall.args, parent)
      end
    end
  end
  selfdepreduce =
    ifelse(((!u₁unrolledsym) & isu₁unrolled(op)) & (u₁ > 1), selfdep, 0)
  if maskreduct
    ifelsefunc = if us.u₁ == 1
      :ifelse # don't need to be fancy
    elseif (u₁loopsym !== vloopsym)
      :ifelsepartial # ifelse all the early ones
    else# mask last u₁
      :ifelselast # ifelse only the last one
    end
    if last(instrcall.args) === varsym
      pushfirst!(instrcall.args, lv(ifelsefunc))
      # showexpr = true
      insert!(instrcall.args, 3, MASKSYMBOL)
      if !(ifelsefunc === :ifelse)
        insert!(instrcall.args, 4, staticexpr(u₁))
        insert!(instrcall.args, 5, staticexpr(selfdepreduce))
      end
    elseif all(in(loopdependencies(op)), reduceddeps) || selfdep ≠ 0#any(opp -> mangledvar(opp) === mangledvar(op), parents_op)
      # Here, we are evaluating the function, and then `ifelse`-ing it with `hasf == false`.
      # That means we still need to adjust the `instrcall` in case we're reducing/accumulating across the unroll
      if ifelsefunc ≡ :ifelse # ifelse means it's unrolled by 1, no need
        # push!(q.args, Expr(:(=), varsym, Expr(:call, lv(ifelsefunc), MASKSYMBOL, instrcall, selfopname)))
        push!(
          q.args,
          Expr(
            :(=),
            varsym,
            Expr(
              :call,
              lv(ifelsefunc),
              MASKSYMBOL,
              inlinecall(instrcall),
              selfopname
            )
          )
        )
      elseif ((u₁ ≡ 1) | (selfdepreduce ≡ 0))
        # if the current unroll is 1, no need to accumulate. Same if there is no selfdepreduce, but there has to be if we're here?
        # push!(q.args, Expr(:(=), varsym, Expr(:call, lv(ifelsefunc), MASKSYMBOL, staticexpr(u₁), staticexpr(selfdepreduce), instrcall, selfopname)))
        push!(
          q.args,
          Expr(
            :(=),
            varsym,
            Expr(
              :call,
              lv(ifelsefunc),
              MASKSYMBOL,
              staticexpr(u₁),
              staticexpr(selfdepreduce),
              inlinecall(instrcall),
              selfopname
            )
          )
        )
      else
        make_partial_map!(instrcall, selfopname, u₁, selfdepreduce)
        # partialmap accumulates
        push!(
          q.args,
          Expr(
            :(=),
            varsym,
            Expr(
              :call,
              lv(:ifelse),
              MASKSYMBOL,
              inlinecall(instrcall),
              selfopname
            )
          )
        )
      end
      return
      # elseif selfdep != 0
      #   make_partial_map!(instrcall, selfopname, u₁, selfdepreduce)
    end
  elseif selfdep != 0 && (
    dopartialmap ||
    (isouterreduct && (opunrolled) && (u₁ < us.u₁)) ||
    (isreduct & (u₁ > 1) & (!u₁unrolledsym) & isu₁unrolled(op))
  ) # TODO: DRY `selfdepreduce` definition
    # first possibility (`isouterreduct && opunrolled && (u₁ < ls.unrollspecification.u₁)`):
    # checks if we're in the "reduct" part of an outer reduction
    #
    # second possibility (`(isreduct & (u₁ > 1) & (!u₁unrolledsym) & isu₁unrolled(op))`):
    # if the operation is repeated across u₁ (indicated by `isu₁unrolled(op)`) but
    # the variables are not correspondingly replicated across u₁ (indicated by `!u₁unrolledsym`)
    # then we need to accumulate it.
    make_partial_map!(instrcall, selfopname, u₁, selfdepreduce)
    # elseif 
  end
  if instr.instr === :identity && isone(length(parents_op))
    if instrcall.args[2] !== varsym
      push!(q.args, Expr(:(=), varsym, instrcall.args[2]))
    end
  elseif identifier(op) ∉ ls.outer_reductions && should_broadcast_op(op)
    push!(
      q.args,
      Expr(
        :(=),
        varsym,
        Expr(:call, lv(:vbroadcast), VECTORWIDTHSYMBOL, inlinecall(instrcall))
      )
    )
  else
    push!(q.args, Expr(:(=), varsym, inlinecall(instrcall)))
  end
  # end
end
function make_partial_map!(instrcall, selfopname, u₁, selfdep)
  pushfirst!(instrcall.args, lv(:partialmap))
  insert!(instrcall.args, 3, selfopname)
  insert!(instrcall.args, 4, staticexpr(u₁))
  insert!(instrcall.args, 5, staticexpr(selfdep))
  nothing
end

# file for misc loopset transforms

function hoist_constant_memory_accesses!(ls::LoopSet)
  hoist_stores = false
  for op ∈ operations(ls)
    if isload(op)
      length(getindicesonly(op)) == 0 && hoist_constant_vload!(ls, op)
    elseif isstore(op) && iszero(length(getindicesonly(op)))
      hoist_stores = true
    end
  end
  hoist_stores && return hoist_constant_memory_accesses_nocheck!(ls)
  ls.preamble
end

function hoist_constant_memory_accesses_nocheck!(ls::LoopSet)
  post = Expr(:block)
  for op ∈ operations(ls)
    if isstore(op) && length(getindicesonly(op)) == 0
      hoist_constant_store!(post, ls, op)
    end
  end
  post
end
function hoist_constant_vload!(ls::LoopSet, op::Operation)
  op.instr = LOOPCONSTANT
  op.node_type = constant
  add_constant_vload!(
    ls,
    op,
    ArrayReferenceMetaPosition(
      op.ref,
      parents(op),
      loopdependencies(op),
      reduceddependencies(op),
      name(op)
    ),
    elementbytes
  )
end

function return_empty_reductinit(op::Operation, var::Symbol)
  for opp ∈ parents(op)
    if (name(opp) === var) &&
       (length(reduceddependencies(opp)) == 0) &&
       (length(loopdependencies(opp)) == 0) &&
       (length(children(opp)) == 1)
      return opp
    end
    opcheck = return_empty_reductinit(opp, var)
    opcheck === opp || return opcheck
  end
  return op
end

function constant_symbol!(ls::LoopSet, op::Operation)
  # hack
  # relowers, but should make it work
  # TODO: DRY with `lower_licm_constants!` from `src/codegen/lower_constants.jl`
  skip_constant(instruction(op)) || return instruction(op).instr
  idcheck = identifier(op)
  symname = constantopname(op)
  for (id, sym) ∈ ls.preamble_symsym
    (idcheck ≢ nothing) && ((idcheck == id) && continue)
    pushpreamble!(ls, Expr(:(=), symname, sym))
    return symname
    # setconstantop!(ls, op,  sym)
    # setconstantop!(ls, op, Expr(:call, lv(:maybeconvert), ls.T, sym))
  end
  for (id, (intval, intsz, signed)) ∈ ls.preamble_symint
    (idcheck ≢ nothing) && ((idcheck == id) && continue)
    if intsz == 1
      pushpreamble!(ls, Expr(:(=), symname, intval % Bool))
    else
      pushpreamble!(
        ls,
        Expr(:(=), symname, sizeequivalent_symint_expr(intval, signed))
      )
    end
    return symname
  end
  for (id, floatval) ∈ ls.preamble_symfloat
    (idcheck ≢ nothing) && ((idcheck == id) && continue)
    pushpreamble!(
      ls,
      Expr(
        :(=),
        symname,
        Expr(:call, lv(:sizeequivalentfloat), ELTYPESYMBOL, floatval)
      )
    )
    return symname
  end
  for (id, typ) ∈ ls.preamble_zeros
    (idcheck ≢ nothing) && ((idcheck == id) && continue)
    instruction(op) === LOOPCONSTANT || continue
    if typ == IntOrFloat
      pushpreamble!(ls, Expr(:(=), symname, Expr(:call, :zero, ELTYPESYMBOL)))
    elseif typ == HardInt
      pushpreamble!(
        ls,
        Expr(:(=), symname, Expr(:call, lv(:zerointeger), ELTYPESYMBOL))
      )
    else#if typ == HardFloat
      pushpreamble!(
        ls,
        Expr(:(=), symname, Expr(:call, lv(:zerofloat), ELTYPESYMBOL))
      )
    end
    return symname
  end
  for (id, f) ∈ ls.preamble_funcofeltypes
    (idcheck ≢ nothing) && ((idcheck == id) && continue)
    pushpreamble!(
      ls,
      Expr(:(=), symname, Expr(:call, reduction_zero(f), ELTYPESYMBOL))
    )
    return symname
  end
  throw("Constant operation symbol not found.")
end

function hoist_constant_store!(q::Expr, ls::LoopSet, op::Operation)
  op.instruction = DROPPEDCONSTANT
  op.node_type = constant

  opr = only(parents(op))
  while opr.instruction.instr === :identity
    opr.instruction = DROPPEDCONSTANT
    opr.node_type = constant
    opr = only(parents(opr))
  end
  push!(ls.outer_reductions, identifier(opr))

  initop = return_empty_reductinit(opr, name(opr))
  # @show last(ls.preamble.args)
  init = constant_symbol!(ls, initop)
  # @show last(ls.preamble.args)
  pushpreamble!(
    ls,
    Expr(:(=), outer_reduct_init_typename(opr), Expr(:call, lv(:typeof), init))
  )
  qpre = Expr(:block)
  push!(
    q.args,
    Expr(
      :call,
      lv(:unsafe_store!),
      Expr(:call, lv(:pointer), op.ref.ptr),
      outer_reduction_to_scalar_reduceq!(qpre, opr, init)
    )
  )
  length(qpre.args) == 0 || pushpreamble!(ls, qpre) # creating `Expr` and pushing because `outer_reduction_to_scalar_reduceq!` uses `pushfirst!(q.args`, and we don't want it at the start of the preamble
  return nothing
end

using OffsetArrays, LinearAlgebra, LoopVectorization, Test

let nt = min(Threads.nthreads(), (Sys.CPU_THREADS)::Int)
  if (LoopVectorization.num_cores() < 4) && (nt ≥ 4)
    @eval LoopVectorization.num_cores() = LoopVectorization.StaticInt{$nt}()
  end
end

function mydotavx(a, b)
  s = zero(eltype(a))
  @tturbo for i ∈ eachindex(a, b)
    s += a[i] * b[i]
  end
  s
end
function AmulB!(C, A, B)
  @tturbo for n in indices((B, C), 2), m in indices((A, C), 1)
    Cmn = zero(eltype(C))
    for k in indices((A, B), (2, 1))
      Cmn += A[m, k] * B[k, n]
    end
    C[m, n] = Cmn
  end
  C
end
function dot3(
  x::AbstractVector{Complex{T}},
  A::AbstractMatrix{Complex{T}},
  y::AbstractVector{Complex{T}},
) where {T}
  xr = reinterpret(reshape, T, x)
  yr = reinterpret(reshape, T, y)
  Ar = reinterpret(reshape, T, A)
  sre = zero(T)
  sim = zero(T)
  @tturbo for n in axes(Ar, 3)
    tre = zero(T)
    tim = zero(T)
    for m in axes(Ar, 2)
      tre += xr[1, m] * Ar[1, m, n] + xr[2, m] * Ar[2, m, n]
      tim += xr[1, m] * Ar[2, m, n] - xr[2, m] * Ar[1, m, n]
    end
    sre += tre * yr[1, n] - tim * yr[2, n]
    sim += tre * yr[2, n] + tim * yr[1, n]
  end
  sre + im * sim
end
function conv!(out, A, kern)
  @tturbo for n ∈ axes(out, 2), m ∈ axes(out, 1)
    tmp = zero(eltype(out))
    for nᵢ ∈ -1:1, mᵢ ∈ -1:1
      tmp += A[mᵢ+m, nᵢ+n] * kern[mᵢ, nᵢ]
    end
    out[m, n] = tmp
  end
  out
end
function conv_baseline!(out, A, kern)
  for n ∈ axes(out, 2), m ∈ axes(out, 1)
    tmp = zero(eltype(out))
    for nᵢ ∈ -1:1, mᵢ ∈ -1:1
      tmp += A[mᵢ+m, nᵢ+n] * kern[mᵢ, nᵢ]
    end
    out[m, n] = tmp
  end
  out
end


struct DenseConvDims{N,K,C_in,C_out} end

function kernaxes(::DenseConvDims{2,K,C_in,C_out}) where {K,C_in,C_out}
  K₁ = LoopVectorization.StaticInt(1):LoopVectorization.StaticInt(K[1])
  K₂ = LoopVectorization.StaticInt(1):LoopVectorization.StaticInt(K[2])
  Cᵢₙ = LoopVectorization.StaticInt(1):LoopVectorization.StaticInt(C_in)
  Cₒᵤₜ = LoopVectorization.StaticInt(1):LoopVectorization.StaticInt(C_out)
  (K₁, K₂, Cᵢₙ, Cₒᵤₜ)
end

function convlayer!(
  out::AbstractArray{<:Any,4},
  img,
  kern,
  dcd::DenseConvDims{2,<:Any,<:Any,<:Any},
)
  (K₁, K₂, Cᵢₙ, Cₒᵤₜ) = kernaxes(dcd)
  @tturbo for j₁ ∈ axes(out, 1), j₂ ∈ axes(out, 2), d ∈ axes(out, 4), o ∈ Cₒᵤₜ
    s = zero(eltype(out))
    for k₁ ∈ K₁, k₂ ∈ K₂, i ∈ Cᵢₙ
      s += img[j₁+k₁-1, j₂+k₂-1, i, d] * kern[k₁, k₂, i, o]
    end
    out[j₁, j₂, o, d] = s
  end
  out
end
function convlayer_direct!(
  out::AbstractArray{<:Any,4},
  img,
  kern,
  dcd::DenseConvDims{2,<:Any,<:Any,<:Any},
)
  (K₁, K₂, Cᵢₙ, Cₒᵤₜ) = kernaxes(dcd)
  @inbounds @fastmath for j₁ ∈ axes(out, 1), j₂ ∈ axes(out, 2), d ∈ axes(out, 4), o ∈ Cₒᵤₜ
    s = zero(eltype(out))
    for k₁ ∈ K₁, k₂ ∈ K₂, i ∈ Cᵢₙ
      s += img[j₁+k₁-1, j₂+k₂-1, i, d] * kern[k₁, k₂, i, o]
    end
    out[j₁, j₂, o, d] = s
  end
  out
end

function thread_cartesian_indices!(dst, src)
  @turbo thread = true for i in eachindex(dst, src)
    dst[i] = src[i]
  end
end



@testset "Threading" begin
  @show @__LINE__
  dcd = DenseConvDims{2,(5, 5),3,6}()
  kern4 = rand(Float32, 5, 5, 3, 6)
  @time for M ∈ 17:50:267
    img = rand(Float32, M, M, 3, 100)
    outimage1 = Array{Float32}(
      undef,
      size(img, 1) + 1 - size(kern4, 1),
      size(img, 2) + 1 - size(kern4, 2),
      size(kern4, 4),
      size(img, 4),
    )
    outimage2 = similar(outimage1)

    convlayer!(outimage1, img, kern4, dcd)
    convlayer_direct!(outimage2, img, kern4, dcd)
    @test outimage1 ≈ outimage2
  end

  @time for M ∈ 17:399
    # @show M
    K = M
    N = M
    A = rand(M, K)
    B = rand(K, N)
    b = rand(K)
    @test dot(A, B) ≈ mydotavx(A, B)

    C1 = A * B
    @test AmulB!(similar(C1), A, B) ≈ C1
    c1 = A * b
    @test AmulB!(similar(c1), A, b) ≈ c1

    if VERSION ≥ v"1.6"
      x = randn(Complex{Float64}, 3M - 1)
      W = randn(Complex{Float64}, 3M - 1, 3M + 1)
      y = randn(Complex{Float64}, 3M + 1)
      @test dot(x, W, y) ≈ dot3(x, W, y)
    end

    kern = OffsetArray(randn(3, 3), -2, -2)
    out1 = OffsetArray(randn(size(A) .- 2), 1, 1)
    out2 = similar(out1)
    @test conv!(out1, A, kern) ≈ conv_baseline!(out2, A, kern)
  end

  src_big = rand(4, 10)
  dst_big = similar(src_big)
  src = view(src_big, 2:3, :)
  dst = view(dst_big, 2:3, :)
  thread_cartesian_indices!(dst, src)
  dst ≈ src

  let a = zeros(3, 2), N = 2
    @turbo thread = true for i = 1:1, j = 1:N
      a[i, j] += 1.0
    end
    @test all(isone, @view(a[1, :]))
    @test all(iszero, @view(a[2:end, :]))
  end


end

module SpecialFunctionsExt
using SpecialFunctions
using LoopVectorization: VectorizationBase
using LoopVectorization: AbstractSIMD
@inline SpecialFunctions.erf(x::AbstractSIMD) = VectorizationBase.verf(float(x))
end

_vcount(f) = 0
function _vcount(f::F, args::Vararg{StridedArray,M}) where {F,M}
  x = first(args)
  y = Base.tail(args)
  foreach(a -> @assert(size(a) == size(x)), y)
  N = length(x)
  ptrargs = map(VectorizationBase.zstridedpointer, args)
  i = 0
  V = VectorizationBase.pick_vector_width(
    reduce(promote_type, map(eltype, ptrargs))
  )
  W = unwrap(V)
  UNROLL = 4
  LOG2UNROLL = 2
  _counts = if VERSION >= v"1.7"
    VecUnroll(ntuple(Returns(0), Val(UNROLL)))
  else
    VecUnroll(ntuple(_ -> (0), Val(UNROLL)))
  end
  counts::typeof(_counts) = _counts
  while i < vsub_nsw(N, ((W << LOG2UNROLL) - 1))
    index = VectorizationBase.Unroll{1,W,UNROLL,1,W,zero(UInt)}((i,))
    counts += count_ones(f(VectorizationBase.fmap(vload, ptrargs, index)...))
    i = vadd_nw(i, StaticInt{UNROLL}() * W)
  end
  count = reduce_tup(+, data(counts))
  while i < vsub_nsw(N, (W - 1)) # stops at 16 when
    count += count_ones(f(map1(vload, ptrargs, (MM{W}(i),))...))
    i = vadd_nw(i, W)
  end
  if i < N
    m = mask(StaticInt(W), N & (W - 1))
    vfinal = f(map1(vload, ptrargs, (MM{W}(i),), m)...)
    count += count_ones(vfinal & m)
  end
  count
end

@generated function vcount(f::F, args::Vararg{StridedArray,M}) where {F,M}
  call = Expr(:call, :_vcount, :f)
  gc_preserve_call_quote(call, M::Int)
end
vcount(::typeof(identity), x::StridedArray{Bool}) =
  vcount(VectorizationBase.tomask, x)
vcount(x::StridedArray{Bool}) = vcount(VectorizationBase.tomask, x)

struct TURBO{UNROLL,OPS,ARF,AM,LPSYM,LBV,FLBV} <: Function end

# This should call the same `_turbo_!(Val{UNROLL}(), Val{OPS}(), Val{ARF}(), Val{AM}(), Val{LPSYM}(), _vargs)` as normal so that this
# hopefully shouldn't add much to compile time.

function (::TURBO{UNROLL,OPS,ARF,AM,LPSYM,LBV,FLBV})(
  p::Ptr{UInt}
) where {UNROLL,OPS,ARF,AM,LPSYM,K,LBV,FLBV<:Tuple{Vararg{Any,K}}}
  (_, _vargs) = ThreadingUtilities.load(p, FLBV, 2 * sizeof(UInt))
  # Main.VARGS[Threads.threadid()] = first(_vargs)
  # Threads.threadid() == 2 && Core.println(typeof(_vargs))
  ret = _turbo_!(
    Val{UNROLL}(),
    Val{OPS}(),
    Val{ARF}(),
    Val{AM}(),
    Val{LPSYM}(),
    Val{LBV}(),
    _vargs...
  )
  ThreadingUtilities.store!(p, ret, Int(register_size()))
  ThreadingUtilities._atomic_store!(p, ThreadingUtilities.SPIN)
  nothing
end
@generated function Base.pointer(
  ::TURBO{UNROLL,OPS,ARF,AM,LPSYM,LBV,FLBV}
) where {UNROLL,OPS,ARF,AM,LPSYM,K,LBV,FLBV<:Tuple{Vararg{Any,K}}}
  f = TURBO{UNROLL,OPS,ARF,AM,LPSYM,LBV,FLBV}()
  precompile(f, (Ptr{UInt},))
  quote
    $(Expr(:meta, :inline))
    @cfunction($f, Cvoid, (Ptr{UInt},))
  end
end

@inline function setup_turbo_threads!(
  p::Ptr{UInt},
  fptr::Ptr{Cvoid},
  args::LBV
) where {K,LBV<:Tuple{Vararg{Any,K}}}
  offset = ThreadingUtilities.store!(p, fptr, sizeof(UInt))
  offset = ThreadingUtilities.store!(p, args, offset)
  nothing
end

struct StaticType{T} end
@inline gettype(::StaticType{T}) where {T} = T

@inline function avx_launch(
  ::Val{UNROLL},
  ::Val{OPS},
  ::Val{ARF},
  ::Val{AM},
  ::Val{LPSYM},
  ::StaticType{LBV},
  fargs::FARGS,
  tid
) where {UNROLL,OPS,ARF,AM,LPSYM,K,LBV<:Tuple{Vararg{Any,K}},FARGS}
  ThreadingUtilities.launch(
    setup_turbo_threads!,
    tid,
    pointer(TURBO{UNROLL,OPS,ARF,AM,LPSYM,LBV,FARGS}()),
    fargs
  )
end

@generated function calc_factors(::StaticInt{nc}) where {nc}
  t = Expr(:tuple)
  for i ∈ nc:-1:1
    d, r = divrem(nc, i)
    iszero(r) && push!(t.args, (i % UInt, d % UInt))
  end
  t
end
@inline cld_fast(x, y) = Base.udiv_int(vsub_nw(vadd_nw(x, y), one(y)), y)
@inline function choose_num_blocks(
  MoW::UInt,
  ::StaticInt{U},
  ::StaticInt{T}
) where {U,T}
  factors = calc_factors(StaticInt{T}())
  for i ∈ 1:length(factors)-1
    # miter decreases in each iteration of factors
    miter, niter = factors[i]

    r = MoW % miter
    # if ((miter * W * U * 2) ≤ M - (W+W)) & ((r == 0) | (miter == (r+1)))
    mlarge = (miter * (U * 2)) ≤ MoW - 2
    # we want `mlarge` enough, or there to be no remainder (`r == 0`)
    # or the remainder to be small relative to `M`, e.g. `M ÷ 128`.
    if mlarge && ((r == 0) || ((miter - r) ≤ (cld_fast(MoW, miter) >>> 3)))
      return miter, niter
    end
  end
  last(factors)
end
@inline function choose_num_blocks(::StaticInt{T}) where {T}
  factors = calc_factors(StaticInt{T}())
  @inbounds factors[(length(factors)+1)>>>1]
end

@generated function choose_num_block_table(::StaticInt{NC}) where {NC}
  t = Expr(:tuple)
  for n ∈ 1:NC
    push!(t.args, :(choose_num_blocks(StaticInt{$n}())))
  end
  t
end

@generated function _choose_num_blocks(
  M::UInt,
  ::StaticInt{U},
  nt,
  ::StaticInt{NTMAX}
) where {U,NTMAX}
  if NTMAX == 2 # `nt` must be `2`
    return quote
      $(Expr(:meta, :inline))
      choose_num_blocks(M, StaticInt{$U}(), StaticInt{$NTMAX}())
    end
  end
  q = Expr(:block)#, Expr(:meta,:inline))
  ifq = Expr(
    :if,
    :(nt == $NTMAX),
    :(choose_num_blocks(M, StaticInt{$U}(), StaticInt{$NTMAX}()))
  )
  add_bisecting_if_branches!(ifq, 2, NTMAX - 1, U, false)
  push!(q.args, ifq)
  q
end
function add_bisecting_if_branches!(q, lb, ub, U, isfirst::Bool)
  if lb == ub
    push!(q.args, :(choose_num_blocks(M, StaticInt{$U}(), StaticInt{$lb}())))
    return
  end
  midpoint = (lb + ub) >> 1
  alt = Expr(isfirst ? :if : :elseif, :(nt > $midpoint))
  add_bisecting_if_branches!(alt, midpoint + 1, ub, U, true)
  add_bisecting_if_branches!(alt, lb, midpoint, U, false)
  push!(q.args, alt)
  return
end

# if a threaded loop is vectorized, call
@inline function choose_num_blocks(M, ::StaticInt{U}, nt) where {U}
  _choose_num_blocks(M % UInt, StaticInt{U}(), nt, num_cores())
end
# otherwise, call
@inline choose_num_blocks(nt, ::StaticInt{NC} = num_cores()) where {NC} =
  @inbounds choose_num_block_table(StaticInt{NC}())[nt]

scale_cost(c) = @fastmath c * (Sys.ARCH === :x86_64 ? 0.0225 : 0.005625)
scale_cost(c, looplen) = scale_cost(@fastmath c / looplen)
@inline function choose_num_threads(
  C::T,
  NT::UInt,
  x::Base.BitInteger
) where {T<:Union{Float32,Float64}}
  _choose_num_threads(scale_cost(T(C)), NT, x)
end
@inline function _choose_num_threads(
  C::T,
  NT::UInt,
  x::Base.BitInteger
) where {T<:Union{Float32,Float64}}
  max(
    min(
      Base.fptoui(
        UInt,
        Base.ceil_llvm(
          Base.mul_float_fast(C, Base.sqrt_llvm_fast(Base.uitofp(T, x)))
        )
      ),
      NT
    ),
    one(UInt)
  )
end
function push_loop_length_expr!(q::Expr, ls::LoopSet)
  l = 1
  ndynamic = 0
  mulexpr = length(ls.loops) == 1 ? q : Expr(:call, lv(:vmul_nw))
  for loop ∈ ls.loops
    if isstaticloop(loop)
      l *= length(loop)
    else
      ndynamic += 1
      if ndynamic < 3
        push!(mulexpr.args, loop.lensym)
      else
        mulexpr = Expr(:call, lv(:vmul_nw), mulexpr, loop.lensym)
      end
    end
  end
  if length(ls.loops) == 1
    ndynamic == 0 && push!(q.args, l)
  elseif l == 1
    if ndynamic == 1
      push!(q.args, last(mulexpr.args))
    elseif ndynamic == 0
      push!(q.args, l)
    else
      push!(q.args, mulexpr)
    end
  elseif ndynamic == 0
    push!(q.args, l)
  elseif ndynamic == 1
    push!(mulexpr.args, l)
    push!(q.args, mulexpr)
  else
    push!(q.args, Expr(:call, :vmul_nw, mulexpr, l))
  end
  nothing
end
@inline function divrem_fast(numerator, denominator)
  d = Base.udiv_int(numerator, denominator)
  r = numerator - denominator * d
  d, r
end

function outer_reduct_combine_expressions(ls::LoopSet, retv)
  gf = GlobalRef(Core, :getfield)
  q = Expr(
    :block,
    :(
      var"#load#thread#ret#" = $gf(
        ThreadingUtilities.load(
          var"#thread#ptr#",
          typeof($retv),
          $(reg_size(ls))
        ),
        2,
        false
      )
    )
  )
  # push!(q.args, :(@show var"#load#thread#ret#"))
  for (i, or) ∈ enumerate(ls.outer_reductions)
    op = ls.operations[or]
    mvar = mangledvar(op)
    instr = instruction(op)
    out = Symbol(mvar, "##onevec##")
    instrcall::Expr = if instr.instr ≢ :ifelse
      Expr(:call, lv(reduce_to_onevecunroll(instr)))
    else
      reductexpr::Expr = let ls = ls
        ifelse_reduction(:IfElseReduced, op) do opv
          @assert length(ls.outer_reductions) > 1
          j = findfirst(==(identifier(opv)), ls.outer_reductions)
          otherarg = Expr(
            :call,
            lv(:vecmemaybe),
            Expr(
              :call,
              GlobalRef(Core, :getfield),
              Symbol("#load#thread#ret#"),
              j,
              false
            )
          )
          Expr(:call, lv(:vecmemaybe), Symbol(mangledvar(opv), "##onevec##")),
          (otherarg,)
        end
      end
      Expr(:call, reductexpr)
    end
    push!(instrcall.args, Expr(:call, lv(:vecmemaybe), out))
    if length(ls.outer_reductions) > 1
      push!(
        instrcall.args,
        Expr(
          :call,
          lv(:vecmemaybe),
          Expr(:call, gf, Symbol("#load#thread#ret#"), i, false)
        )
      )
    else
      push!(
        instrcall.args,
        Expr(:call, lv(:vecmemaybe), Symbol("#load#thread#ret#"))
      )
    end
    push!(q.args, Expr(:(=), out, Expr(:call, :data, instrcall)))
    # push!(q.args, Expr(:(=), out, :(@show $data($instrcall))))
  end
  q
end

function thread_loop_summary!(
  ls::LoopSet,
  ua::UnrollArgs,
  threadedloop::Loop,
  issecondthreadloop::Bool
)
  W = ls.vector_width
  @unpack u₁loop, u₂loop, vloop, u₁, u₂max = ua
  threadloopnumtag = Int(issecondthreadloop)
  lensym = Symbol("#len#thread#$threadloopnumtag#")
  define_len = if isstaticloop(threadedloop)
    :($lensym = $(length(threadedloop)) % UInt)
  else
    :($lensym = $((threadedloop.lensym)) % UInt)
  end
  unroll_factor = Core.ifelse(threadedloop === vloop, W, 1)
  num_unroll_sym = Symbol("#num#unrolls#thread#$threadloopnumtag#")
  define_num_unrolls = if unroll_factor == 1
    :($num_unroll_sym = $lensym)
  else
    # :($num_unroll_sym = Base.udiv_int($lensym, $(UInt(unroll_factor))))
    :(
      $num_unroll_sym = Base.udiv_int(
        vadd_nw($lensym, $(UInt(unroll_factor - 1))),
        $(UInt(unroll_factor))
      )
    )
  end
  iterstart_sym = Symbol("#iter#start#$threadloopnumtag#")
  iterstop_sym = Symbol("#iter#stop#$threadloopnumtag#")
  blksz_sym = Symbol("#nblock#size#thread#$threadloopnumtag#")
  loopstart = if isknown(first(threadedloop))
    :($iterstart_sym::Int = $(gethint(first(threadedloop))))
  else
    :($iterstart_sym::Int = $(getsym(first(threadedloop))))
  end
  if isknown(step(threadedloop))
    mf = gethint(step(threadedloop))
    if isone(mf)
      iterstop = :($iterstop_sym::Int = vadd_nsw($iterstart_sym, $blksz_sym))
      looprange = :(CloseOpen($iterstart_sym))
      lastrange = :(CloseOpen($iterstart_sym))
      push_loopbound_ends!(
        looprange,
        lastrange,
        unroll_factor,
        threadedloop,
        iterstop_sym,
        true
      )
    else
      iterstop = :(
        $iterstop_sym::Int =
          vadd_nsw($iterstart_sym, vmul_nw($blksz_sym, $mf))
      )
      looprange = :($iterstart_sym:StaticInt{$mf}())
      lastrange = :($iterstart_sym:StaticInt{$mf}())
      push_loopbound_ends!(
        looprange,
        lastrange,
        unroll_factor,
        threadedloop,
        :(vsub_nsw($iterstop_sym, one($iterstop_sym))),
        false
      )
    end
  else
    stepthread_sym = Symbol("#step#thread#$threadloopnumtag#")
    pushpreamble!(ls, :($stepthread_sym = $(getsym(step(threadedloop)))))
    iterstop = :(
      $iterstop_sym =
        vadd_nsw($iterstart_sym, vmul_nw($blksz_sym, $stepthread_sym))
    )
    looprange = :($iterstart_sym:$stepthread_sym)
    lastrange = :($iterstart_sym:$stepthread_sym)
    push_loopbound_ends!(
      looprange,
      lastrange,
      unroll_factor,
      threadedloop,
      :(vsub_nsw($iterstop_sym, one($iterstop_sym))),
      false
    )
  end
  define_len, define_num_unrolls, loopstart, iterstop, looprange, lastrange
end
function push_last_bound!(
  looprange::Expr,
  lastrange::Expr,
  lastexpr,
  iterstop,
  unroll_factor::Int
)
  push!(lastrange.args, lastexpr)
  unroll_factor ≠ 1 && push!(looprange.args, :(min($lastexpr, $iterstop)))
  nothing
end
function push_loopbound_ends!(
  looprange::Expr,
  lastrange::Expr,
  unroll_factor::Int,
  threadedloop::Loop,
  iterstop,
  offsetlast::Bool
)
  if unroll_factor == 1
    push!(looprange.args, iterstop)
  end
  if isknown(last(threadedloop))
    push_last_bound!(
      looprange,
      lastrange,
      gethint(last(threadedloop)) + offsetlast,
      iterstop,
      unroll_factor
    )
  else
    lastsym = getsym(last(threadedloop))
    if offsetlast
      push_last_bound!(
        looprange,
        lastrange,
        :(vadd_nsw($lastsym, one($lastsym))),
        iterstop,
        unroll_factor
      )
    else
      push_last_bound!(looprange, lastrange, lastsym, iterstop, unroll_factor)
    end
  end
  nothing
end
function define_block_size(threadedloop, vloop, tn, W)
  baseblocksizeuint = Symbol("#base#block#size#thread#uint#$tn#")
  baseblocksizeint = Symbol("#base#block#size#thread#$tn#")
  nrem = Symbol("#nrem#thread#$tn#")
  remstep = Symbol("#block#rem#step#$tn#")
  num_unroll = Symbol("#num#unrolls#thread#$tn#")
  thread_factor = Symbol("#thread#factor#$tn#")
  if threadedloop === vloop
    quote
      $baseblocksizeuint, $nrem = divrem_fast($num_unroll, $thread_factor)
      $baseblocksizeint =
        ($baseblocksizeuint << $(VectorizationBase.intlog2(W))) % Int
      $remstep = $(Int(W))
    end
  else
    quote
      $baseblocksizeuint, $nrem = divrem_fast($num_unroll, $thread_factor)
      $baseblocksizeint = $baseblocksizeuint % Int
      $remstep = 1
    end
  end
end
function thread_one_loops_expr(
  ls::LoopSet,
  ua::UnrollArgs,
  valid_thread_loop::Vector{Bool},
  ntmax::UInt,
  c::Float64,
  UNROLL::Tuple{Bool,Int8,Int8,Int8,Bool,Int,Int,Int,Int,UInt,Int,Bool},
  OPS::Expr,
  ARF::Expr,
  AM::Expr,
  LPSYM::Expr
)
  looplen = looplengthprod(ls)
  c = scale_cost(c, looplen)
  if all(isstaticloop, ls.loops)
    _num_threads = _choose_num_threads(c, ntmax, Int64(looplen))::UInt
    _num_threads > 1 || return avx_body(ls, UNROLL)
    ntcallexpr = Expr(:call, %, Expr(:call, Threads.nthreads), UInt)
    choose_nthread = Expr(
      :(=),
      Symbol("#nthreads#"),
      Expr(:call, min, ntcallexpr, _num_threads)
    )
  else
    choose_nthread = :(_choose_num_threads(
      $(Float32(c)),
      min(Threads.nthreads() % UInt, $ntmax)
    ))
    push_loop_length_expr!(choose_nthread, ls)
    choose_nthread = Expr(:(=), Symbol("#nthreads#"), choose_nthread)
  end
  threadedid = findfirst(valid_thread_loop)::Int
  threadedloop = getloop(ls, threadedid)
  define_len, define_num_unrolls, loopstart, iterstop, looprange, lastrange =
    thread_loop_summary!(ls, ua, threadedloop, false)
  loopboundexpr = Expr(:tuple) # for launched threads
  lastboundexpr = Expr(:tuple) # remainder, started on main thread
  for loop ∈ ls.loops
    if loop === threadedloop
      push!(loopboundexpr.args, looprange)
      push!(lastboundexpr.args, lastrange)
    else
      loop_boundary!(loopboundexpr, loop, true)
      loop_boundary!(lastboundexpr, loop, true)
    end
  end
  avxcall_args = Expr(:tuple, lastboundexpr, Symbol("#vargs#"))
  _turbo_call_ = :(_turbo_!(
    Val{$UNROLL}(),
    $OPS,
    $ARF,
    $AM,
    $LPSYM,
    Val(typeof(var"#avx#call#args#")),
    flatten_to_tuple(var"#avx#call#args#")...
  ))
  update_return_values = if length(ls.outer_reductions) > 0
    retv = loopset_return_value(ls, Val(false))
    _turbo_call_ = Expr(:(=), retv, _turbo_call_)
    outer_reduct_combine_expressions(ls, retv)
  else
    nothing
  end
  retexpr =
    length(ls.outer_reductions) > 0 ? :(return $retv) : :(return nothing)
  iterdef = define_block_size(threadedloop, ua.vloop, 0, ls.vector_width)
  q = quote
    $choose_nthread # UInt
    $loopstart
    var"##do#thread##" = var"#nthreads#" > one(var"#nthreads#")
    if var"##do#thread##"
      $define_len
      $define_num_unrolls
      var"#nthreads#" = Base.min(var"#nthreads#", var"#num#unrolls#thread#0#")
      var"#nrequest#" = vsub_nw((var"#nthreads#" % UInt32), 0x00000001)
      var"##do#thread##" = var"#nrequest#" ≠ 0x00000000
      if var"##do#thread##"
        var"#threads#tuple#", var"#torelease#tuple#" =
          PolyesterWeave.request_threads(var"#nrequest#")
        var"#thread#factor#0#" = var"#nthreads#"
        $iterdef
        var"#thread#id#" = 0x00000000
        var"##do#thread##" = false
        for var"#threads#" in var"#threads#tuple#"
          var"#thread#launch#count#" = 0x00000000
          var"#thread#mask#" = PolyesterWeave.mask(var"#threads#")
          var"#nrequest#" = length(var"#threads#")
          var"#threads#remain#" = var"#thread#launch#count#" ≠ var"#nrequest#"
          var"##do#thread##" |= var"#threads#remain#"
          while var"#threads#remain#"
            VectorizationBase.assume(
              var"#thread#mask#" ≠ zero(var"#thread#mask#")
            )
            var"#trailzing#zeros#" =
              Base.trailing_zeros(var"#thread#mask#") % UInt32
            var"#nblock#size#thread#0#" = Core.ifelse(
              var"#thread#launch#count#" < (var"#nrem#thread#0#" % UInt32),
              vadd_nw(var"#base#block#size#thread#0#", var"#block#rem#step#0#"),
              var"#base#block#size#thread#0#"
            )
            var"#trailzing#zeros#" =
              vadd_nw(var"#trailzing#zeros#", 0x00000001)
            $iterstop
            var"#thread#id#" =
              vadd_nw(var"#thread#id#", var"#trailzing#zeros#")

            var"##lbvargs#to_launch##" = ($loopboundexpr, var"#vargs#")
            avx_launch(
              Val{$UNROLL}(),
              $OPS,
              $ARF,
              $AM,
              $LPSYM,
              StaticType{typeof(var"##lbvargs#to_launch##")}(),
              flatten_to_tuple(var"##lbvargs#to_launch##"),
              var"#thread#id#"
            )

            var"#thread#mask#" >>>= var"#trailzing#zeros#"

            var"#iter#start#0#" = var"#iter#stop#0#"
            var"#thread#launch#count#" =
              vadd_nw(var"#thread#launch#count#", 0x00000001)
            var"#threads#remain#" =
              var"#thread#launch#count#" ≠ var"#nrequest#"
          end
          var"#nrem#thread#0#" -= var"#nrequest#"
        end
      else# eliminate undef var errors that the compiler should be able to figure out are unreachable, but doesn't
        var"#torelease#tuple#" = (zero(UInt),)
        var"#threads#tuple#" =
          (PolyesterWeave.UnsignedIteratorEarlyStop(zero(UInt), 0x00000000),)
      end
    end
    var"#avx#call#args#" = $avxcall_args
    $_turbo_call_
    var"##do#thread##" || $retexpr
    var"#thread#id#" = 0x00000000
    for var"#i#" ∈ eachindex(var"#threads#tuple#")
      var"#threads#" = var"#threads#tuple#"[var"#i#"]

      var"#thread#mask#" = PolyesterWeave.mask(var"#threads#")
      var"#threads#remain#" =
        (length(var"#threads#tuple#") == 1) ||
        (var"#thread#mask#" ≠ zero(var"#thread#mask#"))
      while var"#threads#remain#"
        VectorizationBase.assume(var"#thread#mask#" ≠ zero(var"#thread#mask#"))
        var"#trailzing#zeros#" = vadd_nw(
          Base.trailing_zeros(var"#thread#mask#") % UInt32,
          0x00000001
        )
        var"#thread#mask#" >>>= var"#trailzing#zeros#"
        var"#thread#id#" = vadd_nw(var"#thread#id#", var"#trailzing#zeros#")
        var"#thread#ptr#" = ThreadingUtilities.taskpointer(var"#thread#id#")
        ThreadingUtilities.wait(var"#thread#ptr#", var"#thread#id#")
        $update_return_values
        var"#threads#remain#" = var"#thread#mask#" ≠ 0x00000000
      end
      PolyesterWeave.free_threads!(var"#torelease#tuple#"[var"#i#"])
    end
    $retexpr
  end
  Expr(:block, ls.preamble, q)
end
function define_vthread_blocks(vloop, u₁loop, u₂loop, u₁, u₂, ntmax, tn)
  if tn == 0
    loopunrollname = Symbol("#num#unrolls#thread#0#")
    lhs = :((var"#thread#factor#0#", var"#thread#factor#1#"))
  else
    loopunrollname = Symbol("#num#unrolls#thread#1#")
    lhs = :((var"#thread#factor#1#", var"#thread#factor#0#"))
  end
  sntmax = staticexpr(ntmax % Int)
  if vloop === u₁loop
    :(
      $lhs = _choose_num_blocks(
        $loopunrollname,
        StaticInt{$u₁}(),
        var"#nthreads#",
        $sntmax
      )
    )
  elseif vloop === u₂loop
    :(
      $lhs = _choose_num_blocks(
        $loopunrollname,
        StaticInt{$u₂}(),
        var"#nthreads#",
        $sntmax
      )
    )
  else
    :(
      $lhs = _choose_num_blocks(
        $loopunrollname,
        StaticInt{1}(),
        var"#nthreads#",
        $sntmax
      )
    )
  end
end
function define_thread_blocks(
  threadedloop1,
  threadedloop2,
  vloop,
  u₁loop,
  u₂loop,
  u₁,
  u₂,
  ntmax
)
  if vloop === threadedloop1
    define_vthread_blocks(threadedloop1, u₁loop, u₂loop, u₁, u₂, ntmax, 0)
  elseif vloop === threadedloop2
    define_vthread_blocks(threadedloop2, u₁loop, u₂loop, u₁, u₂, ntmax, 1)
  else
    :(
      (var"#thread#factor#0#", var"#thread#factor#1#") =
        choose_num_blocks(var"#nthreads#", StaticInt{$(Int(ntmax))}())
    )
  end
end
function thread_two_loops_expr(
  ls::LoopSet,
  ua::UnrollArgs,
  valid_thread_loop::Vector{Bool},
  ntmax::UInt,
  c::Float64,
  UNROLL::Tuple{Bool,Int8,Int8,Int8,Bool,Int,Int,Int,Int,UInt,Int,Bool},
  OPS::Expr,
  ARF::Expr,
  AM::Expr,
  LPSYM::Expr
)
  looplen = looplengthprod(ls)
  # c = 0.0225 * c / looplen
  c = scale_cost(c, looplen)
  if all(isstaticloop, ls.loops)
    _num_threads = _choose_num_threads(c, ntmax, Int64(looplen))::UInt
    _num_threads > 1 || return avx_body(ls, UNROLL)
    ntcallexpr = Expr(:call, %, Expr(:call, Threads.nthreads), UInt)
    choose_nthread = Expr(
      :(=),
      Symbol("#nthreads#"),
      Expr(:call, min, ntcallexpr, _num_threads)
    )
  else
    choose_nthread = :(_choose_num_threads(
      $(Float32(c)),
      min(Threads.nthreads() % UInt, $ntmax)
    ))
    push_loop_length_expr!(choose_nthread, ls)
    choose_nthread = Expr(:(=), Symbol("#nthreads#"), choose_nthread)
  end
  threadedid1 = threadedid2 = 0
  for (i, v) ∈ enumerate(valid_thread_loop)
    v || continue
    if threadedid1 == 0
      threadedid1 = i
    else#if threadedid2 == 0
      threadedid2 = i
      break
    end
  end
  @unpack u₁loop, u₂loop, vloop, u₁, u₂max = ua
  u₂ = u₂max
  threadedloop1 = getloop(ls, threadedid1)
  threadedloop2 = getloop(ls, threadedid2)
  define_len1,
  define_num_unrolls1,
  loopstart1,
  iterstop1,
  looprange1,
  lastrange1 = thread_loop_summary!(ls, ua, threadedloop1, false)
  define_len2,
  define_num_unrolls2,
  loopstart2,
  iterstop2,
  looprange2,
  lastrange2 = thread_loop_summary!(ls, ua, threadedloop2, true)
  loopboundexpr = Expr(:tuple)
  lastboundexpr = Expr(:tuple)
  for loop ∈ ls.loops
    if loop === threadedloop1
      push!(loopboundexpr.args, looprange1)
      push!(lastboundexpr.args, lastrange1)
    elseif loop === threadedloop2
      push!(loopboundexpr.args, looprange2)
      push!(lastboundexpr.args, lastrange2)
    else
      loop_boundary!(loopboundexpr, loop, true)
      loop_boundary!(lastboundexpr, loop, true)
    end
  end
  avxcall_args = Expr(:tuple, lastboundexpr, Symbol("#vargs#"))
  _turbo_call_ = :(_turbo_!(
    Val{$UNROLL}(),
    $OPS,
    $ARF,
    $AM,
    $LPSYM,
    Val(typeof(var"#avx#call#args#")),
    flatten_to_tuple(var"#avx#call#args#")...
  ))
  update_return_values = if length(ls.outer_reductions) > 0
    retv = loopset_return_value(ls, Val(false))
    _turbo_call_ = Expr(:(=), retv, _turbo_call_)
    outer_reduct_combine_expressions(ls, retv)
  else
    nothing
  end
  blockdef = define_thread_blocks(
    threadedloop1,
    threadedloop2,
    vloop,
    u₁loop,
    u₂loop,
    u₁,
    u₂,
    ntmax
  )
  iterdef1 = define_block_size(threadedloop1, vloop, 0, ls.vector_width)
  iterdef2 = define_block_size(threadedloop2, vloop, 1, ls.vector_width)
  retexpr =
    length(ls.outer_reductions) > 0 ? :(return $retv) : :(return nothing)
  q = quote
    $choose_nthread # UInt
    $loopstart1
    $loopstart2
    var"##do#thread##" = var"#nthreads#" > one(var"#nthreads#")
    if var"##do#thread##"
      $define_len1
      $define_len2
      $define_num_unrolls1
      $define_num_unrolls2
      var"#unroll#prod#" =
        vmul_nw(var"#num#unrolls#thread#0#", var"#num#unrolls#thread#1#")
      if var"#nthreads#" ≥ var"#unroll#prod#"
        var"#nthreads#" = var"#unroll#prod#"
        var"#thread#factor#0#" = var"#num#unrolls#thread#0#"
        var"#thread#factor#1#" = var"#num#unrolls#thread#1#"
      else
        var"##thread#0##excess##" =
          var"#num#unrolls#thread#0#" ≥ var"#nthreads#"
        var"##thread#1##excess##" =
          var"#num#unrolls#thread#1#" ≥ var"#nthreads#"
        if var"##thread#0##excess##" & var"##thread#1##excess##"
          $blockdef
        elseif var"##thread#0##excess##" # var"#num#unrolls#thread#1#" is small but var"#num#unrolls#thread#0#" is not; we want to place a small one in front
          (var"#thread#factor#1#", var"#thread#factor#0#") =
            _choose_num_blocks(
              var"#num#unrolls#thread#1#",
              StaticInt{1}(),
              var"#nthreads#",
              $(staticexpr(ntmax % Int))
            )
        else # var"#num#unrolls#thread#0#" is small, and var"#num#unrolls#thread#1#" may or may not be
          (var"#thread#factor#0#", var"#thread#factor#1#") =
            _choose_num_blocks(
              var"#num#unrolls#thread#0#",
              StaticInt{1}(),
              var"#nthreads#",
              $(staticexpr(ntmax % Int))
            )
        end
        var"#thread#factor#0#" =
          min(var"#thread#factor#0#", var"#num#unrolls#thread#0#")
        var"#thread#factor#1#" =
          min(var"#thread#factor#1#", var"#num#unrolls#thread#1#")
      end
      # @show (var"#thread#factor#0#", var"#thread#factor#1#")
      var"#nrequest#" = vsub_nsw(
        vmul_nsw(var"#thread#factor#0#", var"#thread#factor#1#" % UInt32),
        0x00000001
      )
      var"#loop#1#start#init#" = var"#iter#start#0#"
      var"##do#thread##" = var"#nrequest#" ≠ 0x00000000
      if var"##do#thread##"
        # var"#threads#tuple#", var"#torelease#tuple#" = PolyesterWeave.request_threads(Threads.threadid(), var"#nrequest#")
        var"#threads#tuple#", var"#torelease#tuple#" =
          PolyesterWeave.request_threads(var"#nrequest#")
        var"##do#thread##" = false
        $iterdef1
        $iterdef2
        var"#thread#launch#count#0#" = 0x00000000
        var"#thread#launch#count#1#" = 0x00000000
        var"#thread#id#" = 0x00000000
        for var"#threads#" ∈ var"#threads#tuple#"
          var"#nrequest#" = length(var"#threads#")
          # @show var"#base#block#size#thread#0#", var"#block#rem#step#0#" var"#base#block#size#thread#1#", var"#block#rem#step#1#"
          var"#thread#launch#count#" = 0x00000000
          var"#thread#mask#" = PolyesterWeave.mask(var"#threads#")
          var"#threads#remain#" = var"#thread#launch#count#" ≠ var"#nrequest#"
          var"##do#thread##" |= var"#threads#remain#"
          while var"#threads#remain#"
            VectorizationBase.assume(
              var"#thread#mask#" ≠ zero(var"#thread#mask#")
            )
            var"#trailzing#zeros#" =
              Base.trailing_zeros(var"#thread#mask#") % UInt32
            var"#nblock#size#thread#0#" = Core.ifelse(
              var"#thread#launch#count#0#" < (var"#nrem#thread#0#" % UInt32),
              vadd_nw(var"#base#block#size#thread#0#", var"#block#rem#step#0#"),
              var"#base#block#size#thread#0#"
            )
            var"#nblock#size#thread#1#" = Core.ifelse(
              var"#thread#launch#count#1#" < (var"#nrem#thread#1#" % UInt32),
              vadd_nw(var"#base#block#size#thread#1#", var"#block#rem#step#1#"),
              var"#base#block#size#thread#1#"
            )
            var"#trailzing#zeros#" =
              vadd_nw(var"#trailzing#zeros#", 0x00000001)
            $iterstop1
            $iterstop2
            var"#thread#id#" =
              vadd_nw(var"#thread#id#", var"#trailzing#zeros#")
            # @show var"#thread#id#" $loopboundexpr
            var"##lbvargs#to_launch##" = ($loopboundexpr, var"#vargs#")
            avx_launch(
              Val{$UNROLL}(),
              $OPS,
              $ARF,
              $AM,
              $LPSYM,
              StaticType{typeof(var"##lbvargs#to_launch##")}(),
              flatten_to_tuple(var"##lbvargs#to_launch##"),
              var"#thread#id#"
            )
            var"#thread#mask#" >>>= var"#trailzing#zeros#"

            var"##end#inner##" =
              var"#thread#launch#count#0#" ==
              vsub_nw(var"#thread#factor#0#", 0x00000001)
            var"#thread#launch#count#0#" = Core.ifelse(
              var"##end#inner##",
              0x00000000,
              vadd_nw(var"#thread#launch#count#0#", 0x00000001)
            )
            var"#thread#launch#count#1#" = Core.ifelse(
              var"##end#inner##",
              var"#thread#launch#count#1#" + 0x00000001,
              var"#thread#launch#count#1#"
            )

            var"#iter#start#0#" = Core.ifelse(
              var"##end#inner##",
              var"#loop#1#start#init#",
              var"#iter#stop#0#"
            )
            var"#iter#start#1#" = Core.ifelse(
              var"##end#inner##",
              var"#iter#stop#1#",
              var"#iter#start#1#"
            )

            var"#thread#launch#count#" =
              vadd_nw(var"#thread#launch#count#", 0x00000001)
            var"#threads#remain#" =
              var"#thread#launch#count#" ≠ var"#nrequest#"
          end
        end
      else# eliminate undef var errors that the compiler should be able to figure out are unreachable, but doesn't
        var"#torelease#tuple#" = (zero(UInt),)
        var"#threads#tuple#" =
          PolyesterWeave.UnsignedIteratorEarlyStop(zero(UInt), 0x00000000)
      end
    end
    # @show $lastboundexpr
    var"#avx#call#args#" = $avxcall_args
    $_turbo_call_
    var"##do#thread##" || $retexpr
    var"#thread#id#" = 0x00000000
    for var"#i#" ∈ 1:length(var"#threads#tuple#")
      var"#threads#" = var"#threads#tuple#"[var"#i#"]
      var"#thread#mask#" = PolyesterWeave.mask(var"#threads#")
      var"#threads#remain#" =
        (length(var"#threads#tuple#") == 1) ||
        (var"#thread#mask#" ≠ zero(var"#thread#mask#"))
      while var"#threads#remain#"
        VectorizationBase.assume(var"#thread#mask#" ≠ zero(var"#thread#mask#"))
        var"#trailzing#zeros#" = vadd_nw(
          Base.trailing_zeros(var"#thread#mask#") % UInt32,
          0x00000001
        )
        var"#thread#mask#" >>>= var"#trailzing#zeros#"
        var"#thread#id#" = vadd_nw(var"#thread#id#", var"#trailzing#zeros#")
        var"#thread#ptr#" = ThreadingUtilities.taskpointer(var"#thread#id#")
        ThreadingUtilities.wait(var"#thread#ptr#", var"#thread#id#")
        $update_return_values
        var"#threads#remain#" = var"#thread#mask#" ≠ 0x00000000
      end
      PolyesterWeave.free_threads!(var"#torelease#tuple#"[var"#i#"])
    end
    $retexpr
  end
  Expr(:block, ls.preamble, q)
end

function valid_thread_loops(ls::LoopSet)
  order, u₁loop, u₂loop, vectorized, u₁, u₂, c, shouldinline =
    choose_order_cost(ls)
  # NOTE: `names` are being placed in the opposite order here versus normal lowering!
  copyto!(names(ls), order)
  init_loop_map!(ls)
  u₁loop = getloop(ls, u₁loop)
  _u₂loop = getloopid_or_nothing(ls, u₂loop)
  u₂loop = _u₂loop === nothing ? u₁loop : getloop_from_id(ls, _u₂loop)
  ua = UnrollArgs(u₁loop, u₂loop, getloop(ls, vectorized), u₁, u₂, u₂)
  valid_thread_loop = fill(true, length(order))
  has_reduced_deps = false
  for op ∈ operations(ls)
    if isstore(op) && (length(reduceddependencies(op)) > 0)
      for reduceddep ∈ reduceddependencies(op)
        for (i, o) ∈ enumerate(order)
          if o === reduceddep
            has_reduced_deps = true
            valid_thread_loop[i] = false
          end
        end
      end
    end
  end
  c *= (1.0 + 0.5has_reduced_deps)
  for (i, o) ∈ enumerate(order)
    loop = getloop(ls, o)
    if isstaticloop(loop) & (length(loop) ≤ 1)
      valid_thread_loop[i] = false
    end
  end
  valid_thread_loop, ua, c
end
function avx_threads_expr(
  ls::LoopSet,
  UNROLL::Tuple{Bool,Int8,Int8,Int8,Bool,Int,Int,Int,Int,UInt,Int,Bool},
  nt::UInt,
  OPS::Expr,
  ARF::Expr,
  AM::Expr,
  LPSYM::Expr
)
  valid_thread_loop, ua, c = valid_thread_loops(ls)
  num_candidates = sum(valid_thread_loop)
  if (num_candidates == 0) || (nt ≤ 1) # it was called from `avx_body` but now `nt` was set to `1`
    avx_body(ls, UNROLL)
  elseif (num_candidates == 1) || (nt ≤ 3)
    thread_one_loops_expr(
      ls,
      ua,
      valid_thread_loop,
      nt,
      c,
      UNROLL,
      OPS,
      ARF,
      AM,
      LPSYM
    )
  else # requires at least 4 threads
    thread_two_loops_expr(
      ls,
      ua,
      valid_thread_loop,
      nt,
      c,
      UNROLL,
      OPS,
      ARF,
      AM,
      LPSYM
    )
  end
end

using OffsetArrays, Test
@testset "UpperboundedIntegers" begin
  function ubsum(x)
    @assert firstindex(x) == 0
    r = LoopVectorization.CloseOpen(
      LoopVectorization.UpperBoundedInteger(length(x), LoopVectorization.StaticInt(15)),
    )
    s = zero(eltype(x))
    @turbo for i ∈ r
      s += x[i]
    end
    s
  end
  function ubdouble!(y, x)
    @assert firstindex(x) == 0
    r = LoopVectorization.CloseOpen(
      LoopVectorization.UpperBoundedInteger(length(x), LoopVectorization.StaticInt(15)),
    )
    @turbo for i ∈ r
      y[i] = 2 * x[i]
    end
    y
  end
  for l ∈ 1:15
    x = OffsetVector(rand(l), -1)
    @test ubsum(x) ≈ sum(x)
    @test ubdouble!(similar(x), x) == x .* 2
  end
  for l ∈ 70:75
    # If the actual value is greater than the ubber bound, as is the case here,
    # (upper bound = 15, actual length = 70:75), then the result is undefined.
    # Currently, it'll evaluate to the actual value with heavily unrolled reductions
    x = OffsetVector(rand(l), -1)
    @test ubsum(x) ≈ ubsum(x)
    xs = similar(x)
    # both otherwise, the behavior is undefined. It'll evaluate at most
    # UF * W * cld(UB, W)
    # iterations, where UF is the unroll factor, W the vector width,
    # and N the actual length.
    # It may evaluate less than the upper bound, depending on the mask's value.
    # We check that the first few match
    @test @view(ubdouble!(xs, x)[begin:3]) == @view(x[begin:3]) .* 2
    LoopVectorization.register_size() > 16 && (@test xs[end] ≠ 2x[end])
  end
end

function parentind(ind::Symbol, op::Union{Operation,ArrayReferenceMetaPosition})
  for (id, opp) ∈ enumerate(parents(op))
    name(opp) === ind && return id
  end
  -1
end
function symbolind(ind::Symbol, op::Operation, td::UnrollArgs, ls::LoopSet)
  id = parentind(ind, op)
  id == -1 && return ind, op
  @unpack u₁, u₁loopsym, u₂loopsym, vloopsym, u₂max, suffix = td
  parent = parents(op)[id]
  pvar, u₁op, u₂op = variable_name_and_unrolled(
    parent,
    u₁loopsym,
    u₂loopsym,
    vloopsym,
    suffix,
    ls
  )
  Symbol(pvar, '_', Core.ifelse(u₁op, u₁, 1)), parent
end

staticexpr(x::StaticInt) = x
staticexpr(x::Int) = StaticInt{x}()
staticexpr(x::Union{Symbol,Expr}) = Expr(:call, lv(:StaticInt), x)

_MMind(ind::Union{Symbol,Expr}, str::Int) =
  Expr(:call, lv(:MM), VECTORWIDTHSYMBOL, ind, staticexpr(str))
_MMind(ind::Int, str::Int) =
  Expr(:call, lv(:MM), VECTORWIDTHSYMBOL, staticexpr(ind), staticexpr(str))

_MMind(ind::Union{Int,Symbol,Expr}, str::Union{Symbol,Expr}) =
  addexpr(mulexpr(_MMind(0, 1), str), ind)
_MMind(ind, str::MaybeKnown) =
  isknown(str) ? _MMind(ind, gethint(str)) : _MMind(ind, getsym(str))

_iszero(::Symbol) = false
_iszero(::Expr) = false
_iszero(x) = iszero(x)
_isone(::Symbol) = false
_isone(::Expr) = false
_isone(x) = isone(x)
# To make this code type stable, despite potentially pushing `Int`s, `Symbol`s, or `Expr`s into `ret`,
# it takes the form of nested calls, each branching and popping off an argument.
function addoffset!(ret::Expr, stride, ind) # 3 args
  if _iszero(stride)
    pushexpr!(ret, ind)
  else
    pushexpr!(ret, _MMind(ind, stride))
  end
  nothing
end
# dropping `calcbypointeroffset` has to be delayed until after multiplying the `indexstride` by `index.
function addoffset!(ret::Expr, stride, ind, offset, calcbypointeroffset::Bool) # 5 -> 3 args
  if calcbypointeroffset
    addoffset!(ret, stride, offset)
  elseif _iszero(offset)
    addoffset!(ret, stride, ind)
  else
    addoffset!(ret, stride, addexpr(ind, offset))
  end
end
function _addoffset!(
  ret::Expr,
  vloopstride,
  indexstride::Union{Int,MaybeKnown},
  index,
  offset,
  calcbypointeroffset::Bool
) # 6 -> 5 args
  if _isone(indexstride)
    addoffset!(ret, vloopstride, index, offset, calcbypointeroffset)
  else
    __addoffset!(
      ret,
      vloopstride,
      indexstride,
      index,
      offset,
      calcbypointeroffset
    )
  end
end
function _addoffset!(
  ret::Expr,
  vloopstride,
  indexstride,
  index,
  offset,
  calcbypointeroffset::Bool
) # 6 -> 5 args
  ___addoffset!(
    ret,
    vloopstride,
    indexstride,
    index,
    offset,
    calcbypointeroffset
  )
end
function __addoffset!(
  ret::Expr,
  vloopstride,
  indexstride,
  index,
  offset,
  calcbypointeroffset::Bool
) # 6 -> 5 args
  ___addoffset!(
    ret,
    vloopstride,
    indexstride,
    index,
    offset,
    calcbypointeroffset
  )
end
function __addoffset!(
  ret::Expr,
  vloopstride::Union{Int,MaybeKnown},
  indexstride::Union{Int,MaybeKnown},
  index,
  offset,
  calcbypointeroffset::Bool
) # 6 -> 5 args
  if isknown(vloopstride) & isknown(indexstride)
    addoffset!(
      ret,
      gethint(vloopstride) * gethint(indexstride),
      index,
      offset,
      calcbypointeroffset
    )
  else
    ___addoffset!(
      ret,
      vloopstride,
      indexstride,
      index,
      offset,
      calcbypointeroffset
    )
  end
end
function ___addoffset!(
  ret::Expr,
  vloopstride,
  indexstride,
  index,
  offset,
  calcbypointeroffset::Bool
) # 6 -> 5 args
  addoffset!(
    ret,
    mulexpr(vloopstride, indexstride),
    index,
    offset,
    calcbypointeroffset
  )
end
# multiply `index` by `indexstride`
function addoffset!(
  ret::Expr,
  vloopstride,
  indexstride,
  index,
  offset,
  calcbypointeroffset::Bool
) # 6 -> (5 or 6) args
  if _isone(indexstride)
    addoffset!(ret, vloopstride, index, offset, calcbypointeroffset) # 5
  elseif calcbypointeroffset # `ind` is getting dropped, no need to allocate via `mulexpr`
    _addoffset!(
      ret,
      vloopstride,
      indexstride,
      index,
      offset,
      calcbypointeroffset
    ) # 6
  else # multiply index by stride
    _addoffset!(
      ret,
      vloopstride,
      indexstride,
      mulexpr(index, indexstride),
      offset,
      calcbypointeroffset
    ) # 6
  end
end

function addoffset!(
  ret::Expr,
  indvectorized::Bool,
  vloopstride,
  indexstride,
  index,
  offset,
  calcbypointeroffset::Bool
) # 7 -> (5 or 6) args
  if indvectorized
    addoffset!(
      ret,
      vloopstride,
      indexstride,
      index,
      offset,
      calcbypointeroffset
    )
  elseif _isone(indexstride)
    addoffset!(ret, 0, index, offset, calcbypointeroffset)
  else
    addoffset!(
      ret,
      0,
      lazymulexpr(index, indexstride),
      offset,
      calcbypointeroffset
    )
  end
end

function addvectoroffset!(
  ret::Expr,
  indvectorized::Bool,
  unrolledsteps,
  vloopstride,
  indexstride,
  index,
  offset,
  calcbypointeroffset::Bool
) # 8 -> 7 args
  # if _iszero(unrolledsteps) # if no steps, pass through; should be unreachable
  #     addoffset!(ret, indvectorized, vloopstride, indexstride, index, offset, calcbypointeroffset)
  # else
  if calcbypointeroffset # if we previously would've dropped the index, we now replace it with the `VECTORWIDTH` step
    if _isone(unrolledsteps)
      addoffset!(
        ret,
        indvectorized,
        vloopstride,
        indexstride,
        VECTORWIDTHSYMBOL,
        offset,
        false
      )
    else
      addoffset!(
        ret,
        indvectorized,
        vloopstride,
        indexstride,
        mulexpr(VECTORWIDTHSYMBOL, unrolledsteps),
        offset,
        false
      )
    end
  elseif _isone(unrolledsteps) # add the step to the index
    addoffset!(
      ret,
      indvectorized,
      vloopstride,
      indexstride,
      addexpr(VECTORWIDTHSYMBOL, index),
      offset,
      false
    )
  else
    addoffset!(
      ret,
      indvectorized,
      vloopstride,
      indexstride,
      addexpr(mulexpr(VECTORWIDTHSYMBOL, unrolledsteps), index),
      offset,
      false
    )
  end
end
# unrolledloopstride is a stride multiple on `unrolledsteps`
function addvectoroffset!(
  ret::Expr,
  mm::Bool,
  unrolledsteps::Int,
  unrolledloopstride,
  vloopstride,
  indexstride::Integer,
  index,
  offset::Integer,
  calcbypointeroffset::Bool,
  indvectorized::Bool
) # 10 -> (7 or 8) args
  if unrolledsteps == 0 # neither unrolledloopstride or indexstride can be 0
    addoffset!(
      ret,
      mm,
      vloopstride,
      indexstride,
      index,
      offset,
      calcbypointeroffset
    ) # 7 arg
  elseif indvectorized
    unrolledsteps *= indexstride
    if isknown(unrolledloopstride)
      addvectoroffset!(
        ret,
        mm,
        gethint(unrolledloopstride) * unrolledsteps,
        vloopstride,
        indexstride,
        index,
        offset,
        calcbypointeroffset
      ) # 8 arg
    elseif unrolledsteps == 1
      addvectoroffset!(
        ret,
        mm,
        unrolledloopstride,
        vloopstride,
        indexstride,
        index,
        offset,
        calcbypointeroffset
      ) # 8 arg
    else
      addvectoroffset!(
        ret,
        mm,
        mulexpr(unrolledloopstride, unrolledsteps),
        vloopstride,
        indexstride,
        index,
        offset,
        calcbypointeroffset
      ) # 8 arg
    end
  elseif _isone(unrolledloopstride)
    addoffset!(
      ret,
      mm,
      vloopstride,
      indexstride,
      index,
      offset + unrolledsteps,
      calcbypointeroffset
    ) # 7 arg
  else
    addoffset!(
      ret,
      mm,
      vloopstride,
      mulexpr(unrolledloopstride, indexstride),
      index,
      addexpr(offset, lazymulexpr(unrolledloopstride, unrolledsteps)),
      calcbypointeroffset
    ) # 7 arg
  end
end

"""
unrolled loads are calculated as offsets with respect to an initial gesp. This has proven important to helping LLVM generate efficient code in some cases.
Therefore, unrolled === true results in inds being ignored.
_mm means to insert `mm`s.
"""
function mem_offset(
  op::Operation,
  td::UnrollArgs,
  inds_calc_by_ptr_offset::Vector{Bool},
  _mm::Bool,
  ls::LoopSet,
  preserve_vecunroll::Bool
)
  # @assert accesses_memory(op) "Computing memory offset only makes sense for operations that access memory."
  ret = Expr(:tuple)
  indices = getindicesonly(op)
  offsets = getoffsets(op)
  strides = getstrides(op)
  loopedindex = op.ref.loopedindex
  # inds_calc_by_ptr_offset = indices_calculated_by_pointer_offsets(ls, op.ref)
  @unpack vloopsym = td
  for (n, ind) ∈ enumerate(indices)
    indvectorized = _mm & (ind === vloopsym)
    offset = offsets[n] % Int
    stride = strides[n] % Int
    ind_by_offset = inds_calc_by_ptr_offset[n] | (ind === CONSTANTZEROINDEX)
    @unpack vstep = td
    if loopedindex[n]
      addoffset!(ret, indvectorized, vstep, stride, ind, offset, ind_by_offset) # 7 arg
    else
      offset += (stride - 1) # 1 -> 0-based inedxing
      newname, parent = symbolind(ind, op, td, ls)
      # _mmi = indvectorized && parent !== op && (!isvectorized(parent))
      # addoffset!(ret, newname, stride, offset, _mmi)
      _mmi = indvectorized && parent !== op && (!isvectorized(parent))
      @assert !_mmi "Please file an issue with an example of how you got this."
      if (isu₁unrolled(parent) & (td.u₁ > 1)) & (!preserve_vecunroll)
        gf = GlobalRef(Core, :getfield)
        firstnew = Expr(:call, gf, Expr(:call, gf, newname, 1), 1, false)
        if isvectorized(parent) & (!_mm)
          firstnew = Expr(:call, lv(:unmm), firstnew)
        end
        addoffset!(ret, 0, firstnew, offset, false)
      elseif isvectorized(parent) & (!_mm)
        addoffset!(ret, 0, Expr(:call, lv(:unmm), newname), offset, false)
      else
        addoffset!(ret, 0, newname, offset, false)
      end
    end
  end
  ret
end
function sptr(op::Operation)
  vp = vptr(op)
  Expr(
    :call,
    GlobalRef(VectorizationBase, :reconstruct_ptr),
    vp,
    vptr_offset(vp)
  )
end
function sptr!(q::Expr, op::Operation)
  vp = vptr(op)
  sptrsym = gensym(vp)
  push!(q.args, Expr(:(=), sptrsym, sptr(op)))
  sptrsym
end

# function unrolled_curly(op::Operation, u₁::Int, u₁loopsym::Symbol, vectorized::Symbol, mask::Bool)

# interleave: `0` means `false`, positive means literal, negative means multiplier
function unrolled_curly(
  op::Operation,
  u₁::Int,
  u₁loop::Loop,
  vloop::Loop,
  mask::Bool,
  interleave::Int = 0
)
  u₁loopsym = u₁loop.itersymbol
  vloopsym = vloop.itersymbol
  indices = getindicesonly(op)
  vstep = step(vloop)
  li = op.ref.loopedindex
  # @assert all(loopedindex)
  # @unpack u₁, u₁loopsym, vloopsym = td
  AV = AU = -1
  for (n, ind) ∈ enumerate(indices)
    if li[n]
      if ind === vloopsym
        @assert AV == -1 # FIXME: these asserts should be replaced with checks that prevent using `unrolled_curly` in these cases (also to be reflected in cost modeling, to avoid those)
        AV = n
      end
      if ind === u₁loopsym
        if AU ≠ -1
          u₁loopsym === CONSTANTZEROINDEX && continue
          throw(ArgumentError("Two of the same index $ind?"))
        end
        AU = n
      end
    else
      opp = findop(parents(op), ind)
      if isvectorized(opp)
        @assert AV == -1
        AV = n
      end
      # if (u₁loopsym === CONSTANTZEROINDEX) ? (CONSTANTZEROINDEX ∈ loopdependencies(opp)) : (isu₁unrolled(opp) || (ind === u₁loopsym))
      # can't check isu₁unrolled(opp) because we may be lying.
      if (u₁loopsym === CONSTANTZEROINDEX) ?
         (CONSTANTZEROINDEX ∈ loopdependencies(opp)) :
         (u₁loopsym ∈ loopdependencies(opp) || (ind === u₁loopsym))
        @assert AU == -1
        AU = n
      end
    end
  end
  AU == -1 &&
    throw(LoopError("Failed to find $(u₁loopsym) in args of $(repr(op))."))
  vecnotunrolled = AU != AV
  conditional_memory_op = isconditionalmemop(op)
  if mask || conditional_memory_op
    M = one(UInt)
    # `isu₁unrolled(last(parents(op)))` === is condop unrolled?
    # isu₁unrolled(last(parents(op)))
    if vecnotunrolled || conditional_memory_op || (interleave > 0) # mask all
      M = (M << u₁) - M
    else # mask last
      M <<= (u₁ - 1)
    end
  else
    M = zero(UInt)
  end
  @assert isknown(step(u₁loop)) "Unrolled loops must have known steps to use `Unroll` type; this is a bug, shouldn't have reached here"
  if AV > 0
    @assert isknown(step(vloop)) "Vectorized loops must have known steps to use `Unroll` type; this is a bug, shouldn't have reached here."
    XU = convert(Int, getstrides(op)[AU]) * gethint(step(u₁loop))
    X = convert(Int, getstrides(op)[AV])
    X *= gethint(step(vloop))
    intvecsym = :(Int($VECTORWIDTHSYMBOL))
    if interleave > 0
      Expr(:curly, lv(:Unroll), AU, interleave, u₁, AV, intvecsym, M, X)
    elseif interleave < 0
      interleave *= -XU
      if AU == AV
        unrollstepexpr = :(Int($(mulexpr(VECTORWIDTHSYMBOL, interleave))))
        Expr(:curly, lv(:Unroll), AU, unrollstepexpr, u₁, AV, intvecsym, M, X)
      else
        Expr(:curly, lv(:Unroll), AU, interleave, u₁, AV, intvecsym, M, X)
      end
    else
      if vecnotunrolled
        # Expr(:call, Expr(:curly, lv(:Unroll), AU, 1, u₁, AV, intvecsym, M, 1), ind)
        Expr(:curly, lv(:Unroll), AU, XU, u₁, AV, intvecsym, M, X)
      else
        if isone(X)
          Expr(:curly, lv(:Unroll), AU, intvecsym, u₁, AV, intvecsym, M, X)
        else
          unrollstepexpr = :(Int($(mulexpr(VECTORWIDTHSYMBOL, X))))
          Expr(:curly, lv(:Unroll), AU, unrollstepexpr, u₁, AV, intvecsym, M, X)
        end
      end
    end
  else
    Expr(
      :curly,
      lv(:Unroll),
      AU,
      convert(Int, getstrides(op)[AU]) * gethint(step(u₁loop)),
      u₁,
      0,
      1,
      M,
      1
    )
  end
end
function unrolledindex(
  op::Operation,
  td::UnrollArgs,
  mask::Bool,
  inds_calc_by_ptr_offset::Vector{Bool},
  ls::LoopSet
)
  @unpack u₁, u₁loopsym, u₁loop, vloop = td
  isone(u₁) &&
    return mem_offset_u(op, td, inds_calc_by_ptr_offset, true, 0, ls, false)
  any(==(u₁loopsym), getindicesonly(op)) ||
    return mem_offset_u(op, td, inds_calc_by_ptr_offset, true, 0, ls, true)

  unrollcurl = unrolled_curly(op, u₁, u₁loop, vloop, mask)
  ind = mem_offset_u(op, td, inds_calc_by_ptr_offset, false, 0, ls, false)
  Expr(:call, unrollcurl, ind)
end

function mem_offset_u(
  op::Operation,
  td::UnrollArgs,
  inds_calc_by_ptr_offset::Vector{Bool},
  _mm::Bool,
  incr₁::Int,
  ls::LoopSet,
  preserve_vecunroll::Bool
)
  @assert accesses_memory(op) "Computing memory offset only makes sense for operations that access memory."
  @unpack u₁loopsym, u₂loopsym, vloopsym, u₁step, u₂step, vstep, suffix = td

  #u₁
  incr₂ = max(suffix, 0)#(suffix == -1) ? 0 : suffix
  ret = Expr(:tuple)
  indices = getindicesonly(op)
  offsets = getoffsets(op)
  strides = getstrides(op)
  # allbasezero = all(inds_calc_by_ptr_offset) && all(iszero, offsets)
  loopedindex = op.ref.loopedindex
  if iszero(incr₁) & iszero(incr₂)
    return mem_offset(
      op,
      td,
      inds_calc_by_ptr_offset,
      _mm,
      ls,
      preserve_vecunroll
    )
    # append_inds!(ret, indices, loopedindex)
  else
    for (n, ind) ∈ enumerate(indices)
      ind_by_offset = inds_calc_by_ptr_offset[n] | (ind === CONSTANTZEROINDEX)
      offset = convert(Int, offsets[n])
      stride = convert(Int, strides[n])
      # @show stride, ind, u₂loopsym
      indvectorized = ind === vloopsym
      indvectorizedmm = _mm & indvectorized
      if ind === u₁loopsym
        # TODO: should it be stride*incr₁ ???
        addvectoroffset!(
          ret,
          indvectorizedmm,
          incr₁,
          u₁step,
          vstep,
          stride,
          ind,
          offset,
          ind_by_offset,
          indvectorized
        ) # 9 arg
      elseif ind === u₂loopsym
        addvectoroffset!(
          ret,
          indvectorizedmm,
          stride * incr₂,
          u₂step,
          vstep,
          stride,
          ind,
          offset,
          ind_by_offset,
          indvectorized
        ) # 9 arg
      elseif loopedindex[n]
        addoffset!(
          ret,
          indvectorizedmm,
          vstep,
          stride,
          ind,
          offset,
          ind_by_offset
        ) # 7 arg
      else
        offset += (stride - 1) # 1 -> 0-based indexing
        newname, parent = symbolind(ind, op, td, ls)
        _mmi = indvectorizedmm && parent !== op && (!isvectorized(parent))
        #                              addoffset!(ret, newname, 1, offset, _mmi)
        @assert !_mmi "Please file an issue with an example of how you got this."
        if isvectorized(parent) & (!_mm)
          if isu₁unrolled(parent) & (td.u₁ > 1)
            gf = GlobalRef(Core, :getfield)
            newname_unmm = Expr(
              :call,
              lv(:unmm),
              Expr(:call, gf, Expr(:call, gf, newname, 1), incr₁ + 1, false)
            )
          else
            newname_unmm = Expr(:call, lv(:unmm), newname)
          end
          if stride ≠ 1
            newname_unmm = mulexpr(newname_unmm, stride)
          end
          addoffset!(ret, 0, newname_unmm, offset, false)
        elseif (isu₁unrolled(parent) & (td.u₁ > 1)) && !preserve_vecunroll
          gf = GlobalRef(Core, :getfield)
          firstnew =
            Expr(:call, gf, Expr(:call, gf, newname, 1), incr₁ + 1, false)
          if stride ≠ 1
            firstnew = mulexpr(firstnew, stride)
          end
          addoffset!(ret, 0, firstnew, offset, false)
        elseif stride == 1
          addoffset!(ret, 0, newname, offset, false)
        else
          addoffset!(ret, 0, mulexpr(newname, stride), offset, false)
        end
      end
    end
  end
  ret
end

@inline and_last(a, b) = a & b
@generated function and_last(v::VecUnroll{N}, m) where {N}
  q = Expr(:block, Expr(:meta, :inline), :(vd = data(v)))
  t = Expr(:call, lv(:promote))
  gf = GlobalRef(Core, :getfield)
  for n ∈ 1:N
    push!(t.args, :($gf(vd, $n, false)))
  end
  push!(t.args, :($gf(vd, $(N + 1), false) & m))
  push!(q.args, Expr(:call, lv(:VecUnroll), t))
  q
end

isconditionalmemop(op::Operation) =
  (instruction(op).instr === :conditionalload) ||
  (instruction(op).instr === :conditionalstore!)
function add_memory_mask!(
  memopexpr::Expr,
  op::Operation,
  td::UnrollArgs,
  mask::Bool,
  ls::LoopSet,
  u₁ᵢ::Int
)
  @unpack u₁, u₁loopsym, u₂loopsym, vloopsym, u₂max, suffix = td
  if isconditionalmemop(op)
    condop = last(parents(op))
    opu₂ = (suffix ≠ -1) && isu₂unrolled(op)
    condvar, condu₁unrolled = condvarname_and_unroll(
      condop,
      u₁loopsym,
      u₂loopsym,
      vloopsym,
      suffix,
      opu₂,
      ls
    )
    # if it isn't unrolled, then `m`
    u = condu₁unrolled ? u₁ : 1
    # u = isu₁unrolled(condop) ? u₁ : 1
    condvar = Symbol(condvar, '_', u)
    # If we need to apply `MASKSYMBOL` and the condvar
    # 2 condvar possibilities:
    #   `VecUnroll` applied everywhere
    #    single mask "broadcast"
    # 2 mask possibilities
    #    u₁loopsym ≠  vloopsym, and we mask all
    #    u₁loopsym == vloopsym, and we mask last
    # broadcast both, so can do so implicitly
    # this is true whether or not `condbroadcast`
    if !mask || (!isvectorized(op))
      if (u₁ᵢ == 0) | (u == 1)
        push!(memopexpr.args, condvar)
      else
        push!(
          memopexpr.args,
          :($getfield($getfield($condvar, 1), $(u₁ᵢ), false))
        )
      end
    elseif (u₁loopsym ≢ vloopsym) | (u₁ == 1) # mask all equivalenetly
      push!(memopexpr.args, Expr(:call, lv(:&), condvar, MASKSYMBOL))
      # if the condition `(u₁loopsym ≢ vloopsym) | (u₁ == 1)` failed, we need to apply `MASKSYMBOL` only to last unroll.
    elseif ((!condu₁unrolled)) && isu₁unrolled(op)  # condbroadcast
      if u₁ᵢ == 0
        # explicitly broadcast `condvar`, and apply `MASKSYMBOL` to end
        t = Expr(:call, lv(:promote))
        for um ∈ 1:u₁-1
          push!(t.args, condvar)
        end
        push!(t.args, Expr(:call, lv(:&), condvar, MASKSYMBOL))
        push!(memopexpr.args, Expr(:call, lv(:VecUnroll), t))
      else
        push!(memopexpr.args, condvar)
      end
    elseif u₁ᵢ == 0# !condbroadcast && !vecunrolled
      push!(memopexpr.args, Expr(:call, lv(:and_last), condvar, MASKSYMBOL))
    elseif u₁ᵢ == u₁ # mask
      push!(
        memopexpr.args,
        Expr(
          :call,
          lv(:&),
          :($getfield($getfield(condvar, 1), $u₁ᵢ, false)),
          MASKSYMBOL
        )
      )
    else
      push!(
        memopexpr.args,
        Expr(:call, lv(:&), :($getfield($getfield(condvar, 1), $u₁ᵢ, false)))
      )
    end
  elseif mask && isvectorized(op)
    push!(memopexpr.args, MASKSYMBOL)
  end
  nothing
end

function condvarname_and_unroll(
  cond::Operation,
  u₁loop::Symbol,
  u₂loop::Symbol,
  vloop::Symbol,
  suffix::Int,
  opu₂::Bool,
  ls::LoopSet
)
  condvar, condu₁, condu₂ = variable_name_and_unrolled(
    cond,
    u₁loop,
    u₂loop,
    vloop,
    Core.ifelse(opu₂, suffix, -1),
    ls
  )
  condvar, condu₁
end

using LoopVectorization, Test
T = Float32

if !@isdefined(RUN_SLOW_TESTS)
  @eval const RUN_SLOW_TESTS = true
end

function test_broadcast(::Type{T}) where {T}
  M, N = 37, 47
  @show T, @__LINE__
  R = T <: Integer ? (T(-100):T(100)) : T
  a = rand(R, 99, 99, 99)
  b = rand(R, 99, 99, 1)
  bl = LowDimArray{(true, true, false)}(b)
  @test size(bl) == size(b)
  @test LoopVectorization.static_size(bl) ===
        (size(b, 1), size(b, 2), LoopVectorization.StaticInt(1))

  br = reshape(b, (99, 99))
  c1 = a .+ b
  c2 = @turbo inline = false a .+ bl
  @test c1 ≈ c2
  fill!(c2, 99999)
  @turbo inline = false c2 .= a .+ br
  @test c1 ≈ c2
  fill!(c2, 99999)
  @turbo inline = false c2 .= a .+ b
  @test c1 ≈ c2
  br = reshape(b, (99, 1, 99))
  bl = LowDimArray{(true, false, true)}(br)
  @test size(bl) == size(br)
  @test LoopVectorization.static_size(bl) ===
        (size(br, 1), LoopVectorization.StaticInt(1), size(br, 3))
  @. c1 = a + br
  fill!(c2, 99999)
  @turbo inline = false @. c2 = a + bl
  @test c1 ≈ c2
  fill!(c2, 99999)
  @turbo inline = false @. c2 = a + br
  @test c1 ≈ c2
  br = reshape(b, (1, 99, 99))
  bl = LowDimArray{(false,)}(br)
  @test size(bl) == size(br)
  @test LoopVectorization.static_size(bl) ===
        (LoopVectorization.StaticInt(1), size(br, 2), size(br, 3))
  @. c1 = a + br
  fill!(c2, 99999)
  @test c1 ≈ @turbo inline = false @. c2 = a + bl
  # @test c1 ≈ c2
  br = reshape(rand(R, 99), (1, 99, 1))
  bl = LowDimArray{(false,)}(br)
  @test size(bl) == size(br)
  @. c1 = a + br
  fill!(c2, 99999)
  @turbo inline = false @. c2 = a + bl
  @test c1 ≈ c2

  if T <: Integer
    xs = rand(-T(100):T(100), M)
  else
    xs = rand(T, M)
  end
  max_ = maximum(xs, dims = 1)
  @test (@turbo inline = false exp.(xs .- LowDimArray{(false,)}(max_))) ≈
        exp.(xs .- LowDimArray{(false,)}(max_))
  @test size(LowDimArray{(false,)}(max_)) == size(max_)

  if T === Int32
    a = rand(T(1):T(100), 73, 1)
    @test sqrt.(Float32.(a)) ≈ @turbo inline = false sqrt.(a)
  elseif T === Int64
    a = rand(T(1):T(100), 73, 1)
    @test sqrt.(a) ≈ @tturbo inline = false sqrt.(a)
  else
    a = rand(T, 73, 1)
    @test sqrt.(a) ≈ @turbo inline = false sqrt.(a)
  end

  a = rand(R, M)
  B = rand(R, M, N)
  c = rand(R, N)
  c′ = c'
  d1 = @. a + B * c′
  d2 = @tturbo inline = false @. a + B * c′
  @test d1 ≈ d2

  @. d1 = a + B * c′
  @turbo inline = false @. d2 = a + B * c′
  @test d1 ≈ d2

  d3 = a .+ B * c
  d4 = @turbo inline = false a .+ B *ˡ c
  @test d3 ≈ d4

  fill!(d3, -1000.0)
  fill!(d4, 91000.0)

  d3 .= a .+ B * c
  @turbo inline = false d4 .= a .+ B *ˡ c
  @test d3 ≈ d4

  fill!(d4, 91000.0)
  @turbo inline = false @. d4 = a + B *ˡ c
  @test d3 ≈ d4

  M, K, N = 77, 83, 57
  A = rand(R, M, K)
  B = rand(R, K, N)
  C = rand(R, M, N)
  At = copy(A')
  D1 = C .+ A * B
  D2 = @tturbo inline = false C .+ A .*ˡ B
  @test D1 ≈ D2
  if RUN_SLOW_TESTS
    fill!(D2, -999999)
    D2 = @turbo inline = false C .+ At' *ˡ B
    @test D1 ≈ D2
    fill!(D2, -999999)
    @test A * B ≈ (@turbo inline = false @. D2 = A *ˡ B)
    D1 .= view(C, 1, :)' .+ A * B
    fill!(D2, -999999)
    @turbo inline = false D2 .= view(C, 1, :)' .+ A .*ˡ B
    @test D1 ≈ D2
    C3d = rand(R, 3, M, N)
    D1 .= view(C3d, 1, :, :) .+ A * B
    fill!(D2, -999999)
    @tturbo inline = false D2 .= view(C3d, 1, :, :) .+ A .*ˡ B
    @test D1 ≈ D2
  end
  D1 .= 9999
  @turbo inline = false D2 .= 9999
  @test D1 == D2
  D1 .= -99999
  @tturbo inline = false D2' .= -99999
  @test D1 == D2

  b = rand(T, K)
  x = rand(R, N)
  D1 .= C .+ A * (b .+ x')
  @tturbo inline = false @. D2 = C + A *ˡ (b + x')
  @test D1 ≈ D2
  D2 = @turbo inline = false @. C + A *ˡ (b + x')
  @test D1 ≈ D2
  if T === Int64
    xd = rand(-1_000_000_000_000:1_000_000_000_000, 89)
  elseif T === Int32
    xd = rand(-Int32(10_000_000):Int32(10_000_000), 89)
  else
    xd = rand(R, 89)
  end
  yd = rand(R, 89)
  yd[yd.==0] .= 77
  @test xd .÷ yd == @turbo xd .÷ yd

  if T <: Union{Float32,Float64}
    D3 = cos.(B')
    D4 = @turbo inline = false cos.(B')
    @test D3 ≈ D4

    fill!(D3, -1e3)
    fill!(D4, 9e9)
    Bt = transpose(B)
    @. D3 = exp(Bt)
    @tturbo inline = false @. D4 = exp(Bt)
    @test D3 ≈ D4

    D1 = similar(B)
    D2 = similar(B)
    D1t = transpose(D1)
    D2t = transpose(D2)
    @. D1t = exp(Bt)
    @turbo inline = false @. D2t = exp(Bt)
    @test D1t ≈ D2t

    fill!(D1, -1e3)
    fill!(D2, 9e9)
    @. D1' = exp(Bt)
    lset = @tturbo inline = false @. D2' = exp(Bt)

    @test D1 ≈ D2

    a = rand(137)
    b1 = @turbo inline = false @. 3 * a + sin(a) + sqrt(a)
    b2 = @. 3 * a + sin(a) + sqrt(a)
    @test b1 ≈ b2
    three = 3
    fill!(b1, -9999)
    @tturbo inline = false @. b1 = three * a + sin(a) + sqrt(a)
    @test b1 ≈ b2

    C = rand(100, 10, 10)
    D1 = C .^ 0.3
    D2 = @tturbo inline = false C .^ 0.3
    @test D1 ≈ D2
    @. D1 = C^2
    @turbo inline = false @. D2 = C^2
    @test D1 ≈ D2
    @turbo view(C, 1:100, 1:10, 1:10) .= 0
    @test all(==(0), C)
    @turbo view(B, axes(B, 1), axes(B, 2))' .= 2
    @test all(==(2), B)
  end
end

@testset "broadcast_float" begin
  for T ∈ (Float32, Float64, Int32, Int64)
    @time test_broadcast(T)
  end
end

const DISCONTIGUOUS = Symbol("##DISCONTIGUOUSSUBARRAY##")
const CONSTANTZEROINDEX = Symbol("##CONSTANTZEROINDEX##")
const LOOPCONSTANT =
  Instruction(:LoopVectorization, Symbol("LOOPCONSTANTINSTRUCTION"))
const GLOBALCONSTANT = Symbol("##GLOBAL##CONSTANT##")

"""
    ArrayReference

A type for encoding an array reference `A[i,j]` occurring inside an `@turbo` block.

# Fields

$(TYPEDFIELDS)
"""
struct ArrayReference
  "The array variable"
  array::Symbol
  "The list of indices (e.g., `[:i, :j]`), or `name(op)` for computed indices."
  indices::Vector{Symbol}
  """Index offset, e.g., `a[i+7]` would store the `7`. `offsets` is also used
  to help identify opportunities for avoiding reloads, for example in `y[i] = x[i] - x[i-1]`,
  the previous load `x[i-1]` can be "carried over" to the next iteration.
  Only used for small (`Int8`) offsets."""
  offsets::Vector{Int8}
  strides::Vector{Int8}
end
function ArrayReference(array, indices)
  ninds = length(indices)
  if ninds > 0
    ninds -= (first(indices) === DISCONTIGUOUS)
  end
  ArrayReference(array, indices, zeros(Int8, ninds), ones(Int8, ninds))
end
function sameref(x::ArrayReference, y::ArrayReference)
  (x.array === y.array) && (x.indices == y.indices) && (x.strides == y.strides)
end
function Base.isequal(x::ArrayReference, y::ArrayReference)
  sameref(x, y) || return false
  xoffs = x.offsets
  yoffs = y.offsets
  # xmult = x.strides; ymult = y.strides
  length(xoffs) == length(yoffs) || return false
  for n ∈ eachindex(xoffs)
    # ((xoffs[n] == yoffs[n]) & (xmult[n] == ymult[n])) || return false
    (xoffs[n] == yoffs[n]) || return false
  end
  true
end

"""
    ArrayReferenceMeta

A type similar to [`ArrayReference`](@ref) but holding additional information.

# Fields

$(TYPEDFIELDS)
"""
struct ArrayReferenceMeta
  "The `ArrayReference`"
  ref::ArrayReference
  "A vector of Bools indicating whether each index is a loop variable (`false` for operation-computed indices)"
  loopedindex::Vector{Bool}
  "Variable holding the pointer to the array's underlying storage"
  ptr::Symbol
end
function ArrayReferenceMeta(ref::ArrayReference, loopedindex, ptr = vptr(ref))
  ArrayReferenceMeta(ref, loopedindex, ptr)
end

struct OffsetLoadCollection
  opids::Vector{Vector{Int}}
  # offsets::Vector{Vector{Vector{Int8}}}
  opidcollectionmap::Vector{Tuple{Int,Int}}
  batchedcollections::Vector{
    SubArray{
      Tuple{Int,Int},
      1,
      Vector{Tuple{Int,Int}},
      Tuple{UnitRange{Int}},
      true
    }
  }
  batchedcollectionmap::Vector{Tuple{Int,Int}}
  function OffsetLoadCollection()
    new(
      Vector{Int}[],
      Tuple{Int,Int}[],
      SubArray{
        Tuple{Int,Int},
        1,
        Vector{Tuple{Int,Int}},
        Tuple{UnitRange{Int}},
        true
      }[],
      Tuple{Int,Int}[]
    )
  end
end

# function Base.hash(x::ArrayReference, h::UInt)
# @inbounds for n ∈ eachindex(x)
# h = hash(x.ref[n], h)
# end
# hash(x.array, h)
# end
loopdependencies(ref::ArrayReferenceMeta) = ref.ref.indices
"""
This definition is used to find the matching arrays for the LoopStartStopManager.
It checks the underly ArrayReferences, but also the vptr names. This is because different
slices of the same array will have the same ArrayReference, but different vptr names.
"""
sameref(x::ArrayReferenceMeta, y::ArrayReferenceMeta) =
  (vptr(x) === vptr(y)) && sameref(x.ref, y.ref)
Base.convert(::Type{ArrayReference}, ref::ArrayReferenceMeta) = ref.ref
Base.:(==)(x::ArrayReference, y::ArrayReference) = isequal(x, y)
Base.:(==)(x::ArrayReferenceMeta, y::ArrayReferenceMeta) =
  (x.ptr === y.ptr) && isequal(x.ref, y.ref)

# Errors preferable than silently working?
Base.:(==)(x::ArrayReference, y::ArrayReferenceMeta) = x == y.ref
Base.:(==)(x::ArrayReferenceMeta, y::ArrayReference) = x.ref == y
# Base.:(==)(x::ArrayReference, y) = false
# Base.:(==)(x::ArrayReferenceMeta, y) = false

abstract type AbstractLoopOperation end

"""
`OperationType` is an `@enum` for classifying supported operations that can appear in
`@turbo` blocks. Type `LoopVectorization.OperationType` to see the different types.
"""
@enum OperationType begin
  constant
  memload
  compute
  memstore
  loopvalue
end
"""
An operation setting a variable to a constant value (e.g., `a = 0.0`)
"""
constant
"""
An operation setting a variable from a memory location (e.g., `a = A[i,j]`)
"""
memload
"""
An operation computing a new value from one or more variables (e.g., `a = b + c`)
"""
compute
"""
An operation storing a value to a memory location (e.g., `A[i,j] = a`)
"""
memstore
"""
`loopvalue` indicates an loop variable (`i` in `for i in ...`). These are the "parents" of `compute`
operations that involve the loop variables.
"""
loopvalue

# TODO: can some computations be cached in the operations?
"""
    Operation

A structure to encode a particular action occurring inside an `@turbo` block.

# Fields

$(TYPEDFIELDS)

# Example

```jldoctest Operation; filter = r"\\"##.*\\""
julia> using LoopVectorization

julia> AmulBq = :(for m ∈ 1:M, n ∈ 1:N
           C[m,n] = zero(eltype(B))
           for k ∈ 1:K
               C[m,n] += A[m,k] * B[k,n]
           end
       end);

julia> lsAmulB = LoopVectorization.LoopSet(AmulBq);

julia> LoopVectorization.operations(lsAmulB)
6-element Vector{LoopVectorization.Operation}:
 var"##RHS#245" = var"##zero#246"
 C[m, n] = var"##RHS#245"
 var"##tempload#248" = A[m, k]
 var"##tempload#249" = B[k, n]
 var"##RHS#245" = LoopVectorization.vfmadd(var"##tempload#248", var"##tempload#249", var"##RHS#245")
 var"##RHS#245" = LoopVectorization.identity(var"##RHS#245")
```
Each one of these lines is a pretty-printed `Operation`.
"""
mutable struct Operation <: AbstractLoopOperation
  """A unique identifier for this operation.
  `identifier(op::Operation)` returns the index of this operation within `operations(ls::LoopSet)`."""
  identifier::Int
  """The name of the variable storing the result of this operation.
  For `a = val` this would be `:a`. For array assignments `A[i,j] = val` this would be `:A`."""
  variable::Symbol
  "Intended to be the size of the result, in bytes. Often inaccurate, not to be relied on."
  elementbytes::Int
  "The specific operator, e.g., `identity` or `+`"
  instruction::Instruction
  "The [`OperationType`](@ref) associated with this operation"
  node_type::OperationType
  "The loop variables this operation depends on"
  dependencies::Vector{Symbol}
  "Additional loop dependencies that must execute before this operation can be performed successfully (often needed in reductions)"
  reduced_deps::Vector{Symbol}
  "Operations whose result this operation depends on"
  parents::Vector{Operation}
  "Operations who depend on this result"
  children::Vector{Operation}
  "For `memload` or `memstore`, encodes the array location"
  ref::ArrayReferenceMeta
  "`gensymmed` name of result."
  mangledvariable::Symbol
  """Loop variables that *consumers* of this operation depend on.
  Often used in reductions to replicate assignment of initializers when unrolling."""
  reduced_children::Vector{Symbol}
  "Cached value for whether u₁loopsym ∈ loopdependencies(op)"
  u₁unrolled::Bool
  "Cached value for whether u₂loopsym ∈ loopdependencies(op)"
  u₂unrolled::Bool
  "Cached value for whether vectorized ∈ loopdependencies(op)"
  vectorized::Bool
  "Cached value for whether or not to lower memop using `Unrolled`"
  rejectcurly::Bool
  "Cached value for whether or not to lower memop by interleaving it with offset operations"
  rejectinterleave::Bool
  function Operation(
    identifier::Int,
    variable::Symbol,
    elementbytes::Int,
    instruction::Union{Symbol,Instruction},
    node_type::OperationType,
    dependencies::Vector{Symbol} = Symbol[],
    reduced_deps::Vector{Symbol} = Symbol[],
    parents::Vector{Operation} = Operation[],
    ref::ArrayReferenceMeta = NOTAREFERENCE,
    reduced_children::Vector{Symbol} = Symbol[]
  )
    new(
      identifier,
      variable,
      elementbytes,
      instruction,
      node_type,
      dependencies,
      reduced_deps,
      parents,
      Operation[],
      ref,
      Symbol("##", variable, :_),
      reduced_children
    )
  end
end

isu₁unrolled(op::Operation) = op.u₁unrolled
isu₂unrolled(op::Operation) = op.u₂unrolled
isvectorized(op::Operation) = op.vectorized

function matches(op1::Operation, op2::Operation)
  op1 === op2 && return true
  op1.instruction === op2.instruction || return false
  op1.node_type == op2.node_type || return false
  if isconstant(op1)
    return iszero(length(loopdependencies(op1))) &&
           iszero(length(loopdependencies(op2))) &&
           (mangledvar(op1) === mangledvar(op2))
  end
  op1.dependencies == op2.dependencies || return false
  op2.reduced_deps == op2.reduced_deps || return false
  if accesses_memory(op1)
    op1.ref == op2.ref || return false
  end
  nparents = length(parents(op1))
  nparents == length(parents(op2)) || return false
  for p ∈ 1:nparents
    matches(op1.parents[p], op2.parents[p]) || return false
  end
  true
end

# negligible save on allocations for operations that don't need these (eg, constants).
const NODEPENDENCY = Symbol[]
const NOPARENTS = Operation[]

function ref_for_print(op::Operation)
  ref = Expr(:ref, name(op.ref))
  inds = getindicesonly(op)
  length(inds) ≠ length(parent(inds)) && push!(ref.args, first(parent(inds)))
  strides = getstrides(op)
  offsets = getoffsets(op)
  for i ∈ eachindex(inds)
    s = strides[i]
    o = offsets[i]
    ind = inds[i]
    if s == 1
      if o == 0
        push!(ref.args, ind)
      else
        push!(ref.args, :($ind + $o))
      end
    elseif s == 0
      push!(ref.args, o)
    else
      index = :($s * $ind)
      o == 0 || (index = :($index + $o))
      push!(ref.args, index)
    end
  end
  ref
end
function Base.show(io::IO, op::Operation)
  if isconstant(op)
    if op.instruction === LOOPCONSTANT
      print(io, Expr(:(=), op.variable, 0))
    elseif op.instruction.instr === GLOBALCONSTANT
      print(io, op.instruction.instr)
    else
      print(io, Expr(:(=), op.variable, op.instruction.instr))
    end
  elseif isload(op)
    print(io, Expr(:(=), op.variable, ref_for_print(op)))
  elseif iscompute(op)
    print(
      io,
      Expr(:(=), op.variable, callexpr(op.instruction, map(name, parents(op))))
    )
  elseif isstore(op)
    print(io, Expr(:(=), ref_for_print(op), name(first(parents(op)))))
  elseif isloopvalue(op)
    print(io, Expr(:(=), op.variable, first(loopdependencies(op))))
  end
end

function isreduction(op::Operation)
  ((op.node_type == compute) || (op.node_type == memstore)) &&
    length(reduceddependencies(op)) > 0
  # (op.node_type == memstore) && (length(op.symbolic_metadata) < length(op.dependencies))# && issubset(op.symbolic_metadata, op.dependencies)
end
optype(op::Operation) = op.node_type
isload(op::AbstractLoopOperation) = optype(op) == memload
iscompute(op::AbstractLoopOperation) = optype(op) == compute
isstore(op::AbstractLoopOperation) = optype(op) == memstore
isconstant(op::AbstractLoopOperation) = optype(op) == constant
isloopvalue(op::AbstractLoopOperation) = optype(op) == loopvalue
accesses_memory(op::AbstractLoopOperation) = isload(op) | isstore(op)
elsize(op::Operation) = op.elementbytes
dependson(op::Operation, sym::Symbol) = sym ∈ op.dependencies
parents(op::Operation) = op.parents
children(op::Operation) = op.children
loopdependencies(op::Operation) = op.dependencies
reduceddependencies(op::Operation) = op.reduced_deps
reducedchildren(op::Operation) = op.reduced_children
identifier(op::Operation) = op.identifier + 1
vptr(x::Symbol) = Symbol("##vptr##_", x)
vptr(x::ArrayReference) = vptr(x.array)
vptr(x::ArrayReferenceMeta) = x.ptr
vptr(x::Operation) = x.ref.ptr
vptr_offset(x::Symbol) = Symbol(x, "#offset##")
vptr_offset(x) = vptr_offset(vptr(x))
# vptrbase(x) = Symbol(vptr(x), "##BASE##")
name(x::ArrayReference) = x.array
name(x::ArrayReferenceMeta) = x.ref.array
name(op::Operation) = op.variable
instruction(op::Operation) = op.instruction
isreductcombineinstr(op::Operation) =
  iscompute(op) && isreductcombineinstr(instruction(op))
"""
    mvar = mangledvar(op)

Returns the mangled variable name, for use in the produced expressions.
These names will be further processed if op is tiled and/or unrolled.

```julia
if tiled ∈ loopdependencies(op) # `suffix` is tilenumber
  mvar = Symbol(op, suffix, :_)
end
if unrolled ∈ loopdependencies(op) # `u` is unroll number
  mvar = Symbol(op, u)
end
```
"""
mangledvar(op::Operation) = op.mangledvariable

mutable struct ArrayReferenceMetaPosition
  mref::ArrayReferenceMeta
  parents::Vector{Operation}
  loopdependencies::Vector{Symbol}
  reduceddeps::Vector{Symbol}
  varname::Symbol
end
# function ArrayReferenceMetaPosition(parents::Vector{Operation}, ldref::Vector{Symbol}, reduceddeps::Vector{Symbol}, varname::Symbol)
#     ArrayReferenceMetaPosition( NOTAREFERENCE, parents, ldref, reduceddeps, varname )
# end
function Operation(
  id::Int,
  var::Symbol,
  elementbytes::Int,
  instr,
  optype::OperationType,
  mpref::ArrayReferenceMetaPosition
)
  Operation(
    id,
    var,
    elementbytes,
    instr,
    optype,
    mpref.loopdependencies,
    mpref.reduceddeps,
    mpref.parents,
    mpref.mref
  )
end
Base.:(==)(x::ArrayReferenceMetaPosition, y::ArrayReferenceMetaPosition) =
  x.mref == y.mref
parents(op::ArrayReferenceMetaPosition) = op.parents
# Avoid memory allocations by using this for ops that aren't references
const NOTAREFERENCE =
  ArrayReferenceMeta(ArrayReference(Symbol(""), Symbol[]), Bool[], Symbol(""))
const NOTAREFERENCEMP = ArrayReferenceMetaPosition(
  NOTAREFERENCE,
  NOPARENTS,
  Symbol[],
  Symbol[],
  Symbol("")
)
varname(::Nothing) = nothing
varname(mpref::ArrayReferenceMetaPosition) = mpref.varname
name(mpref::ArrayReferenceMetaPosition) = name(mpref.mref.ref)
loopdependencies(ref::ArrayReferenceMetaPosition) = ref.loopdependencies
reduceddependencies(ref::ArrayReferenceMetaPosition) = ref.reduceddeps
arrayref(ref::ArrayReference) = ref
arrayref(ref::ArrayReferenceMeta) = ref.ref
arrayref(ref::ArrayReferenceMetaPosition) = ref.mref.ref
arrayref(op::Operation) = op.ref.ref
getindices(ref) = arrayref(ref).indices
getoffsets(ref) = arrayref(ref).offsets
getstrides(ref) = arrayref(ref).strides

isdiscontiguous(ref) = isdiscontiguous_inds(getindices(ref))
function isdiscontiguous_inds(inds)
  length(inds) == 0 ? false : (@inbounds(inds[begin]) === DISCONTIGUOUS)
end
function makediscontiguous!(inds)
  if iszero(length(inds)) || !isdiscontiguous_inds(inds)
    pushfirst!(inds, DISCONTIGUOUS)
  end
  nothing
end

function getindicesonly(ref)
  indices = getindices(ref)
  @view(indices[isdiscontiguous(ref)+1:end])
end
# function hasintersection(s1::Set{T}, s2::Set{T}) where {T}
# for x ∈ s1
# x ∈ s2 && return true
# end
# false
# end

# function symposition(op::Operation, sym::Symbol)
# findfirst(s -> s === sym, op.symbolic_metadata)
# end
# function stride(op::Operation, sym::Symbol)
# @assert accesses_memory(op) "This operation does not access memory!"
# # access stride info?
# op.numerical_metadata[symposition(op,sym)]
# end
function find_cmp_args_from_ifelse(op::Operation)
  parents_op = parents(op)
  @assert length(parents_op) == 3
  cmp = parents_op[1]
  a = parents_op[2]
  b = parents_op[3]
  not = false
  cmp_instr = instruction(cmp).instr
  parents_cmp = parents(cmp)
  while length(parents_cmp) == 1
    @assert (cmp_instr === :(!)) || (cmp_instr === :(~))
    not = !not
    cmp = only(parents_cmp)
    cmp_instr = instruction(cmp).instr
    parents_cmp = parents(cmp)
  end
  @assert length(parents_cmp) == 2
  cmpa = parents_cmp[1]
  cmpb = parents_cmp[2]
  if (cmpa ≡ b) && (cmpb ≡ a)
    not = !not
    cmpa, cmpb = cmpb, cmpa
    cmp, cmpb, cmpa, !not, true
  else
    cmp, cmpa, cmpb, not, ((cmpa === a) & (cmpb === b))
  end
end

function ifelse_reduce_fun_expr(f::Symbol, op::Operation)
  cmp, cmpa, cmpb, not, success = find_cmp_args_from_ifelse(op)
  lvcmp_instr = lv(instruction(cmp).instr)
  if success
    lvf = lv(f)
    return not ? Expr(:call, lvf, :($(!) ∘ $lvcmp_instr)) :
           Expr(:call, lvf, lvcmp_instr)
  end
  options = children(cmp)
  for oop ∈ options
    oop === op && continue
    _cmp, _cmpa, _cmpb, _not, _success = find_cmp_args_from_ifelse(oop)
    _success || continue
    lvf = lv(Symbol(f, :Mirror))
    expr =
      not ? Expr(:call, lvf, :($(!) ∘ $lvcmp_instr)) :
      Expr(:call, lvf, lvcmp_instr)
    push!(expr.args, name(_cmpa), name(_cmpb))
    return expr
  end
  throw("Failed to find matching reduction to select")
end

function ifelse_reduction(f::F, rsym::Symbol, op::Operation) where {F}
  cmp, cmpa, cmpb, not, success = find_cmp_args_from_ifelse(op)
  lvcmp_instr = lv(instruction(cmp).instr)
  if success
    lvf = lv(rsym)
    return not ? Expr(:call, lvf, :($(!) ∘ $lvcmp_instr)) :
           Expr(:call, lvf, lvcmp_instr)
  end
  options = children(cmp)
  for oop ∈ options
    oop === op && continue
    _cmp, _cmpa, _cmpb, _not, _success = find_cmp_args_from_ifelse(oop)
    _success || continue
    lvf = lv(Symbol(rsym, :Mirror))
    foop, goop = f(oop)
    return not ? Expr(:call, lvf, :($(!) ∘ $lvcmp_instr), foop, goop...) :
           Expr(:call, lvf, lvcmp_instr, foop, goop...)
  end
  throw("Failed to find matching reduction to select")
end

# for f ∈ [:reduction_scalar_combine, :reduction_to_scalar, :reduce_number_of_vectors, (:reduce_to_onevecunroll,:IfElseOp),(:reduction_to_single_vector,:IfElseCollapser)]
# for f ∈ [:reduction_scalar_combine, :reduction_to_scalar, :reduce_number_of_vectors,:reduce_to_onevecunroll,:reduction_to_single_vector]
#   @eval begin
#     $f(x) = $f(reduction_instruction_class(x))
#     $f(op::Operation)::GlobalRef = lv($f(instruction(op)))
#   end
# end
# No `@eval` to make the language server happy
reduction_scalar_combine(x) =
  reduction_scalar_combine(reduction_instruction_class(x))
reduction_scalar_combine(op::Operation)::GlobalRef =
  lv(reduction_scalar_combine(instruction(op)))
reduction_to_scalar(x) = reduction_to_scalar(reduction_instruction_class(x))
reduction_to_scalar(op::Operation)::GlobalRef =
  lv(reduction_to_scalar(instruction(op)))
reduce_number_of_vectors(x) =
  reduce_number_of_vectors(reduction_instruction_class(x))
reduce_number_of_vectors(op::Operation)::GlobalRef =
  lv(reduce_number_of_vectors(instruction(op)))
reduce_to_onevecunroll(x) =
  reduce_to_onevecunroll(reduction_instruction_class(x))
reduce_to_onevecunroll(op::Operation)::GlobalRef =
  lv(reduce_to_onevecunroll(instruction(op)))
reduction_to_single_vector(x) =
  reduction_to_single_vector(reduction_instruction_class(x))
reduction_to_single_vector(op::Operation)::GlobalRef =
  lv(reduction_to_single_vector(instruction(op)))

using BenchmarkTools

const SUITE = BenchmarkGroup()
SUITE["linalg"] = BenchmarkGroup(["matmul", "dot"])

include(joinpath(@__DIR__, "looptests.jl"))

SUITE["linalg"]["matmul"] = BenchmarkGroup()
SUITE["linalg"]["dot"] = BenchmarkGroup()
for n ∈ 1:64
  A = rand(n, n)
  A′ = copy(A')
  B = rand(n, n)
  C = Matrix{Float64}(undef, n, n)
  SUITE["linalg"]["matmul"]["AmulB", n] = @benchmarkable gemmavx!($C, $A, $B)
  SUITE["linalg"]["matmul"]["A′mulB", n] =
    @benchmarkable jAtmulBavx!($C, $A′, $B)
  x = rand(n)
  y = rand(n)
  SUITE["linalg"]["dot"]["dot", n] = @benchmarkable jdotavx($x, $y)
  SUITE["linalg"]["dot"]["selfdot", n] = @benchmarkable jselfdotavx($x)
  SUITE["linalg"]["dot"]["dot3", n] = @benchmarkable jdot3avx($x, $A, $y)
end

include(joinpath(LOOPVECBENCHDIR, "looptests.jl"))
include(joinpath(LOOPVECBENCHDIR, "loadsharedlibs.jl"))

using BenchmarkTools, SharedArrays
struct SizedResults{V<:AbstractVector} <: AbstractMatrix{String}
  results::Matrix{Float64}
  sizes::V
end
function Base.size(sr::SizedResults)
  M, N = size(sr.results)
  N, M + 1
end
struct BenchmarkResult{V}
  tests::Vector{String}
  sizedresults::SizedResults{V}
end
function BenchmarkResult(results, tests, sizes)
  ntests = length(tests)
  nsizes = length(sizes)
  BenchmarkResult(append!(["Size"], tests), SizedResults(results, sizes))
end
function Base.getindex(br::SizedResults, row, col)
  col == 1 ? string(br.sizes[row]) : string(br.results[col-1, row])
end
Base.setindex!(br::BenchmarkResult, v, i...) = br.sizedresults.results[i...] = v
function Base.vcat(br1::BenchmarkResult, br2::BenchmarkResult)
  BenchmarkResult(
    br1.tests,
    SizedResults(
      hcat(br1.sizedresults.results, br2.sizedresults.results),
      vcat(br1.sizedresults.sizes, br2.sizedresults.sizes)
    )
  )
end

tothreetuple(i::Int) = (i, i, i)
tothreetuple(i::NTuple{3,Int}) = i
function matmul_bench!(br, C, A, B, i)
  M, N = size(C)
  K = size(B, 1)
  n_gflop = M * K * N * 2e-9
  Cblas = A * B
  br[1, i] = n_gflop / @belapsed gemmavx!($C, $A, $B)
  @assert C ≈ Cblas "LoopVec gemm wrong?"
  fill!(C, NaN)
  br[2, i] = n_gflop / @belapsed jgemm!($C, $A, $B)
  @assert C ≈ Cblas "Julia gemm wrong?"
  fill!(C, NaN)
  br[3, i] = n_gflop / @belapsed cgemm!($C, $A, $B)
  @assert C ≈ Cblas "Clang gemm wrong?"
  fill!(C, NaN)
  br[4, i] = n_gflop / @belapsed fgemm!($C, $A, $B)
  @assert C ≈ Cblas "Fort gemm wrong?"
  fill!(C, NaN)
  if INTEL_BENCH
    br[5, i] = n_gflop / @belapsed icgemm!($C, $A, $B)
    @assert C ≈ Cblas "icc gemm wrong?"
    fill!(C, NaN)
    br[6, i] = n_gflop / @belapsed ifgemm!($C, $A, $B)
    @assert C ≈ Cblas "ifort gemm wrong?"
    fill!(C, NaN)
  end
  br[5+2INTEL_BENCH, i] = n_gflop / @belapsed egemm!($C, $A, $B)
  @assert C ≈ Cblas "eigen gemm wrong?"
  fill!(C, NaN)
  br[6+2INTEL_BENCH, i] = n_gflop / @belapsed iegemm!($C, $A, $B)
  @assert C ≈ Cblas "i-eigen gemm wrong?"
  fill!(C, NaN)

  br[7+2INTEL_BENCH, i] = n_gflop / @belapsed fgemm_builtin!($C, $A, $B)
  @assert C ≈ Cblas "Fort builtin gemm wrong?"
  fill!(C, NaN)
  if INTEL_BENCH
    br[8+2INTEL_BENCH, i] = n_gflop / @belapsed ifgemm_builtin!($C, $A, $B)
    @assert C ≈ Cblas "ifort builtin gemm wrong?"
    fill!(C, NaN)
  end
  br[8+3INTEL_BENCH, i] = n_gflop / @belapsed gemmopenblas!($C, $A, $B)
  @assert C ≈ Cblas "OpenBLAS gemm wrong?"
  if MKL_BENCH
    br[9+3INTEL_BENCH, i] = n_gflop / @belapsed gemmmkl!($C, $A, $B)
    @assert C ≈ Cblas "MKL gemm wrong?"
  end
  # br[12,i] = n_gflop / @belapsed gemmavx!($C, $A, $B)
end
function A_mul_B_bench!(br, s, i)
  M, K, N = tothreetuple(s)
  C = Matrix{Float64}(undef, M, N)
  A = rand(M, K)
  B = rand(K, N)
  matmul_bench!(br, C, A, B, i)
end
function A_mul_B_bench!(br, s, i)
  M, K, N = tothreetuple(s)
  C = Matrix{Float64}(undef, M, N)
  A = rand(M, K)
  B = rand(K, N)
  matmul_bench!(br, C, A, B, i)
end
function A_mul_Bt_bench!(br, s, i)
  M, K, N = tothreetuple(s)
  C = Matrix{Float64}(undef, M, N)
  A = rand(M, K)
  B = rand(N, K)'
  matmul_bench!(br, C, A, B, i)
end
function At_mul_B_bench!(br, s, i)
  M, K, N = tothreetuple(s)
  C = Matrix{Float64}(undef, M, N)
  A = rand(K, M)'
  B = rand(K, N)
  matmul_bench!(br, C, A, B, i)
end
function At_mul_Bt_bench!(br, s, i)
  M, K, N = tothreetuple(s)
  C = Matrix{Float64}(undef, M, N)
  A = rand(K, M)'
  B = rand(N, K)'
  matmul_bench!(br, C, A, B, i)
end

function dot_bench!(br, s, i)
  a = rand(s)
  b = rand(s)
  dotblas = dot(a, b)
  n_gflop = s * 2e-9
  br[1, i] = n_gflop / @belapsed jdotavx($a, $b)
  @assert jdotavx(a, b) ≈ dotblas "LoopVec dot wrong?"
  br[2, i] = n_gflop / @belapsed jdot($a, $b)
  @assert jdot(a, b) ≈ dotblas "Julia dot wrong?"
  br[3, i] = n_gflop / @belapsed cdot($a, $b)
  @assert cdot(a, b) ≈ dotblas "Clang dot wrong?"
  br[4, i] = n_gflop / @belapsed fdot($a, $b)
  @assert fdot(a, b) ≈ dotblas "Fort dot wrong?"
  if INTEL_BENCH
    br[5, i] = n_gflop / @belapsed icdot($a, $b)
    @assert icdot(a, b) ≈ dotblas "icc dot wrong?"
    br[6, i] = n_gflop / @belapsed ifdot($a, $b)
    @assert ifdot(a, b) ≈ dotblas "ifort dot wrong?"
  end
  br[5+2INTEL_BENCH, i] = n_gflop / @belapsed edot($a, $b)
  @assert edot(a, b) ≈ dotblas "eigen dot wrong?"
  br[6+2INTEL_BENCH, i] = n_gflop / @belapsed iedot($a, $b)
  @assert iedot(a, b) ≈ dotblas "i-eigen dot wrong?"
  # br[9,i] = n_gflop / @belapsed dot($a, $b)
end
function selfdot_bench!(br, s, i)
  a = rand(s)
  b = rand(s)
  dotblas = dot(a, a)
  n_gflop = s * 2e-9
  br[1, i] = n_gflop / @belapsed jselfdotavx($a)
  @assert jselfdotavx(a) ≈ dotblas "LoopVec dot wrong?"
  br[2, i] = n_gflop / @belapsed jselfdot($a)
  @assert jselfdot(a) ≈ dotblas "Julia dot wrong?"
  br[3, i] = n_gflop / @belapsed cselfdot($a)
  @assert cselfdot(a) ≈ dotblas "Clang dot wrong?"
  br[4, i] = n_gflop / @belapsed fselfdot($a)
  @assert fselfdot(a) ≈ dotblas "Fort dot wrong?"
  if INTEL_BENCH
    br[5, i] = n_gflop / @belapsed icselfdot($a)
    @assert cselfdot(a) ≈ dotblas "icc dot wrong?"
    br[6, i] = n_gflop / @belapsed ifselfdot($a)
    @assert fselfdot(a) ≈ dotblas "ifort dot wrong?"
  end
  br[5+2INTEL_BENCH, i] = n_gflop / @belapsed eselfdot($a)
  @assert eselfdot(a) ≈ dotblas "eigen dot wrong?"
  br[6+2INTEL_BENCH, i] = n_gflop / @belapsed ieselfdot($a)
  @assert ieselfdot(a) ≈ dotblas "i-eigen dot wrong?"
  # br[9,i] = n_gflop / @belapsed dot($a, $a)
end

totwotuple(i::Int) = (i, i)
totwotuple(i::Tuple{Int,Int}) = i
function gemv_bench!(br, x, A, y, i)
  M, N = size(A)
  n_gflop = M * N * 2e-9
  xblas = A * y
  br[1, i] = n_gflop / @belapsed jgemvavx!($x, $A, $y)
  @assert x ≈ xblas "LoopVec wrong?"
  fill!(x, NaN)
  br[2, i] = n_gflop / @belapsed jgemv!($x, $A, $y)
  @assert x ≈ xblas "Julia wrong?"
  fill!(x, NaN)
  br[3, i] = n_gflop / @belapsed cgemv!($x, $A, $y)
  @assert x ≈ xblas "Clang wrong?"
  fill!(x, NaN)
  br[4, i] = n_gflop / @belapsed fgemv!($x, $A, $y)
  @assert x ≈ xblas "Fort wrong?"
  fill!(x, NaN)
  if INTEL_BENCH
    br[5, i] = n_gflop / @belapsed icgemv!($x, $A, $y)
    @assert x ≈ xblas "icc wrong?"
    fill!(x, NaN)
    br[6, i] = n_gflop / @belapsed ifgemv!($x, $A, $y)
    @assert x ≈ xblas "ifort wrong?"
    fill!(x, NaN)
  end
  br[5+2INTEL_BENCH, i] = n_gflop / @belapsed egemv!($x, $A, $y)
  @assert x ≈ xblas "eigen wrong?"
  fill!(x, NaN)
  br[6+2INTEL_BENCH, i] = n_gflop / @belapsed iegemv!($x, $A, $y)
  @assert x ≈ xblas "i-eigen wrong?"
  fill!(x, NaN)
  br[7+2INTEL_BENCH, i] = n_gflop / @belapsed fgemv_builtin!($x, $A, $y)
  @assert x ≈ xblas "Fort wrong?"
  fill!(x, NaN)
  br[8+2INTEL_BENCH, i] = n_gflop / @belapsed ifgemv_builtin!($x, $A, $y)
  @assert x ≈ xblas "ifort wrong?"
  fill!(x, NaN)
  br[9+2INTEL_BENCH, i] = n_gflop / @belapsed dgemvopenblas!($x, $A, $y)
  @assert x ≈ xblas "gemvopenblas wrong?"
  fill!(x, NaN)
  br[10+2INTEL_BENCH, i] = n_gflop / @belapsed dgemvmkl!($x, $A, $y)
  @assert x ≈ xblas "gemvmkl wrong?"
  fill!(x, NaN)
end
function A_mul_vb_bench!(br, s, i)
  M, N = totwotuple(s)
  x = Vector{Float64}(undef, M)
  A = rand(M, N)
  y = rand(N)
  gemv_bench!(br, x, A, y, i)
end
function At_mul_vb_bench!(br, s, i)
  M, N = totwotuple(s)
  x = Vector{Float64}(undef, M)
  A = rand(N, M)'
  y = rand(N)
  gemv_bench!(br, x, A, y, i)
end

function dot3_bench!(br, s, i)
  M, N = totwotuple(s)
  x = rand(M)
  A = rand(M, N)
  y = rand(N)
  dotblas = dot(x, A, y)
  n_gflop = M * N * 3e-9
  br[1, i] = n_gflop / @belapsed jdot3avx($x, $A, $y)
  @assert jdot3avx(x, A, y) ≈ dotblas "LoopVec dot wrong?"
  br[2, i] = n_gflop / @belapsed jdot3($x, $A, $y)
  @assert jdot3(x, A, y) ≈ dotblas "Julia dot wrong?"
  br[3, i] = n_gflop / @belapsed cdot3($x, $A, $y)
  @assert cdot3(x, A, y) ≈ dotblas "Clang dot wrong?"
  br[4, i] = n_gflop / @belapsed fdot3($x, $A, $y)
  @assert fdot3(x, A, y) ≈ dotblas "Fort dot wrong?"
  if INTEL_BENCH
    br[5, i] = n_gflop / @belapsed icdot3($x, $A, $y)
    @assert icdot3(x, A, y) ≈ dotblas "icc dot wrong?"
    br[6, i] = n_gflop / @belapsed ifdot3($x, $A, $y)
    @assert ifdot3(x, A, y) ≈ dotblas "ifort dot wrong?"
  end
  br[5+2INTEL_BENCH, i] = n_gflop / @belapsed edot3($x, $A, $y)
  @assert edot3(x, A, y) ≈ dotblas "eigen dot wrong?"
  br[6+2INTEL_BENCH, i] = n_gflop / @belapsed iedot3($x, $A, $y)
  @assert iedot3(x, A, y) ≈ dotblas "c-eigen dot wrong?"
  br[7+2INTEL_BENCH, i] = n_gflop / @belapsed dot($x, $A, $y)
end
# BLAS.set_num_threads(1)
function sse!(Xβ, y, X, β)
  dgemvmkl!(copyto!(Xβ, y), X, β, 1.0, -1.0)
  jdot(Xβ, Xβ)
end
sse_totwotuple(s::NTuple{2}) = s
sse_totwotuple(s::Integer) = ((3s) >> 1, s >> 1)

function sse_bench!(br, s, i)
  N, P = sse_totwotuple(s)
  y = rand(N)
  β = rand(P)
  X = randn(N, P)
  Xβ = similar(y)
  lpblas = sse!(Xβ, y, X, β)
  n_gflop = 2e-9 * (P * N + 2N)
  br[1, i] = n_gflop / @belapsed jOLSlp_avx($y, $X, $β)
  @assert jOLSlp_avx(y, X, β) ≈ lpblas "LoopVec wrong?"
  br[2, i] = n_gflop / @belapsed jOLSlp($y, $X, $β)
  @assert jOLSlp(y, X, β) ≈ lpblas "Julia wrong?"
  br[3, i] = n_gflop / @belapsed cOLSlp($y, $X, $β)
  @assert cOLSlp(y, X, β) ≈ lpblas "Clang wrong?"
  br[4, i] = n_gflop / @belapsed fOLSlp($y, $X, $β)
  @assert fOLSlp(y, X, β) ≈ lpblas "Fort wrong?"
  if INTEL_BENCH
    br[5, i] = n_gflop / @belapsed icOLSlp($y, $X, $β)
    @assert icOLSlp(y, X, β) ≈ lpblas "icc wrong?"
    br[6, i] = n_gflop / @belapsed ifOLSlp($y, $X, $β)
    @assert ifOLSlp(y, X, β) ≈ lpblas "ifort wrong?"
  end
  br[5+2INTEL_BENCH, i] = n_gflop / @belapsed eOLSlp($y, $X, $β)
  @assert eOLSlp(y, X, β) ≈ lpblas "eigen wrong?"
  br[6+2INTEL_BENCH, i] = n_gflop / @belapsed ieOLSlp($y, $X, $β)
  @assert ieOLSlp(y, X, β) ≈ lpblas "i-eigen wrong?"
  if MKL_BENCH
    br[7+2INTEL_BENCH, i] = n_gflop / @belapsed sse!($Xβ, $y, $X, $β)
    @assert sse!(Xβ, y, X, β) ≈ lpblas "MKL wrong?"
  end
end

function exp_bench!(br, s, i)
  a = rand(s)
  b = similar(a)
  n_gflop = 1e-9 * s # not really gflops
  br[1, i] = n_gflop / @belapsed @turbo @. $b = exp($a)
  baseb = copy(b)
  br[2, i] = n_gflop / @belapsed @. $b = exp($a)
  @assert b ≈ baseb "LoopVec wrong?"
  br[3, i] = n_gflop / @belapsed cvexp!($b, $a)
  @assert b ≈ baseb "Clang wrong?"
  br[4, i] = n_gflop / @belapsed fvexp!($b, $a)
  @assert b ≈ baseb "Fort wrong?"
  if INTEL_BENCH
    br[5, i] = n_gflop / @belapsed icvexp!($b, $a)
    @assert b ≈ baseb "icc wrong?"
    br[6, i] = n_gflop / @belapsed ifvexp!($b, $a)
    @assert b ≈ baseb "ifort wrong?"
  end
end

function aplusBc_bench!(br, s, i)
  M, N = totwotuple(s)
  a = rand(M)
  B = rand(M, N)
  c = rand(N)
  c′ = c'
  D = similar(B)
  n_gflop = 2e-9 * M * N
  br[1, i] = n_gflop / @belapsed @turbo @. $D = $a + $B * $c′
  Dcopy = copy(D)
  fill!(D, NaN)
  br[2, i] = n_gflop / @belapsed @. $D = $a + $B * $c′
  @assert D ≈ Dcopy "LoopVec wrong?"
  br[3, i] = n_gflop / @belapsed caplusBc!($D, $a, $B, $c)
  @assert D ≈ Dcopy "Clang wrong?"
  fill!(D, NaN)
  br[4, i] = n_gflop / @belapsed faplusBc!($D, $a, $B, $c)
  @assert D ≈ Dcopy "Fort wrong?"
  fill!(D, NaN)
  if INTEL_BENCH
    br[5, i] = n_gflop / @belapsed icaplusBc!($D, $a, $B, $c)
    @assert D ≈ Dcopy "icc wrong?"
    fill!(D, NaN)
    br[6, i] = n_gflop / @belapsed ifaplusBc!($D, $a, $B, $c)
    @assert D ≈ Dcopy "ifort wrong?"
    fill!(D, NaN)
  end
  br[7, i] = n_gflop / @belapsed eaplusBc!($D, $a, $B, $c)
  @assert D ≈ Dcopy "eigen wrong?"
  fill!(D, NaN)
  br[8, i] = n_gflop / @belapsed ieaplusBc!($D, $a, $B, $c)
  @assert D ≈ Dcopy "i-eigen wrong?"
  fill!(D, NaN)
end

function AplusAt_bench!(br, s, i)
  A = rand(s, s)
  B = similar(A)
  n_gflop = 1e-9 * s^2
  br[1, i] = n_gflop / @belapsed @turbo @. $B = $A + $A'
  baseB = copy(B)
  fill!(B, NaN)
  br[2, i] = n_gflop / @belapsed @. $B = $A + $A'
  @assert B ≈ baseB "LoopVec wrong?"
  br[3, i] = n_gflop / @belapsed cAplusAt!($B, $A)
  @assert B ≈ baseB "Clang wrong?"
  fill!(B, NaN)
  br[4, i] = n_gflop / @belapsed fAplusAt!($B, $A)
  @assert B ≈ baseB "Fort wrong?"
  fill!(B, NaN)
  if INTEL_BENCH
    br[5, i] = n_gflop / @belapsed icAplusAt!($B, $A)
    @assert B ≈ baseB "icc wrong?"
    fill!(B, NaN)
    br[6, i] = n_gflop / @belapsed ifAplusAt!($B, $A)
    @assert B ≈ baseB "ifort wrong?"
    fill!(B, NaN)
  end
  br[5+2INTEL_BENCH, i] = n_gflop / @belapsed eAplusAt!($B, $A)
  @assert B ≈ baseB "eigen wrong?"
  fill!(B, NaN)
  br[6+2INTEL_BENCH, i] = n_gflop / @belapsed ieAplusAt!($B, $A)
  @assert B ≈ baseB "i-eigen wrong?"
  fill!(B, NaN)
  br[7+2INTEL_BENCH, i] = n_gflop / @belapsed fAplusAt_builtin!($B, $A)
  @assert B ≈ baseB "Fort-builtin wrong?"
  fill!(B, NaN)
  if INTEL_BENCH
    br[8+2INTEL_BENCH, i] = n_gflop / @belapsed ifAplusAt_builtin!($B, $A)
    @assert B ≈ baseB "ifort-builtin wrong?"
    fill!(B, NaN)
  end
end

function randomaccess_bench!(br, s, i)
  A, C = totwotuple(s)
  P = rand(A, C) .+= 0.5
  basis = rand(1:C, A, C)
  coefs = randn(C)
  n_gflop = 1e-9 * (A * C + C)
  p = randomaccess(P, basis, coefs)
  br[1, i] = n_gflop / @belapsed randomaccessavx($P, $basis, $coefs)
  @assert p ≈ randomaccessavx(P, basis, coefs) "LoopVec wrong?"
  br[2, i] = n_gflop / @belapsed randomaccess($P, $basis, $coefs)
  br[3, i] = n_gflop / @belapsed crandomaccess($P, $basis, $coefs)
  @assert p ≈ crandomaccess(P, basis, coefs) "Clang wrong?"
  br[4, i] = n_gflop / @belapsed frandomaccess($P, $basis, $coefs)
  @assert p ≈ frandomaccess(P, basis, coefs) "Fort wrong?"
  if INTEL_BENCH
    br[5, i] = n_gflop / @belapsed icrandomaccess($P, $basis, $coefs)
    @assert p ≈ icrandomaccess(P, basis, coefs) "icc wrong?"
    br[6, i] = n_gflop / @belapsed ifrandomaccess($P, $basis, $coefs)
    @assert p ≈ ifrandomaccess(P, basis, coefs) "ifort wrong?"
  end
end

function logdettriangle_bench!(br, s, i)
  S = randn(s, 2s)
  U = cholesky(Symmetric(S * S')).U
  n_gflop = 1e-9 * s
  ld = logdet(U)
  br[1, i] = n_gflop / @belapsed jlogdettriangleavx($U)
  @assert ld ≈ jlogdettriangleavx(U) "LoopVec wrong?"
  br[2, i] = n_gflop / @belapsed jlogdettriangle($U)
  @assert ld ≈ jlogdettriangle(U) "Julia wrong?"
  br[3, i] = n_gflop / @belapsed clogdettriangle($U)
  @assert ld ≈ clogdettriangle(U) "Clang wrong?"
  br[4, i] = n_gflop / @belapsed flogdettriangle($U)
  @assert ld ≈ flogdettriangle(U) "Fort wrong?"
  if INTEL_BENCH
    br[5, i] = n_gflop / @belapsed iclogdettriangle($U)
    @assert ld ≈ iclogdettriangle(U) "icc wrong?"
    br[6, i] = n_gflop / @belapsed iflogdettriangle($U)
    @assert ld ≈ iflogdettriangle(U) "ifort wrong?"
  end
  # br[7,i] = n_gflop / @belapsed elogdettriangle($U)
  # @assert ld ≈ elogdettriangle(U) "eigen wrong?"; fill!(B, NaN);
  # br[8,i] = n_gflop / @belapsed ielogdettriangle($U)
  # @assert ld ≈ ielogdettriangle(U) "i-eigen wrong?"; fill!(B, NaN);
  br[5+2INTEL_BENCH, i] = n_gflop / @belapsed logdet($U)
end

function filter2d_bench_run!(br, s, i, K)
  A = rand(s + 2, s + 2)
  B = OffsetArray(similar(A, (s, s)), 1, 1)
  Mk, Nk = size(K)
  n_gflop = 1e-9 * (2Mk * Nk - 1) * s^2
  br[1, i] = n_gflop / @belapsed filter2davx!($B, $A, $K)
  Bcopy = copy(B)
  fill!(B, NaN)
  br[2, i] = n_gflop / @belapsed filter2d!($B, $A, $K)
  @assert B ≈ Bcopy "LoopVec wrong?"
  br[3, i] = n_gflop / @belapsed cfilter2d!($B, $A, $K)
  @assert B ≈ Bcopy "Clang wrong?"
  br[4, i] = n_gflop / @belapsed ffilter2d!($B, $A, $K)
  @assert B ≈ Bcopy "Fort wrong?"
  if INTEL_BENCH
    br[5, i] = n_gflop / @belapsed icfilter2d!($B, $A, $K)
    @assert B ≈ Bcopy "icc wrong?"
    br[6, i] = n_gflop / @belapsed iffilter2d!($B, $A, $K)
    @assert B ≈ Bcopy "ifort wrong?"
  end
end

function filter2dunrolled_bench_run!(br, s, i, K)
  A = rand(s + 2, s + 2)
  B = OffsetArray(similar(A, (s, s)), 1, 1)
  Mk, Nk = size(K)
  n_gflop = 1e-9 * (2Mk * Nk - 1) * s^2
  br[1, i] = n_gflop / @belapsed filter2dunrolledavx!($B, $A, $K)
  Bcopy = copy(B)
  fill!(B, NaN)
  br[2, i] = n_gflop / @belapsed filter2dunrolled!($B, $A, $K)
  @assert B ≈ Bcopy "LoopVec wrong?"
  br[3, i] = n_gflop / @belapsed cfilter2dunrolled!($B, $A, $K)
  @assert B ≈ Bcopy "Clang wrong?"
  br[4, i] = n_gflop / @belapsed ffilter2dunrolled!($B, $A, $K)
  @assert B ≈ Bcopy "Fort wrong?"
  if INTEL_BENCH
    br[5, i] = n_gflop / @belapsed icfilter2dunrolled!($B, $A, $K)
    @assert B ≈ Bcopy "icc wrong?"
    br[6, i] = n_gflop / @belapsed iffilter2dunrolled!($B, $A, $K)
    @assert B ≈ Bcopy "ifort wrong?"
  end
end

using Documenter, LoopVectorization

makedocs(;
  modules = [LoopVectorization],
  format = Documenter.HTML(; prettyurls = get(ENV, "CI", nothing) == "true"),
  pages = [
    "Home" => "index.md",
    "Getting Started" => "getting_started.md",
    "Examples" => [
      "examples/multithreading.md",
      "examples/matrix_multiplication.md",
      "examples/array_interface.md",
      "examples/matrix_vector_ops.md",
      "examples/dot_product.md",
      "examples/datetime_arrays.md",
      "examples/special_functions.md",
      "examples/sum_of_squared_error.md",
      "examples/filtering.md"
    ],
    "Vectorized Convenience Functions" => "vectorized_convenience_functions.md",
    "Future Work" => "future_work.md",
    "API reference" => "api.md",
    "Developer Documentation" => [
      "devdocs/overview.md",
      "devdocs/loopset_structure.md",
      "devdocs/constructing_loopsets.md",
      "devdocs/evaluating_loops.md",
      "devdocs/lowering.md",
      "devdocs/reference.md"
    ]
  ],
  # repo="https://github.com/JuliaSIMD/LoopVectorization.jl/blob/{commit}{path}#L{line}",
  sitename = "LoopVectorization.jl",
  authors = "Chris Elrod",
  checkdocs=:exports,
  # assets=[],
)

deploydocs(; repo = "github.com/JuliaSIMD/LoopVectorization.jl")

using VectorizationBase, LoopVectorization
using VectorizationBase: data

# @generated to use VectorizationBase's API for supporting 1.5 and 1.6+
@generated function readcyclecounter()
  decl = "declare i64 @llvm.readcyclecounter()"
  instr = "%res = call i64 @llvm.readcyclecounter()\nret i64 %res"
  VectorizationBase.llvmcall_expr(
    decl,
    instr,
    :Int64,
    :(Tuple{}),
    "i64",
    String[],
    Symbol[]
  )
end

@generated function volatile(x::Vec{W,T}) where {W,T}
  typ = VectorizationBase.LLVM_TYPES[T]
  vtyp = "<$W x $typ>"

  suffix = T == Float32 ? "ps" : "pd"
  sideeffect_str = """%res = call <$W x $(typ)> asm sideeffect "", "=v,v"(<$W x $(typ)> %0)
                             ret <$W x $(typ)> %res"""
  quote
    $(Expr(:meta, :inline))
    Vec(
      Base.llvmcall(
        $sideeffect_str,
        NTuple{$W,Core.VecElement{$T}},
        Tuple{NTuple{$W,Core.VecElement{$T}}},
        VectorizationBase.data(x)
      )
    )
  end
end
@inline volatile(x::VecUnroll) =
  VecUnroll(VectorizationBase.fmap(volatile, data(x)))
@inline volatile(x::Tuple) = map(volatile, x)
# @generated function volatile(x::Vec{W,T}, x::Vec{W,T}) where {W,T}
#     typ = VectorizationBase.LLVM_TYPES[T]
#     vtyp = "<$W x $typ>"

#     suffix = T == Float32 ? "ps" : "pd"
#     sideeffect_str = """%res = call <$W x $(typ)> asm sideeffect "", "=v,v"(<$W x $(typ)> %0, <$W x $(typ)> %1)
#                                ret <$W x $(typ)> %res"""
#     quote
#         $(Expr(:meta, :inline))
#         Vec(Base.llvmcall($sideeffect_str, NTuple{$W,Core.VecElement{$T}}, Tuple{NTuple{$W,Core.VecElement{$T}}}, VectorizationBase.data(x)))
#     end
# end

num_vectors(::VecUnroll{N}) where {N} = N + 1
num_vectors(::Vec) = 1
function unrolltest(f::F, vs::Vararg{Any,K}) where {F,K}
  cc = readcyclecounter()
  # num_iter = 1_048_576
  num_iter = 4_194_304
  for i ∈ 1:num_iter
    volatile(f(map(volatile, vs)...))
  end
  cycles = readcyclecounter() - cc
  cycles / (num_vectors(first(vs)) * num_iter)
end

# @generated function vapply!(f::F, y, x, ::Val{U}) where {F,U}
#     quote
#         @turbo unroll=$U for j ∈ 1:1024
#             y[j] = f(x[j])
#         end
#     end
# end

# vector_init(::Val{N}, ::Type{T}) where {N,T} = VectorizationBase.zero_vecunroll(StaticInt(N), pick_vector_width(T), T, VectorizationBase.register_size())
# vector_init(::Val{1}, ::Type{T}) where {T} = VectorizationBase.vzero(pick_vector_width(T), T)

# @generated function unrolltest(f::F, x::AbstractVector{T}, ::Val{U}) where {F,U,T}
#     quote
#         cc = readcyclecounter()
#         for i ∈ 1:8192
#             s = vector_init(Val{$U}(), $T)
#             @turbo unroll=$U for j ∈ 1:512
#                 s += f(x[j])
#             end
#             volatile(s)
#         end
#         cycles = readcyclecounter() - cc
#         pick_vector_width(T) * cycles / (512 * 8192)
#     end
# end

# @generated function unrolltest!(f::F, y::AbstractVector{T}, x::AbstractVector{T}, ::Val{U}) where {F,U,T}
#     quote
#         cc = readcyclecounter()
#         for i ∈ 1:8192
#             @turbo unroll=$U for j ∈ 1:512
#                 y[j] = f(x[j])
#             end
#         end
#         cycles = readcyclecounter() - cc
#         pick_vector_width(T) * cycles / (512 * 8192)
#     end
# end

let
  vx = Vec(ntuple(_ -> 10randn(), pick_vector_width(Float64))...)
  vu2 = VectorizationBase.VecUnroll(
    ntuple(
      _ -> Vec(ntuple(_ -> 10randn(), pick_vector_width(Float64))...),
      Val(2)
    )
  )
  vu4 = VectorizationBase.VecUnroll(
    ntuple(
      _ -> Vec(ntuple(_ -> 10randn(), pick_vector_width(Float64))...),
      Val(4)
    )
  )
  vu8 = VectorizationBase.VecUnroll(
    ntuple(
      _ -> Vec(ntuple(_ -> 10randn(), pick_vector_width(Float64))...),
      Val(8)
    )
  )
  for unaryf ∈ [log, log2, log10, log1p, exp, exp2, exp10, expm1, sin, cos]
    rt1 = unrolltest(f, vx)
    rt2 = unrolltest(f, vu2)
    rt4 = unrolltest(f, vu4)
    rt8 = unrolltest(f, vu8)
  end
  for binaryf ∈ [+, *, ^]
    rt1 = unrolltest(f, vx, vx)
    rt2 = unrolltest(f, vu2, vu2)
    rt4 = unrolltest(f, vu4, vu4)
    rt8 = unrolltest(f, vu8, vu8)
  end
end

let
  f, io = mktemp()
  W = Int(VectorizationBase.pick_vector_width(Float64))
  code_native(
    io,
    exp,
    (VecUnroll{1,W,Float64,Vec{W,Float64}},);
    debuginfo = :none
  )
  close(io)
  run(
    `llvm-mca -mcpu=$(Sys.CPU_NAME) -output-asm-variant=1 -bottleneck-analysis $f`
  )
end

using LoopVectorization, Random, Test
T = Float32

@testset "ifelse (masks)" begin

  function promote_bool_store!(z, x, y)
    for i ∈ eachindex(x)
      z[i] = (x[i] * x[i] + y[i] * y[i]) < 1
    end
    z
  end
  function promote_bool_storeavx!(z, x, y)
    @turbo for i ∈ eachindex(x)
      z[i] = (x[i] * x[i] + y[i] * y[i]) < 1
    end
    z
  end
  function promote_bool_store_avx!(z, x, y)
    @_avx for i ∈ eachindex(x)
      z[i] = (x[i] * x[i] + y[i] * y[i]) < 1
    end
    z
  end
  # @macroexpand @_avx for i ∈ eachindex(x)
  # z[i] = (x[i]*x[i] + y[i]*y[i]) < 1
  # end
  function promote_bool_storeavx2!(z, x, y)
    @turbo for i ∈ eachindex(x)
      z[i] = (x[i] * x[i] + y[i] * y[i]) < 1 ? 1 : 0
    end
    z
  end
  function promote_bool_store_avx2!(z, x, y)
    @_avx for i ∈ eachindex(x)
      z[i] = (x[i] * x[i] + y[i] * y[i]) < 1 ? 1 : 0
    end
    z
  end

  function Bernoulli_logit(y, α::AbstractVector{T}) where {T}
    t = zero(promote_type(Float64, T))
    @inbounds for i ∈ eachindex(α)
      invOmP = 1 + exp(α[i])
      nlogOmP = log(invOmP)
      nlogP = nlogOmP - α[i]
      t -= y[i] ? nlogP : nlogOmP
    end
    t
  end
  function Bernoulli_logitavx(y, α::AbstractVector{T}) where {T}
    t = zero(T === Int32 ? Float32 : Float64)
    @turbo for i ∈ eachindex(α)
      invOmP = 1 + exp(α[i])
      nlogOmP = log(invOmP)
      nlogP = nlogOmP - α[i]
      t -= y[i] ? nlogP : nlogOmP
    end
    t
  end
  function Bernoulli_logit_avx(y, α::AbstractVector{T}) where {T}
    t = zero(T === Int32 ? Float32 : Float64)
    @_avx for i ∈ eachindex(α)
      invOmP = 1 + exp(α[i])
      nlogOmP = log(invOmP)
      nlogP = nlogOmP - α[i]
      t -= y[i] ? nlogP : nlogOmP
    end
    t
  end

  function addormul!(c, a, b)
    for i ∈ eachindex(c, a, b)
      c[i] = a[i] > b[i] ? a[i] + b[i] : a[i] * b[i]
    end
  end
  function addormul_avx!(c, a, b)
    @_avx for i ∈ eachindex(c, a, b)
      c[i] = a[i] > b[i] ? a[i] + b[i] : a[i] * b[i]
    end
  end
  function addormulavx!(c, a, b)
    @turbo for i ∈ eachindex(c, a, b)
      c[i] = if a[i] > b[i]
        a[i] + b[i]
      else
        a[i] * b[i]
      end
    end
  end
  function addormulp1!(c, a, b)
    for i ∈ eachindex(c, a, b)
      c[i] = 1 + (a[i] > b[i] ? a[i] + b[i] : a[i] * b[i])
    end
  end
  function addormulp1_avx!(c, a, b)
    @_avx for i ∈ eachindex(c, a, b)
      c[i] = 1 + (a[i] > b[i] ? a[i] + b[i] : a[i] * b[i])
    end
  end
  function addormulp1avx!(c, a, b)
    @turbo for i ∈ eachindex(c, a, b)
      a_greater_than_b = a[i] > b[i]
      c[i] = 1 + (a_greater_than_b ? a[i] + b[i] : a[i] * b[i])
    end
  end
  function addifelsemul_avx!(c, a, b)
    @_avx for i ∈ eachindex(c, a, b)
      c[i] = ifelse(a[i] > b[i], a[i] + b[i], a[i] * b[i])
    end
  end
  function addifelsemulavx!(c, a, b)
    @turbo for i ∈ eachindex(c, a, b)
      c[i] = ifelse(a[i] > b[i], a[i] + b[i], a[i] * b[i])
    end
  end
  function addifelsemulp1_avx!(c, a, b)
    @_avx for i ∈ eachindex(c, a, b)
      c[i] = 1 + ifelse(a[i] > b[i], a[i] + b[i], a[i] * b[i])
    end
  end
  function addifelsemulp1avx!(c, a, b)
    @turbo for i ∈ eachindex(c, a, b)
      c[i] = 1 + ifelse(a[i] > b[i], a[i] + b[i], a[i] * b[i])
    end
  end
  function ifelseoverwrite!(p)
    for i ∈ eachindex(p)
      p[i] = p[i] < 0.5 ? p[i]^2 : p[i]^3
    end
  end
  function ifelseoverwriteavx!(p)
    @turbo for i ∈ eachindex(p)
      p[i] = p[i] < 0.5 ? p[i]^2 : p[i]^3
    end
  end



  function maybewriteand!(c, a, b)
    @inbounds for i ∈ eachindex(c, a, b)
      a[i] > b[i] && (c[i] = a[i] + b[i])
    end
  end
  function maybewriteand_avx!(c, a, b)
    @_avx for i ∈ eachindex(c, a, b)
      a[i] > b[i] && (c[i] = a[i] + b[i])
    end
  end
  function maybewriteandavx!(c, a, b)
    @turbo for i ∈ eachindex(c, a, b)
      a[i] > b[i] && (c[i] = a[i] + b[i])
    end
  end
  function maybewriteor!(c, a, b)
    @inbounds for i ∈ eachindex(c, a, b)
      a[i] > b[i] || (c[i] = a[i]^b[i])
    end
  end
  function maybewriteor_avx!(c, a, b)
    @_avx for i ∈ eachindex(c, a, b)
      a[i] > b[i] || (c[i] = a[i]^b[i])
    end
  end
  function maybewriteoravx!(c, a, b)
    @turbo for i ∈ eachindex(c, a, b)
      a[i] > b[i] || (c[i] = a[i]^b[i])
    end
  end
  function maybewriteor!(c::AbstractVector{<:Integer}, a, b)
    @inbounds for i ∈ eachindex(c, a, b)
      a[i] > b[i] || (c[i] = a[i] & b[i])
    end
  end
  function maybewriteor_avx!(c::AbstractVector{<:Integer}, a, b)
    @_avx for i ∈ eachindex(c, a, b)
      a[i] > b[i] || (c[i] = a[i] & b[i])
    end
  end
  function maybewriteoravx!(c::AbstractVector{<:Integer}, a, b)
    @turbo for i ∈ eachindex(c, a, b)
      a[i] > b[i] || (c[i] = a[i] & b[i])
    end
  end

  function notacondload!(C, A, b)
    @inbounds for n ∈ 1:size(C, 2), m ∈ 1:size(C, 1)
      C[m, n] = A[m, n] * (b[n] > 0 ? b[n] : -b[n])
    end
  end
  function notacondloadavx!(C, A, b)
    @turbo for n ∈ 1:size(C, 2), m ∈ 1:size(C, 1)
      C[m, n] = A[m, n] * (b[n] > 0 ? b[n] : -b[n])
    end
  end
  function condloadscalar!(C, A, c, b)
    @inbounds for n ∈ 1:size(C, 2), m ∈ 1:size(C, 1)
      C[m, n] = A[m, n] * (c[n] > 0 ? b[n] : 1) + c[n]
    end
  end
  function condloadscalaravx!(C, A, c, b)
    @turbo for n ∈ 1:size(C, 2), m ∈ 1:size(C, 1)
      C[m, n] = A[m, n] * (c[n] > 0 ? b[n] : 1) + c[n]
    end
  end
  function maskedloadscalar!(C, A, b)
    @inbounds for n ∈ 1:size(C, 2), m ∈ 1:size(C, 1)
      C[m, n] = A[m, n] * (A[m, n] > 0 ? b[n] : 1)
    end
  end
  function maskedloadscalaravx!(C, A, b)
    @turbo for n ∈ 1:size(C, 2), m ∈ 1:size(C, 1)
      C[m, n] = A[m, n] * (A[m, n] > 0 ? b[n] : 1)
    end
  end
  function AtmulBpos!(C, A, B)
    @inbounds for n ∈ 1:size(C, 2), m ∈ 1:size(C, 1)
      Cₘₙ = zero(eltype(C))
      @simd ivdep for k ∈ 1:size(A, 1)
        Cₘₙ += A[k, m] * B[k, n]
      end
      C[m, n] > 0 && (C[m, n] = Cₘₙ)
    end
  end
  function AtmulBposavx!(C, A, B)
    @turbo for n ∈ 1:size(C, 2), m ∈ 1:size(C, 1)
      Cₘₙ = zero(eltype(C))
      for k ∈ 1:size(A, 1)
        Cₘₙ += A[k, m] * B[k, n]
      end
      C[m, n] > 0 && (C[m, n] = Cₘₙ)
    end
  end
  function AtmulBpos_avx!(C, A, B)
    @_avx for n ∈ 1:size(C, 2), m ∈ 1:size(C, 1)
      Cₘₙ = zero(eltype(C))
      for k ∈ 1:size(A, 1)
        Cₘₙ += A[k, m] * B[k, n]
      end
      C[m, n] > 0 && (C[m, n] = Cₘₙ)
    end
  end
  function condstore!(x)
    @inbounds for i ∈ eachindex(x)
      x1 = 2 * x[i] - 100
      x2 = x1 * x1
      x3 = x2 + x1
      x4 = x3
      x[i] = x1
      (x1 < -50) && (x[i] = x2)
      (x1 < 60) || (x[i] = x4)
    end
  end
  function condstore1avx!(x)
    @turbo for i ∈ eachindex(x)
      x1 = 2 * x[i] - 100
      x2 = x1 * x1
      x3 = x2 + x1
      x[i] = x1
      (x1 < -50) && (x[i] = x2)
      (x1 < 60) || (x[i] = x3)
    end
  end
  function condstore1_avx!(x)
    @_avx for i ∈ eachindex(x)
      x1 = 2 * x[i] - 100
      x2 = x1 * x1
      x3 = x2 + x1
      x[i] = x1
      (x1 < -50) && (x[i] = x2)
      (x1 < 60) || (x[i] = x3)
    end
  end
  function condstore2avx!(x)
    @turbo for i ∈ eachindex(x)
      x1 = 2 * getindex(x, i) - 100
      x2 = x1 * x1
      x3 = x2 + x1
      setindex!(x, x1, i)
      (x1 < -50) && setindex!(x, x2, i)
      (x1 < 60) || setindex!(x, x3, i)
    end
  end
  function condstore2_avx!(x)
    @_avx for i ∈ eachindex(x)
      x1 = 2 * getindex(x, i) - 100
      x2 = x1 * x1
      x3 = x2 + x1
      setindex!(x, x1, i)
      (x1 < -50) && setindex!(x, x2, i)
      (x1 < 60) || setindex!(x, x3, i)
    end
  end
  function andorassignment!(x, y, z)
    @inbounds for i ∈ eachindex(x, y, z)
      yᵢ = y[i]
      zᵢ = z[i]
      (yᵢ > 0.5) || (yᵢ *= 2)
      (zᵢ < 0.5) && (zᵢ *= 2)
      x[i] = yᵢ * zᵢ
    end
  end
  function andorassignmentavx!(x, y, z)
    @turbo for i ∈ eachindex(x, y, z)
      yᵢ = y[i]
      zᵢ = z[i]
      (yᵢ > 0.5) || (yᵢ *= 2)
      (zᵢ < 0.5) && (zᵢ *= 2)
      x[i] = yᵢ * zᵢ
    end
  end
  function andorassignment_avx!(x, y, z)
    @turbo for i ∈ eachindex(x, y, z)
      yᵢ = y[i]
      zᵢ = z[i]
      (yᵢ > 0.5) || (yᵢ *= 2)
      (zᵢ < 0.5) && (zᵢ *= 2)
      x[i] = yᵢ * zᵢ
    end
  end

  function twoifelses!(res, half, m, keep = nothing, final = true)
    local 𝒶𝓍j = axes(half, 1)
    for j in 𝒶𝓍j
      𝓇𝒽𝓈 = if isnothing(keep)
        log(half[j]) + m[j]
      else
        res[j] + (log(half[j]) + m[j])
      end
      res[j] = isnothing(final) ? 𝓇𝒽𝓈 : exp(𝓇𝒽𝓈)
    end
    res
  end
  function twoifelses_avx!(res, half, m, keep = nothing, final = true)
    local 𝒶𝓍j = axes(half, 1)
    @turbo for j in 𝒶𝓍j
      𝓇𝒽𝓈 = if isnothing(keep)
        log(half[j]) + m[j]
      else
        res[j] + (log(half[j]) + m[j])
      end
      res[j] = if isnothing(final)
        𝓇𝒽𝓈
      else
        exp(𝓇𝒽𝓈)
      end
    end
    res
  end
  function testfunction!(f::Matrix{<:AbstractFloat}, v, d, g, s, θ)
    @inbounds @simd for j = 1:size(f, 1)
      x = v[j, s] + v[j, d] - v[j, g] + f[j, g] + θ
      _x = ifelse(isnan(x), typemin(eltype(f)), x)
      f[j, d] = _x
    end
  end
  function testfunctionavx!(f::Matrix{<:AbstractFloat}, v, d, g, s, θ)
    @turbo for j = 1:size(f, 1)
      x = v[j, s] + v[j, d] - v[j, g] + f[j, g] + θ
      _x = ifelse(isnan(x), typemin(eltype(f)), x)
      f[j, d] = _x
    end
  end

  chebpts(m) = (n = m - 1; [cos(k * pi / n) for k = 0:n])
  function barycentric_weight0(X)
    local T = eltype(X)
    local n = length(X) - 1
    local w = zero(X)
    @inbounds @fastmath for j = 0:n
      tmp = one(T)
      for k = 0:n
        tmp = k == j ? tmp : tmp * (X[j+1] - X[k+1])
      end
      w[j+1] = inv(tmp)
    end
    return w
  end
  function barycentric_weight1(X)
    local T = eltype(X)
    local n = length(X) - 1
    local w = zero(X)
    @turbo for j = 0:n
      tmp = one(T)
      for k = 0:n
        tmp = k != j ? tmp * (X[j+1] - X[k+1]) : tmp
      end
      w[j+1] = inv(tmp)
    end
    return w
  end
  function barycentric_weight2(X)
    local T = eltype(X)
    local n = length(X) - 1
    local w = zero(X)
    @turbo inline = true for j = 0:n
      tmp = one(T)
      for k = 0:n
        tmp = k == j ? tmp : tmp * (X[j+1] - X[k+1])
      end
      w[j+1] = inv(tmp)
    end
    return w
  end
  function barycentric_weight3(X)
    local T = eltype(X)
    local n = length(X) - 1
    local w = zero(X)
    @turbo inline = true for j = 0:n
      tmp = one(T)
      for k = 0:n
        tmp = ifelse(k != j, tmp * (X[j+1] - X[k+1]), tmp)
      end
      w[j+1] = inv(tmp)
    end
    return w
  end
  function barycentric_weight4(X)
    local T = eltype(X)
    local n = length(X) - 1
    local w = zero(X)
    @turbo for j = 0:n
      tmp = one(T)
      for k = 0:n
        tmp = ifelse(k == j, tmp, tmp * (X[j+1] - X[k+1]))
      end
      w[j+1] = inv(tmp)
    end
    return w
  end


  function mwe_v(dest, src, lut)
    # for i in eachindex(src)
    LoopVectorization.@turbo for i in eachindex(src)
      v = src[i]
      s = 128
      s2 = s | 64
      s = ifelse(lut[s2] <= v, s2, s)
      s2 = s | 32
      s = ifelse(lut[s2] <= v, s2, s)
      dest[i] = s
    end
    return dest
  end

  function mwe_s(dest, src, lut)
    for i in eachindex(src)
      # LoopVectorization.@turbo for i in eachindex(src)
      v = src[i]
      s = 128
      s2 = s | 64
      s = ifelse(lut[s2] <= v, s2, s)
      s2 = s | 32
      s = ifelse(lut[s2] <= v, s2, s)
      dest[i] = s
    end
    return dest
  end

  function turbocomparison!(m)
    @turbo for i in eachindex(m)
      m[i] = ifelse(0 < m[i] < 0.5, 0.0, m[i])
    end
  end
  function turbocomparison!(m, y)
    @turbo for i in eachindex(m)
      m[i] = ifelse(0 < m[i] < y[i] < 0.5, 0.0, m[i])
    end
  end

  function absmax_tturbo(a) # LV threaded
    local result = zero(eltype(a))
    @tturbo for i = 1:length(a)
      abs(a[i]) > result && (result = abs(a[i]))
    end
    result
  end

  function findminturbo(x)
    local indmin = 0
    local minval = typemax(eltype(x))
    @turbo for i ∈ eachindex(x)
      newmin = x[i] < minval
      minval = newmin ? x[i] : minval
      indmin = newmin ? i : indmin
    end
    minval, indmin
  end
  function findmintturbo(x)
    local indmin = 0
    local minval = typemax(eltype(x))
    @tturbo for i ∈ eachindex(x)
      newmin = x[i] < minval
      minval = newmin ? x[i] : minval
      indmin = newmin ? i : indmin
    end
    minval, indmin
  end
  function findminturbo_u4(x)
    local indmin = 0
    local minval = typemax(eltype(x))
    @turbo unroll = 4 for i ∈ eachindex(x)
      newmin = x[i] < minval
      minval = newmin ? x[i] : minval
      indmin = newmin ? i : indmin
    end
    minval, indmin
  end
  function extrema_turbo(x)
    local a = first(x)
    local b = a
    @turbo for i in eachindex(x)
      local e = x[i]
      b = max(b, e)
      a = min(a, e)
    end
    a, b
  end

  N = 117
  for T ∈ (Float32, Float64, Int32, Int64)
    @show T, @__LINE__
    if T <: Integer
      a = rand(-T(100):T(100), N)
      b = rand(-T(100):T(100), N)
      mv, mi = findminturbo(a)
      mv2, mi2 = findminturbo_u4(a)
      @test mv == a[mi] == minimum(a) == mv2 == a[mi2]
      for n = 1000:1000:10_000
        x = rand(-T(100):T(100), n)
        @test absmax_tturbo(x) == mapreduce(abs, max, x)
        mv, mi = findmintturbo(x)
        @test mv == x[mi] == minimum(x)
      end
    else
      a = rand(T, N)
      b = rand(T, N)
      @test findmin(a) == findminturbo(a) == findminturbo_u4(a)
      for n = 1000:1000:10_000
        x = randn(T, n)
        @test absmax_tturbo(x) == mapreduce(abs, max, x)
        mv, mi = findmintturbo(x)
        @test mv == x[mi] == minimum(x)
      end
    end
    c1 = similar(a)
    c2 = similar(a)

    @test extrema(a) == extrema_turbo(a)
    promote_bool_store!(c1, a, b)
    promote_bool_storeavx!(c2, a, b)
    @test c1 == c2
    fill!(c2, -999999999)
    promote_bool_store_avx!(c2, a, b)
    @test c1 == c2
    fill!(c2, -999999999)
    promote_bool_storeavx2!(c2, a, b)
    @test c1 == c2
    fill!(c2, -999999999)
    promote_bool_store_avx2!(c2, a, b)
    @test c1 == c2

    fill!(c1, 999999999)
    addormul!(c1, a, b)
    fill!(c2, -999999999)
    addormul_avx!(c2, a, b)
    @test c1 ≈ c2
    fill!(c2, -999999999)
    addormulavx!(c2, a, b)
    @test c1 ≈ c2
    fill!(c2, -999999999)
    addifelsemul_avx!(c2, a, b)
    @test c1 ≈ c2
    fill!(c2, -999999999)
    addifelsemulavx!(c2, a, b)
    @test c1 ≈ c2
    addormulp1!(c1, a, b)
    addormulp1_avx!(c2, a, b)
    @test c1 ≈ c2
    fill!(c2, -999999999)
    addormulp1avx!(c2, a, b)
    @test c1 ≈ c2
    fill!(c2, -999999999)
    addifelsemulp1_avx!(c2, a, b)
    @test c1 ≈ c2
    fill!(c2, -999999999)
    addifelsemulp1avx!(c2, a, b)
    @test c1 ≈ c2

    fill!(c1, -999999999)
    maybewriteand!(c1, a, b)
    fill!(c2, -999999999)
    maybewriteand_avx!(c2, a, b)
    @test c1 ≈ c2
    fill!(c2, -999999999)
    maybewriteandavx!(c2, a, b)
    @test c1 ≈ c2

    fill!(c1, -999999999)
    maybewriteor!(c1, a, b)
    fill!(c2, -999999999)
    maybewriteor_avx!(c2, a, b)
    @test c1 ≈ c2
    fill!(c2, -999999999)
    maybewriteoravx!(c2, a, b)
    @test c1 ≈ c2

    andorassignment!(c1, a, b)
    andorassignmentavx!(c2, a, b)
    @test c1 ≈ c2
    fill!(c2, -999999999)
    andorassignment_avx!(c2, a, b)
    @test c1 ≈ c2

    a1 = copy(a)
    a2 = copy(a)
    ifelseoverwrite!(a1)
    ifelseoverwriteavx!(a2)
    @test a1 ≈ a2

    if T <: Union{Float32,Float64}
      a .*= 100
    end
    b1 = copy(a)
    b2 = copy(a)
    condstore!(b1)
    condstore1avx!(b2)
    @test b1 == b2
    copyto!(b2, a)
    condstore1_avx!(b2)
    @test b1 == b2
    copyto!(b2, a)
    condstore2avx!(b2)
    @test b1 == b2
    copyto!(b2, a)
    condstore2_avx!(b2)
    @test b1 == b2

    M, K, N = 83, 85, 79
    if T <: Integer
      A = rand(T(-100):T(100), K, M)
      B = rand(T(-100):T(100), K, N)
      C1 = rand(T(-100):T(100), M, N)
      b = rand(T(-100):T(100), N)
      d = rand(T(-100):T(100), N)
    else
      A = randn(T, K, M)
      B = randn(T, K, N)
      C1 = randn(T, M, N)
      b = randn(T, N)
      d = randn(T, N)
    end
    C2 = copy(C1)
    C3 = copy(C1)
    AtmulBpos!(C1, A, B)
    AtmulBposavx!(C2, A, B)
    AtmulBpos_avx!(C3, A, B)
    @test C1 ≈ C2
    @test C1 ≈ C3
    C1 = similar(B)
    C2 = similar(B)
    notacondload!(C1, B, b)
    notacondloadavx!(C2, B, b)
    @test C1 ≈ C2
    maskedloadscalar!(C1, B, b)
    maskedloadscalaravx!(C2, B, b)
    @test C1 ≈ C2
    condloadscalar!(C1, B, b, d)
    condloadscalaravx!(C2, B, b, d)
    @test C1 ≈ C2

    if T <: Integer
      half = rand(T(1):T(100), 7)
      m = rand(T(-10):T(10), 7)
    else
      half = rand(T, 7)
      m = rand(T, 7)
    end
    if sizeof(T) == 4
      res1 = Vector{Float32}(undef, 7)
      res2 = Vector{Float32}(undef, 7)
    else
      res1 = Vector{Float64}(undef, 7)
      res2 = Vector{Float64}(undef, 7)
    end

    for keep ∈ (nothing, true), final ∈ (nothing, true)
      @test twoifelses!(res1, half, m) ≈ twoifelses_avx!(res2, half, m)
    end

  end


  a = rand(-10:10, 43)
  bit = a .> 0.5
  bool = copyto!(Vector{Bool}(undef, length(bit)), bit)
  t = Bernoulli_logit(bit, a)
  @test isapprox(t, Bernoulli_logitavx(bit, a), atol = ifelse(Int === Int32, 0.1, 0.0))
  if LoopVectorization.pick_vector_width(eltype(a)) ≥ 4
    # @_avx isn't really expected to work with bits if you don't have AVX512
    # but it happens to work with AVX2 for this anyway, so may as well keep testing.
    # am ruling out non-avx2 with the `VectorizationBase.pick_vector_width(eltype(a)) ≥ 4` check
    @test isapprox(t, Bernoulli_logit_avx(bit, a), atol = ifelse(Int === Int32, 0.1, 0.0))
  end
  @test isapprox(t, Bernoulli_logitavx(bool, a), atol = ifelse(Int === Int32, 0.1, 0.0))
  @test isapprox(t, Bernoulli_logit_avx(bool, a), atol = ifelse(Int === Int32, 0.1, 0.0))
  a = rand(43)
  bit = a .> 0.5
  bool = copyto!(Vector{Bool}(undef, length(bit)), bit)
  t = Bernoulli_logit(bit, a)
  @test t ≈ Bernoulli_logitavx(bit, a)
  @test t ≈ Bernoulli_logit_avx(bit, a)
  @test t ≈ Bernoulli_logitavx(bool, a)
  @test t ≈ Bernoulli_logit_avx(bool, a)

  ai = [rand(Bool) for _ = 1:71]
  bi = [rand(Bool) for _ = 1:71]
  # if LoopVectorization.VectorizationBase.AVX2 || Base.libllvm_version ≥ v"8" #FIXME Why doesn't this work on Travis Ivy Bridge Julia 1.1?
  @test (ai .& bi) == (@turbo ai .& bi)
  @test (ai .| bi) == (@turbo ai .| bi)
  @test (ai .⊻ bi) == (@turbo ai .⊻ bi)
  # else
  #     @test_broken (ai .& bi) == (@turbo ai .& bi)
  #     @test_broken (ai .| bi) == (@turbo ai .| bi)
  #     @test_broken (ai .⊻ bi) == (@turbo ai .⊻ bi)
  # end
  a = bitrand(127)
  b = bitrand(127)
  @test (a .& b) == (@turbo a .& b)
  @test (a .| b) == (@turbo a .| b)
  @test (a .⊻ b) == (@turbo a .⊻ b)

  s, d, g = 3, 1, 2
  f = rand(N, 2)
  v = rand(N, 3)
  θ = 0.78
  v[rand(eachindex(v), length(v) >> 3)] .= NaN
  fc = copy(f)
  testfunction!(fc, v, d, g, s, θ)
  # fc2 = copy(f);
  testfunctionavx!(f, v, d, g, s, θ)
  finite_subset = isfinite.(fc)
  @test finite_subset == isfinite.(f)
  @test f[finite_subset] ≈ fc[finite_subset]

  for i ∈ 1:50
    X = chebpts(i)
    bX = barycentric_weight0(X)
    @test barycentric_weight1(X) ≈ bX
    @test barycentric_weight2(X) ≈ bX
    @test barycentric_weight3(X) ≈ bX
    @test barycentric_weight4(X) ≈ bX
  end

  let
    lut = let x = cumsum(rand(Float32, 256) ./ 128)
      x[end] = Inf
      x
    end
    src = rand(Float32, N)

    @test mwe_v(Vector{Int}(undef, N), src, lut) == mwe_s(Vector{Int}(undef, N), src, lut)
    @test mwe_v(Vector{Int32}(undef, N), src, lut) ==
          mwe_s(Vector{Int32}(undef, N), src, lut)
  end

  let m = rand(25, 25),
    y = rand(25, 25),
    baseline5 = (@. ifelse(0 < m < 0.5, 0.0, m)),
    baseline7 = @. ifelse(0 < y < m < 0.5, 0.0, y)

    turbocomparison!(y, m)
    @test y == baseline7
    turbocomparison!(m)
    @test m == baseline5
  end

end

function contract!(tiJaB_d_temp3, tiJaB_i, Wmnij)
  rvir = axes(tiJaB_d_temp3, 4)
  nvir = last(rvir)
  rocc = axes(tiJaB_d_temp3, 1)
  @inbounds @fastmath for b in rvir, a = b:nvir, j in rocc, i = j:last(rocc)
    temp = zero(eltype(tiJaB_i))
    for n in rocc, m in rocc
      temp += tiJaB_i[m, n, a, b] * Wmnij[m, n, i, j]
    end
    tiJaB_d_temp3[i, j, a, b] = temp
    tiJaB_d_temp3[j, i, b, a] = temp
  end
end

function contracttest1!(tiJaB_d_temp3, tiJaB_i, Wmnij)
  rvir = axes(tiJaB_d_temp3, 4)
  nvir = last(rvir)
  rocc = axes(tiJaB_d_temp3, 1)
  for b in rvir, j in rocc
    @turbo for a = b:nvir, i = j:last(rocc)
      temp = zero(eltype(tiJaB_i))
      for n in rocc, m in rocc
        temp += tiJaB_i[m, n, a, b] * Wmnij[m, n, i, j]
      end
      tiJaB_d_temp3[i, j, a, b] = temp
      tiJaB_d_temp3[j, i, b, a] = temp
    end
  end
  tiJaB_d_temp3
end
function contracttest2!(tiJaB_d_temp3, tiJaB_i, Wmnij)
  rvir = axes(tiJaB_d_temp3, 4)
  nvir = last(rvir)
  rocc = axes(tiJaB_d_temp3, 1)
  for b in rvir, a = b:nvir, j in rocc
    @turbo for i = j:last(rocc)
      temp = zero(eltype(tiJaB_i))
      for n in rocc, m in rocc
        temp += tiJaB_i[m, n, a, b] * Wmnij[m, n, i, j]
      end
      tiJaB_d_temp3[i, j, a, b] = temp
      tiJaB_d_temp3[j, i, b, a] = temp
    end
  end
  tiJaB_d_temp3
end

@testset "Tensors" begin
  @show Float64, @__LINE__
  LA, LIM = 31, 23
  A = rand(LIM, LIM, LA, LA)
  B = rand(LIM, LIM, LIM, LIM)

  C1 = fill(-999.999, LIM, LIM, LA, LA)
  C2 = fill(-999.999, LIM, LIM, LA, LA)
  C3 = fill(-999.999, LIM, LIM, LA, LA)
  # C1 = Array{Float64}(undef, LIM, LIM, LA, LA);
  # C2 = similar(C1); C3 = similar(C1);

  contract!(C1, A, B)
  @test C1 ≈ contracttest1!(C2, A, B)
  @test C1 ≈ contracttest2!(C3, A, B)

  Apermute = PermutedDimsArray(permutedims(A, (2, 4, 1, 3)), (3, 1, 4, 2))
  Bpermute = PermutedDimsArray(permutedims(B, (2, 1, 4, 3)), (2, 1, 4, 3))
  @test C1 ≈ contracttest1!(C2, Apermute, Bpermute)
  @test C1 ≈ contracttest2!(C3, Apermute, Bpermute)
end

const CONSTANT_SYMBOLS = (
  :nothing,
  :Float64,
  :Float32,
  :Int8,
  :UInt8,
  :Int16,
  :UInt16,
  :Int32,
  :UInt32,
  :Int64,
  :UInt64
)
function add_constant!(ls::LoopSet, var::Symbol, elementbytes::Int)
  var ∈ ls.loopsymbols && return add_loopvalue!(ls, var, elementbytes)
  globalconst = Base.sym_in(var, CONSTANT_SYMBOLS)
  instr = globalconst ? Instruction(GLOBALCONSTANT, var) : LOOPCONSTANT
  op = Operation(
    length(operations(ls)),
    var,
    elementbytes,
    instr,
    constant,
    NODEPENDENCY,
    Symbol[],
    NOPARENTS
  )
  rop = pushop!(ls, op, var)
  (!globalconst && (rop === op)) && pushpreamble!(ls, op, var)
  rop
end
# function add_constant!(ls::LoopSet, var, elementbytes::Int = 8)
#     sym = gensym(:loopconstant)
#     pushpreamble!(ls, Expr(:(=), sym, var))
#     add_constant!(ls, sym, elementbytes)
# end
function add_constant!(
  ls::LoopSet,
  var::Number,
  elementbytes::Int = 8,
  varname = gensym!(ls, "loopconstnumber")
)
  op = Operation(
    length(operations(ls)),
    varname,
    elementbytes,
    LOOPCONSTANT,
    constant,
    NODEPENDENCY,
    Symbol[],
    NOPARENTS
  )
  ops = operations(ls)
  typ = var isa Integer ? HardInt : HardFloat
  if iszero(var)
    for (id, typ_) ∈ ls.preamble_zeros
      (instruction(ops[id]) == LOOPCONSTANT && typ == typ_) && return ops[id]
    end
    push!(ls.preamble_zeros, (identifier(op), typ))
  elseif var isa Integer
    idescript = integer_description(var)
    for (id, descript) ∈ ls.preamble_symint
      if (instruction(ops[id]) == LOOPCONSTANT) && (idescript == descript)
        return ops[id]
      end
    end
    push!(ls.preamble_symint, (identifier(op), idescript))
  else#if var isa FloatX
    for (id, fvar) ∈ ls.preamble_symfloat
      (instruction(ops[id]) == LOOPCONSTANT && fvar == var) && return ops[id]
    end
    push!(ls.preamble_symfloat, (identifier(op), var))
  end
  rop = pushop!(ls, op)
  rop === op || return rop
  pushpreamble!(ls, Expr(:(=), name(op), var))
  rop
end
function ensure_constant_lowered!(ls::LoopSet, op::Operation)
  if iscompute(op)
    call = callexpr(instruction(op))
    for opp ∈ parents(op)
      ensure_constant_lowered!(ls, opp)
      push!(call.args, name(opp))
    end
    pushpreamble!(ls, Expr(:(=), name(op), call))
  elseif isconstant(op) & !isconstantop(op)
    opid = identifier(op)
    for (id, sym) ∈ ls.preamble_symsym
      if id == opid
        pushpreamble!(ls, Expr(:(=), name(op), sym))
        return
      end
    end
    for (id, (intval, intsz, signed)) ∈ ls.preamble_symint
      if id == opid
        if intsz == 1
          pushpreamble!(ls, Expr(:(=), name(op), intval % Bool))
        elseif signed
          pushpreamble!(ls, Expr(:(=), name(op), intval))
        else
          pushpreamble!(ls, Expr(:(=), name(op), intval % UInt))
        end
        return
      end
    end
    for (id, floatval) ∈ ls.preamble_symfloat
      if id == opid
        pushpreamble!(ls, Expr(:(=), name(op), floatval))
        return
      end
    end
    for (id, typ) ∈ ls.preamble_zeros
      if id == opid
        pushpreamble!(ls, Expr(:(=), name(op), staticexpr(0)))
        return
      end
    end
    for (id, f) ∈ ls.preamble_funcofeltypes
      if id == opid
        pushpreamble!(
          ls,
          Expr(:(=), name(op), Expr(:call, reduction_zero(f), Float64))
        )
        return
      end
    end
  end
end
function ensure_constant_lowered!(
  ls::LoopSet,
  mpref::ArrayReferenceMetaPosition,
  ind::Symbol
)
  length(loopdependencies(mpref)) == 0 && return
  for (id, opp) ∈ enumerate(parents(mpref))
    if name(opp) === ind
      ensure_constant_lowered!(ls, opp)
    end
  end
  return nothing
end
function add_constant_vload!(
  ls::LoopSet,
  op::Operation,
  mpref::ArrayReferenceMetaPosition,
  elementbytes::Int
)
  temp = gensym!(ls, "intermediateconstref")
  use_getindex = vptr(name(mpref)) === mpref.mref.ptr
  vloadcall =
    use_getindex ? Expr(:call, Base.getindex, name(mpref)) :
    Expr(:call, lv(:_vload), mpref.mref.ptr)
  nindices = length(getindices(op))
  # getoffsets(op) .+= 1
  if nindices > 0
    dummyloop = first(ls.loops)
    for ind ∈ getindicesonly(op)
      ensure_constant_lowered!(ls, mpref, ind)
    end
    if use_getindex
      append!(
        vloadcall.args,
        mem_offset(
          op,
          UnrollArgs(dummyloop, dummyloop, dummyloop, 0, 0, 0),
          fill(false, nindices),
          true,
          ls,
          false
        ).args
      )
    else
      push!(
        vloadcall.args,
        mem_offset(
          op,
          UnrollArgs(dummyloop, dummyloop, dummyloop, 0, 0, 0),
          fill(false, nindices),
          true,
          ls,
          false
        )
      )
    end
  end
  if use_getindex
    pushpreamble!(ls, Expr(:(=), temp, :(@inbounds $vloadcall)))
  else
    push!(vloadcall.args, Expr(:call, lv(:False)), staticexpr(reg_size(ls)))
    pushpreamble!(ls, Expr(:(=), temp, vloadcall))
  end
  pushpreamble!(ls, Expr(:(=), name(op), temp))
  pushpreamble!(ls, op, temp)
  return temp
end
function add_constant!(
  ls::LoopSet,
  mpref::ArrayReferenceMetaPosition,
  elementbytes::Int
)
  op = Operation(
    length(operations(ls)),
    varname(mpref),
    elementbytes,
    LOOPCONSTANT,
    constant,
    NODEPENDENCY,
    Symbol[],
    NOPARENTS,
    mpref.mref
  )
  add_vptr!(ls, op)
  temp = add_constant_vload!(ls, op, mpref, elementbytes)
  pushop!(ls, op, temp)
end
# This version has loop dependencies. var gets assigned to sym when lowering.
# value is what will get assigned within the loop.
# assignedsym will be assigned to value within the preamble
function add_constant!(
  ls::LoopSet,
  value::Symbol,
  deps::Vector{Symbol},
  assignedsym::Symbol,
  elementbytes::Int,
  f::Symbol = Symbol("")
)
  value ∈ ls.loopsymbols && return add_loopvalue!(ls, value, elementbytes)
  retop = get(ls.opdict, value, nothing)
  if retop === nothing
    op = Operation(
      length(operations(ls)),
      assignedsym,
      elementbytes,
      Instruction(f, value),
      constant,
      deps,
      NODEPENDENCY,
      NOPARENTS
    )
  else
    op = Operation(
      length(operations(ls)),
      assignedsym,
      elementbytes,
      :identity,
      compute,
      deps,
      reduceddependencies(retop),
      [retop]
    )
  end
  pushop!(ls, op, assignedsym)
end
# function add_constant!(
#     ls::LoopSet, value, deps::Vector{Symbol}, assignedsym::Symbol, elementbytes::Int, f::Symbol = Symbol("")
# )
#     intermediary = gensym(:intermediate) # hack, passing meta info here
#     pushpreamble!(ls, Expr(:(=), intermediary, value))
#     add_constant!(ls, intermediary, deps, assignedsym, f, elementbytes)
# end
function add_constant!(
  ls::LoopSet,
  value::Number,
  deps::Vector{Symbol},
  assignedsym::Symbol,
  elementbytes::Int
)
  op = add_constant!(
    ls,
    gensym!(ls, string(value)),
    deps,
    assignedsym,
    elementbytes,
    :numericconstant
  )
  pushpreamble!(ls, op, value)
  op
end

using LoopVectorization
using Test

@testset "Utilities" begin
  @show @__LINE__
  @test LoopVectorization.isscopedname(:(Base.OneTo), :Base, :OneTo)
  @test LoopVectorization.isscopedname(:(A.B.C.D), (:A, :B, :C), :D)
  @test !LoopVectorization.isscopedname(:(A.B.D), (:A, :B, :C), :D)
  @test !LoopVectorization.isscopedname(:(A.B.C.D), (:A, :B, :C), :E)
  @test !LoopVectorization.isscopedname(:hello, :Base, :OneTo)

  @test LoopVectorization.isglobalref(GlobalRef(Base, :getindex), Base, :getindex)
  @test !LoopVectorization.isglobalref(GlobalRef(Base, :getindex), Base, :setindex!)
  @test !LoopVectorization.isglobalref(GlobalRef(Core, :getindex), Base, :getindex)
  @test !LoopVectorization.isglobalref(:getindex, Base, :getindex)
end

using OffsetArrays

function reg_term(omega, B = size(omega, 2); alpha = 0.01)
  reg = 0.0
  for b = 1:B
    t = maximum(@views omega[:, b]) - omega[b, b]
    reg += t
  end
  return alpha * reg
end

function reg_term_turbo(omega, B = size(omega, 2); alpha = 0.01)
  reg = 0.0
  @turbo for b = 1:B
    m = -Inf
    for i in axes(omega, 1)
      m = max(m, omega[i, b])
    end
    t = m - omega[b, b]
    reg += t
  end
  return alpha * reg
end

function awmean_lv(x::AbstractArray{T1}, σ::AbstractArray{T2}) where {T1<:Number,T2<:Number}
  n = length(x)
  T3 = promote_type(T1, T2)
  T = sizeof(T3) ≤ 4 ? Float32 : Float64
  sum_of_values = sum_of_weights = χ2 = zero(T)
  @turbo for i = 1:n
    sum_of_values += x[i] / (σ[i] * σ[i])
    sum_of_weights += 1 / (σ[i] * σ[i])
  end
  wx = sum_of_values / sum_of_weights

  @turbo for i = 1:n
    χ2 += (x[i] - wx) * (x[i] - wx) / (σ[i] * σ[i])
  end
  mswd = χ2 / (n - 1)
  wσ = sqrt(one(T) / sum_of_weights)
  return wx, wσ, mswd
end
function awmean_simd(
  x::AbstractArray{T1},
  σ::AbstractArray{T2},
) where {T1<:Number,T2<:Number}
  n = length(x)
  T3 = promote_type(T1, T2)
  T = sizeof(T3) ≤ 4 ? Float32 : Float64
  sum_of_values = sum_of_weights = χ2 = zero(T)
  @fastmath @inbounds @simd for i = 1:n
    sum_of_values += x[i] / (σ[i] * σ[i])
    sum_of_weights += 1 / (σ[i] * σ[i])
  end
  wx = sum_of_values / sum_of_weights

  @fastmath @inbounds @simd for i = 1:n
    χ2 += (x[i] - wx) * (x[i] - wx) / (σ[i] * σ[i])
  end
  mswd = χ2 / (n - 1)
  wσ = sqrt(one(T) / sum_of_weights)
  return wx, wσ, mswd
end

function test_awmean(::Type{T}) where {T}
  for n ∈ 2:100
    if T <: Integer
      x = view(rand(T(-50):T(100), n + 32), 17:n+16)
      σ = view(rand(T(1):T(10), n + 32), 17:n+16)
    else
      x = view((randn(T, n + 32) .+= T(2)), 17:n+16)
      σ = view(rand(T, n + 32), 17:n+16)
    end
    wx, wσ, mswd = awmean_simd(x, σ)
    @test iszero(@allocated((wxlv, wσlv, mswdlv) = awmean_lv(x, σ)))
    wxlv, wσlv, mswdlv = awmean_lv(x, σ)
    isfinite(wx) && @test wx ≈ wxlv
    isfinite(wσ) && @test wσ ≈ wσlv
    isfinite(mswd) &&
      @test mswd ≈ mswdlv atol = eps(typeof(mswdlv)) rtol = sqrt(eps(typeof(mswdlv)))
  end
end

function logℒ_fast(α, β, t, c, x)
  eα = abs(α)
  n, k = size(x)

  (n == length(t) == length(c) && length(β) == k + 1) || throw(DimensionMismatch())
  s = zero(typeof(α))
  @inbounds for i = 1:n
    xb = sum(@inbounds(x[i, j] * β[j+1]) for j = 1:k) + β[1]
    ti = t[i]
    s += (1 - (c[i] == ti)) * (log(eα) + (eα - 1) * log(ti) + xb) - ti^eα * exp(xb)
  end
  return s
end
function logℒ_fast_turbo(α, β, t, c, x)
  eα = abs(α)
  n, k = size(x)

  (n == length(t) == length(c) && length(β) == k + 1) || throw(DimensionMismatch())
  s = zero(typeof(α))
  @turbo for i = 1:n
    xb0 = 0.0
    for j = 1:k
      xb0 += x[i, j] * β[j+1]
    end
    xb = xb0 + β[1]
    ti = t[i]
    s += (1 - (c[i] == ti)) * (log(eα) + (eα - 1) * log(ti) + xb) - ti^eα * exp(xb)
  end
  return s
end

function test_logℒ(n, k)
  t = rand(n)
  c = copy(t)
  b = rand(n) .> 0.5
  c[b] .= rand.()
  x = rand(n, k)
  α = 2.85
  β = rand(k + 1)
  @test logℒ_fast(α, β, t, c, x) ≈ logℒ_fast_turbo(α, β, t, c, x)
end

function not_an_outer_reduct!(r, N::Int, x = 2.0, y = nothing) # there was a bug where this was classified as one
  @turbo for i ∈ eachindex(r)
    acc = y === nothing ? x : r[i]
    for n ∈ 1:N
      acc += 0
    end
    r[i] = acc
  end
  r
end
function tk(v::Vector{T}, c_::Vector{T}, n::Int) where {T}
  l00 = l10 = l01 = l11 = zero(T)
  @turbo for j ∈ 1:n-1
    a00 = v[3n-3j+1]
    a01 = -v[3n-3j+2]
    a10 = v[3n-3j+2]
    a11 = v[3n-3j+3]
    b00 = c_[4j+1]
    b01 = c_[4j+2]
    b10 = c_[4j+3]
    b11 = c_[4j+4]
    l00 += a00 * b00 + a01 * b10
    l01 += a00 * b01 + a01 * b11
    l10 += a10 * b00 + a11 * b10
    l11 += a10 * b01 + a11 * b11
  end
  l00 + l01 + l10 + l11
end
function tk2(v::Vector{T}, c_::Vector{T}, n::Int) where {T}
  l00 = l10 = l01 = l11 = zero(T)
  @turbo for j ∈ 1:n-1
    i = n - j
    a00 = v[3i+1]
    a01 = -v[3i+2]
    a10 = v[3i+2]
    a11 = v[3i+3]
    b00 = c_[4j+1]
    b01 = c_[4j+2]
    b10 = c_[4j+3]
    b11 = c_[4j+4]
    l00 += a00 * b00 + a01 * b10
    l01 += a00 * b01 + a01 * b11
    l10 += a10 * b00 + a11 * b10
    l11 += a10 * b01 + a11 * b11
  end
  l00 + l01 + l10 + l11
end
function tk_base(v::Vector{T}, c_::Vector{T}, n::Int) where {T}
  l00 = l10 = l01 = l11 = zero(T)
  @inbounds @simd for j ∈ 1:n-1
    a00 = v[3n-3j+1]
    a01 = -v[3n-3j+2]
    a10 = v[3n-3j+2]
    a11 = v[3n-3j+3]
    i = n - j
    a00 = v[3i+1]
    a01 = -v[3i+2]
    a10 = v[3i+2]
    a11 = v[3i+3]
    b00 = c_[4j+1]
    b01 = c_[4j+2]
    b10 = c_[4j+3]
    b11 = c_[4j+4]
    l00 += a00 * b00 + a01 * b10
    l01 += a00 * b01 + a01 * b11
    l10 += a10 * b00 + a11 * b10
    l11 += a10 * b01 + a11 * b11
  end
  l00 + l01 + l10 + l11
end


function noturbosum(x, kern)
  ks = zero(eltype(x))
  @inbounds @fastmath for i = 2:size(x, 1)-1
    for j in axes(kern, 1), m in axes(kern, 2)
      ks += x[i+j, i+m] * kern[j, m]
    end
  end
  ks
end
function outersum(x, kern)
  ks = zero(eltype(x))
  @turbo for i = 2:size(x, 1)-1
    for j in axes(kern, 1), m in axes(kern, 2)
      ks += x[i+j, i+m] * kern[j, m]
    end
  end
  ks
end
function insum(x, kern)
  ks = zero(eltype(x))
  @turbo for i = 2:size(x, 1)-1
    s1 = zero(eltype(x))
    for j in axes(kern, 1), m in axes(kern, 2)
      s1 += x[i+j, i+m] * kern[j, m]
    end
    ks += s1
  end
  ks
end
function in2sum(x, kern)
  ks = zero(eltype(x))
  @turbo for i = 2:size(x, 1)-1
    for j in axes(kern, 1)
      s0 = zero(eltype(x))
      for m in axes(kern, 2)
        s0 += x[i+j, i+m] * kern[j, m]
      end
      ks += s0
    end
  end
  ks
end


@testset "Outer Reductions" begin
  for T ∈ [Float32, Float64, Int32, Int64]
    test_awmean(T)
    v = rand(T, 4 * 127)
    c = rand(T, 4 * 127)
    @test tk(v, c, 127) ≈ tk2(v, c, 127) ≈ tk_base(v, c, 127)
  end
  @test all(==(7.4), not_an_outer_reduct!(Vector{Float64}(undef, 5), 17, 7.4))
  for n ∈ 1:20, k ∈ 1:5
    test_logℒ(n, k)
  end
  omega = rand(87, 87)
  @test reg_term(omega) ≈ reg_term_turbo(omega)

  x = rand(100, 100)
  kern = OffsetArray(rand(3, 3), -2, -2)
  s = noturbosum(x, kern)
  @test s ≈ outersum(x, kern)
  @test s ≈ insum(x, kern)
  @test s ≈ in2sum(x, kern)
end

using LoopVectorization, StrideArraysCore, Test

function issue238_noavx!(output, matrix, input)
  for i in axes(output, 2), v in axes(output, 1)
    res = zero(eltype(output))
    for ii in axes(matrix, 2)
      res += matrix[i, ii] * input[v, ii]
    end
    output[v, i] = res
  end
  return nothing
end
function issue238!(output, matrix, input)
  @turbo inline = true for i in axes(output, 2), v in axes(output, 1)
    res = zero(eltype(output))
    for ii in axes(matrix, 2)
      res += matrix[i, ii] * input[v, ii]
    end
    output[v, i] += res
  end
  return nothing
end
function issue238_v2!(output, matrix, input)
  @turbo inline = true for i in axes(output, 2), v in axes(output, 1)
    res = output[v, i]
    for ii in axes(matrix, 2)
      res += matrix[i, ii] * input[v, ii]
    end
    output[v, i] = res
  end
  return nothing
end
const MAXTESTSIZE = 8 # N^3 loop iterations, meaning N^3 different functions compiled
function n2testloop(output1, output2, output3, output_nonstatic0, output_nonstatic1)
  n1, n3 = size(output1)
  for n2 ∈ 1:MAXTESTSIZE
    # @show n1, n2, n3
    input = randn(n1, n2)
    matrix = randn(n3, n2)
    smatrix = StrideArray(matrix, (StaticInt(n3), StaticInt(n2)))
    issue238_noavx!(output_nonstatic0, matrix, input)
    fill!(output_nonstatic1, 0)
    issue238!(output_nonstatic1, matrix, input)
    fill!(output1, 0)
    issue238!(output1, matrix, input)
    fill!(output2, 0)
    issue238!(output2, smatrix, input)
    fill!(output3, 0)
    issue238_v2!(output3, smatrix, input)
    if !(output1 ≈ output2 ≈ output3 ≈ output_nonstatic0 ≈ output_nonstatic1)
      @show n1, n2, n3
    end
    @test output_nonstatic0 ≈ output1 # static test
    @test output_nonstatic0 ≈ output2 # static test
    @test output_nonstatic0 ≈ output3 # static test
    @test output_nonstatic0 ≈ output_nonstatic1 # nonstatic test
  end
end
function update!(B⁻¹yₖ, B⁻¹, yₖ, sₖᵀyₖ⁻¹)
  yₖᵀB⁻¹yₖ = zero(eltype(B⁻¹))
  @inbounds @fastmath for c ∈ axes(B⁻¹, 2)
    t = zero(yₖᵀB⁻¹yₖ)
    for r ∈ axes(B⁻¹, 1)
      t += yₖ[r] * B⁻¹[r, c]
    end
    B⁻¹yₖ[c] = t * sₖᵀyₖ⁻¹
    yₖᵀB⁻¹yₖ += t * yₖ[c]
  end
  yₖᵀB⁻¹yₖ
end
function update_turbo!(B⁻¹yₖ, B⁻¹, yₖ, sₖᵀyₖ⁻¹)
  yₖᵀB⁻¹yₖ = zero(eltype(B⁻¹))
  @turbo for c ∈ axes(B⁻¹, 2)
    t = zero(yₖᵀB⁻¹yₖ)
    for r ∈ axes(B⁻¹, 1)
      t += yₖ[r] * B⁻¹[r, c]
    end
    B⁻¹yₖ[c] = t * sₖᵀyₖ⁻¹
    yₖᵀB⁻¹yₖ += t * yₖ[c]
  end
  yₖᵀB⁻¹yₖ
end

function maxabs(x)
  s = -Inf
  @turbo for i ∈ eachindex(x)
    s = max(s, abs(x[i]))
  end
  s
end
function sum_turbo(x)
  s = zero(eltype(x))
  @turbo for i ∈ eachindex(x)
    s += x[i]
  end
  s
end
function sum2_10turbo(x)
  s = zero(eltype(x))
  for i = 1:10, j = 1:2
    s += x[j, i]
  end
  s
end

@testset "Statically Sized Arrays" begin
  @show @__LINE__
  for n1 ∈ 1:MAXTESTSIZE, n3 ∈ 1:MAXTESTSIZE
    # @show n1, n3
    output1 = StrideArray(undef, StaticInt(n1), StaticInt(n3))
    output2 = StrideArray(undef, StaticInt(n1), StaticInt(n3))
    output3 = StrideArray(undef, StaticInt(n1), StaticInt(n3))
    output_nonstatic0 = StrideArray(undef, n1, n3)
    output_nonstatic1 = StrideArray(undef, n1, n3)
    n2testloop(output1, output2, output3, output_nonstatic0, output_nonstatic1)

    y = StrideArray(undef, StaticInt(max(n1, n3)))
    y .= rand.()
    By0 = StrideArray(undef, StaticInt(n3))
    By1 = StrideArray(undef, StaticInt(n3))
    GC.@preserve By0 By1 output1 y begin
      @test update_turbo!(By0, output1, y, 0.124) ≈ update!(By1, output1, y, 0.124)
      @test By0 ≈ By1
    end
  end
  for i = 1:65
    # @show i
    x = StrideArray(undef, StaticInt(i))
    x .= randn.()
    @test maxabs(x) == maximum(abs, x)
    @test sum_turbo(x) ≈ sum(x)
  end
  let A = rand(2, 10)
    @test sum2_10turbo(A) ≈ sum(A)
  end
end

function check_linear_parents(ls::LoopSet, op::Operation, s::Symbol)
  (s ∈ loopdependencies(op)) || return true
  if isload(op) # TODO: handle loading from ranges.
    return false
  elseif !iscompute(op)
    return true
  end
  Base.sym_in(
    instruction(op).instr,
    (
      :vadd_nsw,
      :vadd_nuw,
      :vadd_nw,
      :vsub_nsw,
      :vsub_nuw,
      :vsub_nw,
      :(+),
      :vadd,
      :add_fast,
      :(-),
      :vsub,
      :sub_fast
    )
  ) || return false
  for opp ∈ parents(op)
    check_linear_parents(ls, opp, s) || return false
  end
  true
end

function findparent(ls::LoopSet, s::Symbol)#opdict isn't filled when reconstructing
  id = findfirst(Base.Fix2(===, s) ∘ name, operations(ls))
  id === nothing && throw("$s not found")
  operations(ls)[id]
end
function unitstride(ls::LoopSet, op::Operation, s::Symbol)
  inds = getindices(op)
  li = op.ref.loopedindex
  # The first index is allowed to be indexed by `s`
  fi = first(inds)
  if ((fi === DISCONTIGUOUS) | (fi === CONSTANTZEROINDEX)) ||
     (first(getstrides(op)) ≠ 1) ||
     !unitstep(getloop(ls, s))
    return false
    # elseif !first(li)
    #     # We must check if this
    #     parent = findparent(ls, fi)
    #     indexappearences(parent, s) > 1 && return false
  end
  if length(li) > 0 && !first(li)
    parent = findparent(ls, first(inds))
    check_linear_parents(ls, parent, s) || return false
  end
  for i ∈ 2:length(inds)
    if li[i]
      s === inds[i] && return false
    else
      parent = findparent(ls, inds[i])
      s ∈ loopdependencies(parent) && return false
    end
  end
  true
end
function cannot_shuffle(
  op::Operation,
  u₁::Symbol,
  u₂::Symbol,
  contigind::Symbol,
  indices
) # assumes isvectorized and !unitstride
  !((
    !rejectcurly(op) && (
      (
        (contigind === CONSTANTZEROINDEX) &&
        ((length(indices) > 1) && (indices[2] === u₁) || (indices[2] === u₂))
      ) || ((u₁ === contigind) | (u₂ === contigind))
    )
  ))
end
const DOUBLE_THROUGHPUT = occursin("apple-m", LoopVectorization.get_cpu_name())
function cost(
  ls::LoopSet,
  op::Operation,
  (u₁, u₂)::Tuple{Symbol,Symbol},
  vloopsym::Symbol,
  Wshift::Int,
  size_T::Int = op.elementbytes
)
  isconstant(op) && return 0.0, 0, 1.0#Float64(length(loopdependencies(op)) > 0)
  isloopvalue(op) && return 0.0, 0, 0.0
  instr = instruction(op)
  if length(parents(op)) == 1
    if instr == Instruction(:-) ||
       instr === Instruction(:sub_fast) ||
       instr == Instruction(:+) ||
       instr == Instruction(:add_fast)
      return 0.0, 0, 0.0
    end
  elseif iscompute(op) && (
    Base.sym_in(
      instruction(op).instr,
      (:vadd_nsw, :vsub_nsw, :(+), :(-), :add_fast, :sub_fast)
    ) && all(opp -> (isloopvalue(opp)), parents(op))
  )# || (reg_count(ls) == 32) && (instruction(op).instr === :ifelse))
    # all(opp -> (isloopvalue(opp) | isconstant(opp)), parents(op))
    return 0.0, 0, 0.0
  end
  shuffle_rt = 0
  opisvectorized = isvectorized(op)
  srt, sl, srp =
    opisvectorized ? vector_cost(instr, Wshift, size_T) : scalar_cost(instr)
  if accesses_memory(op)
    # either vbroadcast/reductionstore, vmov(a/u)pd, or gather/scatter
    if opisvectorized
      if !unitstride(ls, op, vloopsym)# || !isdense(op) # need gather/scatter
        indices = getindices(op)
        contigind = first(indices)
        shifter = max(2, Wshift)
        # rejectinterleave false means omop
        # cannot shuffle false means reject curly
        # either false means shuffle
        dont_shuffle =
          (Wshift > 3) || (
            rejectinterleave(op) &&
            (cannot_shuffle(op, u₁, u₂, contigind, indices))
          )
        if dont_shuffle
          # offset = 0.0 # gather/scatter, alignment doesn't matter
          r = 1 << shifter
          srt = srt * r# + offset
          sl *= r
        else#if rejectinterleave(op) # means omop
          if isload(op) & (length(loopdependencies(op)) > 1)# vmov(a/u)pd
            srt += 0.5reg_size(ls) / cache_lnsze(ls)
          end
          shuffle_rt += shifter
          srt += shifter # shifter == number of shuffles
          sl += shifter
        end
      elseif isload(op) & (length(loopdependencies(op)) > 1)# vmov(a/u)pd
        # penalize vectorized loads with more than 1 loopdep
        # heuristic; more than 1 loopdep means that many loads will not be aligned
        # Roughly corresponds to double-counting loads crossing cacheline boundaries
        # TODO: apparently the new ARM A64FX CPU (with 512 bit vectors) is NOT penalized for unaligned loads
        #       would be nice to add a check for this CPU, to see if such a penalty is still appropriate.
        #       Also, once more SVE (scalable vector extension) CPUs are released, would be nice to know if
        #       this feature is common to all of them.
        srt += 0.5reg_size(ls) / cache_lnsze(ls)
        # srt += 0.25reg_size(ls) / cache_lnsze(ls)
      end
    elseif isstore(op)# && isvectorized(first(parents(op))) # broadcast or reductionstore; if store we want to penalize reduction
      srt *= 3
      sl *= 3
    end
  end
  if DOUBLE_THROUGHPUT
    srt *= 0.5
    shuffle_rt >>= 1
  end
  srt, sl, Float64(srp + 1), shuffle_rt
end

# Base._return_type()

biggest_type_size(ls::LoopSet) = maximum(elsize, operations(ls))
function hasintersection(a, b)
  for aᵢ ∈ a, bᵢ ∈ b
    aᵢ === bᵢ && return true
  end
  false
end
const num_iterations = cld

function set_vector_width!(ls::LoopSet, vloopsym::Symbol)
  W = ls.vector_width
  if !iszero(W)
    ls.vector_width = min(W, VectorizationBase.nextpow2(length(ls, vloopsym)))
  end
  nothing
end
function lsvecwidthshift(ls::LoopSet, vloopsym::Symbol, size_T = nothing)
  W = ls.vector_width
  lvec = length(ls, vloopsym)
  W = if iszero(W)
    bytes = size_T === nothing ? biggest_type_size(ls) : size_T
    reg_size(ls) ÷ bytes
  else
    min(W, VectorizationBase.nextpow2(lvec))
  end
  W, VectorizationBase.intlog2(W)
end

# evaluates cost of evaluating loop in given order
function evaluate_cost_unroll(
  ls::LoopSet,
  order::Vector{Symbol},
  vloopsym::Symbol,
  max_cost::Float64 = typemax(Float64),
  sld::Vector{Vector{Symbol}} = store_load_deps(operations(ls))
)
  included_vars =
    fill!(resize!(ls.included_vars, length(operations(ls))), false)
  nested_loop_syms = Symbol[]#Set{Symbol}()
  total_cost = 0.0
  iter = 1.0
  size_T = biggest_type_size(ls)
  W, Wshift = lsvecwidthshift(ls, vloopsym, size_T)
  # Need to check if fusion is possible
  for itersym ∈ order
    cacheunrolled!(ls, itersym, Symbol(""), vloopsym)
    # Add to set of defined symbols
    push!(nested_loop_syms, itersym)
    looplength = length(ls, itersym)
    liter = itersym === vloopsym ? num_iterations(looplength, W) : looplength
    iter *= liter
    # check which vars we can define at this level of loop nest
    for (id, op) ∈ enumerate(operations(ls))
      # won't define if already defined...
      # id = identifier(op)
      included_vars[id] && continue
      # it must also be a subset of defined symbols
      loopdependencies(op) ⊆ nested_loop_syms || continue
      # hasintersection(reduceddependencies(op), nested_loop_syms) && return Inf
      (isassigned(sld, id) && any(s -> (s ∉ sld[id]), nested_loop_syms)) &&
        return Inf
      included_vars[id] = true
      # TODO: use actual unrolls here?
      c =
        first(cost(ls, op, (Symbol(""), Symbol("")), vloopsym, Wshift, size_T))
      total_cost += iter * c
      0.9total_cost > max_cost && return total_cost # abort if more expensive; we only want to know the cheapest
    end
  end
  0.9total_cost + stride_penalty(ls, order) # 0.999 to place finger on scale in its favor
end

# only covers vectorized ops; everything else considered lifted?
function depchain_cost!(
  ls::LoopSet,
  skip::Vector{Bool},
  op::Operation,
  unrolled::Symbol,
  vloopsym::Symbol,
  Wshift::Int,
  size_T::Int,
  rt::Float64 = 0.0,
  sl::Int = 0
)
  skip[identifier(op)] = true
  # depth first search
  for opp ∈ parents(op)
    skip[identifier(opp)] && continue
    rt, sl =
      depchain_cost!(ls, skip, opp, unrolled, vloopsym, Wshift, size_T, rt, sl)
  end
  # Basically assuming memory and compute don't conflict, but everything else does
  # Ie, ignoring the fact that integer and floating point operations likely don't either
  if iscompute(op)
    rtᵢ, slᵢ = cost(ls, op, (unrolled, Symbol("")), vloopsym, Wshift, size_T)
    rt += rtᵢ
    sl += slᵢ
  elseif isload(op)
    _, _, _, shufflecost =
      cost(ls, op, (unrolled, Symbol("")), vloopsym, Wshift, size_T)
    rt += shufflecost
    sl += shufflecost
  end
  rt, sl
end
function parentsnotreduction(op::Operation)
  for opp ∈ parents(op)
    isreduction(opp) && return false
  end
  return true
end
# function roundpow2(i::Integer)
#     u = VectorizationBase.nextpow2(i)
#     l = u >>> 1
#     ud = u - i
#     ld = i - l
#     ud > ld ? l : u
# end
# function roundpow2(x::Float64)
# 1 << round(Int, log2(x))
# end
function unroll_no_reductions(ls, order, vloopsym)
  size_T = biggest_type_size(ls)
  W, Wshift = lsvecwidthshift(ls, vloopsym, size_T)

  compute_rt = load_rt = store_rt = 0.0
  unrolled = last(order)
  i = 0
  while reject_reorder(ls, unrolled, false)
    i += 1
    unrolled = order[end-i]
  end
  if unrolled === vloopsym && length(order) > 1
    unrolled_candidate = order[end-1]
    if !reject_reorder(ls, unrolled_candidate, false)
      unrolled = unrolled_candidate
    end
  end
  # latency not a concern, because no depchains
  innerloop = last(order)
  compute_l = 0.0
  rpp = 0 # register pressure proportional to unrolling
  rpc = 0 # register pressure independent of unroll factor
  for op ∈ operations(ls)
    isu₁unrolled(op) || continue
    rt, sl, rpop =
      cost(ls, op, (unrolled, Symbol("")), vloopsym, Wshift, size_T)
    if iscompute(op)
      compute_rt += rt
      compute_l += sl
      rpc += max(zero(rpop), rpop - one(rpop)) # constant loads for special functions reused with unrolling
    elseif isload(op)
      load_rt += rt
      rpp += rpop # loads are proportional to unrolling
    elseif isstore(op)
      store_rt += rt
    end
  end
  # heuristic guess
  # roundpow2(min(4, round(Int, (compute_rt + load_rt + 1) / compute_rt)))
  memory_rt = load_rt + store_rt
  u = if compute_rt ≤ 1
    4
  elseif compute_rt > memory_rt
    # if compute_rt > 40
    # max(VectorizationBase.nextpow2( min( 4, round(Int, compute_rt / memory_rt) ) ), 1)
    # else
    clamp(
      round(Int, compute_l / compute_rt),
      1,
      Core.ifelse(compute_rt > 80, 2, 4)
    )
    # end
  elseif iszero(load_rt)
    iszero(store_rt) ? 4 : max(1, min(4, round(Int, 2compute_rt / store_rt)))
  else
    max(1, min(4, round(Int, 1.75compute_rt / load_rt)))
  end
  # u = min(u, max(1, (reg_count(ls) ÷ max(1,round(Int,rp)))))
  # commented out here is to decide to align loops
  # if memory_rt > compute_rt && isone(u) && (length(order) > 1) && (last(order) === vloopsym) && length(getloop(ls, last(order))) > 8W
  #     ls.align_loops[] = findfirst(operations(ls)) do op
  #         isstore(op) && isu₁unrolled(op)
  #     end
  # end
  # if unrolled === vloopsym
  #   u = demote_unroll_factor(ls, u, vloopsym)
  # end
  remaining_reg = max(8, (reg_count(ls) - round(Int, rpc))) # spilling a few consts isn't so bad
  if compute_l ≥ 4compute_rt ≥ 4rpp
    # motivation for skipping division by loads here: https://github.com/microhh/stencilbuilder/blob/master/julia/stencil_julia_4th.jl
    # Some values:
    # (load_rt, store_rt, compute_rt, compute_l, u, rpc, rpp) = (52.0, 3.0, 92.0, 736.0, 4, 0.0, 52.0)
    # This is fastest when `u = 4`, but `reg_constraint` was restricting it to 1. ## later benchmarks were faster with u = 2?
    # Obviously, this limitation on number of registers didn't seem so important in practice.
    # So, heuristically I check if compute latency dominates the problem, in which case unrolling could be expected to benefit us.
    # Ideally, we'd count the number of loads that actually have to be live at a given time. But this heuristic is hopefully okay for now.
    reg_constraint = max(1, remaining_reg)
  else
    reg_constraint = max(1, remaining_reg ÷ max(1, round(Int, rpp)))
  end
  maybe_demote_unroll(ls, clamp(u, 1, reg_constraint), unrolled, vloopsym),
  unrolled
  # rt = max(compute_rt, load_rt + store_rt)
  # # (iszero(rt) ? 4 : max(1, roundpow2( min( 4, round(Int, 16 / rt) ) ))), unrolled
  # (iszero(rt) ? 4 : max(1, VectorizationBase.nextpow2( min( 4, round(Int, 8 / rt) ) ))), unrolled
end
function rthroughput_latency(
  ls::LoopSet,
  order::Vector{Symbol},
  unrolled::Symbol,
  vloopsym::Symbol
)
  cacheunrolled!(ls, unrolled, Symbol(""), vloopsym)
  size_T = biggest_type_size(ls)
  W, Wshift = lsvecwidthshift(ls, vloopsym, size_T)

  # So if num_reductions > 0, we set the unroll factor to be high enough so that the CPU can be kept busy
  # if there are, U = max(1, round(Int, max(latency) * throughput / num_reductions)) = max(1, round(Int, latency / (recip_throughput * num_reductions)))
  # We also make sure register pressure is not too high.
  latency = 1.0
  # compute_recip_throughput_u = 0.0
  compute_recip_throughput = 0.0
  visited_nodes = fill(false, length(operations(ls)))
  load_recip_throughput = 0.0
  store_recip_throughput = 0.0
  for op ∈ operations(ls)
    if isreduction(op)
      rt, sl = depchain_cost!(
        ls,
        visited_nodes,
        op,
        unrolled,
        vloopsym,
        Wshift,
        size_T
      )
      if isouterreduction(ls, op) ≠ -1 || unrolled ∉ reduceddependencies(op)
        latency = max(sl, latency)
      end
      compute_recip_throughput += rt
    elseif isload(op)
      lrt, _, _, shufflert =
        cost(ls, op, (unrolled, Symbol("")), vloopsym, Wshift, size_T)
      load_recip_throughput += lrt - shufflert
      # shufflert considered as part of depchain_cost!
    elseif isstore(op)
      srt, _, _, shufflert =
        cost(ls, op, (unrolled, Symbol("")), vloopsym, Wshift, size_T)
      store_recip_throughput += srt - shufflert
      compute_recip_throughput += shufflert
    end
  end
  recip_throughput =
    max(compute_recip_throughput, load_recip_throughput, store_recip_throughput)
  recip_throughput, latency
end
function count_reductions(ls::LoopSet)
  num_reductions = 0
  for op ∈ operations(ls)
    if isreduction(op) & iscompute(op) && parentsnotreduction(op)
      num_reductions += 1
    end
  end
  num_reductions
end

demote_unroll_factor(ls::LoopSet, UF, loop::Symbol) =
  demote_unroll_factor(ls, UF, getloop(ls, loop))
function demote_unroll_factor(ls::LoopSet, UF, loop::Loop)
  W = ls.vector_width
  if !iszero(W) && isstaticloop(loop)
    UFW = maybedemotesize(UF * W, length(loop))
    UF = cld(UFW, W)
  end
  UF
end

function determine_unroll_factor(
  ls::LoopSet,
  order::Vector{Symbol},
  vloopsym::Symbol
)
  num_reductions = count_reductions(ls)
  # The strategy is to use an unroll factor of 1, unless there appears to be loop carried dependencies (ie, num_reductions > 0)
  # The assumption here is that unrolling provides no real benefit, unless it is needed to enable OOO execution by breaking up these dependency chains
  loopindexesbit = ls.loopindexesbit
  if iszero(length(loopindexesbit)) ||
     ((!loopindexesbit[getloopid(ls, vloopsym)]))
    if iszero(num_reductions)
      return unroll_no_reductions(ls, order, vloopsym)
    else
      return determine_unroll_factor(ls, order, vloopsym, num_reductions)
    end
  elseif iszero(num_reductions) # handle `BitArray` loops w/out reductions
    return 8 ÷ ls.vector_width, vloopsym
  else # handle `BitArray` loops with reductions
    rttemp, ltemp = rthroughput_latency(ls, order, vloopsym, vloopsym)
    UF =
      min(8, VectorizationBase.nextpow2(max(1, round(Int, ltemp / (rttemp)))))
    UFfactor = 8 ÷ ls.vector_width
    cld(UF, UFfactor) * UFfactor, vloopsym
    # UF2 = cld(UF, UFfactor)*UFfactor, vloopsym
    # maybe_demote_unroll(ls, UF2, vloopsym, vloopsym), vloopsym
  end
end
# function scale_unrolled()
# end
function determine_unroll_factor(
  ls::LoopSet,
  order::Vector{Symbol},
  vloopsym::Symbol,
  num_reductions::Int
)
  innermost_loop = last(order)
  rt = Inf
  rtcomp = Inf
  latency = Inf
  best_unrolled = Symbol("")
  for unrolled ∈ order
    reject_reorder(ls, unrolled, false) && continue
    rttemp, ltemp = rthroughput_latency(ls, order, unrolled, vloopsym)
    rtcomptemp =
      rttemp + (
        0.01 *
        ((vloopsym === unrolled) + (unrolled === innermost_loop) - latency)
      )
    if rtcomptemp < rtcomp
      rt = rttemp
      rtcomp = rtcomptemp
      latency = ltemp
      best_unrolled = unrolled
    end
  end
  # min(8, roundpow2(max(1, round(Int, latency / (rt * num_reductions) ) ))), best_unrolled
  lrtratio = latency / rt
  if lrtratio ≥ 7.0
    UF = 8
  else
    UF =
      VectorizationBase.nextpow2(round(Int, clamp(lrtratio, 1.0, 4.0), RoundUp))
  end
  UF = maybe_demote_unroll(ls, UF, best_unrolled, vloopsym)
  UF, best_unrolled
end
function maybe_demote_unroll(
  ls::LoopSet,
  UF::Int,
  unrollsym::Symbol,
  vloopsym::Symbol
)::Int
  if unrollsym === vloopsym
    return demote_unroll_factor(ls, UF, vloopsym)
  else
    ul = getloop(ls, unrollsym)
    isstaticloop(ul) ? min(length(ul), UF) : UF
  end
end

@inline function unroll_cost(X, u₁, u₂, u₁L, u₂L)
  u₂factor = (num_iterations(u₂L, u₂) / u₂L)
  u₁factor = (num_iterations(u₁L, u₁) / u₁L)
  # X[1]*u₂factor*u₁factor + X[4] + X[2] * u₂factor + X[3] * u₁factor
  X[1] + X[2] * u₂factor + X[3] * u₁factor + X[4] * u₁factor * u₂factor
end
# function itertilesize(X, u₁L, u₂L)
#     cb = Inf
#     u₁b = 1; u₂b = 1
#     for u₁ ∈ 1:4, u₂ ∈ 1:4
#         c = unroll_cost(X, u₁, u₂, u₁L, u₂L)
#         if cb > c
#             cb = c
#             u₁b = u₁; u₂b = u₂
#         end
#     end
#     u₁b, u₂b, cb
# end

function solve_unroll_iter(X, R, u₁L, u₂L, u₁range, u₂range)
  R₁, R₂, R₃, R₄ = R[1], R[2], R[3], R[4]
  RR = R₄
  u₁best, u₂best = 0, 0
  bestcost = Inf
  for u₁temp ∈ u₁range
    for u₂temp ∈ u₂range
      RR ≥ u₁temp * u₂temp * R₁ + u₁temp * R₂ + u₂temp * R₃ || continue
      tempcost = unroll_cost(X, u₁temp, u₂temp, u₁L, u₂L)
      if tempcost ≤ bestcost
        bestcost = tempcost
        u₁best, u₂best = u₁temp, u₂temp
      end
    end
  end
  u₁best, u₂best, bestcost
end

function solve_unroll_lagrange(
  X,
  R,
  u₁L,
  u₂L,
  u₁step::Int,
  u₂step::Int,
  atleast31registers::Bool
)
  X₁, X₂, X₃, X₄ = X[1], X[2], X[3], X[4]
  # If we don't have opmask registers, masks probably occupy a vector register (e.g., on CPUs with AVX but not AVX512)
  R₁, R₂, R₃, R₄ = R[1], R[2], R[3], R[4]
  iszero(R₃) ||
    return solve_unroll_iter(X, R, u₁L, u₂L, u₁step:u₁step:10, u₂step:u₂step:10)
  RR = R₄
  a = R₂^2 * X₃ - R₁ * X₄ * R₂ - R₁ * X₂ * RR
  b = R₁ * X₄ * RR - R₁ * X₄ * RR - 2X₃ * RR * R₂
  c = X₃ * RR^2
  discriminant = b^2 - 4a * c
  discriminant < 0 && return -1, -1, Inf
  u₁float = max((sqrt(discriminant) + b) / (-2a), float(u₁step)) # must be at least 1
  u₂float = (RR - u₁float * R₂) / (u₁float * R₁)
  u₁float_finite = isfinite(u₁float)
  u₂float_finite = isfinite(u₂float)
  if !(u₁float_finite & u₂float_finite) # brute force
    u₁high =
      Core.ifelse(iszero(X₃), u₁step, Core.ifelse(atleast31registers, 8, 6))
    u₂high =
      Core.ifelse(iszero(X₂), u₂step, Core.ifelse(atleast31registers, 8, 6))
    return solve_unroll_iter(
      X,
      R,
      u₁L,
      u₂L,
      u₁step:u₁step:u₁high,
      u₂step:u₂step:u₂high
    )
  end
  u₁low = floor(Int, u₁float)
  u₂low = max(u₂step, floor(Int, 0.8u₂float)) # must be at least 1
  u₁high = solve_unroll_constT(R, u₂low) + u₁step
  u₂high = solve_unroll_constU(R, u₁low) + u₂step
  if u₁low ≥ u₁high
    u₁low = solve_unroll_constT(R, u₂high)
  end
  if u₂low ≥ u₂high
    u₂low = solve_unroll_constU(R, u₁high)
  end
  maxunroll = atleast31registers ? (((X₂ > 0) & (X₃ > 0)) ? 10 : 8) : 6
  u₁low = (clamp(u₁low, u₁step, maxunroll) ÷ u₁step) * u₁step
  u₂low = (clamp(u₂low, u₂step, maxunroll) ÷ u₂step) * u₂step
  u₁high = clamp(u₁high, 1, maxunroll)
  u₂high = clamp(u₂high, 1, maxunroll)
  solve_unroll_iter(
    X,
    R,
    u₁L,
    u₂L,
    reverse(u₁low:u₁step:u₁high),
    reverse(u₂low:u₂step:u₂high)
  )
end

function solve_unroll_constU(R::AbstractVector, u₁::Int)
  denom = u₁ * R[1] + R[3]
  iszero(denom) && return 8
  floor(Int, (R[4] - u₁ * R[2]) / denom)
end
function solve_unroll_constT(R::AbstractVector, u₂::Int)
  denom = u₂ * R[1] + R[2]
  iszero(denom) && return 8
  floor(Int, (R[4] - u₂ * R[3]) / denom)
end
# function solve_unroll_constT(ls::LoopSet, u₂::Int)
#     R = @view ls.reg_pres[:,1]
#     denom = u₂ * R[1] + R[2]
#     iszero(denom) && return 8
#     floor(Int, (dynamic_register_count() - R[3] - R[4] - u₂*R[5]) / (u₂ * R[1] + R[2]))
# end
# Tiling here is about alleviating register pressure for the UxT
function solve_unroll(
  X,
  R,
  u₁max,
  u₂max,
  u₁L,
  u₂L,
  u₁step,
  u₂step,
  atleast31registers::Bool
)
  # iszero(first(R)) && return -1,-1,Inf #solve_smalltilesize(X, R, u₁max, u₂max)
  u₁, u₂, cost =
    solve_unroll_lagrange(X, R, u₁L, u₂L, u₁step, u₂step, atleast31registers)
  # u₂ -= u₂ & 1
  # u₁ = min(u₁, u₂)
  u₁_too_large = u₁ > u₁max
  u₂_too_large = u₂ > u₂max
  if u₁_too_large
    u₁ = u₁max
    if u₂_too_large
      u₂ = u₂max
    else # u₁ too large, resolve u₂
      u₂ = min(u₂max, max(1, solve_unroll_constU(R, u₁)))
    end
    cost = unroll_cost(X, u₁, u₂, u₁L, u₂L)
  elseif u₂_too_large
    u₂ = u₂max
    u₁ = min(u₁max, max(1, solve_unroll_constT(R, u₂)))
    cost = unroll_cost(X, u₁, u₂, u₁L, u₂L)
  end
  u₁, u₂, cost
end
maybedemotesize(U::Int, N::Int) = num_iterations(N, num_iterations(N, U))
function maybedemotesize(u₂::Int, N::Int, U::Int, Uloop::Loop, maxu₂base::Int)
  u₂ > 1 || return 1
  u₂ == N && return u₂
  u₂ = maybedemotesize(u₂, N)
  if !(isstaticloop(Uloop) && length(Uloop) == U)
    if N % u₂ != 0
      u₂ = min(u₂, maxu₂base)
    end
  end
  u₂
end

function solve_unroll(
  ls::LoopSet,
  u₁loopsym::Symbol,
  u₂loopsym::Symbol,
  cost_vec::AbstractVector{Float64},
  reg_pressure::AbstractVector{Float64},
  W::Int,
  vloopsym::Symbol,
  rounduᵢ::Int
)
  (u₁step, u₂step) = if rounduᵢ == 1 # max is to safeguard against some weird arch I've never heard of.
    (clamp(cache_lnsze(ls) ÷ reg_size(ls), 1, 4), 1)
  elseif rounduᵢ == 2
    (1, clamp(cache_lnsze(ls) ÷ reg_size(ls), 1, 4))
  elseif rounduᵢ == -1
    (8 ÷ ls.vector_width, 1)
  elseif rounduᵢ == -2
    (1, 8 ÷ ls.vector_width)
  else
    (1, 1)
  end
  u₁loop = getloop(ls, u₁loopsym)
  u₂loop = getloop(ls, u₂loopsym)
  solve_unroll(
    u₁loopsym,
    u₂loopsym,
    cost_vec,
    reg_pressure,
    W,
    vloopsym,
    u₁loop,
    u₂loop,
    u₁step,
    u₂step,
    reg_count(ls) ≥ 31
  )
end

function solve_unroll(
  u₁loopsym::Symbol,
  u₂loopsym::Symbol,
  cost_vec::AbstractVector{Float64},
  reg_pressure::AbstractVector{Float64},
  W::Int,
  vloopsym::Symbol,
  u₁loop::Loop,
  u₂loop::Loop,
  u₁step::Int,
  u₂step::Int,
  atleast31registers::Bool
)
  maxu₂base = maxu₁base = atleast31registers ? 10 : 6#8
  maxu₂ = maxu₂base#8
  maxu₁ = maxu₁base#8
  u₁L = length(u₁loop)
  u₂L = length(u₂loop)
  if isstaticloop(u₂loop)
    if u₂loopsym !== vloopsym && u₂L ≤ 4
      if isstaticloop(u₁loop)
        u₁ = max(solve_unroll_constT(reg_pressure, u₂L), 1)
        u₁ = maybedemotesize(u₁, u₁loopsym === vloopsym ? cld(u₁L, W) : u₁L)
      else
        u₁ = clamp(solve_unroll_constT(reg_pressure, u₂L), 1, 8)
      end
      return u₁, u₂L, unroll_cost(cost_vec, u₁, u₂L, u₁L, u₂L)
    end
    u₂Ltemp = u₂loopsym === vloopsym ? cld(u₂L, W) : u₂L
    maxu₂ = min(4maxu₂, u₂Ltemp)
  end
  if isstaticloop(u₁loop)
    if u₁loopsym !== vloopsym && u₁L ≤ 4
      if isstaticloop(u₂loop)
        u₂ = max(solve_unroll_constU(reg_pressure, u₁L), 1)
        u₂ = maybedemotesize(u₂, u₂loopsym === vloopsym ? cld(u₂L, W) : u₂L)
      else
        u₂ = clamp(solve_unroll_constU(reg_pressure, u₁L), 1, 8)
      end
      return u₁L, u₂, unroll_cost(cost_vec, u₁L, u₂, u₁L, u₂L)
    end
    u₁Ltemp = u₁loopsym === vloopsym ? cld(u₁L, W) : u₁L
    maxu₁ = min(4maxu₁, u₁Ltemp)
  end
  if u₁loopsym === vloopsym
    u₁Lf = u₁L / W
  else
    u₁Lf = Float64(u₁L)
  end
  if u₂loopsym === vloopsym
    u₂Lf = u₂L / W
  else
    u₂Lf = Float64(u₂L)
  end
  u₁, u₂, cost = solve_unroll(
    cost_vec,
    reg_pressure,
    maxu₁,
    maxu₂,
    u₁Lf,
    u₂Lf,
    u₁step,
    u₂step,
    atleast31registers
  )
  # heuristic to more evenly divide small numbers of iterations
  if isstaticloop(u₂loop)
    u₂ = maybedemotesize(u₂, length(u₂loop), u₁, u₁loop, maxu₂base)
  end
  if isstaticloop(u₁loop)
    u₁ = maybedemotesize(u₁, length(u₁loop), u₂, u₂loop, maxu₁base)
  end
  u₁, u₂, cost
end

function set_upstream_family!(adal::Vector{T}, op::Operation, val::T) where {T}
  adal[identifier(op)] == val && return # must already have been set
  adal[identifier(op)] = val
  for opp ∈ parents(op)
    set_upstream_family!(adal, opp, val)
  end
end
function loopdepindices(ls::LoopSet, op::Operation)
  loopdeps = loopdependencies(op.ref)
  isdiscontig = first(loopdeps) === DISCONTIGUOUS
  # isdiscontig = isdiscontiguous(op.ref)
  loopedindex = op.ref.loopedindex
  if !isdiscontig && all(loopedindex) && !(any(==(CONSTANTZEROINDEX), loopdeps))
    return loopdeps
  end
  loopdepsret = Symbol[]
  for i ∈ eachindex(loopedindex)
    if loopedindex[i]
      loopdeps[i+isdiscontig] === CONSTANTZEROINDEX ||
        push!(loopdepsret, loopdeps[i+isdiscontig])
    else
      oploopdeps = loopdependencies(findparent(ls, loopdeps[i+isdiscontig]))
      for ld ∈ oploopdeps
        (ld ∉ loopdepsret) && push!(loopdepsret, ld)
      end
    end
  end
  loopdepsret
end
function stride_penalty(
  ls::LoopSet,
  op::Operation,
  order::Vector{Symbol},
  loopfreqs
)
  loopdeps = loopdepindices(ls, op)
  opstrides = Vector{Int}(undef, length(loopdeps))
  # very minor stride assumption here, because we don't really want to base optimization decisions on it...
  opstrides[1] =
    1.0 +
    (first(loopdependencies(op.ref)) === DISCONTIGUOUS) +
    (first(loopdependencies(op.ref)) === CONSTANTZEROINDEX)
  l = Float64(length(getloop(ls, first(loopdeps))))
  for i ∈ 2:length(loopdeps)
    looplength = length(getloop(ls, loopdeps[i-1]))
    opstrides[i] = opstrides[i-1] * looplength
    l *= looplength
    # opstrides[i] = opstrides[i-1] * length(loops[i-1])
  end
  penalty = 0.0
  for i ∈ eachindex(order)
    id = findfirst(Base.Fix2(===, order[i]), loopdeps)
    if !(id === nothing)
      penalty += loopfreqs[i] * opstrides[id]
    end
  end
  penalty * l
end
function stride_penalty(ls::LoopSet, order::Vector{Symbol})
  stridepenaltydict = Dict{Symbol,Vector{Float64}}()
  loopfreqs = Vector{Int}(undef, length(order))
  loopfreqs[1] = 1
  for i ∈ 2:length(order)
    loopfreqs[i] = loopfreqs[i-1] * length(getloop(ls, order[i]))
  end
  for op ∈ operations(ls)
    if accesses_memory(op)
      v = get!(() -> Float64[], stridepenaltydict, op.ref.ref.array)
      push!(v, stride_penalty(ls, op, order, loopfreqs))
    end
  end
  if iszero(length(values(stridepenaltydict)))
    0.0
  else # 1 / 1024 = 0.0009765625
    50.0sum(maximum, values(stridepenaltydict)) *
    Base.power_by_squaring(0.0009765625, length(order))
  end
end

function isuniqueinindices(ls::LoopSet, op::Operation, opp::Operation, i::Int)
  ld = loopdependencies(opp)
  inds = getindicesonly(op)
  li = op.ref.loopedindex
  for j ∈ eachindex(inds)
    i == j && continue
    if li[j]
      inds[j] ∈ ld && return false
    else
      opp = findparent(ls, inds[i+(first(inds)===DISCONTIGUOUS)])
      any(in(ld), loopdependencies(opp)) && return false
    end
  end
  true
end
function isoptranslation(ls::LoopSet, op::Operation, unrollsyms::UnrollSymbols)
  @unpack u₁loopsym, u₂loopsym, vloopsym = unrollsyms
  (vloopsym == u₁loopsym || vloopsym == u₂loopsym) && return 0, 0x00
  (isu₁unrolled(op) && isu₂unrolled(op)) || return 0, 0x00
  u₁step = step(getloop(ls, u₁loopsym))
  u₂step = step(getloop(ls, u₂loopsym))
  (isknown(u₁step) & isknown(u₂step)) || return 0, 0x00
  abs(gethint(u₁step)) == abs(gethint(u₂step)) || return 0, 0x00

  istranslation = 0
  inds = getindices(op)
  li = op.ref.loopedindex
  for i ∈ eachindex(li)
    if !li[i]
      opp = findparent(ls, inds[i+(first(inds)===DISCONTIGUOUS)])
      if isu₁unrolled(opp) & isu₂unrolled(opp)
        if Base.sym_in(instruction(opp).instr, (:vadd_nsw, :(+)))
          isuniqueinindices(ls, op, opp, i) || return 0, 0x00
          return i, 0x03 # 00000011 - both positive
        elseif Base.sym_in(instruction(opp).instr, (:vsub_nsw, :(-)))
          isuniqueinindices(ls, op, opp, i) || return 0, 0x00
          oppp1 = parents(opp)[1]
          if isu₁unrolled(oppp1)
            return i, 0x01 # 00000001 - u₁ positive, u₂ negative
          else#isu₂unrolled(oppp1)
            return i, 0x02 # 00000010 - u₂ positive, u₁ negative
          end
        end
      end
    end
  end
  0, 0x00
end
# function maxnegativeoffset_old(ls::LoopSet, op::Operation, u::Symbol)
#     opmref = op.ref
#     opref = opmref.ref
#     mno = typemin(Int)
#     id = 0
#     opoffs = opref.offsets
#     for opp ∈ operations(ls)
#         opp === op && continue
#         oppmref = opp.ref
#         oppref = oppmref.ref
#         sameref(opref, oppref) || continue
#         opinds = getindicesonly(op)
#         oppinds = getindicesonly(opp)
#         oppoffs = oppref.offsets
#         # oploopi = opmref.loopedindex
#         # opploopi = oppmref.loopedindex
#         mnonew = typemin(Int)
#         for i ∈ eachindex(opinds)
#             if opinds[i] === u
#                 mnonew = (opoffs[i] - oppoffs[i])
#             elseif opoffs[i] != oppoffs[i]
#                 mnonew = 1
#                 break
#             end
#         end
#         if mno < mnonew < 0
#             mno = mnonew
#             id = identifier(opp)
#         end
#     end
#     mno, id
# end
function maxnegativeoffset(ls::LoopSet, op::Operation, u::Symbol)
  mno::Int = typemin(Int)
  id = 0
  isknown(step(getloop(ls, u))) || return mno, id
  omop = offsetloadcollection(ls)
  collectionid, opind = omop.opidcollectionmap[identifier(op)]
  collectionid == 0 && return mno, id
  @unpack opids = omop

  opidcol = opids[collectionid]
  opid = identifier(op)
  opoffs = getoffsets(op)
  opstrd = getstrides(op)
  ops = operations(ls)
  opindices = getindicesonly(op)
  for oppid ∈ opidcol
    opid == oppid && continue
    opp = ops[oppid]
    oppoffs = getoffsets(opp)
    oppstrd = getstrides(opp)
    mnonew::Int = typemin(Int)
    for i ∈ eachindex(opindices)
      strd = opstrd[i]
      strd == oppstrd[i] == 1 || continue
      if opindices[i] === u
        mnonew = (opoffs[i] % Int) - (oppoffs[i] % Int)
        # mnonew_t, mnonew_rem = divrem((opoffs[i] % Int) - (oppoffs[i] % Int), strd % Int)
        # mnonew_rem == 0 || continue
        # mnonew = mnonew_t
      elseif opoffs[i] != oppoffs[i]
        mnonew = 1
        break
      end
    end
    if mno < mnonew < 0
      mno = mnonew
      id = identifier(opp)
    end
  end
  mno, id
end
function maxnegativeoffset(
  ls::LoopSet,
  op::Operation,
  unrollsyms::UnrollSymbols
)
  @unpack u₁loopsym, u₂loopsym, vloopsym = unrollsyms
  mno = typemin(Int)
  i = 0
  if u₁loopsym !== vloopsym
    mnou₁ = first(maxnegativeoffset(ls, op, u₁loopsym))
    if mnou₁ > mno
      i = 1
      mno = mnou₁
    end
  end
  if u₂loopsym !== vloopsym
    mnou₂ = first(maxnegativeoffset(ls, op, u₂loopsym))
    if mnou₂ > mno
      i = 2
      mno = mnou₂
    end
  end
  mno, i
end
function load_elimination_cost_factor!(
  cost_vec,
  reg_pressure,
  choose_to_inline,
  ls::LoopSet,
  op::Operation,
  iters,
  unrollsyms::UnrollSymbols,
  Wshift,
  size_T
)
  @unpack u₁loopsym, u₂loopsym, vloopsym = unrollsyms
  if !iszero(first(isoptranslation(ls, op, unrollsyms)))
    rt, lat, rp = cost(ls, op, (u₁loopsym, u₂loopsym), vloopsym, Wshift, size_T)
    # rt = Core.ifelse(isvectorized(op), 0.5rt, rt)
    rto = rt
    rt *= iters
    # rt *= factor1; rp *= factor2;
    choose_to_inline[] = true
    # for loop ∈ ls.loops
    #     # If another loop is short, assume that LLVM will unroll it, in which case
    #     # we want to be a little more conservative in terms of register pressure.
    #     #FIXME: heuristic hack to get some desired behavior.
    #     if isstaticloop(loop) && length(loop) ≤ 4
    #         itersym = loop.itersymbol
    #         if itersym !== u₁loopsym && itersym !== u₂loopsym
    #             return (0.25, dynamic_register_count() == 32 ? 2.0 : 1.0)
    #             # return (0.25, 1.0)
    #             return true
    #         end
    #     end
    # end
    # u₁c, u₂c = child_dependent_u₁u₂(op)
    # rp = max(zero(rp), rp - one(rp))
    # # (0.25, dynamic_register_count() == 32 ? 1.2 : 1.0)
    # (0.25, 1.0)
    # cost_vec[1] -= rt
    # cost_vec[1] -= 0.5625 * iters
    # cost_vec[1] -= 0.5625 * iters / 2
    # reg_pressure[1] += 0.25rp
    reg_pressure[1] += 0.25rp
    cost_vec[2] += rt
    reg_pressure[2] += rp
    cost_vec[3] += rt
    # currently only place `reg_pressure[3]` is updated
    reg_pressure[3] += rp
    true
  else
    (1.0, 1.0)
    false
  end
end
function loadintostore(ls::LoopSet, op::Operation)
  isload(op) || return false # leads to bad behavior more than it helps
  for opp ∈ operations(ls)
    isstore(opp) && opp.ref == op.ref && return true
  end
  false
end
function store_load_deps!(deps::Vector{Symbol}, op::Operation, compref = op.ref)
  for opp ∈ parents(op)
    for ld ∈ loopdependencies(opp)
      (ld ∈ deps) || push!(deps, ld)
    end
    for ld ∈ reduceddependencies(opp)
      (ld ∈ deps) || push!(deps, ld)
    end
    if isload(opp)
      (opp.ref == compref) && return true
    else
      store_load_deps!(deps, opp, compref) && return true
    end
  end
  false
end
function store_load_deps(op::Operation)::Union{Nothing,Vector{Symbol}}
  isstore(op) || return nothing
  deps = copy(loopdependencies(op))
  store_load_deps!(deps, op) ? deps : nothing
end
function store_load_deps(ops::Vector{Operation})
  sld = Vector{Vector{Symbol}}(undef, length(ops))
  for i ∈ eachindex(sld)
    sldᵢ = store_load_deps(ops[i])
    sldᵢ ≢ nothing && (sld[i] = sldᵢ)
  end
  sld
end

function add_constant_offset_load_elmination_cost!(
  X,
  R,
  choose_to_inline,
  ls::LoopSet,
  op::Operation,
  iters,
  unrollsyms::UnrollSymbols,
  u₁reduces::Bool,
  u₂reduces::Bool,
  Wshift::Int,
  size_T::Int,
  opisininnerloop::Bool
)
  @unpack u₁loopsym, u₂loopsym, vloopsym = unrollsyms
  offset, uid = maxnegativeoffset(ls, op, unrollsyms)
  if -4 < offset < 0
    udependent_reduction = (-1 - offset) / 3 # -3, -2, -1 -> 2/3, 1/3, 0/3
    uindependent_increase = (4 + offset) / 3 # -3, -2, -1 -> 1/3, 2/3, 3/3
    rt, lat, rp = cost(ls, op, (u₁loopsym, u₂loopsym), vloopsym, Wshift, size_T)
    rt *= iters
    rp = opisininnerloop ? rp : zero(rp)
    # if loadintostore(ls, op) # For now, let's just avoid unrolling in this way...
    #     rt = Inf
    # end
    # u_uid is getting eliminated
    # we treat this as the unrolled loop getting eliminated is split into 2 parts:
    # 1 a non-cost-reduced part, with factor udependent_reduction
    # 2 a cost-reduced part, with factor uindependent_increase
    if opisininnerloop
      u₁c, u₂c = child_dependent_u₁u₂(op)
      rp = max(zero(rp), rp - one(rp))
    end
    if uid == 1 # u₁reduces was false
      @assert !u₁reduces
      # max negative offset was in the u₁ unroll direction
      update_cost_vec!(X, rt * uindependent_increase, true, u₂reduces)
      update_cost_vec!(X, rt * udependent_reduction, false, u₂reduces)
      update_reg_pres!(R, rp * uindependent_increase, true, u₂reduces)
      update_reg_pres!(R, rp * udependent_reduction, false, u₂reduces)
    elseif uid == 2 # u₂reduces was false
      @assert !u₂reduces
      update_cost_vec!(X, rt * uindependent_increase, u₁reduces, true)
      update_cost_vec!(X, rt * udependent_reduction, u₁reduces, false)
      update_reg_pres!(R, rp * uindependent_increase, u₁reduces, true)
      update_reg_pres!(R, rp * udependent_reduction, u₁reduces, false)
    else
      throw("uid somehow did not return 1 or 2, even though offset > -4.")
    end
    choose_to_inline[] = true
    return true
  else
    return false
  end
end

update_cost_vec!(costs, cost, u₁reduces, u₂reduces) = @inbounds if u₁reduces &
                                                                   u₂reduces
  costs[4] += cost
elseif u₂reduces # cost decreased by unrolling u₂loop
  costs[2] += cost
elseif u₁reduces # cost decreased by unrolling u₁loop
  costs[3] += cost
else # no cost decrease; cost must be repeated
  costs[1] += cost
end
update_reg_pres!(rp, cost, u₁reduces, u₂reduces) = @inbounds if u₁reduces# & u₂reduces
  rp[4] -= cost
elseif u₂reduces # cost decreased by unrolling u₂loop
  rp[2] += cost
  # elseif u₁reduces # cost decreased by unrolling u₁loop
  # rp[4] -= cost
else # no cost decrease; cost must be repeated
  rp[1] += cost
end
function child_dependent_u₁u₂(op::Operation)
  u₁ = u₂ = false
  for opc ∈ children(op)
    u₁ |= isu₁unrolled(opc)
    u₂ |= isu₂unrolled(opc)
  end
  u₁, u₂
end
function evaluate_cost_tile(
  ls::LoopSet,
  order::Vector{Symbol},
  unrollsyms::UnrollSymbols,
  anyisbit::Bool = false
)
  nops = length(operations(ls))
  iters = Vector{Float64}(undef, nops)
  reduced_by_unrolling = Array{Bool}(undef, 2, 2, nops)
  fill_children!(ls)
  evaluate_cost_tile!(
    iters,
    reduced_by_unrolling,
    ls,
    order,
    unrollsyms,
    anyisbit
  )
end
function evaluate_cost_tile!(
  iters::Vector{Float64},
  reduced_by_unrolling::Array{Bool,3},
  ls::LoopSet,
  order::Vector{Symbol},
  unrollsyms::UnrollSymbols,
  anyisbit::Bool,
  sld::Vector{Vector{Symbol}} = store_load_deps(operations(ls)),
  holdopinreg::Vector{Bool} = holdopinregister(ls)
)
  N = length(order)
  @assert N ≥ 2 "Cannot tile merely $N loops!"
  @unpack u₁loopsym, u₂loopsym, vloopsym = unrollsyms
  cacheunrolled!(ls, u₁loopsym, u₂loopsym, vloopsym)
  # println("\n")
  # u₂loopsym = order[1]
  # u₁loopsym = order[2]
  ops = operations(ls)
  nops = length(ops)
  included_vars = resize!(ls.included_vars, nops)
  descendentsininnerloop = resize!(ls.place_after_loop, nops)
  @inbounds for i ∈ 1:nops
    included_vars[i] = false
    descendentsininnerloop[i] = false
    reduced_by_unrolling[1, 1, i] = false
    reduced_by_unrolling[2, 1, i] = false
    reduced_by_unrolling[1, 2, i] = false
    reduced_by_unrolling[2, 2, i] = false
    iters[i] = -99.9
  end
  innerloop = last(order)
  nested_loop_syms = Symbol[]# Set{Symbol}()
  # Need to check if fusion is possible
  size_T = biggest_type_size(ls)
  W, Wshift = lsvecwidthshift(ls, vloopsym, size_T)
  # costs =
  # cost_mat[1] / ( unrolled * u₂loopsym)
  # cost_mat[2] / ( u₂loopsym)
  # cost_mat[3] / ( unrolled)
  # cost_mat[4]

  cost_vec = cost_vec_buf(ls)
  reg_pressure = reg_pres_buf(ls)
  iter::Float64 = 1.0
  u₁reached = u₂reached = false
  choose_to_inline = Ref(false)
  copyto!(names(ls), order)
  reverse!(names(ls))
  prefetch_good_idea = false
  # goes from outer to inner
  for n ∈ 1:N
    itersym = order[n]
    if itersym == u₁loopsym
      u₁reached = true
    elseif itersym == u₂loopsym
      u₂reached = true
    end
    # Add to set of defined symbols
    push!(nested_loop_syms, itersym)
    looplength = length(ls, itersym)
    iter *= itersym === vloopsym ? num_iterations(looplength, W) : looplength
    # check which vars we can define at this level of loop nest
    for (id, op) ∈ enumerate(ops)
      # isconstant(op) && continue
      # @assert id == identifier(op)+1 # testing, for now
      # won't define if already defined...
      included_vars[id] && continue
      # it must also be a subset of defined symbols
      _maybe_continue = true
      for ld ∈ loopdependencies(op)
        mbc = false
        for nls ∈ nested_loop_syms
          if ld === nls
            mbc = true
            break
          end
        end
        if !mbc
          _maybe_continue = false
          break
        end
      end
      # @assert _maybe_continue == all(ld -> ld ∈ nested_loop_syms, loopdependencies(op))
      _maybe_continue || continue
      # all(ld -> ld ∈ nested_loop_syms, loopdependencies(op)) || continue
      # rd = reduceddependencies(op)
      # if hasintersection(rd, @view(nested_loop_syms[1:end-length(rd)]))
      #     return 0,0,Inf,false
      # end
      (isassigned(sld, id) && any(s -> (s ∉ sld[id]), nested_loop_syms)) &&
        return 0, 0, Inf, false
      included_vars[id] = true
      if isconstant(op)
        depends_on_u₁, depends_on_u₂ =
          isunrolled_sym(op, u₁loopsym, u₂loopsym, vloopsym)
        reduced_by_unrolling[1, 1, id] = !depends_on_u₁
        reduced_by_unrolling[2, 1, id] = !depends_on_u₂
      else
        depends_on_u₁ = isu₁unrolled(op)
        depends_on_u₂ = isu₂unrolled(op)
        reduced_by_unrolling[1, 1, id] = (u₁reached) & !depends_on_u₁
        reduced_by_unrolling[2, 1, id] = (u₂reached) & !depends_on_u₂
      end
      # cost is reduced by unrolling u₁ if it is interior to u₁loop (true if either u₁reached, or if depends on u₂ [or u₁]) and doesn't depend on u₁
      inner₁ = u₁reached | depends_on_u₂
      inner₂ = u₂reached | depends_on_u₁
      # if isconstantop(op)
      reduced_by_unrolling[1, 2, id] = inner₁ & !depends_on_u₁
      reduced_by_unrolling[2, 2, id] = inner₂ & !depends_on_u₂
      # else
      #   reduced_by_unrolling[1,2,id] = inner₁ & !depends_on_u₁
      #   reduced_by_unrolling[2,2,id] = inner₂ & !depends_on_u₂
      # end
      iters[id] = iter
      innerloop ∈ loopdependencies(op) &&
        set_upstream_family!(descendentsininnerloop, op, true)
    end
  end
  irreducible_storecosts = 0.0
  for (id, op) ∈ enumerate(ops)
    iters[id] == -99.9 && continue
    opisininnerloop = descendentsininnerloop[id]
    u₁reducesrt, u₂reducesrt =
      reduced_by_unrolling[1, 1, id], reduced_by_unrolling[2, 1, id]
    u₁reducesrp, u₂reducesrp =
      reduced_by_unrolling[1, 2, id], reduced_by_unrolling[2, 2, id]
    if isload(op)
      if add_constant_offset_load_elmination_cost!(
        cost_vec,
        reg_pressure,
        choose_to_inline,
        ls,
        op,
        iters[id],
        unrollsyms,
        u₁reducesrp,
        u₂reducesrp,
        Wshift,
        size_T,
        opisininnerloop
      )
        continue
      elseif load_elimination_cost_factor!(
        cost_vec,
        reg_pressure,
        choose_to_inline,
        ls,
        op,
        iters[id],
        unrollsyms,
        Wshift,
        size_T
      )
        continue
      end
    end
    rt, lat, rp = cost(ls, op, (u₁loopsym, u₂loopsym), vloopsym, Wshift, size_T)
    if isload(op) & (!prefetch_good_idea)
      prefetch_good_idea =
        prefetchisagoodidea(ls, op, UnrollArgs(ls, 4, unrollsyms, 4, 0)) ≠ 0
    end
    # rp = (opisininnerloop && !(loadintostore(ls, op))) ? rp : zero(rp) # we only care about register pressure within the inner most loop
    rp = if opisininnerloop # we only care about register pressure within the inner most loop
      rp
    else #FIXME: hack to not go crazy
      max(zero(rp), rp - one(rp))
    end
    # rto = rt
    rt *= iters[id]
    if isstore(op) & (!u₁reducesrt) & (!u₂reducesrt)
      irreducible_storecosts += rt
    end
    update_cost_vec!(cost_vec, rt, u₁reducesrt, u₂reducesrt)
    # if child_dependent_u₁u₂(op)
    if iscompute(op) | isload(op)
      if !holdopinreg[id]
        rp = max(zero(rp), rp - one(rp))
      elseif innerloop ∈ loopdependencies(op)
        u₁c, u₂c = child_dependent_u₁u₂(op)
        # The idea here is that we check if the operation is executed in the innermost loop nest
        #   - If this is true, then the operation must be recalculated on every iteration of the inner most loop
        # 
        # Then we check if it's children don't depend on both unrolled loops. If they do not depend on both,
        # we assume that these children can safely overwrite the results of this operation.
        # (Because this op has to be recalculated on the next iteration, there's no point to holding it somewhere)
        if !(u₁c & u₂c)
          # if u₁reducesrp & u₂reducesrp & !(u₁c & u₂c)
          rp = max(zero(rp), rp - one(rp))
        end
      end
    end
    update_reg_pres!(reg_pressure, rp, u₁reducesrp, u₂reducesrp)
    # end
    # update_costs!(reg_pressure, rp, u₁reducesrp, u₂reducesrp)
  end
  # reg_pressure[1] = max(reg_pressure[1], length(ls.outer_reductions))
  # @inbounds ((cost_vec[4] > 0) || ((cost_vec[2] > 0) & (cost_vec[3] > 0))) || return 0,0,Inf,false
  # reg_pres[4] == remaining_registers
  costpenalty =
    ((reg_pressure[1] + reg_pressure[2] + reg_pressure[3]) > reg_pressure[4]) ?
    2 : 1
  u₁v = vloopsym === u₁loopsym
  u₂v = vloopsym === u₂loopsym
  visbit = anyisbit && ls.loopindexesbit[getloopid(ls, vloopsym)]
  round_uᵢ = if visbit
    (u₁v ? -1 : (u₂v ? -2 : 0))
  elseif prefetch_good_idea
    (u₁v ? 1 : (u₂v ? 2 : 0))
  else
    0
  end
  if (irreducible_storecosts / sum(cost_vec) ≥ 0.5) &&
     !any(op -> loadintostore(ls, op), operations(ls))
    u₁, u₂ = if visbit
      vecsforbyte = 8 ÷ ls.vector_width
      u₁v ? (vecsforbyte, 1) : (1, vecsforbyte)
    else
      (1, 1)
    end
    ucost = unroll_cost(
      cost_vec,
      1,
      1,
      length(getloop(ls, u₁loopsym)),
      length(getloop(ls, u₂loopsym))
    )
  else
    u₁, u₂, ucost = solve_unroll(
      ls,
      u₁loopsym,
      u₂loopsym,
      cost_vec,
      reg_pressure,
      W,
      vloopsym,
      round_uᵢ
    )
  end
  outer_reduct_penalty = length(ls.outer_reductions) * (u₁ + isodd(u₁))
  favor_bigger_u₂ = u₁ - u₂
  # favor_smaller_vloopsym = (u₁v ? u₁ : -u₁) + (u₂v ?  u₂ : -u₂)
  favor_smaller_vectorized = (u₁v ⊻ u₂v) ? (u₁v ? u₁ - u₂ : u₂ - u₁) : 0
  favor_u₁_vectorized = -0.2u₁v
  favoring_heuristics =
    favor_bigger_u₂ + 0.5favor_smaller_vectorized + favor_u₁_vectorized
  costpenalty =
    costpenalty * ucost +
    stride_penalty(ls, order) +
    outer_reduct_penalty +
    favoring_heuristics
  u₁, u₂, costpenalty, choose_to_inline[]
end

function holdopinregister(ls::LoopSet)
  ops = operations(ls)
  childdeps = fill(false, length(ops))
  # childdeps = fill(false, length(ls.loops), length(ops))
  for i ∈ eachindex(ops)
    op = ops[i]
    ld = loopdependencies(op)
    found = false
    for opc ∈ children(op)
      for j ∈ loopdependencies(opc)
        if j ∉ ld
          found = true
          break
        end
      end
      if found
        childdeps[i] = true
        break
      end
    end
  end
  childdeps
end

# struct LoopOrders
#     syms::Vector{Int}
#     buff::Vector{Int}
# end
# function LoopOrders(ls::LoopSet)
#   syms = collect(Base.OneTo(num_loops(ls)))
#   LoopOrders(syms, similar(syms))
# end
struct LoopOrders
  syms_nr::Vector{Symbol}
  syms_r::Vector{Symbol}
  buff::Vector{Symbol}
  state::Vector{Int}
end

function outer_reduct_loopordersplit(ls::LoopSet)
  ops = operations(ls)
  nonouterreducts = Int[]
  for i ∈ eachindex(ops)
    i ∈ ls.outer_reductions || push!(nonouterreducts, i)
  end
  reductsyms = Symbol[]
  nonreductsyms = Symbol[]
  for l ∈ ls.loopsymbols
    isreduct = false
    for opid ∈ nonouterreducts
      if l ∈ reduceddependencies(ops[opid])
        isreduct = true
        push!(reductsyms, l)
        break
      end
    end
    isreduct || push!(nonreductsyms, l)
  end
  reductsyms, nonreductsyms
end
function loopordersplit(ls::LoopSet)
  reductsyms = Symbol[]
  nonreductsyms = Symbol[]
  for l ∈ ls.loopsymbols
    isreduct = false
    for op ∈ operations(ls)
      if l ∈ reduceddependencies(op)
        isreduct = true
        push!(reductsyms, l)
        break
      end
    end
    isreduct || push!(nonreductsyms, l)
  end
  reductsyms, nonreductsyms
end
function LoopOrders(ls::LoopSet)
  if length(ls.outer_reductions) == 0
    reductsyms, nonreductsyms = loopordersplit(ls)
  else
    reductsyms, nonreductsyms = outer_reduct_loopordersplit(ls)
  end
  LoopOrders(
    nonreductsyms,
    reductsyms,
    Vector{Symbol}(undef, length(ls.loopsymbols)),
    Vector{Int}(undef, length(ls.loopsymbols))
  )
end

nonreductview(lo::LoopOrders) = @inbounds view(lo.buff, 1:length(lo.syms_nr))
reductview(lo::LoopOrders) = @inbounds view(lo.buff, 1+length(lo.syms_nr):length(lo.buff))
function Base.iterate(lo::LoopOrders)
  _copyto!(nonreductview(lo), lo.syms_nr)
  _copyto!(reductview(lo), lo.syms_r)
  nr = length(lo.syms_nr)
  r = length(lo.syms_r)
  state = lo.state
  _fill!(state,0)
  lo.buff, (view(state, 1:nr), view(state, 1+nr:nr+r))
end

function advance_state!(state)
  N = length(state)
  N > 1 || return false
  for n ∈ 1:N
    sₙ = state[n]
    if sₙ == N - n
      if n == N
        return false
      else
        state[n] = 0
      end
    else
      state[n] = sₙ + 1
      break
    end
  end
  true
end
function _copyto!(x,y)
  @inbounds for i = eachindex(x,y)
    x[i]=y[i]
  end
end
function _fill!(x,y)
  @inbounds for i = eachindex(x)
    x[i]=y
  end
end
function advance_state!(state, Nr)::Bool
  state_nr = view(state, 1:Nr)
  advance_state!(state_nr) && return true
  _fill!(state_nr, 0)
  advance_state!(view(state, 1+Nr:length(state)))
end
swap!(x::AbstractVector, i::Int, j::Int) = (x[j], x[i]) = (x[i], x[j])
function swap!(
  dest::AbstractVector{Symbol},
  src::AbstractVector{Symbol},
  offs::AbstractVector{Int}
)
  _copyto!(dest, src)
  for i ∈ eachindex(offs)
    sᵢ = offs[i]
    sᵢ == 0 || swap!(dest, i, i + sᵢ)
  end
end
# This is not a good algorithm
@inline function Base.iterate(lo::LoopOrders, states)
 (state_nr, state_r) = states
  if advance_state!(state_nr)
    swap!(nonreductview(lo), lo.syms_nr, state_nr)
  else
    advance_state!(state_r) || return nothing
    _fill!(state_nr, 0)
    _copyto!(nonreductview(lo), lo.syms_nr)
    swap!(reductview(lo), lo.syms_r, state_r)
  end
  lo.buff, (state_nr, state_r)
end

function reject_reorder(ls::LoopSet, loop::Int, isu₂::Bool)
  r = ls.validreorder[loop]
  r < Core.ifelse(isu₂, 0x01, 0x03)
end
function reject_reorder(ls::LoopSet, loop::Symbol, isu₂::Bool)
  for i ∈ eachindex(ls.loops)
    ls.loops[i].itersymbol === loop && return reject_reorder(ls, i, isu₂)
  end
  false
end

function choose_unroll_order(
  ls::LoopSet,
  lowest_cost::Float64 = Inf,
  sld::Vector{Vector{Symbol}} = store_load_deps(operations(ls)),
  v::Int = 0
)
  iszero(length(offsetloadcollection(ls).opidcollectionmap)) &&
    fill_offset_memop_collection!(ls)
  lo = LoopOrders(ls)
  new_order, state = iterate(lo) # right now, new_order === best_order
  vec_iter_prealloc = v == 0 ? new_order : [(ls.loops)[v].itersymbol]
  best_order = similar(new_order)
  best_vec = first(new_order)
  while true
    vec_iter = v == 0 ? new_order : vec_iter_prealloc
    for new_vec ∈ vec_iter
      reject_reorder(ls, new_vec, false) && continue
      cost_temp = evaluate_cost_unroll(ls, new_order, new_vec, lowest_cost, sld)
      if cost_temp < lowest_cost
        lowest_cost = cost_temp
        _copyto!(best_order, new_order)
        best_vec = new_vec
      end
    end
    iter = iterate(lo, state)
    iter === nothing && return best_order, best_vec, lowest_cost
    new_order, state = iter
  end
end

"""
This function searches for unrolling combinations that will cause LoopVectorization to generate invalid code.

Currently, it is only searching for one scenario, based on how `isunrolled_sym` and lowering currently work.
`isunrolledsym` tries to avoid the creation of excessive numbers of accumulation vectors in the case of reductions.
If an unrolled loop isn't reduced, it will need separate vectors.
But separate vectors for a reduced loop are not needed. Separate vectors will help to break up dependency chains,
so you want to unroll at least one of the loops. However, reductions demand combining all the separate vectors,
and each vector also eats a valuable register, so it's best to avoid excessive numbers these accumulation vectors.

If a reduced op depends on both unrolled loops (u1 and u2), it will check over which of these it is reduced. If...
neither: cannot avoid unrolling it along both
one of them: don't unroll the reduced loop
both of them: don't unroll along u2 (unroll along u1)

Now, a look at lowering:
It interleaves u1-unrolled operations in an effort to improve superscalar parallelism,
while u2-unrolled operations are lowered by block. E.g., op_u2id_u1id (as they're printed):

u2 = 0
opa_0_0 = fa(...)
opa_0_1 = fa(...)
opa_0_2 = fa(...)
opb_0_0 = fb(...)
opb_0_1 = fb(...)
opb_0_2 = fb(...)
u2 += 1
opa_1_0 = fa(...)
opa_1_1 = fa(...)
opa_1_2 = fa(...)
opb_1_0 = fb(...)
opb_1_1 = fb(...)
opb_1_2 = fb(...)

what if `opa` vectors were not replicated across u1?
opa_0_ = fa(...)
opa_0_ = fa(...)
opa_0_ = fa(...)

Then unless `fa` was taking the previous `opa_0_`s as an argument and updating them, this would be wrong, because it'd be overwriting the previous `opa_0_` values.
"""
function reject_candidate(op::Operation, u₁loopsym::Symbol, u₂loopsym::Symbol)
  if iscompute(op) &&
     u₁loopsym ∈ reduceddependencies(op) &&
     u₁loopsym ∈ loopdependencies(op)
    if u₂loopsym ∉ reduceddependencies(op) &&
       !any(opp -> name(opp) === name(op), parents(op))
      return true
    end
  end
  false
end
function reject_candidate(ls::LoopSet, u₁loopsym::Symbol, u₂loopsym::Symbol)
  for op ∈ operations(ls)
    reject_candidate(op, u₁loopsym, u₂loopsym) && return true
  end
  false
end
inlinedecision(inline::Int, shouldinline::Bool) =
  iszero(inline) ? shouldinline : isone(inline)

function choose_tile(
  ls::LoopSet,
  sld::Vector{Vector{Symbol}} = store_load_deps(operations(ls)),
  v::Int = 0
)
  iszero(length(offsetloadcollection(ls).opidcollectionmap)) &&
    fill_offset_memop_collection!(ls)
  lo = LoopOrders(ls)
  best_order = ls.loop_order.bestorder
  vec_iter_prealloc = v == 0 ? best_order : [(ls.loops)[v].itersymbol]
  bestu₁ = bestu₂ = best_vec = Symbol("")
  u₁ = u₂ = 0
  lowest_cost = Inf
  loadelim = false
  anyisbit = any(ls.loopindexesbit)

  nops = length(operations(ls))
  iters = Vector{Float64}(undef, nops)
  reduced_by_unrolling = Array{Bool}(undef, 2, 2, nops)
  holdopinreg = holdopinregister(ls)
  for newu₂ ∈ ls.loopsymbols
    reject_reorder(ls, newu₂, true) && continue
    for newu₁ ∈ ls.loopsymbols#@view(new_order[nt+1:end])
      (
        ((newu₁ == newu₂) || reject_reorder(ls, newu₁, true)) ||
        reject_candidate(ls, newu₁, newu₂)
      ) && continue
      new_order, state = iterate(lo) # right now, new_order === best_order
      while true
        vec_iter = v == 0 ? new_order : vec_iter_prealloc
        for new_vec ∈ vec_iter
          reject_reorder(ls, new_vec, false) && continue
          if anyisbit && ls.loopindexesbit[getloopid(ls, new_vec)]
            # ((new_vec === newu₁) || (new_vec === newu₂)) || continue
            (new_vec === newu₁) || continue
          end
          u₁temp, u₂temp, cost_temp, loadelim_temp = evaluate_cost_tile!(
            iters,
            reduced_by_unrolling,
            ls,
            new_order,
            UnrollSymbols(newu₁, newu₂, new_vec),
            anyisbit,
            sld,
            holdopinreg
          )
          # if cost_temp < lowest_cost # leads to 4 vmovapds
          if cost_temp ≤ lowest_cost # lead to 2 vmovapds
            lowest_cost = cost_temp
            u₁, u₂ = u₁temp, u₂temp
            best_vec = new_vec
            bestu₂ = newu₂
            bestu₁ = newu₁
            loadelim = loadelim_temp
            _copyto!(best_order, new_order)
            save_tilecost!(ls)
          end
        end
        iter = iterate(lo, state)
        iter === nothing && break
        new_order, state = iter
      end
    end
  end
  ls.loadelimination = loadelim
  # `any(...)` is a HACK: specialization can fail in Tullio's codegen, resulting in bad performance. See https://github.com/JuliaSIMD/LoopVectorization.jl/issues/245
  shouldinline = (looplengthprod(ls) < 4097.0) #|| any(op -> iscompute(op) && iszero(length(loopdependencies(op))), operations(ls))
  best_order, bestu₁, bestu₂, best_vec, u₁, u₂, lowest_cost, shouldinline
end
function mismatchedstorereductions(ls::LoopSet)
  reduceddeps = Vector{Symbol}[]
  nreduceddeps = 0
  for op ∈ operations(ls)
    isstore(op) || continue
    rd = reduceddependencies(first(parents(op)))
    if nreduceddeps ≠ 0
      length(rd) == nreduceddeps || return true
    else
      nreduceddeps = length(rd)
    end
    for rdo ∈ reduceddeps
      for s ∈ rdo
        s ∈ rd || return true
      end
    end
    push!(reduceddeps, rd)
  end
  false
end
# Last in order is the inner most loop
function choose_order_cost(ls::LoopSet, v::Int = 0)
  fill_children!(ls)
  resize!(ls.loop_order, length(ls.loopsymbols))
  sld = store_load_deps(operations(ls))
  if (num_loops(ls) > 1) && (length(ls.operations) ≤ 100)
    torder, tunroll, ttile, tvec, tU, tT, tc, shouldinline =
      choose_tile(ls, sld, v)
  else
    torder = names(ls) # dummy
    tunroll = ttile = tvec = Symbol("##undefined##") # dummy
    tU = tT = 0 # dummy
    tc = Inf
  end
  uorder, uvec, uc = choose_unroll_order(ls, tc, sld, v)
  mismatched = mismatchedstorereductions(ls)
  if num_loops(ls) > 1 && tc ≤ uc
    @assert ls.loop_order.bestorder === torder
    # _copyto!(ls.loop_order.bestorder, torder)
    return torder,
    tunroll,
    ttile,
    isone(ls.vector_width) ? Symbol("##not#vectorized##") : tvec,
    tU,
    tT,
    Core.ifelse(mismatched, Inf, tc),
    shouldinline
    # return torder, tvec, 4, 4#5, 5
  else
    _copyto!(ls.loop_order.bestorder, uorder)
    UF, uunroll = determine_unroll_factor(ls, uorder, uvec)
    return uorder,
    uunroll,
    Symbol("##undefined##"),
    isone(ls.vector_width) ? Symbol("##not#vectorized##") : uvec,
    UF,
    -1,
    Core.ifelse(mismatched, Inf, uc),
    true
  end
end
function choose_order(ls::LoopSet)
  order, unroll, tile, vec, u₁, u₂, c = choose_order_cost(ls)
  order, unroll, tile, vec, u₁, u₂
end

function prefetchisagoodidea(ls::LoopSet, op::Operation, td::UnrollArgs)
  # ((Sys.ARCH === :x86_64) || (Sys.ARCH === :i686)) || return false
  # return false
  @unpack u₁, u₁loopsym, u₂loopsym, vloopsym, vstep, u₂max, suffix = td
  length(loopdependencies(op)) ≤ 1 && return 0
  isvectorized(op) || return 0
  ((u₁ > 1) & (u₂max > 1)) || return 0
  u₂loopsym === Symbol("##undefined##") && return 0
  dontskip = (cache_lnsze(ls) ÷ reg_size(ls)) - 1
  # u₂loopsym is vectorized
  # u₁vectorized = vectorized === u₁loopsym
  u₂vectorized = vloopsym === u₂loopsym
  ((suffix ≠ -1) && u₂vectorized && !iszero(suffix & dontskip)) && return 0
  innermostloopsym = first(names(ls))
  loopedindex = op.ref.loopedindex
  if length(loopedindex) > 1 && first(loopedindex)
    indices = getindices(op)
    if first(indices) === vloopsym && first(indices) !== innermostloopsym
      (isone(vstep) && isone(first(getstrides(op)))) || return 0
      # We want at least 4 reuses per load
      uses = Core.ifelse(isu₁unrolled(op), 1, u₁)
      uses = Core.ifelse(isu₂unrolled(op), uses, uses * u₂max)
      uses < 4 && return 0
      innermostloopind = -1
      for (i, inds) ∈ enumerate(getindices(op))
        if inds === innermostloopsym
          innermostloopind == -1 || return 0
          innermostloopind = i
        end
      end
      innermostloopind == -1 && return 0
      # if prod(s -> Float64(looplength(ls, s)), @view(indices[1:innermostloopind-1])) ≥ 120.0 &&
      if length(getloop(ls, innermostloopsym)) ≥ 120
        if getoffsets(op)[innermostloopind] < 120
          for opp ∈ operations(ls)
            if iscompute(opp) &&
               (innermostloopsym ∈ loopdependencies(opp)) &&
               load_constrained(
                 opp,
                 u₁loopsym,
                 u₂loopsym,
                 innermostloopsym,
                 true
               )
              return 0
            end
          end
          return innermostloopind
        end
      end
    end
  end
  0
end
function add_prefetches!(
  q::Expr,
  ls::LoopSet,
  op::Operation,
  td::UnrollArgs,
  prefetchind::Int
)
  # TODO: maybe prefetch for non-x86_64?
  ((Sys.ARCH === :x86_64) || (Sys.ARCH === :i686)) || return nothing
  @unpack u₁, u₁loopsym, u₂loopsym, vloopsym, u₂max = td
  # we should only be here if `unitsride(vloop)`
  dontskip = (cache_lnsze(ls) ÷ reg_size(ls)) - 1
  ptr = vptr(op)
  innermostloopsym = first(names(ls))
  us = ls.unrollspecification
  prefetch_distance =
    u₁loopsym === innermostloopsym ? us.u₁ :
    (u₂loopsym === innermostloopsym ? us.u₂ : 1)
  # prefetch_distance = u₁loopsym === innermostloopsym ? u₁ : ( u₂loopsym === innermostloopsym ? u₂max : 1 )
  prefetch_multiplier = 5
  prefetch_distance *= prefetch_multiplier
  offsets = getoffsets(op) # what a hack
  inner_offset = offsets[prefetchind]
  prefetchstride = prefetch_distance * getstrides(op)[prefetchind]
  prefetchloop_step = step(getloop(ls, getindices(op)[prefetchind]))
  if isknown(prefetchloop_step)
    prefetchstride *= gethint(prefetchloop_step)
  end
  offsets[prefetchind] = inner_offset + prefetchstride
  gespinds = mem_offset_u(
    op,
    td,
    indices_calculated_by_pointer_offsets(ls, op.ref),
    false,
    0,
    ls,
    false
  )
  offsets[prefetchind] = inner_offset
  ptr = vptr(op)
  gptr = Symbol(ptr, "##GESPEDPREFETCH##")
  if !isknown(prefetchloop_step)
    for i ∈ eachindex(gespinds.args)
      if i == prefetchind
        gespinds.args[i] = mulexpr(
          getsym(prefetchloop_step),
          (gespinds.args[i])::Union{Symbol,Expr}
        )
      end
      # gespinds.args[i] = Expr(:call, lv(:data), gespinds.args[i])
    end
  end
  ip = GlobalRef(VectorizationBase, :increment_ptr)
  push!(
    q.args,
    Expr(:(=), gptr, Expr(:call, ip, ptr, vptr_offset(ptr), gespinds))
  )
  inds = Expr(:tuple)
  indices = getindicesonly(op)

  i = 0
  for (j, ind) ∈ enumerate(indices)
    push!(inds.args, Expr(:call, lv(:Zero)))
    (ind == u₁loopsym) && (i = j)
  end
  prefetch0 = GlobalRef(VectorizationBase, :prefetch)
  push!(q.args, Expr(:call, prefetch0, Expr(:call, ip, ptr, gptr, copy(inds))))
  # push!(q.args, Expr(:call, lv(:prefetch0), gptr, copy(inds)))
  i == 0 && return
  for u ∈ 1:u₁-1
    # for u ∈ umin:min(umin,U-1)
    # (u₁loopsym === vloopsym && !iszero(u & dontskip)) && continue
    if u₁loopsym === vloopsym
      iszero(u & dontskip) || continue
      # W = ls.vector_width[]
      # if W != 0
      #     inds.args[i] = staticexpr(W*u)
      # else
      if isone(u)
        inds.args[i] = VECTORWIDTHSYMBOL
      else
        inds.args[i] = mulexpr(VECTORWIDTHSYMBOL, u)
      end
    else
      inds.args[i] = staticexpr(u)
    end
    push!(
      q.args,
      Expr(:call, prefetch0, Expr(:call, ip, ptr, gptr, copy(inds)))
    )
  end
  nothing
end
broadcastedname(mvar) = Symbol(mvar, "##broadcasted##")
function pushbroadcast!(q::Expr, mvar::Symbol)
  push!(
    q.args,
    Expr(
      :(=),
      broadcastedname(mvar),
      Expr(:call, lv(:vbroadcast), VECTORWIDTHSYMBOL, mvar)
    )
  )
end

function child_cost_until_vectorized(op::Operation)
  isvectorized(op) && return 0.0
  c = 0.0
  for child ∈ children(op)
    if (!isvectorized(child) & iscompute(child))
      # FIXME: can double count
      c +=
        instruction_cost(instruction(child)).scalar_reciprocal_throughput +
        child_cost_until_vectorized(child)
    end
  end
  c
end
function vectorization_profitable(op::Operation)
  # if op is vectorized itself, return true
  isvectorized(op) && return true
  # otherwise, check if descendents until hitting a vectorized portion are expensive enough
  child_cost_until_vectorized(op) ≥ 5
end

function lower_load_no_optranslation!(
  q::Expr,
  ls::LoopSet,
  op::Operation,
  td::UnrollArgs,
  mask::Bool,
  inds_calc_by_ptr_offset::Vector{Bool}
)
  @unpack u₁, u₁loopsym, u₂loopsym, vloopsym, suffix = td
  # @assert isvectorized(op)
  opu₁, opu₂ = isunrolled_sym(op, u₁loopsym, u₂loopsym, vloopsym, ls)
  u = ifelse(opu₁, u₁, 1)
  mvar = Symbol(variable_name(op, Core.ifelse(opu₂, suffix, -1)), '_', u)
  falseexpr = Expr(:call, lv(:False))
  rs = staticexpr(reg_size(ls))
  if (!rejectcurly(op)) && vectorization_profitable(op)
    inds = unrolledindex(op, td, mask, inds_calc_by_ptr_offset, ls)
    loadexpr = Expr(:call, lv(:_vload), sptr(op), inds)
    add_memory_mask!(loadexpr, op, td, mask, ls, 0)
    push!(loadexpr.args, falseexpr, rs) # unaligned load
    push!(q.args, Expr(:(=), mvar, loadexpr))
  elseif (u₁ > 1) & opu₁
    t = Expr(:tuple)
    sptrsym = sptr!(q, op)
    for u ∈ 1:u₁
      inds =
        mem_offset_u(op, td, inds_calc_by_ptr_offset, true, u - 1, ls, false)
      loadexpr = Expr(:call, lv(:_vload), sptrsym, inds)
      domask =
        mask && (isvectorized(op) & ((u == u₁) | (vloopsym !== u₁loopsym)))
      add_memory_mask!(loadexpr, op, td, domask, ls, u)
      push!(loadexpr.args, falseexpr, rs)
      push!(t.args, loadexpr)
      # push!(q.args, Expr(:(=), mvar, loadexpr))
    end
    push!(q.args, Expr(:(=), mvar, Expr(:call, lv(:VecUnroll), t)))
  else
    inds = mem_offset_u(op, td, inds_calc_by_ptr_offset, true, 0, ls, false) # not unrolled
    loadexpr = Expr(:call, lv(:_vload), sptr(op), inds)
    add_memory_mask!(loadexpr, op, td, mask, ls, 0)
    push!(loadexpr.args, falseexpr, rs)
    push!(q.args, Expr(:(=), mvar, loadexpr))
  end
  if isvectorized(op)
    prefetchind = prefetchisagoodidea(ls, op, td)
    iszero(prefetchind) || add_prefetches!(q, ls, op, td, prefetchind)
  elseif any(isvectorized, children(op))
    pushbroadcast!(q, mvar)
  end
  nothing
end
function indisvectorized(ls::LoopSet, ind::Symbol)
  for op ∈ operations(ls)
    ((op.variable === ind) && isvectorized(op)) && return true
  end
  false
end
@inline firstunroll(vu::VecUnroll) = getfield(getfield(vu, :data), 1, false)
@inline firstunroll(x) = x
@inline lastunroll(vu::VecUnroll) = last(getfield(vu, :data))
@inline lastunroll(x) = x
@inline unmm(x) = x
@inline unmm(x::MM) = getfield(x, :i)
function lower_load_for_optranslation!(
  q::Expr,
  op::Operation,
  posindicator::UInt8,
  ls::LoopSet,
  td::UnrollArgs,
  mask::Bool,
  translationind::Int
)
  @unpack u₁loop, u₂loop, vloop, u₁, u₂max, suffix = td
  # @unpack u₁, u₁loopsym, u₂loopsym, vloopsym, u₂max, suffix = td
  iszero(suffix) || return
  total_unroll = u₁ + u₂max - 1
  mref = op.ref
  inds_by_ptroff = indices_calculated_by_pointer_offsets(ls, mref)
  # initial offset pointer
  # Unroll directions can be + or -
  # we want to start at minimum position.
  step₁ = gethint(step(u₁loop))
  step₂ = gethint(step(u₂loop))
  # abs of steps are equal
  equal_steps = (step₁ == step₂) ⊻ (posindicator ≠ 0x03)
  _td = UnrollArgs(
    u₁loop,
    u₂loop,
    vloop,
    u₁,
    u₂max,
    Core.ifelse(equal_steps, 0, u₂max - 1)
  )
  gespinds = mem_offset(op, _td, inds_by_ptroff, false, ls, false)
  ptr = vptr(op)
  gptr = Symbol(ptr, "##GESPED##")
  for i ∈ eachindex(gespinds.args)
    if i == translationind
      gespinds.args[i] = Expr(
        :call,
        lv(Core.ifelse(equal_steps, :firstunroll, :lastunroll)),
        gespinds.args[i]
      )
    end
  end
  ip = GlobalRef(VectorizationBase, :increment_ptr)
  vpo = vptr_offset(gptr)
  push!(
    q.args,
    Expr(:(=), vpo, Expr(:call, ip, ptr, vptr_offset(ptr), gespinds))
  )
  push!(q.args, Expr(:(=), gptr, ptr))#Expr(:call, GlobalRef(VectorizationBase, :reconstruct_ptr),
  fill!(inds_by_ptroff, true)
  @unpack ref, loopedindex = mref
  indices = copy(getindices(ref))
  # old_translation_index = indices[translationind]
  # indices[translationind] = u₁loop.itersymbol
  # getindicesonly returns a view of `getindices`
  dummyref =
    ArrayReference(ref.array, indices, zero(getoffsets(ref)), getstrides(ref))
  # loopedindex[translationind] = true
  dummymref =
    ArrayReferenceMeta(dummyref, fill!(similar(loopedindex), true), gptr)
  indonly = getindicesonly(dummyref)
  for i ∈ eachindex(indonly)
    if i == translationind
      indonly[i] = u₁loop.itersymbol
    elseif !loopedindex[i]
      ind = indonly[i]
      for indop ∈ operations(ls)
        if isvectorized(indop) & (name(indop) === ind)
          indonly[i] = vloop.itersymbol
          break
        end
      end
    end
  end
  _td = UnrollArgs(u₁loop, u₂loop, vloop, total_unroll, u₂max, -1)
  op.ref = dummymref
  _lower_load!(q, ls, op, _td, mask)
  # set old values
  op.ref = mref
  # loopedindex[translationind] = false
  # indices[translationind] = old_translation_index
  shouldbroadcast = (!isvectorized(op)) && any(isvectorized, children(op))
  # now we need to assign the `Vec`s from the `VecUnroll` to the correct name.
  variable_name_u = Symbol(variable_name(op, -1), '_', total_unroll)
  variable_name_data = Symbol(variable_name_u, "##data##")
  push!(q.args, :($variable_name_data = getfield($variable_name_u, 1)))
  if shouldbroadcast
    broadcasted_data = broadcastedname(variable_name_data)
    push!(
      q.args,
      :($broadcasted_data = getfield($(broadcastedname(variable_name_u)), 1))
    )
  end
  gf = GlobalRef(Core, :getfield)
  for u₂ ∈ 0:u₂max-1
    variable_name_u₂ = Symbol(variable_name(op, u₂), '_', u₁)
    t = Expr(:tuple)
    if shouldbroadcast
      tb = Expr(:tuple)
    end
    for u ∈ 1:u₁
      uu = if equal_steps
        u + u₂
      else
        u - u₂ + u₂max - 1
      end
      push!(t.args, :($gf($variable_name_data, $uu)))
      if shouldbroadcast
        push!(tb.args, :($gf($broadcasted_data, $uu)))
      end
    end
    push!(q.args, Expr(:(=), variable_name_u₂, Expr(:call, lv(:VecUnroll), t)))
    if shouldbroadcast
      push!(
        q.args,
        Expr(
          :(=),
          broadcastedname(variable_name_u₂),
          Expr(:call, lv(:VecUnroll), tb)
        )
      )
    end
  end
  nothing
end

# TODO: this code should be rewritten to be more "orthogonal", so that we're just combining separate pieces.
# Using sentinel values (eg, T = -1 for non tiling) in part to avoid recompilation.
function lower_load!(
  q::Expr,
  op::Operation,
  ls::LoopSet,
  td::UnrollArgs,
  mask::Bool
)
  @unpack u₁, u₂max, u₁loopsym, u₂loopsym, vloopsym, suffix = td
  if (suffix != -1) && ls.loadelimination
    if (u₁ > 1) & (u₂max > 1)
      istr, ispl =
        isoptranslation(ls, op, UnrollSymbols(u₁loopsym, u₂loopsym, vloopsym))
      if istr ≠ 0x00
        return lower_load_for_optranslation!(q, op, ispl, ls, td, mask, istr)
      end
    end
    if (suffix > 0) && (u₂loopsym !== vloopsym)
      mno, id = maxnegativeoffset(ls, op, u₂loopsym)
      if -suffix < mno < 0 # already checked that `suffix != -1` above
        varnew = variable_name(op, suffix)
        varold = variable_name(operations(ls)[id], suffix + mno)
        u = isu₁unrolled(op) ? u₁ : 1
        push!(
          q.args,
          Expr(:(=), Symbol(varnew, '_', u), Symbol(varold, '_', u))
        )
        return
      end
    end
  end
  _lower_load!(q, ls, op, td, mask)
end
function _lower_load!(
  q::Expr,
  ls::LoopSet,
  op::Operation,
  td::UnrollArgs,
  mask::Bool,
  inds_calc_by_ptr_offset::Vector{Bool} = indices_calculated_by_pointer_offsets(
    ls,
    op.ref
  )
)
  if rejectinterleave(op)
    return lower_load_no_optranslation!(
      q,
      ls,
      op,
      td,
      mask,
      inds_calc_by_ptr_offset
    )
  else
    omop = offsetloadcollection(ls)
    @unpack opids, opidcollectionmap, batchedcollections, batchedcollectionmap =
      omop
    batchid, opind = batchedcollectionmap[identifier(op)]
    for (bid, oid) ∈ batchedcollectionmap # this relies on `for op ∈ ops` in codegen/operation_evaluation_order.jl
      if bid == batchid
        if oid == opind
          collectionid, copind = opidcollectionmap[identifier(op)]
          opidmap = opids[collectionid]
          idsformap = batchedcollections[batchid]
          lower_load_collection!(
            q,
            ls,
            opidmap,
            idsformap,
            td,
            mask,
            inds_calc_by_ptr_offset
          )
        end
        return nothing
      end
    end
  end
  return nothing
end
function additive_vectorized_loopinductvar_only(op::Operation)
  isvectorized(op) || return true
  isloopvalue(op) && return true
  iscompute(op) || return false
  additive_instr = (:add_fast, :(+), :vadd, :identity, :sub_fast, :(-), :vsub)
  Base.sym_in(instruction(op).instr, additive_instr) || return false
  return all(additive_vectorized_loopinductvar_only, parents(op))
end
# Checks if we cannot use `Unroll`
function rejectcurly(ls::LoopSet, op::Operation, td::UnrollArgs)
  @unpack u₁loopsym, vloopsym = td
  rejectcurly(ls, op, u₁loopsym, vloopsym)
end
function rejectcurly(
  ls::LoopSet,
  op::Operation,
  u₁loopsym::Symbol,
  vloopsym::Symbol
)
  indices = getindicesonly(op)
  li = op.ref.loopedindex
  AV = AU = false
  for (n, ind) ∈ enumerate(indices)
    if li[n]
      if ind === vloopsym
        AV && return true
        AV = true
      end
      if ind === u₁loopsym
        AU && return true
        AU = true
      end
    else
      opp = findop(parents(op), ind)
      isu₂unrolled(opp) && return true
      if length(parents(opp)) == 3
        instruction(opp).instr === :muladd
      elseif length(parents(opp)) ≠ 2
        return true
      end
      if instruction(opp).instr === :(+) || instruction(opp).instr === :add_fast
        isadd = true
      elseif instruction(opp).instr === :(-) ||
             instruction(opp).instr === :sub_fast
        isadd = false
      else
        return true
      end
      opp1 = parents(opp)[1]
      opp2 = parents(opp)[2]
      if isvectorized(opp)
        AV && return true
        AV = true
        if isvectorized(opp1)
          isvectorized(opp2) && return true
          isloopvalue(opp1) || return true
        else# opp2 vectorized
          isadd || return true
          isloopvalue(opp2) || return true
        end
      end
      if (u₁loopsym === CONSTANTZEROINDEX) ?
         (CONSTANTZEROINDEX ∈ loopdependencies(opp)) : (isu₁unrolled(opp))
        AU && return true
        AU = true
      end
    end
  end
  false
end
function rejectinterleave(
  ls::LoopSet,
  op::Operation,
  vloop::Loop,
  idsformap::SubArray{
    Tuple{Int,Int},
    1,
    Vector{Tuple{Int,Int}},
    Tuple{UnitRange{Int}},
    true
  }
)
  strd = step(vloop)
  isknown(strd) || return true
  # TODO: reject if there is a vectorized !loopedindex index
  indices = getindicesonly(op)
  li = op.ref.loopedindex
  for i ∈ eachindex(li)
    li[i] && continue
    ind = indices[i]
    for indop ∈ operations(ls)
      if (name(indop) === ind) && isvectorized(indop)
        additive_vectorized_loopinductvar_only(indop) || return true # so that it is `MM`
      end
    end
  end
  vloopsym = vloop.itersymbol
  (first(getindices(op)) === vloopsym) &&
    (length(idsformap) ≠ abs(first(getstrides(op)) * gethint(strd)))
end
# function lower_load_collection_manual_u₁unroll!(
#     q::Expr, ls::LoopSet, opidmap::Vector{Int},
#     idsformap::SubArray{Tuple{Int,Int}, 1, Vector{Tuple{Int,Int}}, Tuple{UnitRange{Int}}, true},
#     ua::UnrollArgs, mask::Bool, inds_calc_by_ptr_offset::Vector{Bool}, op::Operation
# )
#     @unpack u₁, u₁loop, u₁loopsym, u₂loopsym, vloopsym, vloop, suffix = ua
#     _mvar = mangledvar(op)
#     op.mangledvariable = gensym!(ls,_mvar)
#     for u ∈ 0:u₁-1
#         lower_load_collection!(
#             q, ls, opidmap, idsformap, ua, mask, inds_calc_by_ptr_offset
#         )
#     end
#     op.mangledvariable = _mvar
# end
function lower_load_collection!(
  q::Expr,
  ls::LoopSet,
  opidmap::Vector{Int},
  idsformap::SubArray{
    Tuple{Int,Int},
    1,
    Vector{Tuple{Int,Int}},
    Tuple{UnitRange{Int}},
    true
  },
  ua::UnrollArgs,
  mask::Bool,
  inds_calc_by_ptr_offset::Vector{Bool}
)
  @unpack u₁, u₁loop, u₁loopsym, u₂loopsym, vloopsym, vloop, suffix = ua

  ops = operations(ls)
  nouter = length(idsformap)
  # ua = UnrollArgs(nouter, unrollsyms, u₂, 0)
  # idsformap contains (index, offset) pairs
  op = ops[opidmap[first(first(idsformap))]]
  # if isu₁unrolled(op) && u₁ > 1 && !isknown(step(u₁loop))
  #     return lower_load_collection_manual_u₁unroll!(
  #         q, ls, opidmap, idsformap, ua,
  #         mask, inds_calc_by_ptr_offset, op
  #     )
  # end
  opindices = getindices(op)
  # construct dummy unrolled loop
  offset_dummy_loop = Loop(
    first(opindices),
    MaybeKnown(1),
    MaybeKnown(1024),
    MaybeKnown(1),
    Symbol(""),
    Symbol("")
  )
  unrollcurl₂ = unrolled_curly(op, nouter, offset_dummy_loop, vloop, mask, 1) # interleave always 1 here
  inds = mem_offset_u(op, ua, inds_calc_by_ptr_offset, false, 0, ls, false)
  # @show op suffix, inds
  falseexpr = Expr(:call, lv(:False))
  rs = staticexpr(reg_size(ls))
  opu₁, opu₂ = isunrolled_sym(op, u₁loopsym, u₂loopsym, vloopsym, ls)
  manualunrollu₁ = if opu₁ && u₁ > 1 # both unrolled
    if isknown(step(u₁loop)) &&
       sum(Base.Fix2(===, u₁loopsym), getindicesonly(op)) == 1
      # if first(opindices) === u₁loopsym#vloopsym
      #   interleaveval = -nouter
      # else
      interleaveval = 0
      # end
      unrollcurl₁ =
        unrolled_curly(op, u₁, ua.u₁loop, vloop, mask, interleaveval)
      inds = Expr(:call, unrollcurl₁, inds)
      false
    else
      true # u₁ > 1 already checked to reach here
    end
  else
    false
  end
  uinds = Expr(:call, unrollcurl₂, inds)
  sptrsym = sptr!(q, op)
  loadexpr = Expr(:call, lv(:_vload), sptrsym, uinds)
  # not using `add_memory_mask!(storeexpr, op, ua, mask, ls, 0)` because we checked `isconditionalmemop` earlier in `lower_load_collection!`
  u₁vectorized = u₁loopsym === vloopsym
  if (mask && isvectorized(op))
    if !(manualunrollu₁ & u₁vectorized)
      push!(loadexpr.args, MASKSYMBOL)
    end
  end
  push!(loadexpr.args, falseexpr, rs)
  collectionname = Symbol(
    vptr(op),
    "##collection##number#",
    opidmap[first(first(idsformap))],
    "#",
    suffix,
    "##size##",
    nouter,
    "##u₁##",
    u₁
  )
  gf = GlobalRef(Core, :getfield)
  if manualunrollu₁
    masklast = mask & u₁vectorized & isvectorized(op)
    extractedvs = Vector{Expr}(undef, length(idsformap))
    for i ∈ eachindex(extractedvs)
      extractedvs[i] = Expr(:tuple)
    end
    for u ∈ 0:u₁-1
      collectionname_u = Symbol(collectionname, :_, u)
      if u ≠ 0
        inds =
          mem_offset_u(op, ua, inds_calc_by_ptr_offset, false, u, ls, false)
        uinds = Expr(:call, unrollcurl₂, inds)
        loadexpr = copy(loadexpr)
        loadexpr.args[3] = Expr(:call, unrollcurl₂, inds)
        (((u + 1) == u₁) & masklast) &&
          insert!(loadexpr.args, length(loadexpr.args) - 1, MASKSYMBOL) # 1 for `falseexpr` pushed at end
      end
      # unpack_collection!(q, ls, opidmap, idsformap, ua, loadexpr, collectionname, op, false)
      push!(q.args, Expr(:(=), collectionname_u, Expr(:call, gf, loadexpr, 1)))
      # getfield to extract data from `VecUnroll` object, so we have a tuple
      for (i, (opid, o)) ∈ enumerate(idsformap)
        ext = extractedvs[i]
        if (u + 1) == u₁
          _op = ops[opidmap[opid]]
          mvar =
            Symbol(variable_name(_op, Core.ifelse(opu₂, suffix, -1)), '_', u₁)
          push!(q.args, Expr(:(=), mvar, Expr(:call, lv(:VecUnroll), ext)))
        end
        push!(ext.args, Expr(:call, gf, collectionname_u, i, false))
      end
    end
  else
    push!(q.args, Expr(:(=), collectionname, Expr(:call, gf, loadexpr, 1)))
    # getfield to extract data from `VecUnroll` object, so we have a tuple
    u = Core.ifelse(opu₁, u₁, 1)
    for (i, (opid, o)) ∈ enumerate(idsformap)
      extractedv = Expr(:call, gf, collectionname, i, false)

      _op = ops[opidmap[opid]]
      mvar = Symbol(variable_name(_op, Core.ifelse(opu₂, suffix, -1)), '_', u)
      push!(q.args, Expr(:(=), mvar, extractedv))
    end
    # unpack_collection!(q, ls, opidmap, idsformap, ua, loadexpr, collectionname, op, true)
  end
end

@testset "Fall back behavior" begin

  @show Float64, @__LINE__
  function msd(x)
    s = zero(eltype(x))
    for i in eachindex(x)
      s += x[i] * x[i]
    end
    s
  end
  function msdavx(x)
    s = zero(eltype(x))
    @turbo warn_check_args = true for i in eachindex(x)
      s = muladd(x[i], x[i], s) # Avoids fastmath in fallback loop.
    end
    s
  end

  x = fill(8.0, 128)
  x[1] = 1e9

  @test @inferred LoopVectorization.check_args(x)
  @test @inferred LoopVectorization.check_args(x, x)
  @test @inferred LoopVectorization.check_args(x, x, x)
  @test @inferred !LoopVectorization.check_args(view(x, [1, 3, 4, 18]))
  @test @inferred !LoopVectorization.check_args(FallbackArrayWrapper(x))
  @test @inferred !LoopVectorization.check_args(FallbackArrayWrapper(x), x, x)
  @test @inferred !LoopVectorization.check_args(x, FallbackArrayWrapper(x))
  @test @inferred !LoopVectorization.check_args(x, FallbackArrayWrapper(x), x)
  @test @inferred !LoopVectorization.check_args(x, x, FallbackArrayWrapper(x))
  @test @inferred !LoopVectorization.check_args(
    x,
    x,
    FallbackArrayWrapper(x),
    FallbackArrayWrapper(x),
  )
  @test @inferred !LoopVectorization.check_args(['a'])
  @test @inferred !LoopVectorization.check_args(Diagonal(x))

  @test_nowarn msdavx(x)
  lnn = LineNumberNode(14, joinpath(pkgdir(LoopVectorization), "test", "fallback.jl"))
  warnstring = "$(lnn):\n`LoopVectorization.check_args` on your inputs failed; running fallback `@inbounds @fastmath` loop instead.\nUse `warn_check_args=false`, e.g. `@turbo warn_check_args=false ...`, to disable this warning."

  @test_logs (:warn, warnstring) msdavx(FallbackArrayWrapper(x))
  @test msdavx(FallbackArrayWrapper(x)) == 1e18
  @test msd(x) == msdavx(FallbackArrayWrapper(x))
  @test msdavx(x) != msdavx(FallbackArrayWrapper(x))

  x = rand(1000) # should be long enough to make zero differences incredibly unlikely
  @test exp.(x) != (@turbo exp.(x))
  @test exp.(x) == (@turbo exp.(FallbackArrayWrapper(x)))
end

module LoopVectorization

export indices,
  @avx,
  @avxt,
  @turbo,
  @tturbo,
  vmap,
  vmap!,
  vmapt,
  vmapt!,
  vmapnt,
  vmapnt!,
  vmapntt,
  vmapntt!,
  vfilter,
  vfilter!,
  vmapreduce,
  vsum,
  vreduce,
  vcount

if isdefined(Base, :Experimental) &&
   isdefined(Base.Experimental, Symbol("@max_methods"))
  @eval Base.Experimental.@max_methods 1
end
export LowDimArray,
  static, stridedpointer, *ˡ, _turbo_!, tanh_fast, sigmoid_fast

using ArrayInterface: UpTri, LoTri
using Static: StaticInt, gt, static, Zero, One, reduce_tup
using VectorizationBase,
  SLEEFPirates, UnPack, OffsetArrays, StaticArrayInterface
const ArrayInterface = StaticArrayInterface
using LayoutPointers:
  AbstractStridedPointer,
  StridedPointer,
  StridedBitPointer,
  grouped_strided_pointer,
  stridedpointer_preserve,
  GroupedStridedPointers
import LayoutPointers

using SIMDTypes: NativeTypes

using VectorizationBase:
  mask,
  MM,
  AbstractMask,
  data,
  AbstractSIMD,
  vzero,
  offsetprecalc,
  lazymul,
  vadd_nw,
  vadd_nsw,
  vadd_nuw,
  vsub_nw,
  vsub_nsw,
  vsub_nuw,
  vmul_nw,
  vmul_nsw,
  vmul_nuw,
  vfmaddsub,
  vfmsubadd,
  vpermilps177,
  vmovsldup,
  vmovshdup,
  maybestaticfirst,
  maybestaticlast,
  gep,
  gesp,
  vfmadd,
  vfmsub,
  vfnmadd,
  vfnmsub,
  vfmadd_fast,
  vfmsub_fast,
  vfnmadd_fast,
  vfnmsub_fast,
  vfmadd231,
  vfmsub231,
  vfnmadd231,
  vfnmsub231,
  vfma_fast,
  vmuladd_fast,
  vdiv_fast,
  vadd_fast,
  vsub_fast,
  vmul_fast,
  relu,
  stridedpointer,
  _vload,
  _vstore!,
  reduced_add,
  reduced_prod,
  reduce_to_add,
  reduce_to_prod,
  reduced_max,
  reduced_min,
  reduce_to_max,
  reduce_to_min,
  reduced_all,
  reduced_any,
  reduce_to_all,
  reduce_to_any,
  vsum,
  vprod,
  vmaximum,
  vminimum,
  vany,
  vall,
  Unroll,
  VecUnroll,
  preserve_buffer,
  zero_vecunroll,
  vbroadcast_vecunroll,
  _vzero,
  _vbroadcast,
  contract_add,
  collapse_add,
  contract_mul,
  collapse_mul,
  contract_max,
  collapse_max,
  contract_min,
  collapse_min,
  contract_and,
  collapse_and,
  contract_or,
  collapse_or,
  max_mask,
  maybestaticsize,
  zero_mask

using HostCPUFeatures:
  pick_vector_width,
  register_size,
  register_count,
  has_opmask_registers,
  unwrap,
  get_cpu_name
using CPUSummary: num_cores, cache_linesize, cache_size

using IfElse: ifelse

using ThreadingUtilities, PolyesterWeave
using Base.Broadcast: Broadcasted, DefaultArrayStyle
using LinearAlgebra: Adjoint, Transpose, Diagonal
using Base.Meta: isexpr
using DocStringExtensions
import LinearAlgebra # for check_args

using Base: unsafe_trunc

using Base.FastMath:
  add_fast,
  sub_fast,
  mul_fast,
  div_fast,
  inv_fast,
  abs2_fast,
  rem_fast,
  max_fast,
  min_fast,
  pow_fast,
  sqrt_fast
using SLEEFPirates:
  log_fast,
  log2_fast,
  log10_fast,
  pow,
  sin_fast,
  cos_fast,
  sincos_fast,
  tan_fast

using StaticArrayInterface:
  OptionallyStaticUnitRange,
  OptionallyStaticRange,
  StaticBool,
  True,
  False,
  indices,
  static_strides,
  offsets,
  static_size,
  static_axes,
  StrideIndex
using CloseOpenIntervals: AbstractCloseOpen, CloseOpen#, SafeCloseOpen
# @static if VERSION ≥ v"1.6.0-rc1" #TODO: delete `else` when dropping 1.5 support
# using ArrayInterface: static_step
# else # Julia 1.5 did not define `step` on CartesianIndices
@inline static_step(x) = ArrayInterface.static_step(x)
@inline static_step(x::CartesianIndices) =
  VectorizationBase.CartesianVIndex(map(static_step, x.indices))
# end

const VECTORWIDTHSYMBOL, ELTYPESYMBOL, MASKSYMBOL =
  Symbol("##Wvecwidth##"), Symbol("##Tloopeltype##"), Symbol("##mask##")

include("vectorizationbase_compat/contract_pass.jl")
include("vectorizationbase_compat/subsetview.jl")
include("getconstindexes.jl")
include("predicates.jl")
include("simdfunctionals/map.jl")
include("simdfunctionals/filter.jl")
include("modeling/costs.jl")
include("modeling/operations.jl")
include("modeling/graphs.jl")
include("codegen/operation_evaluation_order.jl")
include("parse/memory_ops_common.jl")
include("parse/add_loads.jl")
include("parse/add_stores.jl")
include("parse/add_compute.jl")
include("parse/add_constants.jl")
include("parse/add_ifelse.jl")
include("modeling/determinestrategy.jl")
include("codegen/line_number_nodes.jl")
include("codegen/loopstartstopmanager.jl")
include("codegen/lower_compute.jl")
include("codegen/lower_constant.jl")
include("codegen/lower_memory_common.jl")
include("codegen/lower_load.jl")
include("codegen/lower_store.jl")
include("codegen/lowering.jl")
include("codegen/split_loops.jl")
include("codegen/lower_threads.jl")
include("condense_loopset.jl")
include("transforms.jl")
include("reconstruct_loopset.jl")
include("constructors.jl")
include("user_api_conveniences.jl")
include("simdfunctionals/mapreduce.jl")
include("simdfunctionals/count.jl")
include("broadcast.jl")

"""
LoopVectorization provides macros and functions that combine SIMD vectorization and
loop-reordering so as to improve performance:

  - [`@turbo`](@ref): transform `for`-loops and broadcasting
  - [`vmapreduce`](@ref): vectorized version of `mapreduce`
  - [`vreduce`](@ref): vectorized version of `reduce`
  - [`vsum`](@ref): vectorized version of `sum`
  - [`vmap`](@ref) and `vmap!`: vectorized version of `map` and `map!`
  - [`vmapnt`](@ref) and `vmapnt!`: non-temporal variants of `vmap` and `vmap!`
  - [`vmapntt`](@ref) and `vmapntt!`: threaded variants of `vmapnt` and `vmapnt!`
  - [`vfilter`](@ref) and `vfilter!`: vectorized versions of `filter` and `filter!`
"""
LoopVectorization

include("precompile.jl")
# _precompile_()

# _vreduce(+, Float64[1.0])
# matmul_params(64, 32, 64)

# import ChainRulesCore, ForwardDiff
# include("vmap_grad.jl")
if !isdefined(Base, :get_extension)
  include("../ext/ForwardDiffExt.jl")
  include("../ext/SpecialFunctionsExt.jl")
end
end # module

const ProdArg = Union{Symbol,Expr,Number}
function mulexprcost(@nospecialize(x::ProdArg))::Int
  if x isa Number
    return 0
  elseif x isa Symbol
    return 1
  else
    ex = x::Expr
    base = ex.head === :call ? 10 : 1
    return base + length(ex.args)
  end
end
function mul_fast_expr(
  args::SubArray{Any,1,Vector{Any},Tuple{UnitRange{Int}},true}
)::Expr
  b = Expr(:call, :mul_fast)
  for i ∈ 2:length(args)
    push!(b.args, args[i])
  end
  b
end
function mulexpr(
  mulexargs::SubArray{Any,1,Vector{Any},Tuple{UnitRange{Int}},true}
)::Tuple{ProdArg,ProdArg}
  a = (mulexargs[1])::ProdArg
  Nexpr = length(mulexargs)
  Nexpr == 2 && return (a, mulexargs[2]::ProdArg)
  Nexpr != 3 && return (a, mul_fast_expr(mulexargs))
  # We'll calc the product between the guesstimated cheaper two args first, for better out of order execution
  b = (mulexargs[2])::ProdArg
  c = (mulexargs[3])::ProdArg
  ac = mulexprcost(a)
  bc = mulexprcost(b)
  cc = mulexprcost(c)
  maxc = max(ac, bc, cc)
  ac == maxc && return (a, Expr(:call, :mul_fast, b, c))
  bc == maxc && return (b, Expr(:call, :mul_fast, c, a))
  return (c, Expr(:call, :mul_fast, a, b))
end
function append_args_skip!(call, args, i, mod)
  for j ∈ eachindex(args)
    j == i && continue
    if length(call.args) < 3
      push!(call.args, args[j])
    else
      call = Expr(:call, :add_fast, call, args[j])
    end
  end
  call
end

function fastfunc(f)
  i = findfirst(Base.Fix2(===, f), (:sin, :cos, :sincos))
  if i === nothing
    get(VectorizationBase.FASTDICT, f, f)
  else
    (:sin_fast, :cos_fast, :sincos_fast)[i]
  end
end
function muladd_arguments!(argv, mod, f = first(argv))
  if f === :*
    argv[1] = :mul_fast
  else
    argv[1] = fastfunc(f)
  end
  for i ∈ 2:length(argv)
    a = argv[i]
    a isa Expr || continue
    argv[i] = capture_muladd(a::Expr, mod)
  end
end

function recursive_muladd_search!(
  call,
  argv,
  mod,
  cnmul::Bool = false,
  csub::Bool = false
)
  if length(argv) < 3
    muladd_arguments!(argv, mod)
    return length(call.args) == 4, cnmul, csub
  end
  fun = first(argv)
  isadd =
    fun === :+ ||
    fun === :add_fast ||
    fun === :vadd ||
    (fun == :(Base.FastMath.add_fast))::Bool
  issub =
    fun === :- ||
    fun === :sub_fast ||
    fun === :vsub ||
    (fun == :(Base.FastMath.sub_fast))::Bool
  if isadd
    argv[1] = :add_fast
  elseif issub
    argv[1] = :sub_fast
  else
    muladd_arguments!(argv, mod, fun)
    return length(call.args) == 4, cnmul, csub
  end
  exargs = @view(argv[2:end])
  for i ∈ eachindex(exargs)
    if exargs[i] === :Inf
      exargs[i] === Inf
    end
  end
  issub && @assert length(exargs) == 2
  for (i, ex) ∈ enumerate(exargs)
    if ex isa Expr && ex.head === :call
      exa = ex.args
      f = first(exa)
      exav = @view(exa[2:end])
      if f === :* ||
         f === :mul_fast ||
         f === :vmul ||
         (f == :(Base.FastMath.mul_fast))::Bool
        a, b = mulexpr(exav)
        call.args[2] = a
        call.args[3] = b
        if length(exargs) == 2
          push!(call.args, exargs[3-i])
        else
          push!(
            call.args,
            append_args_skip!(Expr(:call, :add_fast), exargs, i, mod)
          )
        end
        if issub
          csub = i == 1
          cnmul = !csub
        end
        return true, cnmul, csub
      elseif isadd
        found, cnmul, csub = recursive_muladd_search!(call, exa, mod)
        if found
          if csub
            call.args[4] = if length(exargs) == 2
              Expr(:call, :sub_fast, exargs[3-i], call.args[4])
            else
              Expr(
                :call,
                :sub_fast,
                append_args_skip!(Expr(:call, :add_fast), exargs, i, mod),
                call.args[4]
              )
            end
          else
            call.args[4] = append_args_skip!(
              Expr(:call, :add_fast, call.args[4]),
              exargs,
              i,
              mod
            )
          end
          return true, cnmul, false
        end
      elseif issub
        found, cnmul, csub = recursive_muladd_search!(call, exa, mod)
        if found
          if i == 1
            if csub
              call.args[4] = Expr(:call, :add_fast, call.args[4], exargs[3-i])
            else
              call.args[4] = Expr(:call, :sub_fast, call.args[4], exargs[3-i])
            end
          else
            cnmul = !cnmul
            if csub
              call.args[4] = Expr(:call, :add_fast, exargs[3-i], call.args[4])
            else
              call.args[4] = Expr(:call, :sub_fast, exargs[3-i], call.args[4])
            end
            csub = false
          end
          return true, cnmul, csub
        end
      end
    end
  end
  length(call.args) == 4, cnmul, csub
end

function capture_a_muladd(ex::Expr, mod)
  call = Expr(:call, Symbol(""), Symbol(""), Symbol(""))
  found, nmul, sub = recursive_muladd_search!(call, ex.args, mod)
  if !found
    if length(ex.args) > 3
      f = ex.args[1]
      if (f === :add_fast) | (f === :mul_fast)
        newex = Expr(:call, f, ex.args[2], ex.args[3])
        for i ∈ 4:length(ex.args)
          newex = Expr(:call, f, newex, ex.args[i])
        end
        ex = newex
      end
    end
    return false, ex
  end
  # found || return ex
  # a, b, c = call.args[2], call.args[3], call.args[4]
  # call.args[2], call.args[3], call.args[4] = c, a, b
  f = if nmul && sub
    :vfnmsub_fast
  elseif nmul
    :vfnmadd_fast
  elseif sub
    :vfmsub_fast
  else
    :vfmadd_fast
  end
  if mod === nothing
    call.args[1] = f
  else
    call.args[1] = Expr(:(.), mod, QuoteNode(f))
  end
  true, call
end
capture_muladd(ex::Expr, mod) =
  while true
    ex.head === :ref && return ex
    if Meta.isexpr(ex, :call, 2)
      if (ex.args[1] === :(-))
        if (ex.args[2] isa Number)
          return -ex.args[2]
        elseif ex.args[2] === :Inf
          return -Inf
        end
      end
    end
    found, ex = capture_a_muladd(ex, mod)
    found || return ex
  end
function append_update_args(f::Symbol, ex::Expr)
  call = Expr(:call, f)
  for i ∈ 2:length(ex.args)
    push!(call.args, ex.args[i])
  end
  push!(call.args, ex.args[1])
  call
end
contract_pass!(::Any, ::Any) = nothing
function contract!(expr::Expr, ex::Expr, i::Int, mod)
  # if ex.head === :call
  # expr.args[i] = capture_muladd(ex, mod)
  if ex.head === :(+=)
    call = append_update_args(:add_fast, ex)
    expr.args[i] = ex = Expr(:(=), first(ex.args), call)
  elseif ex.head === :(*=)
    call = append_update_args(:mul_fast, ex)
    expr.args[i] = ex = Expr(:(=), first(ex.args), call)
  elseif Meta.isexpr(ex, :(\=), 2)
    exa1 = ex.args[1]
    call = Expr(:call, :div_fast, ex.args[2], exa1)
    expr.args[i] = ex = Expr(:(=), exa1, call)
  else
    j = findfirst(
      Base.Fix2(===, ex.head),
      (
        :(-=),
        :(/=),
        :(÷=),
        :(%=),
        :(^=),
        :(&=),
        :(|=),
        :(⊻=),
        :(>>>=),
        :(>>=),
        :(<<=)
      )
    )
    if j ≢ nothing
      f = (
        :sub_fast,
        :div_fast,
        :(÷),
        :(%),
        :(^),
        :(&),
        :(|),
        :(⊻),
        :(>>>),
        :(>>),
        :(<<)
      )[j::Int]
      call = Expr(:call, f)
      append!(call.args, ex.args)
      expr.args[i] = ex = Expr(:(=), first(ex.args), call)
    end
  end
  if ex.head === :(=)
    RHS = ex.args[2]
    if RHS isa Expr && Base.sym_in(RHS.head, (:call, :if))
      ex.args[2] = capture_muladd(RHS, mod)
    end
  end
  contract_pass!(expr.args[i], mod)
end
# contract_pass(x) = x # x will probably be a symbol
function contract_pass!(expr::Expr, mod = nothing)
  i = Core.ifelse(expr.head === :for, 1, 0)
  Nexpr = length(expr.args)
  while i < Nexpr
    _ex = expr.args[(i+=1)]
    _ex isa Expr || continue
    ex::Expr = _ex
    contract!(expr, ex, i, mod)
  end
end

"""
    isscopedname(ex, modpath, name::Symbol)

Test whether expression `ex` is a module-scoped `name`. Both of these return `true`:

```
isscopedname(:(Base.OneTo), :Base, :OneTo)
isscopedname(:(Base.Checked.checked_add), (:Base, :Checked), :checked_add)
```
"""
function isscopedname(ex, modpath, name::Symbol)
  isexpr(ex, :(.), 2) &&
    (a = ex.args[2]; isa(a, QuoteNode) && a.value === name) &&
    hasscope(ex.args[1], modpath)
end
hasscope(modex, mod::Symbol) = modex === mod
hasscope(modex, mod::Tuple{Symbol}) = hasscope(modex, mod[1])
hasscope(modex, modpath::Tuple{Vararg{Symbol}}) =
  isscopedname(modex, Base.front(modpath), modpath[end])

"""
    isglobalref(g, mod, name)

Return true if `g` is equal to `GlobalRef(mod, name)`.
"""
isglobalref(g, mod, name) =
  isa(g, GlobalRef) && g.mod === mod && g.name === name

using LinearAlgebra, LoopVectorization, Libdl

const REGISTER_SIZE = LoopVectorization.VectorizationBase.register_size()

# const LOOPVECBENCHDIR = joinpath(pkgdir(LoopVectorization), "benchmark")
include(joinpath(LOOPVECBENCHDIR, "looptests.jl"))

const LIBCTEST = joinpath(LOOPVECBENCHDIR, "libctests.so")
const LIBFTEST = joinpath(LOOPVECBENCHDIR, "libftests.so")
const LIBICTEST = joinpath(LOOPVECBENCHDIR, "libictests.so")
const LIBIFTEST = joinpath(LOOPVECBENCHDIR, "libiftests.so")
const LIBEIGENTEST = joinpath(LOOPVECBENCHDIR, "libetest.so")
const LIBIEIGENTEST = joinpath(LOOPVECBENCHDIR, "libietest.so")

# requires Clang with polly to build
cfile = joinpath(LOOPVECBENCHDIR, "looptests.c")
if !isfile(LIBCTEST) || mtime(cfile) > mtime(LIBCTEST)
  if (Sys.ARCH === :aarch64) && Sys.isapple() # assume no `-march=native` support
    run(
      `clang -Ofast -mprefer-vector-width=$(8REGISTER_SIZE) -lm -shared -fPIC $cfile -o $LIBCTEST`
    )
  else
    run(
      `clang -Ofast -march=native -mprefer-vector-width=$(8REGISTER_SIZE) -lm -shared -fPIC $cfile -o $LIBCTEST`
    )
  end

  # run(`/usr/local/bin/clang -Ofast -march=native -mprefer-vector-width=$(8REGISTER_SIZE) -lm -mllvm -polly -mllvm -polly-vectorizer=stripmine -shared -fPIC $cfile -o $LIBCTEST`)
end
ffile = joinpath(LOOPVECBENCHDIR, "looptests.f90")
if !isfile(LIBFTEST) || mtime(ffile) > mtime(LIBFTEST)
  # --param max-unroll-times defaults to ≥8, which is generally excessive
  if (Sys.ARCH === :x86_64)
    run(
      `gfortran -Ofast -march=native -funroll-loops -mprefer-vector-width=$(8REGISTER_SIZE) -fvariable-expansion-in-unroller --param max-variable-expansions-in-unroller=4 -shared -fPIC $ffile -o $LIBFTEST`
    )
  else
    run(
      `gfortran -Ofast -march=native -funroll-loops -fvariable-expansion-in-unroller --param max-variable-expansions-in-unroller=4 -shared -fPIC $ffile -o $LIBFTEST`
    )
  end
  # run(`gfortran -Ofast -march=native -funroll-loops -floop-nest-optimize -mprefer-vector-width=$(8REGISTER_SIZE) -shared -fPIC $ffile -o $LIBFTEST`)
end

const INTEL_BENCH = try
  if !isfile(LIBIFTEST) || mtime(ffile) > mtime(LIBIFTEST)
    run(
      `ifort -fast -qopt-zmm-usage=high -qoverride-limits -shared -fPIC $ffile -o $LIBIFTEST`
    )
  end
  if !isfile(LIBICTEST) || mtime(cfile) > mtime(LIBICTEST)
    run(
      `icc -fast -qopt-zmm-usage=high -fargument-noalias-global -qoverride-limits -shared -fPIC $cfile -o $LIBICTEST`
    )
  end
  true
catch ProcessFailedException
  false
end

# g++ -> ICE, so Clang and ICPC
eigenfile = joinpath(LOOPVECBENCHDIR, "looptestseigen.cpp")
if !isfile(LIBEIGENTEST) || mtime(eigenfile) > mtime(LIBEIGENTEST)
  # Clang seems to have trouble finding includes
  if Bool(LoopVectorization.VectorizationBase.has_feature(Val(:x86_64_avx512f)))
    run(
      `g++ -O3 -march=native -mprefer-vector-width=$(8REGISTER_SIZE) -DEIGEN_VECTORIZE_AVX512 -I/usr/include/eigen3 -shared -fPIC $eigenfile -o $LIBEIGENTEST`
    )
  elseif (Sys.ARCH === :aarch64) && Sys.isapple() # assume homebrew
    run(
      `g++-10 -O3 -march=native -I/opt/homebrew/Cellar/eigen/3.3.9/include/eigen3 -shared -fPIC $eigenfile -o $LIBEIGENTEST`
    )
  else
    run(
      `g++ -O3 -march=native -mprefer-vector-width=$(8REGISTER_SIZE) -I/usr/include/eigen3 -shared -fPIC $eigenfile -o $LIBEIGENTEST`
    )
  end
end
if !isfile(LIBIEIGENTEST) || mtime(eigenfile) > mtime(LIBIEIGENTEST)
  # run(`/usr/bin/clang++ -Ofast -march=native -mprefer-vector-width=$(8REGISTER_SIZE) -DEIGEN_VECTORIZE_AVX512 -I/usr/include/c++/9 -I/usr/include/c++/9/x86_64-generic-linux -I/usr/include/eigen3 -shared -fPIC $eigenfile -o $LIBEIGENTEST`)
  if Bool(LoopVectorization.VectorizationBase.has_feature(Val(:x86_64_avx512f)))
    run(
      `clang++ -Ofast -march=native -mprefer-vector-width=$(8REGISTER_SIZE) -DEIGEN_VECTORIZE_AVX512 -I/usr/include/eigen3 -shared -fPIC $eigenfile -o $LIBIEIGENTEST`
    )
  elseif (Sys.ARCH === :aarch64) && Sys.isapple() # assume homebrew and no `-march=native`
    run(
      `clang++ -Ofast -I/opt/homebrew/Cellar/eigen/3.3.9/include/eigen3 -shared -fPIC $eigenfile -o $LIBIEIGENTEST`
    )
  else
    run(
      `clang++ -Ofast -march=native -mprefer-vector-width=$(8REGISTER_SIZE) -I/usr/include/eigen3 -shared -fPIC $eigenfile -o $LIBIEIGENTEST`
    )
  end
  # run(`icpc -fast -qopt-zmm-usage=high -fargument-noalias-global -qoverride-limits -I/usr/include/eigen3 -shared -fPIC $eigenfile -o $LIBIEIGENTEST`)
end

# MKL_ROOT = "/home/chriselrod/intel"
# directcalljitfile = joinpath(LOOPVECBENCHDIR, "directcalljit.f90")
# if !isfile(LIBDIRECTCALLJIT) || mtime(directcalljitfile) > mtime(LIBDIRECTCALLJIT)
#     run(`ifort -fast -DMKL_DIRECT_CALL_SEQ_JIT -fpp -qopt-zmm-usage=high -Wl,--start-group $(joinpath(MKL_ROOT,"mkl/lib/intel64/libmkl_intel_lp64.a")) $(joinpath(MKL_ROOT,"mkl/lib/intel64/libmkl_sequential.a")) $(joinpath(MKL_ROOT,"mkl/lib/intel64/libmkl_core.a")) -Wl,--end-group -I$(joinpath(MKL_ROOT, "mkl/include")) -I$(joinpath(MKL_ROOT, "compilers_and_libraries_2020.1.217/linux/mkl/include/intel64/lp64")) -shared -fPIC $directcalljitfile -o $LIBDIRECTCALLJIT`)
#     # run(`gfortran -Ofast -march=native -DMKL_DIRECT_CALL_SEQ_JIT -cpp -mprefer-vector-width=$(8REGISTER_SIZE) -Wl,--start-group $(joinpath(MKL_ROOT,"mkl/lib/intel64/libmkl_intel_lp64.a")) $(joinpath(MKL_ROOT,"mkl/lib/intel64/libmkl_sequential.a")) $(joinpath(MKL_ROOT,"mkl/lib/intel64/libmkl_core.a")) -Wl,--end-group -I$(joinpath(MKL_ROOT, "mkl/include")) -I$(joinpath(MKL_ROOT, "compilers_and_libraries_2020.1.217/linux/mkl/include/intel64/lp64")) -shared -fPIC $directcalljitfile -o $LIBDIRECTCALLJIT`)

#     # run(`gfortran -Ofast -march=native -DMKL_DIRECT_CALL_SEQ_JIT -cpp -mprefer-vector-width=$(8REGISTER_SIZE) -shared -fPIC $directcalljitfile -o $LIBDIRECTCALLJIT`)
# end

randa(::Type{T}, dim...) where {T} = rand(T, dim...)
randa(::Type{T}, dim...) where {T<:Signed} = rand(T(-100):T(200), dim...)

using MKL_jll, OpenBLAS_jll

const MKL_BENCH = isdefined(MKL_jll, :libmkl_rt)

if MKL_BENCH
  const libMKL = Libdl.dlopen(MKL_jll.libmkl_rt)
  const DGEMM_MKL = Libdl.dlsym(libMKL, :dgemm)
  const SGEMM_MKL = Libdl.dlsym(libMKL, :sgemm)
  const DGEMV_MKL = Libdl.dlsym(libMKL, :dgemv)
  const MKL_SET_NUM_THREADS = Libdl.dlsym(libMKL, :MKL_Set_Num_Threads)
  true
else
  false
end

const libOpenBLAS = Libdl.dlopen(OpenBLAS_jll.libopenblas)
const DGEMM_OpenBLAS = Libdl.dlsym(libOpenBLAS, :dgemm_64_)
const SGEMM_OpenBLAS = Libdl.dlsym(libOpenBLAS, :sgemm_64_)
const DGEMV_OpenBLAS = Libdl.dlsym(libOpenBLAS, :dgemv_64_)
const OPENBLAS_SET_NUM_THREADS =
  Libdl.dlsym(libOpenBLAS, :openblas_set_num_threads64_)

istransposed(x) = 'N'
istransposed(x::Adjoint{<:Real}) = 'T'
istransposed(x::Adjoint) = 'C'
istransposed(x::Transpose) = 'T'
for (lib, f) ∈ [(:GEMM_MKL, :gemmmkl!), (:GEMM_OpenBLAS, :gemmopenblas!)]
  for (T, prefix) ∈ [(Float32, :S), (Float64, :D)]
    fm = Symbol(prefix, lib)
    @eval begin
      function $f(
        C::AbstractMatrix{$T},
        A::AbstractMatrix{$T},
        B::AbstractMatrix{$T}
      )
        transA = istransposed(A)
        transB = istransposed(B)
        M, N = size(C)
        K = size(B, 1)
        pA = parent(A)
        pB = parent(B)
        ldA = stride(pA, 2)
        ldB = stride(pB, 2)
        ldC = stride(C, 2)
        α = one($T)
        β = zero($T)
        ccall(
          $fm,
          Cvoid,
          (
            Ref{UInt8},
            Ref{UInt8},
            Ref{Int64},
            Ref{Int64},
            Ref{Int64},
            Ref{$T},
            Ref{$T},
            Ref{Int64},
            Ref{$T},
            Ref{Int64},
            Ref{$T},
            Ref{$T},
            Ref{Int64}
          ),
          transA,
          transB,
          M,
          N,
          K,
          α,
          pA,
          ldA,
          pB,
          ldB,
          β,
          C,
          ldC
        )
      end
    end
  end
end
if MKL_BENCH
  mkl_set_num_threads(N::Integer) =
    ccall(MKL_SET_NUM_THREADS, Cvoid, (Int32,), N % Int32)
  mkl_set_num_threads(1)
end
openblas_set_num_threads(N::Integer) =
  ccall(OPENBLAS_SET_NUM_THREADS, Cvoid, (Int64,), N)
openblas_set_num_threads(1)

function dgemvmkl!(
  y::AbstractVector{Float64},
  A::AbstractMatrix{Float64},
  x::AbstractVector{Float64},
  α = 1.0,
  β = 0.0
)
  transA = istransposed(A)
  pA = parent(A)
  M, N = size(pA)
  ldA = stride(pA, 2)
  incx = LinearAlgebra.stride1(x)
  incy = LinearAlgebra.stride1(y)
  ccall(
    DGEMV_MKL,
    Cvoid,
    (
      Ref{UInt8},
      Ref{Int64},
      Ref{Int64},
      Ref{Float64},
      Ref{Float64},
      Ref{Int64},
      Ref{Float64},
      Ref{Int64},
      Ref{Float64},
      Ref{Float64},
      Ref{Int64}
    ),
    transA,
    M,
    N,
    α,
    pA,
    ldA,
    x,
    incx,
    β,
    y,
    incy
  )
end
function dgemvopenblas!(
  y::AbstractVector{Float64},
  A::AbstractMatrix{Float64},
  x::AbstractVector{Float64}
)
  transA = istransposed(A)
  pA = parent(A)
  M, N = size(pA)
  ldA = stride(pA, 2)
  incx = LinearAlgebra.stride1(x)
  incy = LinearAlgebra.stride1(y)
  α = 1.0
  β = 0.0
  ccall(
    DGEMV_OpenBLAS,
    Cvoid,
    (
      Ref{UInt8},
      Ref{Int64},
      Ref{Int64},
      Ref{Float64},
      Ref{Float64},
      Ref{Int64},
      Ref{Float64},
      Ref{Int64},
      Ref{Float64},
      Ref{Float64},
      Ref{Int64}
    ),
    transA,
    M,
    N,
    α,
    pA,
    ldA,
    x,
    incx,
    β,
    y,
    incy
  )
end

for (prefix, Eshared) ∈ ((Symbol(""), LIBEIGENTEST), (:i, LIBIEIGENTEST))
  @eval function $(Symbol(prefix, :egemm!))(C, A, B)
    M, N = size(C)
    K = size(B, 1)
    ccall(
      (:AmulB, $Eshared),
      Cvoid,
      (Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Clong, Clong, Clong),
      C,
      A,
      B,
      M,
      K,
      N
    )
  end
  let (p, s) = (:e, Eshared)
    @eval function $(Symbol(prefix, p, :gemm!))(C, A::Adjoint, B)
      M, N = size(C)
      K = size(B, 1)
      ccall(
        (:AtmulB, $s),
        Cvoid,
        (Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Clong, Clong, Clong),
        C,
        parent(A),
        B,
        M,
        K,
        N
      )
    end
    @eval function $(Symbol(prefix, p, :gemm!))(C, A, B::Adjoint)
      M, N = size(C)
      K = size(B, 1)
      ccall(
        (:AmulBt, $s),
        Cvoid,
        (Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Clong, Clong, Clong),
        C,
        A,
        parent(B),
        M,
        K,
        N
      )
    end
    @eval function $(Symbol(prefix, p, :gemm!))(C, A::Adjoint, B::Adjoint)
      M, N = size(C)
      K = size(B, 1)
      ccall(
        (:AtmulBt, $s),
        Cvoid,
        (Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Clong, Clong, Clong),
        C,
        parent(A),
        parent(B),
        M,
        K,
        N
      )
    end
    @eval function $(Symbol(prefix, p, :dot))(a, b)
      N = length(a)
      ccall((:dot, $s), Float64, (Ptr{Float64}, Ptr{Float64}, Clong), a, b, N)
    end
    @eval function $(Symbol(prefix, p, :gemv!))(y, A, x)
      M, K = size(A)
      ccall(
        ($(QuoteNode(p === :c ? :gemv : :Amulvb)), $s),
        Cvoid,
        (Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Clong, Clong),
        y,
        A,
        x,
        M,
        K
      )
    end
    @eval function $(Symbol(prefix, p, :selfdot))(a)
      N = length(a)
      ccall((:selfdot, $s), Float64, (Ptr{Float64}, Clong), a, N)
    end
    @eval function $(Symbol(prefix, p, :dot3))(x, A, y)
      M, N = size(A)
      ccall(
        (:dot3, $s),
        Float64,
        (Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Clong, Clong),
        x,
        A,
        y,
        M,
        N
      )
    end
    @eval function $(Symbol(prefix, p, :gemv!))(y, A::Adjoint, x)
      M, K = size(A)
      ccall(
        (:Atmulvb, $s),
        Cvoid,
        (Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Clong, Clong),
        y,
        parent(A),
        x,
        M,
        K
      )
    end
    @eval function $(Symbol(prefix, p, :aplusBc!))(D, a, B, c)
      M, K = size(B)
      ccall(
        (:aplusBc, $s),
        Cvoid,
        (Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Clong, Clong),
        D,
        a,
        B,
        c,
        M,
        K
      )
    end
    @eval function $(Symbol(prefix, p, :OLSlp))(y, X, β)
      N, P = size(X)
      ccall(
        (:OLSlp, $s),
        Float64,
        (Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Clong, Clong),
        y,
        X,
        β,
        N,
        P
      )
    end
    @eval function $(Symbol(prefix, p, :AplusAt!))(B, A)
      N = size(B, 1)
      ccall((:AplusAt, $s), Cvoid, (Ptr{Float64}, Ptr{Float64}, Clong), B, A, N)
    end
    @eval function $(Symbol(prefix, p, :logdettriangle))(
      T::Union{LowerTriangular,UpperTriangular}
    )
      N = size(T, 1)
      Tp = parent(T)
      ccall((:logdettriangle, $s), Float64, (Ptr{Float64}, Clong), Tp, N)
    end
  end
end
funcs_to_define = if INTEL_BENCH
  ((Symbol(""), LIBCTEST, LIBFTEST), (:i, LIBICTEST, LIBIFTEST))
else
  ((Symbol(""), LIBCTEST, LIBFTEST),)
end
for (prefix, Cshared, Fshared) ∈ funcs_to_define
  for order ∈ (:kmn, :knm, :mkn, :mnk, :nkm, :nmk)
    gemm = Symbol(:gemm_, order)
    @eval function $(Symbol(prefix, :c, gemm, :!))(C, A, B)
      M, N = size(C)
      K = size(B, 1)
      ccall(
        ($(QuoteNode(gemm)), $Cshared),
        Cvoid,
        (Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Clong, Clong, Clong),
        C,
        A,
        B,
        M,
        K,
        N
      )
    end
    @eval function $(Symbol(prefix, :f, gemm, :!))(C, A, B)
      M, N = size(C)
      K = size(B, 1)
      ccall(
        ($(QuoteNode(gemm)), $Fshared),
        Cvoid,
        (
          Ptr{Float64},
          Ptr{Float64},
          Ptr{Float64},
          Ref{Clong},
          Ref{Clong},
          Ref{Clong}
        ),
        C,
        A,
        B,
        Ref(M),
        Ref(K),
        Ref(N)
      )
    end
  end
  @eval $(Symbol(prefix, :cgemm!))(C, A, B) =
    $(Symbol(prefix, :cgemm_nkm!))(C, A, B)
  @eval $(Symbol(prefix, :fgemm!))(C, A, B) =
    $(Symbol(prefix, :fgemm_nkm!))(C, A, B)
  @eval function $(Symbol(prefix, :fgemm_builtin!))(C, A, B)
    M, N = size(C)
    K = size(B, 1)
    ccall(
      (:gemmbuiltin, $Fshared),
      Cvoid,
      (
        Ptr{Float64},
        Ptr{Float64},
        Ptr{Float64},
        Ref{Clong},
        Ref{Clong},
        Ref{Clong}
      ),
      C,
      A,
      B,
      Ref(M),
      Ref(K),
      Ref(N)
    )
  end
  let (p, s) = (:c, Cshared)
    @eval function $(Symbol(prefix, p, :gemm!))(C, A::Adjoint, B)
      M, N = size(C)
      K = size(B, 1)
      ccall(
        (:AtmulB, $s),
        Cvoid,
        (Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Clong, Clong, Clong),
        C,
        parent(A),
        B,
        M,
        K,
        N
      )
    end
  end
  @eval function $(Symbol(prefix, :fgemm!))(C, A::Adjoint, B)
    M, N = size(C)
    K = size(B, 1)
    ccall(
      (:AtmulB, $Fshared),
      Cvoid,
      (
        Ptr{Float64},
        Ptr{Float64},
        Ptr{Float64},
        Ref{Clong},
        Ref{Clong},
        Ref{Clong}
      ),
      C,
      parent(A),
      B,
      Ref(M),
      Ref(K),
      Ref(N)
    )
  end
  @eval function $(Symbol(prefix, :fgemm_builtin!))(C, A::Adjoint, B)
    M, N = size(C)
    K = size(B, 1)
    ccall(
      (:AtmulBbuiltin, $Fshared),
      Cvoid,
      (
        Ptr{Float64},
        Ptr{Float64},
        Ptr{Float64},
        Ref{Clong},
        Ref{Clong},
        Ref{Clong}
      ),
      C,
      parent(A),
      B,
      Ref(M),
      Ref(K),
      Ref(N)
    )
  end
  let (p, s) = (:c, Cshared)# (:e,Eshared)]
    @eval function $(Symbol(prefix, p, :gemm!))(C, A, B::Adjoint)
      M, N = size(C)
      K = size(B, 1)
      ccall(
        (:AmulBt, $s),
        Cvoid,
        (Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Clong, Clong, Clong),
        C,
        A,
        parent(B),
        M,
        K,
        N
      )
    end
  end
  @eval function $(Symbol(prefix, :fgemm!))(C, A, B::Adjoint)
    M, N = size(C)
    K = size(B, 1)
    ccall(
      (:AmulBt, $Fshared),
      Cvoid,
      (
        Ptr{Float64},
        Ptr{Float64},
        Ptr{Float64},
        Ref{Clong},
        Ref{Clong},
        Ref{Clong}
      ),
      C,
      A,
      parent(B),
      Ref(M),
      Ref(K),
      Ref(N)
    )
  end
  @eval function $(Symbol(prefix, :fgemm_builtin!))(C, A, B::Adjoint)
    M, N = size(C)
    K = size(B, 1)
    ccall(
      (:AmulBtbuiltin, $Fshared),
      Cvoid,
      (
        Ptr{Float64},
        Ptr{Float64},
        Ptr{Float64},
        Ref{Clong},
        Ref{Clong},
        Ref{Clong}
      ),
      C,
      A,
      parent(B),
      Ref(M),
      Ref(K),
      Ref(N)
    )
  end
  @eval function $(Symbol(prefix, :fgemm!))(C, A::Adjoint, B::Adjoint)
    M, N = size(C)
    K = size(B, 1)
    ccall(
      (:AtmulBt, $Fshared),
      Cvoid,
      (
        Ptr{Float64},
        Ptr{Float64},
        Ptr{Float64},
        Ref{Clong},
        Ref{Clong},
        Ref{Clong}
      ),
      C,
      parent(A),
      parent(B),
      Ref(M),
      Ref(K),
      Ref(N)
    )
  end
  @eval function $(Symbol(prefix, :fgemm_builtin!))(C, A::Adjoint, B::Adjoint)
    M, N = size(C)
    K = size(B, 1)
    ccall(
      (:AtmulBtbuiltin, $Fshared),
      Cvoid,
      (
        Ptr{Float64},
        Ptr{Float64},
        Ptr{Float64},
        Ref{Clong},
        Ref{Clong},
        Ref{Clong}
      ),
      C,
      parent(A),
      parent(B),
      Ref(M),
      Ref(K),
      Ref(N)
    )
  end
  @eval function $(Symbol(prefix, :fdot))(a, b)
    N = length(a)
    ccall(
      (:dot, $Fshared),
      Float64,
      (Ptr{Float64}, Ptr{Float64}, Ref{Clong}),
      a,
      b,
      Ref(N)
    )
  end

  @eval function $(Symbol(prefix, :fselfdot))(a)
    N = length(a)
    ccall((:selfdot, $Fshared), Float64, (Ptr{Float64}, Ref{Clong}), a, Ref(N))
  end
  @eval function $(Symbol(prefix, :fdot3))(x, A, y)
    M, N = size(A)
    ccall(
      (:dot3, $Fshared),
      Float64,
      (Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Ref{Clong}, Ref{Clong}),
      x,
      A,
      y,
      Ref(M),
      Ref(N)
    )
  end
  @eval function $(Symbol(prefix, :fgemv!))(y, A, x)
    M, K = size(A)
    ccall(
      (:gemv, $Fshared),
      Cvoid,
      (Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Ref{Clong}, Ref{Clong}),
      y,
      A,
      x,
      Ref(M),
      Ref(K)
    )
  end
  @eval function $(Symbol(prefix, :fgemv_builtin!))(y, A, x)
    M, K = size(A)
    ccall(
      (:gemvbuiltin, $Fshared),
      Cvoid,
      (Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Ref{Clong}, Ref{Clong}),
      y,
      A,
      x,
      Ref(M),
      Ref(K)
    )
  end
  @eval function $(Symbol(prefix, :fgemv!))(y, A::Adjoint, x)
    M, K = size(A)
    ccall(
      (:Atmulvb, $Fshared),
      Cvoid,
      (Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Ref{Clong}, Ref{Clong}),
      y,
      parent(A),
      x,
      Ref(M),
      Ref(K)
    )
  end
  @eval function $(Symbol(prefix, :fgemv_builtin!))(y, A::Adjoint, x)
    M, K = size(A)
    ccall(
      (:Atmulvbbuiltin, $Fshared),
      Cvoid,
      (Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Ref{Clong}, Ref{Clong}),
      y,
      parent(A),
      x,
      Ref(M),
      Ref(K)
    )
  end
  let (p, s) = (:c, Cshared)# (:e,Eshared)]
    @eval function $(Symbol(prefix, p, :gemm!))(C, A::Adjoint, B::Adjoint)
      M, N = size(C)
      K = size(B, 1)
      ccall(
        (:AtmulBt, $s),
        Cvoid,
        (Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Clong, Clong, Clong),
        C,
        parent(A),
        parent(B),
        M,
        K,
        N
      )
    end
    @eval function $(Symbol(prefix, p, :dot))(a, b)
      N = length(a)
      ccall((:dot, $s), Float64, (Ptr{Float64}, Ptr{Float64}, Clong), a, b, N)
    end
    @eval function $(Symbol(prefix, p, :gemv!))(y, A, x)
      M, K = size(A)
      ccall(
        ($(QuoteNode(p === :c ? :gemv : :Amulvb)), $s),
        Cvoid,
        (Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Clong, Clong),
        y,
        A,
        x,
        M,
        K
      )
    end
    @eval function $(Symbol(prefix, p, :selfdot))(a)
      N = length(a)
      ccall((:selfdot, $s), Float64, (Ptr{Float64}, Clong), a, N)
    end
    @eval function $(Symbol(prefix, p, :dot3))(x, A, y)
      M, N = size(A)
      ccall(
        (:dot3, $s),
        Float64,
        (Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Clong, Clong),
        x,
        A,
        y,
        M,
        N
      )
    end
    @eval function $(Symbol(prefix, p, :gemv!))(y, A::Adjoint, x)
      M, K = size(A)
      ccall(
        (:Atmulvb, $s),
        Cvoid,
        (Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Clong, Clong),
        y,
        parent(A),
        x,
        M,
        K
      )
    end
    @eval function $(Symbol(prefix, p, :aplusBc!))(D, a, B, c)
      M, K = size(B)
      ccall(
        (:aplusBc, $s),
        Cvoid,
        (Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Clong, Clong),
        D,
        a,
        B,
        c,
        M,
        K
      )
    end
    @eval function $(Symbol(prefix, p, :OLSlp))(y, X, β)
      N, P = size(X)
      ccall(
        (:OLSlp, $s),
        Float64,
        (Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Clong, Clong),
        y,
        X,
        β,
        N,
        P
      )
    end
    @eval function $(Symbol(prefix, p, :AplusAt!))(B, A)
      N = size(B, 1)
      ccall((:AplusAt, $s), Cvoid, (Ptr{Float64}, Ptr{Float64}, Clong), B, A, N)
    end
    @eval function $(Symbol(prefix, p, :logdettriangle))(
      T::Union{LowerTriangular,UpperTriangular}
    )
      N = size(T, 1)
      Tp = parent(T)
      ccall((:logdettriangle, $s), Float64, (Ptr{Float64}, Clong), Tp, N)
    end
  end
  @eval function $(Symbol(prefix, :faplusBc!))(D, a, B, c)
    M, K = size(B)
    ccall(
      (:aplusBc, $Fshared),
      Cvoid,
      (
        Ptr{Float64},
        Ptr{Float64},
        Ptr{Float64},
        Ptr{Float64},
        Ref{Clong},
        Ref{Clong}
      ),
      D,
      a,
      B,
      c,
      Ref(M),
      Ref(K)
    )
  end
  @eval function $(Symbol(prefix, :fOLSlp))(y, X, β)
    N, P = size(X)
    ccall(
      (:OLSlp, $Fshared),
      Float64,
      (Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Ref{Clong}, Ref{Clong}),
      y,
      X,
      β,
      Ref(N),
      Ref(P)
    )
  end
  @eval function $(Symbol(prefix, :cvexp!))(b, a)
    N = length(b)
    ccall(
      (:vexp, $Cshared),
      Cvoid,
      (Ptr{Float64}, Ptr{Float64}, Clong),
      b,
      a,
      N
    )
  end
  @eval function $(Symbol(prefix, :fvexp!))(b, a)
    N = length(b)
    ccall(
      (:vexp, $Fshared),
      Cvoid,
      (Ptr{Float64}, Ptr{Float64}, Ref{Clong}),
      b,
      a,
      Ref(N)
    )
  end
  @eval function $(Symbol(prefix, :fvexpsum))(a)
    N = length(a)
    s = Ref{Float64}()
    ccall(
      (:svexp, $Fshared),
      Cvoid,
      (Ref{Float64}, Ptr{Float64}, Ref{Clong}),
      s,
      a,
      Ref(N)
    )
    s[]
  end
  @eval function $(Symbol(prefix, :fAplusAt!))(B, A)
    N = size(B, 1)
    ccall(
      (:AplusAt, $Fshared),
      Cvoid,
      (Ptr{Float64}, Ptr{Float64}, Ref{Clong}),
      B,
      A,
      Ref(N)
    )
  end
  @eval function $(Symbol(prefix, :fAplusAt_builtin!))(B, A)
    N = size(B, 1)
    ccall(
      (:AplusAtbuiltin, $Fshared),
      Cvoid,
      (Ptr{Float64}, Ptr{Float64}, Ref{Clong}),
      B,
      A,
      Ref(N)
    )
  end

  @eval function $(Symbol(prefix, :crandomaccess))(P, basis, coefs)
    A, C = size(P)
    ccall(
      (:randomaccess, $Cshared),
      Float64,
      (Ptr{Float64}, Ptr{Clong}, Ptr{Float64}, Clong, Clong),
      P,
      basis,
      coefs,
      A,
      C
    )
  end
  @eval function $(Symbol(prefix, :frandomaccess))(P, basis, coefs)
    A, C = size(P)
    ccall(
      (:randomaccess, $Fshared),
      Float64,
      (Ptr{Float64}, Ptr{Clong}, Ptr{Float64}, Ref{Clong}, Ref{Clong}),
      P,
      basis,
      coefs,
      Ref(A),
      Ref(C)
    )
  end
  @eval function $(Symbol(prefix, :flogdettriangle))(
    T::Union{LowerTriangular,UpperTriangular}
  )
    N = size(T, 1)
    Tp = parent(T)
    ccall(
      (:logdettriangle, $Fshared),
      Float64,
      (Ptr{Float64}, Ref{Clong}),
      Tp,
      Ref(N)
    )
  end
  @eval function $(Symbol(prefix, :cfilter2d!))(
    B::OffsetArray,
    A::AbstractArray,
    K::OffsetArray
  )
    Ma, Na = size(A)
    offset = first(B.offsets)
    ccall(
      (:filter2d, $Cshared),
      Cvoid,
      (Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Clong, Clong, Clong),
      parent(B),
      A,
      parent(K),
      Ma,
      Na,
      offset
    )
  end
  @eval function $(Symbol(prefix, :ffilter2d!))(
    B::OffsetArray,
    A::AbstractArray,
    K::OffsetArray
  )
    Ma, Na = size(A)
    offset = first(B.offsets)
    ccall(
      (:filter2d, $Fshared),
      Cvoid,
      (
        Ptr{Float64},
        Ptr{Float64},
        Ptr{Float64},
        Ref{Clong},
        Ref{Clong},
        Ref{Clong}
      ),
      parent(B),
      A,
      parent(K),
      Ref(Ma),
      Ref(Na),
      Ref(offset)
    )
  end
  @eval function $(Symbol(prefix, :cfilter2d!))(
    B::OffsetArray,
    A::AbstractArray,
    K::SizedOffsetMatrix{Float64,-1,1,-1,1}
  )
    Ma, Na = size(A)
    ccall(
      (:filter2d3x3, $Cshared),
      Cvoid,
      (Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Clong, Clong),
      parent(B),
      A,
      K,
      Ma,
      Na
    )
  end
  @eval function $(Symbol(prefix, :ffilter2d!))(
    B::OffsetArray,
    A::AbstractArray,
    K::SizedOffsetMatrix{Float64,-1,1,-1,1}
  )
    Ma, Na = size(A)
    ccall(
      (:filter2d3x3, $Fshared),
      Cvoid,
      (Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Ref{Clong}, Ref{Clong}),
      parent(B),
      A,
      K,
      Ref(Ma),
      Ref(Na)
    )
  end
  @eval function $(Symbol(prefix, :cfilter2dunrolled!))(
    B::OffsetArray,
    A::AbstractArray,
    K::SizedOffsetMatrix{Float64,-1,1,-1,1}
  )
    Ma, Na = size(A)
    ccall(
      (:filter2d3x3unrolled, $Cshared),
      Cvoid,
      (Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Clong, Clong),
      parent(B),
      A,
      K,
      Ma,
      Na
    )
  end
  @eval function $(Symbol(prefix, :ffilter2dunrolled!))(
    B::OffsetArray,
    A::AbstractArray,
    K::SizedOffsetMatrix{Float64,-1,1,-1,1}
  )
    Ma, Na = size(A)
    ccall(
      (:filter2d3x3unrolled, $Fshared),
      Cvoid,
      (Ptr{Float64}, Ptr{Float64}, Ptr{Float64}, Ref{Clong}, Ref{Clong}),
      parent(B),
      A,
      K,
      Ref(Ma),
      Ref(Na)
    )
  end
end

# issue 288
function not_a_reduction!(A, B)
  @turbo for j ∈ 1:size(A.re, 2)
    jre = B.re[j]
    jim = B.im[j]
    for i ∈ 1:size(A.re, 1)
      ire = B.re[i]
      iim = B.im[i]
      cisim = iim * jre - ire * jim
      cisre = ire * jre + iim * jim
      ρre_i = A.re[i, j]
      ρim_i = A.im[i, j]
      re_out = ρre_i * cisre - ρim_i * cisim
      im_out = ρre_i * cisim + ρim_i * cisre
      A.re[i, j] = re_out
      A.im[i, j] = im_out
    end
  end
  return nothing
end
function not_a_reduction_noturbo!(A, B)
  @turbo for j ∈ 1:size(A.re, 2)
    jre = B.re[j]
    jim = B.im[j]
    for i ∈ 1:size(A.re, 1)
      ire = B.re[i]
      iim = B.im[i]
      cisim = iim * jre - ire * jim
      cisre = ire * jre + iim * jim
      ρre_i = A.re[i, j]
      ρim_i = A.im[i, j]
      re_out = ρre_i * cisre - ρim_i * cisim
      im_out = ρre_i * cisim + ρim_i * cisre
      A.re[i, j] = re_out
      A.im[i, j] = im_out
    end
  end
  return nothing
end

@testset "Untangle reductions" begin
  @show @__LINE__
  N = 11
  A1 = (re = rand(N, N), im = rand(N, N))
  A2 = deepcopy(A1)
  B = (re = rand(N), im = rand(N))
  not_a_reduction!(A1, B)
  not_a_reduction_noturbo!(A2, B)
  @test A1.re ≈ A2.re
  @test A1.im ≈ A2.im
end

@testset "filter" begin
  N = 347
  for T ∈ (Float32, Float64, Int32, Int64)
    @show T, @__LINE__
    if T <: Integer
      x = rand(T(-100):T(100), N)
    else
      x = rand(T, N)
    end
    y1 = filter(a -> a > 0.7, x)
    y2 = vfilter(a -> a > 0.7, x)
    @test y1 == y2
    y1 = filter(a -> a ≤ 0.7, x)
    y3 = vfilter(a -> a ≤ 0.7, x)
    @test y1 == y3
    @test length(y2) + length(y3) == N
  end
end

using LoopVectorization, Test
using LoopVectorization: ArrayInterface
using LoopVectorization: check_inputs!

# macros for generate loops whose body is not a block
macro gen_loop_issue395(ex)
  sym, ind = ex.args
  loop_body = :(ret[$ind] = $sym[$ind])
  loop = Expr(:for, :($ind = axes($sym, 1)), loop_body)
  return esc(:(@turbo $loop))
end
macro gen_single_loop(B, A)
  loop_body = :($B[i] = $A[i])
  loop = Expr(:for, :(i = indices(($B, $A), 1)), loop_body)
  return esc(:(@turbo $loop))
end
macro gen_nest_loop(C, A, B)
  loop_body = :($C[i, j] = $A[i] * $B[j])
  loop_head = Expr(:block, :(j = indices(($C, $B), (2, 1))), :(i = indices(($C, $A), 1)))
  loop = Expr(:for, loop_head, loop_body)
  return esc(:(@turbo $loop))
end
macro gen_A_mul_B(C, A, B)
  inner_body = :(Cji += $A[j, k] * $B[k, i])
  inner_loop = Expr(:for, :(k = indices(($A, $B), (2, 1))), inner_body)
  loop = :(
    for i in indices(($C, $B), 2), j in indices(($C, $A), 1)
      Cji = zero(eltype($C))
      $inner_loop
      $C[j, i] = Cji
    end
  )
  return esc(:(@turbo $loop))
end

@testset "check_block, #395" begin
  A = rand(4)
  B = rand(4)
  C = rand(4, 4)
  D = zeros(4)
  E = zeros(4, 4)
  F = zeros(4, 4)
  ret = zeros(4)
  @gen_single_loop D A
  @gen_loop_issue395 B[i]
  @gen_nest_loop E A B
  @gen_A_mul_B F C E
  @test D == A
  @test ret == B
  @test E ≈ A * B'
  @test F ≈ C * E
end

@testset "enumerate, #393" begin
  A = zeros(4)
  B = zeros(4)
  C = zeros(4, 4)
  D = zeros(4, 4)
  @turbo for (i, x) in enumerate(1:4)
    A[i] = x
  end
  @turbo for (i,) in enumerate(B)
    B[i] += 1
  end
  @turbo for (j, Aj) in enumerate(A), (i, Bi) in enumerate(B)
    C[i, j] = Aj * Bi
  end
  @turbo for (j, Bj) in enumerate(B)
    for (i, Ai) in enumerate(A)
      D[i, j] = Ai * Bj
    end
  end
  @test A == 1:4
  @test B == ones(4)
  @test A .* B' == C' == D
  @test_throws ArgumentError check_inputs!(:(
    for ix in enumerate(A)
      A[ix[1]] = ix[1] + ix[2]
    end
  ), Any[])
  @test_throws ArgumentError check_inputs!(:(
    for () in enumerate(A)
    end
  ), Any[])
end

using Zygote, Test, LinearAlgebra
zygotefun2(a, b) = sigmoid_fast(a + b) + LoopVectorization.relu(a * b) * tanh(a - b)
zygotefun3(a, b, c) = log(tanh_fast(a * b) + 1 + exp(b - c))
@testset "Zygote" begin
  @show @__LINE__

  for T ∈ (Float32, Float64)
    x = randn(T, 217)
    y = randn(T, 217)
    z = randn(T, 217)
    w = randn(T, 217)
    # Test 1-arg and `tanh_fast` vs `tanh`
    gref1 = gradient(x -> dot(w, map(tanh, x)), x)
    glv_1 = gradient(x -> dot(w, vmap(tanh_fast, x)), x)

    @test only(gref1) ≈ only(glv_1)

    # Test 2 arguments
    # Test 3 arguments
    gref2 = gradient(xyz -> dot(w, map(zygotefun2, xyz...)), (x, y))
    g_lv2 = gradient(xyz -> dot(w, vmap(zygotefun2, xyz...)), (x, y))

    @test all(map(≈, only(gref2), only(g_lv2)))

    gref3 = gradient(xyz -> dot(w, map(zygotefun3, xyz...)), (x, y, z))
    g_lv3 = gradient(xyz -> dot(w, vmap(zygotefun3, xyz...)), (x, y, z))

    @test all(map(≈, only(gref3), only(g_lv3)))
  end
end

using Base: Forward

using NNlib, LoopVectorization, VectorizationBase, ForwardDiff, Test
randnvec() = Vec(ntuple(_ -> randn(), pick_vector_width(Float64))...)

tovec(x::Vec{W,T}) where {W,T} = T[Tuple(x)...]
tovec(x::VecUnroll) = reduce(vcat, map(tovec, VectorizationBase.data(x)))
function tovec(x::ForwardDiff.Dual{T,V,N}) where {T,V,N}
  v = tovec(ForwardDiff.value(x))
  dv = map(tovec, Tuple(ForwardDiff.partials(x)))
  D = ForwardDiff.Dual{T,eltype(v),N}
  ret = Vector{D}(undef, length(v))
  for i in eachindex(v)
    ret[i] = ForwardDiff.Dual(v[i], map(Base.Fix2(Base.getindex, i), dv)...)
  end
  return ret
end

vx0 = randnvec()
vx1 = randnvec()
vx2 = randnvec()
vx3 = randnvec()
vx4 = randnvec()
vx5 = randnvec()

vd0 = ForwardDiff.Dual(vx0, vx1, vx2, vx3, vx4, vx5)

vu0 = VecUnroll((vx0, vx1))
vu1 = VecUnroll((vx2, vx3))
vu2 = VecUnroll((vx4, vx5))

vud = ForwardDiff.Dual(vu0, vu1, vu2)

@test reinterpret(Float64, tovec(NNlib.leakyrelu(vd0))) ≈
      reinterpret(Float64, NNlib.leakyrelu.(tovec(vd0)))
@test reinterpret(Float64, tovec(NNlib.leakyrelu(vud))) ≈
      reinterpret(Float64, NNlib.leakyrelu.(tovec(vud)))

@test reinterpret(Float64, tovec(NNlib.relu(vd0))) ≈
      reinterpret(Float64, NNlib.relu.(tovec(vd0)))
@test reinterpret(Float64, tovec(NNlib.relu(vud))) ≈
      reinterpret(Float64, NNlib.relu.(tovec(vud)))

function add_operation!(
  ls_new::LoopSet,
  included::Vector{Int},
  ls::LoopSet,
  op::Operation,
  ids::Vector{Int},
  issecond::Bool
)
  newid = included[identifier(op)]
  iszero(newid) || return operations(ls_new)[newid]
  vparents = Operation[]
  for opp ∈ parents(op)
    # TODO: get it so that
    # a[i] = f(a[i]) will split into one loop computing and storing f(a[i]), and the other loading from that storage if it needs it.
    if issecond && (iscompute(opp) & (!isstore(op)))
      found = false
      for opc ∈ children(opp)
        if isstore(opc) && identifier(opc) ∉ ids
          # @show opp opc op
          # replace opp with a load from opc
          parentsopc = parents(opc)
          parentsnew = length(parentsopc) > 1 ? Operation[] : NOPARENTS
          opnew = Operation(
            length(operations(ls_new)),
            name(opp),
            opc.elementbytes,
            instruction(:getindex),
            memload,
            loopdependencies(opc),
            reduceddependencies(opc),
            parentsnew,
            opc.ref,
            reducedchildren(opc)
          )
          addsetv!(ls_new.includedactualarrays, vptr(opc.ref))
          push!(operations(ls_new), opnew)
          push!(vparents, opnew)
          for i ∈ 2:length(parentsopc)
            push!(
              parentsnew,
              add_operation!(
                ls_new,
                included,
                ls,
                parentsopc[i],
                ids,
                issecond
              )
            )
          end
          included[identifier(opp)] = identifier(opnew)
          found = true
          break
        end
      end
      found && continue
    end
    push!(vparents, add_operation!(ls_new, included, ls, opp, ids, issecond))
  end
  opnew = Operation(
    length(operations(ls_new)),
    name(op),
    op.elementbytes,
    instruction(op),
    op.node_type,
    loopdependencies(op),
    reduceddependencies(op),
    vparents,
    op.ref,
    reducedchildren(op)
  )
  accesses_memory(op) && addsetv!(ls_new.includedactualarrays, vptr(op.ref))
  push!(operations(ls_new), opnew)
  included[identifier(op)] = identifier(opnew)
  opnew
end

append_if_included!(vnew, vold, included) =
  for (i, v) ∈ vold
    id = included[i]
    iszero(id) || push!(vnew, (id, v))
  end

function split_loopset(ls::LoopSet, ids::Vector{Int}, issecond::Bool)
  ls_new = LoopSet(:LoopVectorization)
  included = zeros(Int, length(operations(ls)))
  for i ∈ ids
    add_operation!(ls_new, included, ls, operations(ls)[i], ids, issecond)
  end
  for op ∈ operations(ls_new)
    for l ∈ loopdependencies(op)
      if l ∉ ls_new.loopsymbols
        add_loop!(ls_new, getloop(ls, l))
      end
    end
    length(ls_new.loopsymbols) == length(ls.loopsymbols) && break
  end
  append_if_included!(ls_new.preamble_symsym, ls.preamble_symsym, included)
  append_if_included!(ls_new.preamble_symint, ls.preamble_symint, included)
  append_if_included!(ls_new.preamble_symfloat, ls.preamble_symfloat, included)
  append_if_included!(ls_new.preamble_zeros, ls.preamble_zeros, included)
  append_if_included!(
    ls_new.preamble_funcofeltypes,
    ls.preamble_funcofeltypes,
    included
  )
  for i ∈ ls.outer_reductions
    id = included[i]
    iszero(id) || push!(ls_new.outer_reductions, id)
  end
  # TODO: allow them to differ. E.g., non-AVX2 x86 cpus don't have efficient integer calculations
  # Therefore, it would be profitable to split for this reason.
  # However, currently the default assumption in vector width will be wrong, so we should calculate
  # it correctly (like ls.vector_width); wrong (too high) value will encourage splitting when
  # it shouldn't.
  # Current behavior is incorrect when VECWIDTH chosen does actually differ between
  # split loops and the loops are statically sized, because code gen will then assume it is correct...
  set_hw!(ls_new, reg_size(ls), reg_count(ls), cache_lnsze(ls))
  ls_new.vector_width = ls.vector_width
  fill_offset_memop_collection!(ls)
  # println("ls_new operations:")
  # display(ls_new.operations)
  # println()
  ls_new
end

function returned_ops(ls::LoopSet)
  ops = operations(ls)
  retops = Int[]
  for op ∈ ops
    isstore(op) && push!(retops, identifier(op))
  end
  for i ∈ ls.outer_reductions
    push!(retops, i)
  end
  retops
end

function lower_and_split_loops(ls::LoopSet, inline::Int)
  split_candidates = returned_ops(ls)
  length(split_candidates) > 1 || return lower(ls, inline)
  order_fused,
  unrolled_fused,
  tiled_fused,
  vectorized_fused,
  U_fused,
  T_fused,
  cost_fused,
  shouldinline_fused = choose_order_cost(ls)
  remaining_ops = Vector{Int}(undef, length(split_candidates) - 1)
  split_1 = Int[0]
  # for (ind,i) ∈ enumerate(split_candidates)
  looplenpen = 0.05
  ls_looplen = looplengthprod(ls) * looplenpen
  for (ind, i) ∈ enumerate(split_candidates)
    split_1[1] = i
    ls_1 = split_loopset(ls, split_1, false)
    order_1,
    unrolled_1,
    tiled_1,
    vectorized_1,
    U_1,
    T_1,
    cost_1,
    shouldinline_1 = choose_order_cost(ls_1)
    remaining_ops[1:ind-1] .= @view(split_candidates[1:ind-1])
    remaining_ops[ind:end] .= @view(split_candidates[ind+1:end])
    ls_2 = split_loopset(ls, remaining_ops, true)
    order_2,
    unrolled_2,
    tiled_2,
    vectorized_2,
    U_2,
    T_2,
    cost_2,
    shouldinline_2 = choose_order_cost(ls_2)
    # U_1 = T_1 = U_2 = T_2 = 2
    if cost_1 +
       cost_2 +
       looplenpen * (looplengthprod(ls_1) + looplengthprod(ls_2)) ≤
       muladd(0.9, cost_fused, ls_looplen)
      ls_2_lowered = if length(remaining_ops) > 1
        inline = iszero(inline) ? (shouldinline_1 % Int) : inline
        lower_and_split_loops(ls_2, inline)
      else
        doinline = inlinedecision(inline, shouldinline_1 | shouldinline_2)
        lower(
          ls_2,
          order_2,
          unrolled_2,
          tiled_2,
          vectorized_2,
          U_2,
          T_2,
          doinline
        )
      end
      return Expr(
        :block,
        ls.preamble,
        lower(
          ls_1,
          order_1,
          unrolled_1,
          tiled_1,
          vectorized_1,
          U_1,
          T_1,
          false
        ),
        ls_2_lowered,
        nothing
      )
    end
    length(split_candidates) == 2 && break
  end
  doinline = inlinedecision(inline, shouldinline_fused)
  lower(
    ls,
    order_fused,
    unrolled_fused,
    tiled_fused,
    vectorized_fused,
    U_fused,
    T_fused,
    doinline
  )
end

# the `lowernonstore` and `lowerstore` options are there as a means of lowering all non-store operations before lowering the stores.
function lower!(
  q::Expr,
  ops::AbstractVector{Operation},
  ls::LoopSet,
  unrollsyms::UnrollSymbols,
  u₁::Int,
  u₂::Int,
  suffix::Int,
  mask::Bool,
  lowernonstore::Bool,
  lowerstore::Bool
)
  ua = UnrollArgs(ls, u₁, unrollsyms, u₂, suffix)
  for op ∈ ops
    if isstore(op)
      lowerstore && lower_store!(q, ls, op, ua, mask)
    else
      lowernonstore || continue
      if isconstant(op)
        zerotyp = zerotype(ls, op)
        if zerotyp == INVALID
          lower_constant!(q, op, ls, ua)
        else
          lower_zero!(q, op, ls, ua, zerotyp)
        end
      elseif isload(op)
        lower_load!(q, op, ls, ua, mask)
      elseif iscompute(op)
        lower_compute!(q, op, ls, ua, mask)
      end
    end
  end
end
function isu₂invalidstorereorder(ls::LoopSet, us::UnrollSpecification)
  us.u₂ == -1 ? false : ls.validreorder[ls.loopordermap[us.u₂loopnum]] ≠ 0x03
end
function lower_block(
  ls::LoopSet,
  us::UnrollSpecification,
  n::Int,
  mask::Bool,
  UF::Int
)
  @unpack u₁loopnum, u₂loopnum, vloopnum, u₁, u₂ = us
  ops = oporder(ls)
  order = names(ls)
  u₁loopsym = order[u₁loopnum]
  u₂loopsym = order[u₂loopnum]
  vectorized = order[vloopnum]
  unrollsyms = UnrollSymbols(u₁loopsym, u₂loopsym, vectorized)
  u₁ = n == u₁loopnum ? UF : u₁
  dontmaskfirsttiles = mask && vloopnum == u₂loopnum
  blockq = Expr(:block)
  cannot_reorder_u₂ = isu₂invalidstorereorder(ls, us)
  for prepost ∈ 1:2
    # !u₁ && !u₂
    lower!(
      blockq,
      ops[1, 1, prepost, n],
      ls,
      unrollsyms,
      u₁,
      u₂,
      -1,
      mask,
      true,
      true
    )
    # isu₁unrolled, isu₂unrolled, after_loop, n
    opsv1 = ops[1, 2, prepost, n]
    opsv2 = ops[2, 2, prepost, n]
    if length(opsv1) + length(opsv2) > 0
      nstores = 0
      iszero(length(opsv1)) || (nstores += sum(isstore, opsv1))
      iszero(length(opsv2)) || (nstores += sum(isstore, opsv2))
      # if nstores
      if (length(opsv1) + length(opsv2) == nstores) && u₂ > 1 # all_u₂_ops_store
        lower!(
          blockq,
          ops[2, 1, prepost, n],
          ls,
          unrollsyms,
          u₁,
          u₂,
          -1,
          mask,
          true,
          true
        ) # for u ∈ 0:u₁-1
        lower_tiled_store!(blockq, opsv1, opsv2, ls, unrollsyms, u₁, u₂, mask)
      else
        for store ∈ (false, true)
          if cannot_reorder_u₂
            nstores = 0# break
            lowernonstore = lowerstore = true
          else
            lowerstore = store
            lowernonstore = !store
          end
          for t ∈ 0:u₂-1
            # !u₁ &&  u₂
            lower!(
              blockq,
              opsv1,
              ls,
              unrollsyms,
              u₁,
              u₂,
              t,
              mask & !(dontmaskfirsttiles & (t < u₂ - 1)),
              lowernonstore,
              lowerstore
            )
            if iszero(t) && !store #  u₁ && !u₂
              # for u ∈ 0:u₁-1
              lower!(
                blockq,
                ops[2, 1, prepost, n],
                ls,
                unrollsyms,
                u₁,
                u₂,
                -1,
                mask,
                true,
                true
              )
              # end
            end
            #  u₁ && u₂
            # for u ∈ 0:u₁-1
            lower!(
              blockq,
              opsv2,
              ls,
              unrollsyms,
              u₁,
              u₂,
              t,
              mask & !(dontmaskfirsttiles & (t < u₂ - 1)),
              lowernonstore,
              lowerstore
            )
            # end
          end
          nstores == 0 && break
        end
      end
    elseif cannot_reorder_u₂
      lower!(
        blockq,
        ops[2, 1, prepost, n],
        ls,
        unrollsyms,
        u₁,
        u₂,
        -1,
        mask,
        true,
        true
      )
    else
      # for u ∈ 0:u₁-1     #  u₁ && !u₂
      lower!(
        blockq,
        ops[2, 1, prepost, n],
        ls,
        unrollsyms,
        u₁,
        u₂,
        -1,
        mask,
        true,
        false
      )
      lower!(
        blockq,
        ops[2, 1, prepost, n],
        ls,
        unrollsyms,
        u₁,
        u₂,
        -1,
        mask,
        false,
        true
      )
      # end
    end
    if n > 1 && prepost == 1
      push!(blockq.args, lower_unrolled_dynamic(ls, us, n - 1, mask))
    end
  end
  incrementloopcounter!(blockq, ls, us, n, UF)
  blockq
end

assume(ex) = Expr(:call, GlobalRef(VectorizationBase, :assume), ex)
function loopiteratesatleastonce!(ls, loop::Loop)
  start = first(loop)
  stop = last(loop)
  (isknown(start) & isknown(stop)) && return loop
  comp = Expr(:call, :≥)
  pushexpr!(comp, last(loop))
  pushexpr!(comp, first(loop))
  pushpreamble!(ls, assume(comp))
  return loop
end

function check_full_conv_kernel(ls, us, N)
  loop₁ = getloop(ls, us.u₁loopnum)
  (isstaticloop(loop₁) && length(loop₁) == us.u₁) && return true
  loop₂ = getloop(ls, us.u₂loopnum)
  (isstaticloop(loop₂) && length(loop₂) == us.u₂) && return true
  false
end
function allinteriorunrolled(ls::LoopSet, us::UnrollSpecification, N)
  if ls.loadelimination
    check_full_conv_kernel(ls, us, N) || return false
  end
  unroll_total = 1
  for n ∈ 1:N-1
    loop = getloop(ls, n)
    nisvectorized = isvectorized(us, n)
    W = nisvectorized ? ls.vector_width : 1
    ((length(loop) ≤ 8W) && (isstaticloop(loop) & (!iszero(W)))) || return false
    unroll_total *= cld(length(loop), W)
  end
  if us.u₁loopnum > N
    unroll_total *= us.u₁
  end
  if us.u₂loopnum > N
    unroll_total *= us.u₂
  end
  unroll_total ≤ 16
end

function lower_no_unroll(
  ls::LoopSet,
  us::UnrollSpecification,
  n::Int,
  inclmask::Bool
)
  nisvectorized = isvectorized(us, n)
  loop = getloop(ls, n)
  tc = terminatecondition(ls, us, n, inclmask, 1)
  body = lower_block(ls, us, n, inclmask, 1)
  loopisstatic = isstaticloop(loop)
  W = nisvectorized ? ls.vector_width : 1
  loopisstatic &= (!iszero(W))
  completely_unrolled = false
  length_loop = loopisstatic ? length(loop) : 0
  if loopisstatic &&
     (!ls.loadelimination) &&
     (
       isone(length_loop ÷ W) ||
       (n ≤ 3 && length_loop ≤ 8W && allinteriorunrolled(ls, us, n)) ||
       (length_loop ≤ W)
     )
    completely_unrolled = true
    q = Expr(:block)
    for _ ∈ 1:(length_loop÷W)
      push!(q.args, body)
    end
  elseif nisvectorized
    q = Expr(:block, Expr(:while, tc, body))
  else
    termcond = gensym(:maybeterm)
    push!(body.args, Expr(:(=), termcond, tc))
    q = Expr(:block, Expr(:(=), termcond, true), Expr(:while, termcond, body))
  end
  if nisvectorized && !(loopisstatic && iszero(length_loop & (W - 1)))
    body = lower_block(ls, us, n, true, 1)
    if isone(num_loops(ls))
      pushfirst!(body.args, definemask(loop))
    end
    if loopisstatic
      push!(q.args, body)
    else
      tc = terminatecondition(ls, us, n, true, 1)
      push!(q.args, Expr(:if, tc, body))
    end
  end
  Expr(:let, startloop(ls, us, n, completely_unrolled), q)
end
function lower_unrolled_dynamic(
  ls::LoopSet,
  us::UnrollSpecification,
  n::Int,
  inclmask::Bool
)
  UF = unrollfactor(us, n)
  isone(UF) && return lower_no_unroll(ls, us, n, inclmask)
  @unpack u₁loopnum, vloopnum, u₁, u₂ = us
  order = names(ls)
  loop = getloop(ls, n)
  vectorized = order[vloopnum]
  nisunrolled = isunrolled1(us, n)
  nisvectorized = isvectorized(us, n)
  W = nisvectorized ? ls.vector_width : 1
  UFW = UF * W
  looplength = length(loop)
  if W ≠ 0 & isknown(first(loop)) & isknown(step(loop))
    loopisstatic = isknown(last(loop))
    # something other than the default hint currently means an UpperBoundedInteger was passed as an argument
    loopisbounded =
      (looplength < UFW) & (loopisstatic | (gethint(last(loop)) ≠ 1024))
  else
    loopisstatic = false
    loopisbounded = false
  end
  Ureduct = ((n == num_loops(ls) && (u₂ == -1))) ? ureduct(ls) : -1
  # for now, require loopisstatic or !Ureduct-ing for reducing UF
  if loopisbounded & (loopisstatic | (Ureduct < 0))
    UFWnew = cld(looplength, cld(looplength, UFW))
    UF = cld(UFWnew, W)
    UFW = UF * W
    us =
      nisunrolled ? UnrollSpecification(us, UF, u₂) :
      UnrollSpecification(us, u₁, UF)
  end
  remmask = inclmask | nisvectorized
  sl = startloop(ls, us, n, false)
  UFt = loopisstatic ? cld(looplength % UFW, W) : 1
  # Don't place remainder first if we're going to have to mask this loop (i.e., if this loop is vectorized)
  remfirst =
    loopisstatic &
    (!nisvectorized) &
    (UFt > 0) &
    !(unsigned(Ureduct) < unsigned(UF))
  tc = terminatecondition(ls, us, n, inclmask, remfirst ? 1 : UF)
  # Don't need to create the body if loop is dynamic and bounded
  dynamicbounded = ((!loopisstatic) & loopisbounded)
  body = dynamicbounded ? tc : lower_block(ls, us, n, inclmask, UF)
  if loopisstatic
    iters = length(loop) ÷ UFW
    if (iters ≤ 1) || (iters * UF ≤ 16 && allinteriorunrolled(ls, us, n))# Let's set a limit on total unrolling
      q = Expr(:block)
      for _ ∈ 1:iters
        push!(q.args, body)
      end
    else
      q = Expr(:while, tc, body)
    end
    remblock = Expr(:block)
    (nisvectorized && (UFt > 0) && isone(num_loops(ls))) &&
      push!(remblock.args, definemask(loop))
  else
    remblock = init_remblock(loop, ls.lssm, n)#loopsym)
    # unroll_cleanup = Ureduct > 0 || (nisunrolled ? (u₂ > 1) : (u₁ > 1))
    q = if loopisbounded
      Expr(:block)
    elseif unsigned(Ureduct) < unsigned(UF)
      termcond = gensym(:maybeterm)
      push!(body.args, Expr(:(=), termcond, tc))
      Expr(:block, Expr(:(=), termcond, true), Expr(:while, termcond, body))
    else
      Expr(:while, tc, body)
    end
  end
  q = if unsigned(Ureduct) < unsigned(UF) # unsigned(-1) == typemax(UInt); 
    add_cleanup = Core.ifelse(loopisstatic, !nisvectorized, true)# true
    if isone(Ureduct)
      UF_cleanup = 1
      if nisvectorized
        blockhead = :while
      else
        blockhead = if UF == 2
          if loopisstatic
            # add_cleanup = UFt == 1
            :block
          else
            :if
          end
        else
          :while
        end
        UFt = 0
      end
    elseif 2Ureduct < UF
      UF_cleanup = 2
      blockhead = :while
    else
      UF_cleanup = UF - Ureduct
      blockhead = :if
    end
    _q = if dynamicbounded
      initialize_outer_reductions!(q, ls, Ureduct)
      q
    elseif loopisstatic
      blockhead = :block
      if length(loop) < UF * W
        Expr(:block)
      else
        if add_cleanup
          UFt -= Ureduct
        end
        Expr(
          :block,
          add_upper_outer_reductions(ls, q, Ureduct, UF, loop, nisvectorized)
        )
      end
    else
      Expr(
        :block,
        add_upper_outer_reductions(ls, q, Ureduct, UF, loop, nisvectorized)
      )
    end
    if add_cleanup
      cleanup_expr = Expr(blockhead)
      blockhead === :block || push!(
        cleanup_expr.args,
        terminatecondition(ls, us, n, inclmask, UF_cleanup)
      )
      us_cleanup =
        nisunrolled ? UnrollSpecification(us, UF_cleanup, u₂) :
        UnrollSpecification(us, u₁, UF_cleanup)
      push!(
        cleanup_expr.args,
        lower_block(ls, us_cleanup, n, inclmask, UF_cleanup)
      )
      push!(_q.args, cleanup_expr)
    end
    UFt > 0 && push!(_q.args, remblock)
    _q
  elseif remfirst
    numiters = length(loop) ÷ UF
    if numiters > 2
      Expr(:block, remblock, q)
    else
      q = Expr(:block, remblock)
      for i ∈ 1:numiters
        push!(q.args, body)
      end
      q
    end
  elseif iszero(UFt)
    Expr(:block, q)
  elseif !nisvectorized && !loopisstatic && UF ≥ 10
    rem_uf = UF - 1
    UF = rem_uf >> 1
    UFt = rem_uf - UF
    ust =
      nisunrolled ? UnrollSpecification(us, UFt, u₂) :
      UnrollSpecification(us, u₁, UFt)
    newblock = lower_block(ls, ust, n, remmask, UFt)
    # comparison = unrollremcomparison(ls, loop, UFt, n, nisvectorized, remfirst)
    comparison = terminatecondition(ls, us, n, inclmask, UFt)
    UFt = 1
    UF += 1 - iseven(rem_uf)
    Expr(
      :block,
      q,
      Expr(iseven(rem_uf) ? :while : :if, comparison, newblock),
      remblock
    )
  else
    Expr(:block, q, remblock)
  end
  if !iszero(UFt)
    # if unroll_cleanup
    iforelseif = :if
    while true
      ust =
        nisunrolled ? UnrollSpecification(us, UFt, u₂) :
        UnrollSpecification(us, u₁, UFt)
      newblock = lower_block(ls, ust, n, remmask, UFt)
      if (UFt ≥ UF - 1 + nisvectorized) || UFt == Ureduct || loopisstatic
        if isone(num_loops(ls)) && isone(UFt) && isone(Ureduct)
          newblock = Expr(:block, definemask(loop), newblock)
        end
        push!(remblock.args, newblock)
        break
      end
      comparison =
        unrollremcomparison(ls, loop, UFt, n, nisvectorized, remfirst)
      if isone(num_loops(ls)) && isone(UFt)
        remblocknew = Expr(:if, comparison, newblock)
        push!(
          remblock.args,
          Expr(:block, Expr(:let, definemask(loop), remblocknew))
        )
        remblock = remblocknew
      else
        remblocknew = Expr(iforelseif, comparison, newblock)
        # remblocknew = Expr(:elseif, comparison, newblock)
        push!(remblock.args, remblocknew)
        remblock = remblocknew
        iforelseif = :elseif
      end
      UFt += 1
    end
    # else
    #     ust = nisunrolled ? UnrollSpecification(us, 1, u₂) : UnrollSpecification(us, u₁, 1)
    #     # newblock = lower_block(ls, ust, n, remmask, 1)
    #     push!(remblock.args, lower_no_unroll(ls, ust, n, inclmask, false, UF-1))
    # end
  end
  if (length(ls.outer_reductions) > 0) && (2 ≤ n < length(ls.loops))
    pre, post = reinit_and_update_tiled_outer_reduct!(
      sl,
      q,
      ls,
      order[u₁loopnum],
      order[us.u₂loopnum],
      vectorized
    )
    Expr(:block, pre, Expr(:let, sl, q), post)
  else
    Expr(:block, Expr(:let, sl, q))
  end
end
function unrollremcomparison(
  ls::LoopSet,
  loop::Loop,
  UFt::Int,
  n::Int,
  nisvectorized::Bool,
  remfirst::Bool
)
  termind = ls.lssm.terminators[n]
  if iszero(termind)
    loopvarremcomparison(loop, UFt, nisvectorized, remfirst)
  else
    pointerremcomparison(ls, termind, UFt, n, nisvectorized, remfirst, loop)
  end
end
function loopvarremcomparison(
  loop::Loop,
  UFt::Int,
  nisvectorized::Bool,
  remfirst::Bool
)
  loopsym = loop.itersymbol
  loopstep = loop.step
  if nisvectorized
    offset = mulexpr(VECTORWIDTHSYMBOL, UFt, loopstep)
    itercount = subexpr(last(loop), offset)
    Expr(:call, GlobalRef(Base, :>), loopsym, itercount)
  elseif remfirst # requires `isstaticloop(loop)`
    Expr(
      :call,
      GlobalRef(Base, :<),
      loopsym,
      gethint(first(loop)) + UFt * gethint(loopstep) - 1
    )
  elseif isknown(last(loop))
    if isknown(loopstep)
      Expr(
        :call,
        GlobalRef(Base, :>),
        loopsym,
        gethint(last(loop)) - UFt * gethint(loopstep)
      )
    elseif isone(UFt)
      Expr(
        :call,
        GlobalRef(Base, :>),
        loopsym,
        subexpr(gethint(last(loop)), getsym(loopstep))
      )
    else
      Expr(
        :call,
        GlobalRef(Base, :>),
        loopsym,
        subexpr(gethint(last(loop)), mulexpr(getsym(loopstep), UFt))
      )
    end
  else
    if isknown(loopstep)
      Expr(
        :call,
        GlobalRef(Base, :>),
        loopsym,
        Expr(:call, lv(:vsub_nsw), getsym(last(loop)), UFt * gethint(loopstep))
      )
    elseif isone(UFt)
      Expr(
        :call,
        GlobalRef(Base, :>),
        loopsym,
        Expr(:call, lv(:vsub_nsw), getsym(last(loop)), getsym(loopstep))
      )
    else
      Expr(
        :call,
        GlobalRef(Base, :>),
        loopsym,
        Expr(
          :call,
          lv(:vsub_nsw),
          getsym(last(loop)),
          mulexpr(getsym(loopstep), UFt)
        )
      )
    end
  end
end
function pointerremcomparison(
  ls::LoopSet,
  termind::Int,
  UFt::Int,
  n::Int,
  nisvectorized::Bool,
  remfirst::Bool,
  loop::Loop
)
  lssm = ls.lssm
  termar = lssm.incrementedptrs[n][termind]
  ptrdef = lssm.incrementedptrs[n][termind]
  ptr = vptr(termar)
  ptroff = vptr_offset(ptr)
  if remfirst
    cmp = GlobalRef(VectorizationBase, :vlt)
    Expr(
      :call,
      cmp,
      ptroff,
      pointermax(ls, ptrdef, n, 1 - UFt, nisvectorized, loop),
      ptr
    )
  else
    cmp = GlobalRef(VectorizationBase, :vge)
    Expr(:call, cmp, ptroff, maxsym(ptr, UFt), ptr)
  end
end

@generated function of_same_size(
  ::Type{T},
  ::Type{S},
  ::StaticInt{R}
) where {T,S,R}
  sizeof_S = sizeof(S)
  sizeof_T = sizeof(T)
  if T <: Integer
    # max(..., 4) to maybe demote Int64 -> Int32
    # but otherwise, we're giving up too much with the demotion.
    if T === Bool || sizeof_S < 8
      # HACK: T === Bool, makes code work.
      sizeof_S *= 8
    else
      sizeof_S *= max(8 ÷ R, 4)
    end
    # multiply by 8 for sake of following `==` comparison
    sizeof_T *= 8
  end
  sizeof_T == sizeof_S && return T
  # Tfloat = T <: Union{Float32,Float64}
  if T <: Union{Float32,Float64}
    sizeof_S ≥ 8 ? Float64 : Float32
  elseif T <: Signed
    Symbol(:Int, sizeof_S)
  elseif (T <: Unsigned) | (T === Bool)
    Symbol(:UInt, sizeof_S)
  else
    S
  end
end
@inline function of_same_size(::Type{T}, ::Type{S}) where {T,S}
  of_same_size(
    T,
    S,
    VectorizationBase.register_size() ÷
    VectorizationBase.simd_integer_register_size()
  )
end
function outer_reduction_zero(
  op::Operation,
  u₁u::Bool,
  Umax::Int,
  reduct_class::Float64,
  rs::Union{Expr,StaticInt}
)
  isifelse = instruction(op).instr === :ifelse
  reduct_zero = if isifelse
    Symbol(name(op), "##BASE##EXTRACT##")
    # Expr(:call, lv(:vbroadcast), VECTORWIDTHSYMBOL,
  else
    reduction_zero(reduct_class)
  end
  # Tsym = outer_reduct_init_typename(op)
  # Tsym = ELTYPESYMBOL
  Tsym =
    Expr(:call, lv(:of_same_size), outer_reduct_init_typename(op), ELTYPESYMBOL)
  if isvectorized(op)
    if Umax == 1 || !u₁u
      if reduct_zero === :zero
        Expr(:call, lv(:_vzero), VECTORWIDTHSYMBOL, Tsym, rs)
      elseif isifelse
        Expr(:call, lv(:_vbroadcast), VECTORWIDTHSYMBOL, reduct_zero, rs)
      else
        Expr(
          :call,
          lv(:_vbroadcast),
          VECTORWIDTHSYMBOL,
          Expr(:call, lv(reduct_zero), Tsym),
          rs
        )
      end
    else
      if reduct_zero === :zero
        Expr(
          :call,
          lv(:zero_vecunroll),
          staticexpr(Umax),
          VECTORWIDTHSYMBOL,
          Tsym,
          rs
        )
      elseif isifelse
        Expr(
          :call,
          lv(:vbroadcast_vecunroll),
          staticexpr(Umax),
          VECTORWIDTHSYMBOL,
          reduct_zero,
          rs
        )
      else
        Expr(
          :call,
          lv(:vbroadcast_vecunroll),
          staticexpr(Umax),
          VECTORWIDTHSYMBOL,
          Expr(:call, reduct_zero, Tsym),
          rs
        )
      end
    end
  elseif isifelse
    Expr(:call, identity, reduct_zero) # type stability within LV
  else
    Expr(:call, reduct_zero, Tsym)
  end
end

# TODO: handle tiled outer reductions; they will require a suffix arg
function initialize_outer_reductions!(
  q::Expr,
  ls::LoopSet,
  op::Operation,
  _Umax::Int,
  us::UnrollSpecification,
  rs::Union{Expr,StaticInt}
)
  @unpack u₁, u₂ = us
  Umax = u₂ == -1 ? _Umax : u₁

  u₁u, u₂u = isunrolled_sym(
    op,
    getloop(ls, us.u₁loopnum).itersymbol,
    getloop(ls, us.u₂loopnum).itersymbol,
    getloop(ls, us.vloopnum).itersymbol,
    ls
  )#, u₂)
  z = outer_reduction_zero(
    op,
    u₁u,
    Umax,
    reduction_instruction_class(instruction(op)),
    rs
  )
  mvar = variable_name(op, -1)
  if (u₂ == -1)
    push!(q.args, Expr(:(=), Symbol(mvar, '_', _Umax), z))
  elseif u₁u
    push!(q.args, Expr(:(=), Symbol(mvar, '_', u₁), z))
  elseif isu₂unrolled(op) # we unroll u₂
    for u ∈ 0:_Umax-1
      push!(q.args, Expr(:(=), Symbol(mvar, u), z))
    end
  else
    push!(q.args, Expr(:(=), Symbol(mvar, '_', 1), z))
  end
  nothing
end
function initialize_outer_reductions!(
  q::Expr,
  ls::LoopSet,
  Umax::Union{Int,StaticInt}
)
  rs = staticexpr(reg_size(ls))
  us = ls.unrollspecification
  for or ∈ ls.outer_reductions
    initialize_outer_reductions!(q, ls, ls.operations[or], Umax, us, rs)
  end
end
initialize_outer_reductions!(ls::LoopSet, Umax::Int) =
  initialize_outer_reductions!(ls.preamble, ls, Umax)
function add_upper_comp_check(unrolledloop, loopbuffer)
  if isstaticloop(unrolledloop)
    Expr(:call, Base.GlobalRef(Base, :≥), length(unrolledloop), loopbuffer)
  elseif isknown(first(unrolledloop))
    if isone(first(unrolledloop))
      Expr(
        :call,
        Base.GlobalRef(Base, :≥),
        getsym(last(unrolledloop)),
        loopbuffer
      )
    else
      Expr(
        :call,
        Base.GlobalRef(Base, :≥),
        getsym(last(unrolledloop)),
        addexpr(loopbuffer, gethint(first(unrolledloop)) - 1)
      )
    end
  elseif isknown(last(unrolledloop))
    Expr(
      :call,
      Base.GlobalRef(Base, :≥),
      Expr(
        :call,
        lv(:vsub_nsw),
        gethint(last(unrolledloop)) + 1,
        getsym(first(unrolledloop))
      ),
      loopbuffer
    )
  else# both are given by symbols
    Expr(
      :call,
      Base.GlobalRef(Base, :>),
      Expr(
        :call,
        lv(:vsub_nsw),
        getsym(last(unrolledloop)),
        Expr(:call, lv(:vsub_nsw), getsym(first(unrolledloop)), staticexpr(1))
      ),
      loopbuffer
    )
  end
end
function add_upper_outer_reductions(
  ls::LoopSet,
  loopq::Expr,
  Ulow::Int,
  Uhigh::Int,
  unrolledloop::Loop,
  reductisvectorized::Bool
)
  ifq = Expr(:block)
  ifqlet = Expr(:block)
  initialize_outer_reductions!(ifqlet, ls, Uhigh)
  push!(ifq.args, loopq)
  t = Expr(:tuple)
  mvartu = Expr(:tuple)
  mvartl = Expr(:tuple)
  for or ∈ ls.outer_reductions
    op = ls.operations[or]
    # var = name(op)
    mvar = Symbol(mangledvar(op), '_', Uhigh)
    if instruction(op).instr ≢ :ifelse
      f = reduce_number_of_vectors(op)
      push!(t.args, Expr(:call, f, mvar, staticexpr(Ulow)))
    else
      fifelse = let Uhigh = Uhigh
        ifelse_reduction(:IfElseCollapser, op) do opv
          Symbol(mangledvar(opv), '_', Uhigh), tuple()
        end
      end
      push!(t.args, Expr(:call, fifelse, mvar, staticexpr(Ulow)))
    end
    push!(mvartu.args, mvar)
    push!(mvartl.args, Symbol(mangledvar(op), '_', Ulow))
  end
  push!(ifq.args, t)
  ifqfull = Expr(:let, ifqlet, ifq)
  if isstaticloop(unrolledloop)
    W = Core.ifelse(reductisvectorized, ls.vector_width, 1)
    if Uhigh * W * gethint(step(unrolledloop)) ≤ length(unrolledloop)
      return Expr(:(=), mvartl, ifqfull)
    end
  end
  ncomparison = if reductisvectorized
    add_upper_comp_check(
      unrolledloop,
      mulexpr(VECTORWIDTHSYMBOL, Uhigh, step(unrolledloop))
    )
  elseif isknown(step(unrolledloop))
    add_upper_comp_check(unrolledloop, Uhigh * gethint(step(unrolledloop)))
  else
    add_upper_comp_check(unrolledloop, mulexpr(Uhigh, getsym(step(unrolledloop))))
  end
  elseq = Expr(:block)
  initialize_outer_reductions!(elseq, ls, Ulow)
  push!(elseq.args, mvartl)
  Expr(:(=), mvartl, Expr(:if, ncomparison, ifqfull, elseq))
end
## This performs reduction to one `Vec`
function reduce_expr!(q::Expr, ls::LoopSet, U::Int)
  us = ls.unrollspecification
  if us.u₂ == -1
    u₁f = ifelse(U == -1, us.u₁, U)
    u₂f = -1
  else
    u₁f = us.u₁
    u₂f = U
  end
  # u₁loop, u₂loop = getunrolled(ls)
  u₁loop = getloop(ls, us.u₁loopnum).itersymbol
  u₂loop = getloop(ls, us.u₂loopnum).itersymbol
  vloop = getloop(ls, us.vloopnum).itersymbol
  for or ∈ ls.outer_reductions
    op = ls.operations[or]
    var = name(op)
    mvar = mangledvar(op)
    u₁u, u₂u = isunrolled_sym(op, u₁loop, u₂loop, vloop, ls)#, u₂f)
    reduce_expr!(q, mvar, op, u₁f, u₂f, u₁u, u₂u)
    if length(ls.opdict) ≠ 0
      if (isu₁unrolled(op) | isu₂unrolled(op))
        if instruction(op).instr ≢ :ifelse
          push!(
            q.args,
            Expr(
              :(=),
              var,
              Expr(
                :call,
                reduction_scalar_combine(op),
                Symbol(mvar, "##onevec##"),
                var
              )
            )
          )
        else
          reductexpr = ifelse_reduction(:IfElseReduced, op) do opv
            Symbol(mangledvar(opv), "##onevec##"), (name(opv),)
          end
          push!(
            q.args,
            Expr(
              :(=),
              var,
              Expr(:call, reductexpr, Symbol(mvar, "##onevec##"), var)
            )
          )
        end
      else
        push!(q.args, Expr(:(=), var, mvar))
      end
    end
  end
end
function reinit_push_preblockpost!(
  letblock::Expr,
  pre::Expr,
  block::Expr,
  post::Expr,
  z::Expr,
  s::Symbol,
  reduct::Symbol
)
  push!(letblock.args, Expr(:(=), s, z))
  tempsym = gensym(s) # placeholder
  push!(pre.args, Expr(:(=), tempsym, s))
  push!(block.args, Expr(:(=), tempsym, Expr(:call, lv(reduct), tempsym, s)))
  push!(post.args, Expr(:(=), s, tempsym))
  nothing
end
function reinit_and_update_tiled_outer_reduct!(
  letblock::Expr,
  block::Expr,
  ls::LoopSet,
  u₁loopsym::Symbol,
  u₂loopsym::Symbol,
  vloopsym::Symbol
)
  rs = staticexpr(reg_size(ls))
  usorig = ls.unrollspecification
  Umax = ureduct(ls)
  pre = Expr(:block)
  post = Expr(:block)
  for or ∈ ls.outer_reductions
    op = ls.operations[or]
    instr = instruction(op).instr
    instr === :ifelse && continue # FIXME - skipping this will result in bad performance
    u₁u, u₂u = isunrolled_sym(op, u₁loopsym, u₂loopsym, vloopsym, ls)
    reduct_class::Float64 = reduction_instruction_class(instr)
    z = outer_reduction_zero(op, u₁u, Umax, reduct_class, rs)
    reduct = reduce_to_onevecunroll(reduct_class)
    mvar = variable_name(op, -1)
    if u₁u # it's u₁unrolled
      reinit_push_preblockpost!(
        letblock,
        pre,
        block,
        post,
        z,
        Symbol(mvar, '_', usorig.u₁),
        reduct
      )
    else # it's u₂unrolled
      for u ∈ 0:Umax-1
        reinit_push_preblockpost!(
          letblock,
          pre,
          block,
          post,
          z,
          Symbol(mvar, u),
          reduct
        )
      end
    end
    initialize_outer_reductions!(
      letblock,
      ls,
      ls.operations[or],
      ureduct(ls),
      usorig,
      rs
    )
  end
  pre, post
end

function gc_preserve(ls::LoopSet, q::Expr)
  length(ls.opdict) == 0 && return q
  q2 = Expr(:block)
  gcp = Expr(:gc_preserve, q)
  for array ∈ ls.includedactualarrays
    pb = gensym(array)
    push!(q2.args, Expr(:(=), pb, Expr(:call, lv(:preserve_buffer), array)))
    push!(gcp.args, pb)
  end
  q.head === :block && push!(q.args, nothing)
  push!(q2.args, gcp)
  q2
end
function push_outer_reduct_types!(pt::Expr, ls::LoopSet, ortypdefined::Bool)
  for j ∈ ls.outer_reductions
    oreducop = ls.operations[j]
    if ortypdefined
      push!(pt.args, eltype_expr(oreducop))
    else
      push!(pt.args, outer_reduct_init_typename(oreducop))
    end
  end
end
function determine_eltype(ls::LoopSet, ortypdefined::Bool)::Union{Symbol,Expr}
  narrays = length(ls.includedactualarrays)
  noreduc = length(ls.outer_reductions)
  ntyp = narrays + noreduc
  if ntyp == 0
    return Expr(:call, lv(:typeof), 0)
  elseif ntyp == 1
    if narrays == 1
      return Expr(:call, lv(:eltype), first(ls.includedactualarrays))
    else
      oreducop = ls.operations[ls.outer_reductions[1]]
      if ortypdefined
        return eltype_expr(oreducop)
      else
        return outer_reduct_init_typename(oreducop)
      end
    end
  end
  pt = Expr(:call, lv(:promote_type))
  for array ∈ ls.includedactualarrays
    push!(pt.args, Expr(:call, lv(:eltype), array))
  end
  push_outer_reduct_types!(pt, ls, ortypdefined)
  return pt
end
@inline _eltype(x) = eltype(x)
@inline _eltype(::BitArray) = VectorizationBase.Bit
function determine_width(ls::LoopSet, vectorized::Union{Symbol,Nothing})
  vwidth_q = Expr(:call, lv(:pick_vector_width))
  if vectorized ≢ nothing
    vloop = getloop(ls, vectorized)
    if isstaticloop(vloop)
      push!(vwidth_q.args, Expr(:call, Expr(:curly, :Val, length(vloop))))
    end
  end
  push!(vwidth_q.args, ELTYPESYMBOL)
  vwidth_q
end
function init_remblock(unrolledloop::Loop, lssm::LoopStartStopManager, n::Int)#u₁loop::Symbol = unrolledloop.itersymbol)
  termind = lssm.terminators[n]
  if iszero(termind)
    rangesym = unrolledloop.rangesym
    if rangesym === Symbol("")
      condition = Expr(
        :call,
        lv(:cmpend),
        unrolledloop.itersymbol,
        staticloopexpr(unrolledloop)
      )
    else
      condition = Expr(:call, lv(:cmpend), unrolledloop.itersymbol, rangesym)
    end
  else
    termar = lssm.incrementedptrs[n][termind]
    ptr = vptr(termar)
    ptroff = vptr_offset(ptr)
    condition = Expr(
      :call,
      GlobalRef(VectorizationBase, :vlt),
      ptroff,
      maxsym(ptr, 0),
      ptr
    )
  end
  Expr(:if, condition)
end

maskexpr(looplimit) =
  Expr(:(=), MASKSYMBOL, Expr(:call, lv(:mask), VECTORWIDTHSYMBOL, looplimit))
@inline idiv_fast(a::I, b::I) where {I<:Base.BitInteger} = Base.udiv_int(a, b)
@inline idiv_fast(a, b) = idiv_fast(Int(a), Int(b))
function definemask(loop::Loop)
  isstaticloop(loop) && return maskexpr(length(loop))
  # W = 4
  # loop iterates 3, step 2
  # (1, 3, 5), 7
  start = first(loop)
  incr = step(loop)
  stop = last(loop)
  if isone(start) & isone(incr)
    isknown(stop) ? maskexpr(gethint(stop)) : maskexpr(getsym(stop))
  elseif loop.lensym !== Symbol("")
    maskexpr(loop.lensym)
  elseif isone(incr)
    if isknown(start) & isknown(stop)
      maskexpr(1 + gethint(stop) - gethint(start))
    else
      lexpr = if isknown(start)
        subexpr(stop, gethint(start) - 1)
      elseif isknown(stop)
        subexpr(gethint(stop) + 1, start)
      else
        subexpr(stop, subexpr(start, 1))
      end
      maskexpr(lexpr)
    end
  else
    lenexpr = Expr(:call, lv(:idiv_fast), subexpr(stop, start))
    pushexpr!(lenexpr, incr)
    maskexpr(addexpr(lenexpr, 1))
  end
end
function define_eltype_vec_width!(
  q::Expr,
  ls::LoopSet,
  vectorized,
  ortypdefined::Bool
)
  push!(q.args, Expr(:(=), ELTYPESYMBOL, determine_eltype(ls, ortypdefined)))
  push!(q.args, Expr(:(=), VECTORWIDTHSYMBOL, determine_width(ls, vectorized)))
  nothing
end
function setup_preamble!(ls::LoopSet, us::UnrollSpecification, Ureduct::Int)
  @unpack u₁loopnum, u₂loopnum, vloopnum, u₁, u₂ = us
  order = names(ls)
  vectorized = order[vloopnum]
  set_vector_width!(ls, vectorized)
  iszero(length(ls.includedactualarrays) + length(ls.outer_reductions)) ||
    define_eltype_vec_width!(ls.preamble, ls, vectorized, false)
  lower_licm_constants!(ls)
  isone(num_loops(ls)) || pushpreamble!(ls, definemask(getloop(ls, vectorized)))#, u₁ > 1 && u₁loopnum == vloopnum))
  if (Ureduct == u₁) || (u₂ != -1) || (Ureduct == -1)
    initialize_outer_reductions!(ls, ifelse(Ureduct == -1, u₁, Ureduct)) # TODO: outer reducts?
  elseif length(ls.outer_reductions) > 0
    decl = Expr(:local)
    for or ∈ ls.outer_reductions
      push!(decl.args, Symbol(mangledvar(ls.operations[or]), '_', Ureduct))
    end
    pushpreamble!(ls, decl)
  end
  for op ∈ operations(ls)
    if (iszero(length(loopdependencies(op))) && iscompute(op))
      ua = UnrollArgs(
        getloop(ls, us.u₁loopnum),
        getloop(ls, us.u₂loopnum),
        getloop(ls, us.vloopnum),
        u₁,
        u₂,
        -1
      )
      lower_compute!(ls.preamble, op, ls, ua, false)
    end
  end
end
lsexpr(ls::LoopSet, q) = Expr(:block, ls.preamble, q)

function isanouterreduction(ls::LoopSet, op::Operation)
  opname = name(op)
  for or ∈ ls.outer_reductions
    name(ls.operations[or]) === opname && return true
  end
  false
end

# tiled_outerreduct_unroll(ls::LoopSet) = tiled_outerreduct_unroll(ls.unrollspecification)
# function tiled_outerreduct_unroll(us::UnrollSpecification)
#     @unpack u₁, u₂ = us
#     unroll = u₁ ≥ 8 ? 1 : 8 ÷ u₁
#     cld(u₂, cld(u₂, unroll))
# end
function calc_Ureduct!(ls::LoopSet, us::UnrollSpecification)
  @unpack u₁loopnum, u₁, u₂, vloopnum = us
  ur = if iszero(length(ls.outer_reductions))
    -1
  elseif u₂ == -1
    if u₁loopnum == num_loops(ls)
      u₁loop = getloop(ls, u₁loopnum)
      loopisstatic = isstaticloop(u₁loop)
      loopisstatic &= ((vloopnum != u₁loopnum) | (!iszero(ls.vector_width)))
      # loopisstatic ? u₁ : min(u₁, 4) # much worse than the other two options, don't use this one
      if loopisstatic
        W = Core.ifelse(vloopnum == u₁loopnum, ls.vector_width, 1)
        UFt = cld(length(u₁loop) % (W * u₁), W)
        Core.ifelse(UFt == 0, u₁, UFt)
        # rem = length(u₁loop) - 
        # max(1, cld(rem, u₁))
      else
        Core.ifelse(get_cpu_name() === "znver1", 1, Core.ifelse(u₁ ≥ 4, 2, 1))
      end
    else
      -1
    end
  else
    u₁ui = u₂ui = -1
    u₁loopsym = getloop(ls, u₁loopnum).itersymbol
    u₂loopsym = getloop(ls, us.u₂loopnum).itersymbol
    vloopsym = getloop(ls, vloopnum).itersymbol
    for or ∈ ls.outer_reductions
      op = ls.operations[or]
      u₁u, u₂u = isunrolled_sym(op, u₁loopsym, u₂loopsym, vloopsym, us)
      if u₁ui == -1
        u₁ui = Int(u₁u)
        u₂ui = Int(u₁u)
      elseif !((u₁ui == Int(u₁u)) & (u₂ui == Int(u₁u)))
        throw(
          ArgumentError(
            "Doesn't currently handle differently unrolled reductions yet, please file an issue with an example."
          )
        )
      end
    end
    if u₁ui % Bool
      u₁
    else
      u₂
    end
  end
  ls.ureduct = ur
end
ureduct(ls::LoopSet) = ls.ureduct
function lower_unrollspec(ls::LoopSet)
  us = ls.unrollspecification
  @unpack vloopnum, u₁, u₂ = us
  init_loop_map!(ls)
  Ureduct = calc_Ureduct!(ls, us)
  setup_preamble!(ls, us, Ureduct)
  initgesps = add_loop_start_stop_manager!(ls)
  q =
    Expr(:let, initgesps, lower_unrolled_dynamic(ls, us, num_loops(ls), false))
  q = gc_preserve(ls, Expr(:block, q))
  reduce_expr!(q, ls, Ureduct)
  lsexpr(ls, q)
end

function lower(
  ls::LoopSet,
  order,
  u₁loop,
  u₂loop,
  vectorized,
  u₁,
  u₂,
  inline::Bool
)
  cacheunrolled!(ls, u₁loop, u₂loop, vectorized)
  fillorder!(ls, order, u₁loop, u₂loop, u₂, vectorized)
  ls.unrollspecification =
    UnrollSpecification(ls, u₁loop, u₂loop, vectorized, u₁, u₂)
  q = lower_unrollspec(ls)
  inline && pushfirst!(q.args, Expr(:meta, :inline))
  q
end

function lower(ls::LoopSet, inline::Int = -1)
  fill_offset_memop_collection!(ls)
  order, u₁loop, u₂loop, vectorized, u₁, u₂, c, shouldinline =
    choose_order_cost(ls)
  lower(
    ls,
    order,
    u₁loop,
    u₂loop,
    vectorized,
    u₁,
    u₂,
    inlinedecision(inline, shouldinline)
  )
end
function lower(ls::LoopSet, u₁::Int, u₂::Int, v::Int, inline::Int)
  fill_offset_memop_collection!(ls)
  if u₂ > 1
    @assert num_loops(ls) > 1 "There is only $(num_loops(ls)) loop, but specified blocking parameter u₂ is $u₂."
    order, u₁loop, u₂loop, vectorized, _u₁, _u₂, c, shouldinline =
      choose_tile(ls, store_load_deps(operations(ls)), v)
    copyto!(ls.loop_order.bestorder, order)
  elseif u₁ > 0
    u₂ = -1
    order, vectorized, c =
      choose_unroll_order(ls, Inf, store_load_deps(operations(ls)), v)
    u₁loop = first(order)
    u₂loop = Symbol("##undefined##")
    shouldinline = true
    copyto!(ls.loop_order.bestorder, order)
  else
    order, u₁loop, u₂loop, vectorized, u₁, u₂, c, shouldinline =
      choose_order_cost(ls, v)
  end
  doinline = inlinedecision(inline, shouldinline)
  lower(ls, order, u₁loop, u₂loop, vectorized, u₁, u₂, doinline)
end

# Base.convert(::Type{Expr}, ls::LoopSet) = lower(ls)
Base.show(io::IO, ls::LoopSet) = println(io, lower(ls))

function search_children_for_self(op::Operation, target::Symbol = name(op))
  for opc ∈ children(op)
    name(opc) === target && return opc
  end
  for opc ∈ children(op)#breadth first
    opcc = search_children_for_self(opc, target)
    opcc === opc || return opcc
  end
  op
end

# TODO: this is no longer how I generate code...
"""
This function is normally called
isunrolled_sym(op, u₁loop)
isunrolled_sym(op, u₁loop, u₂loop)

It returns `true`/`false` for each loop, indicating whether they're unrolled.

If there is a third argument, it will avoid unrolling that symbol along reductions if said symbol is part of the reduction chain.
"""
function isunrolled_sym(
  op::Operation,
  u₁loop::Symbol,
  u₂loop::Symbol,
  vloop::Symbol,
  (u₁ild, u₂ild)::Tuple{Bool,Bool} = (isu₁unrolled(op), isu₂unrolled(op))
)
  (accesses_memory(op) | isloopvalue(op)) && return (u₁ild, u₂ild)
  if isconstant(op)
    if length(loopdependencies(op)) == 0
      newop = search_children_for_self(op)
      newop === op || return isunrolled_sym(newop, u₁loop, u₂loop, vloop)
    end
    if !u₁ild
      u₁ild = u₁loop ∈ reducedchildren(op)
    end
    if !u₂ild
      u₂ild = u₂loop ∈ reducedchildren(op)
    end
  end
  (u₁ild & u₂ild) || return u₁ild, u₂ild
  reductops = isconstant(op) ? reducedchildren(op) : reduceddependencies(op)
  iszero(length(reductops)) && return true, true
  u₁reduced = u₁loop ∈ reductops
  u₂reduced = u₂loop ∈ reductops
  # If they're being reduced, we want to only unroll the reduced variable along one of the two loops.
  if u₂reduced
    if u₁reduced# if both are reduced, we unroll u₁
      if vloop === u₁loop
        false, true
      else
        true, false
      end
    else
      true, false
    end
  elseif u₁reduced
    false, true
  else
    true, true
  end
end
function isunrolled_sym(
  op::Operation,
  u₁loop::Symbol,
  u₂loop::Symbol,
  vloop::Symbol,
  ls::LoopSet
)
  us = ls.unrollspecification
  isunrolled_sym(op, u₁loop, u₂loop, vloop, us)
end
function isunrolled_sym(
  op::Operation,
  u₁loop::Symbol,
  u₂loop::Symbol,
  vloop::Symbol,
  us::UnrollSpecification
)
  @unpack u₁, u₂ = us
  u₁u = (u₁ > 1) & isu₁unrolled(op)
  u₂u = (u₂ > 1) & isu₂unrolled(op)
  ((u₂ > 1) | accesses_memory(op)) ?
  isunrolled_sym(op, u₁loop, u₂loop, vloop, (u₁u, u₂u)) :
  (isunrolled_sym(op, u₁loop, u₁u), false)
end

isunrolled_sym(op::Operation, u₁loop::Symbol, ls::LoopSet) =
  isunrolled_sym(op, u₁loop, ls.unrollspecification)
function isunrolled_sym(op::Operation, u₁loop::Symbol, us::UnrollSpecification)
  u₁u = (us.u₁ > 1) & isu₁unrolled(op)
  isunrolled_sym(op, u₁loop, u₁u)
end
function isunrolled_sym(
  op::Operation,
  u₁loop::Symbol,
  u₁u::Bool = isu₁unrolled(op)
)
  u₁u || (isconstant(op) & (u₁loop ∈ reducedchildren(op)))
end

function isunrolled_sym(
  op::Operation,
  u₁loop::Symbol,
  u₂loop::Symbol,
  vloop::Symbol,
  u₂max::Int
)
  ((u₂max > 1) | accesses_memory(op)) ?
  isunrolled_sym(op, u₁loop, u₂loop, vloop) :
  (isunrolled_sym(op, u₁loop), false)
end

function variable_name(op::Operation, suffix::Int)
  mvar = mangledvar(op)
  suffix == -1 ? mvar : Symbol(mvar, suffix, :_)
end

function variable_name_and_unrolled(
  op::Operation,
  u₁loop::Symbol,
  u₂loop::Symbol,
  vloop::Symbol,
  u₂iter::Int,
  ls::LoopSet
)
  u₁op, u₂op = isunrolled_sym(op, u₁loop, u₂loop, vloop, ls)
  mvar = u₂op ? variable_name(op, u₂iter) : mangledvar(op)
  mvar, u₁op, u₂op
end

include("testsetup.jl")

import InteractiveUtils

InteractiveUtils.versioninfo(stdout; verbose = true)

const LOOPVECTORIZATION_TEST = get(ENV, "LOOPVECTORIZATION_TEST", "all")

if LOOPVECTORIZATION_TEST == "all"
  NUMGROUPS = 5
  processes = Vector{Base.Process}(undef, NUMGROUPS)
  paths = Vector{String}(undef, NUMGROUPS)
  ios = Vector{IOStream}(undef, NUMGROUPS)
  tmp = tempdir()
  for i ∈ 1:NUMGROUPS
    path, io = mktemp(tmp)
    paths[i] = path
    ios[i] = io
    env = copy(ENV)
    env["LOOPVECTORIZATION_TEST"] = "part$i"
    env["JULIA_NUM_THREADS"] = string(Threads.nthreads())
    processes[i] = run(
      pipeline(
        setenv(`$(Base.julia_cmd()) --project=$(Base.active_project()) $(@__FILE__)`, env),
        stderr = io,
        stdout = io,
      ),
      wait = false,
    )
  end
  completed = fill(false, NUMGROUPS)
  while true
    for i ∈ eachindex(completed)
      completed[i] && continue
      proc = processes[i]
      process_running(proc) && continue
      completed[i] = true
      close(ios[i])
      println("Test Group: $i")
      run(`cat $(paths[i])`)
      println("\n\n")
    end
    all(completed) && break
    sleep(5)
  end
  @testset verbose = true "All" begin
    for (i, proc) ∈ enumerate(processes)
      @testset "part$i" begin
        @test success(proc)
      end
    end
  end
else
  include("grouptests.jl")
end

function extract_all_lnns(x)
  lnns = Vector{LineNumberNode}(undef, 0)
  return extract_all_lnns!(lnns, x)
end

function extract_all_lnns!(
  lnns::AbstractVector{<:LineNumberNode},
  lnn::LineNumberNode
)
  push!(lnns, lnn)
  return lnns
end
function extract_all_lnns!(lnns::AbstractVector{<:LineNumberNode}, ex::Expr)
  for arg in ex.args
    extract_all_lnns!(lnns::AbstractVector{<:LineNumberNode}, arg)
  end
  return lnns
end
extract_all_lnns!(lnns::AbstractVector{<:LineNumberNode}, ::Any) = lnns

function prepend_lnns!(ex::Expr, lnns::AbstractVector{<:LineNumberNode})
  return prepend_lnns!(ex, lnns, Val(ex.head))
end
function prepend_lnns!(
  ex::Expr,
  lnns::AbstractVector{<:LineNumberNode},
  ::Val{:block}
)
  for lnn in lnns
    pushfirst!(ex.args, Expr(:block, lnn, :(nothing)))
  end
  return ex
end

# This is a convenience function for libraries like MaBLAS and PaddedMatrices to use explicitly, and for others to force more type inference in precompilation.

const GEMMLOOPSET = loopset(:(
  for n ∈ 1:N, m ∈ 1:M
    Cₘₙ = zero(eltype(C))
    for k ∈ 1:K
      Cₘₙ += A[m, k] * B[k, n]
    end
    C[m, n] += Cₘₙ
  end
));

# function matmul_params(rs::Int, rc::Int, cls::Int)
#     set_hw!(GEMMLOOPSET, rs, rc, cls, Int(cache_size(StaticInt(1))), Int(cache_size(StaticInt(2))), Int(cache_size(StaticInt(3))))
#     order = choose_order(GEMMLOOPSET)
#     order[5], last(order)
# end
function matmul_params(
  rs::Int,
  rc::Int,
  cls::Int;
  M = nothing,
  K = nothing,
  N = nothing,
  W = 0
)
  set_hw!(GEMMLOOPSET, rs, rc, cls)
  if N ≢ nothing
    nloop = GEMMLOOPSET.loops[1]
    GEMMLOOPSET.loops[1] = Loop(
      :n,
      MaybeKnown(1),
      MaybeKnown(N),
      MaybeKnown(1),
      nloop.rangesym,
      nloop.lensym
    )
  end
  if M ≢ nothing
    mloop = GEMMLOOPSET.loops[2]
    GEMMLOOPSET.loops[2] = Loop(
      :m,
      MaybeKnown(1),
      MaybeKnown(M),
      MaybeKnown(1),
      mloop.rangesym,
      mloop.lensym
    )
  end
  if K ≢ nothing
    kloop = GEMMLOOPSET.loops[3]
    GEMMLOOPSET.loops[3] = Loop(
      :k,
      MaybeKnown(1),
      MaybeKnown(K),
      MaybeKnown(1),
      kloop.rangesym,
      kloop.lensym
    )
  end
  GEMMLOOPSET.vector_width = W
  order = choose_order(GEMMLOOPSET)
  (N ≢ nothing) && (GEMMLOOPSET.loops[1] = nloop)
  (M ≢ nothing) && (GEMMLOOPSET.loops[2] = mloop)
  (K ≢ nothing) && (GEMMLOOPSET.loops[3] = kloop)
  order[5], last(order)
end
@generated function matmul_params(
  ::StaticInt{RS},
  ::StaticInt{RC},
  ::StaticInt{CLS}
) where {RS,RC,CLS}
  mᵣ, nᵣ = matmul_params(RS, RC, CLS)
  Expr(
    :tuple,
    Expr(:call, Expr(:curly, :StaticInt, mᵣ)),
    Expr(:call, Expr(:curly, :StaticInt, nᵣ))
  )
end
matmul_params() =
  matmul_params(register_size(), register_count(), cache_linesize())

# function dotturbo(x,y)
#   s = zero(promote_type(eltype(x),eltype(y)))
#   @turbo for i ∈ eachindex(x,y)
#     s += x[i]*y[i]
#   end
#   s
# end
# dotturbo(Float64[1.0], Float64[2.0])

function opisreduced(op::Operation)
  for rdep ∈ reduceddependencies(op)
    rdep ∉ loopdependencies(op) && return true
  end
  false
end
function storeinstr_preprend(op::Operation, vloopsym::Symbol)
  # defaultstoreop = :vstore!
  # defaultstoreop = :vnoaliasstore!
  isvectorized(op) && return Symbol("")
  vloopsym ∉ reduceddependencies(op) && return Symbol("")
  # vectorized is not a loopdep, but is a reduced dep
  opp::Operation = first(parents(op))
  # while vectorized ∉ loopdependencies(opp)
  while ((!isvectorized(opp)) || opisreduced(opp))
    oppold = opp
    for oppp ∈ parents(opp)
      if vloopsym ∈ reduceddependencies(oppp)
        @assert opp !== oppp "More than one parent is a reduction over the vectorized variable."
        opp = oppp
      end
    end
    @assert opp !== oppold "Failed to find any parents "
  end
  instr = instruction(opp).instr
  instr === :ifelse && return Symbol("") #throw(LoopError("ifelse not yet supported for inner reductions"))
  return reduction_to_scalar(instr)
  # if instr ≢ :ifelse
  #   Expr(:(.), LoopVectorization, QuoteNode(reduction_to_scalar(instr))) # :IfElseReducer
  # else
  #   ifelse_reduction(:IfElseReducer,opp) do opv
  #     throw(LoopError("Does not support storing mirrored ifelse-reductions yet"))
  #   end
  # end
end

function reduce_expr_u₂(
  toreduct::Symbol,
  op::Operation,
  u₂::Int,
  suffix::Symbol
)
  t = Expr(:tuple)
  for u ∈ 0:u₂-1
    push!(t.args, Symbol(toreduct, u, suffix))
  end
  Expr(:call, lv(:reduce_tup), reduce_to_onevecunroll(op), t)
end
function reduce_expr!(
  q::Expr,
  toreduct::Symbol,
  op::Operation,
  u₁::Int,
  u₂::Int,
  isu₁unrolled::Bool,
  isu₂unrolled::Bool
)
  if isu₂unrolled# u₂ != -1
    _toreduct = Symbol(toreduct, 0)
    push!(
      q.args,
      Expr(:(=), _toreduct, reduce_expr_u₂(toreduct, op, u₂, Symbol("")))
    )
  else#if u₂ == -1
    _toreduct = Symbol(toreduct, '_', u₁)
  end
  if (u₁ == 1) | (~isu₁unrolled)
    push!(q.args, Expr(:(=), Symbol(toreduct, "##onevec##"), _toreduct))
  elseif instruction(op).instr ≢ :ifelse
    push!(
      q.args,
      Expr(
        :(=),
        Symbol(toreduct, "##onevec##"),
        Expr(:call, reduction_to_single_vector(op), _toreduct)
      )
    )
  else
    fifelse = let u₁ = u₁
      ifelse_reduction(:IfElseCollapser, op) do opv
        Symbol(mangledvar(opv), '_', u₁), tuple()
      end
    end
    push!(
      q.args,
      Expr(
        :(=),
        Symbol(toreduct, "##onevec##"),
        Expr(:call, fifelse, _toreduct, staticexpr(1))
      )
    )
  end
  nothing
end

function lower_store_collection!(
  q::Expr,
  ls::LoopSet,
  op::Operation,
  ua::UnrollArgs,
  mask::Bool,
  inds_calc_by_ptr_offset::Vector{Bool}
)
  omop = offsetloadcollection(ls)
  batchid, _ = omop.batchedcollectionmap[identifier(op)]
  collectionid, __ = omop.opidcollectionmap[identifier(op)]
  opidmap = offsetloadcollection(ls).opids[collectionid]
  idsformap = omop.batchedcollections[batchid]

  @unpack u₁, u₁loop, u₁loopsym, u₂loopsym, vloopsym, vloop, u₂max, suffix = ua
  ops = operations(ls)
  # __u₂max = ls.unrollspecification.u₂
  nouter = length(idsformap)

  t = Expr(:tuple)
  for (opid, _) ∈ idsformap
    opp = first(parents(ops[opidmap[opid]]))

    isu₁, isu₂ = isunrolled_sym(opp, u₁loopsym, u₂loopsym, vloopsym, ls)#, __u₂max)
    u = Core.ifelse(isu₁, u₁, 1)
    if isloopvalue(opp)
      loopval = first(loopdependencies(opp))
      add_loopvalue!(t, loopval, ua, u₁, getloop(ls, loopval))
    else
      mvar = Symbol(variable_name(opp, ifelse(isu₂, suffix, -1)), '_', u)
      push!(t.args, mvar)
    end
  end
  offset_dummy_loop = Loop(
    first(getindices(op)),
    MaybeKnown(1),
    MaybeKnown(1024),
    MaybeKnown(1),
    Symbol(""),
    Symbol("")
  )
  unrollcurl₂ = unrolled_curly(op, nouter, offset_dummy_loop, vloop, mask, 1)
  inds = mem_offset_u(op, ua, inds_calc_by_ptr_offset, false, 0, ls, false)
  falseexpr = Expr(:call, lv(:False))
  aliasexpr = falseexpr
  # trueexpr = Expr(:call, lv(:True));
  rs = staticexpr(reg_size(ls))
  manualunrollu₁ = if isu₁unrolled(op) && u₁ > 1 # both unrolled
    # unrollcurl₂ is unrolled along `first(getindices(op))` by factor of `nouter`
    # 
    # if isknown(step(u₁loop)) && sum(Base.Fix2(===,u₁loopsym), getindicesonly(op)) == 1
    if (
      isknown(step(u₁loop)) &&
      sum(Base.Fix2(===, u₁loopsym), getindicesonly(op)) == 1
    )# && (isone(step(u₁loop)) | (first(getindices(op)) ≢ u₁loopsym))
      # if first(getindices(op)) === u₁loopsym#vloopsym
      #   interleaveval = -nouter
      # else
      interleaveval = 0
      # end
      unrollcurl₁ = unrolled_curly(op, u₁, u₁loop, vloop, mask, interleaveval)
      inds = Expr(:call, unrollcurl₁, inds)
      false
    else
      true
    end
  else
    false
  end
  uinds = Expr(:call, unrollcurl₂, inds)
  sptrsym = sptr!(q, op)
  storeexpr =
    Expr(:call, lv(:_vstore!), sptrsym, Expr(:call, lv(:VecUnroll), t), uinds)
  # not using `add_memory_mask!(storeexpr, op, ua, mask, ls)` because we checked `isconditionalmemop` earlier in `lower_load_collection!`
  u₁vectorized = u₁loopsym === vloopsym
  if mask# && isvectorized(op))
    if !(manualunrollu₁ & u₁vectorized)
      push!(storeexpr.args, MASKSYMBOL)
    end
  end
  push!(storeexpr.args, falseexpr, aliasexpr, falseexpr, rs)
  if manualunrollu₁
    masklast = mask & u₁vectorized
    gf = GlobalRef(Core, :getfield)
    tv = Vector{Symbol}(undef, length(t.args))
    for i ∈ eachindex(tv)
      s = gensym!(ls, "##tmp##collection##store##")
      tv[i] = s
      push!(q.args, Expr(:(=), s, Expr(:call, gf, t.args[i], 1)))
    end
    for u ∈ 0:u₁-1
      lastiter = (u + 1) == u₁
      storeexpr_tmp = if lastiter
        storeexpr
        (((u + 1) == u₁) & masklast) &&
          insert!(storeexpr.args, length(storeexpr.args) - 3, MASKSYMBOL) # 3 for falseexpr, aliasexpr, falseexpr
        storeexpr
      else
        copy(storeexpr)
      end
      vut = Expr(:tuple)
      for i ∈ eachindex(tv)
        push!(vut.args, Expr(:call, gf, tv[i], u + 1, false))
      end
      storeexpr_tmp.args[3] = Expr(:call, lv(:VecUnroll), vut)
      if u ≠ 0
        storeexpr_tmp.args[4] = Expr(
          :call,
          unrollcurl₂,
          mem_offset_u(op, ua, inds_calc_by_ptr_offset, false, u, ls, false)
        )
      end
      push!(q.args, storeexpr_tmp)
    end
  else
    push!(q.args, storeexpr)
  end
  nothing
end
gf(s::Symbol, n::Int) = Expr(:call, GlobalRef(Core, :getfield), s, n, false)
function lower_store!(
  q::Expr,
  ls::LoopSet,
  op::Operation,
  ua::UnrollArgs,
  mask::Bool,
  reductfunc::Symbol = storeinstr_preprend(op, ua.vloop.itersymbol),
  inds_calc_by_ptr_offset = indices_calculated_by_pointer_offsets(ls, op.ref)
)
  @unpack u₁, u₁loopsym, u₂loopsym, vloopsym, vloop, u₂max, suffix = ua
  omop = offsetloadcollection(ls)
  batchid, opind = omop.batchedcollectionmap[identifier(op)]
  if ((batchid ≠ 0) && isvectorized(op)) && (!rejectinterleave(op))
    (opind == 1) &&
      lower_store_collection!(q, ls, op, ua, mask, inds_calc_by_ptr_offset)
    return
  end
  falseexpr = Expr(:call, lv(:False))
  aliasexpr = falseexpr
  # trueexpr = Expr(:call, lv(:True));
  rs = staticexpr(reg_size(ls))
  opp = first(parents(op))
  if (
    (opp.instruction.instr === reductfunc) ||
    (opp.instruction.instr === :identity)
  )
    parents_opp = parents(opp)
    opppstate = Base.iterate(parents_opp)
    if opppstate ≢ nothing
      oppp, state = opppstate
      if (Base.iterate(parents_opp, state) === nothing) &&
         isu₂unrolled(op) == isu₂unrolled(oppp)
        opp = oppp
      end
    end
  end
  # __u₂max = ls.unrollspecification.u₂
  isu₁, isu₂ = isunrolled_sym(opp, u₁loopsym, u₂loopsym, vloopsym, ls)#, __u₂max)
  u = isu₁ ? u₁ : 1
  mvar = Symbol(variable_name(opp, ifelse(isu₂, suffix, -1)), '_', u)
  if isloopvalue(opp)
    def = Expr(:(=), mvar)
    loopval = first(loopdependencies(opp))
    add_loopvalue!(def, loopval, ua, u₁, getloop(ls, loopval))
    push!(q.args, def)
  end
  if all(op.ref.loopedindex)
    inds = unrolledindex(op, ua, mask, inds_calc_by_ptr_offset, ls)
    storeexpr = if reductfunc === Symbol("")
      Expr(:call, lv(:_vstore!), sptr(op), mvar, inds)
    else
      Expr(:call, lv(:_vstore!), lv(reductfunc), sptr(op), mvar, inds)
    end
    add_memory_mask!(storeexpr, op, ua, mask, ls, 0)
    push!(storeexpr.args, falseexpr, aliasexpr, falseexpr, rs)
    push!(q.args, storeexpr)
  else
    parents_op = parents(op)
    data_u₁ = isu₁ & (u₁ > 1)

    indices_u₁ = data_u₁
    if !data_u₁ & (length(parents_op) > 1)
      indices_u₁ = first(isunrolled_sym(op, u₁loopsym, u₂loopsym, vloopsym, ls))
    end
    if indices_u₁
      mvard = Symbol(mvar, "##data##")
      # isu₁ &&
      data_u₁ && push!(q.args, Expr(:(=), mvard, Expr(:call, lv(:data), mvar)))
      sptrsym = sptr!(q, op)
      for u ∈ 1:u₁
        inds =
          mem_offset_u(op, ua, inds_calc_by_ptr_offset, true, u - 1, ls, false)
        storeexpr = if data_u₁
          if reductfunc === Symbol("")
            Expr(:call, lv(:_vstore!), sptrsym, gf(mvard, u), inds)
          else
            Expr(
              :call,
              lv(:_vstore!),
              lv(reductfunc),
              sptrsym,
              gf(mvard, u),
              inds
            )
          end
        elseif reductfunc === Symbol("")
          Expr(:call, lv(:_vstore!), sptrsym, mvar, inds)
        else
          Expr(:call, lv(:_vstore!), lv(reductfunc), sptrsym, mvar, inds)
        end
        domask =
          mask && (isvectorized(op) & ((u == u₁) | (vloopsym !== u₁loopsym)))
        add_memory_mask!(storeexpr, op, ua, domask, ls, u)# & ((u == u₁) | isvectorized(op)))
        push!(storeexpr.args, falseexpr, aliasexpr, falseexpr, rs)
        push!(q.args, storeexpr)
      end
    else
      inds = mem_offset_u(op, ua, inds_calc_by_ptr_offset, true, 0, ls, false)
      storeexpr = if reductfunc === Symbol("")
        Expr(:call, lv(:_vstore!), sptr(op), mvar, inds)
      else
        Expr(:call, lv(:_vstore!), lv(reductfunc), sptr(op), mvar, inds)
      end
      add_memory_mask!(storeexpr, op, ua, mask, ls, 0)
      push!(storeexpr.args, falseexpr, aliasexpr, falseexpr, rs)
      push!(q.args, storeexpr)
    end
  end
  nothing
end

function lower_tiled_store!(
  blockq::Expr,
  opsv1::Vector{Operation},
  opsv2::Vector{Operation},
  ls::LoopSet,
  unrollsyms::UnrollSymbols,
  u₁::Int,
  u₂::Int,
  mask::Bool
)
  ua = UnrollArgs(ls, u₁, unrollsyms, u₂, 0)
  for opsv ∈ (opsv1, opsv2)
    for op ∈ opsv
      lower_tiled_store!(blockq, op, ls, ua, u₁, u₂, mask)
    end
  end
end

function donot_tile_store(
  ls::LoopSet,
  op::Operation,
  reductfunc::Symbol,
  u₂::Int
)
  (
    (!((reductfunc === Symbol("")) && all(op.ref.loopedindex))) ||
    (u₂ ≤ 1) ||
    isconditionalmemop(op)
  ) && return true
  rejectcurly(op) && return true
  omop = offsetloadcollection(ls)
  batchid, _ = omop.batchedcollectionmap[identifier(op)]
  return ((batchid ≠ 0) && isvectorized(op)) && (!rejectinterleave(op))
end

# VectorizationBase implements optimizations for certain grouped stores
# thus we group stores together here to allow for these possibilities.
# (In particular, it tries to replace scatters with shuffles when there are groups
#   of stores offset from one another.)
function lower_tiled_store!(
  blockq::Expr,
  op::Operation,
  ls::LoopSet,
  ua::UnrollArgs,
  u₁::Int,
  u₂::Int,
  mask::Bool
)
  @unpack u₁loopsym, u₂loopsym, vloopsym, u₁loop, u₂loop, vloop = ua
  reductfunc = storeinstr_preprend(op, vloopsym)
  inds_calc_by_ptr_offset = indices_calculated_by_pointer_offsets(ls, op.ref)

  if donot_tile_store(ls, op, reductfunc, u₂)
    # If we have a reductfunc, we're using a reducing store instead of a contiguous or shuffle store anyway
    # so no benefit to being able to handle that case here, vs just calling the default `lower_store!` method
    @unpack u₁, u₂max = ua
    for t ∈ 0:u₂-1
      unrollargs = UnrollArgs(u₁loop, u₂loop, vloop, u₁, u₂max, t)
      lower_store!(
        blockq,
        ls,
        op,
        unrollargs,
        mask,
        reductfunc,
        inds_calc_by_ptr_offset
      )
    end
    return
  end
  opp = first(parents(op))
  if (opp.instruction.instr === reductfunc) && isone(length(parents(opp)))
    throw(
      LoopError(
        "Operation $opp's instruction is $reductfunc, shouldn't be able to reach here."
      )
    )
    # opp = only(parents(opp))
  end
  isu₁, isu₂ = isunrolled_sym(opp, u₁loopsym, u₂loopsym, vloopsym, ls)#, u₂)
  # It's reasonable for this to be `!isu₁`
  u = Core.ifelse(isu₁, u₁, 1)
  tup = Expr(:tuple)
  for t ∈ 0:u₂-1
    # tiled stores cannot be loop values, as they're necessarily
    # functions of at least two loops, meaning we do not need to handle them here.
    push!(tup.args, Symbol(variable_name(opp, ifelse(isu₂, t, -1)), '_', u))
  end
  vut = Expr(:call, lv(:VecUnroll), tup) # `VecUnroll` of `VecUnroll`s
  inds = mem_offset_u(op, ua, inds_calc_by_ptr_offset, false, 0, ls, false)
  unrollcurl₂ = unrolled_curly(op, u₂, u₂loop, vloop, mask)
  falseexpr = Expr(:call, lv(:False))
  aliasexpr = falseexpr
  # trueexpr = Expr(:call, lv(:True));
  rs = staticexpr(reg_size(ls))
  if isu₁ && u₁ > 1 # both unrolled
    unrollcurl₁ = unrolled_curly(op, u₁, u₁loop, vloop, mask)
    inds = Expr(:call, unrollcurl₁, inds)
  end
  uinds = Expr(:call, unrollcurl₂, inds)
  storeexpr = Expr(:call, lv(:_vstore!), sptr(op), vut, uinds)
  if mask && isvectorized(op)
    # add_memory_mask!(storeexpr, op, ua, mask, ls)
    # we checked for `isconditionalmemop` earlier, so we skip this check
    # and just directly take the branch in `add_memory_mask!`
    push!(storeexpr.args, MASKSYMBOL)
  end
  push!(storeexpr.args, falseexpr, aliasexpr, falseexpr, rs)
  push!(blockq.args, storeexpr)
  nothing
end

const EXTRACTFUNS = (
  :first,
  :second,
  :third,
  :fourth,
  :fifth,
  :sixth,
  :seventh,
  :eighth,
  :ninth,
  :tenth,
  :eleventh,
  :twelfth,
  :thirteenth,
  :fourteenth,
  :fifteenth,
  :sixteenth,
  :seventeenth,
  :eighteenth,
  :nineteenth,
  :twentieth,
  :twentyfirst,
  :twentysecond,
  :twentythird,
  :twentyfourth,
  :twentyfifth,
  :twentysixth,
  :twentyseventh,
  :twentyeighth,
  :twentyninth,
  :thirtieth,
  :thirtyfirst,
  :thirtysecond,
  :thirtythird,
  :thirtyfourth,
  :thirtyfifth,
  :thirtysixth,
  :thirtyseventh,
  :thirtyeighth,
  :last
)

for (i, f) ∈ enumerate(EXTRACTFUNS)
  (i == 1 || i == length(EXTRACTFUNS)) && continue
  @eval @inline $f(x) = @inbounds getindex(x, $i)
end

using LoopVectorization, Test


function multiassign!(y, x)
  @assert length(y) + 3 == length(x)
  @inbounds for i ∈ eachindex(y)
    x₁, ((x₂, x₃), (x₄, x₅)) = x[i], (sincos(x[i+1]), (x[i+2], x[i+3]))
    y[i] = x₁ * x₄ - x₂ * x₃
  end
  y
end
multiassign(x) = multiassign!(similar(x, length(x) - 3), x)
function multiassign_turbo!(y, x)
  @assert length(y) + 3 == length(x)
  @turbo for i ∈ eachindex(y)
    x₁, ((x₂, x₃), (x₄, x₅)) = x[i], (sincos(x[i+1]), (x[i+2], x[i+3]))
    y[i] = x₁ * x₄ - x₂ * x₃
  end
  y
end
multiassign_turbo(x) = multiassign_turbo!(similar(x, length(x) - 3), x)

multistorefunc(x) = exp(x), sincos(x)
function multistore!(x, y, z, a)
  @inbounds for i ∈ eachindex(x, y, z, a)
    x[i], (y[i], z[i]) = multistorefunc(a[i])
  end
end
function multistore_turbo!(x, y, z, a)
  @turbo for i ∈ eachindex(x, y, z, a)
    x[i], (y[i], z[i]) = multistorefunc(a[i])
  end
end

@testset "Multiple assignments" begin
  @show @__LINE__
  x = rand(111)
  @test multiassign(x) ≈ multiassign_turbo(x)
  a0 = similar(x)
  b0 = similar(x)
  c0 = similar(x)
  a1 = similar(x)
  b1 = similar(x)
  c1 = similar(x)
  multistore!(a0, b0, c0, x)
  multistore_turbo!(a1, b1, c1, x)
  @test a0 ≈ a1
  @test b0 ≈ b1
  @test c0 ≈ c1
end

function copy_sp_data_range!(newR, newstrd, newoffsets, ind, R, rg)
  for i ∈ rg
    push!(newR.args, R[i])
    push!(newstrd.args, :($getfield(strd, $i, false)))
    push!(newoffsets.args, :($getfield(offs, $i, false)))
    push!(ind.args, :($getfield(offs, $i, false)))
  end
  nothing
end
@generated function subsetview(
  ptr::AbstractStridedPointer{T,N,C,B,R,X,O},
  ::StaticInt{I},
  i::Union{Integer,StaticInt}
) where {T,N,C,B,R,X,O,I}
  I > N && return :ptr
  @assert B ≤ 0 "Batched dims not currently supported."
  newC = C == I ? -1 : (C < I ? C : C - 1)
  newR = Expr(:tuple)
  newstrd = Expr(:tuple)
  newoffsets = Expr(:tuple)
  ind = Expr(:tuple)
  copy_sp_data_range!(newR, newstrd, newoffsets, ind, R, 1:I-1)
  push!(ind.args, :i)
  copy_sp_data_range!(newR, newstrd, newoffsets, ind, R, I+1:N)
  gptr = Expr(:call, :gep, :ptr, ind)
  quote
    $(Expr(:meta, :inline))
    strd = strides(ptr)
    offs = offsets(ptr)
    si = ArrayInterface.StrideIndex{$(N - 1),$newR,$newC}($newstrd, $newoffsets)
    stridedpointer($gptr, si, StaticInt{$B}())
  end
end
@inline _subsetview(
  ptr::AbstractStridedPointer,
  ::StaticInt{I},
  J::Tuple{}
) where {I} = ptr
@inline _subsetview(
  ptr::AbstractStridedPointer,
  ::StaticInt{I},
  J::Tuple{J1}
) where {I,J1} = subsetview(ptr, StaticInt{I}(), first(J))
@inline _subsetview(
  ptr::AbstractStridedPointer,
  ::StaticInt{I},
  J::Tuple{J1,J2,Vararg}
) where {I,J1,J2} = _subsetview(
  subsetview(ptr, StaticInt{I}(), first(J)),
  StaticInt{I}(),
  Base.tail(J)
)
@inline subsetview(
  ptr::AbstractStridedPointer,
  ::StaticInt{I},
  J::CartesianIndex
) where {I} = _subsetview(ptr, StaticInt{I}(), Tuple(J))

@inline _gesp(
  sp::VectorizationBase.FastRange,
  ::StaticInt{1},
  i,
  ::StaticInt{1}
) = gesp(sp, (i,))
@generated function _gesp(
  sp::AbstractStridedPointer{T,N},
  ::StaticInt{I},
  i::Union{Integer,StaticInt},
  ::StaticInt{D}
) where {I,N,T,D}
  t = Expr(:tuple)
  for j ∈ 1:I-1
    # push!(t.args, staticexpr(0))
    push!(t.args, VectorizationBase.NullStep())
  end
  push!(t.args, :i)
  if D > 1
    for j ∈ I+1:N
      # push!(t.args, staticexpr(0))
      push!(t.args, VectorizationBase.NullStep())
    end
  end
  quote
    $(Expr(:meta, :inline))
    gesp(sp, $t)
  end
end

using LoopVectorization, LinearAlgebra, OffsetArrays, ArrayInterface
BLAS.set_num_threads(1)

using LoopVectorization: Static
# TODO: remove this once this PR merges: https://github.com/JuliaArrays/OffsetArrays.jl/pull/170
@inline Base.unsafe_convert(::Type{Ptr{T}}, A::OffsetArray{T}) where {T} =
  pointer(parent(A))

struct SizedOffsetMatrix{T,LR,UR,LC,UC} <: DenseMatrix{T}
  data::Matrix{T}
end
Base.size(::SizedOffsetMatrix{<:Any,LR,UR,LC,UC}) where {LR,UR,LC,UC} =
  (UR - LR + 1, UC - LC + 1)
Base.axes(::SizedOffsetMatrix{T,LR,UR,LC,UC}) where {T,LR,UR,LC,UC} =
  (StaticInt{LR}():StaticInt{UR}(), StaticInt{LC}():StaticInt{UC}())
Base.parent(A::SizedOffsetMatrix) = A.data
Base.unsafe_convert(::Type{Ptr{T}}, A::SizedOffsetMatrix{T}) where {T} =
  pointer(A.data)
ArrayInterface.contiguous_axis(::Type{<:SizedOffsetMatrix}) = StaticInt(1)
ArrayInterface.contiguous_batch_size(::Type{<:SizedOffsetMatrix}) = StaticInt(0)
ArrayInterface.stride_rank(::Type{<:SizedOffsetMatrix}) =
  (StaticInt(1), StaticInt(2))
function ArrayInterface.strides(
  A::SizedOffsetMatrix{T,LR,UR,LC,UC}
) where {T,LR,UR,LC,UC}
  (StaticInt{1}(), (StaticInt{UR}() - StaticInt{LR}() + StaticInt{1}()))
end
ArrayInterface.offsets(
  A::SizedOffsetMatrix{T,LR,UR,LC,UC}
) where {T,LR,UR,LC,UC} = (StaticInt{LR}(), StaticInt{LC}())
ArrayInterface.parent_type(::Type{<:SizedOffsetMatrix{T}}) where {T} = Matrix{T}
Base.getindex(A::SizedOffsetMatrix, i, j) =
  LoopVectorization.vload(LoopVectorization.stridedpointer(A), (i, j))

function jgemm!(𝐂, 𝐀, 𝐁)
  𝐂 .= 0
  M, N = size(𝐂)
  K = size(𝐁, 1)
  @inbounds for n ∈ 1:N, k ∈ 1:K
    @simd ivdep for m ∈ 1:M
      @fastmath 𝐂[m, n] += 𝐀[m, k] * 𝐁[k, n]
    end
  end
end
function jgemm!(𝐂, 𝐀ᵀ::Adjoint, 𝐁)
  𝐀 = parent(𝐀ᵀ)
  @inbounds for n ∈ 1:size(𝐂, 2), m ∈ 1:size(𝐂, 1)
    𝐂ₘₙ = zero(eltype(𝐂))
    @simd ivdep for k ∈ 1:size(𝐀, 1)
      @fastmath 𝐂ₘₙ += 𝐀[k, m] * 𝐁[k, n]
    end
    𝐂[m, n] = 𝐂ₘₙ
  end
end
function jgemm!(𝐂, 𝐀, 𝐁ᵀ::Adjoint)
  𝐂 .= 0
  𝐁 = parent(𝐁ᵀ)
  M, N = size(𝐂)
  K = size(𝐁ᵀ, 1)
  @inbounds for k ∈ 1:K, n ∈ 1:N
    @simd ivdep for m ∈ 1:M
      @fastmath 𝐂[m, n] += 𝐀[m, k] * 𝐁[n, k]
    end
  end
end
function jgemm!(𝐂, 𝐀ᵀ::Adjoint, 𝐁ᵀ::Adjoint)
  𝐂 .= 0
  𝐀 = parent(𝐀ᵀ)
  𝐁 = parent(𝐁ᵀ)
  M, N = size(𝐂)
  K = size(𝐁ᵀ, 1)
  @inbounds for n ∈ 1:N, k ∈ 1:K
    @simd ivdep for m ∈ 1:M
      @fastmath 𝐂[m, n] += 𝐀[k, m] * 𝐁[n, k]
    end
  end
end
gemmavx!(𝐂, 𝐀, 𝐁) = @turbo for m ∈ indices((𝐀, 𝐂), 1), n ∈ indices((𝐁, 𝐂), 2)
  𝐂ₘₙ = zero(eltype(𝐂))
  for k ∈ indices((𝐀, 𝐁), (2, 1))
    𝐂ₘₙ += 𝐀[m, k] * 𝐁[k, n]
  end
  𝐂[m, n] = 𝐂ₘₙ
end
function gemmavx!(
  Cc::AbstractMatrix{Complex{T}},
  Ac::AbstractMatrix{Complex{T}},
  Bc::AbstractMatrix{Complex{T}}
) where {T}
  A = reinterpret(reshape, T, Ac)
  B = reinterpret(reshape, T, Bc)
  C = reinterpret(reshape, T, Cc)
  @turbo for m ∈ indices((A, C), 2), n ∈ indices((B, C), 3)
    Cre = zero(T)
    Cim = zero(T)
    for k ∈ indices((A, B), (3, 2))
      Cre += A[1, m, k] * B[1, k, n] - A[2, m, k] * B[2, k, n]
      Cim += A[1, m, k] * B[2, k, n] + A[2, m, k] * B[1, k, n]
    end
    C[1, m, n] = Cre
    C[2, m, n] = Cim
  end
end
gemmavxt!(𝐂, 𝐀, 𝐁) = @tturbo for m ∈ indices((𝐀, 𝐂), 1), n ∈ indices((𝐁, 𝐂), 2)
  𝐂ₘₙ = zero(eltype(𝐂))
  for k ∈ indices((𝐀, 𝐁), (2, 1))
    𝐂ₘₙ += 𝐀[m, k] * 𝐁[k, n]
  end
  𝐂[m, n] = 𝐂ₘₙ
end
function gemmavxt!(
  Cc::AbstractMatrix{Complex{T}},
  Ac::AbstractMatrix{Complex{T}},
  Bc::AbstractMatrix{Complex{T}}
) where {T}
  A = reinterpret(reshape, T, Ac)
  B = reinterpret(reshape, T, Bc)
  C = reinterpret(reshape, T, Cc)
  @tturbo for m ∈ indices((A, C), 2), n ∈ indices((B, C), 3)
    Cre = zero(T)
    Cim = zero(T)
    for k ∈ indices((A, B), (3, 2))
      Cre += A[1, m, k] * B[1, k, n] - A[2, m, k] * B[2, k, n]
      Cim += A[1, m, k] * B[2, k, n] + A[2, m, k] * B[1, k, n]
    end
    C[1, m, n] = Cre
    C[2, m, n] = Cim
  end
end
function jdot(a, b)
  s = zero(eltype(a))
  # @inbounds @simd ivdep for i ∈ eachindex(a,b)
  @inbounds @simd ivdep for i ∈ eachindex(a)
    s += a[i] * b[i]
  end
  s
end
function jdotavx(a, b)
  s = zero(eltype(a))
  # @turbo for i ∈ eachindex(a,b)
  @turbo for i ∈ eachindex(a)
    s += a[i] * b[i]
  end
  s
end
function jdotavxt(a, b)
  s = zero(eltype(a))
  # @turbo for i ∈ eachindex(a,b)
  @tturbo for i ∈ eachindex(a)
    s += a[i] * b[i]
  end
  s
end
function jselfdot(a)
  s = zero(eltype(a))
  @inbounds @simd ivdep for i ∈ eachindex(a)
    s += a[i] * a[i]
  end
  s
end
function jselfdotavx(a)
  s = zero(eltype(a))
  @turbo for i ∈ eachindex(a)
    s += a[i] * a[i]
  end
  s
end
function jdot3v2(x, A, y)
  M, N = size(A)
  s = zero(promote_type(eltype(x), eltype(A), eltype(y)))
  @inbounds @fastmath for n ∈ 1:N, m ∈ 1:M
    s += x[m] * A[m, n] * y[n]
  end
  s
end
function jdot3v2avx(x, A, y)
  M, N = size(A)
  s = zero(promote_type(eltype(x), eltype(A), eltype(y)))
  @turbo for n ∈ 1:N, m ∈ 1:M
    s += x[m] * A[m, n] * y[n]
  end
  s
end
function jdot3(x, A, y)
  s = zero(promote_type(eltype(x), eltype(A), eltype(y)))
  @inbounds @fastmath for n ∈ axes(A, 2)
    t = zero(s)
    @simd ivdep for m ∈ axes(A, 1)
      t += x[m] * A[m, n]
    end
    s += t * y[n]
  end
  s
end
function jdot3avx(x, A, y)
  s = zero(promote_type(eltype(x), eltype(A), eltype(y)))
  @turbo for n ∈ axes(A, 2)
    t = zero(s)
    for m ∈ axes(A, 1)
      t += x[m] * A[m, n]
    end
    s += t * y[n]
  end
  s
end
jvexp!(b, a) = @inbounds for i ∈ eachindex(a)
  b[i] = exp(a[i])
end
jvexpavx!(b, a) = @turbo for i ∈ eachindex(a)
  b[i] = exp(a[i])
end
function jsvexp(a)
  s = zero(eltype(a))
  @inbounds for i ∈ eachindex(a)
    s += exp(a[i])
  end
  s
end
function jsvexpavx(a)
  s = zero(eltype(a))
  @turbo for i ∈ eachindex(a)
    s += exp(a[i])
  end
  s
end
function jgemv!(y, 𝐀, x)
  y .= zero(eltype(y))
  @inbounds for j ∈ eachindex(x)
    @simd ivdep for i ∈ eachindex(y)
      @fastmath y[i] += 𝐀[i, j] * x[j]
    end
  end
end
function jgemv!(𝐲, 𝐀ᵀ::Adjoint, 𝐱)
  𝐀 = parent(𝐀ᵀ)
  @inbounds for i ∈ eachindex(𝐲)
    𝐲ᵢ = zero(eltype(𝐲))
    @simd ivdep for j ∈ eachindex(𝐱)
      @fastmath 𝐲ᵢ += 𝐀[j, i] * 𝐱[j]
    end
    𝐲[i] = 𝐲ᵢ
  end
end
jgemvavx!(𝐲, 𝐀, 𝐱) = @turbo for i ∈ eachindex(𝐲)
  𝐲ᵢ = zero(eltype(𝐲))
  for j ∈ eachindex(𝐱)
    𝐲ᵢ += 𝐀[i, j] * 𝐱[j]
  end
  𝐲[i] = 𝐲ᵢ
end
function jvar!(𝐬², 𝐀, x̄)
  @. s² = zero(eltype(𝐬²))
  @inbounds @fastmath for i ∈ 1:size(𝐀, 2)
    @simd for j ∈ eachindex(𝐬²)
      δ = 𝐀[j, i] - x̄[j]
      𝐬²[j] += δ * δ
    end
  end
end
jvaravx!(𝐬², 𝐀, x̄) = @turbo for j ∈ eachindex(𝐬²)
  𝐬²ⱼ = zero(eltype(𝐬²))
  x̄ⱼ = x̄[j]
  for i ∈ 1:size(𝐀, 2)
    δ = 𝐀[j, i] - x̄ⱼ
    𝐬²ⱼ += δ * δ
  end
  𝐬²[j] = 𝐬²ⱼ
end
japlucBc!(D, a, B, c) = @. D = a + B * c';
japlucBcavx!(D, a, B, c) = @turbo @. D = a + B * c';

function jOLSlp(y, X, β)
  lp = zero(eltype(y))
  @inbounds @fastmath for i ∈ eachindex(y)
    δ = y[i]
    @simd for j ∈ eachindex(β)
      δ -= X[i, j] * β[j]
    end
    lp += δ * δ
  end
  lp
end
function jOLSlp_avx(y, X, β)
  lp = zero(eltype(y))
  @turbo for i ∈ eachindex(y)
    δ = y[i]
    for j ∈ eachindex(β)
      δ -= X[i, j] * β[j]
    end
    lp += δ * δ
  end
  lp
end
function randomaccess(P, basis, coeffs::Vector{T}) where {T}
  C = length(coeffs)
  A = size(P, 1)
  p = zero(T)
  @fastmath @inbounds for c ∈ 1:C
    pc = coeffs[c]
    for a = 1:A
      pc *= P[a, basis[a, c]]
    end
    p += pc
  end
  return p
end
function randomaccessavx(P, basis, coeffs::Vector{T}) where {T}
  C = length(coeffs)
  A = size(P, 1)
  p = zero(T)
  @turbo for c ∈ 1:C
    pc = coeffs[c]
    for a = 1:A
      pc *= P[a, basis[a, c]]
    end
    p += pc
  end
  return p
end
function jlogdettriangle(B::Union{LowerTriangular,UpperTriangular})
  ld = 0.0
  @inbounds @fastmath for n ∈ 1:size(B, 1)
    ld += log(B[n, n])
  end
  ld
end
function jlogdettriangleavx(B::Union{LowerTriangular,UpperTriangular})
  A = parent(B) # No longer supported
  ld = zero(eltype(A))
  @turbo for n ∈ axes(A, 1)
    ld += log(A[n, n])
  end
  ld
end

function filter2d!(out::AbstractMatrix, A::AbstractMatrix, kern)
  @inbounds @fastmath for J in CartesianIndices(out)
    tmp = zero(eltype(out))
    for I ∈ CartesianIndices(kern)
      tmp += A[I+J] * kern[I]
    end
    out[J] = tmp
  end
  out
end
function filter2davx!(out::AbstractMatrix, A::AbstractMatrix, kern)
  @turbo for J in CartesianIndices(out)
    tmp = zero(eltype(out))
    for I ∈ CartesianIndices(kern)
      tmp += A[I+J] * kern[I]
    end
    out[J] = tmp
  end
  out
end

function filter2dunrolled!(
  out::AbstractMatrix,
  A::AbstractMatrix,
  kern::SizedOffsetMatrix{T,-1,1,-1,1}
) where {T}
  rng1, rng2 = axes(out)
  Base.Cartesian.@nexprs 3 jk ->
    Base.Cartesian.@nexprs 3 ik -> kern_ik_jk = kern[ik-2, jk-2]
  @inbounds for j in rng2
    @simd ivdep for i in rng1
      tmp_0 = zero(eltype(out))
      Base.Cartesian.@nexprs 3 jk -> Base.Cartesian.@nexprs 3 ik ->
        tmp_{ik + (jk - 1) * 3} = Base.FastMath.add_fast(
          Base.FastMath.mul_fast(A[i+(ik-2), j+(jk-2)], kern_ik_jk),
          tmp_{ik + (jk - 1) * 3 - 1}
        )
      out[i, j] = tmp_9
    end
  end
  out
end
function filter2dunrolledavx!(
  out::AbstractMatrix,
  A::AbstractMatrix,
  kern::SizedOffsetMatrix{T,-1,1,-1,1}
) where {T}
  rng1, rng2 = axes(out)
  Base.Cartesian.@nexprs 3 jk ->
    Base.Cartesian.@nexprs 3 ik -> kern_ik_jk = kern[ik-2, jk-2]
  @turbo for j in rng2, i in rng1
    tmp_0 = zero(eltype(out))
    Base.Cartesian.@nexprs 3 jk -> Base.Cartesian.@nexprs 3 ik ->
      tmp_{ik + (jk - 1) * 3} =
        A[i+(ik-2), j+(jk-2)] * kern_ik_jk + tmp_{ik + (jk - 1) * 3 - 1}
    out[i, j] = tmp_9
  end
  out
end

# function smooth_line!(sl,nrm1,j,i1,rl,ih2,denom)
#     @fastmath @inbounds @simd ivdep for i=i1:2:nrm1
#         sl[i,j]=denom*(rl[i,j]+ih2*(sl[i,j-1]+sl[i-1,j]+sl[i+1,j]+sl[i,j+1]))
#     end
# end
# function smooth_line_avx!(sl,nrm1,j,i1,sl,rl,ih2,denom)
#     @turbo for i=i1:2:nrm1
#         sl[i,j]=denom*(rl[i,j]+ih2*(sl[i,j-1]+sl[i-1,j]+sl[i+1,j]+sl[i,j+1]))
#     end
# end

using LoopVectorization, Test
# Tests for Tullio

@testset "Tullio Tests" begin
  A = (1:10) .^ 2
  K = rand(10)

  function act!(ℛ::AbstractArray, A, 𝒶𝓍i = axes(A, 1), 𝒶𝓍j = axes(ℛ, 2))
    @turbo for j in 𝒶𝓍j
      for i in 𝒶𝓍i
        ℛ[i, j] = A[i] / j
      end
    end
    ℛ
  end
  function act_noavx!(ℛ::AbstractArray, A, 𝒶𝓍i = axes(A, 1), 𝒶𝓍j = axes(ℛ, 2))
    for j in 𝒶𝓍j
      for i in 𝒶𝓍i
        ℛ[i, j] = A[i] / j
      end
    end
    ℛ
  end
  @test act!(rand(10, 10), A) ≈ act_noavx!(rand(10, 10), A)

  D = similar(A, 10, 10) .= 999

  inds = [2, 3, 5, 2]

  function two!(ℛ::AbstractArray, inds, A, 𝒶𝓍j = axes(ℛ, 2), 𝒶𝓍i = axes(inds, 1))
    @turbo for i in 𝒶𝓍i
      for j in 𝒶𝓍j
        ℛ[inds[i], j] = A[j]
      end
    end
    ℛ
  end
  function two_noavx!(ℛ::AbstractArray, inds, A, 𝒶𝓍j = axes(ℛ, 2), 𝒶𝓍i = axes(inds, 1))
    for i in 𝒶𝓍i
      for j in 𝒶𝓍j
        ℛ[inds[i], j] = A[j]
      end
    end
    ℛ
  end
  @test two!(copy(D), inds, A) == two!(copy(D), inds, A)

  function three!(ℛ::AbstractArray, A, 𝒶𝓍i = axes(ℛ, 1))
    @turbo for i in 𝒶𝓍i
      ℛ[i] = A[2i+1] + A[i]
    end
    ℛ
  end
  function three_noavx!(ℛ::AbstractArray, A, 𝒶𝓍i = axes(ℛ, 1))
    for i in 𝒶𝓍i
      ℛ[i] = A[2i+1] + A[i]
    end
    ℛ
  end
  @test three!(rand(4), A) == three_noavx!(rand(4), A)

  function and(A, 𝒶𝓍i = axes(A, 1))
    𝒜𝒸𝒸 = true
    @turbo for i in 𝒶𝓍i
      𝒜𝒸𝒸 = 𝒜𝒸𝒸 & (A[i] > 0)
    end
    𝒜𝒸𝒸
  end
  @test and(A)
  A[3] = -1
  @test !and(A)


  function dadada!(EV, Fu, V, ♻️ = nothing)
    (ndims)(EV) == 5 || (throw)("expected a 5-array EV")
    (ndims)(Fu) == 2 || (throw)("expected a 2-array Fu")
    (ndims)(V) == 4 || (throw)("expected a 4-array V")

    local 𝒶𝓍a = (axes)(EV, 1)
    local 𝒶𝓍k = (axes)(EV, 2)
    (axes)(V, 1) == (axes)(EV, 2) || (throw)("range of index k must agree")
    local 𝒶𝓍iu = (axes)(Fu, 2)
    (axes)(V, 4) == (axes)(Fu, 2) || (throw)("range of index iu must agree")
    local 𝒶𝓍z = (axes)(EV, 4)
    (axes)(V, 3) == (axes)(EV, 4) || (throw)("range of index z must agree")
    local 𝒶𝓍u = (axes)(EV, 5)
    (axes)(Fu, 1) == (axes)(EV, 5) || (throw)("range of index u must agree")
    local 𝒶𝓍x = (axes)(EV, 3)
    (axes)(V, 2) == (axes)(EV, 3) || (throw)("range of index x must agree")

    ℛ = EV

    @turbo for u in 𝒶𝓍u
      for z in 𝒶𝓍z
        for x in 𝒶𝓍x
          for k in 𝒶𝓍k
            for a in 𝒶𝓍a
              𝒜𝒸𝒸 = zero(eltype(EV))  # simpler, same error
              # 𝒜𝒸𝒸 = if ♻️ === nothing
              #         zero(𝒯)
              #     else
              #         ℛ[a, k, x, z, u]
              #     end
              for iu in 𝒶𝓍iu
                𝒜𝒸𝒸 = 𝒜𝒸𝒸 + Fu[u, iu] * V[k, x, z, iu]
              end
              ℛ[a, k, x, z, u] = 𝒜𝒸𝒸
            end
          end
        end
      end
    end
  end
  function dadada_noavx!(EV, Fu, V, ♻️ = nothing)
    (ndims)(EV) == 5 || (throw)("expected a 5-array EV")
    (ndims)(Fu) == 2 || (throw)("expected a 2-array Fu")
    (ndims)(V) == 4 || (throw)("expected a 4-array V")

    local 𝒶𝓍a = (axes)(EV, 1)
    local 𝒶𝓍k = (axes)(EV, 2)
    (axes)(V, 1) == (axes)(EV, 2) || (throw)("range of index k must agree")
    local 𝒶𝓍iu = (axes)(Fu, 2)
    (axes)(V, 4) == (axes)(Fu, 2) || (throw)("range of index iu must agree")
    local 𝒶𝓍z = (axes)(EV, 4)
    (axes)(V, 3) == (axes)(EV, 4) || (throw)("range of index z must agree")
    local 𝒶𝓍u = (axes)(EV, 5)
    (axes)(Fu, 1) == (axes)(EV, 5) || (throw)("range of index u must agree")
    local 𝒶𝓍x = (axes)(EV, 3)
    (axes)(V, 2) == (axes)(EV, 3) || (throw)("range of index x must agree")

    ℛ = EV

    @inbounds @fastmath for u in 𝒶𝓍u
      for z in 𝒶𝓍z
        for x in 𝒶𝓍x
          for k in 𝒶𝓍k
            for a in 𝒶𝓍a
              𝒜𝒸𝒸 = zero(eltype(EV))  # simpler, same error
              # 𝒜𝒸𝒸 = if ♻️ === nothing
              #         zero(𝒯)
              #     else
              #         ℛ[a, k, x, z, u]
              #     end
              for iu in 𝒶𝓍iu
                𝒜𝒸𝒸 = 𝒜𝒸𝒸 + Fu[u, iu] * V[k, x, z, iu]
              end
              ℛ[a, k, x, z, u] = 𝒜𝒸𝒸
            end
          end
        end
      end
    end
  end
  EV, Fu, V = rand(3, 3, 3, 3, 3), rand(3, 3), rand(3, 3, 3, 3)
  EV2 = similar(EV)
  dadada!(EV, Fu, V)
  dadada_noavx!(EV2, Fu, V)
  @test EV ≈ EV2


  let A = ones(2, 2, 2, 2)
    𝒜𝒸𝒸 = 0.0
    LoopVectorization.@turbo unroll = 0 for b in axes(A, 2), a in axes(A, 1)
      𝒜𝒸𝒸 = 𝒜𝒸𝒸 + A[a, b, a, b]
    end
    @test 𝒜𝒸𝒸 == 4.0
  end
end

"""
`vstorent!` (non-temporal store) requires data to be aligned.
`alignstores!` will align `y` in preparation for the non-temporal maps.
"""
function setup_vmap!(
  f::F,
  y::AbstractArray{T},
  ::Val{true},
  args::Vararg{AbstractArray,A}
) where {F,T<:Base.HWReal,A}
  N = length(y)
  ptry = VectorizationBase.zstridedpointer(y)
  ptrargs = map(VectorizationBase.zstridedpointer, args)
  V = pick_vector_width(T)
  W = unwrap(V)
  zero_index = (MM{W}(StaticInt(0)),)
  uintptry = reinterpret(UInt, pointer(ptry))
  @assert iszero(uintptry & (sizeof(T) - 1)) "The destination vector (`dest`) must be aligned to `sizeof(eltype(dest)) == $(sizeof(T))` bytes."
  alignment = uintptry & (register_size() - 1)
  if alignment > 0
    i =
      reinterpret(Int, W - (alignment >>> VectorizationBase.intlog2(sizeof(T))))
    m = mask(T, i)
    if N < i
      m &= mask(T, N & (W - 1))
    end
    _vstore!(
      ptry,
      f(map1(vload, ptrargs, zero_index, m)...),
      zero_index,
      m,
      False(),
      True(),
      False(),
      register_size()
    )
    gesp(ptry, (i,)), map1(gesp, ptrargs, (i,)), N - i
  else
    ptry, ptrargs, N
  end
end
function map1_quote(K::Int, args::Int)
  t = Expr(:tuple)
  gf = GlobalRef(Core, :getfield)
  for k ∈ 1:K
    c = Expr(:call, :f, Expr(:call, gf, :x_1, k, false))
    for a ∈ 2:args
      push!(c.args, Symbol(:x_, a))
    end
    push!(t.args, c)
  end
  Expr(:block, Expr(:meta, :inline), t)
end
@generated map1(f::F, x_1::Tuple{Vararg{Any,K}}, x_2) where {F,K} =
  map1_quote(K, 2)
@generated map1(f::F, x_1::Tuple{Vararg{Any,K}}, x_2, x_3) where {F,K} =
  map1_quote(K, 3)

@inline function setup_vmap!(
  f,
  y,
  ::Val{false},
  args::Vararg{AbstractArray,A}
) where {A}
  N = length(y)
  ptry = VectorizationBase.zstridedpointer(y)
  ptrargs = map(VectorizationBase.zstridedpointer, args)
  ptry, ptrargs, N
end

function vmap_singlethread!(
  f::F,
  y::AbstractArray{T},
  ::Val{NonTemporal},
  args::Vararg{AbstractArray,A}
) where {F,T<:NativeTypes,A,NonTemporal}
  presy = preserve_buffer(y)
  GC.@preserve presy begin
    ptry, ptrargs, N = setup_vmap!(f, y, Val{NonTemporal}(), args...)
    _vmap_singlethread!(f, ptry, Zero(), N, Val{NonTemporal}(), ptrargs)
  end
  nothing
end
function _vmap_singlethread!(
  f::F,
  ptry::AbstractStridedPointer{T},
  start,
  N,
  ::Val{NonTemporal},
  ptrargs::Tuple{Vararg{Any,A}}
) where {F,T,NonTemporal,A}
  i = convert(Int, start)
  V = VectorizationBase.pick_vector_width(
    promote_type(T, reduce(promote_type, map(eltype, ptrargs)))
  )
  W = unwrap(V)
  UNROLL = 4
  LOG2UNROLL = 2
  while i < vsub_nsw(N, ((W << LOG2UNROLL) - 1))
    index = VectorizationBase.Unroll{1,W,UNROLL,1,W,zero(UInt)}((i,))
    v = f(VectorizationBase.fmap(vload, ptrargs, index)...)
    if NonTemporal
      _vstore!(ptry, v, index, True(), True(), True(), register_size())
    else
      _vstore!(ptry, v, index, False(), True(), False(), register_size())
    end
    i = vadd_nw(i, StaticInt{UNROLL}() * W)
  end
  # if Base.libllvm_version ≥ v"11" # this seems to be slower
  #     Nm1 = vsub_nw(N, 1)
  #     while i < N # stops at 16 when
  #         m = mask(V, i, Nm1)
  #         vnoaliasstore!(ptry, f(vload.(ptrargs, ((MM{W}(i),),), m)...), (MM{W}(i,),), m)
  #         i = vadd_nw(i, W)
  #     end
  # else
  while i < vsub_nsw(N, (W - 1)) # stops at 16 when
    vᵣ = f(map1(vload, ptrargs, (MM{W}(i),))...)
    if NonTemporal
      _vstore!(ptry, vᵣ, (MM{W}(i),), True(), True(), True(), register_size())
    else
      _vstore!(ptry, vᵣ, (MM{W}(i),), False(), True(), False(), register_size())
    end
    i = vadd_nw(i, W)
  end
  if i < N
    m = mask(StaticInt(W), N & (W - 1))
    vfinal = f(map1(vload, ptrargs, (MM{W}(i),), m)...)
    if NonTemporal
      _vstore!(
        ptry,
        vfinal,
        (MM{W}(i),),
        m,
        True(),
        True(),
        False(),
        register_size()
      )
    else
      _vstore!(
        ptry,
        vfinal,
        (MM{W}(i),),
        m,
        False(),
        True(),
        False(),
        register_size()
      )
    end
  end
  # end
  nothing
end

abstract type AbstractVmapClosure{NonTemporal,F,D,N,A<:Tuple{Vararg{Any,N}}} <:
              Function end
struct VmapClosure{NonTemporal,F,D,N,A} <:
       AbstractVmapClosure{NonTemporal,F,D,N,A}
  f::F
  function VmapClosure{NonTemporal}(
    f::F,
    ::D,
    ::A
  ) where {NonTemporal,F,D,N,A<:Tuple{Vararg{Any,N}}}
    new{NonTemporal,F,D,N,A}(f)
  end
end
# struct VmapKnownClosure{NonTemporal,F,D,N,A} <: AbstractVmapClosure{NonTemporal,F,D,N,A} end

# @generated function (::VmapKnownClosure{NonTemporal,F,D,N,A})(p::Ptr{UInt})  where {NonTemporal,F,D,N,A}
#     :(_vmap_thread_call!($(F.instance), p, $D, $A, Val{$NonTemporal}()))
# end
function (m::VmapClosure{NonTemporal,F,D,N,A})(
  p::Ptr{UInt}
) where {NonTemporal,F,D,N,A}
  (offset, dest) = ThreadingUtilities.load(p, D, 2 * sizeof(UInt))
  (offset, args) = ThreadingUtilities.load(p, A, offset)

  (offset, start) = ThreadingUtilities.load(p, Int, offset)
  (offset, stop) = ThreadingUtilities.load(p, Int, offset)

  _vmap_singlethread!(m.f, dest, start, stop, Val{NonTemporal}(), args)
  NonTemporal && Threads.atomic_fence()
  ThreadingUtilities._atomic_store!(p, ThreadingUtilities.SPIN)
  nothing
end

@inline function _get_fptr(cfunc::Base.CFunction)
  Base.unsafe_convert(Ptr{Cvoid}, cfunc)
end
# @generated function _get_fptr(cfunc::F) where {F<:VmapKnownClosure}
#     precompile(F(), (Ptr{UInt},))
#     quote
#         $(Expr(:meta,:inline))
#         @cfunction($(F()), Cvoid, (Ptr{UInt},))
#     end
# end

@inline function setup_thread_vmap!(p, cfunc, ptry, ptrargs, start, stop)
  fptr = _get_fptr(cfunc)
  offset = ThreadingUtilities.store!(p, fptr, sizeof(UInt))
  offset = ThreadingUtilities.store!(p, ptry, offset)
  offset = ThreadingUtilities.store!(p, ptrargs, offset)
  offset = ThreadingUtilities.store!(p, start, offset)
  offset = ThreadingUtilities.store!(p, stop, offset)
  nothing
end
@inline function launch_thread_vmap!(tid, cfunc, ptry, ptrargs, start, stop)
  ThreadingUtilities.launch(
    tid,
    cfunc,
    ptry,
    ptrargs,
    start,
    stop
  ) do p, cfunc, ptry, ptrargs, start, stop
    setup_thread_vmap!(p, cfunc, ptry, ptrargs, start, stop)
  end
end

@inline function vmap_closure(
  f::F,
  ptry::D,
  ptrargs::A,
  ::Val{NonTemporal}
) where {F,D<:StridedPointer,N,A<:Tuple{Vararg{Any,N}},NonTemporal}
  vmc = VmapClosure{NonTemporal}(f, ptry, ptrargs)
  @cfunction($vmc, Cvoid, (Ptr{UInt},))
end

function vmap_multithread!(
  f::F,
  y::AbstractArray{T},
  ::Val{NonTemporal},
  args::Vararg{AbstractArray,A}
) where {F,T,A,NonTemporal}
  W, Wshift = VectorizationBase.pick_vector_width_shift(T)
  ptry, ptrargs, N = setup_vmap!(f, y, Val{NonTemporal}(), args...)
  # nt = min(Threads.nthreads(), VectorizationBase.SYS_CPU_THREADS, N >> (Wshift + 3))
  nt = min(Threads.nthreads(), num_cores(), N >> (Wshift + 5))

  # if !((nt > 1) && iszero(ccall(:jl_in_threaded_region, Cint, ())))
  if nt < 2
    _vmap_singlethread!(f, ptry, Zero(), N, Val{NonTemporal}(), ptrargs)
    return
  end

  cfunc = vmap_closure(f, ptry, ptrargs, Val{NonTemporal}())
  Nveciter = (N + (W - 1)) >> Wshift
  Nd, Nr = divrem(Nveciter, nt)
  NdW = Nd << Wshift
  NdWr = NdW + W
  GC.@preserve cfunc begin
    start = 0
    for tid ∈ 1:nt-1
      stop = start + ifelse(tid ≤ Nr, NdWr, NdW)
      launch_thread_vmap!(tid, cfunc, ptry, ptrargs, start, stop)
      start = stop
    end
    _vmap_singlethread!(f, ptry, start, N, Val{NonTemporal}(), ptrargs)
    for tid ∈ 1:nt-1
      ThreadingUtilities.wait(tid)
    end
  end
  nothing
end
function gc_preserve_call_quote(call, A::Int)
  q = Expr(:block, Expr(:meta, :inline))
  gcpres = Expr(:gc_preserve, call)
  for a ∈ 1:A
    arg = Symbol(:arg_, a)
    parg = Symbol(:parg_, a)
    push!(q.args, Expr(:(=), arg, :($getfield(args, $a))))
    push!(q.args, Expr(:(=), parg, Expr(:call, :preserve_buffer, arg)))
    push!(call.args, arg)
    push!(gcpres.args, parg)
  end
  push!(q.args, gcpres)
  q
end
function gc_preserve_vmap_quote(NonTemporal::Bool, Threaded::Bool, A::Int)
  m = Threaded ? :vmap_multithread! : :vmap_singlethread!
  call = Expr(:call, m, :f, :y, Expr(:call, Expr(:curly, :Val, NonTemporal)))
  q = gc_preserve_call_quote(call, A)
  push!(q.args, :y)
  q
end
@generated function gc_preserve_vmap!(
  f::F,
  y::AbstractArray,
  ::Val{NonTemporal},
  ::Val{Threaded},
  args::Vararg{AbstractArray,A}
) where {F,A,NonTemporal,Threaded}
  gc_preserve_vmap_quote(NonTemporal, Threaded, A)
end

@inline _all_dense(t::Tuple{ArrayInterface.True}) = true
@inline _all_dense(t::Tuple{ArrayInterface.True,ArrayInterface.True,Vararg}) =
  _all_dense(Base.tail(t))
@inline _all_dense(t::Tuple{ArrayInterface.True,ArrayInterface.False,Vararg}) =
  false
@inline _all_dense(t::Tuple{ArrayInterface.False,Vararg}) = false
@inline all_dense() = true
@inline all_dense(t::NTuple{N}) where {N} = true
@inline all_dense(A::Array) = true
@inline all_dense(A::AbstractArray) = _all_dense(ArrayInterface.dense_dims(A))
@inline all_dense(
  A::AbstractArray,
  B::AbstractArray,
  C::Vararg{AbstractArray,K}
) where {K} = all_dense(A) && all_dense(B, C...)

"""
    vmap!(f, destination, a::AbstractArray)
    vmap!(f, destination, a::AbstractArray, b::AbstractArray, ...)

Vectorized-`map!`, applying `f` to batches of elements of `a` (or paired batches of `a`, `b`, ...)
and storing the result in `destination`.

The function `f` must accept `VectorizationBase.AbstractSIMD` inputs. Ideally, all this requires
is making sure that `f` is defined to be agnostic with respect to input types, but if the function `f`
contains branches or loops, more work will probably be needed. For example, a function

```julia
f(x) = x > 0 ? log(x) : inv(x)
```

can be rewritten into

```julia
using IfElse
f(x) = IfElse.ifelse(x > 0, log(x), inv(x))
```
"""
function vmap!(
  f::F,
  y::AbstractArray,
  arg1::AbstractArray,
  arg2::AbstractArray,
  args::Vararg{AbstractArray,A}
) where {F,A}
  if check_args(y, arg1, arg2, args...) && all_dense(y, arg1, arg2, args...)
    gc_preserve_vmap!(f, y, Val{false}(), Val{false}(), arg1, arg2, args...)
  else
    map!(f, y, arg1, arg2, args...)
  end
end
function vmap!(f::F, y::AbstractArray, arg::AbstractArray) where {F}
  if check_args(y, arg) && all_dense(y, arg)
    gc_preserve_vmap!(f, y, Val{false}(), Val{false}(), arg)
  else
    map!(f, y, arg)
  end
end

"""
    vmapt!(::Function, dest, args...)

A threaded variant of [`vmap!`](@ref).
"""
function vmapt!(
  f::F,
  y::AbstractArray,
  args::Vararg{AbstractArray,A}
) where {F,A}
  if check_args(y, args...) && all_dense(y, args...)
    gc_preserve_vmap!(f, y, Val{false}(), Val{true}(), args...)
  else
    map!(f, y, args...)
  end
end

"""
    vmapnt!(::Function, dest, args...)

This is a vectorized map implementation using nontemporal store operations. This means that the write operations to the destination will not go to the CPU's cache.
If you will not immediately be reading from these values, this can improve performance because the writes won't pollute your cache. This can especially be the case if your arguments are very long.

```julia
julia> f(x, y) = exp(-0.5abs2(x - y))
using LoopVectorization, BenchmarkTools

julia> @benchmark map!(f, \$z, \$x, \$y)
x = rand(10^8); y = rand(10^8); z = similar(x);

julia> @benchmark vmap!(f, \$z, \$x, \$y)
f (generic function with 1 method)

julia> @benchmark vmapnt!(f, \$z, \$x, \$y)
BenchmarkTools.Trial:
  memory estimate:  0 bytes
  allocs estimate:  0
  --------------
  minimum time:     439.613 ms (0.00% GC)
  median time:      440.729 ms (0.00% GC)
  mean time:        440.695 ms (0.00% GC)
  maximum time:     441.665 ms (0.00% GC)
  --------------
  samples:          12
  evals/sample:     1
```
"""
function vmapnt!(
  f::F,
  y::AbstractArray,
  args::Vararg{AbstractArray,A}
) where {F,A}
  if check_args(y, args...) && all_dense(y, args...)
    gc_preserve_vmap!(f, y, Val{true}(), Val{false}(), args...)
  else
    map!(f, y, args...)
  end
end

"""
    vmapntt!(::Function, dest, args...)

A threaded variant of [`vmapnt!`](@ref).
"""
function vmapntt!(
  f::F,
  y::AbstractArray,
  args::Vararg{AbstractArray,A}
) where {F,A}
  if check_args(y, args...) && all_dense(y, args...)
    gc_preserve_vmap!(f, y, Val{true}(), Val{true}(), args...)
  else
    map!(f, y, args...)
  end
end

# generic fallbacks
@inline vmap!(f, args...) = map!(f, args...)
@inline vmapt!(f, args...) = map!(f, args...)
@inline vmapnt!(f, args...) = map!(f, args...)
@inline vmapntt!(f, args...) = map!(f, args...)

# similar_bit(x, ::Type{T}) where {T} = similar(x, T)
# similar_bit(x, ::Type{Bool}) = BitArray(undef, size(x))

function vmap_call(f::F, vm!::V, args::Vararg{Any,N}) where {V,F,N}
  T = Base._return_type(f, Base.Broadcast.eltypes(args))
  dest = similar(first(args), T)
  # dest = similar_bit(first(args), T)
  vm!(f, dest, args...)
end

"""
    vmap(f, a::AbstractArray)
    vmap(f, a::AbstractArray, b::AbstractArray, ...)

SIMD-vectorized `map`, applying `f` to each element of `a` (or paired elements of `a`, `b`, ...)
and returning a new array.
"""
vmap(f::F, args::Vararg{Any,N}) where {F,N} = vmap_call(f, vmap!, args...)

"""
    vmapt(f, a::AbstractArray)
    vmapt(f, a::AbstractArray, b::AbstractArray, ...)

A threaded variant of [`vmap`](@ref).
"""
vmapt(f::F, args::Vararg{Any,N}) where {F,N} = vmap_call(f, vmapt!, args...)

"""
    vmapnt(f, a::AbstractArray)
    vmapnt(f, a::AbstractArray, b::AbstractArray, ...)

A "non-temporal" variant of [`vmap`](@ref). This can improve performance in cases where
`destination` will not be needed soon.
"""
vmapnt(f::F, args::Vararg{Any,N}) where {F,N} = vmap_call(f, vmapnt!, args...)

"""
    vmapntt(f, a::AbstractArray)
    vmapntt(f, a::AbstractArray, b::AbstractArray, ...)

A threaded variant of [`vmapnt`](@ref).
"""
vmapntt(f::F, args::Vararg{Any,N}) where {F,N} = vmap_call(f, vmapntt!, args...)

@testset "Special Functions" begin
  vexpq = :(
    for i ∈ eachindex(a)
      b[i] = exp(a[i])
    end
  )
  lsvexp = LoopVectorization.loopset(vexpq)
  if Sys.ARCH === :aarch64
    # returned `4` on an M1...
    @test LoopVectorization.choose_order(lsvexp) ==
          (Symbol[:i], :i, Symbol("##undefined##"), :i, 4, -1)
  else
    @test LoopVectorization.choose_order(lsvexp) ==
          (Symbol[:i], :i, Symbol("##undefined##"), :i, 2, -1)
  end

  function myvexp!(b, a)
    @inbounds for i ∈ eachindex(a)
      b[i] = exp(a[i])
    end
  end
  function myvexpavx!(b, a)
    @turbo for i ∈ eachindex(a)
      b[i] = Base.exp(a[i])
    end
  end
  function myvexp_avx!(b, a)
    @_avx for i ∈ eachindex(a)
      b[i] = exp(a[i])
    end
  end
  function offset_exp!(A, B)
    @turbo for i = 1:size(A, 1), j = 1:size(B, 2)
      A[i, j] = exp(B[i, j])
    end
  end
  function offset_expavx!(A, B)
    @turbo for i = 1:size(A, 1), j = 1:size(B, 2)
      A[i, j] = exp(B[i, j])
    end
  end
  function offset_exp_avx!(A, B)
    @_avx for i = 1:size(A, 1), j = 1:size(B, 2)
      A[i, j] = exp(B[i, j])
    end
  end

  vexpsq = :(
    for i ∈ eachindex(a)
      s += exp(a[i])
    end
  )
  lsvexps = LoopVectorization.loopset(vexpsq)
  @test LoopVectorization.choose_order(lsvexps) ==
        (Symbol[:i], :i, Symbol("##undefined##"), :i, 4, -1)

  function myvexp(a)
    s = zero(eltype(a))
    @inbounds for i ∈ eachindex(a)
      s += exp(a[i])
    end
    s
  end
  function myvexpavx(a)
    s = zero(eltype(a))
    @turbo for i ∈ eachindex(a)
      s += exp(a[i])
    end
    s
  end

  function myvexp_avx(a)
    s = zero(eltype(a))
    @_avx for i ∈ eachindex(a)
      s += exp(a[i])
    end
    s
  end
  function trianglelogdetavx(L)
    ld = zero(eltype(L))
    @turbo for i ∈ 1:size(L, 1)
      ld += log(L[i, i])
    end
    ld
  end
  function trianglelogdet_avx(L)
    ld = zero(eltype(L))
    @_avx for i ∈ 1:size(L, 1)
      ld += log(L[i, i])
    end
    ld
  end
  function testrepindshigherdim_avx(L)
    ld = zero(eltype(L))
    @_avx for i ∈ axes(L, 1), j ∈ axes(L, 2)
      ld += log(L[i, j, i])
    end
    ld
  end
  function testrepindshigherdimavx(L)
    ld = zero(eltype(L))
    @turbo for i ∈ axes(L, 1), j ∈ axes(L, 2)
      ld += log(L[i, j, i])
    end
    ld
  end
  ldq = :(
    for i ∈ 1:size(L, 1)
      ld += log(L[i, i])
    end
  )
  lsld = LoopVectorization.loopset(ldq)
  @test LoopVectorization.choose_order(lsld) ==
        (Symbol[:i], :i, Symbol("##undefined##"), :i, 4, -1)

  function calc_sins!(res::AbstractArray{T}) where {T}
    code_phase_delta = T(0.01)
    @inbounds for i ∈ eachindex(res)
      res[i] = sin(i * code_phase_delta)
    end
  end
  function calc_sinsavx!(res::AbstractArray{T}) where {T}
    code_phase_delta = T(0.01)
    @turbo for i ∈ eachindex(res)
      res[i] = sin(i * code_phase_delta)
    end
  end
  function calc_sins_avx!(res::AbstractArray{T}) where {T}
    code_phase_delta = T(0.01)
    @_avx for i ∈ eachindex(res)
      res[i] = sin(i * code_phase_delta)
    end
  end

  function logsumexp!(r::AbstractArray{T}, x::AbstractArray{T}) where {T}
    n = length(x)
    length(r) == n || throw(DimensionMismatch())
    isempty(x) && return -T(Inf)
    1 == LinearAlgebra.stride1(r) == LinearAlgebra.stride1(x) ||
      throw(error("Arrays not strided"))

    u = maximum(x)                                       # max value used to re-center
    abs(u) == Inf && return any(isnan, x) ? T(NaN) : u   # check for non-finite values
    s = zero(T)
    @inbounds for i = 1:n
      tmp = exp(x[i] - u)
      r[i] = tmp
      s += tmp
    end
    invs = inv(s)
    r .*= invs

    return log1p(s - 1) + u
  end
  function logsumexpavx!(r::AbstractArray{T}, x::AbstractArray{T}) where {T}
    n = length(x)
    length(r) == n || throw(DimensionMismatch())
    isempty(x) && return -T(Inf)
    1 == LinearAlgebra.stride1(r) == LinearAlgebra.stride1(x) ||
      throw(error("Arrays not strided"))

    u = maximum(x)                                       # max value used to re-center
    abs(u) == Inf && return any(isnan, x) ? T(NaN) : u   # check for non-finite values
    s = zero(T)
    @turbo for i = 1:n
      tmp = exp(x[i] - u)
      r[i] = tmp
      s += tmp
    end

    invs = inv(s)
    r .*= invs

    return log1p(s - 1) + u
  end
  function logsumexp_avx!(r::AbstractArray{T}, x::AbstractArray{T}) where {T}
    n = length(x)
    length(r) == n || throw(DimensionMismatch())
    isempty(x) && return -T(Inf)
    1 == LinearAlgebra.stride1(r) == LinearAlgebra.stride1(x) ||
      throw(error("Arrays not strided"))

    u = maximum(x)                                       # max value used to re-center
    abs(u) == Inf && return any(isnan, x) ? T(NaN) : u   # check for non-finite values
    s = zero(T)
    @_avx for i = 1:n
      tmp = exp(x[i] - u)
      r[i] = tmp
      s += tmp
    end

    invs = inv(s)
    r .*= invs

    return log1p(s - 1) + u
  end
  # feq = :(for i = 1:n
  #         tmp = exp(x[i] - u)
  #         r[i] = tmp
  #         s += tmp
  #         end)
  # lsfeq = LoopVectorization.loopset(feq);
  # # lsfeq.operations

  function vpow0!(y, x)
    @turbo for i ∈ eachindex(y, x)
      y[i] = x[i]^0
    end
    y
  end
  function vpown1!(y, x)
    @turbo for i ∈ eachindex(y, x)
      y[i] = x[i]^-1
    end
    y
  end
  function vpow1!(y, x)
    @turbo for i ∈ eachindex(y, x)
      y[i] = x[i]^1
    end
    y
  end
  function vpown2!(y, x)
    @turbo for i ∈ eachindex(y, x)
      y[i] = x[i]^-2
    end
    y
  end
  function vpow2!(y, x)
    @turbo for i ∈ eachindex(y, x)
      y[i] = x[i]^2
    end
    y
  end
  function vpown3!(y, x)
    @turbo for i ∈ eachindex(y, x)
      y[i] = x[i]^-3
    end
    y
  end
  function vpow3!(y, x)
    @turbo for i ∈ eachindex(y, x)
      y[i] = x[i]^3
    end
    y
  end
  function vpown4!(y, x)
    @turbo for i ∈ eachindex(y, x)
      y[i] = x[i]^-4
    end
    y
  end
  function vpow4!(y, x)
    @turbo for i ∈ eachindex(y, x)
      y[i] = x[i]^4
    end
    y
  end
  function vpown5!(y, x)
    @turbo for i ∈ eachindex(y, x)
      y[i] = x[i]^-5
    end
    y
  end
  q = :(
    for i ∈ eachindex(y, x)
      y[i] = x[i]^-5
    end
  )
  ls = LoopVectorization.loopset(q)
  q2 = :(
    for i ∈ eachindex(y, x)
      y[i] = x[i]^5
    end
  )
  ls2 = LoopVectorization.loopset(q2)

  function vpow5!(y, x)
    @turbo for i ∈ eachindex(y, x)
      y[i] = x[i]^5
    end
    y
  end
  function vpowf!(y, x)
    @turbo for i ∈ eachindex(y, x)
      y[i] = x[i]^2.3
    end
    y
  end
  function vpowf!(y, x, p::Number)
    @turbo for i ∈ eachindex(y, x)
      y[i] = x[i]^p
    end
    y
  end
  function vpowf!(y, x, p::AbstractArray)
    @turbo for i ∈ eachindex(y, x)
      y[i] = x[i]^p[i]
    end
    y
  end
  @generated function vpow!(y, x, ::Val{p}) where {p}
    quote
      @turbo for i ∈ eachindex(y, x)
        y[i] = x[i]^$p
      end
      return y
    end
  end

  function csetanh!(y, z, x)
    for j in axes(x, 2)
      for i in axes(x, 1)
        t2 = inv(tanh(x[i, j]))
        t1 = tanh(x[i, j])
        y[i, j] = z[i, j] * (-(1 - t1^2) * t2)
      end
    end
    y
  end
  function csetanhavx!(y, z, x)
    @turbo for j in axes(x, 2)
      for i in axes(x, 1)
        t2 = inv(tanh(x[i, j]))
        t1 = tanh(x[i, j])
        y[i, j] = z[i, j] * (-(1 - t1^2) * t2)
      end
    end
    y
  end

  function transposedvectoraccess(x::AbstractVector{T}) where {T}
    N = length(x)
    ent = zeros(T, N)
    x isa AbstractVector && (x = x')
    for i = 1:N, j = 1:size(x, 1)
      ent[i] += x[j, i] * log(x[j, i])
    end
    ent
  end
  function transposedvectoraccessavx(x::AbstractVector{T}) where {T}
    N = length(x)
    ent = zeros(T, N)
    x isa AbstractVector && (x = x')
    @turbo for i = 1:N, j = 1:size(x, 1)
      ent[i] += x[j, i] * log(x[j, i])
    end
    ent
  end

  function vsincos(x)
    y = Matrix{eltype(x)}(undef, length(x), 2)
    for i in eachindex(x)
      y[i, 1], y[i, 2] = sincos(x[i])
    end
    return y
  end
  function vsincosavx(x)
    y = Matrix{eltype(x)}(undef, length(x), 2)
    @turbo for i in eachindex(x)
      y[i, 1], y[i, 2] = sincos(x[i])
    end
    return y
  end
  function sincosdot(x)
    a = zero(eltype(x))
    for i ∈ eachindex(x)
      s, c = sincos(x[i])
      a += s * c
    end
    a
  end
  function sincosdotavx(x)
    a = zero(eltype(x))
    @turbo for i ∈ eachindex(x)
      s, c = sincos(x[i])
      a += s * c
    end
    a
  end

  function sin_sum_3loop!(u, x, y, z)
    @turbo for k = 1:length(z)
      for j = 1:length(y)
        for i = 1:length(x)
          u[i, j, k] = sin(x[i]) + sin(y[j]) + sin(z[k])
        end
      end
    end
  end
  function sin_sum_3loop_split!(u, x, y, z)
    sx = similar(x)
    sy = similar(y)
    sz = similar(z)
    @turbo for k = 1:length(z)
      for j = 1:length(y)
        for i = 1:length(x)
          sxi = sin(x[i])
          syj = sin(y[j])
          szk = sin(z[k])
          sx[i] = sxi
          sy[j] = syj
          sz[k] = szk
          u[i, j, k] = sxi + syj + szk
        end
      end
    end
  end

  for T ∈ (Float32, Float64)
    @show T, @__LINE__
    a = randn(T, 127)
    b1 = similar(a)
    b2 = similar(a)

    myvexp!(b1, a)
    myvexpavx!(b2, a)
    @test b1 ≈ b2
    fill!(b2, -999.9)
    myvexp_avx!(b2, a)
    @test b1 ≈ b2
    s = myvexp(a)
    @test s ≈ myvexpavx(a)
    @test s ≈ myvexp_avx(a)
    @test b1 ≈ @turbo exp.(a)

    @test vsincos(a) ≈ vsincosavx(a)
    @test sincosdot(a) ≈ sincosdotavx(a)

    A = rand(T, 73, 73)
    ld = logdet(UpperTriangular(A))
    @test ld ≈ trianglelogdetavx(A)
    @test ld ≈ trianglelogdet_avx(A)
    Adim3 = rand(T, 37, 13, 37)
    ld = sum(i -> logdet(UpperTriangular(@view(Adim3[:, i, :]))), axes(Adim3, 2))
    @test ld ≈ testrepindshigherdimavx(Adim3)
    @test ld ≈ testrepindshigherdim_avx(Adim3)

    x = rand(T, 999)
    r1 = similar(x)
    r2 = similar(x)
    lse = logsumexp!(r1, x)
    @test logsumexpavx!(r2, x) ≈ lse
    @test r1 ≈ r2
    fill!(r2, T(NaN))
    @test logsumexp_avx!(r2, x) ≈ lse
    @test r1 ≈ r2

    calc_sins!(r1)
    calc_sinsavx!(r2)
    @test r1 ≈ r2
    fill!(r2, NaN)
    calc_sins_avx!(r2)
    @test r1 ≈ r2

    N, M = 47, 53
    B = reshape(cumsum(ones(T, 3N)), N, :)
    A1 = zeros(T, N, M)
    A2 = zeros(T, N, M)
    offset_exp!(A1, B)
    offset_expavx!(A2, B)
    @test A1 ≈ A2
    fill!(A2, 0)
    offset_exp_avx!(A2, B)
    @test A1 ≈ A2



    @test all(isone, vpow0!(r1, x))
    @test vpown1!(r1, x) ≈ map!(inv, r2, x)
    @test vpow1!(r1, x) == x
    @test vpown2!(r1, x) ≈ map!(abs2 ∘ inv, r2, x)
    @test vpow2!(r1, x) ≈ map!(abs2, r2, x)
    @test vpown3!(r1, x) ≈ (r2 .= x .^ -3)
    @test vpow3!(r1, x) ≈ (r2 .= x .^ 3)
    @test vpown4!(r1, x) ≈ (r2 .= x .^ -4)
    @test vpow4!(r1, x) ≈ (r2 .= x .^ 4)
    @test vpown5!(r1, x) ≈ (r2 .= x .^ -5)
    @test vpow5!(r1, x) ≈ (r2 .= x .^ 5)
    @test vpowf!(r1, x) ≈ (r2 .= x .^ 2.3)
    @test vpowf!(r1, x, -1.7) ≈ (r2 .= x .^ -1.7)
    p = randn(length(x))
    @test vpowf!(r1, x, x) ≈ (r2 .= x .^ x)
    @test vpow!(r1, x, Val(0.75)) ≈ (r2 .= x .^ 0.75)
    @test vpow!(r1, x, Val(2 / 3)) ≈ (r2 .= x .^ (2 / 3))
    # TODO: find out why these do not match exactly
    vpow!(r1, x, Val(0.5))
    r2 .= Base.sqrt_llvm.(x)
    # if Bool(!LoopVectorization.VectorizationBase.has_feature(Val(:x86_64_avx2)))
    for i ∈ eachindex(x)
      # @test abs(r1[i] - r2[i]) ≤ eps(r1[i])
      @test abs(r1[i] - r2[i]) ≤ 3eps(r1[i])
    end
    # else
    #   @test r1 == r2
    # end
    @test vpow!(r1, x, Val(1 / 4)) ≈ (r2 .= x .^ (1 / 4))
    @test vpow!(r1, x, Val(4.5)) ≈ (r2 .= x .^ 4.5)

    X = rand(T, N, M)
    Z = rand(T, N, M)
    Y1 = similar(X)
    Y2 = similar(Y1)
    @test csetanh!(Y1, X, Z) ≈ csetanhavx!(Y2, X, Z)

    x = rand(T, 97)
    @test transposedvectoraccessavx(x) ≈ transposedvectoraccess(x)

    itot = 47
    dx = 1.0 / itot
    x = dx * collect(0:itot-1)
    y = dx * collect(0:itot-1)
    z = dx * collect(0:itot-1)
    u = zeros(itot + 8, itot + 8, itot + 8)
    uv = @view u[5:5+itot-1, 5:5+itot-1, 5:5+itot-1]
    sin_sum_3loop!(uv, x, y, z)
    uv2 = @view similar(u)[5:5+itot-1, 5:5+itot-1, 5:5+itot-1]
    sin_sum_3loop_split!(uv2, x, y, z)
    @test uv ≈
          uv2 ≈
          (identity(sin.(x)) .+ identity((sin.(y))')) .+
          identity(reshape(sin.(z), (1, 1, length(z))))
  end
end

module looptests

  use ISO_C_BINDING

  implicit none

  contains

    subroutine gemm_mnk(C, A, B, M, K, N) BIND(C, name="gemm_mnk")
      integer(C_long), intent(in) :: M, K, N
      real(C_double), dimension(M, N), intent(out) :: C
      real(C_double), dimension(M, K), intent(in) :: A
      real(C_double), dimension(K, N), intent(in) :: B
      integer(C_long) :: mm, kk, nn
      C = 0.0
      do concurrent(mm = 1:M, nn = 1:N, kk = 1:K)
          C(mm,nn) = C(mm,nn) + A(mm,kk) * B(kk,nn)
      end do
    end subroutine gemm_mnk
    subroutine gemm_mkn(C, A, B, M, K, N) BIND(C, name="gemm_mkn")
      integer(C_long), intent(in) :: M, K, N
      real(C_double), dimension(M, N), intent(out) :: C
      real(C_double), dimension(M, K), intent(in) :: A
      real(C_double), dimension(K, N), intent(in) :: B
      integer(C_long) :: mm, kk, nn
      C = 0.0
      do concurrent(mm = 1:M, kk = 1:K, nn = 1:N)
          C(mm,nn) = C(mm,nn) + A(mm,kk) * B(kk,nn)
      end do
    end subroutine gemm_mkn
    subroutine gemm_nmk(C, A, B, M, K, N) BIND(C, name="gemm_nmk")
      integer(C_long), intent(in) :: M, K, N
      real(C_double), dimension(M, N), intent(out) :: C
      real(C_double), dimension(M, K), intent(in) :: A
      real(C_double), dimension(K, N), intent(in) :: B
      integer(C_long) :: mm, kk, nn
      C = 0.0
      do concurrent(nn = 1:N, mm = 1:M, kk = 1:K)
          C(mm,nn) = C(mm,nn) + A(mm,kk) * B(kk,nn)
      end do
    end subroutine gemm_nmk
    subroutine gemm_nkm(C, A, B, M, K, N) BIND(C, name="gemm_nkm")
      integer(C_long), intent(in) :: M, K, N
      real(C_double), dimension(M, N), intent(out) :: C
      real(C_double), dimension(M, K), intent(in) :: A
      real(C_double), dimension(K, N), intent(in) :: B
      integer(C_long) :: mm, kk, nn
      C = 0.0
      do concurrent(kk = 1:K, nn = 1:N, mm = 1:M)
          C(mm,nn) = C(mm,nn) + A(mm,kk) * B(kk,nn)
      end do
    end subroutine gemm_nkm
    subroutine gemm_kmn(C, A, B, M, K, N) BIND(C, name="gemm_kmn")
      integer(C_long), intent(in) :: M, K, N
      real(C_double), dimension(M, N), intent(out) :: C
      real(C_double), dimension(M, K), intent(in) :: A
      real(C_double), dimension(K, N), intent(in) :: B
      integer(C_long) :: mm, kk, nn
      C = 0.0
      do concurrent(kk = 1:K, mm = 1:M, nn = 1:N)
          C(mm,nn) = C(mm,nn) + A(mm,kk) * B(kk,nn)
      end do
    end subroutine gemm_kmn
    subroutine gemm_knm(C, A, B, M, K, N) BIND(C, name="gemm_knm")
      integer(C_long), intent(in) :: M, K, N
      real(C_double), dimension(M, N), intent(out) :: C
      real(C_double), dimension(M, K), intent(in) :: A
      real(C_double), dimension(K, N), intent(in) :: B
      integer(C_long) :: mm, kk, nn
      C = 0.0
      do concurrent(kk = 1:K, nn = 1:N, mm = 1:M)
         C(mm,nn) = C(mm,nn) + A(mm,kk) * B(kk,nn)
      end do
    end subroutine gemm_knm
    subroutine gemmbuiltin(C, A, B, M, K, N) BIND(C, name="gemmbuiltin")
      integer(C_long), intent(in) :: M, K, N
      real(C_double), dimension(M, N), intent(out) :: C
      real(C_double), dimension(M, K), intent(in) :: A
      real(C_double), dimension(K, N), intent(in) :: B
      C = matmul(A, B)
    end subroutine gemmbuiltin
    subroutine AtmulB(C, A, B, M, K, N) BIND(C, name="AtmulB")
      integer(C_long), intent(in) :: M, K, N
      real(C_double), dimension(M, N), intent(out) :: C
      real(C_double), dimension(K, M), intent(in) :: A
      real(C_double), dimension(K, N), intent(in) :: B
      integer(C_long) :: mm, kk, nn
      C = 0.0
      do concurrent(nn = 1:N, mm = 1:M, kk = 1:K)
          C(mm,nn) = C(mm,nn) + A(kk,mm) * B(kk,nn)
      end do
    end subroutine AtmulB
    subroutine AtmulBbuiltin(C, A, B, M, K, N) BIND(C, name="AtmulBbuiltin")
      integer(C_long), intent(in) :: M, K, N
      real(C_double), dimension(M, N), intent(out) :: C
      real(C_double), dimension(K, M), intent(in) :: A
      real(C_double), dimension(K, N), intent(in) :: B
      C = matmul(transpose(A), B)
    end subroutine AtmulBbuiltin
    subroutine AmulBt(C, A, B, M, K, N) BIND(C, name="AmulBt")
      integer(C_long), intent(in) :: M, K, N
      real(C_double), dimension(M, N), intent(out) :: C
      real(C_double), dimension(M, K), intent(in) :: A
      real(C_double), dimension(N, K), intent(in) :: B
      integer(C_long) :: mm, kk, nn
      C = 0.0d0
      do concurrent(kk = 1:K, nn = 1:N, mm = 1:M)
         C(mm,nn) = C(mm,nn) + A(mm,kk) * B(nn,kk)
      end do
    end subroutine AmulBt
    subroutine AmulBtbuiltin(C, A, B, M, K, N) BIND(C, name="AmulBtbuiltin")
      integer(C_long), intent(in) :: M, K, N
      real(C_double), dimension(M, N), intent(out) :: C
      real(C_double), dimension(M, K), intent(in) :: A
      real(C_double), dimension(N, K), intent(in) :: B
      C = matmul(A, transpose(B))
    end subroutine AmulBtbuiltin
    subroutine AtmulBt(C, A, B, M, K, N) BIND(C, name="AtmulBt")
      integer(C_long), intent(in) :: M, K, N
      real(C_double), dimension(M, N), intent(out) :: C
      real(C_double), dimension(K, M), intent(in) :: A
      real(C_double), dimension(N, K), intent(in) :: B
      integer(C_long) :: mm, kk, nn
      C = 0.0d0
      do concurrent(nn = 1:N, kk = 1:K, mm = 1:M)
         C(mm,nn) = C(mm,nn) + A(kk,mm) * B(nn,kk)
      end do
    end subroutine AtmulBt
    subroutine AtmulBtbuiltin(C, A, B, M, K, N) BIND(C, name="AtmulBtbuiltin")
      integer(C_long), intent(in) :: M, K, N
      real(C_double), dimension(M, N), intent(out) :: C
      real(C_double), dimension(K, M), intent(in) :: A
      real(C_double), dimension(N, K), intent(in) :: B
      C = transpose(matmul(B, A))
    end subroutine AtmulBtbuiltin
    real(C_double) function dot(a, b, N) BIND(C, name="dot")
      integer(C_long), intent(in) :: N
      real(C_double), dimension(N), intent(in) :: a, b
      integer(C_long) :: i
      dot = 0d0
      do concurrent(i = 1:N)
         dot = dot + a(i) * b(i)
      end do
    end function dot
    real(C_double) function selfdot(a, N) BIND(C, name="selfdot")
      integer(C_long), intent(in) :: N
      real(C_double), dimension(N), intent(in) :: a
      integer(C_long) :: i
      selfdot = 0d0
      do concurrent(i = 1:N)
         selfdot = selfdot + a(i) * a(i)
      end do
    end function selfdot
    real(C_double) function dot3v2(x, A, y, M, N) BIND(C, name="dot3v2")
      integer(C_long), intent(in) :: M, N
      real(C_double), intent(in) :: x(M), A(M,N), y(N)
      real(C_double) :: t
      integer(C_long) :: mm, nn
      dot3v2 = 0.0d0
      do concurrent(nn = 1:N, mm = 1:M)
         dot3v2 = dot3v2 + x(mm) * A(mm, nn) * y(nn)
      end do
    end function dot3v2
    real(C_double) function dot3(x, A, y, M, N) BIND(C, name="dot3")
      integer(C_long), intent(in) :: M, N
      real(C_double), intent(in) :: x(M), A(M,N), y(N)
      real(C_double) :: t
      integer(C_long) :: mm, nn
      dot3 = 0.0d0
      do concurrent(nn = 1:N)
         t = 0.0d0
         do concurrent(mm = 1:M)
            t = t + x(mm) * A(mm, nn)
         end do
         dot3 = dot3 + t * y(nn)
      end do
    end function dot3
    real(C_double) function dot3builtin(x, A, y, M, N) BIND(C, name="dot3builtin")
      integer(C_long), intent(in) :: M, N
      real(C_double), intent(in) :: x(M), A(M,N), y(N)
      dot3builtin = dot_product(x, matmul(A, y))
    end function dot3builtin
    !GCC$ builtin (exp) attributes simd (notinbranch) if('x86_64')
    subroutine vexp(b, a, N) BIND(C, name="vexp")
      integer(C_long), intent(in) :: N
      real(C_double), dimension(N), intent(in) :: a
      real(C_double), dimension(N), intent(out) :: b
      integer(C_long) :: i
      do concurrent(i = 1:N)
         b(i) = exp(a(i))
      end do
    end subroutine vexp
    real(C_double) function svexp(a, N) BIND(C, name="svexp")
      integer(C_long), intent(in) :: N
      real(C_double), dimension(N), intent(in) :: a
      integer(C_long) :: i
      svexp = 0
      do concurrent(i = 1:N)
         svexp = svexp + exp(a(i))
      end do
    end function svexp
    subroutine gemv(y, A, x, M, K) BIND(C, name="gemv")
      integer(C_long), intent(in) :: M, K
      real(C_double), intent(in) :: A(M,K), x(K)
      real(C_double), dimension(M), intent(out) :: y
      integer(C_long) :: mm, kk
      y = 0.0
      do concurrent(kk = 1:K, mm = 1:M)
         y(mm) = y(mm) + A(mm,kk) * x(kk)
      end do
    end subroutine gemv
    subroutine gemvbuiltin(y, A, x, M, K) BIND(C, name="gemvbuiltin")
      integer(C_long), intent(in) :: M, K
      real(C_double), intent(in) :: A(M,K), x(K)
      real(C_double), dimension(M), intent(out) :: y
      y = matmul(A, x)
    end subroutine gemvbuiltin
    subroutine Atmulvb(y, A, x, M, K) BIND(C, name="Atmulvb")
      integer(C_long), intent(in) :: M, K
      real(C_double), intent(in) :: A(K,M), x(K)
      real(C_double), dimension(M), intent(out) :: y
      integer(C_long) :: mm, kk
      real(C_double) :: ymm
      y = 0
      do concurrent(mm = 1:M, kk = 1:K)
          y(mm) = y(mm) + A(kk,mm) * x(kk)
      end do
    end subroutine Atmulvb
    subroutine Atmulvbbuiltin(y, A, x, M, K) BIND(C, name="Atmulvbbuiltin")
      integer(C_long), intent(in) :: M, K
      real(C_double), intent(in) :: A(K,M), x(1,K)
      real(C_double), dimension(1,M), intent(out) :: y
      ! y = matmul(transpose(A), x)
      y = matmul(x, A)
    end subroutine Atmulvbbuiltin
    subroutine unscaledvar(s, A, x, M, N) BIND(C, name="unscaledvar")
      integer(C_long), intent(in) :: M, N
      real(C_double), intent(in) :: A(M,N), x(M)
      real(C_double), dimension(M), intent(out) :: s
      integer(C_long) :: mm, nn
      real(C_double) :: d
      s = 0.0
      do concurrent(nn = 1:N, mm = 1:M)
         d = A(mm,nn) - x(mm)
         s(mm) = s(mm) + d * d
      end do
    end subroutine unscaledvar
    subroutine aplusBc(D, a, B, c, M, N) BIND(C, name="aplusBc")
      integer(C_long), intent(in) :: M, N
      real(C_double), intent(in) :: a(M), B(M,N), c(N)
      real(C_double), dimension(M,N), intent(out) :: D
      integer(C_long) :: mm, nn
      do concurrent(nn = 1:N, mm = 1:M)
         D(mm,nn) = a(mm) + B(mm,nn) * c(nn)
      end do
    end subroutine aplusBc
    real(C_double) function OLSlp(y, X, b, N, P) BIND(C, name="OLSlp")
      integer(C_long), intent(in) :: N, P
      real(C_double), intent(in) :: y(N), X(N, P), b(P)
      integer(C_long) :: nn, pp
      real(C_double) :: d
      OLSlp = 0
      do concurrent(nn = 1:N)
         d = y(nn)
         do concurrent(pp = 1:P)
            d = d - X(nn,pp) * b(pp)
         end do
         OLSlp = OLSlp + d*d
      end do
    end function OLSlp
    real(C_double) function OLSlpsplit(y, X, b, N, P) BIND(C, name="OLSlpsplit")
      integer(C_long), intent(in) :: N, P
      real(C_double), intent(in) :: y(N), X(N, P), b(P)
      integer(C_long) :: nn, pp
      real(C_double) :: d(N)
      d = y - matmul(X, b)
      OLSlpsplit = dot_product(d, d)
    end function OLSlpsplit
    subroutine AplusAt(B, A, N) BIND(C, name="AplusAt")
      integer(C_long), intent(in) :: N
      real(C_double), dimension(N,N), intent(out) :: B
      real(C_double), dimension(N,N), intent(in) :: A
      integer(C_long) :: i, j
      do concurrent(i = 1:N, j = 1:N)
         B(j,i) = A(j,i) + A(i,j)
      end do
    end subroutine AplusAt
    subroutine AplusAtbuiltin(B, A, N) BIND(C, name="AplusAtbuiltin")
      integer(C_long), intent(in) :: N
      real(C_double), dimension(N,N), intent(out) :: B
      real(C_double), dimension(N,N), intent(in) :: A
      B = A + transpose(A)
    end subroutine AplusAtbuiltin
    real(C_double) function randomaccess(P, basis, coefs, A, C) BIND(C, name="randomaccess")
      integer(C_long), intent(in) :: A, C, basis(A,C)
      real(C_double), intent(in) :: P(A,C), coefs(C)
      real(C_double) :: pc
      integer(C_long) :: aa, cc
      randomaccess = 0
      do cc = 1,C
         pc = coefs(cc)
         do aa = 1,A
            pc = pc * P(aa, basis(aa, cc))
         end do
         randomaccess = randomaccess + pc
      end do
    end function randomaccess
    !GCC$ builtin (log) attributes simd (notinbranch) if('x86_64')
    real(C_double) function logdettriangle(T, N) BIND(C, name="logdettriangle")
      integer(C_long), intent(in) :: N
      real(C_double), intent(in) :: T(N,N)
      integer(C_long) :: nn
      logdettriangle = 0
      do concurrent(nn = 1:N)
         logdettriangle = logdettriangle + log(T(nn,nn))
      end do
    end function logdettriangle

  subroutine filter2d(B, A, K, Ma, Na, offset) BIND(C, name="filter2d")
      integer(C_long), intent(in) :: Ma, Na, offset
      real(C_double), intent(in) :: A(Ma,Na), K(-offset:offset,-offset:offset)
      real(C_double), intent(out) :: B(1+offset:Ma-offset,1+offset:Na-offset)
      integer(C_long) :: mma, nna, mmk, nnk
      real(C_double) :: tmp
      do concurrent(mma = 1+offset:Ma-offset, nna = 1+offset:Na-offset)
         tmp = 0
         do concurrent(mmk = -offset:offset, nnk = -offset:offset)
            tmp = tmp + A(mma + mmk, nna + nnk) * K(mmk, nnk)
         end do
         B(mma,nna) = tmp
      end do
    end subroutine filter2d

    subroutine filter2d3x3(B, A, K, Ma, Na) BIND(C, name="filter2d3x3")
      integer(C_long), parameter :: offset = 1
      integer(C_long), intent(in) :: Ma, Na
      real(C_double), intent(in) :: A(Ma,Na), K(-offset:offset,-offset:offset)
      real(C_double), intent(out) :: B(1+offset:Ma-offset,1+offset:Na-offset)
      integer(C_long) :: mma, nna, mmk, nnk
      real(C_double) :: tmp
      do concurrent(mma = 1+offset:Ma-offset, nna = 1+offset:Na-offset)
         tmp = 0
         do concurrent(mmk = -offset:offset, nnk = -offset:offset)
            tmp = tmp + A(mma + mmk, nna + nnk) * K(mmk, nnk)
         end do
         B(mma,nna) = tmp
      end do
    end subroutine filter2d3x3

    subroutine filter2d3x3unrolled(B, A, K, Ma, Na) BIND(C, name="filter2d3x3unrolled")
      integer(C_long), intent(in) :: Ma, Na
      real(C_double), intent(in) :: A(Ma,Na), K(-1:1,-1:1)
      real(C_double), intent(out) :: B(2:Ma-1,2:Na-1)
      integer(C_long) :: mma, nna, mmk, nnk
      real(C_double) :: tmp
      do concurrent(mma = 2:Ma-1, nna = 2:Na-1)
         tmp =       A(mma - 1, nna - 1) * K(-1, -1)
         tmp = tmp + A(mma    , nna - 1) * K( 0, -1)
         tmp = tmp + A(mma + 1, nna - 1) * K( 1, -1)
         tmp = tmp + A(mma - 1, nna    ) * K(-1,  0)
         tmp = tmp + A(mma    , nna    ) * K( 0,  0)
         tmp = tmp + A(mma + 1, nna    ) * K( 1,  0)
         tmp = tmp + A(mma - 1, nna + 1) * K(-1,  1)
         tmp = tmp + A(mma    , nna + 1) * K( 0,  1)
         tmp = tmp + A(mma + 1, nna + 1) * K( 1,  1)
         B(mma,nna) = tmp
      end do
    end subroutine filter2d3x3unrolled




    
  end module looptests
    

@generated function sum_way_too_unrolled(A, ::Val{rows}, ::Val{cols}) where {rows,cols}
  terms = :(0)

  for i = 1:rows
    for j = 1:cols
      terms = :($terms + A[$i, $j, k])
    end
  end

  quote
    sum = 0.0
    @turbo for k in axes(A, 3)
      sum += $terms
    end
    sum
  end
end

@testset "Many Array References" begin
  A = rand(17, 16, 10)

  @test isapprox(sum_way_too_unrolled(A, Val(17), Val(16)), sum(A))
end

@testset "mapreduce" begin
  function maximum_avx(x)
    s = typemin(eltype(x))
    @turbo for i in eachindex(x)
      s = max(s, x[i])
    end
    s
  end
  function minimum_avx(x)
    s = typemax(eltype(x))
    @turbo for i in eachindex(x)
      s = min(s, x[i])
    end
    s
  end
  for T ∈ (Int32, Int64, Float32, Float64)
    @show T, @__LINE__
    if T <: Integer
      R = T(1):T(100)
      x7 = rand(R, 7)
      y7 = rand(R, 7)
      x = rand(R, 127, 7, 7)
      y = rand(R, 127, 7, 7)
      z = rand(R, 3, 3, 3, 3, 3, 3)
    else
      x7 = rand(T, 7)
      y7 = rand(T, 7)
      x = rand(T, 127, 7, 7)
      y = rand(T, 127, 7, 7)
      if VERSION ≥ v"1.4"
        @test vmapreduce(hypot, +, x, y) ≈ mapreduce(hypot, +, x, y)
        @test vmapreduce(^, (a, b) -> a + b, x7, y7) ≈ mapreduce(^, +, x7, y7)
      else
        @test vmapreduce(hypot, +, x, y) ≈ sum(hypot.(x, y))
        @test vmapreduce(^, (a, b) -> a + b, x7, y7) ≈ sum(x7 .^ y7)
      end
      z = rand(T, 3, 3, 3, 3, 3, 3)
    end
    @test vreduce(+, x7) ≈ sum(x7)
    @test vreduce(+, x) ≈ sum(x)
    if T === Int32
      @test vreduce(*, x7) == (prod(x7) % Int32)
      @test vreduce(*, x) == (prod(x) % Int32)
    else
      @test vreduce(*, x7) ≈ prod(x7)
      @test vreduce(*, x) ≈ prod(x)
    end
    @test vmapreduce(abs2, max, x) ≈ mapreduce(abs2, max, x)
    @test vmapreduce(abs2, min, x) ≈ mapreduce(abs2, min, x)
    @test vmapreduce(sqrt, *, x) ≈ mapreduce(sqrt, *, x)
    @test_throws AssertionError vmapreduce(hypot, +, x7, x)
    if VERSION ≥ v"1.4"
      @test vmapreduce(a -> 2a, *, x) ≈ mapreduce(a -> 2a, *, x)
      @test vmapreduce(sin, +, x7) ≈ mapreduce(sin, +, x7)
    else
      @test vmapreduce(a -> 2a, *, x) ≈ prod(2 .* x)
      @test vmapreduce(sin, +, x7) ≈ sum(sin.(x7))
    end
    @test vmapreduce(log, +, x) ≈ sum(log, x)
    @test vmapreduce(abs2, +, x) ≈ sum(abs2, x)
    @test vsum(log, x) ≈ sum(log, x)
    @test vsum(abs2, x) ≈ sum(abs2, x)
    @test vsum(x) ≈ sum(x)
    @test maximum(x) == vreduce(max, x) == maximum_avx(x)
    @test minimum(x) == vreduce(min, x) == minimum_avx(x)

    @test vreduce(max, vec(x); dims = 1) == maximum(vec(x); dims = 1)
    @test vreduce(min, vec(x); dims = 1) == minimum(vec(x); dims = 1)
    @test vreduce(+, vec(x); dims = 1) ≈ sum(vec(x); dims = 1)
    for d = 1:ndims(x)
      @test vreduce(max, x; dims = d) == maximum(x; dims = d)
      @test vreduce(min, x; dims = d) == minimum(x; dims = d)
      @test vreduce(+, x; dims = d) ≈ sum(x; dims = d)
    end
    for d = 1:ndims(z)
      vreduce(max, z, dims = d) == maximum(z, dims = d)
      vreduce(min, z, dims = d) == minimum(z, dims = d)
      vreduce(+, z, dims = d) ≈ sum(z, dims = d)
    end
  end

end

@generated function append_true(::Val{D}, ::Val{N}) where {D,N}
  length(D) == N && return D
  t = Expr(:tuple)
  for d in D
    push!(t.args, d)
  end
  for n = length(D)+1:N
    push!(t.args, true)
  end
  t
end
struct LowDimArray{D,T,N,A<:AbstractArray{T,N}} <: AbstractArray{T,N}
  data::A
  function LowDimArray{D}(data::A) where {D,T,N,A<:AbstractArray{T,N}}
    new{append_true(Val{D}(), Val{N}()),T,N,A}(data)
  end
  function LowDimArray{D,T,N,A}(data::A) where {D,T,N,A<:AbstractArray{T,N}}
    new{append_true(Val{D}(), Val{N}()),T,N,A}(data)
  end
end
function LowDimArray{D0}(
  data::LowDimArray{D1,T,N,A}
) where {D0,T,N,D1,A<:AbstractArray{T,N}}
  LowDimArray{map(|, D0, D1),T,N,A}(parent(data))
end
Base.@propagate_inbounds Base.getindex(
  A::LowDimArray,
  i::Vararg{Union{StaticInt,Integer,CartesianIndex},K}
) where {K} = getindex(A.data, i...)
@inline Base.size(A::LowDimArray) = Base.size(A.data)
@inline Base.size(A::LowDimArray, i) = Base.size(A.data, i)

@inline _pick_lowdim_known(::Tuple{}, x) = x
@inline function _pick_lowdim_known(b::Tuple{Bool,Vararg}, x)
  f = first(b) ? first(x) : 1
  l = _pick_lowdim_known(Base.tail(b), Base.tail(x))
  (f, l...)
end
@inline function ArrayInterface.known_size(
  ::Type{LowDimArray{D,T,N,A}}
) where {D,T,N,A}
  _pick_lowdim_known(D, ArrayInterface.known_size(A))
end
@inline ArrayInterface.parent_type(
  ::Type{LowDimArray{D,T,N,A}}
) where {T,D,N,A} = A
@inline Base.strides(A::LowDimArray) = map(Int, static_strides(A))
@inline ArrayInterface.device(::LowDimArray) = ArrayInterface.CPUPointer()
@generated function ArrayInterface.static_size(
  A::LowDimArray{D,T,N}
) where {D,T,N}
  t = Expr(:tuple)
  for n ∈ 1:N
    if n > length(D) || D[n]
      push!(t.args, Expr(:call, getfield, :s, n))
    else
      push!(t.args, Expr(:call, Expr(:curly, lv(:StaticInt), 1)))
    end
  end
  Expr(:block, Expr(:meta, :inline), :(s = ArrayInterface.size(parent(A))), t)
end
Base.parent(A::LowDimArray) = getfield(A, :data)
Base.unsafe_convert(::Type{Ptr{T}}, A::LowDimArray{D,T}) where {D,T} =
  pointer(parent(A))
ArrayInterface.contiguous_axis(A::LowDimArray) =
  ArrayInterface.contiguous_axis(parent(A))
ArrayInterface.contiguous_batch_size(A::LowDimArray) =
  ArrayInterface.contiguous_batch_size(parent(A))
ArrayInterface.stride_rank(A::LowDimArray) =
  ArrayInterface.stride_rank(parent(A))
ArrayInterface.offsets(A::LowDimArray) = ArrayInterface.offsets(parent(A))

@generated function _lowdimfilter(
  ::Val{D},
  tup::Tuple{Vararg{Any,N}}
) where {D,N}
  t = Expr(:tuple)
  for n ∈ 1:N
    if n > length(D) || D[n]
      push!(t.args, Expr(:call, getfield, :tup, n))
    end
  end
  Expr(:block, Expr(:meta, :inline), t)
end

struct ForBroadcast{T,N,A<:AbstractArray{T,N}} <: AbstractArray{T,N}
  data::A
end
@inline Base.parent(fb::ForBroadcast) = getfield(fb, :data)
@inline ArrayInterface.parent_type(::Type{ForBroadcast{T,N,A}}) where {T,N,A} =
  A
Base.@propagate_inbounds Base.getindex(
  A::ForBroadcast,
  i::Vararg{Any,K}
) where {K} = parent(A)[i...]
const LowDimArrayForBroadcast{D,T,N,A} = ForBroadcast{T,N,LowDimArray{D,T,N,A}}
@inline function VectorizationBase.contiguous_axis(
  fb::LowDimArrayForBroadcast{D,T,N,A}
) where {D,T,N,A}
  _contiguous_axis(
    Val{D}(),
    VectorizationBase.contiguous_axis(parent(parent(fb)))
  )
end
@inline forbroadcast(A::AbstractArray) = ForBroadcast(A)
@inline forbroadcast(A::AbstractRange) = A
@inline forbroadcast(A) = A
# @inline forbroadcast(A::Adjoint) = forbroadcast(parent(A))
# @inline forbroadcast(A::Transpose) = forbroadcast(parent(A))
@inline function ArrayInterface.static_strides(
  A::Union{LowDimArray,ForBroadcast}
)
  B = parent(A)
  _strides(
    static_size(A),
    static_strides(B),
    VectorizationBase.val_stride_rank(B),
    VectorizationBase.val_dense_dims(B)
  )
end

# @inline function VectorizationBase.contiguous_batch_size(fb::LowDimArrayForBroadcast{D,T,N,A}) where {D,T,N,A}
#     _contiguous_axis(Val{D}(), VectorizationBase.contiguous_batch_size(parent(parent(fb))))
# end
@generated function _contiguous_axis(::Val{D}, ::StaticInt{C}) where {D,C}
  Dlen = length(D)
  (C > 0) || return Expr(:block, Expr(:meta, :inline), staticexpr(C))
  if C ≤ Dlen
    D[C] || return Expr(:block, Expr(:meta, :inline), staticexpr(-1))
  end
  Cnew = 0
  for n ∈ 1:C
    Cnew += ((n > Dlen)) || D[n]
  end
  Expr(:block, Expr(:meta, :inline), staticexpr(Cnew))
end
function ArrayInterface.contiguous_axis(
  ::Type{LowDimArrayForBroadcast{D,T,N,A}}
) where {D,T,N,A}
  ArrayInterface.contiguous_axis(A)
end
@inline function ArrayInterface.stride_rank(
  ::Type{LowDimArrayForBroadcast{D,T,N,A}}
) where {D,T,N,A}
  _lowdimfilter(Val(D), ArrayInterface.stride_rank(A))
end
@inline function ArrayInterface.dense_dims(
  ::Type{LowDimArrayForBroadcast{D,T,N,A}}
) where {D,T,N,A}
  _lowdimfilter(Val(D), ArrayInterface.dense_dims(A))
end
@inline function ArrayInterface.static_strides(
  fb::LowDimArrayForBroadcast{D}
) where {D}
  _lowdimfilter(Val(D), static_strides(parent(fb)))
end
@inline function ArrayInterface.offsets(
  fb::LowDimArrayForBroadcast{D}
) where {D}
  _lowdimfilter(Val(D), ArrayInterface.offsets(parent(parent(fb))))
end
@inline function ArrayInterface.StrideIndex(
  a::A
) where {A<:LowDimArrayForBroadcast}
  _stride_index(
    ArrayInterface.stride_rank(A),
    ArrayInterface.contiguous_axis(A),
    a
  )
end
@inline function _stride_index(
  r::Tuple{Vararg{StaticInt,N}},
  ::StaticInt{C},
  A
) where {N,C}
  StrideIndex{N,ArrayInterface.known(r),C}(A)
end

for f ∈ [ # groupedstridedpointer support
  :(ArrayInterface.contiguous_axis),
  :(ArrayInterface.contiguous_batch_size),
  :(ArrayInterface.device),
  :(ArrayInterface.stride_rank)
]
  @eval @inline $f(::Type{ForBroadcast{T,N,A}}) where {T,N,A} = $f(A)
end
for f ∈ [ # groupedstridedpointer support
  :(LayoutPointers.memory_reference),
  :(ArrayInterface.contiguous_axis),
  :(ArrayInterface.contiguous_batch_size),
  :(ArrayInterface.device),
  :(ArrayInterface.dense_dims),
  :(ArrayInterface.stride_rank),
  :(VectorizationBase.val_dense_dims),
  :(ArrayInterface.offsets),
  :(Base.size)#, :(ArrayInterface.strides)
]
  @eval @inline $f(fb::ForBroadcast) = $f(getfield(fb, :data))
end

function is_column_major(x)
  for (i, j) ∈ enumerate(x)
    i == j || return false
  end
  true
end
is_row_major(x) = is_column_major(reverse(x))
_find_arg_least_greater(r::Vector{Int}, i) =
  findmin(x -> x > i ? x : typemax(Int), r)

function _strides_expr(
  @nospecialize(s),
  @nospecialize(x),
  R::Vector{Int},
  D::Vector{Bool}
)
  N = length(R)
  q = Expr(:block, Expr(:meta, :inline))
  strd_tup = Expr(:tuple)
  resize!(strd_tup.args, N)
  ifel = GlobalRef(Core, :ifelse)
  Nrange = 1:N # type stability w/ respect to reverse
  # Nrange = 1:1:N # type stability w/ respect to reverse
  use_stride_acc = true
  stride_acc::Int = 1
  next, n = _find_arg_least_greater(R, 0)
  if !D[n]
    use_stride_acc = false
    stride_acc = 0
  end
  sₙ_value::Int = 0
  for _n ∈ Nrange
    xₙ_type = x[n]
    xₙ_static = xₙ_type <: StaticInt
    xₙ_value::Int = xₙ_static ? (xₙ_type.parameters[1])::Int : 0
    s_type = s[n]
    sₙ_static = s_type <: StaticInt
    if sₙ_static
      sₙ_value = s_type.parameters[1]
      if s_type === One
        strd_tup.args[n] = Expr(:call, lv(:Zero))
      elseif stride_acc ≠ 0
        strd_tup.args[n] = staticexpr(stride_acc)
      else
        strd_tup.args[n] = :($getfield(x, $n))
      end
    else
      if xₙ_static
        strd_tup.args[n] = staticexpr(xₙ_value)
      elseif stride_acc ≠ 0
        strd_tup.args[n] = staticexpr(stride_acc)
      else
        strd_tup.args[n] =
          :($ifel(isone($getfield(s, $n)), zero($xₙ_type), $getfield(x, $n)))
      end
    end
    if (_n ≠ N)
      next, n = _find_arg_least_greater(R, next)
      if use_stride_acc
        if D[n]
          if xₙ_static & sₙ_static
            stride_acc = xₙ_value * sₙ_value
          elseif sₙ_static
            if stride_acc ≠ 0
              stride_acc *= sₙ_value
            end
          else
            stride_acc = 0
          end
        else
          stride_acc = 0
        end
      end
    end
  end
  push!(q.args, strd_tup)
  q
end
@generated function _strides(
  s::Tuple{Vararg{Union{StaticInt,Integer},N}},
  x::Tuple{Vararg{Union{StaticInt,Integer},N}},
  ::Val{R},
  ::Val{D}
) where {N,R,D}
  Rv = Vector{Int}(undef, N)
  Dv = Vector{Bool}(undef, N)
  for n = 1:N
    Rv[n] = R[n]
    Dv[n] = D[n]
  end
  _strides_expr(s.parameters, x.parameters, Rv, Dv)
end

struct Product{A,B}
  a::A
  b::B
end
@inline function Base.size(p::Product)
  M = @inbounds size(p.a)[1]
  (M, Base.tail(size(p.b))...)
end
@inline function Base.size(p::Product, i::Integer)
  i == 1 && return @inbounds size(p.a)[1]
  @inbounds size(p.b)[i]
end
@inline Base.length(p::Product) = prod(size(p))
@inline Base.broadcastable(p::Product) = p
@inline numdims(A) = ndims(A) # fallback
@inline numdims(::Type{Product{A,B}}) where {A,B} = numdims(B)
@inline Base.ndims(::Type{Product{A,B}}) where {A,B} = numdims(B)
# This numdims nonsense is a hack to avoid type piracy in defining:
@inline numdims(
  ::Type{B}
) where {
  N,
  S<:Base.Broadcast.AbstractArrayStyle{N},
  B<:Base.Broadcast.Broadcasted{S}
} = N

Base.Broadcast._broadcast_getindex_eltype(
  ::Product{A,B}
) where {T,A<:AbstractVecOrMat{T},B<:AbstractVecOrMat{T}} = T
function Base.Broadcast._broadcast_getindex_eltype(p::Product)
  promote_type(
    Base.Broadcast._broadcast_getindex_eltype(p.a),
    Base.Broadcast._broadcast_getindex_eltype(p.b)
  )
end

_is_one(x) = x !== 1
@inline _dontbc(x) = map(_is_one, ArrayInterface.known_size(x))
@inline _dontbc(x::Product) = _dontbc(x.a), _dontbc(x.b)
@inline _dontbc(bc::Base.Broadcast.Broadcasted) = map(_dontbc, bc.args)

"""
    A *ˡ B

A lazy product of `A` and `B`. While functionally identical to `A * B`, this may avoid the
need for intermediate storage for any computations in `A` or `B`.  Example:

    @turbo @. a + B *ˡ (c + d')

which is equivalent to

     a .+ B * (c .+ d')

It should only be used inside an `@turbo` block, and to materialize the result it cannot be
the final operation.
"""
@inline *ˡ(a::A, b::B) where {A,B} = Product{A,B}(a, b)
@inline Base.Broadcast.broadcasted(::typeof(*ˡ), a::A, b::B) where {A,B} =
  Product{A,B}(a, b)
# TODO: Need to make this handle A or B being (1 or 2)-D broadcast objects.
function add_broadcast!(
  ls::LoopSet,
  mC::Symbol,
  bcname::Symbol,
  loopsyms::Vector{Symbol},
  @nospecialize(prod::Type{<:Product}),
  dontbc,
  elementbytes::Int
)
  A, B = prod.parameters
  Krange = gensym!(ls, "K")
  Klen = gensym!(ls, "K")
  mA = gensym!(ls, "Aₘₖ")
  mB = gensym!(ls, "Bₖₙ")
  pushprepreamble!(ls, Expr(:(=), mA, Expr(:(.), bcname, QuoteNode(:a))))
  pushprepreamble!(ls, Expr(:(=), mB, Expr(:(.), bcname, QuoteNode(:b))))
  pushprepreamble!(
    ls,
    Expr(:(=), Klen, Expr(:call, getfield, Expr(:call, :static_size, mB), 1))
  )
  pushpreamble!(ls, Expr(:(=), Krange, Expr(:call, :(:), staticexpr(1), Klen)))
  k = gensym!(ls, "k")
  add_loop!(ls, Loop(k, 1, Klen, 1, Krange, Klen), k)
  m = loopsyms[1]
  if numdims(B) == 1
    bloopsyms = Symbol[k]
    cloopsyms = Symbol[m]
    reductdeps = Symbol[m, k]
    kvec = bloopsyms
  elseif numdims(B) == 2
    n = loopsyms[2]
    bloopsyms = Symbol[k, n]
    cloopsyms = Symbol[m, n]
    reductdeps = Symbol[m, k, n]
    kvec = Symbol[k]
  else
    throw("B must be a vector or matrix.")
  end
  # load A
  # loadA = add_load!(ls, gensym!(ls, :A), productref(A, mA, m, k), elementbytes)
  loadA = add_broadcast!(
    ls,
    gensym!(ls, "A"),
    mA,
    Symbol[m, k],
    A,
    dontbc[1],
    elementbytes
  )
  # load B
  loadB = add_broadcast!(
    ls,
    gensym!(ls, "B"),
    mB,
    bloopsyms,
    B,
    dontbc[2],
    elementbytes
  )
  # set Cₘₙ = 0
  # setC = add_constant!(ls, zero(promote_type(recursive_eltype(A), recursive_eltype(B))), cloopsyms, mC, elementbytes)
  # targetC will be used for reduce_to_add
  mCt = gensym!(ls, mC)
  targetC = add_constant!(
    ls,
    gensym!(ls, "zero"),
    cloopsyms,
    mCt,
    elementbytes,
    :numericconstant
  )
  push!(ls.preamble_zeros, (identifier(targetC), IntOrFloat))
  setC = add_constant!(
    ls,
    gensym!(ls, "zero"),
    cloopsyms,
    mC,
    elementbytes,
    :numericconstant
  )
  push!(ls.preamble_zeros, (identifier(setC), IntOrFloat))
  setC.reduced_children = kvec
  # compute Cₘₙ += Aₘₖ * Bₖₙ
  instrsym = Base.libllvm_version < v"11.0.0" ? :vfmadd231 : :vfmadd
  reductop = Operation(
    ls,
    mC,
    elementbytes,
    instrsym,
    compute,
    reductdeps,
    kvec,
    Operation[loadA, loadB, setC]
  )
  reductop = pushop!(ls, reductop, mC)
  reductfinal = Operation(
    ls,
    mCt,
    elementbytes,
    :reduce_to_add,
    compute,
    cloopsyms,
    kvec,
    Operation[reductop, targetC]
  )
  pushop!(ls, reductfinal, mCt)
end

function extract_all_1_array!(
  ls::LoopSet,
  bcname::Symbol,
  N::Int,
  elementbytes::Int
)
  refextract = gensym!(ls, bcname)
  ref = Expr(:ref, bcname)
  for _ ∈ 1:N
    push!(ref.args, :begin)
  end
  pushprepreamble!(ls, Expr(:(=), refextract, :(@inbounds $ref)))
  return add_constant!(ls, refextract, elementbytes) # or replace elementbytes with sizeof(T) ? u
end
function doaddref!(ls::LoopSet, op::Operation)
  push!(ls.syms_aliasing_refs, name(op))
  push!(ls.refs_aliasing_syms, op.ref)
  op
end

function add_broadcast!(
  ls::LoopSet,
  destname::Symbol,
  bcname::Symbol,
  loopsyms::Vector{Symbol},
  @nospecialize(_::Type{<:AbstractArray{T,N}}),
  @nospecialize(dontbc::NTuple{N,Bool}),
  elementbytes::Int
) where {T,N}
  any(dontbc) || return extract_all_1_array!(ls, bcname, N, elementbytes)
  bcname2 = gensym!(ls, bcname)
  ref = if all(dontbc)
    pushprepreamble!(ls, Expr(:(=), bcname2, Expr(:call, forbroadcast, bcname)))
    ArrayReference(bcname2, loopsyms[1:N])
  else
    fulldims = Symbol[]
    subset = Expr(:tuple)
    for n = 1:N
      push!(subset.args, dontbc[n])
      dontbc[n] && push!(fulldims, loopsyms[n])
    end
    lda = Expr(:call, Expr(:curly, LowDimArray, subset), bcname)
    pushprepreamble!(ls, Expr(:(=), bcname2, Expr(:call, forbroadcast, lda)))
    ArrayReference(bcname2, fulldims)
  end

  loadop = add_simple_load!(ls, destname, ref, elementbytes, true)::Operation
  doaddref!(ls, loadop)
end
function add_broadcast!(
  ls::LoopSet,
  ::Symbol,
  bcname::Symbol,
  loopsyms::Vector{Symbol},
  @nospecialize(_::Type{T}),
  @nospecialize(__),
  elementbytes::Int
) where {T<:Number}
  add_constant!(ls, bcname, elementbytes) # or replace elementbytes with sizeof(T) ? u
end
function add_broadcast!(
  ls::LoopSet,
  ::Symbol,
  bcname::Symbol,
  loopsyms::Vector{Symbol},
  @nospecialize(_::Type{Base.RefValue{T}}),
  @nospecialize(__),
  elementbytes::Int
) where {T}
  refextract = gensym!(ls, bcname)
  pushprepreamble!(ls, Expr(:(=), refextract, Expr(:ref, bcname)))
  add_constant!(ls, refextract, elementbytes) # or replace elementbytes with sizeof(T) ? u
end
const BroadcastedArray{S<:Broadcast.AbstractArrayStyle,F,A} =
  Broadcasted{S,Nothing,F,A}
function add_broadcast!(
  ls::LoopSet,
  destname::Symbol,
  bcname::Symbol,
  loopsyms::Vector{Symbol},
  @nospecialize(B::Type{<:BroadcastedArray}),
  @nospecialize(dontbc),
  elementbytes::Int
)
  S, _, F, A = B.parameters
  instr = get(FUNCTIONSYMBOLS, F) do
    f = gensym!(ls, "func")
    pushprepreamble!(ls, Expr(:(=), f, Expr(:(.), bcname, QuoteNode(:f))))
    Instruction(bcname, f)
  end
  args = A.parameters
  bcargs = gensym!(ls, "bcargs")
  pushprepreamble!(ls, Expr(:(=), bcargs, Expr(:(.), bcname, QuoteNode(:args))))
  # this is the var name in the loop
  parents = Operation[]
  deps = Symbol[]
  # reduceddeps = Symbol[]
  for (i, arg) ∈ enumerate(args)
    argname = gensym!(ls, "arg")
    pushprepreamble!(ls, Expr(:(=), argname, Expr(:call, getfield, bcargs, i)))
    # dynamic dispatch
    parent = add_broadcast!(
      ls,
      gensym!(ls, "temp"),
      argname,
      loopsyms,
      arg,
      dontbc[i],
      elementbytes
    )::Operation
    push!(parents, parent)
    mergesetdiffv!(deps, loopdependencies(parent), reduceddependencies(parent))
  end
  op = Operation(
    length(operations(ls)),
    destname,
    elementbytes,
    instr,
    compute,
    deps,
    NODEPENDENCY,
    parents
  )
  pushop!(ls, op, destname)
end

function add_broadcast_loops!(
  ls::LoopSet,
  loopsyms::Vector{Symbol},
  destsym::Symbol
)
  axes_tuple = Expr(:tuple)
  pushpreamble!(ls, Expr(:(=), axes_tuple, Expr(:call, :static_axes, destsym)))
  for itersym ∈ loopsyms
    Nrange = gensym!(ls, "N")
    Nlower = gensym!(ls, "N")
    Nupper = gensym!(ls, "N")
    Nlen = gensym!(ls, "N")
    add_loop!(ls, Loop(itersym, Nlower, Nupper, 1, Nrange, Nlen), itersym)
    push!(axes_tuple.args, Nrange)
    pushpreamble!(
      ls,
      Expr(:(=), Nlower, Expr(:call, lv(:maybestaticfirst), Nrange))
    )
    pushpreamble!(
      ls,
      Expr(:(=), Nupper, Expr(:call, lv(:maybestaticlast), Nrange))
    )
    pushpreamble!(
      ls,
      Expr(
        :(=),
        Nlen,
        Expr(:call, GlobalRef(ArrayInterface, :static_length), Nrange)
      )
    )
  end
end

function vmaterialize_fun(
  sizeofT::Int,
  N,
  @nospecialize(_::Type{BC}),
  Mod,
  UNROLL,
  dontbc,
  transpose::Bool
) where {BC}
  # 2 + 1
  # we have an N dimensional loop.
  # need to construct the LoopSet
  ls = LoopSet(Mod)
  inline, u₁, u₂, v, isbroadcast, _, rs, rc, cls, threads, warncheckarg, safe =
    UNROLL
  set_hw!(ls, rs, rc, cls)
  ls.isbroadcast = isbroadcast # maybe set `false` in a DiffEq-like `@..` macro
  loopsyms = [gensym!(ls, "n") for _ ∈ 1:N]
  transpose &&
    pushprepreamble!(ls, Expr(:(=), :dest, Expr(:call, :parent, :dest′)))
  ret = transpose ? :dest′ : :dest
  add_broadcast_loops!(ls, loopsyms, ret)
  elementbytes = sizeofT
  add_broadcast!(ls, :destination, :bc, loopsyms, BC, dontbc, elementbytes)
  transpose && reverse!(loopsyms)
  storeop = add_simple_store!(
    ls,
    :destination,
    ArrayReference(:dest, loopsyms),
    elementbytes
  )
  doaddref!(ls, storeop)
  resize!(ls.loop_order, num_loops(ls)) # num_loops may be greater than N, eg Product
  # return ls
  sc = setup_call(
    ls,
    :(Base.Broadcast.materialize!($ret, bc)),
    LineNumberNode(0),
    inline,
    false,
    u₁,
    u₂,
    v,
    threads % Int,
    warncheckarg,
    safe
  )
  Expr(:block, Expr(:meta, :inline), sc, ret)
end

# size of dest determines loops
# function vmaterialize!(
@generated function vmaterialize!(
  dest::AbstractArray{T,N},
  bc::BC,
  ::Val{Mod},
  ::Val{UNROLL},
  ::Val{dontbc}
) where {T<:NativeTypes,N,BC<:Union{Broadcasted,Product},Mod,UNROLL,dontbc}
  vmaterialize_fun(sizeof(T), N, BC, Mod, UNROLL, dontbc, false)
end
@generated function vmaterialize!(
  dest′::Union{Adjoint{T,A},Transpose{T,A}},
  bc::BC,
  ::Val{Mod},
  ::Val{UNROLL},
  ::Val{dontbc}
) where {
  T<:NativeTypes,
  N,
  A<:AbstractArray{T,N},
  BC<:Union{Broadcasted,Product},
  Mod,
  UNROLL,
  dontbc
}
  vmaterialize_fun(sizeof(T), N, BC, Mod, UNROLL, dontbc, true)
end
# these are marked `@inline` so the `@turbo` itself can choose whether or not to inline.
@generated function vmaterialize!(
  dest::AbstractArray{T,N},
  bc::Broadcasted{
    Base.Broadcast.DefaultArrayStyle{0},
    Nothing,
    typeof(identity),
    Tuple{T2}
  },
  ::Val{Mod},
  ::Val{UNROLL},
  ::Val{dontbc}
) where {T<:NativeTypes,N,T2<:Number,Mod,UNROLL,dontbc}
  inline, u₁, u₂, v, isbroadcast, W, rs, rc, cls, threads, warncheckarg, safe =
    UNROLL
  quote
    $(Expr(:meta, :inline))
    arg = T(first(bc.args))
    @turbo inline = $inline unroll = ($u₁, $u₂) thread = $threads vectorize = $v for i ∈
                                                                                     eachindex(
      dest
    )
      dest[i] = arg
    end
    dest
  end
end
@generated function vmaterialize!(
  dest′::Union{Adjoint{T,A},Transpose{T,A}},
  bc::Broadcasted{
    Base.Broadcast.DefaultArrayStyle{0},
    Nothing,
    typeof(identity),
    Tuple{T2}
  },
  ::Val{Mod},
  ::Val{UNROLL},
  ::Val{dontbc}
) where {T<:NativeTypes,N,A<:AbstractArray{T,N},T2<:Number,Mod,UNROLL,dontbc}
  inline, u₁, u₂, v, isbroadcast, W, rs, rc, cls, threads, warncheckarg, safe =
    UNROLL
  quote
    $(Expr(:meta, :inline))
    arg = T(first(bc.args))
    dest = parent(dest′)
    @turbo inline = $inline unroll = ($u₁, $u₂) thread = $threads vectorize = $v for i ∈
                                                                                     eachindex(
      dest
    )
      dest[i] = arg
    end
    dest′
  end
end
@inline function vmaterialize!(
  dest,
  bc,
  ::Val{Mod},
  ::Val{UNROLL}
) where {Mod,UNROLL}
  vmaterialize!(dest, bc, Val{Mod}(), Val{UNROLL}(), Val(_dontbc(bc)))
end

@inline function vmaterialize(
  bc::Broadcasted{Base.Broadcast.DefaultArrayStyle{0}},
  ::Val{Mod},
  ::Val{UNROLL}
) where {Mod,UNROLL}
  Base.materialize(bc)
end
@inline function vmaterialize(
  bc::Broadcasted,
  ::Val{Mod},
  ::Val{UNROLL}
) where {Mod,UNROLL}
  ElType = Base.Broadcast.combine_eltypes(bc.f, bc.args)
  dest = similar(bc, ElType)
  vmaterialize!(dest, bc, Val{Mod}(), Val{UNROLL}(), Val(_dontbc(bc)))
end

# vmaterialize!(dest, bc, ::Val, ::Val, ::StaticInt, ::StaticInt, ::StaticInt) =
# Base.Broadcast.materialize!(dest, bc)

using LoopVectorization, SnoopCompile
LOOPVECTORIZATION_TEST = "all"
tinf = @snoopi_deep include(
  joinpath(pkgdir(LoopVectorization), "test", "testsetup.jl")
)
tinf = @snoopi_deep include(
  joinpath(pkgdir(LoopVectorization), "test", "grouptests.jl")
)

ttot, pcs = SnoopCompile.parcel(tinf);

lv, pcslv = last(pcs);
@assert lv === LoopVectorization

blacklist = (
  :_turbo_!,
  :vmaterialize!,
  :vmaterialize,
  Symbol("vreduce##kw"),
  :_vreduce_dims!,
  :vreduce,
  :vmapreduce,
  :SIMDMapBack,
  :launch_thread_vmap!,
  :_turbo_loopset_debug,
  :all_dense,
  :sigmoid_fast,
  :rrule,
  :add_broadcast!,
  :create_mrefs!,
  :avx_config_val,
  :subsetview,
  :ifelsepartial,
  :tanh_fast,
  :check_args,
  :relu,
  :init_dual
)
filteredmethods =
  filter(m -> !Base.sym_in(m[2].def.name, blacklist), last(pcslv));
length(filteredmethods);

SnoopCompile.write(
  "/tmp/precompile_loopvec",
  [LoopVectorization => (sum(first, filteredmethods), filteredmethods)]
)

# pc = SnoopCompile.parcel(tinf; blacklist=["vmaterialize", "vmaterialize!", "vreduce", "Base.Broadcast.materialize", "_vreduce_dims!", "vmapreduce"])
# pcs = pc[:LoopVectorization]
# open(joinpath(pkgdir, "src", "precompile.jl"), "w") do io
#     println(io, """
#     function _precompile_()
#         ccall(:jl_generating_output, Cint, ()) == 1 || return nothing
#     """)
#     for stmt in sort(pcs)
#         println(io, "    ", stmt)
#     end
#     println(io, "end")
# end

# Auxiliary functions
const _uint_bit_length = sizeof(UInt) * 8
const _div_uint_size_shift = Int(log2(_uint_bit_length))
@inline _mul2(i::Integer) = i << 1
@inline _div2(i::Integer) = i >> 1
@inline _map_to_index(i::Integer) = _div2(i - 1)
@inline _map_to_factor(i::Integer) = _mul2(i) + 1
@inline _mod_uint_size(i::Integer) = i & (_uint_bit_length - 1)
@inline _div_uint_size(i::Integer) = i >> _div_uint_size_shift
@inline _get_chunk_index(i::Integer) = _div_uint_size(i + (_uint_bit_length - 1))
@inline _get_bit_index_mask(i::Integer) = UInt(1) << _mod_uint_size(i - 1)


function clear_factors_while!(arr::Vector{UInt}, factor_index::Integer, max_index::Integer)
  factor = _map_to_factor(factor_index)
  index = _div2(factor * factor)
  while index <= max_index
    @inbounds arr[_get_chunk_index(index)] |= _get_bit_index_mask(index)
    index += factor
  end
  return arr
end
function clear_factors_turbo!(arr::Vector{UInt}, factor_index::Integer, max_index::Integer)
  factor = _map_to_factor(factor_index)
  factor < _uint_bit_length &&
    error("Factor must be greater than UInt bit length to avoid memory pendencies")
  @turbo for index = _div2(factor * factor):factor:max_index
    @inbounds arr[(index+63)>>_div_uint_size_shift] |= 1 << ((index - 1) & 63)
  end
  return arr
end
function clear_factors_turbo_u4!(
  arr::Vector{UInt},
  factor_index::Integer,
  max_index::Integer,
)
  factor = _map_to_factor(factor_index)
  factor < _uint_bit_length &&
    error("Factor must be greater than UInt bit length to avoid memory pendencies")
  @turbo unroll = 4 for index = _div2(factor * factor):factor:max_index
    @inbounds arr[(index+63)>>_div_uint_size_shift] |= 1 << ((index - 1) & 63)
  end
  return arr
end

@testset "steprange" begin
  x0 = rand(UInt, cld(500_000, sizeof(UInt) * 8))
  x1 = copy(x0)
  x2 = copy(x0)
  clear_factors_while!(x0, 202, 500_000)
  clear_factors_turbo!(x1, 202, 500_000)
  clear_factors_turbo_u4!(x2, 202, 500_000)
  @test x0 == x1 == x2
end

using LoopVectorization, Test

function reference_mul4!(target_arr, src, range_a, range_b, padded_axis_a, padded_axis_b)
  @inbounds @fastmath for a1i ∈ eachindex(range_a),
    a2i ∈ eachindex(range_a),
    b1i ∈ eachindex(range_b),
    b2i ∈ eachindex(range_b)

    a1 = range_a[a1i]
    a2 = range_a[a2i]
    b1 = range_b[b1i]
    b2 = range_b[b2i]
    contribution = zero(eltype(target_arr))
    for i_a ∈ padded_axis_a, i_b ∈ padded_axis_b
      contribution += src[i_a, i_b] * src[i_a+a1, i_b+b1] * src[i_a+a2, i_b+b2]
    end
    target_arr[b1i, b2i] += contribution
  end
end
function mul4_turbo_v1!(target_arr, src, range_a, range_b, padded_axis_a, padded_axis_b)
  @turbo for a1i ∈ eachindex(range_a),
    a2i ∈ eachindex(range_a),
    b1i ∈ eachindex(range_b),
    b2i ∈ eachindex(range_b)

    a1 = range_a[a1i]
    a2 = range_a[a2i]
    b1 = range_b[b1i]
    b2 = range_b[b2i]
    contribution = zero(eltype(target_arr))
    for i_a ∈ padded_axis_a, i_b ∈ padded_axis_b
      contribution += src[i_a, i_b] * src[i_a+a1, i_b+b1] * src[i_a+a2, i_b+b2]
    end
    target_arr[b1i, b2i] += contribution
  end
  target_arr
end
function mul4_turbo_v2!(target_arr, src, range_a, range_b, padded_axis_a, padded_axis_b)
  @turbo for a1i ∈ eachindex(range_a),
    a2i ∈ eachindex(range_a),
    b1i ∈ eachindex(range_b),
    b2i ∈ eachindex(range_b)

    a1 = range_a[a1i]
    a2 = range_a[a2i]
    b1 = range_b[b1i]
    b2 = range_b[b2i]
    contribution = target_arr[b1i, b2i]
    for i_a ∈ padded_axis_a, i_b ∈ padded_axis_b
      contribution += src[i_a, i_b] * src[i_a+a1, i_b+b1] * src[i_a+a2, i_b+b2]
    end
    target_arr[b1i, b2i] = contribution
  end
end
function mul4_turbo_v3!(target_arr, src, range_a, range_b, padded_axis_a, padded_axis_b)
  @turbo for a1i ∈ eachindex(range_a),
    a2i ∈ eachindex(range_a),
    b1i ∈ eachindex(range_b),
    b2i ∈ eachindex(range_b),
    i_a ∈ padded_axis_a,
    i_b ∈ padded_axis_b

    a1 = range_a[a1i]
    a2 = range_a[a2i]
    b1 = range_b[b1i]
    b2 = range_b[b2i]
    target_arr[b1i, b2i] += src[i_a, i_b] * src[i_a+a1, i_b+b1] * src[i_a+a2, i_b+b2]
  end
end
function mul4_turbo_v4!(target_arr, src, range_a, range_b, padded_axis_a, padded_axis_b)
  @turbo for b1i ∈ eachindex(range_b), b2i ∈ eachindex(range_b)
    b1 = range_b[b1i]
    b2 = range_b[b2i]
    contribution = zero(eltype(target_arr))
    for i_a ∈ padded_axis_a,
      i_b ∈ padded_axis_b,
      a1i ∈ eachindex(range_a),
      a2i ∈ eachindex(range_a)

      a1 = range_a[a1i]
      a2 = range_a[a2i]
      contribution += src[i_a, i_b] * src[i_a+a1, i_b+b1] * src[i_a+a2, i_b+b2]
    end
    target_arr[b1i, b2i] += contribution
  end
end

@testset "Inner reductions" begin
  src = ones(19, 101)
  max_a = 7
  max_b = 9
  range_a = -max_a:max_a
  range_b = -max_b:max_b

  target_arr = zeros(Float64, length(range_b), length(range_b))

  padded_axis_b = (first(axes(src, 2)).+max_b):(last(axes(src, 2))-max_b)
  padded_axis_a = (first(axes(src, 1)).+max_a):(last(axes(src, 1))-max_a)

  target_ref = zero(target_arr)
  reference_mul4!(target_ref, src, range_a, range_b, padded_axis_a, padded_axis_b)

  mul4_turbo_v1!(target_arr, src, range_a, range_b, padded_axis_a, padded_axis_b)
  @test target_arr ≈ target_ref
  target_arr .= 0
  mul4_turbo_v2!(target_arr, src, range_a, range_b, padded_axis_a, padded_axis_b)
  @test target_arr ≈ target_ref
  target_arr .= 0
  mul4_turbo_v3!(target_arr, src, range_a, range_b, padded_axis_a, padded_axis_b)
  @test target_arr ≈ target_ref
  target_arr .= 0
  mul4_turbo_v4!(target_arr, src, range_a, range_b, padded_axis_a, padded_axis_b)
  @test target_arr ≈ target_ref

end

using Test
using Pkg
using LoopVectorization

const var"@_avx" = LoopVectorization.var"@_turbo"

using LinearAlgebra
function clenshaw(x, coeff)
  len_c = length(coeff)
  tmp = zero(x)
  ret = zero(x)
  for i = len_c:-1:2
    ret = muladd(x, 2tmp, coeff[i] - ret)
    ret, tmp = tmp, ret
  end
  ret = muladd(x, tmp, coeff[1] - ret)
  return ret
end

"""
Causes `check_args` to fail.
"""
struct FallbackArrayWrapper{T,N} <: AbstractArray{T,N}
  data::Array{T,N}
end
Base.size(A::FallbackArrayWrapper) = size(A.data)
Base.@propagate_inbounds Base.getindex(
  A::FallbackArrayWrapper,
  i::Vararg{Int,N},
) where {N} = getindex(A.data, i...)
Base.@propagate_inbounds Base.setindex!(
  A::FallbackArrayWrapper,
  v,
  i::Vararg{Int,N},
) where {N} = setindex!(A.data, v, i...)
Base.IndexStyle(::Type{<:FallbackArrayWrapper}) = IndexLinear()

const RUN_SLOW_TESTS =
  LoopVectorization.register_count() ≤ 16 ||
  !parse(Bool, get(ENV, "GITHUB_ACTIONS", "false"))

@testset "Print Methods" begin
  @show @__LINE__
  selfdotq = :(
    for i ∈ eachindex(a)
      s += a[i] * a[i] + i
    end
  )
  lsselfdot = LoopVectorization.loopset(selfdotq)
  io = IOBuffer()
  println(io, LoopVectorization.operations(lsselfdot))
  s = String(take!(io))
  @test occursin("Operation[", s)
  @test occursin("s = 0", s)
  @test occursin("s = LoopVectorization.vfmadd_fast", s)

  AmulBq = :(
    for m ∈ 1:M, n ∈ 1:N
      C[m, n] = zero(eltype(B))
      for k ∈ 1:K
        C[m, n] += A[m, k] * B[k, n]
      end
    end
  )
  lsAmulB = LoopVectorization.loopset(AmulBq)
  println(io, LoopVectorization.operations(lsAmulB))
  s = String(take!(io))
  @test occursin("Operation[", s)
  @test occursin("C[m, n] = ", s)
  @test occursin(" = A[m, k]", s)
  @test occursin(" = B[k, n]", s)
  @test occursin(" = LoopVectorization.vfmadd_fast", s)
  # @test occursin(" = LoopVectorization.reduce_to_add", s)
end

function should_broadcast_op(op::Operation)
  (isvectorized(op) || iszero(length(children(op)))) && return false
  for opc ∈ children(op)
    (!isvectorized(op) || accesses_memory(op)) && return false
  end
  true
end

@inline sizeequivalentfloat(
  ::Type{T}
) where {T<:Union{Float16,Float32,Float64}} = T
@inline sizeequivalentfloat(::Type{T}) where {T<:Union{Int8,UInt8}} = Float32
@inline sizeequivalentfloat(::Type{T}) where {T<:Union{Int16,UInt16}} = Float16
@inline sizeequivalentfloat(::Type{T}) where {T<:Union{Int32,UInt32}} = Float32
@inline sizeequivalentfloat(::Type{T}) where {T<:Union{Int64,UInt64}} = Float64
@inline sizeequivalentint(::Type{T}) where {T<:Integer} = T
@inline sizeequivalentfloat(::Type{T}, x) where {T} = sizeequivalentfloat(T)(x)
@inline sizeequivalentint(::Type{T}, x) where {T} = sizeequivalentint(T)(x)

if (Sys.ARCH === :x86_64) || (Sys.ARCH === :i686)
  @inline widest_supported_integer(::True) = Int64
  @inline widest_supported_integer(::False) = Int32
  @inline sizeequivalentint(::Type{Float64}) = widest_supported_integer(
    VectorizationBase.has_feature(Val(:x86_64_avx512dq))
  )
else
  @inline sizeequivalentint(::Type{Float64}) = Int
end
@inline sizeequivalentint(::Type{Float32}) = Int32
@inline sizeequivalentint(::Type{Float16}) = Int16

@inline zerofloat(::Type{T}) where {T} = zero(sizeequivalentfloat(T))
@inline zerointeger(::Type{T}) where {T} = zero(sizeequivalentint(T))

function typeof_sym(ls::LoopSet, op::Operation, zerotyp::NumberType)
  if zerotyp == HardInt
    newtypeT = gensym(:IntType)
    pushpreamble!(
      ls,
      Expr(:(=), newtypeT, Expr(:call, lv(:sizeequivalentint), ELTYPESYMBOL))
    )
    newtypeT
  elseif zerotyp == HardFloat
    newtypeT = gensym(:FloatType)
    pushpreamble!(
      ls,
      Expr(:(=), newtypeT, Expr(:call, lv(:sizeequivalentfloat), ELTYPESYMBOL))
    )
    newtypeT
  else
    ELTYPESYMBOL
  end
end

function lower_zero!(
  q::Expr,
  op::Operation,
  ls::LoopSet,
  ua::UnrollArgs,
  zerotyp::NumberType = zerotype(ls, op)
)
  @unpack u₁, u₁loopsym, u₂loopsym, vloopsym, vloop, u₂max, suffix = ua
  mvar, opu₁, opu₂ =
    variable_name_and_unrolled(op, u₁loopsym, u₂loopsym, vloopsym, suffix, ls)
  !opu₂ && suffix > 0 && return
  # TODO: for u₁, needs to consider if reducedchildren are u₁-unrolled
  #       reductions need to consider reduct-status
  # if !opu₁
  #     opu₁ = u₁loopsym ∈ reducedchildren(op)
  # end
  typeT = typeof_sym(ls, op, zerotyp)
  # TODO: make should_broadcast_op handle everything.
  if isvectorized(op) ||
     vloopsym ∈ reducedchildren(op) ||
     vloopsym ∈ reduceddependencies(op) ||
     should_broadcast_op(op)
    if opu₁ && u₁ > 1
      call = Expr(
        :call,
        lv(:zero_vecunroll),
        staticexpr(u₁),
        VECTORWIDTHSYMBOL,
        typeT,
        staticexpr(reg_size(ls))
      )
    else
      call = Expr(
        :call,
        lv(:_vzero),
        VECTORWIDTHSYMBOL,
        typeT,
        staticexpr(reg_size(ls))
      )
    end
  else
    call = Expr(:call, :zero, typeT)
    if opu₁ && u₁ > 1
      t = Expr(:tuple)
      for u ∈ 1:u₁
        push!(t.args, call)
      end
      call = Expr(:call, lv(:VecUnroll), t)
    end
  end
  if (suffix == -1) && opu₂
    for u ∈ 0:u₂max-1
      push!(
        q.args,
        Expr(:(=), Symbol(mvar, u, "__", Core.ifelse(opu₁, u₁, 1)), call)
      )
    end
  else
    mvar = Symbol(mvar, '_', Core.ifelse(opu₁, u₁, 1))
    push!(q.args, Expr(:(=), mvar, call))
  end
  nothing
end
# Have to awkwardly search through `operations(ls)` to try and find op's child
function getparentsreductzero(ls::LoopSet, op::Operation)::Float64
  opname = name(op)
  for opp ∈ operations(ls)
    if name(opp) === opname &&
       opp !== op &&
       iscompute(opp) &&
       search_tree(parents(opp), opname) &&
       length(reduceddependencies(opp)) > 0
      return reduction_instruction_class(instruction(opp))
    end
  end
  throw("Reduct zero not found for operation $(name(op)).")
end
vecbasefunc(f) = Expr(
  :(.),
  Expr(:(.), :LoopVectorization, QuoteNode(:VectorizationBase)),
  QuoteNode(f)
)
function lower_constant!(q::Expr, op::Operation, ls::LoopSet, ua::UnrollArgs)
  @unpack u₁, u₁loopsym, u₂loopsym, vloopsym, u₂max, suffix = ua
  mvar, opu₁, opu₂ =
    variable_name_and_unrolled(op, u₁loopsym, u₂loopsym, vloopsym, suffix, ls)
  !opu₂ && suffix > 0 && return
  instr = instruction(op)
  instr.mod === GLOBALCONSTANT && return
  constsym = constantopname(op)# instr.instr
  reducedchildvectorized = vloopsym ∈ reducedchildren(op)
  if reducedchildvectorized ||
     isvectorized(op) ||
     vloopsym ∈ reduceddependencies(op) ||
     should_broadcast_op(op)
    # call = Expr(:call, lv(:vbroadcast), W, Expr(:call, lv(:maybeconvert), typeT, constsym))
    call = if reducedchildvectorized && vloopsym ∉ loopdependencies(op)
      instrclass = getparentsreductzero(ls, op)
      if instrclass == ADDITIVE_IN_REDUCTIONS
        Expr(
          :call,
          vecbasefunc(:addscalar),
          Expr(:call, lv(:vzero), VECTORWIDTHSYMBOL, ELTYPESYMBOL),
          constsym
        )
      elseif instrclass == MULTIPLICATIVE_IN_REDUCTIONS
        Expr(
          :call,
          vecbasefunc(:mulscalar),
          Expr(
            :call,
            lv(:vbroadcast),
            VECTORWIDTHSYMBOL,
            Expr(:call, :one, ELTYPESYMBOL)
          ),
          constsym
        )
      elseif instrclass == MAX
        Expr(
          :call,
          vecbasefunc(:maxscalar),
          Expr(
            :call,
            lv(:vbroadcast),
            VECTORWIDTHSYMBOL,
            Expr(:call, :typemin, ELTYPESYMBOL)
          ),
          constsym
        )
      elseif instrclass == MIN
        Expr(
          :call,
          vecbasefunc(:minscalar),
          Expr(
            :call,
            lv(:vbroadcast),
            VECTORWIDTHSYMBOL,
            Expr(:call, :typemax, ELTYPESYMBOL)
          ),
          constsym
        )
      else
        throw(
          "Reductions of type $(reduction_zero(instrclass)) not yet supported; please file an issue as a reminder to take care of this."
        )
      end
    else
      Expr(:call, lv(:vbroadcast), VECTORWIDTHSYMBOL, constsym)
    end
    if opu₁ && u₁ > 1
      # broadcastsym = Symbol(mvar, "_#init#")
      # push!(q.args, Expr(:(=), broadcastsym, call))
      t = Expr(:tuple)
      for u ∈ 1:u₁
        push!(t.args, call)
      end
      call = Expr(:call, lv(:VecUnroll), t)
    end
  elseif opu₁ && u₁ > 1
    t = Expr(:tuple)
    for u ∈ 1:u₁
      push!(t.args, constsym)
    end
    call = Expr(:call, lv(:VecUnroll), t)
  elseif opu₂ & (suffix == -1)
    for u ∈ 0:u₂max-1
      push!(q.args, Expr(:(=), Symbol(mvar, u, "__", 1), constsym))
    end
    return nothing
  else
    push!(q.args, Expr(:(=), Symbol(mvar, '_', 1), constsym))
    return nothing
  end
  u₁tag = Core.ifelse(opu₁, u₁, 1)
  if opu₂ & (suffix == -1)
    for u ∈ 0:u₂max-1
      push!(q.args, Expr(:(=), Symbol(mvar, u, "__", u₁tag), call))
    end
  else
    mvar = Symbol(mvar, '_', u₁tag)
    push!(q.args, Expr(:(=), mvar, call))
  end
  nothing
end

isconstantop(op::Operation) =
  (instruction(op) == LOOPCONSTANT) ||
  (isconstant(op) && length(loopdependencies(op)) == 0)
function isinitializedconst(op::Operation)
  if isconstant(op)
    return true
  elseif iscompute(op)
    for opp ∈ parents(op)
      isinitializedconst(opp) || return false
    end
    return true
  end
  false
end
function constantopname(op::Operation)
  instr = instruction(op)
  if instr === LOOPCONSTANT
    Symbol(mangledvar(op), '_', 1)
  else
    instr.instr
  end
end
function setop!(ls, op, val)
  pushpreamble!(ls, Expr(:(=), constantopname(op), val))
  nothing
end
function setconstantop!(ls, op, val)
  if instruction(op) === LOOPCONSTANT# && mangledvar(op) !== val
    pushpreamble!(ls, Expr(:(=), Symbol(mangledvar(op), '_', 1), val))
    # pushpreamble!(ls, Expr(:(=), mangledvar(op), val))
  end
  nothing
end

# @inline maybeconvert(::Type{T}, s::Number) where {T} = convert(T, s)
# @inline maybeconvert(::Type{T}, s::T) where {T <: Number} = s
# @inline maybeconvert(::Type, s) = s
function sizeequivalent_symint_expr(intval::Int, signed::Bool)
  if signed
    Expr(:call, lv(:sizeequivalentint), ELTYPESYMBOL, intval)
  else
    Expr(:call, lv(:sizeequivalentint), ELTYPESYMBOL, intval % UInt)
  end
end

function lower_licm_constants!(ls::LoopSet)
  ops = operations(ls)
  for (id, sym) ∈ ls.preamble_symsym
    isouterreduct = false
    for or ∈ ls.outer_reductions
      isouterreduct |= mangledvar(ls.operations[or]) === mangledvar(ops[id])
    end
    isouterreduct || setconstantop!(ls, ops[id], sym)
    # setconstantop!(ls, ops[id],  sym)
    # setconstantop!(ls, ops[id], Expr(:call, lv(:maybeconvert), ls.T, sym))
  end
  for (id, (intval, intsz, signed)) ∈ ls.preamble_symint
    if intsz == 1
      setop!(ls, ops[id], intval % Bool)
    else
      setop!(ls, ops[id], sizeequivalent_symint_expr(intval, signed))
    end
  end
  for (id, floatval) ∈ ls.preamble_symfloat
    setop!(
      ls,
      ops[id],
      Expr(:call, lv(:sizeequivalentfloat), ELTYPESYMBOL, floatval)
    )
  end
  for (id, typ) ∈ ls.preamble_zeros
    instruction(ops[id]) === LOOPCONSTANT || continue
    if typ == IntOrFloat
      setconstantop!(ls, ops[id], Expr(:call, :zero, ELTYPESYMBOL))
    elseif typ == HardInt
      setconstantop!(ls, ops[id], Expr(:call, lv(:zerointeger), ELTYPESYMBOL))
    else#if typ == HardFloat
      setconstantop!(ls, ops[id], Expr(:call, lv(:zerofloat), ELTYPESYMBOL))
    end
  end
  for (id, f) ∈ ls.preamble_funcofeltypes
    setop!(ls, ops[id], Expr(:call, reduction_zero(f), ELTYPESYMBOL))
  end
end

function pushconstvalue!(v::Vector{Any}, ls::LoopSet, op::Operation)::Bool
  isconstant(op) || return true
  opid = identifier(op)
  for (id, (intval, intsz, signed)) ∈ ls.preamble_symint
    id == opid || continue
    if intsz == 1
      push!(v, intval % Bool)
      return false
    elseif intsz == 1
      signed ? push!(v, intval % Int8) : push!(v, intval % UInt8)
    elseif intsz == 2
      signed ? push!(v, intval % Int16) : push!(v, intval % UInt16)
    elseif intsz == 4
      signed ? push!(v, intval % Int32) : push!(v, intval % UInt32)
    else
      signed ? push!(v, intval) : push!(v, unsigned(intval))
    end
    return false
  end
  for (id, floatval) ∈ ls.preamble_symfloat
    if id == opid
      push!(v, floatval)
      return false
    end
  end
  for (id, typ) ∈ ls.preamble_zeros
    id == opid || continue
    if typ == HardFloat
      push!(v, 0.0)
    else
      push!(v, 0)
    end
    return false
  end
  for (id, f) ∈ ls.preamble_funcofeltypes
    id == opid || continue
    x = reduction_zero(f)
    if x == ADDITIVE_IN_REDUCTIONS
      push!(v, 0)
    elseif x == MULTIPLICATIVE_IN_REDUCTIONS
      push!(v, 1)
    elseif x == MAX
      push!(v, -Inf)
    elseif x == MIN
      push!(v, Inf)
    elseif x == ALL
      push!(v, true)
    elseif x == ANY
      push!(v, false)
    else
      return true
    end
    return false
  end
  return true
end

import VectorizationBase: vsum

@inline vreduce(::typeof(+), v::VectorizationBase.AbstractSIMDVector) = vsum(v)
@inline vreduce(::typeof(*), v::VectorizationBase.AbstractSIMDVector) = vprod(v)
@inline vreduce(::typeof(max), v::VectorizationBase.AbstractSIMDVector) =
  vmaximum(v)
@inline vreduce(::typeof(min), v::VectorizationBase.AbstractSIMDVector) =
  vminimum(v)
@inline vreduce(op, v::VectorizationBase.AbstractSIMDVector) =
  vec_vreduce(op, v)
@inline vec_reduce(op, v::VectorizationBase.AbstractSIMDVector) =
  vec_reduce(op, Vec(v))
vec_vreduce(op, v::Vec{1}) = VectorizationBase.extractelement(v, 0)
@inline function vec_vreduce(op, v::Vec{W}) where {W}
  a = op(
    VectorizationBase.extractelement(v, 0),
    VectorizationBase.extractelement(v, 1)
  )
  for i ∈ 2:W-1
    a = op(a, VectorizationBase.extractelement(v, i))
  end
  a
end

function mapreduce_simple(
  f::F,
  op::OP,
  args::Vararg{AbstractArray,A}
) where {F,OP,A}
  ptrargs = ntuple(a -> pointer(args[a]), Val(A))
  N = length(first(args))
  iszero(N) && throw("Length of vector is 0!")
  st = ntuple(a -> VectorizationBase.static_sizeof(eltype(args[a])), Val(A))
  a_0 = f(VectorizationBase.__vload.(ptrargs, False(), register_size())...)
  i = 1
  while i < N
    a_0 = op(
      a_0,
      f(
        VectorizationBase.__vload.(
          ptrargs,
          VectorizationBase.lazymul.(st, i),
          False(),
          register_size()
        )...
      )
    )
    i += 1
  end
  a_0
end

"""
    vmapreduce(f, op, A::DenseArray...)

Vectorized version of `mapreduce`. Applies `f` to each element of the arrays `A`, and reduces the result with `op`.
"""
@inline function vmapreduce(
  f::F,
  op::OP,
  arg1::AbstractArray{T},
  args::Vararg{AbstractArray{T},A}
) where {F,OP,T<:NativeTypes,A}
  if !(check_args(arg1, args...) && all_dense(arg1, args...))
    return mapreduce(f, op, arg1, args...)
  end
  N = length(arg1)
  iszero(A) || @assert all(length.(args) .== N)
  W = VectorizationBase.pick_vector_width(T)
  if N < W
    mapreduce_simple(f, op, arg1, args...)
  else
    _vmapreduce(f, op, W, N, T, arg1, args...)
  end
end
@inline function _vmapreduce(
  f::F,
  op::OP,
  ::StaticInt{W},
  N,
  ::Type{T},
  args::Vararg{AbstractArray{<:NativeTypes},A}
) where {F,OP,A,W,T}
  ptrargs = VectorizationBase.zero_offsets.(stridedpointer.(args))
  if N ≥ 4W
    index = VectorizationBase.Unroll{1,W,4,1,W,zero(UInt)}((Zero(),))
    i = 4W
    au = f(vload.(ptrargs, index)...)
    while i < N - ((W << 2) - 1)
      index = VectorizationBase.Unroll{1,W,4,1,W,zero(UInt)}((i,))
      i += 4W
      au = op(au, f(vload.(ptrargs, index)...))
    end
    a_0 = VectorizationBase.reduce_to_onevec(op, au)
  else
    a_0 = f(vload.(ptrargs, ((MM{W}(Zero()),),))...)
    i = W
  end
  while i < N - (W - 1)
    a_0 = op(a_0, f(vload.(ptrargs, ((MM{W}(i),),))...))
    i += W
  end
  if i < N
    m = mask(T, N & (W - 1))
    a_0 = ifelse(m, op(a_0, f(vload.(ptrargs, ((MM{W}(i),),))...)), a_0)
  end
  vreduce(op, a_0)
end
@inline vmapreduce(f, op, args...) = mapreduce(f, op, args...)

"""
    vsum(A::DenseArray)
    vsum(f, A::DenseArray)

Vectorized version of `sum`. Providing a function as the first argument
will apply the function to each element of `A` before summing.
"""
@inline vsum(f::F, A::AbstractArray{T}) where {F,T<:NativeTypes} =
  vmapreduce(f, +, A)
@inline vsum(A::AbstractArray{T}) where {T<:NativeTypes} = vsum(identity, A)

length_one_axis(::Base.OneTo) = Base.OneTo(1)
length_one_axis(::Any) = 1:1

"""
    vreduce(op, A::DenseArray; [dims::Int])

Vectorized version of `reduce`. Reduces the array `A` using the operator `op`.
At most one dimension may be supplied as kwarg.
"""
@inline vreduce(op, arg) = vmapreduce(identity, op, arg)

for (op, init) in zip((:+, :max, :min), (:zero, :typemin, :typemax))
  @eval @inline function vreduce(::typeof($op), arg; dims = nothing)
    if !(check_args(arg) && all_dense(arg))
      return reduce($op, arg; dims = dims)
    end
    dims === nothing && return _vreduce($op, arg)
    isone(ndims(arg)) && return [_vreduce($op, arg)]
    @assert length(dims) == 1
    axes_arg = axes(arg)
    axes_out = Base.setindex(axes_arg, length_one_axis(axes_arg[dims]), dims)
    out = similar(arg, axes_out)
    # fill!(out, $init(first(arg)))
    # TODO: generated function with Base.Cartesian.@nif to set to ndim(arg)
    Base.Cartesian.@nif 5 d -> (d <= ndims(arg) && dims == d) d -> begin
      Rpre = CartesianIndices(ntuple(i -> axes_arg[i], d - 1))
      Rpost = CartesianIndices(ntuple(i -> axes_arg[i+d], ndims(arg) - d))
      _vreduce_dims!(out, $op, Rpre, static_axes(arg, dims), Rpost, arg)
    end d -> begin
      Rpre = CartesianIndices(axes_arg[1:dims-1])
      Rpost = CartesianIndices(axes_arg[dims+1:end])
      _vreduce_dims!(out, $op, Rpre, static_axes(arg, dims), Rpost, arg)
    end
  end

  @eval @inline function _vreduce_dims!(
    out,
    ::typeof($op),
    Rpre,
    is,
    Rpost,
    arg
  )
    s = $init(first(arg))
    @turbo for Ipost in Rpost, Ipre in Rpre
      accum = s
      for i in is
        accum = $op(accum, arg[Ipre, i, Ipost])
      end
      out[Ipre, 1, Ipost] = accum
    end
    return out
  end

  @eval @inline function _vreduce(::typeof($op), arg)
    s = $init(first(arg))
    @turbo for i in eachindex(arg)
      s = $op(s, arg[i])
    end
    return s
  end
end

import LinearAlgebra
function issue407!(Hdata::Matrix{Complex{T}}) where {T}
  Hview = reinterpret(reshape, T, Hdata)
  @tturbo for i = 1:size(Hdata, 1)
    Hview[1, i, i] = i
  end
end
function lv_turbo(r::Vector{UInt64}, mask::UInt64)
  @turbo for i = 1:length(r)
    r[i] &= mask
  end
  r
end

@testset "Simple Miscellaneous" begin
  @show @__LINE__
  r1 = rand(UInt, 239)
  mask = ~(one(eltype(r1)) << (2))
  r2 = r1 .& mask
  @test lv_turbo(r1, mask) == r2
end
@testset "issue 407" begin
  @show @__LINE__
  A = zeros(Complex{Float64}, 10, 10)
  issue407!(A)
  @test real.(A) == LinearAlgebra.Diagonal(1:10)
  @test all(iszero, imag.(A))
end
function issue480(x, y)
  z = false
  @turbo for i in eachindex(x)
    z |= x[i] > y[i]
  end
  z
end
@testset "issue 480" begin
  using LoopVectorization
  x = zeros(33)
  y = zeros(33)
  @test !issue480(x, y)
  for i in eachindex(x)
    x[i] = 1.0
    @test issue480(x, y)
    x[i] = 0.0
  end
end

function mysum_checked(x)
  s = zero(eltype(x))
  @turbo check_empty = true for i ∈ eachindex(x)
    s += x[i]
  end
  s
end
function mysum_unchecked(x)
  s = zero(eltype(x))
  @turbo for i ∈ eachindex(x)
    s += x[i]
  end
  s
end

@testset "Check Empty" begin
  @show @__LINE__
  x = fill(9999, 100, 10, 10)
  xv = view(x, :, 1:0, :)
  @test mysum_checked(x) == mysum_unchecked(x) == sum(x)
  @test iszero(mysum_checked(xv))
  @test !iszero(mysum_unchecked(xv))

end

function broutine2x2!(S::AbstractMatrix{Complex{T}}, U::AbstractMatrix, locs::Int) where {T}
  step_1 = 1 << (locs - 1)
  step_2 = 1 << locs
  U11_re = real(U[1, 1])
  U11_im = imag(U[1, 1])
  U12_re = real(U[1, 2])
  U12_im = imag(U[1, 2])
  U21_re = real(U[2, 1])
  U21_im = imag(U[2, 1])
  U22_re = real(U[2, 2])
  U22_im = imag(U[2, 2])

  Hmax = size(S, 2)
  Sr = reinterpret(reshape, T, S)

  if step_1 == 1
    for _j = 0:(Hmax>>>locs)-1, b in axes(S, 1)
      j = _j << locs

      ST1_re =
        U11_re * Sr[1, b, j+1] - U11_im * Sr[2, b, j+1] + U12_re * Sr[1, b, j+2] -
        U12_im * Sr[2, b, j+2]
      ST1_im =
        U11_re * Sr[2, b, j+1] +
        U11_im * Sr[1, b, j+1] +
        U12_re * Sr[2, b, j+2] +
        U12_im * Sr[1, b, j+2]
      ST2_re =
        U21_re * Sr[1, b, j+1] - U21_im * Sr[2, b, j+1] + U22_re * Sr[1, b, j+2] -
        U22_im * Sr[2, b, j+2]
      ST2_im =
        U21_re * Sr[2, b, j+1] +
        U21_im * Sr[1, b, j+1] +
        U22_re * Sr[2, b, j+2] +
        U22_im * Sr[1, b, j+2]


      Sr[1, b, j+1] = ST1_re
      Sr[2, b, j+1] = ST1_im
      Sr[1, b, j+2] = ST2_re
      Sr[2, b, j+2] = ST2_im
    end
    return S
  end
end

function broutine2x2_avx!(
  S::AbstractMatrix{Complex{T}},
  U::AbstractMatrix,
  locs::Int,
) where {T}
  step_1 = 1 << (locs - 1)
  step_2 = 1 << locs
  U11_re = real(U[1, 1])
  U11_im = imag(U[1, 1])
  U12_re = real(U[1, 2])
  U12_im = imag(U[1, 2])
  U21_re = real(U[2, 1])
  U21_im = imag(U[2, 1])
  U22_re = real(U[2, 2])
  U22_im = imag(U[2, 2])

  Hmax = size(S, 2)
  Sr = reinterpret(reshape, T, S)

  if step_1 == 1
    @turbo for _j = 0:(Hmax>>>locs)-1, b in axes(S, 1)
      j = _j << locs

      ST1_re =
        U11_re * Sr[1, b, j+1] - U11_im * Sr[2, b, j+1] + U12_re * Sr[1, b, j+2] -
        U12_im * Sr[2, b, j+2]
      ST1_im =
        U11_re * Sr[2, b, j+1] +
        U11_im * Sr[1, b, j+1] +
        U12_re * Sr[2, b, j+2] +
        U12_im * Sr[1, b, j+2]
      ST2_re =
        U21_re * Sr[1, b, j+1] - U21_im * Sr[2, b, j+1] + U22_re * Sr[1, b, j+2] -
        U22_im * Sr[2, b, j+2]
      ST2_im =
        U21_re * Sr[2, b, j+1] +
        U21_im * Sr[1, b, j+1] +
        U22_re * Sr[2, b, j+2] +
        U22_im * Sr[1, b, j+2]


      Sr[1, b, j+1] = ST1_re
      Sr[2, b, j+1] = ST1_im
      Sr[1, b, j+2] = ST2_re
      Sr[2, b, j+2] = ST2_im
    end
    return S
  end
end

@testset "Quantum" begin
  N = 10
  S = rand(ComplexF64, 100, 1 << N)
  U = rand(ComplexF64, 2, 2)

  S1 = broutine2x2!(copy(S), U, 1)
  S2 = broutine2x2_avx!(copy(S), U, 1)
  @test S1 ≈ S2 # 239
end

using LoopVectorization
using LinearAlgebra
using OffsetArrays
using Test

if !isdefined(@__MODULE__, Symbol("@_avx"))
  include("testsetup.jl")
end

@testset "Miscellaneous" begin
  # T = Float32
  # Unum, Tnum = LoopVectorization.register_count() == 16 ? (1, 6) : (1, 8)
  dot3q = :(
    for m ∈ 1:M, n ∈ 1:N
      s += x[m] * A[m, n] * y[n]
    end
  )
  lsdot3 = LoopVectorization.loopset(dot3q)
  if LoopVectorization.register_count() ≠ 32
    # @test LoopVectorization.choose_order(lsdot3) == ([:n, :m], :n, :m, :m, 1, 6)
    @test LoopVectorization.choose_order(lsdot3) == ([:n, :m], :m, :n, :m, 1, 6)
  elseif Bool(LoopVectorization.has_opmask_registers())
    # @test LoopVectorization.choose_order(lsdot3) == ([:n, :m], :n, Symbol("##undefined##"), :m, 4, -1)
    @test LoopVectorization.choose_order(lsdot3) == ([:n, :m], :m, :n, :m, 1, 8)
  else
    @test LoopVectorization.choose_order(lsdot3) == ([:n, :m], :m, :n, :m, 1, 8)
    # @test LoopVectorization.choose_order(lsdot3) == ([:n, :m], :n, :m, :m, 1, 8)
  end

  @static if VERSION < v"1.4"
    dot3(x, A, y) = dot(x, A * y)
  else
    dot3(x, A, y) = dot(x, A, y)
  end
  function dot3avx(x, A, y)
    s = zero(promote_type(eltype(x), eltype(A), eltype(y)))
    @turbo for m ∈ axes(A, 1), n ∈ axes(A, 2)
      s += x[m] * A[m, n] * y[n]
    end
    s
  end
  function dot3v2avx(x, A, y)
    s = zero(promote_type(eltype(x), eltype(A), eltype(y)))
    @turbo for n ∈ axes(A, 2)
      t = zero(s)
      for m ∈ axes(A, 1)
        t += x[m] * A[m, n]
      end
      s += t * y[n]
    end
    s
  end
  q = :(
    for n ∈ 1:N
      t = zero(s)
      for m ∈ 1:M
        t += x[m] * A[m, n]
      end
      s += t * y[n]
    end
  )
  ls = LoopVectorization.loopset(q)

  function dot3avx24(x, A, y)
    M, N = size(A)
    s = zero(promote_type(eltype(x), eltype(A), eltype(y)))
    @turbo unroll = (2, 4) for m ∈ 1:M, n ∈ 1:N
      s += x[m] * A[m, n] * y[n]
    end
    s
  end
  function dot3_avx(x, A, y)
    M, N = size(A)
    s = zero(promote_type(eltype(x), eltype(A), eltype(y)))
    @_avx for m ∈ 1:M, n ∈ 1:N
      s += x[m] * A[m, n] * y[n]
    end
    s
  end

  subcolq = :(
    for i ∈ 1:size(A, 2), j ∈ eachindex(x)
      B[j, i] = A[j, i] - x[j]
    end
  )
  lssubcol = LoopVectorization.loopset(subcolq)
  # @test LoopVectorization.choose_order(lssubcol) == (Symbol[:i,:j], :i, Symbol("##undefined##"), :j, 1, -1)
  # @test LoopVectorization.choose_order(lssubcol) == (Symbol[:i,:j], :j, :i, :j, 1, 8)
  @test LoopVectorization.choose_order(lssubcol) == (
    Symbol[:i, :j],
    :j,
    :i,
    :j,
    1,
    ifelse((LoopVectorization.register_count() == 32), 8, 6),
  )

  # if LoopVectorization.register_count() != 8
  #     # @test LoopVectorization.choose_order(lssubcol) == (Symbol[:j,:i], :j, :i, :j, Unum, Tnum)
  #     @test LoopVectorization.choose_order(lssubcol) == (Symbol[:j,:i], :j, :i, :j, 1, 1)
  # end
  # @test LoopVectorization.choose_order(lssubcol) == (Symbol[:i,:j], :i, Symbol("##undefined##"), :j, 1, -1)
  # @test LoopVectorization.choose_order(lssubcol) == (Symbol[:j,:i], :i, Symbol("##undefined##"), :j, 4, -1)
  # if LoopVectorization.register_count() == 32
  #     @test LoopVectorization.choose_order(lssubcol) == (Symbol[:i,:j], :j, :i, :j, 2, 10)
  # elseif LoopVectorization.register_count() == 16
  #     @test LoopVectorization.choose_order(lssubcol) == (Symbol[:i,:j], :j, :i, :j, 2, 6)
  # end
  # @test LoopVectorization.choose_order(lssubcol) == (Symbol[:j,:i], :j, Symbol("##undefined##"), :j, 4, -1)
  ## @turbo is SLOWER!!!!
  ## need to fix!
  function mysubcol!(B, A, x)
    @inbounds for i ∈ 1:size(A, 2)
      @simd for j ∈ eachindex(x)
        B[j, i] = A[j, i] - x[j]
      end
    end
  end
  function mysubcolavx!(B, A, x)
    @turbo for i ∈ 1:size(A, 2), j ∈ eachindex(x)
      B[j, i] = A[j, i] - x[j]
    end
  end
  function mysubcol_avx!(B, A, x)
    @_avx for i ∈ 1:size(A, 2), j ∈ eachindex(x)
      B[j, i] = A[j, i] - x[j]
    end
  end

  colsumq = :(
    for i ∈ 1:size(A, 2), j ∈ eachindex(x)
      x[j] += A[j, i] - 1 / 4
    end
  )
  lscolsum = LoopVectorization.loopset(colsumq)
  # if LoopVectorization.register_count() != 8
  #     # @test LoopVectorization.choose_order(lscolsum) == (Symbol[:j,:i], :j, :i, :j, Unum, Tnum)
  #     @test LoopVectorization.choose_order(lscolsum) == (Symbol[:j,:i], :j, :i, :j, 1, 1)
  # end
  if Sys.ARCH === :aarch64
    @test LoopVectorization.choose_order(lscolsum) ==
          (Symbol[:j, :i], :j, Symbol("##undefined##"), :j, 8, -1)
  else
    @test LoopVectorization.choose_order(lscolsum) ==
          (Symbol[:j, :i], :j, Symbol("##undefined##"), :j, 4, -1)
  end
  # my colsum is wrong (by 0.25), but slightly more interesting
  function mycolsum!(x, A)
    @. x = 0
    @inbounds for i ∈ 1:size(A, 2)
      @simd for j ∈ eachindex(x)
        x[j] += A[j, i] - 0.25
      end
    end
  end
  function mycolsumavx!(x, A)
    @turbo for j ∈ eachindex(x)
      xⱼ = zero(eltype(x))
      for i ∈ 1:size(A, 2)
        xⱼ += A[j, i] - 0.25
      end
      x[j] = xⱼ
    end
  end
  function mycolsum_avx!(x, A)
    @_avx for j ∈ eachindex(x)
      xⱼ = zero(eltype(x))
      for i ∈ 1:size(A, 2)
        xⱼ += A[j, i] - 1 / 4
      end
      x[j] = xⱼ
    end
  end

  varq = :(
    for j ∈ eachindex(s²), i ∈ 1:size(A, 2)
      δ = A[j, i] - x̄[j]
      s²[j] += δ * δ
    end
  )
  lsvar = LoopVectorization.loopset(varq)
  # LoopVectorization.choose_order(lsvar)
  # @test LoopVectorization.choose_order(lsvar) == (Symbol[:j,:i], :j, :i, :j, Unum, Tnum)
  # if LoopVectorization.register_count() == 32
  if Sys.ARCH === :aarch64
    @test LoopVectorization.choose_order(lsvar) ==
          (Symbol[:j, :i], :j, Symbol("##undefined##"), :j, 8, -1)
  else
    @test LoopVectorization.choose_order(lsvar) ==
          (Symbol[:j, :i], :j, Symbol("##undefined##"), :j, 4, -1)
  end
  #     @test LoopVectorization.choose_order(lsvar) == (Symbol[:j,:i], :j, :i, :j, 2, 10)
  # else#if LoopVectorization.register_count() == 16
  # @test LoopVectorization.choose_order(lsvar) == (Symbol[:j,:i], :j, Symbol("##undefined##"), :j, 8, -1)
  #     @test LoopVectorization.choose_order(lsvar) == (Symbol[:j,:i], :j, :i, :j, 2, 6)
  # end
  function piestsimd(rounds)
    pi = 1.0

    @simd for i = 2:(rounds+2)
      x = (-1)^iseven(i)
      pi += x / (2 * i - 1)
    end

    return pi * 4
  end
  function piestturbo(rounds)
    pi = 1.0

    @turbo for i = 2:(rounds+2)
      x = (-1)^iseven(i)
      pi += x / (2 * i - 1)
    end

    return pi * 4
  end
  @test piestturbo(4096) ≈ π rtol = 1e-4
  @test piestturbo(2000) ≈ piestsimd(2000)
  function myvar!(s², A, x̄)
    @. s² = 0
    @inbounds for i ∈ 1:size(A, 2)
      @simd for j ∈ eachindex(s²)
        δ = A[j, i] - x̄[j]
        s²[j] += δ * δ
      end
    end
  end
  function myvaravx!(s², A, x̄)
    @turbo for j ∈ eachindex(s²)
      s²ⱼ = zero(eltype(s²))
      x̄ⱼ = x̄[j]
      for i ∈ 1:size(A, 2)
        δ = A[j, i] - x̄ⱼ
        s²ⱼ += δ * δ
      end
      s²[j] = s²ⱼ
    end
  end
  function myvar_avx!(s², A, x̄)
    @_avx for j ∈ eachindex(s²)
      s²ⱼ = zero(eltype(s²))
      x̄ⱼ = x̄[j]
      for i ∈ 1:size(A, 2)
        δ = A[j, i] - x̄ⱼ
        s²ⱼ += δ * δ
      end
      s²[j] = s²ⱼ
    end
  end

  function setcolumstovectorplus100!(Z::AbstractArray{T}, A) where {T}
    for i in axes(A, 1), j in axes(Z, 2)
      acc = zero(T)
      acc = acc + A[i] + 100
      Z[i, j] = acc
    end
  end
  function setcolumstovectorplus100avx!(Z::AbstractArray{T}, A) where {T}
    @turbo for i in axes(A, 1), j in axes(Z, 2)
      acc = zero(T)
      acc = acc + A[i] + (26 + 74)
      Z[i, j] = acc
    end
  end

  function mvp(P, basis, coeffs::Vector{T}) where {T}
    len_c = length(coeffs)
    len_P = size(P, 1)
    p = zero(T)
    for n = 1:len_c
      pn = coeffs[n]
      for a = 1:len_P
        pn *= P[a, basis[a, n]]
      end
      p += pn
    end
    return p
  end
  function mvpavx(P, basis, coeffs::Vector{T}) where {T}
    C = length(coeffs)
    A = size(P, 1)
    p = zero(T)
    @turbo for c ∈ 1:C
      pc = coeffs[c]
      for a = 1:A
        pc *= P[a, basis[a, c]]
      end
      p += pc
    end
    return p
  end
  function mvp_avx(P, basis, coeffs::Vector{T}) where {T}
    len_c = length(coeffs)
    len_P = size(P, 1)
    p = zero(T)
    @_avx for n = 1:len_c
      pn = coeffs[n]
      for a = 1:len_P
        pn *= P[a, basis[a, n]]
      end
      p += pn
    end
    return p
  end
  bq = :(
    for n = 1:len_c
      pn = coeffs[n]
      for a = 1:len_P
        pn *= P[a, basis[a, n]]
      end
      p += pn
    end
  )
  lsb = LoopVectorization.loopset(bq)
  function threemulaccum_lv(A, B, C)
    D = zero(promote_type(eltype(A), eltype(B), eltype(C)))
    @turbo for i in axes(C, 1), j in axes(C, 2), k in axes(C, 3)
      D += A[i, j] * B[i, k] * C[i, j, k]
    end
    D
  end
  function threemulaccum_base(A, B, C)
    D = zero(promote_type(eltype(A), eltype(B), eltype(C)))
    @inbounds @fastmath for i in axes(C, 1), j in axes(C, 2), k in axes(C, 3)
      D += A[i, j] * B[i, k] * C[i, j, k]
    end
    D
  end
  function clenshaw!(ret, x, coeff)
    @inbounds for j = 1:length(ret)
      ret[j] = clenshaw(x[j], coeff)
    end
  end
  function clenshaw_avx!(ret, x, coeff)
    @_avx for j = 1:length(ret)
      ret[j] = clenshaw(x[j], coeff)
    end
  end
  function clenshawavx!(ret, x, coeff)
    @turbo for j = 1:length(ret)
      ret[j] = clenshaw(x[j], coeff)
    end
  end
  # ret = y2; coeff = c;
  #     LoopVectorization.@turbo_debug for j in 1:length(ret)
  #             ret[j] = clenshaw(x[j], coeff)
  #     end
  #     t = β₁ = β₂ = ρ = s = 0.0; weights = rand(1); nodes = rand(1); lomnibus(args...) = +(args...)
  # LoopVectorization.@turbo_debug for i ∈ eachindex(weights, nodes)
  #         s += weights[i] * lomnibus(nodes[i], t, β₁, β₂, ρ)
  #     end
  # @macroexpand @turbo for i ∈ eachindex(weights, nodes)
  #         s += weights[i] * lomnibus(nodes[i], t, β₁, β₂, ρ)
  #     end
  function softmax3_core!(lse, qq, xx, tmpmax, maxk, nk)
    for k in Base.OneTo(maxk)
      @inbounds for i in eachindex(lse)
        tmp = exp(xx[i, k] - tmpmax[i])
        lse[i] += tmp
        qq[i, k] = tmp
      end
    end
    for k = maxk+1:nk
      @inbounds for i in eachindex(lse)
        tmp = exp(xx[i, k] - tmpmax[i])
        lse[i] += tmp
      end
    end
    qq[:, Base.OneTo(maxk)] ./= vec(lse)
  end
  function softmax3_coreavx1!(lse, qq, xx, tmpmax, maxk, nk)
    for k in Base.OneTo(maxk)
      @turbo for i in eachindex(lse)
        tmp = (tmpm -> exp(xx[i, k] - tmpm))(tmpmax[i])
        lse[i] += tmp
        qq[i, k] = tmp
      end
    end
    for k = maxk+1:nk
      @turbo for i in eachindex(lse)
        tmp = exp(xx[i, k] - tmpmax[i])
        lse[i] += tmp
      end
    end
    qq[:, Base.OneTo(maxk)] ./= vec(lse)
  end
  function softmax3_core_avx1!(lse, qq, xx, tmpmax, maxk, nk)
    for k in Base.OneTo(maxk)
      @_avx for i in eachindex(lse)
        tmp = exp(xx[i, k] - tmpmax[i])
        lse[i] += tmp
        qq[i, k] = tmp
      end
    end
    for k = maxk+1:nk
      @_avx for i in eachindex(lse)
        tmp = exp(xx[i, k] - tmpmax[i])
        lse[i] += tmp
      end
    end
    qq[:, Base.OneTo(maxk)] ./= vec(lse)
  end
  function softmax3_coreavx2!(lse, qq, xx, tmpmax, maxk, nk)
    @turbo for k in Base.OneTo(maxk)
      for i in eachindex(lse)
        tmp = (yy -> exp(yy[i, k] - tmpmax[i]))(xx)
        lse[i] += tmp
        qq[i, k] = tmp
      end
    end
    if maxk < nk
      @turbo for k = maxk+1:nk
        for i in eachindex(lse)
          tmp = exp(xx[i, k] - tmpmax[i])
          lse[i] += tmp
        end
      end
    end
    qq[:, Base.OneTo(maxk)] ./= vec(lse)
  end
  function softmax3_core_avx2!(lse, qq, xx, tmpmax, maxk, nk)
    @_avx for k in Base.OneTo(maxk)
      for i in eachindex(lse)
        tmp = exp(xx[i, k] - tmpmax[i])
        lse[i] += tmp
        qq[i, k] = tmp
      end
    end
    if maxk < nk
      @_avx for k = maxk+1:nk
        for i in eachindex(lse)
          tmp = exp(xx[i, k] - tmpmax[i])
          lse[i] += tmp
        end
      end
    end
    qq[:, Base.OneTo(maxk)] ./= vec(lse)
  end
  function softmax3_coreavx3!(lse, qq, xx, tmpmax, maxk, nk)
    for k in Base.OneTo(nk)
      @turbo for i in eachindex(lse)
        tmp = exp(xx[i, k] - tmpmax[i])
        lse[i] += tmp
        k <= maxk && (qq[i, k] = tmp)
      end
    end
    @turbo qq[:, Base.OneTo(maxk)] ./= vec(lse)
  end
  function softmax3_core_avx3!(lse, qq, xx, tmpmax, maxk, nk)
    for k in Base.OneTo(nk)
      @_avx for i in eachindex(lse)
        tmp = exp(xx[i, k] - tmpmax[i])
        lse[i] += tmp
        k <= maxk && (qq[i, k] = tmp)
      end
    end
    qq[:, Base.OneTo(maxk)] ./= vec(lse)
  end
  # qif = :(for i in eachindex(lse)
  #             tmp = exp(xx[i,k] - tmpmax[i])
  #             lse[i] += tmp
  #             k <= maxk && (qq[i,k] = tmp)
  #          end)
  # lsif = LoopVectorization.loopset(qif)
  function softmax3_coreavx4!(lse, qq, xx, tmpmax, maxk, nk)
    @turbo for k in Base.OneTo(nk)
      for i in eachindex(lse)
        tmp = exp(xx[i, k] - tmpmax[i])
        lse[i] += tmp
        k <= maxk && (qq[i, k] = tmp)
      end
    end
    qq[:, Base.OneTo(maxk)] ./= vec(lse)
  end
  function softmax3_core_avx4!(lse, qq, xx, tmpmax, maxk, nk)
    @_avx for k in Base.OneTo(nk)
      for i in eachindex(lse)
        tmp = exp(xx[i, k] - tmpmax[i])
        lse[i] += tmp
        k <= maxk && (qq[i, k] = tmp)
      end
    end
    qq[:, Base.OneTo(maxk)] ./= vec(lse)
  end
  add_1_dim(x::AbstractArray) = reshape(x, size(x)..., 1)
  check_finite(x::AbstractArray) = all(isfinite.(x)) || throw(error("x not finite!"))
  function softmax3_setup!(
    q::AA,
    lse::A,
    tmpmax::A,
    x::AA,
    maxk = size(q, ndims(q)),
  ) where {T<:Real,A<:Array{T},AA<:AbstractArray{T}}
    ndims(q) == 1 + ndims(lse) || throw(DimensionMismatch())
    xsizes = size(x)
    xsizes == size(q) ||
      throw(DimensionMismatch("size(x) = $(size(x)) but size(q) = $(size(q))"))
    nk = last(xsizes)
    for i in Base.OneTo(ndims(lse))
      size(q, i) == size(lse, i) == size(tmpmax, i) || throw(
        DimensionMismatch(
          "size(x) = $(size(x)),  size(lse) = $(size(lse)), and size(tmpmax) = $(size(tmpmax))",
        ),
      )
    end
    0 < maxk <= nk || throw(DomainError(maxk))
    1 == LinearAlgebra.stride1(q) == LinearAlgebra.stride1(x) ||
      throw(error("Arrays not strided"))
    isempty(x) && throw(error("x empty"))
    check_finite(x)
    maximum!(add_1_dim(tmpmax), x)
    fill!(lse, zero(T))
    xx = reshape(x, :, nk)
    qq = reshape(q, :, nk)
    lse, qq, xx, tmpmax, maxk, nk
  end
  function softmax3_base!(
    q::AA,
    lse::A,
    tmpmax::A,
    x::AA,
    maxk = size(q, ndims(q)),
  ) where {T<:Real,A<:Array{T},AA<:AbstractArray{T}}
    lse, qq, xx, tmpmax, maxk, nk = softmax3_setup!(q, lse, tmpmax, x, maxk)
    softmax3_core!(lse, qq, xx, tmpmax, maxk, nk)
  end
  function softmax3avx1!(
    q::AA,
    lse::A,
    tmpmax::A,
    x::AA,
    maxk = size(q, ndims(q)),
  ) where {T<:Real,A<:Array{T},AA<:AbstractArray{T}}
    lse, qq, xx, tmpmax, maxk, nk = softmax3_setup!(q, lse, tmpmax, x, maxk)
    softmax3_coreavx1!(lse, qq, xx, tmpmax, maxk, nk)
  end
  function softmax3_avx1!(
    q::AA,
    lse::A,
    tmpmax::A,
    x::AA,
    maxk = size(q, ndims(q)),
  ) where {T<:Real,A<:Array{T},AA<:AbstractArray{T}}
    lse, qq, xx, tmpmax, maxk, nk = softmax3_setup!(q, lse, tmpmax, x, maxk)
    softmax3_core_avx1!(lse, qq, xx, tmpmax, maxk, nk)
  end
  function softmax3avx2!(
    q::AA,
    lse::A,
    tmpmax::A,
    x::AA,
    maxk = size(q, ndims(q)),
  ) where {T<:Real,A<:Array{T},AA<:AbstractArray{T}}
    lse, qq, xx, tmpmax, maxk, nk = softmax3_setup!(q, lse, tmpmax, x, maxk)
    softmax3_coreavx2!(lse, qq, xx, tmpmax, maxk, nk)
  end
  function softmax3_avx2!(
    q::AA,
    lse::A,
    tmpmax::A,
    x::AA,
    maxk = size(q, ndims(q)),
  ) where {T<:Real,A<:Array{T},AA<:AbstractArray{T}}
    lse, qq, xx, tmpmax, maxk, nk = softmax3_setup!(q, lse, tmpmax, x, maxk)
    softmax3_core_avx2!(lse, qq, xx, tmpmax, maxk, nk)
  end
  function softmax3avx3!(
    q::AA,
    lse::A,
    tmpmax::A,
    x::AA,
    maxk = size(q, ndims(q)),
  ) where {T<:Real,A<:Array{T},AA<:AbstractArray{T}}
    lse, qq, xx, tmpmax, maxk, nk = softmax3_setup!(q, lse, tmpmax, x, maxk)
    softmax3_coreavx3!(lse, qq, xx, tmpmax, maxk, nk)
  end
  function softmax3_avx3!(
    q::AA,
    lse::A,
    tmpmax::A,
    x::AA,
    maxk = size(q, ndims(q)),
  ) where {T<:Real,A<:Array{T},AA<:AbstractArray{T}}
    lse, qq, xx, tmpmax, maxk, nk = softmax3_setup!(q, lse, tmpmax, x, maxk)
    softmax3_core_avx3!(lse, qq, xx, tmpmax, maxk, nk)
  end
  function softmax3avx4!(
    q::AA,
    lse::A,
    tmpmax::A,
    x::AA,
    maxk = size(q, ndims(q)),
  ) where {T<:Real,A<:Array{T},AA<:AbstractArray{T}}
    lse, qq, xx, tmpmax, maxk, nk = softmax3_setup!(q, lse, tmpmax, x, maxk)
    softmax3_coreavx4!(lse, qq, xx, tmpmax, maxk, nk)
  end
  function softmax3_avx4!(
    q::AA,
    lse::A,
    tmpmax::A,
    x::AA,
    maxk = size(q, ndims(q)),
  ) where {T<:Real,A<:Array{T},AA<:AbstractArray{T}}
    lse, qq, xx, tmpmax, maxk, nk = softmax3_setup!(q, lse, tmpmax, x, maxk)
    softmax3_core_avx4!(lse, qq, xx, tmpmax, maxk, nk)
  end

  function sumprodavx(x)
    s = zero(eltype(x))
    p = one(eltype(x))
    @turbo for i ∈ eachindex(x)
      s += x[i]
      p *= x[i]
    end
    s, p
  end
  function sumprod_avx(x)
    s = zero(eltype(x))
    p = one(eltype(x))
    @_avx for i ∈ eachindex(x)
      s += x[i]
      p *= x[i]
    end
    s, p
  end

  function test_bit_shift(counter)
    accu = zero(first(counter))
    @inbounds for i ∈ eachindex(counter)
      accu += counter[i] << 1
    end
    accu
  end
  function test_bit_shiftavx(counter)
    accu = zero(first(counter))
    @turbo for i ∈ eachindex(counter)
      accu += counter[i] << (-3 * 4 + 13)
    end
    accu
  end
  function test_bit_shift_avx(counter)
    accu = zero(first(counter))
    @_avx for i ∈ eachindex(counter)
      accu += counter[i] << 1
    end
    accu
  end
  function test_for_with_different_index!(c, a, b, start_sample, num_samples)
    @inbounds for i = start_sample:num_samples+start_sample-1
      c[i] = b[i] * a[i]
    end
  end
  function test_for_with_different_indexavx!(c, a, b, start_sample, num_samples)
    @turbo for i = start_sample:num_samples+start_sample-1
      aᵢ = a[i]
      c[i] = ((x, y) -> x * y)(b[i], aᵢ)
    end
  end
  function test_for_with_different_index_avx!(c, a, b, start_sample, num_samples)
    @_avx for i = start_sample:num_samples+start_sample-1
      c[i] = b[i] * a[i]
    end
  end
  function rshift_i!(out)
    n = length(out)
    @inbounds for i = 1:n
      out[i] = out[i] << i
    end
  end
  function rshift_i_avx!(out)
    n = length(out)
    @turbo for i = 1:n
      out[i] = out[i] << i
    end
  end
  function one_plus_i!(out)
    n = length(out)
    @inbounds for i = 1:n
      out[i] = 1 + i
    end
  end
  function one_plus_i_avx!(out)
    n = length(out)
    @turbo for i = 1:n
      out[i] = 1 + i
    end
  end

  function addsumtoeach!(y, z)
    @inbounds @fastmath for i in axes(z, 1)
      @simd ivdep for j in axes(y, 1)
        y[j] = y[j] + z[i]
      end
    end
  end
  function addsumtoeachavx!(y, z)
    @turbo for i in axes(z, 1)
      for j in axes(y, 1)
        y[j] = y[j] + z[i]
      end
    end
  end
  function crossedsumavx!(x, y, z)
    @turbo for i in axes(x, 1)
      for j in axes(x, 2)
        x[i, j] = x[i, j] + z[i]
        y[j, i] = y[j, i] + z[i]
      end
    end
  end
  function crossedsum!(x, y, z)
    @inbounds @fastmath for i in axes(x, 1)
      for j in axes(x, 2)
        x[i, j] = x[i, j] + z[i]
        y[j, i] = y[j, i] + z[i]
      end
    end
  end
  # should be:
  #  3.0  4.0  1.0  2.0  7.0  8.0  5.0  6.0  11.0  12.0  9.0  10.0  15.0  16.0  13.0  …  191.0  192.0  189.0  190.0  195.0  196.0  193.0  194.0  197.0  198.0  199.0
  # 1.0  4.0  5.0  2.0  3.0  8.0  9.0  6.0  7.0  12.0  13.0  10.0  11.0  16.0  17.0  …  187.0  192.0  193.0  190.0  191.0  196.0  197.0  194.0  195.0  198.0  199.0
  function instruct_x_avx!(r::AbstractVector, loc::Int)
    @turbo for lhs = 0:(length(r)>>1)-(1<<(loc-1))
      # mask locations before
      p = lhs + lhs & ~(1 << (loc - 1) - 1)
      q = lhs + lhs & ~(1 << (loc - 1) - 1) + 1 << (loc - 1)
      # swap rows
      tmp = r[p+1]
      r[p+1] = r[q+1]
      r[q+1] = tmp
    end
    return r
  end
  function instruct_x!(r::AbstractVector, loc::Int)
    for lhs = 0:(length(r)>>1)-(1<<(loc-1))
      # mask locations before
      p = lhs + lhs & ~(1 << (loc - 1) - 1)
      q = lhs + lhs & ~(1 << (loc - 1) - 1) + 1 << (loc - 1)
      # swap rows
      tmp = r[p+1]
      r[p+1] = r[q+1]
      r[q+1] = tmp
    end
    return r
  end


  function multiple_unrolls_split_depchains!(
    c_re::AbstractArray{T},
    a_re,
    b_re,
    a_im,
    b_im,
    keep = nothing,
  ) where {T}
    for k = 1:2
      for n = 1:2
        # acc = ifelse(keep === nothing, zero(T), c_re[k, n]) # same problem
        acc = keep === nothing ? zero(T) : c_re[k, n]
        # acc = zero(T) # this works fine
        for c = 1:2
          acc = acc + (a_re[k, n, c] * b_re[c, k] + a_im[k, n, c] * b_im[c, k])
        end
        c_re[k, n] = acc
      end
    end
    c_re
  end
  function multiple_unrolls_split_depchains_avx!(
    c_re::AbstractArray{T},
    a_re,
    b_re,
    a_im,
    b_im,
    keep = nothing,
  ) where {T}
    @turbo for k = 1:2
      for n = 1:2
        # acc = ifelse(keep === nothing, zero(T), c_re[k, n]) # same problem
        acc = keep === nothing ? zero(T) : c_re[k, n]
        # acc = zero(T) # this works fine
        for c = 1:2
          acc = acc + (a_re[k, n, c] * b_re[c, k] + a_im[k, n, c] * b_im[c, k])
        end
        c_re[k, n] = acc
      end
    end
    c_re
  end

  function MatCalcWtDW!(m)
    l, n = size(m.Wt)
    fill!(m.Wt_D_W, 0)
    @turbo for k = 1:n
      for j = 1:l
        for i = 1:l
          m.Wt_D_W[i, j] += m.Wt[i, k] * m.Wt[j, k] * m.d[k]
        end
      end
    end
  end
  function loopinductvardivision(τ)
    M, N = size(τ)
    for t = 1:N, j = 1:M
      τ[j, t] = ((j - 1) / (M - 1))
    end
    τ
  end
  function loopinductvardivisionavx(τ)
    M, N = size(τ)
    @turbo for t = 1:N, j = 1:M
      τ[j, t] = ((j - 1) / (M - 1))
    end
    τ
  end
  function maxavx!(R::AbstractArray{T}, Q, keep = nothing) where {T}
    @turbo for i in axes(Q, 1)
      # acc = -999 # works fine
      acc = ifelse(isnothing(keep), typemin(T), R[i])
      for j in axes(Q, 2), k in axes(Q, 3)
        acc = max(acc, Q[i, j, k])
      end
      R[i] = acc
    end
    R
  end
  function reductionorder(E1, n)
    t = 0.5
    a = 1.0
    _s = 0.0
    k = length(E1)
    @turbo for j = 1:k
      for i = 1:n
        v = a * (1 - t * t)
        _s += v
      end
      E1[j] = _s / n
    end
    E1
  end
  function splitintonoloop(U, E1)
    t = 0.5
    a = 1.0
    _s = 0.0
    n, k = size(U)
    @turbo for j = 1:k
      for i = 1:n
        u = tanh(a * U[i, j])
        v = a * (1 - t * t)
        U[i, j] = u
        _s += v
      end
      E1[j] = _s / n
    end
    U, E1
  end
  function splitintonoloop_reference(U, E1)
    t = 0.5
    a = 1.0
    _s = 0.0
    n, k = size(U)
    for j = 1:k
      for i = 1:n
        u = tanh(a * U[i, j])
        v = a * (1 - t * t)
        U[i, j] = u
        _s += v
      end
      E1[j] = _s / n
    end
    U, E1
  end
  function findreducedparentfornonvecstoreavx!(
    U::AbstractMatrix{T},
    E1::AbstractVector{T},
  ) where {T}
    n, k = size(U)
    _s = zero(T)
    a = 1.0
    @turbo for j = 1:k
      for i = 1:n
        t = tanh(a * U[i, j])
        U[i, j] = t
        _s += a * (1 - t^2)
      end
      E1[j] = (x -> x / n)(_s)
    end
    U, E1
  end
  function findreducedparentfornonvecstore!(
    U::AbstractMatrix{T},
    E1::AbstractVector{T},
  ) where {T}
    n, k = size(U)
    _s = zero(T)
    a = 1.0
    for j = 1:k
      for i = 1:n
        t = tanh(a * U[i, j])
        U[i, j] = t
        _s += a * (1 - t^2)
      end
      E1[j] = _s / n
    end
    U, E1
  end


  function powcseliteral!(x)
    @turbo for i ∈ eachindex(x)
      x[i] = 3^4
    end
    x
  end
  function powcsesymbol!(x, a = 3)
    @turbo for i ∈ eachindex(x)
      x[i] = a^4
    end
    x
  end
  function powfastmath!(x::Vector{T}) where {T}
    @turbo for i = 1:length(x)
      xv = x[i]
      @fastmath x[i] = 1 / (xv^2)
    end
    x
  end
  @inline ninereturns(x) = (0.25x, 0.5x, 0.75, 1.0x, 1.25x, 1.5x, 1.75x, 2.0x, 2.25x)
  function manyreturntest(x)
    s = zero(eltype(x))
    @fastmath for j ∈ eachindex(x)
      a, b, c, d, e, f, g, h, i = ninereturns(x[j])
      s += a * i + b * h + c * g - d
    end
    s
  end
  function manyreturntestavx(x)
    s = zero(eltype(x))
    @turbo for j ∈ eachindex(x)
      a, b, c, d, e, f, g, h, i = ninereturns(x[j])
      s += a * i + b * h + c * g - d
    end
    s
  end

  function maybe_const_issue144!(𝛥mat, 𝛥ℛ, mat, ℛ)
    𝛥ℛ_value = 𝛥ℛ.value
    for j in axes(mat, 2)
      for i in axes(mat, 1)
        ℰ𝓍1 = conj(𝛥ℛ_value) # could be outside both loops
        ℰ𝓍2 = -(ℛ[j])        # could be outside i loop
        ℰ𝓍3 = exp(ℰ𝓍2)       # could be outside i loop
        ℰ𝓍4 = exp(mat[i, j])
        ℰ𝓍5 = ℰ𝓍3 * ℰ𝓍4
        ℰ𝓍6 = ℰ𝓍1 * ℰ𝓍5
        ℰ𝓍7 = conj(ℰ𝓍6)
        𝛥mat[i, j] = 𝛥mat[i, j] + ℰ𝓍7
      end
    end
    𝛥mat
  end
  function maybe_const_issue144_avx!(𝛥mat, 𝛥ℛ, mat, ℛ)
    𝛥ℛ_value = 𝛥ℛ.value
    @turbo for j in axes(mat, 2)
      for i in axes(mat, 1)
        ℰ𝓍1 = conj(𝛥ℛ_value)
        ℰ𝓍2 = -(ℛ[j])
        ℰ𝓍3 = exp(ℰ𝓍2)
        ℰ𝓍4 = exp(mat[i, j])
        ℰ𝓍5 = ℰ𝓍3 * ℰ𝓍4
        ℰ𝓍6 = ℰ𝓍1 * ℰ𝓍5
        ℰ𝓍7 = conj(ℰ𝓍6)
        𝛥mat[i, j] = 𝛥mat[i, j] + ℰ𝓍7
      end
    end
    𝛥mat
  end
  function grad!(𝛥x, 𝛥ℛ, x, 𝒶𝓍i = eachindex(x))
    for i in 𝒶𝓍i
      (i >= first(axes(𝛥x, 1))) & (i <= last(axes(𝛥x, 1))) && (𝛥x[i] = 𝛥x[i] + 𝛥ℛ[i])
    end
    𝛥x
  end
  function grad_avx!(𝛥x, 𝛥ℛ, x, 𝒶𝓍i = eachindex(x))
    @turbo for i in 𝒶𝓍i
      (i >= first(axes(𝛥x, 1))) & (i <= last(axes(𝛥x, 1))) && (𝛥x[i] = 𝛥x[i] + 𝛥ℛ[i])
    end
    𝛥x
  end
  function grad_avx_base!(𝛥x, 𝛥ℛ, x, 𝒶𝓍i = eachindex(x))
    @turbo for i in 𝒶𝓍i
      (i >= first(axes(𝛥x, 1))) & (i <= Base.last(axes(𝛥x, 1))) && (𝛥x[i] = 𝛥x[i] + 𝛥ℛ[i])
    end
    𝛥x
  end
  @eval function grad_avx_eval!(𝛥x, 𝛥ℛ, x, 𝒶𝓍i = eachindex(x))
    @turbo for i in 𝒶𝓍i
      (i >= $first($axes(𝛥x, 1))) & (i <= $last($axes(𝛥x, 1))) && (𝛥x[i] = 𝛥x[i] + 𝛥ℛ[i])
    end
    𝛥x
  end # LoadError: KeyError: key typeof(first) not found

  for T ∈ (Float32, Float64)
    @show T, @__LINE__
    A = randn(T, 199, 498)
    x = randn(T, size(A, 1))
    B1 = similar(A)
    B2 = similar(A)

    mysubcol!(B1, A, x)
    mysubcolavx!(B2, A, x)
    @test B1 ≈ B2
    fill!(B2, T(NaN))
    mysubcolavx!(B2, A, x)
    @test B1 ≈ B2

    x1 = similar(x)
    x2 = similar(x)
    mycolsum!(x1, A)
    mycolsumavx!(x2, A)
    @test x1 ≈ x2
    fill!(x2, T(NaN))
    mycolsum_avx!(x2, A)
    @test x1 ≈ x2

    x̄ = x1 ./ size(A, 2)
    myvar!(x1, A, x̄)
    myvaravx!(x2, A, x̄)
    @test x1 ≈ x2
    fill!(x2, T(NaN))
    myvar_avx!(x2, A, x̄)
    @test x1 ≈ x2

    # x1b = x1; x2b = x2;
    # x1 = copy(x1b); x2 = copy(x2b); x1 ≈ x2
    @test instruct_x!(x1, 2) ≈ instruct_x_avx!(x2, 2)
    @test instruct_x!(x1, 3) ≈ instruct_x_avx!(x2, 3)
    @test instruct_x!(x1, 4) ≈ instruct_x_avx!(x2, 4)

    M, N = 47, 73
    x = rand(T, M)
    A = rand(T, M, N)
    y = rand(T, N)
    d3 = dot3(x, A, y)
    @test dot3avx(LoopVectorization.stridedpointer(x), A, y) ≈ d3
    @test dot3v2avx(x, A, LoopVectorization.stridedpointer(y)) ≈ d3
    @test dot3avx24(x, A, y) ≈ d3
    @test dot3_avx(x, A, y) ≈ d3

    A2 = similar(A)
    setcolumstovectorplus100!(A, x)
    setcolumstovectorplus100avx!(A2, x)
    @test A == A2

    maxdeg = 20
    nbasis = 1_000
    dim = 15
    r = T == Float32 ? (Int32(1):Int32(maxdeg + 1)) : (1:maxdeg+1)
    basis = rand(r, (dim, nbasis))
    coeffs = rand(T, nbasis)
    P = rand(T, dim, maxdeg + 1)
    # mvp(P, basis, coeffs)
    # mvpavx(P, basis, coeffs)
    mvpv = mvp(P, basis, coeffs)
    @test mvpv ≈ mvpavx(P, basis, coeffs)
    @test mvpv ≈ mvp_avx(P, basis, coeffs)

    c = rand(T, 100)
    x = rand(T, 10^4)
    y1 = similar(x)
    y2 = similar(x)
    clenshaw!(y1, x, c)
    clenshaw_avx!(y2, x, c)
    @test y1 ≈ y2
    fill!(y2, NaN)
    clenshawavx!(y2, x, c)
    @test y1 ≈ y2

    C = randn(T, 199, 498)
    start_sample = 29
    num_samples = 800
    test_for_with_different_index!(B1, A, C, start_sample, num_samples)
    test_for_with_different_indexavx!(B2, A, C, start_sample, num_samples)
    r = start_sample:start_sample+num_samples-1
    @test view(vec(B1), r) == view(vec(B2), r)
    fill!(B2, NaN)
    test_for_with_different_index_avx!(B2, A, C, start_sample, num_samples)
    @test view(vec(B1), r) == view(vec(B2), r)

    ni, nj, nk = (127, 113, 13)
    x = rand(T, ni, nj, nk)
    q1 = similar(x)
    q2 = similar(x)
    tmpmax = zeros(T, ni, nj)
    lse = similar(tmpmax)
    fill!(q1, 0)
    fill!(lse, 0)
    softmax3_base!(q1, lse, tmpmax, x)

    fill!(q2, 0)
    fill!(lse, 0)
    softmax3avx1!(q2, lse, tmpmax, x, 1)
    @test all(sum(q2; dims = 3) .<= 1)
    fill!(q2, 0)
    fill!(lse, 0)
    softmax3avx1!(q2, lse, tmpmax, x)
    @test q1 ≈ q2
    @test sum(q2; dims = 3) ≈ ones(T, ni, nj)

    # fill!(q2, 0); fill!(lse, 0);  softmax3_avx1!(q2, lse, tmpmax, x, 1);
    # @test all(sum(q2; dims=3) .<= 1)
    # fill!(q2, 0); fill!(lse, 0);  softmax3_avx1!(q2, lse, tmpmax, x);
    # @test q1 ≈ q2
    # @test sum(q2; dims=3) ≈ ones(T,ni,nj)

    fill!(q2, 0)
    fill!(lse, 0)
    softmax3avx2!(q2, lse, tmpmax, x, 1)
    @test all(sum(q2; dims = 3) .<= 1)
    fill!(q2, 0)
    fill!(lse, 0)
    softmax3avx2!(q2, lse, tmpmax, x)
    @test q1 ≈ q2
    @test sum(q2; dims = 3) ≈ ones(T, ni, nj)

    # fill!(q2, 0); fill!(lse, 0);  softmax3_avx2!(q2, lse, tmpmax, x, 1);
    # @test all(sum(q2; dims=3) .<= 1)
    # fill!(q2, 0); fill!(lse, 0);  softmax3_avx2!(q2, lse, tmpmax, x);
    # @test q1 ≈ q2
    # @test sum(q2; dims=3) ≈ ones(T,ni,nj)

    fill!(q2, 0)
    fill!(lse, 0)
    softmax3avx3!(q2, lse, tmpmax, x, 1)
    @test all(sum(q2; dims = 3) .<= 1)
    fill!(q2, 0)
    fill!(lse, 0)
    softmax3avx3!(q2, lse, tmpmax, x)
    @test q1 ≈ q2
    @test sum(q2; dims = 3) ≈ ones(T, ni, nj)

    # fill!(q2, 0); fill!(lse, 0);  softmax3_avx3!(q2, lse, tmpmax, x, 1);
    # @test all(sum(q2; dims=3) .<= 1)
    # fill!(q2, 0); fill!(lse, 0);  softmax3_avx3!(q2, lse, tmpmax, x);
    # @test q1 ≈ q2
    # @test sum(q2; dims=3) ≈ ones(T,ni,nj)

    fill!(q2, 0)
    fill!(lse, 0)
    softmax3avx4!(q2, lse, tmpmax, x, 1)
    @test all(sum(q2; dims = 3) .<= 1)
    fill!(q2, 0)
    fill!(lse, 0)
    softmax3avx4!(q2, lse, tmpmax, x)
    @test q1 ≈ q2
    @test sum(q2; dims = 3) ≈ ones(T, ni, nj)

    # fill!(q2, 0); fill!(lse, 0);  softmax3_avx4!(q2, lse, tmpmax, x, 1);
    # @test all(sum(q2; dims=3) .<= 1)
    # fill!(q2, 0); fill!(lse, 0);  softmax3_avx4!(q2, lse, tmpmax, x);
    # @test q1 ≈ q2
    # @test sum(q2; dims=3) ≈ ones(T,ni,nj)

    x .+= 0.545
    s = sum(x)
    p = prod(x)
    s1, p1 = sumprodavx(x)
    @test s ≈ s1
    isfinite(p) && @test p ≈ p1
    s1, p1 = sumprod_avx(vec(x)) # FIXME: should use `gespf` so that `vec` is no longer necessary
    @test s ≈ s1
    isfinite(p) && @test p ≈ p1
    r = T == Float32 ? (Int32(-10):Int32(107)) : (Int64(-10):Int64(107))
    s = sum(r)
    p = prod(r)
    s1, p1 = sumprodavx(r)
    @test s ≈ s1
    @test p ≈ p1
    s1, p1 = sumprod_avx(r)
    @test s ≈ s1
    @test p ≈ p1

    @test test_bit_shift(r) == test_bit_shiftavx(r)
    @test test_bit_shift(r) == test_bit_shift_avx(r)

    r = T(-1):T(0.23):T(10)
    s = if VERSION >= v"1.5.0-DEV.255" || T != Float32
      sum(r)
    else
      sum(identity, r)
    end
    p = prod(r)
    s1, p1 = sumprodavx(r)
    @test s ≈ s1
    @test p ≈ p1
    s1, p1 = sumprod_avx(r)
    @test s ≈ s1
    @test p ≈ p1

    x1 = rand(47)
    x2 = copy(x1)
    z = rand(83)
    addsumtoeach!(x1, z)
    addsumtoeachavx!(x2, z)
    @test x1 ≈ x2
    X1 = rand(83, 47)
    X2 = copy(X1)
    Y1 = rand(47, 83)
    Y2 = copy(Y1)
    crossedsum!(X1, Y1, z)
    crossedsumavx!(X2, Y2, z)
    @test X1 ≈ X2
    @test Y1 ≈ Y2

    a_re, a_im = rand(T, 2, 2, 2), rand(T, 2, 2, 2)
    b_re, b_im = rand(T, 2, 2), rand(T, 2, 2)
    c_re_1 = ones(T, 2, 2)
    c_re_2 = ones(T, 2, 2)
    multiple_unrolls_split_depchains!(c_re_1, a_re, b_re, a_im, b_im, true) # [1 1; 1 1]
    multiple_unrolls_split_depchains_avx!(c_re_2, a_re, b_re, a_im, b_im, true) # [1 1; 1 1]
    @test c_re_1 ≈ c_re_2
    multiple_unrolls_split_depchains!(c_re_1, a_re, b_re, a_im, b_im) # [1 1; 1 1]
    multiple_unrolls_split_depchains_avx!(c_re_2, a_re, b_re, a_im, b_im) # [1 1; 1 1]
    @test c_re_1 ≈ c_re_2

    @test loopinductvardivision(X1) ≈ loopinductvardivisionavx(X2)

    mh = (Wt_D_W = Matrix{T}(undef, 181, 181), Wt = rand(T, 181, 191), d = rand(T, 191))

    MatCalcWtDW!(mh)
    @test mh.Wt_D_W ≈ mh.Wt * Diagonal(mh.d) * mh.Wt'

    Q = rand(T, 43, 47, 51)
    R = rand(T, 43)
    @test maxavx!(R, Q) == vec(maximum(Q, dims = (2, 3)))
    R .+= randn.(T)
    Rc = copy(R)
    @test maxavx!(R, Q, true) == max.(vec(maximum(Q, dims = (2, 3))), Rc)

    @test manyreturntest(Q) ≈ manyreturntestavx(Q)

    U0 = randn(T, 15, 17)
    E0 = randn(T, 17)
    U1, E1 = splitintonoloop_reference(copy(U0), copy(E0))
    U2, E2 = splitintonoloop(copy(U0), copy(E0))
    @test U1 ≈ U2
    @test E1 ≈ E2
    U3, E3 = findreducedparentfornonvecstoreavx!(copy(U0), copy(E0))
    findreducedparentfornonvecstore!(U0, E0)
    @test U0 ≈ U3
    @test E0 ≈ E3

    @test all(isequal(81), powcseliteral!(E0))
    @test all(isequal(81), powcsesymbol!(E3))
    let
      x = rand(T, 10) .+ T(0.5)
      r = @. inv(x^2)
      @test r ≈ powfastmath!(x)
    end

    @test isapprox(
      maybe_const_issue144!(
        zeros(T, 3, 4),
        (value = one(T),),
        collect(reshape(1:12, 3, 4)),
        ones(T, 4),
      ),
      maybe_const_issue144_avx!(
        zeros(T, 3, 4),
        (value = one(T),),
        collect(reshape(1:12, 3, 4)),
        ones(T, 4),
      ),
      rtol = ∛(eps(T)),
    )

    @test grad!(zeros(5), ones(5), ones(3)) ≈
          grad_avx!(zeros(5), ones(5), ones(3)) ≈
          grad_avx_base!(zeros(5), ones(5), ones(3)) ≈
          grad_avx_eval!(zeros(5), ones(5), ones(3))

    nta = rand(2)
    namedtuple1 = (a = (1, copy(nta)), b = 10.0)
    @turbo for i = 1:2
      namedtuple1.a[2][i] += namedtuple1.b
    end
    @test namedtuple1.a[2] == nta .+ 10

    namedtuple = (a = (1, (c = copy(nta),)), b = 10.0)
    @turbo for i = 1:2
      namedtuple.a[2].c[i] -= namedtuple.b
    end
    @test namedtuple.a[2].c == nta .- 10

    let A = rand(T, 20, 30)
      B = rand(T, 20, 30)
      C = rand(T, 20, 30, 30)
      @test threemulaccum_base(A, B, C) ≈ threemulaccum_lv(A, B, C)
    end
  end
  for T ∈ [Int16, Int32, Int64]
    n = 8sizeof(T) - 1
    out1 = rand(T(1):T(1_000), n)
    out2 = copy(out1)
    rshift_i!(out1)
    rshift_i_avx!(out2)
    @test out1 == out2
    one_plus_i!(out1)
    one_plus_i_avx!(out2)
    @test out1 == out2
  end

  function smoothdim!(s, x, α, Rpre, irng::AbstractUnitRange, Rpost)
    ifirst, ilast = first(irng), last(irng)
    ifirst > ilast && return s
    # @inbounds @fastmath for Ipost in Rpost
    for Ipost in Rpost
      # Initialize the first value along the filtered dimension
      for Ipre in Rpre
        s[Ipre, ifirst, Ipost] = x[Ipre, ifirst, Ipost]
      end
      # Handle all other entries
      for i = ifirst+1:ilast
        for Ipre in Rpre
          s[Ipre, i, Ipost] = α * x[Ipre, i, Ipost] + (1 - α) * x[Ipre, i-1, Ipost]
        end
      end
    end
    s
  end
  function smoothdim_avx!(s, x, α, Rpre, irng::AbstractUnitRange, Rpost)
    ifirst, ilast = first(irng), last(irng)
    ifirst > ilast && return s
    @turbo for Ipost in Rpost
      for Ipre in Rpre
        s[Ipre, ifirst, Ipost] = x[Ipre, ifirst, Ipost]
        for i = ifirst+1:ilast
          s[Ipre, i, Ipost] = α * x[Ipre, i, Ipost] + (1 - α) * x[Ipre, i-1, Ipost]
        end
      end
    end
    s
  end
  function smoothdim_ifelse_avx!(s, x, α, Rpre, irng::AbstractUnitRange, Rpost)
    ifirst, ilast = first(irng), last(irng)
    ifirst > ilast && return s
    @turbo for Ipost in Rpost, i = ifirst:ilast, Ipre in Rpre
      xi = x[Ipre, i, Ipost]
      xim = i > ifirst ? x[Ipre, i-1, Ipost] : xi
      s[Ipre, i, Ipost] = α * xi + (1 - α) * xim
    end
    s
  end

  function smoothdim_kernel_tile!(
    out,
    z,
    src::AbstractArray,
    kernel::AbstractVector,
    Rpre::CartesianIndices,
    axout_tile,
    Rpost::CartesianIndices,
  )
    # z is an "overflow-safe zero". This is needed in cases where both `src` and `kernel` have eltypes vulnerable to arithmetic overflow.
    axkernel = axes(kernel, 1)
    for Ipost in Rpost
      for i in axout_tile
        for Ipre in Rpre
          tmp = convert(eltype(out), z)
          for j in axkernel
            tmp += oftype(z, src[Ipre, i+j, Ipost]) * kernel[j]
          end
          out[Ipre, i, Ipost] = tmp
        end
      end
    end
    out
  end
  function smoothdim_kernel_tile_avx!(
    out,
    z,
    src::AbstractArray,
    kernel::AbstractVector,
    Rpre::CartesianIndices,
    axout_tile,
    Rpost::CartesianIndices,
  )
    axkernel = axes(kernel, 1)
    zout = convert(eltype(out), z)
    for Ipost in Rpost
      @turbo for i in axout_tile
        for Ipre in Rpre
          tmp = zout
          # tmp = convert(eltype(out), z)    # failing to hoist this leads to an "UndefVarError: tmp not defined"
          for j in axkernel
            tmp += oftype(z, src[Ipre, i+j, Ipost]) * kernel[j]
          end
          out[Ipre, i, Ipost] = tmp
        end
      end
    end
    out
  end
  function smoothdim_kernel_tile_avx_2!(
    out,
    z,
    src::AbstractArray,
    kernel::AbstractVector,
    Rpre::CartesianIndices,
    axout_tile,
    Rpost::CartesianIndices,
  )
    axkernel = axes(kernel, 1)
    for Ipost in Rpost
      @turbo for i in axout_tile
        for Ipre in Rpre
          tmp = zero(eltype(out))
          # tmp = convert(eltype(out), z)    # failing to hoist this leads to an "UndefVarError: tmp not defined"
          for j in axkernel
            tmp += oftype(z, src[Ipre, i+j, Ipost]) * kernel[j]
          end
          out[Ipre, i, Ipost] = tmp
        end
      end
    end
    out
  end


  for T ∈ (UInt8, Float32, Float64)
    @testset "Mixed CartesianIndex/Int indexing" begin
      @show T, @__LINE__
      # A demo similar to the exponential filtering demo from https://julialang.org/blog/2016/02/iteration/,
      # but with no loop-carried dependency.

      # s = dest1;
      # ifirst, ilast = first(axes(x, d)), last(axes(x, d))
      # ls = LoopVectorization.@turbo_debug for Ipost in Rpost, i = ifirst:ilast, Ipre in Rpre
      #     xi = x[Ipre, i, Ipost]
      #     xim = i > ifirst ? x[Ipre, i-1, Ipost] : xi
      #     s[Ipre, i, Ipost] = α*xi + (1-α)*xim
      # end
      # LoopVectorization.choose_order(ls);

      M = 11
      x = rand(T, M, M, M, M, M)
      dest1, dest2 = similar(x, float(T)), similar(x, float(T))
      α = 0.3
      for d = 1:ndims(x)
        # @show d
        Rpre = CartesianIndices(axes(x)[1:d-1])
        Rpost = CartesianIndices(axes(x)[d+1:end])
        smoothdim!(dest1, x, α, Rpre, axes(x, d), Rpost)
        smoothdim_avx!(dest2, x, α, Rpre, axes(x, d), Rpost)
        @test dest1 ≈ dest2
        fill!(dest2, NaN)
        smoothdim_ifelse_avx!(dest2, x, α, Rpre, axes(x, d), Rpost)
        @test dest1 ≈ dest2
      end

      # Mimic of ImageFiltering/ArrayFiltering's separable filters
      σ = 3
      ax = OffsetArray(-6:6, -6:6)
      kernel = float(T)[exp(-i^2 / (2 * σ^2)) for i in ax]   # 1-d Gaussian kernel
      kernel ./= sum(kernel)
      srcax = 1+firstindex(ax):M+lastindex(ax)
      Mpad = length(srcax)
      src = OffsetArray(
        rand(T, Mpad, Mpad, Mpad, Mpad, Mpad),
        srcax,
        srcax,
        srcax,
        srcax,
        srcax,
      )
      dest1 = Array{float(T),5}(undef, M, M, M, M, M)
      dest2 = similar(dest1)
      for d = 1:ndims(src)
        Rpre = CartesianIndices(axes(dest1)[1:d-1])
        Rpost = CartesianIndices(axes(dest1)[d+1:end])
        smoothdim_kernel_tile!(
          dest1,
          float(zero(T)),
          src,
          kernel,
          Rpre,
          axes(dest1, d),
          Rpost,
        )
        smoothdim_kernel_tile_avx!(
          dest2,
          float(zero(T)),
          src,
          kernel,
          Rpre,
          axes(dest2, d),
          Rpost,
        )
        @test dest1 ≈ dest2
        fill!(dest2, NaN)
        smoothdim_kernel_tile_avx_2!(
          dest2,
          float(zero(T)),
          src,
          kernel,
          Rpre,
          axes(dest2, d),
          Rpost,
        )
        @test dest1 ≈ dest2
      end

      # Mimic RGB-valued array
      src = OffsetArray(
        [(rand(T), rand(T), rand(T)) for i in srcax, j in srcax, k in srcax],
        srcax,
        srcax,
        srcax,
      )
      srcr = reinterpret(reshape, T, src)
      fT = float(T)
      dest1 = Array{Tuple{fT,fT,fT}}(undef, M, M, M)
      dest2 = similar(dest1)
      dest1r = reinterpret(reshape, fT, dest1)
      dest2r = reinterpret(reshape, fT, dest2)
      for d = 1:ndims(src)
        Rpre = CartesianIndices((
          LoopVectorization.StaticInt(1):LoopVectorization.StaticInt(3),
          axes(dest1)[1:d-1]...,
        ))
        Rpost = CartesianIndices(axes(dest1)[d+1:end])
        smoothdim_kernel_tile!(
          dest1r,
          float(zero(T)),
          srcr,
          kernel,
          Rpre,
          axes(dest1, d),
          Rpost,
        )
        smoothdim_kernel_tile_avx!(
          dest2r,
          float(zero(T)),
          srcr,
          kernel,
          Rpre,
          axes(dest2, d),
          Rpost,
        )
        @test dest1r ≈ dest2r
        fill!(dest2, (NaN, NaN, NaN))
        smoothdim_kernel_tile_avx_2!(
          dest2r,
          float(zero(T)),
          srcr,
          kernel,
          Rpre,
          axes(dest2, d),
          Rpost,
        )
        @test dest1r ≈ dest2r
      end
      # # Make it easy to check whether the above are ~3x slower than the grayscale version
      # srcg = OffsetArray([rand(T) for i in srcax, j in srcax, k in srcax], srcax, srcax, srcax);
      # destg = Array{eltype(srcg)}(undef, M, M, M);
      # Rpre  = CartesianIndices(axes(destg)[1:d-1]);
      # Rpost = CartesianIndices(axes(destg)[d+1:end]);
      # smoothdim_kernel_tile_avx!(destg, float(zero(T)), srcg, kernel, Rpre, axes(destg, d), Rpost);
    end
  end


  function mul1!(y::Vector{T}, A::Matrix{UInt8}, x::Vector{T}) where {T}
    packedstride = size(A, 1)
    m, n = size(A)
    @turbo for j ∈ eachindex(x)
      for i ∈ eachindex(y)
        k = 2 * ((i - 1) & 3)
        block = A[(j-1)*packedstride+((i-1)>>2)+1]
        Aij = (block >> k) & 3
        y[i] += (((Aij >= 2) + (Aij >= 3))) * x[j]
      end
    end
    y
  end
  function mul2!(y::Vector{T}, A::Matrix{UInt8}, x::Vector{T}) where {T}
    packedstride = size(A, 1)
    m, n = size(A)
    for j ∈ eachindex(x)
      for i ∈ eachindex(y)
        k = 2 * ((i - 1) & 3)
        block = A[(j-1)*packedstride+((i-1)>>2)+1]
        Aij = (block >> k) & 3
        y[i] += (((Aij >= 2) + (Aij >= 3))) * x[j]
      end
    end
    y
  end

  @testset "UInt8 mul" begin
    for n = 1:200
      v1 = rand(n)
      v3 = copy(v1)
      v2 = rand(n)
      A = rand(UInt8, (length(v1) >> 2) + (length(v1) % 4 != 0), length(v2))
      @test mul1!(v1, A, v2) ≈ mul2!(v3, A, v2)
    end
  end

  if VERSION ≥ v"1.7.0-DEV.1031"
    @test_throws LoopVectorization.LoopError @macroexpand begin # pull #172
      @turbo for i in eachindex(xs)
        if i in axes(ys, 1)
          xs[i] = ys[i]
        else
          xs[i] = zero(eltype(ys))
        end
      end
    end
  else
    @test_throws LoadError @macroexpand begin # pull #172
      @turbo for i in eachindex(xs)
        if i in axes(ys, 1)
          xs[i] = ys[i]
        else
          xs[i] = zero(eltype(ys))
        end
      end
    end
  end
  @testset "issue 237" begin
    function obj8(y::AbstractMatrix, s::AbstractArray, θ::AbstractVector)
      out = 0.0
      for i in axes(y, 2)
        for j in axes(y, 1)
          acc = 0.0
          for r in axes(θ, 1)
            acc += abs(θ[r]) * s[r, j, i]
          end
          out += y[j, i] * log(acc)
        end
      end
      out
    end

    function obj9(y::AbstractMatrix, s::AbstractArray, θ::AbstractVector)
      out = 0.0
      @tturbo for i in axes(y, 2)
        for j in axes(y, 1)
          acc = 0.0
          for r in axes(θ, 1)
            acc += abs(θ[r]) * s[r, j, i]
          end
          out += y[j, i] * log(acc)
        end
      end
      out
    end

    y = rand(10, 10)
    s = rand(10, 10, 10)
    θ = rand(10)

    @test obj8(y, s, θ) ≈ obj9(y, s, θ)
  end
  @testset "issues 244,256,257" begin
    function energy(spin_conf)
      (Nx, Ny) = size(spin_conf)
      res = 0
      @turbo for i = 1:Nx
        for j = 1:Ny
          i0 = (i - 1 + Nx) % Nx
          i1 = (i + Nx) % Nx
          j0 = (j - 1 + Ny) % Ny
          j1 = (j + Ny) % Ny
          res += -spin_conf[i0+1, j0+1] * (spin_conf[i1+1, j0+1] + spin_conf[i0+1, j1+1])
        end
      end
      return res
    end
    function energy_base(spin_conf)
      (Nx, Ny) = size(spin_conf)
      res = 0
      for i = 1:Nx
        for j = 1:Ny
          i0 = (i - 1 + Nx) % Nx
          i1 = (i + Nx) % Nx
          j0 = (j - 1 + Ny) % Ny
          j1 = (j + Ny) % Ny
          res += -spin_conf[i0+1, j0+1] * (spin_conf[i1+1, j0+1] + spin_conf[i0+1, j1+1])
        end
      end
      return res
    end
    spin_conf = rand((-1, 1), 64, 64)
    @test energy(spin_conf) == energy_base(spin_conf)

    function issue_257_avx!(A, G)
      N = length(G)
      @turbo for i = 1:N-1
        A[i] = G[(1-1)*N+i] + G[(1-1)*N+i+1]
      end
      A
    end
    function issue_257!(A, G)
      N = length(G)
      @inbounds for i = 1:N-1
        A[i] = G[(1-1)*N+i] + G[(1-1)*N+i+1]
      end
      A
    end
    for i = 2:1000
      G = rand(i)
      A0 = Vector{Float64}(undef, i - 1)
      A1 = similar(A0)
      @test issue_257!(A0, G) ≈ issue_257_avx!(A1, G)
    end

    function sum_range(x)
      s = zero(eltype(x))
      @turbo for xᵢ ∈ x
        s += xᵢ
      end
      s
    end
    @test sum_range(-3:8) == sum(-3:8)
    @test_throws ArgumentError sum_range(Int[1, 2])
  end


end

const START_TIME = time()
@show LoopVectorization.register_count()

@show RUN_SLOW_TESTS

@time @testset "LoopVectorization.jl" begin

  @time if LOOPVECTORIZATION_TEST == "all" || LOOPVECTORIZATION_TEST == "part1"
    @time include("broadcast.jl")
    @time include("parsing_inputs.jl")
    @time include("misc2.jl")
  end

  @time if LOOPVECTORIZATION_TEST == "all" || LOOPVECTORIZATION_TEST == "part2"
    if VERSION >= v"1.9"
      using Aqua
      @time Aqua.test_all(LoopVectorization, ambiguities = false, piracies = false)
    end
    @test isempty(detect_unbound_args(LoopVectorization))

    @time include("printmethods.jl")

    @time include("can_avx.jl")

    @time include("safe_turbo.jl")

    @time include("fallback.jl")

    @time include("utils.jl")

    @time include("arraywrappers.jl")

    @time include("check_empty.jl")

    @time include("loopinductvars.jl")

    @time include("shuffleloadstores.jl")

    if VERSION < v"1.7-DEV"
      @time include("zygote.jl")
    else
      println("Skipping Zygote tests.")
    end

    @time include("map.jl")

    @time include("filter.jl")

    @time include("multiassignments.jl")

    @time include("reduction_untangling.jl")

    @time include("manyarrayrefs.jl")

    @time include("manyloopreductions.jl")

    @time include("simplemisc.jl")

    @time include("convolutions.jl")

    @time include("ifelsemasks.jl")

    @time include("gemv.jl")

    @time include("dot.jl")

    @time include("special.jl")

    @time include("mapreduce.jl")

    @time include("index_processing.jl")
  end

  @time if LOOPVECTORIZATION_TEST == "all" || LOOPVECTORIZATION_TEST == "part3"
    @time include("rejectunroll.jl")

    @time include("miscellaneous.jl")

    @time include("copy.jl")

    @time include("tensors.jl")

    @time include("staticsize.jl")
  end

  @time if LOOPVECTORIZATION_TEST == "all" || LOOPVECTORIZATION_TEST == "part4"
    @time include("threading.jl")

    @time include("tullio.jl")

    @time include("iteration_bound_tests.jl")

    @time include("outer_reductions.jl")

    @time include("upperboundedintegers.jl")

    if VERSION ≥ v"1.6"
      @time include("quantum.jl")
    end

    @time include("offsetarrays.jl")

    @time include("forwarddiffext.jl")
  end

  @time if LOOPVECTORIZATION_TEST == "all" || LOOPVECTORIZATION_TEST == "part5"
    @time include("steprange.jl")

    @time include("gemm.jl")

    @time include("inner_reductions.jl")
  end

end

const ELAPSED_MINUTES = (time() - START_TIME) / 60
@test ELAPSED_MINUTES < 180
# @test ELAPSED_MINUTES < 300

function vfilter!(
  f::F,
  x::Vector{T},
  y::AbstractArray{T}
) where {F,T<:NativeTypes}
  W, Wshift = VectorizationBase.pick_vector_width_shift(T)
  N = length(y)
  Nrep = N >>> Wshift
  Nrem = N & (W - 1)
  j = 0
  st = VectorizationBase.static_sizeof(T)
  zero_index = MM(W, StaticInt(0), st)
  incr = W * VectorizationBase.static_sizeof(T)
  GC.@preserve x y begin
    # ptr_x = llvmptr(x); ptr_y = llvmptr(y)
    ptr_x = pointer(x)
    ptr_y = pointer(y)
    for _ ∈ 1:Nrep
      vy =
        VectorizationBase.__vload(ptr_y, zero_index, False(), register_size())
      mask = f(vy)
      VectorizationBase.compressstore!(
        gep(ptr_x, VectorizationBase.lazymul(st, j)),
        vy,
        mask
      )
      ptr_y = gep(ptr_y, incr)
      j = vadd_nw(j, count_ones(mask))
    end
    rem_mask = VectorizationBase.mask(T, Nrem)
    vy = VectorizationBase.__vload(
      ptr_y,
      zero_index,
      rem_mask,
      False(),
      register_size()
    )
    mask = rem_mask & f(vy)
    VectorizationBase.compressstore!(
      gep(ptr_x, VectorizationBase.lazymul(st, j)),
      vy,
      mask
    )
    j = vadd_nw(j, count_ones(mask))
    Base._deleteend!(x, N - j) # resize!(x, j)
  end
  x
end
vfilter!(f::F, x::Vector{T}) where {F,T<:NativeTypes} = vfilter!(f, x, x)
vfilter(f::F, y::AbstractArray{T}) where {F,T<:NativeTypes} =
  vfilter!(f, Vector{T}(undef, length(y)), y)
vfilter(f::F, y) where {F} = filter(f, y)
vfilter!(f::F, y) where {F} = filter!(f, y)

"""
    vfilter(f, a::AbstractArray)

SIMD-vectorized `filter`, returning an array containing the elements of `a` for which `f` return `true`.

This function requires AVX512 to be faster than `Base.filter`, as it adds compressstore instructions.
"""
vfilter

"""
    vfilter!(f, a::AbstractArray)

SIMD-vectorized `filter!`, removing the element of `a` for which `f` is false.
"""
vfilter!

### This file contains convenience functions for constructing LoopSets.

# function strip_unneeded_const_deps!(ls::LoopSet)
#     for op ∈ operations(ls)
#         if isconstant(op) && iszero(length(reducedchildren(op)))
#             op.dependencies = NODEPENDENCY
#         end
#     end
#     ls
# end

function _copyto!(ls::LoopSet, q::Expr)
  q.head === :for || throw("Expression must be a for loop.")
  add_loop!(ls, q, 8)
  # strip_unneeded_const_deps!(ls)
end

function add_ci_call!(
  q::Expr,
  @nospecialize(f),
  args::Vector{Any},
  syms::Vector{Symbol},
  i::Int,
  @nospecialize(valarg) = nothing,
  @nospecialize(mod) = nothing
)
  call = if f isa Core.SSAValue
    Expr(:call, syms[f.id])
  else
    Expr(:call, f)
  end
  for arg ∈ @view(args[2:end])
    if arg isa Core.SSAValue
      push!(call.args, syms[arg.id])
    else
      push!(call.args, arg)
    end
  end
  if mod !== nothing # indicates it's `vmaterialize(!)`
    push!(call.args, Expr(:call, Expr(:curly, :Val, QuoteNode(mod))), valarg)
  end
  push!(q.args, Expr(:(=), syms[i], call))
end

function substitute_broadcast(
  q::Expr,
  mod::Symbol,
  inline::Bool,
  u₁::Int8,
  u₂::Int8,
  v::Int8,
  threads::Int,
  warncheckarg::Int,
  safe::Bool
)
  ci = first(Meta.lower(LoopVectorization, q).args).code
  nargs = length(ci) - 1
  lb = Expr(:block)
  syms = Vector{Symbol}(undef, nargs)
  configarg = (inline, u₁, u₂, v, true, threads, warncheckarg, safe)
  unroll_param_tup =
    Expr(:call, lv(:avx_config_val), :(Val{$configarg}()), staticexpr(0))
  for n ∈ 1:nargs
    _ciₙ = ci[n]
    if _ciₙ isa Symbol
      syms[n] = _ciₙ::Symbol
    else
      syms[n] = Symbol('%', n)
      #ciₙ::Expr = _ciₙ::Expr
      if _ciₙ isa Expr
          ciₙ = _ciₙ
      elseif _ciₙ isa GlobalRef
          ciₙ = Expr(:globalref, _ciₙ.mod, _ciₙ.name)
      else
        error("Unexpected type in ci: $(typeof(_ciₙ))")
      end
      ciₙargs = ciₙ.args
      f = first(ciₙargs)
      if ciₙ.head === :(=)
        push!(lb.args, Expr(:(=), f, syms[((ciₙargs[2])::Core.SSAValue).id]))
      elseif isglobalref(f, Base, :materialize!)
        add_ci_call!(
          lb,
          lv(:vmaterialize!),
          ciₙargs,
          syms,
          n,
          unroll_param_tup,
          mod
        )
      elseif isglobalref(f, Base, :materialize)
        add_ci_call!(
          lb,
          lv(:vmaterialize),
          ciₙargs,
          syms,
          n,
          unroll_param_tup,
          mod
        )
      else
        add_ci_call!(lb, f, ciₙargs, syms, n)
      end
    end
  end
  ret::Expr = pop!(lb.args)::Expr
  if Meta.isexpr(ret, :(=), 2)
    ret = (ret.args[2])::Expr
  end
  esc(Expr(:let, lb, Expr(:block, ret)))
end

function LoopSet(q::Expr, mod::Symbol = :Main)
  ls = LoopSet(mod)
  check_inputs!(q, ls.prepreamble)
  contract_pass!(q)
  _copyto!(ls, q)
  resize!(ls.loop_order, num_loops(ls))
  ls
end
LoopSet(q::Expr, m::Module) = LoopSet(macroexpand(m, q)::Expr, Symbol(m))

function loopset(q::Expr) # for interactive use only
  ls = LoopSet(q)
  set_hw!(ls)
  ls
end

function check_macro_kwarg(
  arg,
  inline::Bool,
  check_empty::Bool,
  u₁::Int8,
  u₂::Int8,
  v::Int8,
  threads::Int,
  warncheckarg::Int,
  safe::Bool
)
  ((arg.head === :(=)) && (length(arg.args) == 2)) ||
    throw(ArgumentError("macro kwarg should be of the form `argname = value`."))
  kw = (arg.args[1])::Symbol
  value = (arg.args[2])
  if kw === :inline
    inline = value::Bool
  elseif kw === :unroll
    if value isa Integer
      u₁ = convert(Int8, value)::Int8
    elseif Meta.isexpr(value, :tuple, 2)
      u₁ = convert(Int8, value.args[1])::Int8
      u₂ = convert(Int8, value.args[2])::Int8
    else
      throw(
        ArgumentError("Don't know how to process argument in `unroll=$value`.")
      )
    end
  elseif kw === :vectorize
    v = convert(Int8, value)
  elseif kw === :check_empty
    check_empty = value::Bool
  elseif kw === :thread
    if value isa Bool
      threads = Core.ifelse(value::Bool, -1, 1)
    elseif value isa Integer
      threads = max(1, convert(Int, value)::Int)
    else
      throw(
        ArgumentError("Don't know how to process argument in `thread=$value`.")
      )
    end
  elseif kw === :warn_check_args
    warncheckarg = convert(Int, value)::Int
  elseif kw === :safe
    safe = convert(Bool, value)
  else
    throw(
      ArgumentError(
        "Received unrecognized keyword argument $kw. Recognized arguments include:\n`inline`, `unroll`, `check_empty`, and `thread`."
      )
    )
  end
  inline, check_empty, u₁, u₂, v, threads, warncheckarg, safe
end
function process_args(
  args;
  inline::Bool = false,
  check_empty::Bool = false,
  u₁::Int8 = zero(Int8),
  u₂::Int8 = zero(Int8),
  v::Int8 = zero(Int8),
  threads::Int = 1,
  warncheckarg::Int = 1,
  safe::Bool = true
)
  for arg ∈ args
    inline, check_empty, u₁, u₂, v, threads, warncheckarg, safe =
      check_macro_kwarg(
        arg,
        inline,
        check_empty,
        u₁,
        u₂,
        v,
        threads,
        warncheckarg,
        safe
      )
  end
  inline, check_empty, u₁, u₂, v, threads, warncheckarg, safe
end
# check if the body of loop is a block, if not convert it to a block issue#395
# and check if the range of loop is an enumerate, if it is replace it, issue#393
function check_inputs!(q, prepreamble)
  if Meta.isexpr(q, :for)
    if !Meta.isexpr(q.args[2], :block)
      q.args[2] = Expr(:block, q.args[2])
      replace_enumerate!(q, prepreamble) # must after warp block
    else # maybe inner loops in block
      replace_enumerate!(q, prepreamble)
      for arg in q.args[2].args
        check_inputs!(arg, prepreamble) # check recursively for inner loop
      end
    end
  end
  return q
end
function replace_enumerate!(q, prepreamble)
  looprange = q.args[1]
  if Meta.isexpr(looprange, :block)
    for i = 1:length(looprange.args)
      replace_single_enumerate!(q, prepreamble, i)
    end
  else
    replace_single_enumerate!(q, prepreamble)
  end
  return q
end
function replace_single_enumerate!(q, prepreamble, i = nothing)
  if isnothing(i) # not nest loop
    looprange, body = q.args[1]::Expr, q.args[2]
  else # nest loop
    looprange, body = q.args[1].args[i]::Expr, q.args[2]
  end
  @assert Meta.isexpr(looprange, :(=), 2)
  itersyms, r = looprange.args
  if Meta.isexpr(r, :call, 2) && r.args[1] === :enumerate
    _iter = r.args[2]
    if _iter isa Symbol
      iter = _iter
    else # name complex expr
      iter = gensym(:iter)
      push!(prepreamble.args, :($iter = $_iter))
    end
    if Meta.isexpr(itersyms, :tuple, 2)
      indsym, varsym = itersyms.args[1]::Symbol, itersyms.args[2]::Symbol
      _replace_looprange!(q, i, indsym, iter)
      pushfirst!(body.args, :($varsym = $iter[$indsym+firstindex($iter)-1]))
    elseif Meta.isexpr(itersyms, :tuple, 1) # like `for (i,) in enumerate(...)`
      indsym = itersyms.args[1]::Symbol
      _replace_looprange!(q, i, indsym, iter)
    elseif itersyms isa Symbol # if itersyms are not unbox in loop range
      throw(
        ArgumentError("`for $itersyms in enumerate($r)` is not supported,
    please use `for ($(itersyms)_i, $(itersyms)_v) in enumerate($r)` instead.")
      )
    else
      throw(ArgumentError("Don't know how to handle expression `$itersyms`."))
    end
  end
  return q
end
_replace_looprange!(q, ::Nothing, indsym, iter) =
  q.args[1] = :($indsym = Base.OneTo(length($iter)))
_replace_looprange!(q, i::Int, indsym, iter) =
  q.args[1].args[i] = :($indsym = Base.OneTo(length($iter)))

function turbo_macro(mod, src, q, args...)
  q = macroexpand(mod, q)
  if q.head === :for
    ls = LoopSet(q, mod)
    inline, check_empty, u₁, u₂, v, threads, warncheckarg, safe =
      process_args(args)
    esc(
      setup_call(
        ls,
        q,
        src,
        inline,
        check_empty,
        u₁,
        u₂,
        v,
        threads,
        warncheckarg,
        safe
      )
    )
  else
    inline, check_empty, u₁, u₂, v, threads, warncheckarg, safe =
      process_args(args; inline = true)
    substitute_broadcast(
      q,
      Symbol(mod),
      inline,
      u₁,
      u₂,
      v,
      threads,
      warncheckarg,
      safe
    )
  end
end
"""
    @turbo

Annotate a `for` loop, or a set of nested `for` loops whose bounds are constant across iterations, to optimize the computation. For example:

    function AmulB!(C, A, B)
        @turbo for m ∈ indices((A,C), 1), n ∈ indices((B,C), 2) # indices((A,C),1) == axes(A,1) == axes(C,1)
            Cₘₙ = zero(eltype(C))
            for k ∈ indices((A,B), (2,1)) # indices((A,B), (2,1)) == axes(A,2) == axes(B,1)
                Cₘₙ += A[m,k] * B[k,n]
            end
            C[m,n] = Cₘₙ
        end
    end

The macro models the set of nested loops, and chooses an ordering of the three loops to minimize predicted computation time.

Current limitations:

 1. It assumes that loop iterations are independent.
 2. It does not perform bounds checks.
 3. It assumes that each loop iterates at least once. (Use `@turbo check_empty=true` to lift this assumption.)
 4. That there is only one loop at each level of the nest.

It may also apply to broadcasts:

```jldoctest
julia> using LoopVectorization

julia> a = rand(100);

julia> b = @turbo exp.(2 .* a);

julia> c = similar(b);

julia> @turbo @. c = exp(2a);

julia> b ≈ c
true
```

# Extended help

Advanced users can customize the implementation of the `@turbo`-annotated block
using keyword arguments:

```julia
@turbo inline = false unroll = 2 thread = 4 body
```

where `body` is the code of the block (e.g., `for ... end`).

`thread` is either a Boolean, or an integer.
The integer's value indicates the number of threads to use.
It is clamped to be between `1` and `min(Threads.nthreads(),LoopVectorization.num_cores())`.
`false` is equivalent to `1`, and `true` is equivalent to `min(Threads.nthreads(),LoopVectorization.num_cores())`.

`safe` (defaults to `true`) will cause `@turbo` to fall back to `@inbounds @fastmath` if `can_turbo` returns false for any of the functions called in the loop. You can disable the associated warning with `warn_check_args=false`.

Setting the keyword argument `warn_check_args=true` (e.g. `@turbo warn_check_args=true for ...`) in a loop or
broadcast statement will cause it to warn once if `LoopVectorization.check_args` fails and the fallback
loop is executed instead of the LoopVectorization-optimized loop.
Setting it to an integer > 0 will warn that many times, while setting it to a negative integer will warn
an unlimited amount of times. The default is `warn_check_args = 1`. Failure means that there may have been an array with unsupported type, unsupported element types, or (if `safe=true`) a function for which `can_turbo` returned `false`.

`inline` is a Boolean. When `true`, `body` will be directly inlined
into the function (via a forced-inlining call to `_turbo_!`).
When `false`, it wont force inlining of the call to `_turbo_!` instead, letting Julia's own inlining engine
determine whether the call to `_turbo_!` should be inlined. (Typically, it won't.)
Sometimes not inlining can lead to substantially worse code generation, and >40% regressions, even in very
large problems (2-d convolutions are a case where this has been observed).
One can find some circumstances where `inline=true` is faster, and other circumstances
where `inline=false` is faster, so the best setting may require experimentation. By default, the macro
tries to guess. Currently the algorithm is simple: roughly, if there are more than two dynamically sized loops
or and no convolutions, it will probably not force inlining. Otherwise, it probably will.

`check_empty` (default is `false`) determines whether or not it will check if any of the iterators are empty.
If false, you must ensure yourself that they are not empty, else the behavior of the loop is undefined and
(like with `@inbounds`) segmentation faults are likely.

`unroll` is an integer that specifies the loop unrolling factor, or a
tuple `(u₁, u₂) = (4, 2)` signaling that the generated code should unroll more than
one loop. `u₁` is the unrolling factor for the first unrolled loop and `u₂` for the next (if present),
but it applies to the loop ordering and unrolling that will be chosen by LoopVectorization,
*not* the order in `body`.
`uᵢ=0` (the default) indicates that LoopVectorization should pick its own value,
and `uᵢ=-1` disables unrolling for the correspond loop.

The `@turbo` macro also checks the array arguments using `LoopVectorization.check_args` to try and determine
if they are compatible with the macro. If `check_args` returns false, a fall back loop annotated with `@inbounds`
and `@fastmath` is generated. Note that `VectorizationBase` provides functions such as `vadd` and `vmul` that will
ignore `@fastmath`, preserving IEEE semantics both within `@turbo` and `@fastmath`.
`check_args` currently returns false for some wrapper types like `LinearAlgebra.UpperTriangular`, requiring you to
use their `parent`. Triangular loops aren't yet supported.
"""
macro turbo(args...)
  turbo_macro(__module__, __source__, last(args), Base.front(args)...)
end
"""
    @tturbo

Equivalent to `@turbo`, except it adds `thread=true` as the first keyword argument.
Note that later arguments take precedence.

Meant for convenience, as `@tturbo` is shorter than `@turbo thread=true`.
"""
macro tturbo(args...)
  turbo_macro(
    __module__,
    __source__,
    last(args),
    :(thread = true),
    Base.front(args)...
  )
end

function def_outer_reduct_types!(ls::LoopSet)
  for or ∈ ls.outer_reductions
    op = operations(ls)[or]
    pushpreamble!(
      ls,
      Expr(:(=), outer_reduct_init_typename(op), typeof_expr(op))
    )
  end
end
"""
    @_turbo

This macro mostly exists for debugging/testing purposes. It does not support many of the use cases of [`@turbo`](@ref).
It emits loops directly, rather than punting to an `@generated` function, meaning it doesn't have access to type
information when generating code or analyzing the loops, often leading to bad performance.

This macro accepts the `inline` and `unroll` keyword arguments like `@turbo`, but ignores the `check_empty` argument.
"""
macro _turbo(q)
  q = macroexpand(__module__, q)
  ls = LoopSet(q, __module__)
  set_hw!(ls)
  def_outer_reduct_types!(ls)
  esc(Expr(:block, ls.prepreamble, lower_and_split_loops(ls, -1)))
end
macro _turbo(arg, q)
  @assert q.head === :for
  q = macroexpand(__module__, q)
  inline, check_empty, u₁, u₂, v = check_macro_kwarg(
    arg,
    false,
    false,
    zero(Int8),
    zero(Int8),
    zero(Int8),
    1,
    0,
    true
  )
  ls = LoopSet(q, __module__)
  set_hw!(ls)
  def_outer_reduct_types!(ls)
  esc(Expr(:block, ls.prepreamble, lower(ls, u₁ % Int, u₂ % Int, v % Int, -1)))
end

"""
    @turbo_debug

Returns a `LoopSet` object instead of evaluating the loops. Useful for debugging and introspection.
"""
macro turbo_debug(q)
  q = macroexpand(__module__, q)
  ls = LoopSet(q, __module__)
  esc(LoopVectorization.setup_call_debug(ls))
end

# define aliases
const var"@avx" = var"@turbo"
const var"@avxt" = var"@tturbo"
const var"@avx_debug" = var"@turbo_debug"

using LoopVectorization: vpermilps177, vmovshdup, vfmsubadd, vfmaddsub, vmovsldup
function dot_simd(a::AbstractVector, b::AbstractVector)
  s = zero(eltype(a))
  @fastmath @inbounds @simd for i ∈ eachindex(a)
    s += a[i]' * b[i]
  end
  s
end
function cdot_mat(ca::AbstractVector{Complex{T}}, cb::AbstractVector{Complex{T}}) where {T}
  a = reinterpret(reshape, T, ca)
  b = reinterpret(reshape, T, cb)
  re = zero(T)
  im = zero(T)
  @turbo for i ∈ axes(a, 2)
    re += a[1, i] * b[1, i] + a[2, i] * b[2, i]
    im += a[1, i] * b[2, i] - a[2, i] * b[1, i]
  end
  Complex(re, im)
end
function cdot_swizzle(
  ca::AbstractVector{Complex{T}},
  cb::AbstractVector{Complex{T}},
) where {T}
  a = reinterpret(T, ca)
  b = reinterpret(T, cb)
  reim = Vec(zero(T), zero(T))
  @turbo for i ∈ eachindex(a)
    reim =
      vfmsubadd(vmovsldup(a[i]), b[i], vfmsubadd(vmovshdup(a[i]), vpermilps177(b[i]), reim))
  end
  Complex(reim(1), reim(2))
end
function cdot_affine(
  ca::AbstractVector{Complex{T}},
  cb::AbstractVector{Complex{T}},
) where {T}
  a = reinterpret(T, ca)
  b = reinterpret(T, cb)
  re = zero(T)
  im = zero(T)
  # with a multiplier, we go from `i = 1 -> 2i = 2` to `i = 0 -> 2i = 0
  # 2(i+1-1) = 2i + 2 - 2, so....
  @turbo for i ∈ 1:length(a)>>>1
    re += a[2i-1] * b[2i-1] + a[2i] * b[2i]
    im += a[2i-1] * b[2i] - a[2i] * b[2i-1]
  end
  Complex(re, im)
end
function cdot_stride(
  ca::AbstractVector{Complex{T}},
  cb::AbstractVector{Complex{T}},
) where {T}
  a = reinterpret(T, ca)
  b = reinterpret(T, cb)
  re = zero(T)
  im = zero(T)
  @turbo for i ∈ 1:2:length(a)
    re += a[i] * b[i] + a[i+1] * b[i+1]
    im += a[i] * b[i+1] - a[i+1] * b[i]
  end
  Complex(re, im)
end
function qdot_simd(x::AbstractVector{NTuple{4,T}}, y::AbstractVector{NTuple{4,T}}) where {T}
  a = zero(T)
  b = zero(T)
  c = zero(T)
  d = zero(T)
  @fastmath @inbounds @simd for i ∈ eachindex(x)
    a₁, b₁, c₁, d₁ = x[i]
    a₂, b₂, c₂, d₂ = y[i]
    a += a₁ * a₂ + b₁ * b₂ + c₁ * c₂ + d₁ * d₂
    b += a₁ * b₂ - b₁ * a₂ - c₁ * d₂ + d₁ * c₂
    c += a₁ * c₂ + b₁ * d₂ - c₁ * a₂ - d₁ * b₂
    d += a₁ * d₂ - b₁ * c₂ + c₁ * b₂ - d₁ * a₂
  end
  (a, b, c, d)
end
function qdot_mat(x::AbstractMatrix, y::AbstractMatrix)
  a = zero(eltype(x))
  b = zero(eltype(x))
  c = zero(eltype(x))
  d = zero(eltype(x))
  @turbo for i ∈ axes(x, 2)
    a₁ = x[1, i]
    b₁ = x[2, i]
    c₁ = x[3, i]
    d₁ = x[4, i]
    a₂ = y[1, i]
    b₂ = y[2, i]
    c₂ = y[3, i]
    d₂ = y[4, i]
    a += a₁ * a₂ + b₁ * b₂ + c₁ * c₂ + d₁ * d₂
    b += a₁ * b₂ - b₁ * a₂ - c₁ * d₂ + d₁ * c₂
    c += a₁ * c₂ + b₁ * d₂ - c₁ * a₂ - d₁ * b₂
    d += a₁ * d₂ - b₁ * c₂ + c₁ * b₂ - d₁ * a₂
  end
  (a, b, c, d)
end
function qdot_affine(x::AbstractVector, y::AbstractVector)
  a = zero(eltype(x))
  b = zero(eltype(x))
  c = zero(eltype(x))
  d = zero(eltype(x))
  @turbo for i ∈ 1:length(x)>>2
    a₁ = x[4i-3]
    b₁ = x[4i-2]
    c₁ = x[4i-1]
    d₁ = x[4i]
    a₂ = y[4i-3]
    b₂ = y[4i-2]
    c₂ = y[4i-1]
    d₂ = y[4i]
    a += a₁ * a₂ + b₁ * b₂ + c₁ * c₂ + d₁ * d₂
    b += a₁ * b₂ - b₁ * a₂ - c₁ * d₂ + d₁ * c₂
    c += a₁ * c₂ + b₁ * d₂ - c₁ * a₂ - d₁ * b₂
    d += a₁ * d₂ - b₁ * c₂ + c₁ * b₂ - d₁ * a₂
  end
  (a, b, c, d)
end
function qdot_stride(x::AbstractVector, y::AbstractVector)
  a = zero(eltype(x))
  b = zero(eltype(x))
  c = zero(eltype(x))
  d = zero(eltype(x))
  @turbo for i ∈ 1:4:length(x)
    a₁ = x[i]
    b₁ = x[i+1]
    c₁ = x[i+2]
    d₁ = x[i+3]
    a₂ = y[i]
    b₂ = y[i+1]
    c₂ = y[i+2]
    d₂ = y[i+3]
    a += a₁ * a₂ + b₁ * b₂ + c₁ * c₂ + d₁ * d₂
    b += a₁ * b₂ - b₁ * a₂ - c₁ * d₂ + d₁ * c₂
    c += a₁ * c₂ + b₁ * d₂ - c₁ * a₂ - d₁ * b₂
    d += a₁ * d₂ - b₁ * c₂ + c₁ * b₂ - d₁ * a₂
  end
  (a, b, c, d)
end
function cmatmul_array!(
  Cc::AbstractMatrix{Complex{T}},
  Ac::AbstractMatrix{Complex{T}},
  Bc::AbstractMatrix{Complex{T}},
) where {T}
  C = reinterpret(reshape, Float64, Cc)
  A = reinterpret(reshape, Float64, Ac)
  B = reinterpret(reshape, Float64, Bc)
  @turbo for n ∈ indices((C, B), 3), m ∈ indices((C, A), 2)
    Cre = zero(T)
    Cim = zero(T)
    for k ∈ indices((A, B), (3, 2))
      Cre += A[1, m, k] * B[1, k, n] - A[2, m, k] * B[2, k, n]
      Cim += A[1, m, k] * B[2, k, n] + A[2, m, k] * B[1, k, n]
    end
    C[1, m, n] = Cre
    C[2, m, n] = Cim
  end
  return Cc
end
function cmatmul_array_v2!(
  Cc::AbstractMatrix{Complex{T}},
  Ac::AbstractMatrix{Complex{T}},
  Bc::AbstractMatrix{Complex{T}},
) where {T}
  C = reinterpret(Float64, Cc)
  A = reinterpret(Float64, Ac)
  B = reinterpret(reshape, Float64, Bc)
  @turbo vectorize = 2 for n ∈ indices((C, B), (2, 3)), m ∈ indices((C, A), 1)
    Cmn = zero(T)
    for k ∈ indices((A, B), (2, 2))
      Amk = A[m, k]
      Aperm = vpermilps177(Amk)
      Cmn = vfmaddsub(Amk, B[1, k, n], vfmaddsub(Aperm, B[2, k, n], Cmn))
    end
    C[m, n] = Cmn
  end
  return Cc
end

function issue209(M, G, J, H, B, ϕ)
  # tmp = similar(ϕ, G-1, (2*J+1)*(H + 1));
  tmp = view(
    fill(eltype(ϕ)(123456789), G + 15, (2 * J + 1) * (H + 1) + 16),
    9:G+7,
    9:(2*J+1)*(H+1)+8,
  )
  Bf = reinterpret(reshape, Float64, B)
  ϕf = reinterpret(reshape, Float64, ϕ)
  tmpf = reinterpret(reshape, Float64, tmp)
  jmax = 2 * J + 1
  # B is being indexed via ptr offsetting
  # thus B's initial `gesp`ing must set it up for this
  # currently, it isn't because  `jj` and `hh` are loop induct vars
  for mm = 1:M
    m_idx = M + 2 - mm
    @turbo for hh = 1:H+1
      h_idx = (hh - 1) * jmax
      for jj = 1:jmax, gg = 1:G-1
        tmpf[1, gg, jj+h_idx] = ϕf[1, jj, gg+1, hh, m_idx] + Bf[1, jj, gg, hh, m_idx]
        tmpf[2, gg, jj+h_idx] = ϕf[2, jj, gg+1, hh, m_idx] + Bf[2, jj, gg, hh, m_idx]
      end
    end
  end
  parent(tmp)
end
function issue209_noavx(M, G, J, H, B, ϕ)
  tmp = view(
    fill(eltype(ϕ)(123456789), G + 15, (2 * J + 1) * (H + 1) + 16),
    9:G+7,
    9:(2*J+1)*(H+1)+8,
  )
  Bf = reinterpret(reshape, Float64, B)
  ϕf = reinterpret(reshape, Float64, ϕ)
  tmpf = reinterpret(reshape, Float64, tmp)
  jmax = 2 * J + 1
  for mm = 1:M
    m_idx = M + 2 - mm
    for hh = 1:H+1
      h_idx = (hh - 1) * jmax
      for jj = 1:jmax, gg = 1:G-1
        tmpf[1, gg, jj+h_idx] = ϕf[1, jj, gg+1, hh, m_idx] + Bf[1, jj, gg, hh, m_idx]
        tmpf[2, gg, jj+h_idx] = ϕf[2, jj, gg+1, hh, m_idx] + Bf[2, jj, gg, hh, m_idx]
      end
    end
  end
  parent(tmp)
end
using LoopVectorization

function sumdim2_turbo!(r1, r2)
  @turbo thread = true for j in indices((r1, r2), (3, 4)), i ∈ indices((r1, r2), (2, 3))
    r1[1, i, j] = r2[1, 1, i, j] + r2[1, 2, i, j]
    r1[2, i, j] = r2[2, 1, i, j] - r2[2, 2, i, j]
    r1[3, i, j] = r2[3, 1, i, j] * r2[3, 2, i, j]
    r1[4, i, j] = r2[4, 1, i, j] / r2[4, 2, i, j]
  end
  r1
end
function sumdim2!(r1, r2)
  @inbounds @fastmath for j in indices((r1, r2), (3, 4)), i ∈ indices((r1, r2), (2, 3))
    r1[1, i, j] = r2[1, 1, i, j] + r2[1, 2, i, j]
    r1[2, i, j] = r2[2, 1, i, j] - r2[2, 2, i, j]
    r1[3, i, j] = r2[3, 1, i, j] * r2[3, 2, i, j]
    r1[4, i, j] = r2[4, 1, i, j] / r2[4, 2, i, j]
  end
  r1
end

# Issue 287
function my_gemm_noturbo!(out, s::Matrix{UInt8}, V)
  Vcols = size(V, 2)
  srows = size(s, 1)
  scols = size(s, 2)
  k = srows >> 2
  rem = srows & 3
  @inbounds @fastmath for c = 1:Vcols
    for j = 1:scols
      for l = 1:k
        block = s[l, j]
        for p = 1:4
          Aij = (block >> (2 * (p - 1))) & 3
          out[4*(l-1)+p, c] += ((Aij >= 2) + (Aij == 3)) * V[j, c]
        end
      end
    end
  end
  # TODO handle rem
end
function my_gemm_unroll(out, s::Matrix{UInt8}, V)
  Vcols = size(V, 2)
  srows = size(s, 1)
  scols = size(s, 2)
  k = srows >> 2
  rem = srows & 3
  @avx for c = 1:Vcols
    for j = 1:scols
      for l = 1:k
        block = s[l, j]
        for p = 1:4
          Aij = (block >> (2 * (p - 1))) & 3
          out[4*(l-1)+p, c] += ((Aij >= 2) + (Aij == 3)) * V[j, c]
        end
      end
    end
  end
  # TODO handle rem
end
function my_gemm_manual_unroll(out, s::Matrix{UInt8}, V)
  Vcols = size(V, 2)
  srows = size(s, 1)
  scols = size(s, 2)
  k = srows >> 2
  rem = srows & 3
  @avx for c = 1:Vcols
    for j = 1:scols
      for l = 1:k
        block = s[l, j]
        # unrolled loop
        thisiszero = 0
        p = 1
        Aij = (block >> (2 * (p - 1))) & 3
        out[4*(l-1)+p, c+thisiszero] += ((Aij >= 2) + (Aij == 3)) * V[j, c]
        p = 2
        Aij = (block >> (2 * (p - 1))) & 3
        out[4*(l-1)+p, c] += ((Aij >= 2) + (Aij == 3)) * V[j, c]
        p = 3
        Aij = (block >> (2 * (p - 1))) & 3
        out[4*(l-1)+p+thisiszero, c] += ((Aij >= 2) + (Aij == 3)) * V[j, c]
        p = 4
        Aij = (block >> (2 * (p - 1))) & 3
        out[4*(l-1)+p, c] += ((Aij >= 2) + (Aij == 3)) * V[j, c]
      end
    end
  end
  # TODO handle rem
end
function my_gemm_nexpr_unroll(out, s::Matrix{UInt8}, V)
  Vcols = size(V, 2)
  srows = size(s, 1)
  scols = size(s, 2)
  k = srows >> 2
  rem = srows & 3
  @turbo for c = 1:Vcols
    for j = 1:scols
      for l = 1:k
        block = s[l, j]
        # unrolled loop
        Base.Cartesian.@nexprs 4 p -> begin
          Aij = (block >> (2 * (p - 1))) & 3
          out[4*(l-1)+p, c] += ((Aij >= 2) + (Aij == 3)) * V[j, c]
        end
      end
    end
  end
  # TODO handle rem
end

function readraw_turbo!(img, raw)
  npack = length(raw) ÷ 3
  @turbo for i = 0:npack-1
    img[1+4i] = raw[2+3i] << 4
    img[2+4i] = raw[1+3i]
    img[3+4i] = raw[2+3i]
    img[4+4i] = raw[3+3i]
  end
  img
end
function readraw!(img, raw)
  npack = length(raw) ÷ 3
  @inbounds @simd for i = 0:npack-1
    img[1+4i] = raw[2+3i] << 4
    img[2+4i] = raw[1+3i]
    img[3+4i] = raw[2+3i]
    img[4+4i] = raw[3+3i]
  end
  img
end

function issue348_ref!(hi, lo)
  @inbounds @fastmath for j = 0:(size(hi, 2)-3)÷3 # This tturbo 
    for i = 0:(size(hi, 1)-3)÷3
      hi[3i+2, 3j+2] = lo[i+2, j+2]
      hi[3i+3, 3j+2] = lo[i+2, j+2]
      hi[3i+4, 3j+2] = lo[i+2, j+2]
      hi[3i+2, 3j+3] = lo[i+2, j+2]
      hi[3i+3, 3j+3] = lo[i+2, j+2]
      hi[3i+4, 3j+3] = lo[i+2, j+2]
      hi[3i+2, 3j+4] = lo[i+2, j+2]
      hi[3i+3, 3j+4] = lo[i+2, j+2]
      hi[3i+4, 3j+4] = lo[i+2, j+2]
    end
  end
end
function issue348_v0!(hi, lo)
  @turbo for j = 0:(size(hi, 2)-3)÷3 # This tturbo 
    for i = 0:(size(hi, 1)-3)÷3
      hi[3i+2, 3j+2] = lo[i+2, j+2]
      hi[3i+3, 3j+2] = lo[i+2, j+2]
      hi[3i+4, 3j+2] = lo[i+2, j+2]
      hi[3i+2, 3j+3] = lo[i+2, j+2]
      hi[3i+3, 3j+3] = lo[i+2, j+2]
      hi[3i+4, 3j+3] = lo[i+2, j+2]
      hi[3i+2, 3j+4] = lo[i+2, j+2]
      hi[3i+3, 3j+4] = lo[i+2, j+2]
      hi[3i+4, 3j+4] = lo[i+2, j+2]
    end
  end
end
function issue348_v1!(hi, lo)
  @turbo for j = 0:3:size(hi, 2)-3 # This tturbo 
    for i = 0:3:size(hi, 1)-3
      i_lo = i ÷ 3 + 2
      j_lo = j ÷ 3 + 2
      i_hi = i + 2
      j_hi = j + 2
      hi[i_hi, j_hi] = lo[i_lo, j_lo]
      hi[i_hi+1, j_hi] = lo[i_lo, j_lo]
      hi[i_hi+2, j_hi] = lo[i_lo, j_lo]
      hi[i_hi, j_hi+1] = lo[i_lo, j_lo]
      hi[i_hi+1, j_hi+1] = lo[i_lo, j_lo]
      hi[i_hi+2, j_hi+1] = lo[i_lo, j_lo]
      hi[i_hi, j_hi+2] = lo[i_lo, j_lo]
      hi[i_hi+1, j_hi+2] = lo[i_lo, j_lo]
      hi[i_hi+2, j_hi+2] = lo[i_lo, j_lo]
    end
  end
end
function reverse_part(n1, n2)
  A = zeros(n1, n2)
  @turbo for i = 1:n1÷2, j = 1:n2
    c = 1.0
    A[i, j] = c
    r = n1 + 1 - i
    A[r, j] = c
  end
  return A
end
function reverse_part_ref(n1, n2)
  A = zeros(n1, n2)
  @inbounds for i = 1:n1÷2
    @simd for j = 1:n2
      c = 1.0
      A[i, j] = c
      r = n1 + 1 - i
      A[r, j] = c
    end
  end
  return A
end


function tullio_issue_131_ref(arr)
  M, N = size(arr)
  out = zeros(M >>> 1, N >>> 1)
  @inbounds @fastmath for j in axes(out, 2)
    for i in axes(out, 1)
      out[i, j] = arr[2i, 2j] + arr[2i-1, 2j] + arr[2i-1, 2j-1] + arr[2i, 2j-1]
    end
  end
  out
end


function tullio_issue_131(arr)
  M, N = size(arr)
  out = zeros(M >>> 1, N >>> 1)
  @turbo for j in axes(out, 2)
    for i in axes(out, 1)
      out[i, j] = arr[2i, 2j] + arr[2i-1, 2j] + arr[2i-1, 2j-1] + arr[2i, 2j-1]
    end
  end
  out
end


@testset "shuffles load/stores" begin
  @show @__LINE__
  for i ∈ 1:128
    ac = rand(Complex{Float64}, i)
    bc = rand(Complex{Float64}, i)
    dsimd = dot_simd(ac, bc)
    if VERSION ≥ v"1.6.0-rc1"
      @test dsimd ≈ cdot_mat(ac, bc)
    end
    @test dsimd ≈ cdot_affine(ac, bc) ≈ cdot_stride(ac, bc)


    xq = [ntuple(_ -> rand(), Val(4)) for _ ∈ 1:i]
    yq = [ntuple(_ -> rand(), Val(4)) for _ ∈ 1:i]
    xqv = reinterpret(Float64, xq)
    yqv = reinterpret(Float64, yq)
    qsimd = Base.vect(qdot_simd(xq, yq)...)
    if VERSION ≥ v"1.6.0-rc1"
      xqm = reinterpret(reshape, Float64, xq)
      yqm = reinterpret(reshape, Float64, yq)
      @test qsimd ≈ Base.vect(qdot_mat(xqm, yqm)...)
    end
    @test qsimd ≈ Base.vect(qdot_affine(xqv, yqv)...) ≈ Base.vect(qdot_stride(xqv, yqv)...)

    for j ∈ max(1, i - 5):i+5, k ∈ max(1, i - 5, i + 5)
      A = rand(j + 1, k)
      @test tullio_issue_131(A) ≈ tullio_issue_131_ref(A)
      if VERSION ≥ v"1.6.0-rc1"
        Ac = rand(Complex{Float64}, j, i)
        Bc = rand(Complex{Float64}, i, k)
        Cc1 = Ac * Bc
        Cc2 = similar(Cc1)
        Cc3 = similar(Cc1)
        @test Cc1 ≈ cmatmul_array!(Cc2, Ac, Bc)
        Cc2 .= NaN
        @test Cc1 ≈ cmatmul_array_v2!(Cc2, Ac, Bc)
      end
    end
  end
  @show @__LINE__
  if VERSION ≥ v"1.6.0-rc1"
    M = 10
    G = 50
    J = 50
    H = 30

    # B = rand(Complex{Float64}, 2*J+1, G-1, H+1, M+1);
    # ϕ = rand(Complex{Float64}, 2*J+1, G+1, H+1, M+1);
    rbc = let rb = 1.0:((2*J+17)*(G+15)*(H+17)*(M+17)), rbr = reverse(rb)
      Complex{Float64}[rb[i] + im * rbr[i] for i ∈ eachindex(rb)]
    end
    B =
      view(
        reshape(rbc, (2 * J + 17, G + 15, H + 17, M + 17)),
        9:2*J+9,
        9:G+9,
        9:H+9,
        9:M+9,
      ) .= rand.() .+ rand.() .* im
    ϕ =
      view(
        fill(1e5 + 1e7im, 2 * J + 17, G + 17, H + 17, M + 17),
        9:2*J+9,
        9:G+9,
        9:H+9,
        9:M+9,
      ) .= rand.() .+ rand.() .* im
    @test issue209(M, G, J, H, B, ϕ) ≈ issue209_noavx(M, G, J, H, B, ϕ)
  end

  s = Array{Float64}(undef, 4, 128, 128)
  s2 = rand(4, 2, 128, 128)
  @test sumdim2_turbo!(s, s2) ≈ sumdim2!(similar(s), s2)

  # issue 287
  out_test = zeros(100, 10)
  out_test1 = zeros(100, 10)
  s = rand(UInt8, 25, 100)
  V = rand(100, 10)
  my_gemm_noturbo!(out_test, s, V)
  my_gemm_unroll(out_test1, s, V)
  @test out_test ≈ out_test1
  my_gemm_manual_unroll(fill!(out_test1, 0), s, V)
  @test out_test ≈ out_test1
  my_gemm_nexpr_unroll(fill!(out_test1, 0), s, V)
  @test out_test ≈ out_test1


  w = 2048
  raw = rand(UInt8, (3w * w) ÷ 4)
  img1 = Matrix{UInt8}(undef, w, w)
  img2 = Matrix{UInt8}(undef, w, w)
  @test readraw!(img1, raw) == readraw_turbo!(img2, raw)

  for n_hi ∈ 9:100
    iszero((n_hi - 1) % 3) && continue
    n_lo = n_hi ÷ 3
    a_lo_gc = rand(n_lo + 2, n_lo + 2)
    a_hi_tmp_ref = zeros(n_hi + 2, n_hi + 2)
    a_hi_tmp0 = zeros(n_hi + 2, n_hi + 2)

    issue348_ref!(a_hi_tmp_ref, a_lo_gc)
    issue348_v0!(a_hi_tmp0, a_lo_gc)
    @test a_hi_tmp_ref == a_hi_tmp0
    a_hi_tmp1 = view(
      zeros(size(a_hi_tmp0) .* 9),
      map((x, y) -> x .+ (4y), axes(a_hi_tmp0), size(a_hi_tmp0))...,
    )
    issue348_v1!(a_hi_tmp1, a_lo_gc)
    @test a_hi_tmp_ref == a_hi_tmp1
    @turbo a_hi_tmp1 .= 0
    @test all(iszero, parent(a_hi_tmp1))

    @test reverse_part(n_hi, 4) == reverse_part_ref(n_hi, 4)
  end
end

using OffsetArrays

@testset "Iteration Bound Tests" begin
  function masktest_incr1_none1start!(y, x)
    @turbo for i ∈ 0:20
      y[i] = x[i] + 2
    end
  end
  function masktest_incr2_none1start!(y, x)
    @turbo for i ∈ 0:2:20
      y[i] = x[i] + 2
    end
  end

  x = OffsetVector(rand(24), 0:23)
  y = copy(x)
  masktest_incr1_none1start!(y, x)
  @test y == x .+ ifelse.(axes(x, 1) .≤ 20, 2, 0)
  @turbo y .= x
  @test y == x
  masktest_incr2_none1start!(y, x)
  @test y == x .+ ifelse.((axes(x, 1) .≤ 20) .& iseven.(axes(x, 1)), 2, 0)


  # issue #290
  function my_gemm_noturbo!(out, s::Matrix{UInt8}, V, srows, scols, Vcols, μ)
    k = srows >> 2
    rem = srows & 3
    fill!(out, 0)

    for c = 1:Vcols
      for i = 1:scols
        for l = 1:k
          block = s[l, i]
          for p = 1:4
            Aij = (block >> (2 * (p - 1))) & 3
            out[i, c] += (((Aij >= 2) + (Aij == 3) + (Aij == 1) * μ[i]) * V[4*(l-1)+p, c])
          end
        end
      end
    end
    nothing
  end
  function my_gemm!(out, s::Matrix{UInt8}, V, srows, scols, Vcols, μ)
    k = srows >> 2
    rem = srows & 3
    fill!(out, 0)

    @avx for c = 1:Vcols
      for i = 1:scols
        for l = 1:k
          block = s[l, i]
          for p = 1:4
            Aij = (block >> (2 * (p - 1))) & 3
            out[i, c] += (((Aij >= 2) + (Aij == 3) + (Aij == 1) * μ[i]) * V[4*(l-1)+p, c])
          end
        end
      end
    end
    nothing
  end

  out_true = Matrix{Float64}(undef, 100, 100)
  out_test1 = similar(out_true)
  # out_test2 = zeros(100, 100)
  μ = rand(100)
  s = rand(UInt8, 100, 100)
  V = rand(400, 100)

  my_gemm_noturbo!(out_true, s, V, 400, 100, 100, μ)
  my_gemm!(out_test1, s, V, 400, 100, 100, μ)
  @test out_true ≈ out_test1
end

function mismatchedreductions_noturbo!(
  𝛥r392,
  𝛥x923,
  𝛥ℛ,
  ℛ,
  r392,
  x923,
  𝒶𝓍k = 1:2,
  𝒶𝓍n = 1:3,
  𝒶𝓍j = 1:9,
  𝒶𝓍m = 1:9,
  𝒶𝓍i = 1:3,
)
  @inbounds @fastmath for k in 𝒶𝓍k
    for i in 𝒶𝓍i
      for m in 𝒶𝓍m
        for j in 𝒶𝓍j
          for n in 𝒶𝓍n
            ℰ𝓍1 = conj(x923[m, k, n])
            ℰ𝓍2 = 𝛥ℛ[n, j, m, i] * ℰ𝓍1
            ℰ𝓍3 = conj(r392[i, j, k])
            ℰ𝓍4 = 𝛥ℛ[n, j, m, i] * ℰ𝓍3
            𝛥r392[i, j, k] = 𝛥r392[i, j, k] + ℰ𝓍2
            𝛥x923[m, k, n] = 𝛥x923[m, k, n] + ℰ𝓍4
          end
        end
      end
    end
  end
  𝛥r392, 𝛥x923
end
function mismatchedreductions!(
  𝛥r392,
  𝛥x923,
  𝛥ℛ,
  ℛ,
  r392,
  x923,
  𝒶𝓍k = 1:2,
  𝒶𝓍n = 1:3,
  𝒶𝓍j = 1:9,
  𝒶𝓍m = 1:9,
  𝒶𝓍i = 1:3,
)
  @turbo for k in 𝒶𝓍k
    for i in 𝒶𝓍i
      for m in 𝒶𝓍m
        for j in 𝒶𝓍j
          for n in 𝒶𝓍n
            ℰ𝓍1 = conj(x923[m, k, n])
            ℰ𝓍2 = 𝛥ℛ[n, j, m, i] * ℰ𝓍1
            ℰ𝓍3 = conj(r392[i, j, k])
            ℰ𝓍4 = 𝛥ℛ[n, j, m, i] * ℰ𝓍3
            𝛥r392[i, j, k] = 𝛥r392[i, j, k] + ℰ𝓍2
            𝛥x923[m, k, n] = 𝛥x923[m, k, n] + ℰ𝓍4
          end
        end
      end
    end
  end
  𝛥r392, 𝛥x923
end

@testset "Many Loop Reductions" begin
  @show @__LINE__
  A = rand((2:6)...)
  N = ndims(A)
  T = eltype(A)
  let dims = (3, 5)
    sᵢ = size(A)
    sₒ = ntuple(Val(N)) do d
      ifelse(d ∈ dims, 1, sᵢ[d])
    end
    Tₒ = Base.promote_op(+, T, Int)
    B = similar(A, Tₒ, sₒ)

    Bᵥ = view(B, Colon(), Colon(), firstindex(B, 3), Colon(), firstindex(B, 5))
    @turbo for i_1 in indices((A, B), 1)
      for i_2 in indices((A, B), 2)
        for i_4 in indices((A, B), 4)
          Σ = zero(eltype(Bᵥ))
          for i_3 in axes(A, 3)
            for i_5 in axes(A, 5)
              Σ += A[i_1, i_2, i_3, i_4, i_5]
            end
          end
          Bᵥ[i_1, i_2, i_4] = Σ
        end
      end
    end
    @test B ≈ sum(A, dims = dims)
  end
  let dims = (1, 2, 5)

    sᵢ = size(A)
    sₒ = ntuple(Val(N)) do d
      ifelse(d ∈ dims, 1, sᵢ[d])
    end
    Tₒ = Base.promote_op(+, T, Int)
    B = similar(A, Tₒ, sₒ)

    Bᵥ = view(B, firstindex(B, 1), firstindex(B, 2), Colon(), Colon(), firstindex(B, 5))
    @turbo for i_3 in indices((A, B), 3)
      for i_4 in indices((A, B), 4)
        Σ = zero(eltype(Bᵥ))
        for i_1 in axes(A, 1)
          for i_2 in axes(A, 2)
            for i_5 in axes(A, 5)
              Σ += A[i_1, i_2, i_3, i_4, i_5]
            end
          end
        end
        Bᵥ[i_3, i_4] = Σ
      end
    end
    @test B ≈ sum(A, dims = dims)
  end

  r392 = rand(3, 9, 2)
  x923 = rand(9, 2, 3)
  K = rand(3, 9, 9, 3)
  𝛥r392_1, 𝛥x923_1, 𝛥r392_2, 𝛥x923_2, 𝛥ℛ =
    similar(r392), similar(x923), similar(r392), similar(x923), copy(K)
  𝛥r392_1 .= -1
  𝛥x923_1 .= -1
  𝛥r392_2 .= -1
  𝛥x923_2 .= -1

  mismatchedreductions_noturbo!(𝛥r392_1, 𝛥x923_1, 𝛥ℛ, K, r392, x923)
  @time mismatchedreductions!(𝛥r392_2, 𝛥x923_2, 𝛥ℛ, K, r392, x923)
  @test 𝛥r392_1 ≈ 𝛥r392_2
  @test 𝛥x923_1 ≈ 𝛥x923_2
end

function add_unique_store!(ls::LoopSet, op::Operation)
  add_vptr!(ls, op)
  pushop!(ls, op, name(op.ref))
end
function cse_store!(ls::LoopSet, op::Operation)
  id = identifier(op)
  ls.operations[id] = op
  ls.opdict[op.variable] = op
end

function add_store!(
  ls::LoopSet,
  op::Operation,
  add_pvar::Bool = !any(r -> r == op.ref, ls.refs_aliasing_syms)
)
  @assert isstore(op)
  if add_pvar
    push!(ls.syms_aliasing_refs, name(first(parents(op))))
    push!(ls.refs_aliasing_syms, op.ref)
  end
  id = op.identifier
  id == length(operations(ls)) ? add_unique_store!(ls, op) : cse_store!(ls, op)
end
function add_copystore!(
  ls::LoopSet,
  parent::Operation,
  mpref::ArrayReferenceMetaPosition,
  elementbytes::Int
)
  op =
    add_compute!(ls, gensym!(ls, "identity"), :identity, [parent], elementbytes)
  # pushfirst!(mpref.parents, parent)
  add_store!(ls, mpref, elementbytes, op)
end

function add_store!(
  ls::LoopSet,
  mpref::ArrayReferenceMetaPosition,
  elementbytes::Int,
  parent = getop(ls, varname(mpref), mpref.loopdependencies, elementbytes)
)
  isload(parent) && return add_copystore!(ls, parent, mpref, elementbytes)
  vparents = mpref.parents
  ldref = mpref.loopdependencies
  reduceddeps = mpref.reduceddeps
  pvar = name(parent)
  id = length(ls.operations)
  # try to cse store, by replacing the previous one
  mref = mpref.mref
  add_pvar = true
  for opp ∈ operations(ls)
    if mref == opp.ref
      isstore(opp) && (id = opp.identifier)
      add_pvar = false
      break
    end
    # add_pvar &= (name(first(parents(opp))) != pvar)
  end
  pushfirst!(vparents, parent)
  update_deps!(ldref, reduceddeps, parent)
  op = Operation(id, name(mpref), elementbytes, :setindex!, memstore, mpref)
  add_store!(ls, op, add_pvar)
end

function add_store!(
  ls::LoopSet,
  var::Symbol,
  array::Symbol,
  rawindices,
  elementbytes::Int
)
  mpref = array_reference_meta!(ls, array, rawindices, elementbytes, var)
  add_store!(ls, mpref, elementbytes)
end
function add_simple_store!(
  ls::LoopSet,
  parent::Operation,
  mref::ArrayReferenceMeta,
  elementbytes::Int
)
  op = Operation(
    ls,
    name(mref),
    elementbytes,
    :setindex!,
    memstore,
    getindices(mref.ref),
    NODEPENDENCY,
    [parent],
    mref
  )
  add_unique_store!(ls, op)
end
function add_simple_store!(
  ls::LoopSet,
  var::Union{Symbol,Operation},
  ref::Union{ArrayReference,ArrayReferenceMeta},
  elementbytes::Int
)
  parent = isa(var, Symbol) ? getop(ls, var, elementbytes) : var
  mref =
    isa(ref, ArrayReference) ?
    ArrayReferenceMeta(ref, fill(true, length(getindices(ref)))) : ref
  add_simple_store!(ls, parent, mref, elementbytes)
end
function add_store_ref!(ls::LoopSet, var::Symbol, ex::Expr, elementbytes::Int)
  array, raw_indices = ref_from_ref!(ls, ex)
  add_store!(ls, var, array, raw_indices, elementbytes)
end
function add_store_ref!(ls::LoopSet, var, ex::Expr, elementbytes::Int)
  array, raw_indices = ref_from_ref!(ls, ex)
  mpref = array_reference_meta!(ls, array, raw_indices, elementbytes)
  c = add_constant!(
    ls,
    var,
    loopdependencies(mpref),
    gensym(:storeconst),
    elementbytes
  )
  add_store!(ls, mpref, elementbytes, c)
end

# For now, it is illegal to load from a conditional store.
# if you want that sort of behavior, do a conditional reassignment, and store that result unconditionally.
function add_conditional_store!(
  ls::LoopSet,
  LHS,
  condop::Operation,
  storeop::Operation,
  elementbytes::Int
)
  array, rawindices = ref_from_ref!(ls, LHS)
  mpref = array_reference_meta!(ls, array, rawindices, elementbytes)
  mref = mpref.mref
  ldref = mpref.loopdependencies

  pvar = name(storeop)
  id = length(ls.operations)
  @assert pvar ∉ ls.syms_aliasing_refs
  # if pvar ∉ ls.syms_aliasing_refs
  # FIXME properly handle CSE of conditional stores.
  push!(ls.syms_aliasing_refs, pvar)
  push!(ls.refs_aliasing_syms, mref)
  storeparents = [storeop, condop]
  # else
  #     # for now, we don't try to cse the store
  #     # later, as an optimization, we could:
  #     # 1. cse the store
  #     # 2. use the mask to combine the vector we're trying to store here with the vector that would have been stored in the now cse-ed 1.
  #     # 3. use a regular (non-masked) store on that vector.
  #     ref = mpref.mref.ref
  #     for opp ∈ operations(ls)
  #         isstore(opp) || continue
  #         if ref == opp.ref.ref# && return cse_store!(ls, identifier(opp), mref, parents, ldref, reduceddeps, elementbytes)
  #             id = opp.identifier
  #             break
  #         end
  #     end
  #     if id != length(ls.operations) # then there was a previous store
  #         prevstore = getop(ls, id + 1)
  #         # @show prevstore prevstore.node_type, loopdependencies(prevstore)
  #         # @show operations(ls)
  #         storeop = add_compute!(ls, gensym(:combinedstoreop), Instruction(:ifelse), [condop, storeop, first(parents(prevstore))], elementbytes)
  #         storeparents = [storeop]
  #         storeinstr = if prevstore.instruction.instr === :conditionalstore!
  #             push!(storeparents, add_compute!(ls, gensym(:combinedmask), Instruction(:|), [condop, last(parents(prevstore))], elementbytes))
  #             :conditionalstore!
  #         else
  #             :setindex!
  #         end
  #         op = Operation( id, name(mref), elementbytes, storeinstr, memstore, ldref, NODEPENDENCY, storeparents, mref )
  #         return cse_store!(ls, op)
  #     end
  # end
  op = Operation(
    id,
    name(mref),
    elementbytes,
    :conditionalstore!,
    memstore,
    ldref,
    reduceddependencies(storeop),
    storeparents,
    mref
  )
  add_unique_store!(ls, op)
end

using LoopVectorization, OffsetArrays, Test
using LoopVectorization: ArrayInterface
using LoopVectorization: StaticInt
# T = Float64; r = -1:1;
# T = Float32; r = -1:1;


@testset "OffsetArrays" begin

  function old2d!(out::AbstractMatrix, A::AbstractMatrix, kern)
    rng1k, rng2k = axes(kern)
    rng1, rng2 = axes(out)
    for j in rng2, i in rng1
      tmp = zero(eltype(out))
      @inbounds for jk in rng2k, ik in rng1k
        tmp += oftype(tmp, A[i+ik, j+jk]) * kern[ik, jk]
      end
      @inbounds out[i, j] = tmp
    end
    out
  end

  # out = out1;
  # R=CartesianIndices(out);
  # z=zero(eltype(out));
  # # rng1k, rng2k = axes(skern);
  # rng1,  rng2  = R.indices;
  # tmp = z; i = 2; j = 2;
  # ls1 = LoopVectorization.@turbo_debug for jk in rng2, ik in rng1
  #     tmp += A[i+ik,j+jk]*kern[ik,jk]
  # end;
  # ls1

  # out = out1;
  # C = At';
  # ls2d = LoopVectorization.@turbo_debug for j in axes(out1,2), i in axes(out1,1)
  #         tmp = zero(eltype(out1))
  #         for jk in axes(kern,2), ik in axes(kern,1)
  #             tmp += A[i+ik,j+jk]*kern[ik,jk]
  #         end
  #         out1[i,j] = tmp
  # end;
  # LoopVectorization.choose_order(ls2d)
  # ls2ds = LoopVectorization.@turbo_debug for j in axes(out1,2), i in axes(out1,1)
  #         tmp = zero(eltype(out1))
  #         for jk in axes(skern,2), ik in axes(skern,1)
  #             tmp += A[i+ik,j+jk]*skern[ik,jk]
  #         end
  #         out1[i,j] = tmp
  # end;
  # LoopVectorization.choose_order(ls2ds)


  # q2d = :(for j in rng2, i in rng1
  #         tmp = zero(eltype(out))
  #         for jk in rng2k, ik in rng1k
  #             tmp += A[i+ik,j+jk]*kern[ik,jk]
  #         end
  #         out[i,j] = tmp
  #        end);
  # lsq2d = LoopVectorization.loopset(q2d); LoopVectorization.choose_order(lsq2d)

  # oq2 = :(for j in rng2, i in rng1
  #         tmp = zero(eltype(out))
  #         for jk in -1:1, ik in -1:1
  #             tmp += A[i+ik,j+jk]*kern[ik,jk]
  #         end
  #         out[i,j] = tmp
  #        end);
  # lsoq = LoopVectorization.loopset(oq2);
  # LoopVectorization.choose_order(lsoq)

  function avx2d!(out::AbstractMatrix, A::AbstractMatrix, kern)
    rng1k, rng2k = axes(kern)
    rng1, rng2 = axes(out)
    for j in rng2, i in rng1
      tmp = zero(eltype(out))
      @turbo for jk in rng2k, ik in rng1k
        tmp += A[i+ik, j+jk] * kern[ik, jk]
      end
      out[i, j] = tmp
    end
    out
  end
  function avx2douter!(out::AbstractMatrix, A::AbstractMatrix, kern)
    rng1k, rng2k = axes(kern)
    rng1, rng2 = axes(out)
    offset1 = offset2 = 0
    @turbo for j in rng2, i in rng1
      tmp = zero(eltype(out))
      for jk in rng2k, ik in rng1k
        tmp += A[i+ik, j+jk] * kern[ik, jk]
      end
      out[i+offset1, j+offset2] = tmp
    end
    out
  end


  struct SizedOffsetMatrix{T,LR,UR,LC,UC} <: DenseMatrix{T}
    data::Matrix{T}
  end
  Base.size(::SizedOffsetMatrix{<:Any,LR,UR,LC,UC}) where {LR,UR,LC,UC} =
    (UR - LR + 1, UC - LC + 1)
  Base.axes(::SizedOffsetMatrix{T,LR,UR,LC,UC}) where {T,LR,UR,LC,UC} =
    (StaticInt{LR}():StaticInt{UR}(), StaticInt{LC}():StaticInt{UC}())
  Base.parent(A::SizedOffsetMatrix) = A.data
  Base.unsafe_convert(::Type{Ptr{T}}, A::SizedOffsetMatrix{T}) where {T} = pointer(A.data)
  ArrayInterface.contiguous_axis(::Type{<:SizedOffsetMatrix}) = ArrayInterface.One()
  ArrayInterface.contiguous_batch_size(::Type{<:SizedOffsetMatrix}) = ArrayInterface.Zero()
  ArrayInterface.stride_rank(::Type{<:SizedOffsetMatrix}) =
    (ArrayInterface.StaticInt(1), ArrayInterface.StaticInt(2))
  function LoopVectorization.static_strides(
    ::SizedOffsetMatrix{T,LR,UR,LC,UC},
  ) where {T,LR,UR,LC,UC}
    (StaticInt{1}(), (StaticInt{UR}() - StaticInt{LR}() + StaticInt{1}()))
  end
  ArrayInterface.offsets(::SizedOffsetMatrix{T,LR,UR,LC,UC}) where {T,LR,UR,LC,UC} =
    (StaticInt{LR}(), StaticInt{LC}())
  ArrayInterface.dense_dims(::Type{<:SizedOffsetMatrix{T}}) where {T} =
    ArrayInterface.dense_dims(Matrix{T})
  Base.getindex(A::SizedOffsetMatrix, i, j) =
    LoopVectorization.vload(LoopVectorization.stridedpointer(A), (i, j))
  function avx2dunrolled!(
    out::AbstractMatrix,
    A::AbstractMatrix,
    kern::SizedOffsetMatrix{T,-1,1,-1,1},
  ) where {T}
    Base.Cartesian.@nexprs 3 jk ->
      Base.Cartesian.@nexprs 3 ik -> kern_ik_jk = kern[ik-2, jk-2]
    # Manually unpack the OffsetArray
    @turbo for j in axes(out, 2), i in axes(out, 1)
      tmp_0 = zero(eltype(out))
      Base.Cartesian.@nexprs 3 jk -> Base.Cartesian.@nexprs 3 ik ->
        tmp_{ik + (jk - 1) * 3} =
          A[(ik-2)+i, (jk-2)+j*1] * kern_ik_jk + tmp_{ik + (jk - 1) * 3 - 1}
      out[i, j] = tmp_9
    end
    out
  end
  function avx2dunrolled2x2!(
    out::AbstractMatrix,
    A::AbstractMatrix,
    kern::SizedOffsetMatrix{T,-1,1,-1,1},
  ) where {T}
    # rng1,  rng2  = axes(out)
    # Manually unpack the OffsetArray
    # @turbo for j in rng2, i in rng1
    @turbo unroll = (2, 2) for j in axes(out, 2), i in axes(out, 1)
      Base.Cartesian.@nexprs 3 jk ->
        Base.Cartesian.@nexprs 3 ik -> kern_ik_jk = kern[ik-2, jk+(-2)]
      tmp_0 = zero(eltype(out))
      j1 = j * 1 # If you're reading this code for examples, don't do this! The point is to test
      Base.Cartesian.@nexprs 3 jk -> Base.Cartesian.@nexprs 3 ik ->
        tmp_{ik + (jk - 1) * 3} =
          A[i+(ik-2), (jk-2)+j1] * kern_ik_jk + tmp_{ik + (jk - 1) * 3 - 1}
      out[i, j] = tmp_9
    end
    out
  end
  function avx2dunrolled3x3!(
    out::AbstractMatrix,
    A::AbstractMatrix,
    kern::SizedOffsetMatrix{T,-1,1,-1,1},
  ) where {T}
    rng1, rng2 = axes(out)
    Base.Cartesian.@nexprs 3 jk ->
      Base.Cartesian.@nexprs 3 ik -> kern_ik_jk = kern[ik-2, jk-2]
    # Manually unpack the OffsetArray
    @turbo unroll = (3, 3) for j in rng2, i in rng1
      tmp_0 = zero(eltype(out))
      Base.Cartesian.@nexprs 3 jk -> Base.Cartesian.@nexprs 3 ik ->
        tmp_{ik + (jk - 1) * 3} =
          A[(ik-2)+i, j*1+(jk-2)] * kern_ik_jk + tmp_{ik + (jk - 1) * 3 - 1}
      out[i, j] = tmp_9
    end
    out
  end
  # uq = :(for j in rng2, i in rng1
  #         tmp_0 = zero(eltype(out))
  #         Base.Cartesian.@nexprs 3 jk -> Base.Cartesian.@nexprs 3 ik -> tmp_{ik+(jk-1)*3} = A[i+(ik-2),j+(jk-2)] * kern_ik_jk + tmp_{ik+(jk-1)*3-1}
  #         out[i,j] = tmp_9
  #        end);
  # lsuq = LoopVectorization.loopset(macroexpand(Base, uq));
  # LoopVectorization.choose_order(lsuq)
  # lsuq

  # using LoopVectorization, OffsetArrays
  # T = Float64
  # A = rand(T, 100, 100);
  # kern = OffsetArray(rand(T, 3, 3), -1:1, -1:1);
  # out = OffsetArray(similar(A, size(A).-2), 1, 1);   # stay away from the edges of A
  # lsgeneric = LoopVectorization.@turbo_debug for I in CartesianIndices(out)
  #        tmp = zero(eltype(out))
  #        for J in CartesianIndices(kern)
  #            tmp += A[I+J]*kern[J]
  #        end
  #        out[I] = tmp
  #    end;
  # LoopVectorization.choose_order(lsgeneric)
  # # out = out1;
  #     lsgenerics = LoopVectorization.@turbo_debug for I in CartesianIndices(out)
  #            tmp = zero(eltype(out))
  #            for J in CartesianIndices(skern)
  #                tmp += A[I+J]*kern[J]
  #            end
  #            out[I] = tmp
  #        end;
  #     LoopVectorization.choose_order(lsgenerics)
  # @macroexpand @turbo for I in R
  #            tmp = z
  #            for J in Rk
  #                tmp += A[I+J]*kern[J]
  #            end
  #            out[I] = tmp
  #        end

  function avxgeneric!(out, A, kern, R = CartesianIndices(out), z = zero(eltype(out)))
    Rk = CartesianIndices(kern)
    @turbo for I in R
      tmp = z
      for J in Rk
        tmp += A[I+J] * kern[J]
      end
      out[I] = tmp
    end
    out
  end
  function avxgeneric2!(out, A, kern, keep = nothing)
    @turbo for I in CartesianIndices(out)
      tmp = if keep === nothing
        zero(eltype(out))
      else
        out[I]
      end
      for J in CartesianIndices(kern)
        tmp += A[I+J] * kern[J]
      end
      out[I] = tmp
    end
    out
  end
  function pparent(x) # go through nested parents
    px = parent(x)
    px === x ? x : pparent(px)
  end


  for T ∈ (Float32, Float64)
    @show T, @__LINE__
    Abase = fill(T(NaN), 200, 200)
    # out of bounds reads load NaNs, poisoning results leading to test failure.
    A = view(Abase, 51:152, 51:152)
    A .= rand.()
    Atbase = copy(Abase')
    At = view(Atbase, 51:152, 51:152)
    for r ∈ (-1:1, -2:2)
      @show r
      fr = first(r)
      lr = last(r)
      kern = OffsetArray(rand(T, length(r), length(r)), r, r)
      # We test parent equality so that an accidental write out of bounds leading to test failure.
      out1 = OffsetArray(
        view(
          fill(T(-123456.789), size(A) .+ 100),
          (1+lr:100-lr) .+ 32,
          (1+lr:100-lr) .+ 32,
        ),
        lr,
        lr,
      )   # stay away from the edges of A
      # out1 = OffsetArray(similar(A, size(A).-2), 1, 1);   # stay away from the edges of A
      out2 = deepcopy(out1)
      out3 = deepcopy(out1)
      out4 = deepcopy(out1)
      skern = SizedOffsetMatrix{T,fr,lr,fr,lr}(parent(kern))

      old2d!(out1, A, kern)
      avx2d!(out2, A, kern)
      @test pparent(out1) ≈ pparent(out2)

      avx2douter!(out3, A, kern)
      @test pparent(out1) ≈ pparent(out3)

      fill!(out2, NaN)
      avx2d!(out2, A, skern)
      @test pparent(out1) ≈ pparent(out2)

      fill!(out2, NaN)
      avx2douter!(out2, At', kern)
      @test pparent(out1) ≈ pparent(out2)

      fill!(out2, NaN)
      avx2douter!(out2', A, kern)
      @test pparent(out1) ≈ pparent(out2)'

      fill!(out2, NaN)
      avx2douter!(out2', At', kern)
      @test pparent(out1) ≈ pparent(out2)'

      fill!(out3, NaN)
      avx2douter!(out3, A, skern)
      @test pparent(out1) ≈ pparent(out3)

      if r == -1:1
        fill!(out3, NaN)
        avx2dunrolled!(out3, A, skern)
        @test pparent(out1) ≈ pparent(out3)

        fill!(out3, NaN)
        avx2dunrolled2x2!(out3, A, skern)
        @test pparent(out1) ≈ pparent(out3)

        fill!(out3, NaN)
        avx2dunrolled3x3!(out3, A, skern)
        @test pparent(out1) ≈ pparent(out3)
      end

      @test pparent(avxgeneric!(out4, A, kern)) ≈ pparent(out1)
      fill!(out4, NaN)
      @test pparent(avxgeneric!(out4, A, skern)) ≈ pparent(out1)

      fill!(out4, NaN)
      @test pparent(avxgeneric2!(out4, A, kern)) ≈ pparent(out1)
      fill!(out4, NaN)
      @test pparent(avxgeneric2!(out4, A, skern)) ≈ pparent(out1)
      fill!(out4, NaN)
      @test pparent(avxgeneric2!(out4, At', kern)) ≈ pparent(out1)
      fill!(out4, NaN)
      @test pparent(avxgeneric2!(out4, At', skern)) ≈ pparent(out1)
      fill!(out4, NaN)
      @test pparent(avxgeneric2!(out4', A, kern)')' ≈ pparent(out1)
      fill!(out4, NaN)
      @test pparent(avxgeneric2!(out4', A, skern)')' ≈ pparent(out1)
      fill!(out4, NaN)
      @test pparent(avxgeneric2!(out4', At', kern)')' ≈ pparent(out1)
      fill!(out4, NaN)
      @test pparent(avxgeneric2!(out4', At', skern)')' ≈ pparent(out1)
    end
  end

  function issue_295!(R, A, B)
    @turbo for j = 1:4
      for i = 0:1
        R[i, j] = A[2i+2j] + 0 * B[j]
      end
    end
    R
  end

  A = [i^2 for i = 1:10]
  B = [1, 2, 3, 4]
  R = OffsetArray(zeros(Int, 2, 4), 0:1, 1:4)

  @test issue_295!(R, A, B) == OffsetArray([4 16 36 64; 16 36 64 100], -1, 0)
end

@testset "can_avx" begin

  using LoopVectorization

  good_operators = [
    log,
    log1p,
    exp,
    +,
    -,
    Base.FastMath.add_fast,
    /,
    sqrt,
    tanh_fast,
    sigmoid_fast,
    LoopVectorization.relu,
  ]
  bad_operators = [clenshaw, println]

  for op in good_operators
    @test LoopVectorization.ArrayInterface.can_avx(op)
  end
  for op in bad_operators
    @test !LoopVectorization.ArrayInterface.can_avx(op)
  end

end

# struct ParentsBeforeChildrenIterator
#     ops::Vector{Operation}
#     visited::Vector{Bool}
# end
# function iterate(pbci::ParentsBeforeChildrenIterator)
#     for (i,op) ∈ enumerate(pbci.ops)
#         if iszero(length(parents(op)))
#             pbci.visited[i] = true
#             return op, pbci
#         end
#     end
#     nothing
# end
# function iterate()

# end

# function dependent_outer_reducts(ls::LoopSet, op)
#     for i ∈ ls.outer_reductions
#         search_tree(parents(operations(ls)[i]), name(op)) && return true
#     end
#     false
# end

function isnopidentity(
  ls::LoopSet,
  op::Operation,
  u₁loop::Symbol,
  u₂loop::Symbol,
  vectorized::Symbol,
  u₂max::Int
)
  parents_op = parents(op)
  if iscompute(op) && instruction(op).instr === :identity
    # loopistiled = u₂max ≠ -1
    # parents_u₁syms, parents_u₂syms = parent_unroll_status(op, u₁loop, u₂loop, u₂max)
    # if (u₁unrolledsym == first(parents_u₁syms)) && (isu₂unrolled(op) == parents_u₂syms[1])
    oppstate = Base.iterate(parents_op)
    oppstate === nothing && return false
    opp, state = oppstate
    Base.iterate(parents_op, state) === nothing || return false
    name(opp) === name(op) || return false
    # @show op opp isu₁unrolled(op), isu₁unrolled(opp), isu₂unrolled(op), isu₂unrolled(opp)
    (isu₁unrolled(op) == isu₁unrolled(opp)) &
    (isu₂unrolled(op) == isu₂unrolled(opp))
  else
    false
  end
end

function set_upstream_family!(
  adal::Vector{T},
  op::Operation,
  val::T,
  ld::Vector{Symbol},
  id::Int
) where {T}
  adal[identifier(op)] == val && return # must already have been set
  if ld != loopdependencies(op) || id == identifier(op)
    (adal[identifier(op)] = val)
  end
  for opp ∈ parents(op)
    identifier(opp) == identifier(op) && continue
    set_upstream_family!(adal, opp, val, ld, id)
  end
end
function search_for_reductinit!(
  op::Operation,
  opswap::Operation,
  var::Symbol,
  loopdeps::Vector{Symbol}
)
  for (i, opp) ∈ enumerate(parents(op))
    if (name(opp) === var) &&
       (length(reduceddependencies(opp)) == 0) &&
       (length(loopdependencies(opp)) == length(loopdeps)) &&
       (length(children(opp)) == 1)
      if all(in(loopdeps), loopdependencies(opp))
        parents(op)[i] = opswap
        return opp
      end
    end
    opcheck = search_for_reductinit!(opp, opswap, var, loopdeps)
    opcheck === opp || return opcheck
  end
  return op
end
function addoptoorder!(
  ls::LoopSet,
  included_vars::Vector{Bool},
  place_after_loop::Vector{Bool},
  op::Operation,
  loopsym::Symbol,
  _n::Int,
  u₁loop::Symbol,
  u₂loop::Symbol,
  vectorized::Symbol,
  u₂max::Int
)
  lo = ls.loop_order
  id = identifier(op)
  included_vars[id] || return nothing
  loopsym ∈ loopdependencies(op) || return nothing
  for opp ∈ parents(op) # ensure parents are added first
    addoptoorder!(
      ls,
      included_vars,
      place_after_loop,
      opp,
      loopsym,
      _n,
      u₁loop,
      u₂loop,
      vectorized,
      u₂max
    )
  end
  included_vars[id] || return nothing
  included_vars[id] = false
  isunrolled = (isu₁unrolled(op)) + 1
  istiled = isu₂unrolled(op) + 1
  # optype = Int(op.node_type) + 1
  after_loop = place_after_loop[id] + 1
  if !isloopvalue(op)
    isnopidentity(ls, op, u₁loop, u₂loop, vectorized, u₂max) ||
      push!(lo[isunrolled, istiled, after_loop, _n], op)
    # if istiled
    #     isnopidentity(ls, op, u₁loop, u₂loop, vectorized, u₂max, u₂max) || push!(lo[isunrolled,2,after_loop,_n], op)
    # else
    #     isnopidentity(ls, op, u₁loop, u₂loop, vectorized, u₂max, nothing) || push!(lo[isunrolled,1,after_loop,_n], op)
    # end
  end
  # @show op, after_loop
  # isloopvalue(op) || push!(lo[isunrolled,istiled,after_loop,_n], op)
  # all(opp -> iszero(length(reduceddependencies(opp))), parents(op)) &&
  set_upstream_family!(
    place_after_loop,
    op,
    false,
    loopdependencies(op),
    identifier(op)
  ) # parents that have already been included are not moved, so no need to check included_vars to filter
  nothing
end
function replace_reduct_init!(
  ls::LoopSet,
  op::Operation,
  opsub::Operation,
  opcheck::Operation
)
  deleteat!(parents(op), 2)
  op.variable = opcheck.variable
  opsub.variable = opcheck.variable
  op.mangledvariable = opcheck.mangledvariable
  opsub.mangledvariable = opcheck.mangledvariable
  op.instruction = instruction(:identity)
  fill_children!(ls)
end
function nounrollreduction(
  op::Operation,
  u₁loop::Symbol,
  u₂loop::Symbol,
  vectorized::Symbol
)
  reduceddeps = reduceddependencies(op)
  (vectorized ∉ reduceddeps) && (u₁loop ∉ reduceddeps) && (u₂loop ∉ reduceddeps)
end
function load_short_static_reduction_first!(
  ls::LoopSet,
  u₁loop::Symbol,
  u₂loop::Symbol,
  vectorized::Symbol
)
  for op ∈ operations(ls)
    iscompute(op) || continue
    length(reduceddependencies(op)) == 0 && continue
    parents_op = parents(op)
    length(parents_op) == 2 || continue
    found = false
    parent₁deps = loopdependencies(parents_op[1])
    parent₂deps = loopdependencies(parents_op[2])
    for reduced_dep ∈ reduceddependencies(op)
      if (reduced_dep ∈ parent₁deps) || (reduced_dep ∈ parent₂deps)
        found = true
        break
      end
    end
    found || continue
    if (instruction(op).instr === :reduced_add)
      vecloop = getloop(ls, vectorized)
      if isstaticloop(vecloop) &&
         (length(vecloop) ≤ 16) &&
         nounrollreduction(op, u₁loop, u₂loop, vectorized)
        opsub = parents(op)[2]
        length(children(opsub)) == 1 || continue
        opsearch = parents(op)[1]
        opcheck = search_for_reductinit!(
          opsearch,
          opsub,
          name(opsearch),
          loopdependencies(op)
        )
        opcheck === opsearch || replace_reduct_init!(ls, op, opsub, opcheck)
      end
    elseif (instruction(op).instr === :add_fast) &&
           (instruction(first(parents(op))).instr === :identity)
      vecloop = getloop(ls, vectorized)
      if isstaticloop(vecloop) &&
         (length(vecloop) ≤ 16) &&
         nounrollreduction(op, u₁loop, u₂loop, vectorized)
        opsub = parents(op)[2]
        (
          (length(reduceddependencies(opsub)) == 0) &
          (length(children(opsub)) == 1)
        ) || continue
        opsearch = parents(op)[1]
        opcheck = search_for_reductinit!(
          opsearch,
          opsub,
          name(opsearch),
          loopdependencies(op)
        )
        opcheck === opsearch || replace_reduct_init!(ls, op, opsub, opcheck)
      end
    end
  end
end

function fillorder!(
  ls::LoopSet,
  order::Vector{Symbol},
  u₁loop::Symbol,
  u₂loop::Symbol,
  u₂max::Int,
  vectorized::Symbol
)
  load_short_static_reduction_first!(ls, u₁loop, u₂loop, vectorized)
  lo = ls.loop_order
  resize!(lo, length(ls.loopsymbols))
  ro = lo.loopnames # reverse order; will have same order as lo
  nloops = length(order)
  ops = operations(ls)
  nops = length(ops)
  included_vars = getroots!(resize!(ls.included_vars, nops), ls)
  #for i ∈ eachindex(included_vars)
  #    included_vars[i] = !included_vars[i]
  #end
  #included_vars = fill!(resize!(ls.included_vars, nops), false)
  place_after_loop = fill!(resize!(ls.place_after_loop, nops), true)
  # to go inside out, we just have to include all those not-yet included depending on the current sym
  empty!(lo)
  for _n ∈ 1:nloops
    n = 1 + nloops - _n
    ro[_n] = loopsym = order[n]
    #loopsym = order[n]
    for op ∈ ops
      addoptoorder!(
        ls,
        included_vars,
        place_after_loop,
        op,
        loopsym,
        _n,
        u₁loop,
        u₂loop,
        vectorized,
        u₂max
      )
    end
  end
end

function uniquearrayrefs_csesummary(ls::LoopSet)
  uniquerefs = ArrayReferenceMeta[]
  # each `Vector{Tuple{Int,Int}}` has the same name
  # 1 to ≥1 maps:
  name_to_array_map = Vector{Int}[] # refname -> uniquerefs
  unique_to_name_and_op_map = Vector{Tuple{Int,Int,Int}}[] # uniquerefs -> (ind in name_to_array, ind in that vector, ind in operations)
  for (i, op) ∈ enumerate(operations(ls))
    arrayref = op.ref
    arrayref === NOTAREFERENCE && continue
    unique = true
    for (j, namev) ∈ enumerate(name_to_array_map)
      vptr(uniquerefs[first(namev)]) === vptr(arrayref) || continue # no unique
      for (k, unique_id) ∈ enumerate(namev)
        if sameref(uniquerefs[unique_id], arrayref)
          # matching name, matching ref
          push!(unique_to_name_and_op_map[unique_id], (j, k, i))
          unique = false
          break
        end
      end
      if unique # matching name, no matching ref
        push!(uniquerefs, arrayref)
        push!(namev, length(uniquerefs))
        push!(
          unique_to_name_and_op_map,
          Tuple{Int,Int,Int}[(j, length(namev), i)]
        )
        unique = false
      end
      break
    end
    if unique # no matching name, no matching ref
      push!(uniquerefs, arrayref)
      push!(name_to_array_map, Int[length(uniquerefs)])
      push!(
        unique_to_name_and_op_map,
        Tuple{Int,Int,Int}[(length(name_to_array_map), 1, i)]
      )
    end
  end
  uniquerefs, name_to_array_map, unique_to_name_and_op_map
end

function uniquearrayrefs(ls::LoopSet)
  uniquerefs = ArrayReferenceMeta[]
  includeinlet = Bool[]
  # for arrayref ∈ ls.refs_aliasing_syms
  for op ∈ operations(ls)
    op.instruction === DROPPEDCONSTANT && continue
    arrayref = op.ref
    arrayref === NOTAREFERENCE && continue
    notunique = false
    isonlyname = true
    for ref ∈ uniquerefs
      notunique = sameref(arrayref, ref)
      isonlyname &= vptr(arrayref) !== vptr(ref)
      # if they're not the sameref, they may still have the same name
      # if they have different names, they're definitely not sameref
      notunique && break
    end
    if !notunique
      push!(uniquerefs, arrayref)
      push!(includeinlet, isonlyname)
    end
  end
  uniquerefs, includeinlet
end

otherindexunrolled(loopsym::Symbol, ind::Symbol, loopdeps::Vector{Symbol}) =
  ((loopsym ≢ ind) & (loopsym ≢ Symbol("##undefined##"))) &&
  (loopsym ∈ loopdeps)
function otherindexunrolled(ls::LoopSet, ind::Symbol, ref::ArrayReferenceMeta)
  us = ls.unrollspecification
  @unpack u₁loopnum, u₂loopnum, u₁, u₂ = us
  u₁sym = u₁ > 1 ? names(ls)[u₁loopnum] : Symbol("##undefined##")
  u₂sym =
    ((u₂ > 1) & (u₂loopnum > 0)) ? names(ls)[u₂loopnum] :
    Symbol("##undefined##")
  # u₁sym = names(ls)[u₁loopnum]
  # u₂sym = ((u₂loopnum > 0)) ? names(ls)[u₂loopnum] : Symbol("##undefined##")
  otherindexunrolled(u₁sym, ind, loopdependencies(ref)) ||
    otherindexunrolled(u₂sym, ind, loopdependencies(ref))
end
function multiple_with_name(n::Symbol, v::Vector{ArrayReferenceMeta})
  found = false
  for ref ∈ v
    tst = vptr(ref) === n
    (found & tst) && return true
    found |= tst
  end
  false
end
# multiple_with_name(n::Symbol, v::Vector{ArrayReferenceMeta}) = sum(ref -> n === vptr(ref), v) > 1
# TODO: DRY between indices_calculated_by_pointer_offsets and use_loop_induct_var
function indices_calculated_by_pointer_offsets(
  ls::LoopSet,
  ar::ArrayReferenceMeta
)
  indices = getindices(ar)
  ls.isbroadcast && return fill(false, length(indices))
  looporder = names(ls)
  offset = isdiscontiguous(ar)
  out = Vector{Bool}(undef, length(indices))
  strds = getstrides(ar)
  li = ar.loopedindex
  for i ∈ eachindex(li)
    ii = i + offset
    ind = indices[ii]
    if (!li[i]) ||
       (ind === CONSTANTZEROINDEX) ||
       multiple_with_name(vptr(ar), ls.lssm.uniquearrayrefs) ||
       (iszero(ls.vector_width) && isstaticloop(getloop(ls, ind))) ||
       (strds[i] ≤ 0)
      out[i] = false
    elseif (isone(ii) && (first(looporder) === ind))
      out[i] = otherindexunrolled(ls, ind, ar)
    else
      out[i] = true
    end
  end
  # @show ar out
  out
end

# @generated function set_first_stride(sptr::StridedPointer{T,N,C,B,R}) where {T,N,C,B,R}
#     minrank = argmin(R)
#     newC = C > 0 ? (C == minrank ? 1 : 0) : C
#     newB = C > 0 ? (C == minrank ? B : 0) : B #TODO: confirm correctness
#     quote
#         $(Expr(:meta,:inline))
#         # VectorizationBase.StridedPointer{$T,1,$newC,$newB,$(R[minrank],)}($(lv(llvmptr))(sptr), (sptr.strd[$minrank],), (Zero(),))
#         VectorizationBase.StridedPointer{$T,1,$newC,$newB,$(R[minrank],)}(VectorizationBase.cpupointer(sptr), (sptr.strd[$minrank],), (Zero(),))
#     end
# end
# set_first_stride(x) = x # cross fingers that this works
# @inline onetozeroindexgephack(sptr::AbstractStridedPointer) = gesp(set_first_stride(sptr), (StaticInt{-1}(),)) # go backwords
# @inline onetozeroindexgephack(sptr::AbstractStridedPointer{T,1}) where {T} = sptr
# @inline onetozeroindexgephack(sptr::StridedPointer{T,1}) where {T} = sptr
# @inline onetozeroindexgephack(x) = x

# # Removes parent/child relationship for all children with ref `ar`
# function freechildren!(op::Operation, ar::ArrayReferenceMeta)
#   newchildren = Operation[]
#   for opc ∈ children(op)
#     if opc.ref === ar
#       for (i,opp) ∈ enumerate(parents(opc))
#         if opp === op
#           deleteat!(parents(opc), i)
#           break
#         end
#       end
#     else
#       push!(newchildren, opc)
#     end
#   end
#   op.children = newchildren
#   nothing
# end
# function replaceparent!(ops::Vector{Operation}, )

# end
function set_ref_loopedindex_and_ind!(
  ref::ArrayReferenceMeta,
  i::Int,
  ii::Int,
  li::Bool,
  ind::Symbol
)
  ref.loopedindex[i] = li
  getindices(ref)[ii] = ind
end
function set_all_to_constant_index!(
  ls::LoopSet,
  i::Int,
  ii::Int,
  indop::Operation,
  allarrayrefs::Vector{ArrayReferenceMeta},
  array_refs_with_same_name::Vector{Int},
  arrayref_to_name_op_collection::Vector{Vector{Tuple{Int,Int,Int}}}
)
  ops = operations(ls)
  for j ∈ array_refs_with_same_name
    arrayref_to_name_op = arrayref_to_name_op_collection[j]
    set_ref_loopedindex_and_ind!(
      allarrayrefs[j],
      i,
      ii,
      true,
      CONSTANTZEROINDEX
    )
    for (_, __, opid) ∈ arrayref_to_name_op
      op = ops[opid]
      set_ref_loopedindex_and_ind!(op.ref, i, ii, true, CONSTANTZEROINDEX)
      delete_ind = 0
      for (k, opp) ∈ enumerate(parents(op))
        if opp === indop
          delete_ind = k
        end
      end
      # @assert delete_ind ≠ 0
      deleteat!(parents(op), delete_ind)
    end
  end
end
maybeloopvaluename(op::Operation) =
  isloopvalue(op) ? instruction(op).instr : name(op)
function substitute_ops_all!(
  ls::LoopSet,
  i::Int,
  ii::Int,
  indop::Operation,
  new_parent::Operation,
  allarrayrefs::Vector{ArrayReferenceMeta},
  array_refs_with_same_name::Vector{Int},
  arrayref_to_name_op_collection::Vector{Vector{Tuple{Int,Int,Int}}}
)
  newindsym = maybeloopvaluename(new_parent)
  isloopval = isloopvalue(new_parent)
  ops = operations(ls)
  for j ∈ array_refs_with_same_name
    arrayref_to_name_op = arrayref_to_name_op_collection[j]
    set_ref_loopedindex_and_ind!(allarrayrefs[j], i, ii, isloopval, newindsym)
    for (_, __, opid) ∈ arrayref_to_name_op
      op = ops[opid]
      set_ref_loopedindex_and_ind!(op.ref, i, ii, isloopval, newindsym)
      sub_ind = 0
      for (k, opp) ∈ enumerate(parents(op))
        if opp === indop
          sub_ind = k
        end
      end
      # @assert sub_ind ≠ 0
      if isloopval
        deleteat!(parents(op), sub_ind)
      else
        parents(op)[sub_ind] = new_parent
      end
    end
  end
end
# function normalize_offsets!(
#   ls::LoopSet, i::Int, allarrayrefs::Vector{ArrayReferenceMeta},
#   array_refs_with_same_name::Vector{Int}, arrayref_to_name_op_collection::Vector{Vector{Tuple{Int,Int,Int}}}
# )
#   ops = operations(ls)
#   length(ops) > 256 && return 0
#   minoffset::Int8 = typemax(Int8)
#   maxoffset::Int8 = typemin(Int8)
#   # we want to store the offsets, because we don't want to require that the `offset` vectors of the variaous `ArrayReferenceMeta`s don't alias
#   # loopsym = Symbol("##DUMMY##NOT#REALLY#A#LOOP##")
#   # stride::Int = typemin(Int)
#   # thereiszerooffset::Bool = false
#   # offsets::Base.RefValue{NTuple{128,Int8}} = Base.RefValue{NTuple{128,Int8}}();
#   # GC.@preserve offsets begin
#   #   poffsets = Base.unsafe_convert(Ptr{Int8}, offsets)
#   for j ∈ array_refs_with_same_name
#     arrayref_to_name_op = arrayref_to_name_op_collection[j]
#     for (_,__,opid) ∈ arrayref_to_name_op
#       op = ops[opid]
#       opref = op.ref
#       off = getoffsets(opref)[i]
#       # thereiszerooffset |= off == zero(Int8)
#       # off == zero(Int8) && return 0
#       minoffset = min(off, minoffset)
#       maxoffset = max(off, maxoffset)
#       # unsafe_store!(poffsets, off, opid)
#       # if loopsym ≢ Symbol("##DUMMY##NOT#REALLY#A#LOOP##")
#       #   stride = Int(getstrides(opref)[i])
#       #   if opref.loopedindex[i]
#       #     loopsym = getindicesonly(op)[i]
#       #   else
#       #     loopsym = Symbol("##NOT#A#LOOP##")
#       #   end
#       # end
#     end
#   end
#   # reaching here means none of the offsets contain `0`
#   # we won't bother if difference between offsets is >127
#   # we don't want `maxoffset` to overflow when subtracting `minoffset`
#   # so we check if it's safe, and give up if it isn't
#   minoffsetint = Int(minoffset)
#   return (((Int(maxoffset) - minoffsetint) > 127)) ? 0 : minoffsetint

#   #   # if loopsym ≢ Symbol("##DUMMY##NOT#REALLY#A#LOOP##")
#   #   #   loop = getloop(ls, loopsym)
#   #   #   if minstride ≠ maxstride
#   #   #     @assert isknown(first(loop)) "Currently, if the same index is used for the same array with different multiples (e.g., `x[i]` and `x[2*i]`), then the start of that loop range must be known at compile time."
#   #   #   end
#   #   #   stride_offset = 1 - gethint(first(loop))
#   #   # else
#   #   #   loop = first(ls.loops)
#   #   # end
#   #   offset_adjust = Int(minoffset)
#   #   if (loopsym ≢ Symbol("##DUMMY##NOT#REALLY#A#LOOP##")) && (loopsym ≢ Symbol("##NOT#A#LOOP##"))
#   #     loopstart = first(getloop(ls, loopsym))
#   #     if isknown(loopstart)
#   #       loopstartval = gethint(loopstart)
#   #       offset_adjust = loopstartval*(stride - 1)
#   #       if offset_adjust + Int(maxoffset) ≤ typemax(Int8)
#   #         minoffset -= Int8(offset_adjust)
#   #         stride = 1
#   #       end
#   #     end
#   #   end
#   #   for j ∈ array_refs_with_same_name
#   #     arrayref_to_name_op = arrayref_to_name_op_collection[j]
#   #     for (_,__,opid) ∈ arrayref_to_name_op
#   #       new_offset = unsafe_load(poffsets, opid) - minoffset
#   #       old_offset = getoffsets(ops[opid].ref)[i]
#   #       @show new_offset, old_offset
#   #       getoffsets(ops[opid].ref)[i] = new_offset
#   #       # getoffsets(ops[opid].ref)[i] = unsafe_load(poffsets, opid) - minoffset
#   #     end
#   #   end
#   # end
#   # return @show offset_adjust, stride
# end
function isloopvalue(
  ls::LoopSet,
  ind::Symbol,
  isrooted::Union{Nothing,Vector{Bool}} = nothing
)
  for (i, op) ∈ enumerate(operations(ls))
    if (isrooted ≢ nothing)
      isrooted[i] || continue
    end
    (iscompute(op) | isstore(op)) || continue
    for opp ∈ parents(op)# this is to confirm `ind` still has children
      # (isloopvalue(opp) && instruction(opp).instr === ind) && return true
      if (isloopvalue(opp) && instruction(opp).instr === ind)
        return true
      end
    end
  end
  return false
end
function cse_constant_offsets!(
  ls::LoopSet,
  allarrayrefs::Vector{ArrayReferenceMeta},
  allarrayrefsind::Int,
  name_to_array_map::Vector{Vector{Int}},
  arrayref_to_name_op_collection::Vector{Vector{Tuple{Int,Int,Int}}}
)
  ar = allarrayrefs[allarrayrefsind]
  # vptrar = vptr(ar)
  arrayref_to_name_op = arrayref_to_name_op_collection[allarrayrefsind]
  array_refs_with_same_name =
    name_to_array_map[first(first(arrayref_to_name_op))]
  li = ar.loopedindex
  indices = getindices(ar)
  offset = first(indices) === DISCONTIGUOUS
  # gespindoffsets = fill(Symbol(""), length(li))
  gespindsummary = Vector{Symbol}(undef, length(li))
  for i ∈ eachindex(li)
    gespsymbol::Symbol = Symbol("")
    ii = i + offset
    ind::Symbol = indices[ii]
    licmoffset = !li[i]
    if licmoffset
      # we try to licm and offset so we can set `li[i] = true`
      position_in_array_refs_with_same_name = first(arrayref_to_name_op)[2]
      # if position_in_array_refs_with_same_name ≠ 1, then we already performed the op substitutions
      if length(array_refs_with_same_name) > 1 # if it == 1, then there's only 1
        for j ∈ array_refs_with_same_name
          j == position_in_array_refs_with_same_name && continue
          ref = allarrayrefs[j]
          refinds = getindices(ref)
          # refinds === indices && continue # fast check, should be covered by `j == position_in_array_refs_with_same_name`
          if !(
            (refinds[ii] === ind) & (getstrides(ar)[i] == getstrides(ref)[i])
          )
            # For now, we'll only bother with `licm` if all share the same indices
            # This is so that we can apply the same `licm` to each and keep the same array name.
            # Otherwise, we'll rely on LLVM to optimize indexing.
            licmoffset = false
            break
          end
        end
      end
      ops = operations(ls)
      # @show ar
      while licmoffset # repeat until we run out
        # ind = indices[ii]
        # indices are all the same across operations, so we look to the first for checking compatibility...
        memop = indop = ops[first(arrayref_to_name_op)[3]] # indop is a dummy placeholder
        for opp ∈ parents(memop)
          if name(opp) === ind
            indop = opp
          end
        end
        # (we found a match) # iscompute(indop) should be guaranteed...
        ((indop ≢ memop) && iscompute(indop)) || break
        instr = instruction(indop).instr
        parents_indop = parents(indop)
        if instr === :(+)
          constants_to_licm = if gespsymbol === Symbol("")
            Expr(:call, GlobalRef(Base, :(+)))
          else
            Expr(:call, GlobalRef(Base, :(+)), gespsymbol)
          end
          new_parent = indop # dummy, for now we will only licm if it lets us remove `indop`
          for opp ∈ parents_indop
            if isconstantop(opp)
              # NOTE: using `name` because this happens at macroexpansion time
              # push!(constants_to_licm.args, constantopname(opp))
              push!(constants_to_licm.args, name(opp))
            elseif new_parent === indop # first
              new_parent = opp
            else # this is the second parent, we give up on `licm`
              licmoffset = false
              break
            end
          end
          licmoffset || continue
          if length(constants_to_licm.args) > 2
            gespsymbol = gensym!(ls, "#gespsym#")
            pushpreamble!(ls, Expr(:(=), gespsymbol, constants_to_licm))
          elseif length(constants_to_licm.args) == 2
            licmoffset = gespsymbol === Symbol("")
            if licmoffset
              gespsymbol = (constants_to_licm.args[2])::Symbol
            end
          else
            licmoffset = false
          end
          if licmoffset # prune
            if new_parent === indop # no parents left
              ind = CONSTANTZEROINDEX
              set_all_to_constant_index!(
                ls,
                i,
                ii,
                indop,
                allarrayrefs,
                array_refs_with_same_name,
                arrayref_to_name_op_collection
              )
            else # new_parent is a new parent to replace `indop`
              ind = maybeloopvaluename(new_parent)
              substitute_ops_all!(
                ls,
                i,
                ii,
                indop,
                new_parent,
                allarrayrefs,
                array_refs_with_same_name,
                arrayref_to_name_op_collection
              )
            end
          end
        elseif (instr === :(-)) && length(parents_indop) == 2
          op1 = parents(indop)[1]
          op2 = parents(indop)[2]
          op1const = isconstantop(op1)
          op2const = isconstantop(op2)
          if op1const # op1 - op2
            if op2const
              subexpr = if gespsymbol === Symbol("")
                Expr(:call, GlobalRef(Base, :(-)), name(op1), name(op2))
              else
                Expr(
                  :call,
                  GlobalRef(Base, :(-)),
                  Expr(:call, GlobalRef(Base, :(+)), gespsymbol, name(op1)),
                  name(op2)
                )
              end
              gespsymbol = gensym!(ls, "#gespsym#")
              pushpreamble!(ls, Expr(:(=), gespsymbol, subexpr))
              ind = CONSTANTZEROINDEX
              set_all_to_constant_index!(
                ls,
                i,
                ii,
                indop,
                allarrayrefs,
                array_refs_with_same_name,
                arrayref_to_name_op_collection
              )
            else# op1const, op2dynamic
              # won't bother with this for now
              licmoffset = false
            end
          elseif op2const #op1dynamic
            subexpr = if gespsymbol === Symbol("")
              Expr(:call, GlobalRef(Base, :(-)), name(op2))
            else
              Expr(:call, GlobalRef(Base, :(-)), gespsymbol, name(op2))
            end
            gespsymbol = gensym!(ls, "#gespsym#")
            pushpreamble!(ls, Expr(:(=), gespsymbol, subexpr))
            ind = maybeloopvaluename(op1)
            substitute_ops_all!(
              ls,
              i,
              ii,
              indop,
              op1,
              allarrayrefs,
              array_refs_with_same_name,
              arrayref_to_name_op_collection
            )
          else
            licmoffset = false
          end
        else
          licmoffset = false
        end
      end
    end
    # constoffset = normalize_offsets!(ls, i, allarrayrefs, array_refs_with_same_name, arrayref_to_name_op_collection)
    # gespindsummary[i] = (gespsymbol, constoffset)
    gespindsummary[i] = gespsymbol
  end
  return gespindsummary
end
@inline similardims(_, i) = i
@inline similardims(::CartesianIndices{N}, i) where {N} =
  VectorizationBase.CartesianVIndex(ntuple(_ -> i, Val{N}()))
# @generated function similardims(::CartesianIndices{N}, i) where {N}
#   t = Expr(:tuple)
#   for n ∈ 1:N
#     push!(t.args, :i)
#   end
#   Expr(:block,Expr(:meta,:inline),t)
# end
# function maybebroadcastpush!(q::Expr, loop::Loop, b::Bool, ex)
#   if b
#     push!(q.args, Expr(:call, lv(:similardims), loop.rangesym, ex))
#   else
#     push!(q.args, ex)
#   end
#   return nothing
# end

function adjust_offsets!(
  ls::LoopSet,
  i::Int,
  array_refs_with_same_name::Vector{Int},
  arrayref_to_name_op_collection::Vector{Vector{Tuple{Int,Int,Int}}}
)
  ops = operations(ls)
  if length(ops) ≤ 256
    offsets = Ref{NTuple{256,Int8}}()
    poffsets = Base.unsafe_convert(Ptr{Int8}, offsets)
    GC.@preserve offsets adjust_offsets!(
      ls,
      i,
      poffsets,
      array_refs_with_same_name,
      arrayref_to_name_op_collection
    )
  else
    offsetsv = similar(ops, Int8)
    poffsets = pointer(offsetsv)
    GC.@preserve offsetsv adjust_offsets!(
      ls,
      i,
      poffsets,
      array_refs_with_same_name,
      arrayref_to_name_op_collection
    )
  end
end
function adjust_offsets!(
  ls::LoopSet,
  i::Int,
  poffsets::Ptr{Int8},
  array_refs_with_same_name::Vector{Int},
  arrayref_to_name_op_collection::Vector{Vector{Tuple{Int,Int,Int}}}
)
  ops = operations(ls)
  minoffset = typemax(Int8)
  maxoffset = typemin(Int8)
  # stridesunequal = false
  for j ∈ array_refs_with_same_name
    arrayref_to_name_op = arrayref_to_name_op_collection[j]
    for (_, __, opid) ∈ arrayref_to_name_op
      opref = ops[opid].ref
      off = getoffsets(opref)[i]
      minoffset = min(off, minoffset)
      maxoffset = max(off, maxoffset)
      unsafe_store!(poffsets, off, opid)
      # stridesunequal |= (stride ≠ getstrides(opref)[i])
    end
  end
  constoffset = Int(minoffset)
  constoffset = Core.ifelse(Int(maxoffset) - constoffset > 127, 0, constoffset)
  if constoffset ≠ 0
    for j ∈ array_refs_with_same_name
      arrayref_to_name_op = arrayref_to_name_op_collection[j]
      for (_, __, opid) ∈ arrayref_to_name_op
        opref = ops[opid].ref
        newoffset = unsafe_load(poffsets, opid) - constoffset
        # if stridesunequal
        #   stride = getstrides(opref)[i]
        #   newoffsetint = Int(newoffset) + (Int(stride) - 1)
        #   # @assert typemin(Int8) ≤ newoffsetint ≤ typemax(Int8)
        #   newoffset = Int8(newoffsetint)
        # end
        getoffsets(ops[opid].ref)[i] = newoffset
      end
    end
  end
  return constoffset#, Core.ifelse(stridesunequal, 1, Int(stride))
end

function calcgespinds(
  ls::LoopSet,
  ar::ArrayReferenceMeta,
  gespindsummary::Vector{Symbol},
  shouldindbyind::Vector{Bool},
  array_refs_with_same_name::Vector{Int},
  arrayref_to_name_op_collection::Vector{Vector{Tuple{Int,Int,Int}}}
)
  gespinds = Expr(:tuple)
  li = ar.loopedindex
  indices = getindicesonly(ar)
  # offsets = getoffsets(ar)
  strides = getstrides(ar)
  for i ∈ eachindex(li)
    ind = indices[i]
    isli = li[i]
    gespsymbol = gespindsummary[i]
    # if isli & (!index_by_index) && (length(operations(ls)) ≤ 256)
    #   ops = operations(ls)
    #   loopfirst = first(getloop(ls, ind))
    #   if isknown(loopfirst)
    #     # copy in case of aliasing
    #   end
    # end
    # constoffset ≠ 0 &&
    constoffset = adjust_offsets!(
      ls,
      i,
      array_refs_with_same_name,
      arrayref_to_name_op_collection
    )
    index_by_index = isli ? check_shouldindbyind(ls, ind, shouldindbyind) : true
    # (stridesunequal & isli) && (@assert isknown(first(getloop(ls, ind))))

    # end
    #   stride = strides[i]
    #   if stride ≠ 1
    #     loop = getloop(ls, ind)
    #     if isknown(first(loop))
    #       offsets[i] -= gethint(first(loop))
    #     end
    #   end
    #   # for op ∈ operations(ls)
    #   #   accesses_memory(op) || continue
    #   #   sameref(op.ref, ref) || continue
    #   #   getstrides(op)
    #   # end
    # end
    pushgespind!(
      gespinds,
      ls,
      gespsymbol,
      constoffset,
      Int(strides[i]),
      ind,
      isli,
      index_by_index,
      true
    )
  end
  gespinds
end

function pushgespind!(
  gespinds::Expr,
  ls::LoopSet,
  gespsymbol::Symbol,
  constoffset::Int,
  stride::Int,
  ind::Symbol,
  isli::Bool,
  index_by_index::Bool,
  fromgsp::Bool
)
  if isli
    if ind === CONSTANTZEROINDEX
      if gespsymbol === Symbol("")
        push!(gespinds.args, staticexpr(constoffset))
      elseif constoffset == 0
        push!(gespinds.args, gespsymbol)
      else
        push!(
          gespinds.args,
          Expr(
            :call,
            GlobalRef(Base, :(+)),
            gespsymbol,
            staticexpr(constoffset)
          )
        )
      end
    else
      if index_by_index
        if gespsymbol === Symbol("")
          if constoffset == 0
            nostep = if fromgsp | (!index_by_index)
              GlobalRef(VectorizationBase, :NullStep)
            else
              GlobalRef(LoopVectorization, :Zero)
            end
            ns = Expr(:call, nostep)
            if fromgsp
              loop = getloop(ls, ind)
              if loop.rangesym ≢ Symbol("")
                ns = Expr(:call, lv(:similardims), loop.rangesym, ns)
              end
            end
            push!(gespinds.args, ns)
          else
            push!(gespinds.args, staticexpr(constoffset))
          end
        elseif constoffset == 0
          push!(gespinds.args, gespsymbol)
        else
          push!(gespinds.args, addexpr(gespsymbol, constoffset))
        end
      else
        loop = getloop(ls, ind)
        if gespsymbol === Symbol("")
          if isknown(first(loop))
            # @show constoffset, gethint(first(loop))
            push!(
              gespinds.args,
              staticexpr(constoffset + stride * gethint(first(loop)))
            )
          elseif constoffset == 0
            if stride == 1
              push!(gespinds.args, getsym(first(loop)))
            else
              push!(gespinds.args, mulexpr(getsym(first(loop)), stride))
            end
          elseif stride == 1
            push!(gespinds.args, addexpr(getsym(first(loop)), constoffset))
          else
            push!(
              gespinds.args,
              addexpr(mulexpr(getsym(first(loop)), stride), constoffset)
            )
          end
        elseif isknown(first(loop))
          loopfirst = gethint(first(loop)) * stride + constoffset
          if loopfirst == 0
            push!(gespinds.args, gespsymbol)
          else
            push!(
              gespinds.args,
              Expr(
                :call,
                GlobalRef(Base, :(+)),
                gespsymbol,
                staticexpr(loopfirst)
              )
            )
          end
        else
          addedstarts = if stride == 1
            Expr(:call, GlobalRef(Base, :(+)), gespsymbol, getsym(first(loop)))
          else
            Expr(
              :call,
              GlobalRef(Base, :(+)),
              mulexpr(stride, gespsymbol),
              getsym(first(loop))
            )
          end
          if constoffset == 0
            push!(gespinds.args, addedstarts)
          else
            push!(
              gespinds.args,
              Expr(
                :call,
                GlobalRef(Base, :(+)),
                addedstarts,
                staticexpr(constoffset)
              )
            )
          end
        end
      end
    end # if we hit the following elseif/else, not a loopindex
  elseif fromgsp # from gsp means that a loop could be a CartesianIndices, so we may need to expand
    #TODO: broadcast dimensions in case of cartesian indices
    rangesym = ind
    foundind = false
    for op ∈ operations(ls)
      if name(op) === ind
        loopdeps = loopdependencies(op)
        foundind = true
        if length(loopdeps) ≠ 0
          rangesym = getloop(ls, first(loopdeps)).rangesym
        else
          isconstantop(op) || throw(
            LoopError(
              "Please file an issue with LoopVectorization.jl with a reproducer; tried to eliminate a non-constant operation."
            )
          )
          rangesym = name(op)
        end
        break
      end
    end
    @assert foundind
    if rangesym === Symbol("") # there is no rangesym, must be statically sized.
      pushgespsym!(gespinds, gespsymbol, constoffset)
    else
      pushsimdims!(gespinds, rangesym, gespsymbol, constoffset)
    end
  else # it is known all inds are 1-dimensional
    pushgespsym!(gespinds, gespsymbol, constoffset)
  end
  return nothing
end
function pushgespsym!(gespinds::Expr, gespsymbol::Symbol, constoffset::Int)
  if gespsymbol === Symbol("")
    push!(gespinds.args, staticexpr(constoffset))
  elseif constoffset == 0
    push!(gespinds.args, gespsymbol)
  else
    push!(gespinds.args, addexpr(gespsymbol, constoffset))
  end
  return nothing
end
function pushsimdims!(
  gespinds::Expr,
  rangesym::Symbol,
  gespsymbol::Symbol,
  constoffset::Int
)
  simdimscall = Expr(:call, lv(:similardims), rangesym)
  pushgespsym!(simdimscall, gespsymbol, constoffset)
  push!(gespinds.args, simdimscall)
  return nothing
end

# if using ptr offsets, need to offset by loopstart
# if calculating by index, do not offset by loopstart
"""
Returns a vector of length equal to the number of indices.
A value > 0 indicates which loop number that index corresponds to when incrementing the pointer.
A value < 0 indicates that abs(value) is the corresponding loop, and a `loopvalue` will be used.
"""
function use_loop_induct_var!(
  ls::LoopSet,
  q::Expr,
  ar::ArrayReferenceMeta,
  allarrayrefs::Vector{ArrayReferenceMeta},
  includeinlet::Bool
  # array_refs_with_same_name::Vector{Int}, arrayref_to_name_op_collection::Vector{Vector{Tuple{Int,Int,Int}}}
)::Vector{Int}
  us = ls.unrollspecification
  li = ar.loopedindex
  looporder = reversenames(ls)
  uliv = Vector{Int}(undef, length(li))
  indices = getindices(ar)
  strds = getstrides(ar)
  offset = first(indices) === DISCONTIGUOUS
  if length(indices) != offset + length(li)
    println(ar)
    throw("Length of indices and length of offset do not match!")
  end
  isbroadcast = ls.isbroadcast
  # no constant offsets when broadcasting
  # if (!isbroadcast) && !(all(li))
  #   checkforgespind = true
  #   gespindoffsets = cse_constant_offsets!(ls, q, ar, allarrayrefs, allarrayrefsind, array_refs_with_same_name, arrayref_to_name_op_collection)
  # else
  #   checkforgespind = false
  #   gespindoffsets = indices#dummy
  # end
  gespinds = Expr(:tuple)
  offsetprecalc_descript = Expr(:tuple)
  use_offsetprecalc = false
  vptrar = vptr(ar)
  Wisz = false#ls.vector_width == 0
  for (i, isli) ∈ enumerate(li)
    ii = i + offset
    ind = indices[ii]
    Wisz && push!(gespinds.args, staticexpr(0)) # wrong for `@_turbo`...
    if !li[i] # if it wasn't set
      uliv[i] = 0
      push!(offsetprecalc_descript.args, 0)
      Wisz ||
        pushgespind!(gespinds, ls, Symbol(""), 0, 1, ind, isli, true, false)
    elseif ind === CONSTANTZEROINDEX
      uliv[i] = 0
      push!(offsetprecalc_descript.args, 0)
      Wisz ||
        pushgespind!(gespinds, ls, Symbol(""), 0, 1, ind, isli, true, false)
    elseif isbroadcast ||
           (
             (isone(ii) && (last(looporder) === ind)) &&
             !(otherindexunrolled(ls, ind, ar)) ||
             multiple_with_name(vptrar, allarrayrefs)
           ) ||
           (iszero(ls.vector_width) && isstaticloop(getloop(ls, ind))) ||
           (strds[i] ≤ 0)
      # Not doing normal offset indexing
      uliv[i] = -findfirst(Base.Fix2(===, ind), looporder)::Int
      push!(offsetprecalc_descript.args, 0) # not doing offset indexing, so push 0
      Wisz ||
        pushgespind!(gespinds, ls, Symbol(""), 0, 1, ind, isli, true, false)
    else
      uliv[i] = findfirst(Base.Fix2(===, ind), looporder)::Int
      # loop = getloop(ls, ind)
      push!(offsetprecalc_descript.args, max(5, us.u₁ + 1, us.u₂ + 1))
      use_offsetprecalc = true
      Wisz ||
        pushgespind!(gespinds, ls, Symbol(""), 0, 1, ind, isli, false, false)
    end
    # cases for pushgespind! and loopval!
    # if !isloopval, same as before
    # if isloopval & `uliv[i] > 0`, then must setup
  end
  # arrayref_to_name_op = arrayref_to_name_op_collection[allarrayrefsind]
  if includeinlet#first(arrayref_to_name_op)[2] == 1 # if it's the first inside `array_refs_with_same_name`, we need to add the expression to the let block
    vpgesped = Expr(:call, lv(:gesp), vptrar, gespinds)
    if use_offsetprecalc
      vpgesped = Expr(
        :call,
        lv(:offsetprecalc),
        vpgesped,
        Expr(:call, Expr(:curly, :Val, offsetprecalc_descript))
      )
    end
    push!(q.args, Expr(:(=), vptrar, vpgesped))
    push!(
      q.args,
      Expr(
        :(=),
        vptr_offset(vptrar),
        Expr(:call, GlobalRef(VectorizationBase, :increment_ptr), vptrar)
      )
    )
  end
  uliv
end

# Plan here is that we increment every unique array
function add_loop_start_stop_manager!(ls::LoopSet)
  q = Expr(:block)
  # Presence of an explicit use of a loopinducation var means we should use that, so we look for one
  # TODO: replace first with only once you add Compat as a dep or drop support for older Julia versions
  loopinductvars = Symbol[]
  for op ∈ operations(ls)
    isloopvalue(op) && push!(loopinductvars, first(loopdependencies(op)))
  end
  # Filtered ArrayReferenceMetas, we must increment each
  # arrayrefs, name_to_array_map, unique_to_name_and_op_map = uniquearrayrefs(ls)
  arrayrefs, includeinlet = uniquearrayrefs(ls)
  use_livs = Vector{Vector{Int}}(undef, length(arrayrefs))
  # for i ∈ eachindex(name_to_array_map)
  for i ∈ eachindex(arrayrefs)
    use_livs[i] =
      use_loop_induct_var!(ls, q, arrayrefs[i], arrayrefs, includeinlet[i])
    #name_to_array_map[first(first(unique_to_name_and_op_map[i]))], unique_to_name_and_op_map)
  end
  # loops, sorted from outer-most to inner-most
  looporder = reversenames(ls)
  # For each loop, we need to choose an induction variable
  nloops = length(looporder)
  # loopstarts = Vector{Vector{ArrayReferenceMeta}}(undef, nloops)
  loopstarts = fill(ArrayReferenceMeta[], nloops)
  terminators = Vector{Int}(undef, nloops) # zero is standard loop induct var
  # loopincrements = Vector{Vector{ArrayReferenceMeta}}(undef, nloops) # Not needed; copy of loopstarts
  # The purpose of the reminds thing here is to pick which of these to use for the terminator
  # We want to pick the one with the fewest outer loops with respect to this one, to minimize
  # the number of redefinitions of max-pointer used for the termination comparison.
  reached_indices = zeros(Int, length(arrayrefs))
  for (i, loopsym) ∈ enumerate(looporder) # iterates from outer to inner
    loopstartᵢ = ArrayReferenceMeta[]
    ric = Tuple{Int,Int}[]
    for j ∈ eachindex(use_livs) # j is array ref number
      for k ∈ use_livs[j]# l is index number, k is loop number
        if k == i
          push!(loopstartᵢ, arrayrefs[j])
          push!(ric, ((reached_indices[j] += 1), length(loopstartᵢ)))
        end
      end
    end
    loopstarts[nloops+1-i] = loopstartᵢ
    terminators[nloops+1-i] =
      if (loopsym ∈ loopinductvars) ||
         (any(r -> any(isequal(-i), r), use_livs)) ||
         iszero(length(loopstartᵢ))
        0
      else
        # @assert !iszero(length(loopstartᵢ))
        last(ric[argmin(first.(ric))]) # index corresponds to array ref's position in loopstart
      end
  end
  ls.lssm = LoopStartStopManager(terminators, loopstarts, arrayrefs)
  q
end
maxsym(ptr, sub) = Symbol(ptr, "##MAX##", sub, "##")
function pointermax(
  ls::LoopSet,
  ar::ArrayReferenceMeta,
  n::Int,
  sub::Int,
  isvectorized::Bool
)::Expr
  pointermax(ls, ar, n, sub, isvectorized, getloop(ls, names(ls)[n]))
end
function pointermax(
  ls::LoopSet,
  ar::ArrayReferenceMeta,
  n::Int,
  sub::Int,
  isvectorized::Bool,
  loop::Loop
)::Expr
  start = first(loop)
  stop = last(loop)
  incr = step(loop)
  if isknown(start) & isknown(stop)
    return pointermax(
      ls,
      ar,
      n,
      sub,
      isvectorized,
      1 + gethint(stop) - gethint(start),
      incr
    )
  end
  looplensym = isone(start) ? getsym(stop) : loop.lensym
  pointermax(ls, ar, n, sub, isvectorized, looplensym, incr)
end
function pointermax_index(
  ls::LoopSet,
  ar::ArrayReferenceMeta,
  n::Int,
  sub::Int,
  isvectorized::Bool,
  stophint::Int,
  incr::MaybeKnown
)::Tuple{Expr,Int}
  # @unpack u₁loopnum, u₂loopnum, vloopnum, u₁, u₂ = us
  loopsym = names(ls)[n]
  index = Expr(:tuple)
  ind = 0
  for (j, i) ∈ enumerate(getindicesonly(ar))
    if i === loopsym
      ind = j
      if iszero(sub)
        push!(index.args, stophint)
      else
        _ind = if isvectorized
          if isone(sub)
            Expr(:call, lv(:vsub_nsw), staticexpr(stophint), VECTORWIDTHSYMBOL)
          else
            Expr(
              :call,
              lv(:vsub_nsw),
              staticexpr(stophint),
              mulexpr(VECTORWIDTHSYMBOL, sub)
            )
          end
        else
          staticexpr(stophint - sub)
        end
        stride = getstrides(ar)[j]
        if isknown(incr)
          stride *= gethint(incr)
        else
          _ind = mulexpr(_ind, getsym(incr))
        end
        if stride ≠ 1
          @assert stride ≠ 0 "stride shouldn't be 0 if used for determining loop start/stop, but loop $n array $ar was."
          _ind = lazymulexpr(stride, _ind)
        end
        push!(index.args, _ind)
      end
    else
      push!(index.args, Expr(:call, lv(:Zero)))
    end
  end
  @assert ind ≠ 0 "Failed to find $loopsym"
  index, ind
end
function pointermax_index(
  ls::LoopSet,
  ar::ArrayReferenceMeta,
  n::Int,
  sub::Int,
  isvectorized::Bool,
  stopsym,
  incr::MaybeKnown
)::Tuple{Expr,Int}
  loopsym = names(ls)[n]
  index = Expr(:tuple)
  ind = 0
  for (j, i) ∈ enumerate(getindicesonly(ar))
    if i === loopsym
      ind = j
      if iszero(sub)
        push!(index.args, stopsym)
      else
        _ind = if isvectorized
          if isone(sub)
            Expr(:call, lv(:vsub_nsw), stopsym, VECTORWIDTHSYMBOL)
          else
            Expr(:call, lv(:vsub_nsw), stopsym, mulexpr(VECTORWIDTHSYMBOL, sub))
          end
        else
          subexpr(stopsym, sub)
        end
        stride = getstrides(ar)[j]
        if isknown(incr)
          stride *= gethint(incr)
        else
          _ind = mulexpr(_ind, getsym(incr))
        end
        if stride ≠ 1
          @assert stride ≠ 0 "stride shouldn't be 0 if used for determining loop start/stop, but loop $n array $ar was."
          _ind = lazymulexpr(stride, _ind)
        end
        push!(index.args, _ind)
      end
    else
      push!(index.args, Expr(:call, lv(:Zero)))
    end
  end
  @assert ind != 0 "Failed to find $loopsym"
  index, ind
end
function pointermax(
  ls::LoopSet,
  ar::ArrayReferenceMeta,
  n::Int,
  sub::Int,
  isvectorized::Bool,
  stopsym,
  incr::MaybeKnown
)::Expr
  index = first(pointermax_index(ls, ar, n, sub, isvectorized, stopsym, incr))
  vptrar = vptr(ar)
  Expr(
    :call,
    GlobalRef(VectorizationBase, :increment_ptr),
    vptrar,
    vptr_offset(vptrar),
    index
  )
end

function defpointermax(
  ls::LoopSet,
  ar::ArrayReferenceMeta,
  n::Int,
  sub::Int,
  isvectorized::Bool
)::Expr
  Expr(:(=), maxsym(vptr(ar), sub), pointermax(ls, ar, n, sub, isvectorized))
end
function offsetindex(
  dim::Int,
  ind::Int,
  scale::Int,
  isvectorized::Bool,
  incr::MaybeKnown
)
  index = Expr(:tuple)
  for d ∈ 1:dim
    if d ≠ ind || iszero(scale)
      push!(index.args, Expr(:call, lv(:Zero)))
      continue
    end
    if !isvectorized
      pushmulexpr!(index, scale, incr)
    elseif isone(scale)
      pushmulexpr!(index, VECTORWIDTHSYMBOL, incr)
    else
      push!(index.args, mulexpr(VECTORWIDTHSYMBOL, scale, incr))
    end
  end
  index
end
function append_pointer_maxes!(
  loopstart::Expr,
  ls::LoopSet,
  ar::ArrayReferenceMeta,
  n::Int,
  submax::Int,
  isvectorized::Bool,
  stopindicator,
  incr::MaybeKnown
)
  vptr_ar = vptr(ar)
  if submax < 2
    for sub ∈ 0:submax
      push!(
        loopstart.args,
        Expr(
          :(=),
          maxsym(vptr_ar, sub),
          pointermax(ls, ar, n, sub, isvectorized, stopindicator, incr)
        )
      )
    end
  else
    index, ind =
      pointermax_index(ls, ar, n, submax, isvectorized, stopindicator, incr)
    pointercompbase = maxsym(vptr_ar, submax)
    ip = GlobalRef(VectorizationBase, :increment_ptr)
    push!(
      loopstart.args,
      Expr(
        :(=),
        pointercompbase,
        Expr(:call, ip, vptr_ar, vptr_offset(vptr_ar), index)
      )
    )
    dim = length(getindicesonly(ar))
    # OFFSETPRECALCDEF = true
    # if OFFSETPRECALCDEF
    strd = getstrides(ar)[ind]
    for sub ∈ 0:submax-1
      ptrcmp = Expr(
        :call,
        ip,
        vptr_ar,
        pointercompbase,
        offsetindex(dim, ind, (submax - sub) * strd, isvectorized, incr)
      )
      push!(loopstart.args, Expr(:(=), maxsym(vptr_ar, sub), ptrcmp))
    end
  end
end
function append_pointer_maxes!(
  loopstart::Expr,
  ls::LoopSet,
  ar::ArrayReferenceMeta,
  n::Int,
  submax::Int,
  isvectorized::Bool
)
  loop = getloop(ls, n)
  @assert loop.itersymbol == names(ls)[n]
  start = first(loop)
  stop = last(loop)
  incr = step(loop)
  if isknown(start) & isknown(stop)
    return append_pointer_maxes!(
      loopstart,
      ls,
      ar,
      n,
      submax,
      isvectorized,
      startstopΔ(loop) + 1,
      incr
    )
  end
  looplensym = isone(start) ? getsym(stop) : loop.lensym
  append_pointer_maxes!(
    loopstart,
    ls,
    ar,
    n,
    submax,
    isvectorized,
    looplensym,
    incr
  )
end

function maxunroll(us::UnrollSpecification, n)
  @unpack u₁loopnum, u₂loopnum, u₁, u₂ = us
  if n == u₁loopnum# && u₁ > 1
    u₁
  elseif n == u₂loopnum# && u₂ > 1
    u₂
  else
    1
  end
end

function startloop(
  ls::LoopSet,
  us::UnrollSpecification,
  n::Int,
  staticinit::Bool = false
)
  @unpack u₁loopnum, u₂loopnum, vloopnum, u₁, u₂ = us
  lssm = ls.lssm
  termind = lssm.terminators[n]
  ptrdefs = lssm.incrementedptrs[n]
  loopstart = Expr(:block)
  for ar ∈ ptrdefs
    ptr_offset = vptr_offset(ar)
    push!(loopstart.args, Expr(:(=), ptr_offset, ptr_offset))
  end
  if iszero(termind)
    loopsym = names(ls)[n]
    push!(loopstart.args, startloop(getloop(ls, loopsym), loopsym, staticinit))
  else
    isvectorized = n == vloopnum
    submax = maxunroll(us, n)
    append_pointer_maxes!(
      loopstart,
      ls,
      ptrdefs[termind],
      n,
      submax,
      isvectorized
    )
  end
  loopstart
end
function offset_ptr(
  ar::ArrayReferenceMeta,
  us::UnrollSpecification,
  loopsym::Symbol,
  n::Int,
  UF::Int,
  offsetinds::Vector{Bool},
  loop::Loop
)
  indices = getindices(ar)
  strides = getstrides(ar)
  offset = first(indices) === DISCONTIGUOUS
  gespinds = Expr(:tuple)
  li = ar.loopedindex
  for i ∈ eachindex(li)
    ii = i + offset
    ind = indices[ii]
    if !offsetinds[i] || ind !== loopsym
      push!(gespinds.args, Expr(:call, lv(:Zero)))
    else
      incrementloopcounter!(gespinds, us, n, UF * strides[i], loop)
    end
    # ind == loopsym && break
  end
  vpoff = vptr_offset(ar)
  call = Expr(
    :call,
    GlobalRef(VectorizationBase, :increment_ptr),
    vptr(ar),
    vpoff,
    gespinds
  )
  Expr(:(=), vpoff, call)
end
function incrementloopcounter!(
  q::Expr,
  ls::LoopSet,
  us::UnrollSpecification,
  n::Int,
  UF::Int
)
  @unpack u₁loopnum, u₂loopnum, vloopnum, u₁, u₂ = us
  lssm = ls.lssm
  ptrdefs = lssm.incrementedptrs[n]
  looporder = names(ls)
  loopsym = looporder[n]
  termind = lssm.terminators[n]
  loop = getloop(ls, n)
  if iszero(termind) # increment liv
    push!(q.args, incrementloopcounter(us, n, loopsym, UF, loop))
  end
  for ar ∈ ptrdefs
    offsetinds = indices_calculated_by_pointer_offsets(ls, ar)
    push!(q.args, offset_ptr(ar, us, loopsym, n, UF, offsetinds, loop))
  end
  nothing
end
function terminatecondition(
  ls::LoopSet,
  us::UnrollSpecification,
  n::Int,
  inclmask::Bool,
  UF::Int
)
  lssm = ls.lssm
  termind = lssm.terminators[n]
  if iszero(termind)
    loop = getloop(ls, n)
    return terminatecondition(loop, us, n, loop.itersymbol, inclmask, UF)
  end

  termar = lssm.incrementedptrs[n][termind]
  ptr = vptr(termar)
  optr = vptr_offset(ptr)
  if inclmask && isvectorized(us, n)
    Expr(:call, GlobalRef(VectorizationBase, :vlt), optr, maxsym(ptr, 0), ptr)
  else
    Expr(:call, GlobalRef(VectorizationBase, :vle), optr, maxsym(ptr, UF), ptr)
  end
end

using PrettyTables

function Base.show(io::IO, br::BenchmarkResult)
  hb = Highlighter(
    (br, i, j) ->
      (j > 1 && maximum(@view(br.results[:, i])) == br.results[j-1, i]);
    foreground = :green
  )
  pretty_table(
    io,
    br.sizedresults,
    br.tests;
    crop = :none,
    highlighters = (hb,)
  )
end

if (Sys.ARCH === :aarch64) && Sys.isapple()
  nothing
else
  using Colors, ColorSchemes, Gadfly
  const COLORS = [RGB(0.0, 0.0, 0.0), RGB(1.0, 0.0, 0.0)]
  # const COLORS = [RGB(0.0,0.0,0.0),RGB(0.0,1.0,0.0)]
  # const COLORS = distinguishable_colors(14, pushfirst!(get(ColorSchemes.Paired_12, (0.5:11.5) ./ 12), RGB(0.0,0.0,0.0)))
  for i ∈ 1:12 # 11 is number of tested libs - 2
    push!(COLORS, get(ColorSchemes.cyclic_mygbm_30_95_c78_n256_s25, i / 12))
    # push!(COLORS, get(ColorSchemes.vikO, (i-0.5)/12))
  end
  # const COLOR_MAP = Dict{String,RGB{Float64}}()
  # const COLOR_MAP = Dict{String,RGB{Colors.N0f8}}()
  const COLOR_MAP64 = Dict{String,RGB{Float64}}()
  getcolor(s::String) =
    get!(COLOR_MAP64, s) do
      COLORS[length(COLOR_MAP64)+1]
    end
  replace_and(str) = replace(str, '&' => "with")

  function Gadfly.plot(br::BenchmarkResult)
    res = br.sizedresults.results
    sizes = br.sizedresults.sizes
    # sizes = Vector{eltype(brsizes)}(undef, length(res))
    tests = replace_and.(@view(br.tests[2:end]))
    colors = getcolor.(tests)
    addlabel = false

    maxxval, maxxind = findmax(sizes)
    maxxtick = 10cld(maxxval, 10) + (addlabel ? 20 : 0)
    xt = 0:20:maxxtick
    maxres = maximum(res)
    maxtick = 10round(Int, 0.1maxres)
    yt = if iszero(maxtick)
      maxtick = 10round(0.1maxres)
      range(0, maxres; length = 20)
    elseif maxtick < 10
      0:1:maxtick
    elseif maxtick < 20
      0:2:maxtick
    elseif maxtick < 50
      0:5:maxtick
    else
      0:10:maxtick
    end
    p = Gadfly.plot(
      Gadfly.Guide.manual_color_key("Methods", tests, colors),
      Guide.xlabel("Size"),
      Guide.ylabel("GFLOPS"),
      Guide.xticks(; ticks = collect(xt)),
      Guide.yticks(; ticks = collect(yt))
    )
    for i ∈ eachindex(tests)
      push!(
        p,
        layer(;
          x = sizes,
          y = res[i, :],
          Geom.line,
          Theme(; default_color = colors[i])
        )
      )
    end
    addlabel && push!(
      p,
      layer(;
        x = fill(maxxtick - 10, length(tests)),
        y = res[:, maxxind],
        label = tests,
        Geom.label(; position = :centered)
      )
    )
    p
  end
end
# using VegaLite, IndexedTables
# function plot(br::BenchmarkResult)
#     res = vec(br.sizedresults.results)
#     brsizes = br.sizedresults.sizes
#     sizes = Vector{eltype(brsizes)}(undef, length(res))
#     ntests = length(br.tests) - 1
#     for i ∈ 0:length(brsizes)-1
#         si = brsizes[i+1]
#         for j ∈ 1:ntests
#             sizes[j + i*ntests] = si
#         end
#     end
#     names = ["$(i > 9 ? string(i) : "0$i"). $test" for (i,test) ∈ enumerate(@view(br.tests[2:end]))]
#     tests = reduce(vcat, (names for _ ∈ eachindex(brsizes)))
#     t = table((GFLOPS = res, Size = sizes, Method = tests))
#     t |> @vlplot(
#         :line,
#         x = :Size,
#         y = :GFLOPS,
#         width = 900,
#         height = 600,
#         color={
#             :Method,
#             scale={scheme="category20"}
#         }
#     )
# end

dottosym(x)::Symbol = x

function dottosym(x::Expr)::Symbol
  s1 = dottosym(x.args[1])
  xa2 = x.args[2]
  xa2 isa QuoteNode ? Symbol(s1, "###extractarray###", xa2.value) :
  Symbol(s1, "###extractarray###", xa2)
end
function extract_array_symbol_from_ref!(
  ls::LoopSet,
  ex::Expr,
  offset1::Int
)::Symbol
  ar = ex.args[1+offset1]
  if isa(ar, Symbol)
    return ar
  elseif isa(ar, Expr) && (ar.head === :(.) || ar.head === :ref)
    s = dottosym(ar)
    # pushpreamble!(ls, Expr(:(=), s, ar))
    pushprepreamble!(ls, Expr(:(=), s, ar))
    return s
  else
    throw("Indexing into the following expression was not recognized: $ar")
  end
end

function ref_from_expr!(ls, ex, offset1::Int, offset2::Int)
  ar = extract_array_symbol_from_ref!(ls, ex, offset1)
  ar, @view(ex.args[2+offset2:end])
end
ref_from_ref!(ls::LoopSet, ex::Expr) = ref_from_expr!(ls, ex, 0, 0)
ref_from_getindex!(ls::LoopSet, ex::Expr) = ref_from_expr!(ls, ex, 1, 1)
ref_from_setindex!(ls::LoopSet, ex::Expr) = ref_from_expr!(ls, ex, 1, 2)
function ref_from_expr!(ls::LoopSet, ex::Expr)
  if ex.head === :ref
    ref_from_ref!(ls, ex)
  else#if ex.head === :call
    f = first(ex.args)::Symbol
    f === :getindex ? ref_from_getindex!(ls, ex) : ref_from_setindex!(ls, ex)
  end
end

add_vptr!(ls::LoopSet, op::Operation) = add_vptr!(ls, op.ref)
add_vptr!(ls::LoopSet, mref::ArrayReferenceMeta) =
  add_vptr!(ls, mref.ref.array, vptr(mref))
# using VectorizationBase: noaliasstridedpointer
presbufsym(array) = Symbol('#', array, "#preserve#buffer#")
function add_vptr!(
  ls::LoopSet,
  array::Symbol,
  vptrarray::Symbol,
  actualarray::Bool = true
)
  if !includesarray(ls, array)
    push!(ls.includedarrays, array)
    actualarray && push!(ls.includedactualarrays, array)
    pushpreamble!(
      ls,
      Expr(
        :(=),
        Expr(:tuple, vptrarray, presbufsym(array)),
        Expr(:call, lv(:stridedpointer_preserve), array)
      )
    )
  end
  nothing
end

@inline staticdims(::Any) = One()
@inline staticdims(::CartesianIndices{N}) where {N} = StaticInt{N}()

function append_loop_staticdims!(valcall::Expr, loop::Loop, constoffset::Int)
  isstaticloop(loop) && return constoffset + 1
  push!(valcall.args, Expr(:call, lv(:staticdims), loop.rangesym))
  constoffset
end
function subset_vptr!(
  ls::LoopSet,
  vptr::Symbol,
  indnum::Int,
  ind,
  previndices,
  loopindex,
  D::Int
)
  subset = D == 0
  str_typ = subset ? "subset" : "index"
  subsetvptr = Symbol(vptr, "_##$(str_typ)##_$(indnum)_##with##_$(ind)_##")
  valcall = Expr(:call, +)
  constoffset = 1
  if indnum > 1
    offset = first(previndices) === DISCONTIGUOUS
    # valcall =  Expr(:call, :(+), valcall)
    for i ∈ 1:indnum-1
      if loopindex[i]
        loopdep = previndices[i+offset]
        if loopdep === CONSTANTZEROINDEX
          constoffset += 1
          continue
        end
      else
        # assumes all staticdims will be of equal length once expanded...
        # A[I + J, constindex], I and J may be CartesianIndices. This requires they all be of same number of dims
        loopdep = first(loopdependencies(ls.opdict[previndices[i+offset]]))
      end
      constoffset =
        append_loop_staticdims!(valcall, getloop(ls, loopdep), constoffset)
    end
  end
  # indm1 = ind isa Integer ? ind - 1 : Expr(:call, :-, ind, 1)
  f = lv(Core.ifelse(subset, :subsetview, :_gesp))
  constoffsetexpr = staticexpr(constoffset)
  if length(valcall.args) ≠ 1
    push!(valcall.args, constoffsetexpr)
    constoffsetexpr = valcall
  end
  fexpr = Expr(:call, f, vptr, constoffsetexpr, ind)
  subset || push!(fexpr.args, staticexpr(D))
  pushpreamble!(ls, Expr(:(=), subsetvptr, fexpr))
  subsetvptr
end

function gesp_const_offset!(
  ls::LoopSet,
  vptrarray::Symbol,
  ninds::Int,
  indices::Vector{Symbol},
  loopedindex::Vector{Bool},
  mlt::Integer,
  sym,
  D::Int
)
  if isone(mlt)
    subset_vptr!(ls, vptrarray, ninds, sym, indices, loopedindex, D)
  else
    # want same name for arrays to be given the same name if possible
    mltsym = Symbol(sym, "##multiplied##by##", mlt)
    pushpreamble!(ls, Expr(:(=), mltsym, Expr(:call, :(*), mlt, sym)))
    # pushprepreamble!(ls, Expr(:(=), mltsym, Expr(:call, :(*), mlt, sym)))
    subset_vptr!(ls, vptrarray, ninds, mltsym, indices, loopedindex, D)
  end
end
function gesp_const_offsets!(
  ls::LoopSet,
  vptrarray::Symbol,
  ninds::Int,
  indices::Vector{Symbol},
  loopedindex::Vector{Bool},
  mltsyms::Vector{Tuple{Int,Symbol}},
  D::Int
)
  length(mltsyms) > 1 && sort!(mltsyms; by = last) # if multiple have same combination of syms, make sure they match even if order is different
  for (mlt, sym) ∈ mltsyms
    vptrarray = gesp_const_offset!(
      ls,
      vptrarray,
      ninds,
      indices,
      loopedindex,
      mlt,
      sym,
      D
    )
  end
  vptrarray
end

byterepresentable(x)::Bool = false
byterepresentable(x::Integer)::Bool = typemin(Int8) ≤ x ≤ typemax(Int8)
function _addoffset!(
  indices,
  offsets,
  strides,
  loopedindex,
  loopdependencies,
  ind,
  offset,
  stride
)
  push!(indices, ind)
  push!(offsets, offset % Int8)
  # push!(offsets, (offset+stride-1) % Int8)
  push!(strides, stride % Int8)
  push!(loopedindex, true)
  push!(loopdependencies, ind)
  true
end

function addconstindex!(indices, offsets, strides, loopedindex, offset)
  push!(indices, CONSTANTZEROINDEX)
  # push!(offsets, (offset-1) % Int8)
  push!(offsets, (offset) % Int8)
  push!(strides, zero(Int8))
  push!(loopedindex, true)
  true
end
function addopindex!(
  parents::Vector{Operation},
  loopdependencies::Vector{Symbol},
  reduceddeps::Vector{Symbol},
  indices::Vector{Symbol},
  offsets::Vector{Int8},
  strides::Vector{Int8},
  loopedindex::Vector{Bool},
  indop::Operation,
  stride = one(Int8),
  offset = zero(Int8)
)
  pushparent!(parents, loopdependencies, reduceddeps, indop)
  push!(indices, name(indop))
  push!(offsets, offset)
  push!(strides, stride)
  push!(loopedindex, false)
  nothing
end

####################################################################################################
###################################### Index Parsing Helpers #######################################
####################################################################################################

function add_affine_index_expr!(
  ls::LoopSet,
  mult_syms::Vector{Tuple{Int,Symbol}},
  constant::Base.RefValue{Int},
  stride::Int,
  expr::Symbol
)
  push!(mult_syms, (stride, expr))
  return nothing
end
function add_affine_index_expr!(
  ls::LoopSet,
  mult_syms::Vector{Tuple{Int,Symbol}},
  constant::Base.RefValue{Int},
  stride::Int,
  expr::Integer
)
  constant[] += stride * expr
  return nothing
end
function add_affine_op!(
  ls::LoopSet,
  mult_syms::Vector{Tuple{Int,Symbol}},
  constant::Base.RefValue{Int},
  stride::Int,
  expr::Expr
)
  parent = add_operation!(
    ls,
    gensym!(ls, "indexpr"),
    expr,
    sizeof(Int),
    length(ls.loopsymbols)
  )
  add_affine_index_expr!(ls, mult_syms, constant, stride, name(parent))
  return nothing
end
function add_mul!(
  ls::LoopSet,
  mult_syms::Vector{Tuple{Int,Symbol}},
  constant::Base.RefValue{Int},
  stride::Int,
  arg1,
  arg2,
  expr
)
  if arg1 isa Integer
    add_affine_index_expr!(ls, mult_syms, constant, stride * arg1, arg2)
  elseif arg2 isa Integer
    add_affine_index_expr!(ls, mult_syms, constant, stride * arg2, arg1)
  else
    add_affine_op!(ls, mult_syms, constant, stride, expr)
  end
  return nothing
end
function add_affine_index_expr!(
  ls::LoopSet,
  mult_syms::Vector{Tuple{Int,Symbol}},
  constant::Base.RefValue{Int},
  stride::Int,
  expr::Expr
)
  expr.head === :call ||
    return add_affine_op!(ls, mult_syms, constant, stride, expr)
  f = expr.args[1]
  if f === :(*)
    @assert length(expr.args) == 3
    add_mul!(ls, mult_syms, constant, stride, expr.args[2], expr.args[3], expr)
  elseif f === :(-)
    if length(expr.args) == 3
      add_affine_index_expr!(ls, mult_syms, constant, stride, expr.args[2])
    elseif length(expr.args) ≠ 2
      throw("Subtraction expression: $expr has an invalid number of arguments.")
    end
    add_affine_index_expr!(ls, mult_syms, constant, -stride, last(expr.args))
  elseif f === :(+)
    for i ∈ 2:length(expr.args)
      add_affine_index_expr!(ls, mult_syms, constant, stride, expr.args[i])
    end
  else
    add_affine_op!(ls, mult_syms, constant, stride, expr)
  end
  return nothing
end
function affine_index_expression(
  ls::LoopSet,
  expr
)::Tuple{Int,Vector{Tuple{Int,Symbol}}}
  mult_syms = Tuple{Int,Symbol}[]
  constant = Ref(0)
  add_affine_index_expr!(ls, mult_syms, constant, 1, expr)
  return constant[], mult_syms
end

function muladd_index!(
  ls::LoopSet,
  parents,
  loopdependencies,
  reduceddeps,
  indices,
  offsets,
  strides,
  loopedindex,
  mlt::Int,
  sym::Symbol,
  offset::Int
)
  muladd_index!(
    ls,
    parents,
    loopdependencies,
    reduceddeps,
    indices,
    offsets,
    strides,
    loopedindex,
    mlt,
    getop(ls, sym, sizeof(Int)),
    offset
  )
end
function muladd_op!(ls::LoopSet, mlt::Int, sym::Symbol, offset::Int)
  muladd_op!(ls, mlt, getop(ls, sym, sizeof(Int)), offset)
end
function muladd_op!(ls::LoopSet, mlt::Int, symop::Operation, offset::Int)
  indsym = gensym!(ls, "affindexop")
  vparents = [symop]
  # vparents = [, mltop, offop]
  if mlt == -1
    f = :vsub_nsw
    if offset ≠ 0
      pushfirst!(vparents, add_constant!(ls, offset, sizeof(Int)))
    end
  elseif mlt == 1
    offset == 0 && return only(vparents)
    push!(vparents, add_constant!(ls, offset, sizeof(Int)))
    f = :vadd_nsw
  else
    push!(vparents, add_constant!(ls, mlt, sizeof(Int)))
    f = if offset == 0
      :vmul_nsw
    else
      push!(vparents, add_constant!(ls, offset, sizeof(Int)))
      :muladd
    end
  end
  add_compute!(ls, indsym, instruction(f), vparents, sizeof(Int))
end
function muladd_index!(
  ls::LoopSet,
  parents,
  loopdependencies,
  reduceddeps,
  indices,
  offsets,
  strides,
  loopedindex,
  mlt::Int,
  symop::Operation,
  offset::Int
)
  if byterepresentable(offset) & byterepresentable(mlt)
    addopindex!(
      parents,
      loopdependencies,
      reduceddeps,
      indices,
      offsets,
      strides,
      loopedindex,
      symop,
      mlt,
      offset
    )
  else
    indop = muladd_op!(ls, mlt, symop, offset)
    addopindex!(
      parents,
      loopdependencies,
      reduceddeps,
      indices,
      offsets,
      strides,
      loopedindex,
      indop
    )
  end
end

function getintconstant(ls::LoopSet, op::Operation)
  for (i, (v, bits, bool)) ∈ ls.preamble_symint
    i == identifier(op) || continue
    return byterepresentable(v), v % Int8
  end
  return false, zero(Int8)
end

function add_additive_index!(
  ls::LoopSet,
  opparents,
  vptrarray,
  sym,
  mop,
  ninds,
  indices,
  offsets,
  strides,
  loopedindex,
  loopdependencies,
  reduceddeps,
  offset,
  mlt,
  D
)
  factor = Core.ifelse((instruction(mop).instr === :sub_fast), -1, 1)
  if length(parents(mop)) == 2
    sub1 = parents(mop)[1]
    sub2 = parents(mop)[2]
    if isloopvalue(sub1) & isconstant(sub2)
      isliteralint, literalval = getintconstant(ls, sub2)
      if isliteralint
        _addoffset!(
          indices,
          offsets,
          strides,
          loopedindex,
          loopdependencies,
          name(sub1),
          offset + literalval,
          mlt
        )
      else
        vptrarray = gesp_const_offset!(
          ls,
          vptrarray,
          ninds,
          indices,
          loopedindex,
          factor * mlt,
          name(sub2),
          D
        )
        _addoffset!(
          indices,
          offsets,
          strides,
          loopedindex,
          loopdependencies,
          name(sub1),
          offset,
          mlt
        )
      end
    elseif isloopvalue(sub2) & isconstant(sub1)
      isliteralint, literalval = getintconstant(ls, sub1)
      if isliteralint
        _addoffset!(
          indices,
          offsets,
          strides,
          loopedindex,
          loopdependencies,
          name(sub2),
          offset + literalval,
          factor * mlt
        )
      else
        vptrarray = gesp_const_offset!(
          ls,
          vptrarray,
          ninds,
          indices,
          loopedindex,
          mlt,
          name(sub1),
          D
        )
        _addoffset!(
          indices,
          offsets,
          strides,
          loopedindex,
          loopdependencies,
          name(sub2),
          offset,
          factor * mlt
        )
      end
    else
      muladd_index!(
        ls,
        opparents,
        loopdependencies,
        reduceddeps,
        indices,
        offsets,
        strides,
        loopedindex,
        mlt,
        sym,
        offset
      )
    end
  else
    muladd_index!(
      ls,
      opparents,
      loopdependencies,
      reduceddeps,
      indices,
      offsets,
      strides,
      loopedindex,
      mlt,
      sym,
      offset
    )
  end
  vptrarray
end

function checkforoffset!(
  ls::LoopSet,
  vptrarray::Symbol,
  ninds::Int,
  opparents::Vector{Operation},
  indices::Vector{Symbol},
  offsets::Vector{Int8},
  strides::Vector{Int8},
  loopedindex::Vector{Bool},
  loopdependencies::Vector{Symbol},
  reduceddeps::Vector{Symbol},
  ind::Expr,
  D::Int
)::Symbol
  offset, mult_syms = affine_index_expression(ls, ind)
  let deleted = 0, N = length(mult_syms)
    for n ∈ 1:N
      ntemp = n - deleted
      mlt, sym = mult_syms[ntemp]
      opm = get(ls.opdict, sym, nothing)
      opm === nothing && continue
      isconstant(opm) || continue
      found = false
      for (opid, (intval, intsz, signed)) ∈ ls.preamble_symint
        if opid == identifier(opm)
          offset += intval * mlt
          deleted += 1
          deleteat!(mult_syms, ntemp)
          found = true
          break
        end
      end
      found && continue
      for (opid, nt) ∈ ls.preamble_zeros
        if opid == identifier(opm)
          deleted += 1
          deleteat!(mult_syms, ntemp)
          break
        end
      end
    end
  end
  if !byterepresentable(offset)
    if length(mult_syms) == 1
      mlt, sym = only(mult_syms)
      if !byterepresentable(mlt)
        # this is so we don't unnecessarily add a separate offset
        muladd_index!(
          ls,
          opparents,
          loopdependencies,
          reduceddeps,
          indices,
          offsets,
          strides,
          loopedindex,
          mlt,
          sym,
          offset
        )
        return vptrarray
      end
    end
    r = copysign(abs(offset) & 127, offset)
    vptrarray = gesp_const_offset!(
      ls,
      vptrarray,
      ninds,
      indices,
      loopedindex,
      1,
      offset - r,
      D
    )
    offset = r
  end
  # (success && byterepresentable(offset)) || return false, vptrarray
  if length(mult_syms) == 0
    addconstindex!(indices, offsets, strides, loopedindex, offset)
    return vptrarray
  elseif length(mult_syms) == 1
    mlt, sym = mult_syms[1]
    if sym ∈ ls.loopsymbols
      if byterepresentable(mlt)
        _addoffset!(
          indices,
          offsets,
          strides,
          loopedindex,
          loopdependencies,
          sym,
          offset,
          mlt
        )
      else
        muladd_index!(
          ls,
          opparents,
          loopdependencies,
          reduceddeps,
          indices,
          offsets,
          strides,
          loopedindex,
          mlt,
          sym,
          offset
        )
      end
    elseif !byterepresentable(mlt)
      muladd_index!(
        ls,
        opparents,
        loopdependencies,
        reduceddeps,
        indices,
        offsets,
        strides,
        loopedindex,
        mlt,
        sym,
        offset
      )
    else
      mop = get(ls.opdict, sym, nothing)
      if mop === nothing
        vptrarray = gesp_const_offset!(
          ls,
          vptrarray,
          ninds,
          indices,
          loopedindex,
          mlt,
          sym,
          D
        )
        addconstindex!(indices, offsets, strides, loopedindex, offset)
      elseif isconstant(mop)
        vptrarray = gesp_const_offset!(
          ls,
          vptrarray,
          ninds,
          indices,
          loopedindex,
          mlt,
          name(mop),
          D
        )
        addconstindex!(indices, offsets, strides, loopedindex, offset)
      elseif (instruction(mop).instr === :add_fast) ||
             (instruction(mop).instr === :sub_fast)
        vptrarray = add_additive_index!(
          ls,
          opparents,
          vptrarray,
          sym,
          mop,
          ninds,
          indices,
          offsets,
          strides,
          loopedindex,
          loopdependencies,
          reduceddeps,
          offset,
          mlt,
          D
        )
      else
        muladd_index!(
          ls,
          opparents,
          loopdependencies,
          reduceddeps,
          indices,
          offsets,
          strides,
          loopedindex,
          mlt,
          sym,
          offset
        )
      end
    end
    return vptrarray
  end
  loopsym_ind = 0
  operations = Operation[]
  operation_mults = Int[]
  deleteat_inds = Int[]
  for (i, (m, s)) ∈ enumerate(mult_syms)
    if s ∈ ls.loopsymbols
      if loopsym_ind == 0
        loopsym_ind = i
        push!(deleteat_inds, loopsym_ind)
      else
        push!(operations, add_loopvalue!(ls, s, sizeof(Int)))
        push!(deleteat_inds, i)
        push!(operation_mults, m)
      end
    else
      sop = get(ls.opdict, s, nothing)
      if sop === nothing
        push!(deleteat_inds, i)
        vptrarray = gesp_const_offset!(
          ls,
          vptrarray,
          ninds,
          indices,
          loopedindex,
          m,
          s,
          D
        )
      elseif isconstant(sop)
        push!(deleteat_inds, i)
        vptrarray = gesp_const_offset!(
          ls,
          vptrarray,
          ninds,
          indices,
          loopedindex,
          m,
          name(sop),
          D
        )
      else
        # @show sop
        # if instruction(sop).instr === :sub_fast
        #   if length(parents(sop)) == 1
        #     sub1 = parents(sop)[1]
        #   elseif length(parents(op)) == 2
        #     sub1 = parents(sop)[1]
        #     sub2 = parents(sop)[2]
        #     if isloopvalue(sub1)
        #     elseif isloopvalue(sub2)
        #       @show sub2
        #     end
        #   end
        # elseif instruction(op).instr === :add_fast
        # end
        push!(operations, getop(ls, s, 8))
        push!(operation_mults, m)
        push!(deleteat_inds, i)
      end
    end
  end
  if (length(operations) > 0) & (loopsym_ind > 0) # turn into an operation
    _m, _s = mult_syms[loopsym_ind]
    push!(operations, add_loopvalue!(ls, _s, sizeof(Int)))
    push!(operation_mults, _m)
  end
  if length(operations) == 0
    if loopsym_ind == 0
      addconstindex!(indices, offsets, strides, loopedindex, offset)
    else
      mlt, sym = mult_syms[loopsym_ind]
      _addoffset!(
        indices,
        offsets,
        strides,
        loopedindex,
        loopdependencies,
        sym,
        offset,
        mlt
      )
    end
    deleteat!(mult_syms, deleteat_inds)
    return gesp_const_offsets!(
      ls,
      vptrarray,
      ninds,
      indices,
      loopedindex,
      mult_syms,
      D
    )
  end
  deleteat!(mult_syms, deleteat_inds)
  vptrarray = gesp_const_offsets!(
    ls,
    vptrarray,
    ninds,
    indices,
    loopedindex,
    mult_syms,
    D
  )
  if length(operations) == 1
    _mlt = only(operation_mults)
    indop = muladd_op!(
      ls,
      Core.ifelse(byterepresentable(_mlt), 1, _mlt),
      only(operations),
      0
    )
    addopindex!(
      opparents,
      loopdependencies,
      reduceddeps,
      indices,
      offsets,
      strides,
      loopedindex,
      indop,
      Core.ifelse(byterepresentable(_mlt), _mlt % Int8, one(Int8)),
      offset % Int8
    )
  else
    mlt1ind = findfirst(isone, operation_mults)
    opbase = if mlt1ind === nothing # if none of them have a multiplier of `1`, pick the base arbtirarility
      muladd_op!(ls, pop!(operation_mults), pop!(operations), 0)
    else # otherwise, we start accumulating with a 1-multiplier.
      deleteat!(operation_mults, mlt1ind)
      popat!(operations, mlt1ind)
    end
    for i ∈ eachindex(operations)
      _op = operations[i]
      _mlt = operation_mults[i]
      opbase = if _mlt == -1
        add_compute!(
          ls,
          gensym!(ls, "indexaccum"),
          instruction(:(-)),
          [opbase, _op],
          sizeof(Int)
        )
      elseif _mlt == 1
        add_compute!(
          ls,
          gensym!(ls, "indexaccum"),
          instruction(:(+)),
          [opbase, _op],
          sizeof(Int)
        )
      else
        add_compute!(
          ls,
          gensym!(ls, "indexaccum"),
          instruction(:muladd),
          [add_constant!(ls, _mlt, sizeof(Int)), _op, opbase],
          sizeof(Int)
        )
      end
    end
    addopindex!(
      opparents,
      loopdependencies,
      reduceddeps,
      indices,
      offsets,
      strides,
      loopedindex,
      opbase,
      one(Int8),
      offset % Int8
    )
  end
  return vptrarray
end

function move_to_last!(x, i)
  i == length(x) && return
  xᵢ = x[i]
  deleteat!(x, i)
  push!(x, xᵢ)
  nothing
end
# TODO: Make this work with Cartesian Indices
function repeated_index!(
  ls::LoopSet,
  indices::Vector{Symbol},
  vptr::Symbol,
  indnum::Int,
  firstind::Int
)
  # Move ind to last position
  vptrrepremoved =
    Symbol(vptr, "##ind##", firstind, "##repeated##", indnum, "##")
  f = Expr(
    :(.),
    Expr(:(.), :LoopVectorization, QuoteNode(:VectorizationBase)),
    QuoteNode(:double_index)
  )
  fiv = Expr(:call, Expr(:curly, :Val, firstind - 1))
  siv = Expr(:call, Expr(:curly, :Val, indnum - 1))
  pushpreamble!(ls, Expr(:(=), vptrrepremoved, Expr(:call, f, vptr, fiv, siv)))
  vptrrepremoved
end

function array_reference_meta!(
  ls::LoopSet,
  array::Symbol,
  rawindices,
  elementbytes::Int,
  var::Union{Nothing,Symbol} = nothing
)
  vptrarray = vptr(array)
  add_vptr!(ls, array, vptrarray) # now, subset
  indices = Symbol[]
  offsets = Int8[]
  strides = Int8[]
  loopedindex = Bool[]
  parents = Operation[]
  loopdependencies = Symbol[]
  reduceddeps = Symbol[]
  loopset = ls.loopsymbols
  ninds = 1
  D = length(rawindices)
  for ind ∈ rawindices
    if ind isa Integer # subset
      if byterepresentable(ind)
        addconstindex!(indices, offsets, strides, loopedindex, ind)
        ninds += 1
      else
        # convert ind to reduce invalidations
        vptrarray = subset_vptr!(
          ls,
          vptrarray,
          ninds,
          convert(Int, ind),
          indices,
          loopedindex,
          0
        )
        length(indices) == 0 && push!(indices, DISCONTIGUOUS)
      end
    elseif ind isa Expr
      #FIXME: position (in loopnest) wont be length(ls.loopsymbols) in general
      vptrarray = checkforoffset!(
        ls,
        vptrarray,
        ninds,
        parents,
        indices,
        offsets,
        strides,
        loopedindex,
        loopdependencies,
        reduceddeps,
        ind,
        D
      )
      ninds += 1
    elseif ind isa Symbol
      if ind ∈ loopset
        ind_prev_index = findfirst(Base.Fix2(===, ind), indices)
        if ind_prev_index === nothing
          push!(indices, ind)
          ninds += 1
          push!(offsets, zero(Int8))
          push!(strides, one(Int8))
          push!(loopedindex, true)
          push!(loopdependencies, ind)
        else
          move_to_last!(indices, ind_prev_index)
          move_to_last!(offsets, ind_prev_index)
          move_to_last!(strides, ind_prev_index)
          move_to_last!(loopedindex, ind_prev_index)
          if length(loopdependencies) == length(indices)
            move_to_last!(loopdependencies, ind_prev_index)
          else
            move_to_last!(
              loopdependencies,
              findfirst(Base.Fix2(===, ind), loopdependencies)::Int
            )
          end
          vptrarray = repeated_index!(
            ls,
            indices,
            vptrarray,
            ninds,
            ind_prev_index - (first(indices) === DISCONTIGUOUS)
          )
          makediscontiguous!(indices)
        end
      else
        indop = get(ls.opdict, ind, nothing)
        if indop !== nothing && !isconstant(indop)
          if iscompute(indop) &&
             Base.sym_in(instruction(indop).instr, (:add_fast, :sub_fast))
            vptrarray = add_additive_index!(
              ls,
              parents,
              vptrarray,
              ind,
              indop,
              ninds,
              indices,
              offsets,
              strides,
              loopedindex,
              loopdependencies,
              reduceddeps,
              0,
              1,
              D
            )
            ninds += 1
          else
            pushparent!(parents, loopdependencies, reduceddeps, indop)
            push!(indices, name(indop))
            ninds += 1
            push!(offsets, zero(Int8))
            push!(strides, one(Int8))
            push!(loopedindex, false)
          end
        else
          vptrarray =
            subset_vptr!(ls, vptrarray, ninds, ind, indices, loopedindex, 0)
          length(indices) == 0 && push!(indices, DISCONTIGUOUS)
        end
      end
    else
      throw("Unrecognized loop index: $ind.")
    end
  end
  mref = ArrayReferenceMeta(
    ArrayReference(array, indices, offsets, strides),
    loopedindex,
    vptrarray
  )
  ArrayReferenceMetaPosition(
    mref,
    parents,
    loopdependencies,
    reduceddeps,
    var === nothing ? Symbol("") : var
  )
end
function tryrefconvert(
  ls::LoopSet,
  ex::Expr,
  elementbytes::Int,
  var::Union{Nothing,Symbol} = nothing
)::Tuple{Bool,ArrayReferenceMetaPosition}
  ya, yinds = if ex.head === :ref
    ref_from_ref!(ls, ex)
  elseif ex.head === :call
    f = first(ex.args)
    if f === :getindex
      ref_from_getindex!(ls, ex)
    elseif f === :setindex!
      ref_from_setindex!(ls, ex)
    else
      return false, NOTAREFERENCEMP
    end
  else
    return false, NOTAREFERENCEMP
  end
  true, array_reference_meta!(ls, ya, yinds, elementbytes, var)
end

@testset "map" begin
  @inline foo(x, y) = exp(x) - sin(y)
  for T ∈ (Float32, Float64)
    @show T, @__LINE__
    for N ∈ [3, 371]
      a = rand(T, N)
      b = rand(T, N)
      c1 = map(foo, a, b)
      c2 = vmap(foo, a, b)
      @test c1 ≈ c2
      c2 = vmapt(foo, a, b)
      @test c1 ≈ c2
      c2 = vmapnt(foo, a, b)
      @test c1 ≈ c2
      fill!(c2, NaN)
      @views vmapnt!(foo, c2[2:end], a[2:end], b[2:end])
      @test @views c1[2:end] ≈ c2[2:end]
      # sleep(1e-3) # non-temporal stores won't be automatically synced/coherant, so need to wait!
      c0 = vmapntt(foo, a, b)
      c3 = similar(c0) # not aligned
      fill!(c3, NaN)
      @views vmapntt!(foo, c3[2:end], a[2:end], b[2:end])
      @test c0 ≈ c1
      @test isnan(c3[begin])
      @test @views c1[2:end] ≈ c3[2:end]
    end

    c = rand(T, 100)
    x = rand(T, 10^4)
    y1 = similar(x)
    y2 = similar(x)
    map!(xᵢ -> clenshaw(xᵢ, c), y1, x)
    vmap!(xᵢ -> clenshaw(xᵢ, c), y2, x)
    @test y1 ≈ y2
    @test vmap(>(T(0.5)), c) == map(>(T(0.5)), c)
  end
  @test vmap(abs2, 1:100) == map(abs2, 1:100)
  @test vmapt(abs2, 1:3:10000) == map(abs2, 1:3:10000)
  @test vmapt(abs2, 1.0:3.0:10000.0) ≈ map(abs2, 1.0:3.0:10000.0)

  for n = -64:64
    let x = rand(UInt8, (1 << 14) + n)
      @test count(==(UInt8('\n')), x) == vcount(==(UInt8('\n')), x)
    end
    let y = rand(Bool, (1 << 14) + n)
      @test vcount(y) == vcount(identity, y) == count(y)
    end
  end
end

function maybeaddref!(ls::LoopSet, op::Operation)
  ref = op.ref
  id = findfirst(==(ref), ls.refs_aliasing_syms)
  # try to CSE
  if id === nothing
    push!(ls.syms_aliasing_refs, name(op))
    push!(ls.refs_aliasing_syms, ref)
    0
  else
    id
  end
end

function add_load!(ls::LoopSet, op::Operation, actualarray::Bool = true)
  @assert isload(op)
  if (id = maybeaddref!(ls, op)) > 0 # try to CSE
    opp = ls.opdict[ls.syms_aliasing_refs[id]]
    op_inds = getindicesonly(op)
    li = op.ref.loopedindex
    allmatch = true
    parents_op = parents(op)
    parents_opp = parents(opp)
    for i ∈ eachindex(op_inds)
      li[i] && continue
      ind = op_inds[i]
      if (id_op = parentind(ind, op)) > 0
        if (id_opp = parentind(ind, opp)) > 0
          if !matches(parents_op[id_op], parents_opp[id_opp])
            allmatch = false
            break
          end
        end
      end
    end
    if allmatch
      opp = isstore(opp) ? first(parents(opp)) : opp
      ls.opdict[name(op)] = opp
      return opp
    end
  end
  add_vptr!(ls, op.ref.ref.array, vptr(op), actualarray)
  pushop!(ls, op, name(op))
end

function add_load!(
  ls::LoopSet,
  var::Symbol,
  array::Symbol,
  rawindices,
  elementbytes::Int
)
  mpref = array_reference_meta!(ls, array, rawindices, elementbytes, var)
  add_load!(ls, mpref, elementbytes)
end
function load_is_constant(mpref::ArrayReferenceMetaPosition)
  li = mpref.mref.loopedindex
  inds = getindicesonly(mpref)
  for i ∈ eachindex(li)
    li[i] && return false
    if (id = parentind(inds[i], mpref)) > 0
      isinitializedconst(parents(mpref)[id]) || return false
    end
  end
  true
end
function add_load!(
  ls::LoopSet,
  mpref::ArrayReferenceMetaPosition,
  elementbytes::Int
)
  if length(mpref.loopdependencies) == 0 || load_is_constant(mpref)
    return add_constant!(ls, mpref, elementbytes)
  end
  op = Operation(ls, varname(mpref), elementbytes, :getindex, memload, mpref)
  add_load!(ls, op, true)
end

# for use with broadcasting
function add_simple_load!(
  ls::LoopSet,
  var::Symbol,
  ref::ArrayReference,
  elementbytes::Int,
  actualarray::Bool = true
)
  loopdeps = copy(getindicesonly(ref))
  mref = ArrayReferenceMeta(ref, fill(true, length(loopdeps)))
  add_simple_load!(ls, var, mref, loopdeps, elementbytes, actualarray)
end
function add_simple_load!(
  ls::LoopSet,
  var::Symbol,
  mref::ArrayReferenceMeta,
  loopdeps::Vector{Symbol},
  elementbytes::Int,
  actualarray::Bool = true
)
  op = Operation(
    length(operations(ls)),
    var,
    elementbytes,
    :getindex,
    memload,
    loopdeps,
    NODEPENDENCY,
    NOPARENTS,
    mref
  )
  add_vptr!(ls, op.ref.ref.array, vptr(op), actualarray)
  pushop!(ls, op, var)
end
function add_load_ref!(ls::LoopSet, var::Symbol, ex::Expr, elementbytes::Int)
  array, rawindices = ref_from_ref!(ls, ex)
  add_load!(ls, var, array, rawindices, elementbytes)
end
function add_load_getindex!(
  ls::LoopSet,
  var::Symbol,
  ex::Expr,
  elementbytes::Int
)
  array, rawindices = ref_from_getindex!(ls, ex)
  add_load!(ls, var, array, rawindices, elementbytes)
end

function add_loopvalue!(ls::LoopSet, arg::Symbol, elementbytes::Int)
  # check for CSE opportunity
  instr = Instruction(arg, arg)
  for op ∈ operations(ls)#check to CSE
    (op.variable === arg && instr == instruction(op)) && return op
  end
  op = Operation(
    length(operations(ls)),
    arg,
    elementbytes,
    instr,
    loopvalue,
    [arg]
  )
  pushop!(ls, op, arg)
end

# pkgdir(pkg::String) = abspath(joinpath(dirname(Base.find_package(pkg)), ".."))
# const LOOPVECBENCHDIR = joinpath(pkgdir("LoopVectorization"), "benchmarks")
# includet(joinpath(LOOPVECBENCHDIR, "driver.jl"))

using Distributed, LoopVectorization, JLD2, ProgressMeter
const LOOPVECBENCHDIR = joinpath(pkgdir(LoopVectorization), "benchmark")
include(joinpath(LOOPVECBENCHDIR, "benchmarkflops.jl"))
include(joinpath(LOOPVECBENCHDIR, "plotbenchmarks.jl"))

nprocs_to_add() = ((Sys.CPU_THREADS)::Int >> 1)
# nprocs_to_add() = ((Sys.CPU_THREADS)::Int >> 1) - 1
start_worker(wid) =
  remotecall(include, wid, joinpath(LOOPVECBENCHDIR, "setup_worker.jl"))
function start_workers(nprocs = nprocs_to_add())
  addprocs(nprocs; exeflags = "--project=$(Base.active_project())")
  foreach(wait, map(start_worker, workers()))
end
stop_workers() = rmprocs(workers())

function blastests()
  tests = ["LoopVectorization", "Julia", "Clang", "GFortran"]
  INTEL_BENCH && push!(tests, "icc", "ifort")
  push!(
    tests,
    "g++ & Eigen-3",
    "clang++ & Eigen-3",
    "GFortran-builtin",
    "OpenBLAS"
  )
  INTEL_BENCH && push!(tests, "ifort-builtin")
  MKL_BENCH && push!(tests, "MKL")
  tests
end
function benchmark_AmulB(sizes)
  tests = blastests()
  start_workers(nprocs_to_add() >> 1)
  sm = SharedMatrix(Matrix{Float64}(undef, length(tests), length(sizes)))
  @showprogress pmap(is -> A_mul_B_bench!(sm, is[2], is[1]), enumerate(sizes))
  br = BenchmarkResult(Matrix(sm), tests, sizes)
  stop_workers()
  br
end
function benchmark_AmulBt(sizes)
  tests = blastests()
  start_workers(nprocs_to_add() >> 1)
  sm = SharedMatrix(Matrix{Float64}(undef, length(tests), length(sizes)))
  @showprogress pmap(is -> A_mul_Bt_bench!(sm, is[2], is[1]), enumerate(sizes))
  br = BenchmarkResult(Matrix(sm), tests, sizes)
  stop_workers()
  br
end
function benchmark_AtmulB(sizes)
  tests = blastests()
  start_workers(nprocs_to_add() >> 1)
  sm = SharedMatrix(Matrix{Float64}(undef, length(tests), length(sizes)))
  @showprogress pmap(is -> At_mul_B_bench!(sm, is[2], is[1]), enumerate(sizes))
  br = BenchmarkResult(Matrix(sm), tests, sizes)
  stop_workers()
  br
end
function benchmark_AtmulBt(sizes)
  tests = blastests()
  start_workers(nprocs_to_add() >> 1)
  sm = SharedMatrix(Matrix{Float64}(undef, length(tests), length(sizes)))
  @showprogress pmap(is -> At_mul_Bt_bench!(sm, is[2], is[1]), enumerate(sizes))
  br = BenchmarkResult(Matrix(sm), tests, sizes)
  stop_workers()
  br
end
function dot_tests()
  tests = ["LoopVectorization", "Julia", "Clang", "GFortran"]
  INTEL_BENCH && push!(tests, "icc", "ifort")
  push!(tests, "g++ & Eigen-3", "clang++ & Eigen-3")
  tests
end
function benchmark_dot(sizes)
  tests = dot_tests()
  start_workers()
  sm = SharedMatrix(Matrix{Float64}(undef, length(tests), length(sizes)))
  @showprogress pmap(is -> dot_bench!(sm, is[2], is[1]), enumerate(sizes))
  br = BenchmarkResult(Matrix(sm), tests, sizes)
  stop_workers()
  br
end
function benchmark_selfdot(sizes)
  tests = dot_tests()
  start_workers()
  sm = SharedMatrix(Matrix{Float64}(undef, length(tests), length(sizes)))
  @showprogress pmap(is -> selfdot_bench!(sm, is[2], is[1]), enumerate(sizes))
  br = BenchmarkResult(Matrix(sm), tests, sizes)
  stop_workers()
  br
end
function benchmark_Amulvb(sizes)
  tests = blastests()
  start_workers()
  sm = SharedMatrix(Matrix{Float64}(undef, length(tests), length(sizes)))
  @showprogress pmap(is -> A_mul_vb_bench!(sm, is[2], is[1]), enumerate(sizes))
  br = BenchmarkResult(Matrix(sm), tests, sizes)
  stop_workers()
  br
end
function benchmark_Atmulvb(sizes)
  tests = blastests()
  start_workers()
  sm = SharedMatrix(Matrix{Float64}(undef, length(tests), length(sizes)))
  @showprogress pmap(is -> At_mul_vb_bench!(sm, is[2], is[1]), enumerate(sizes))
  br = BenchmarkResult(Matrix(sm), tests, sizes)
  stop_workers()
  br
end
function benchmark_dot3(sizes)
  tests = ["LoopVectorization", "Julia", "Clang", "GFortran"]
  INTEL_BENCH && push!(tests, "icc", "ifort")
  push!(tests, "g++ & Eigen-3", "clang++ & Eigen-3", "LinearAlgebra")
  start_workers()
  sm = SharedMatrix(Matrix{Float64}(undef, length(tests), length(sizes)))
  @showprogress pmap(is -> dot3_bench!(sm, is[2], is[1]), enumerate(sizes))
  br = BenchmarkResult(Matrix(sm), tests, sizes)
  stop_workers()
  br
end
function benchmark_sse(sizes)
  tests = ["LoopVectorization", "Julia", "Clang", "GFortran"]
  INTEL_BENCH && push!(tests, "icc", "ifort")
  push!(tests, "g++ & Eigen-3", "clang++ & Eigen-3")
  MKL_BENCH && push!(tests, "MKL")

  start_workers()
  sm = SharedMatrix(Matrix{Float64}(undef, length(tests), length(sizes)))
  @showprogress pmap(is -> sse_bench!(sm, is[2], is[1]), enumerate(sizes))
  br = BenchmarkResult(Matrix(sm), tests, sizes)
  stop_workers()
  br
end
function benchmark_exp(sizes)
  tests = ["LoopVectorization", "Julia", "Clang", "GFortran"]
  INTEL_BENCH && push!(tests, "icc", "ifort")
  start_workers()
  sm = SharedMatrix(Matrix{Float64}(undef, length(tests), length(sizes)))
  @showprogress pmap(is -> exp_bench!(sm, is[2], is[1]), enumerate(sizes))
  br = BenchmarkResult(Matrix(sm), tests, sizes)
  stop_workers()
  br
end
function benchmark_aplusBc(sizes)
  tests = ["LoopVectorization", "Julia", "Clang", "GFortran"]
  INTEL_BENCH && push!(tests, "icc", "ifort")
  push!(tests, "g++ & Eigen-3", "clang++ & Eigen-3")
  start_workers()
  sm = SharedMatrix(Matrix{Float64}(undef, length(tests), length(sizes)))
  @showprogress pmap(is -> aplusBc_bench!(sm, is[2], is[1]), enumerate(sizes))
  br = BenchmarkResult(Matrix(sm), tests, sizes)
  stop_workers()
  br
end
function benchmark_AplusAt(sizes)
  tests = ["LoopVectorization", "Julia", "Clang", "GFortran"]
  INTEL_BENCH && push!(tests, "icc", "ifort")
  push!(tests, "g++ & Eigen-3", "clang++ & Eigen-3", "GFortran-builtin")
  INTEL_BENCH && push!(tests, "ifort-builtin")
  start_workers()
  sm = SharedMatrix(Matrix{Float64}(undef, length(tests), length(sizes)))
  @showprogress pmap(is -> AplusAt_bench!(sm, is[2], is[1]), enumerate(sizes))
  br = BenchmarkResult(Matrix(sm), tests, sizes)
  stop_workers()
  br
end
function benchmark_random_access(sizes)
  tests = ["LoopVectorization", "Julia", "Clang", "GFortran"]
  INTEL_BENCH && push!(tests, "icc", "ifort")
  start_workers()
  sm = SharedMatrix(Matrix{Float64}(undef, length(tests), length(sizes)))
  @showprogress pmap(
    is -> randomaccess_bench!(sm, is[2], is[1]),
    enumerate(sizes)
  )
  br = BenchmarkResult(Matrix(sm), tests, sizes)
  stop_workers()
  br
end
function benchmark_logdettriangle(sizes)
  # tests = ["LoopVectorization", "Julia", "Clang", "GFortran", "icc", "ifort", "g++ & Eigen-3", "clang++ & Eigen-3", "LinearAlgebra"]
  tests = ["LoopVectorization", "Julia", "Clang", "GFortran"]
  INTEL_BENCH && push!(tests, "icc", "ifort")
  push!(tests, "LinearAlgebra")
  start_workers()
  sm = SharedMatrix(Matrix{Float64}(undef, length(tests), length(sizes)))
  @showprogress pmap(
    is -> logdettriangle_bench!(sm, is[2], is[1]),
    enumerate(sizes)
  )
  br = BenchmarkResult(Matrix(sm), tests, sizes)
  stop_workers()
  br
end
function benchmark_filter2d(sizes, K)
  tests = ["LoopVectorization", "Julia", "Clang", "GFortran"]
  INTEL_BENCH && push!(tests, "icc", "ifort")
  start_workers()
  sm = SharedMatrix(Matrix{Float64}(undef, length(tests), length(sizes)))
  @showprogress pmap(
    is -> filter2d_bench_run!(sm, is[2], is[1], K),
    enumerate(sizes)
  )
  br = BenchmarkResult(Matrix(sm), tests, sizes)
  stop_workers()
  br
end
function benchmark_filter2ddynamic(sizes)
  K = OffsetArray(rand(Float64, 3, 3), -1:1, -1:1)
  benchmark_filter2d(sizes, K)
end
function benchmark_filter2d3x3(sizes)
  K = SizedOffsetMatrix{Float64,-1,1,-1,1}(rand(3, 3))
  benchmark_filter2d(sizes, K)
end
function benchmark_filter2dunrolled(sizes)
  tests = ["LoopVectorization", "Julia", "Clang", "GFortran"]
  INTEL_BENCH && push!(tests, "icc", "ifort")
  start_workers()
  sm = SharedMatrix(Matrix{Float64}(undef, length(tests), length(sizes)))
  K = SizedOffsetMatrix{Float64,-1,1,-1,1}(rand(3, 3))
  @showprogress pmap(
    is -> filter2dunrolled_bench_run!(sm, is[2], is[1], K),
    enumerate(sizes)
  )
  br = BenchmarkResult(Matrix(sm), tests, sizes)
  stop_workers()
  br
end

# sizes = 23:23
sizes = 256:-1:2
longsizes = 1024:-1:2

println("logdet(LowerTriangular(A)) benchmark results:");
logdettriangle_bench = benchmark_logdettriangle(sizes);
println(logdettriangle_bench);
println("x' * A * y benchmark results:");
dot3_bench = benchmark_dot3(sizes);
println(dot3_bench);

println("A * B benchmark results:");
AmulB_bench = benchmark_AmulB(sizes);
println(AmulB_bench);
println("A * B' benchmark results:");
AmulBt_bench = benchmark_AmulBt(sizes);
println(AmulBt_bench);
println("A' * B' benchmark results:");
AtmulBt_bench = benchmark_AtmulBt(sizes);
println(AtmulBt_bench);
println("A' * B benchmark results:");
AtmulB_bench = benchmark_AtmulB(sizes);
println(AtmulB_bench);

println("A * b benchmark results:");
Amulvb_bench = benchmark_Amulvb(sizes);
println(Amulvb_bench);
println("A' * b benchmark results:");
Atmulvb_bench = benchmark_Atmulvb(sizes);
println(Atmulvb_bench);

println("a' * b benchmark results:");
dot_bench = benchmark_dot(longsizes);
println(dot_bench);
println("a' * a benchmark results:");
selfdot_bench = benchmark_selfdot(longsizes);
println(selfdot_bench);

println("Benchmark results of a .+ B .* c':");
aplusBc_bench = benchmark_aplusBc(sizes);
println(aplusBc_bench);
println("Benchmark results of A .+ A':");
AplusAt_bench = benchmark_AplusAt(sizes);
println(AplusAt_bench);

println("Benchmark results for dynamically sized 3x3 convolution:");
filter2d_dynamic_bench = benchmark_filter2ddynamic(sizes);
println(filter2d_dynamic_bench);
println("Benchmark results for statically sized 3x3 convolution:");
filter2d_3x3_bench = benchmark_filter2d3x3(sizes);
println(filter2d_3x3_bench);
println("Benchmark results for unrolled 3x3 convolution:");
filter2d_unrolled_bench = benchmark_filter2dunrolled(sizes);
println(filter2d_unrolled_bench);

println("Benchmark resutls of summing squared error:");
sse_bench = benchmark_sse(sizes);
println(sse_bench);
println("Benchmark results of exponentiating a vector:");
vexp_bench = benchmark_exp(sizes);
println(vexp_bench);
println("Benchmark results from using a vector of indices:");
randomaccess_bench = benchmark_random_access(sizes);
println(randomaccess_bench);

const v = 2
# using Cairo, Fontconfig
const PICTURES = joinpath(pkgdir(LoopVectorization), "docs", "src", "assets")
# saveplot(f, br) = draw(PNG(joinpath(PICTURES, f * "$v.png"), 12inch, 8inch), plot(br))
saveplot(f, br) =
  draw(SVG(joinpath(PICTURES, f * "$v.svg"), 12inch, 8inch), plot(br))

# If only rerunning a few, remove them from load.
# @load "benchmarkresults.jld2" logdettriangle_bench filter2d_dynamic_bench filter2d_3x3_bench filter2d_unrolled_bench dot_bench selfdot_bench dot3_bench sse_bench aplusBc_bench AplusAt_bench vexp_bench randomaccess_bench AmulB_bench AmulBt_bench AtmulB_bench AtmulBt_bench Amulvb_bench Atmulvb_bench

saveplot("bench_dot3_v", dot3_bench);
saveplot("bench_dot_v", dot_bench);
saveplot("bench_selfdot_v", selfdot_bench);
saveplot("bench_sse_v", sse_bench);
saveplot("bench_aplusBc_v", aplusBc_bench);
saveplot("bench_AplusAt_v", AplusAt_bench);
saveplot("bench_AmulB_v", AmulB_bench);
saveplot("bench_AmulBt_v", AmulBt_bench);
saveplot("bench_AtmulB_v", AtmulB_bench);
saveplot("bench_AtmulBt_v", AtmulBt_bench);
saveplot("bench_Amulvb_v", Amulvb_bench);
saveplot("bench_Atmulvb_v", Atmulvb_bench);

saveplot("bench_logdettriangle_v", logdettriangle_bench);
saveplot("bench_filter2d_dynamic_v", filter2d_dynamic_bench);
saveplot("bench_filter2d_3x3_v", filter2d_3x3_bench);
saveplot("bench_filter2d_unrolled_v", filter2d_unrolled_bench);
saveplot("bench_exp_v", vexp_bench);
saveplot("bench_random_access_v", randomaccess_bench);

@save "benchmarkresults.jld2" logdettriangle_bench filter2d_dynamic_bench filter2d_3x3_bench filter2d_unrolled_bench dot_bench selfdot_bench dot3_bench sse_bench aplusBc_bench AplusAt_bench vexp_bench randomaccess_bench AmulB_bench AmulBt_bench AtmulB_bench AtmulBt_bench Amulvb_bench Atmulvb_bench

using LoopVectorization, OffsetArrays
using Test

@testset "dot" begin
  dotq = :(
    for i ∈ eachindex(a, b)
      s += a[i] * b[i]
    end
  )
  lsdot = LoopVectorization.loopset(dotq)
  @test LoopVectorization.choose_order(lsdot) ==
        (Symbol[:i], :i, Symbol("##undefined##"), :i, 4, -1)
  function mydot(a::AbstractVector, b::AbstractVector)
    s = zero(eltype(a))
    za = OffsetArray(a, OffsetArrays.Origin(0))
    zb = OffsetArray(b, OffsetArrays.Origin(0))
    @inbounds @simd for i ∈ LoopVectorization.CloseOpen(min(length(a), length(b)))
      s += za[i] * zb[i]
    end
    s
  end
  function mydotavx(a::AbstractVector, b::AbstractVector)
    s = zero(eltype(a))
    za = OffsetArray(a, OffsetArrays.Origin(0))
    zb = OffsetArray(b, OffsetArrays.Origin(0))
    @turbo for i ∈ LoopVectorization.CloseOpen(min(length(a), length(b)))
      s += za[i] * zb[i]
    end
    s
  end
  @test LoopVectorization.ArrayInterface.static_step(
    LoopVectorization.CloseOpen(-5, 10),
  ) === LoopVectorization.One()
  function mydot(a, b)
    s = zero(eltype(a))
    @inbounds @simd for i ∈ eachindex(a, b)
      s += a[i] * b[i]
    end
    s
  end
  function mydotavx(a, b)
    s = zero(eltype(a))
    @turbo for i ∈ eachindex(a, b)
      s += a[i] * b[i]
    end
    s
  end

  function mydot_avx(a, b)
    s = zero(eltype(a))
    @_avx for i ∈ eachindex(a, b)
      aᵢ = getindex(a, i)
      s += aᵢ * b[i]
    end
    s
  end


  selfdotq = :(
    for i ∈ indices(a, 1)
      s += a[i] * a[i]
    end
  )
  lsselfdot = LoopVectorization.loopset(selfdotq)
  @test LoopVectorization.choose_order(lsselfdot) ==
        (Symbol[:i], :i, Symbol("##undefined##"), :i, 8, -1)

  function myselfdot(a)
    s = zero(eltype(a))
    @inbounds @simd for i ∈ eachindex(a)
      s += getindex(a, i) * a[i]
    end
    s
  end
  function myselfdotavx(a)
    s = zero(eltype(a))
    @turbo for i ∈ eachindex(a)
      s += a[i] * a[i]
    end
    s
  end
  function myselfdotavx_v2(a)
    s = zero(eltype(a))
    @turbo for i ∈ 1:length(a)
      s += a[i] * a[i]
    end
    s
  end
  function myselfdotavx_range(a)
    s = zero(eltype(a))
    rng = axes(a, 1)
    @turbo for i ∈ rng
      s += a[i] * a[i]
    end
    s
  end
  function myselfdot_avx(a)
    s = zero(eltype(a))
    @_avx for i ∈ eachindex(a)
      s += a[i] * a[i]
    end
    s
  end
  function dot_unroll2avx(x::Vector{T}, y::Vector{T}) where {T<:Number}
    z = zero(T)
    o = (3,)
    b = (3,)
    @turbo unroll = 2 for i ∈ 1:length(x)
      z += x[i] * y[i+o[1]-b[1]]
    end
    z
  end
  function dot_unroll3avx(x::Vector{T}, y::Vector{T}) where {T<:Number}
    z = zero(T)
    @turbo unroll = 3 for i ∈ 1:length(x)
      z += x[i] * y[i]
    end
    z
  end
  # @macroexpand @turbo inline=false unroll=2 for i ∈ 1:length(x)
  #         z += x[i]*y[i]
  #     end

  function dot_unroll2avx_noinline(x::Vector{T}, y::Vector{T}) where {T<:Number}
    z = zero(T)
    @turbo inline = true unroll = 2 for i ∈ 1:length(x)
      z += x[i] * y[i]
    end
    z
  end
  function dot_unroll3avx_inline(x::Vector{T}, y::Vector{T}) where {T<:Number}
    z = zero(T)
    @turbo unroll = 3 inline = true check_empty = true for i ∈ 1:length(x)
      z += x[i] * y[i]
    end
    z
  end
  function dot_unroll2_avx(x::Vector{T}, y::Vector{T}) where {T<:Number}
    z = zero(T)
    @_avx unroll = 2 for i ∈ 1:length(x)
      z += x[i] * y[i]
    end
    z
  end
  function dot_unroll3_avx(x::Vector{T}, y::Vector{T}) where {T<:Number}
    z = zero(T)
    @_avx unroll = 3 for i ∈ 1:length(x)
      z += x[i] * y[i]
    end
    z
  end
  function complex_dot_soa(
    xre::AbstractVector{T},
    xim::AbstractVector{T},
    yre::AbstractVector{T},
    yim::AbstractVector{T},
  ) where {T}
    zre = zero(T)
    zim = zero(T)
    @turbo for i ∈ 1:length(xre)
      zre += xre[i] * yre[i] - xim[i] * yim[i]
      zim += xre[i] * yim[i] + xim[i] * yre[i]
    end
    Complex{T}(zre, zim)
  end
  qc = :(
    for i ∈ 1:length(xre)
      zre += xre[i] * yre[i] - xim[i] * yim[i]
      zim += xre[i] * yim[i] + xim[i] * yre[i]
    end
  )
  lsc = LoopVectorization.loopset(qc)
  function complex_mul_with_index_offset!(c_re, c_im, a_re, a_im, b_re, b_im)
    @inbounds @simd ivdep for i = 1:length(a_re)-1
      c_re[i] = b_re[i] * a_re[i+1] - b_im[i] * a_im[i+1]
      c_im[i] = b_re[i] * a_im[i+1] + b_im[i] * a_re[i+1]
    end
  end
  function complex_mul_with_index_offsetavx!(c_re, c_im, a_re, a_im, b_re, b_im)
    @turbo for i = 1:length(a_re)-1
      c_re[i] = b_re[i] * a_re[i+1] - b_im[i] * a_im[i+1]
      c_im[i] = b_re[i] * a_im[i+1] + b_im[i] * a_re[i+1]
    end
  end
  function complex_mul_with_index_offset_avx!(c_re, c_im, a_re, a_im, b_re, b_im)
    @_avx for i = 1:length(a_re)-1
      c_re[i] = b_re[i] * a_re[i+1] - b_im[i] * a_im[i+1]
      setindex!(c_im, b_re[i] * a_im[i+1] + b_im[i] * a_re[i+1], i)
    end
  end
  # q = :(for i = 1:length(a_re) - 1
  #         c_re[i] = b_re[i] * a_re[i + 1] - b_im[i] * a_im[i + 1]
  #         c_im[i] = b_re[i] * a_im[i + 1] + b_im[i] * a_re[i + 1]
  #       end);
  # ls = LoopVectorization.loopset(q)

  function mcpi(x, y)
    acc = 0
    @inbounds @simd for i ∈ eachindex(x)
      acc += (x[i] * x[i] + y[i] * y[i]) < 1.0
    end
    4acc / length(x)
  end
  function mcpiavx(x, y)
    acc = 0
    @turbo for i ∈ eachindex(x)
      acc += (x[i] * x[i] + y[i] * y[i]) < 1.0
    end
    4acc / length(x)
  end
  function mcpiavx_u4(x, y)
    acc = 0
    @turbo unroll = 4 for i ∈ eachindex(x)
      acc += (x[i] * x[i] + y[i] * y[i]) < 1.0
    end
    4acc / length(x)
  end
  function mcpi_avx(x, y)
    acc = 0
    @_avx for i ∈ eachindex(x)
      acc += (x[i] * x[i] + y[i] * y[i]) < 1.0
    end
    4acc / length(x)
  end
  function mcpi_avx_u4(x, y)
    acc = 0
    @_avx unroll = 4 for i ∈ 1:length(x)
      acc += (x[i] * x[i] + y[i] * y[i]) < 1.0
    end
    4acc / length(x)
  end

  function dotloopinductvarpow(x::AbstractArray{T}) where {T}
    s = zero(T)
    for i ∈ eachindex(x)
      s += x[i] * T(i)^3
    end
    s
  end
  function dotloopinductvarpowavx(x)
    s = zero(eltype(x))
    @turbo for i ∈ eachindex(x)
      s += x[i] * i^3
    end
    s
  end
  function dot_from_n_to_100(a, b, n)
    s = zero(eltype(a))
    @turbo for i ∈ n:100
      s += a[i] * b[i]
    end
    s
  end
  function dot33(a, b)
    s = zero(eltype(a))
    @turbo for i ∈ 1:33
      s += a[i] * b[i]
    end
    s
  end
  function dot17(a, b)
    s = zero(eltype(a))
    @turbo for i ∈ 1:17
      s += a[i] * b[i]
    end
    s
  end
  # @macroexpand @_avx for i = 1:length(a_re) - 1
  #     c_re[i] = b_re[i] * a_re[i + 1] - b_im[i] * a_im[i + 1]
  #     c_im[i] = b_re[i] * a_im[i + 1] + b_im[i] * a_re[i + 1]
  # end

  # a = rand(400);
  for T ∈ (Float32, Float64, Int32, Int64)
    @show T, @__LINE__
    N = 143
    R = T <: Integer ? (T(-100):T(100)) : T
    a = rand(R, N)
    b = rand(R, N)
    ao = OffsetArray(a, -60:N-61)
    bo = OffsetArray(b, -60:N-61)
    s = mydot(a, b)
    @test mydotavx(a, b) ≈ s
    @test mydot_avx(a, b) ≈ s
    @test mydotavx(ao, bo) ≈ s
    @test mydot_avx(ao, bo) ≈ s
    @test dot_unroll2avx(a, b) ≈ s
    @test dot_unroll3avx(a, b) ≈ s
    @test dot_unroll2_avx(a, b) ≈ s
    @test dot_unroll3_avx(a, b) ≈ s
    @test dot_unroll2avx_noinline(a, b) ≈ s
    @test dot_unroll3avx_inline(a, b) ≈ s
    s = myselfdot(a)
    @test myselfdotavx(a) ≈ s
    @test myselfdotavx_v2(a) ≈ s
    @test myselfdotavx_range(a) ≈ s
    @test myselfdot_avx(a) ≈ s
    @test myselfdotavx(a) ≈ s

    A = OffsetArray(rand(T, 37, 61), -5, 10)
    s = myselfdot(A)
    @test myselfdotavx(A) ≈ myselfdotavx(A') ≈ s
    @test myselfdotavx_v2(A) ≈ myselfdotavx_v2(A') ≈ s
    # @test myselfdot_avx(A) ≈ myselfdot_avx(A') ≈ s

    @test dot17(a, b) ≈ @view(a[1:17])' * @view(b[1:17])
    @test dot33(a, b) ≈ @view(a[1:33])' * @view(b[1:33])

    if T <: Union{Float32,Float64}
      πest = mcpi(a, b)
      @test πest ≈ mcpiavx(a, b)
      @test πest ≈ mcpiavx_u4(a, b)
      @test πest ≈ mcpi_avx(a, b)
      @test πest ≈ mcpi_avx_u4(a, b)
    end

    if !(
      !Bool(LoopVectorization.VectorizationBase.has_feature(Val(:x86_64_avx2))) &&
      T === Int32
    )
      @test dotloopinductvarpow(a) ≈ dotloopinductvarpowavx(a)
    end
    @test dot_from_n_to_100(a, b, 33) == @views mydotavx(a[33:100], b[33:100])

    a_re = rand(R, N)
    a_im = rand(R, N)
    b_re = rand(R, N)
    b_im = rand(R, N)
    ac = Complex.(a_re, a_im)
    bc = Complex.(b_re, b_im)

    @test mydot(ac, bc) ≈ complex_dot_soa(a_re, a_im, b_re, b_im)

    c_re1 = similar(a_re)
    c_im1 = similar(a_im)
    c_re2 = similar(a_re)
    c_im2 = similar(a_im)
    # b_re = rand(R, length(a_re) + 1); b_im = rand(R, length(a_im) + 1);
    complex_mul_with_index_offset!(c_re1, c_im1, a_re, a_im, b_re, b_im)
    complex_mul_with_index_offsetavx!(c_re2, c_im2, a_re, a_im, b_re, b_im)
    c_re1v, c_im1v, c_re2v, c_im2v =
      @views c_re1[1:end-1], c_im1[1:end-1], c_re2[1:end-1], c_im2[1:end-1]
    @test c_re1v ≈ c_re2v
    @test c_im1v ≈ c_im2v
    fill!(c_re2, -999999)
    fill!(c_im2, 99999999)
    complex_mul_with_index_offset_avx!(c_re2, c_im2, a_re, a_im, b_re, b_im)
    @test c_re1v ≈ c_re2v
    @test c_im1v ≈ c_im2v

    # Float32 is not accurate enough
    # Alternatively, loosen approx requirement?
    R == Float32 && continue
    A = rand(R, N, N, N)
    B = rand(R, N, N, N)
    @test mydot(A, B) ≈ mydotavx(A, B)
    # test CartesianIndices
    for i ∈ [3, :, 1:N-1], j ∈ [5, :, 1:N-2], k ∈ [:, 1:N-3]
      Av = view(A, i, j, k)
      Bv = view(B, i, j, k)
      # @show i, j, k
      @test mydot(Av, Bv) ≈ mydotavx(Av, Bv)
    end
  end
end

const NOpsType = Int#Union{Int,Vector{Int}}

struct UpperBoundedInteger{N,T<:Base.BitInteger} <: Integer
  i::T
  @inline UpperBoundedInteger{N}(i::T) where {N,T<:Base.BitInteger} =
    new{N,T}(i)
end

@inline UpperBoundedInteger(i::T, ::StaticInt{N}) where {N,T<:Base.BitInteger} =
  UpperBoundedInteger{N}(i)
@inline UpperBoundedInteger(::StaticInt{M}, ::StaticInt{N}) where {N,M} =
  StaticInt{M}()
@inline UpperBoundedInteger{N}(::StaticInt{M}) where {N,M} = StaticInt{M}()
@inline Base.:(%)(
  a::UpperBoundedInteger,
  ::Type{T}
) where {T<:Base.BitInteger} = a.i % T
Base.promote_rule(
  ::Type{T},
  ::Type{UpperBoundedInteger{N,S}}
) where {N,T<:Base.BitInteger,S} = promote_rule(T, S)
Base.promote_rule(
  ::Type{UpperBoundedInteger{N,S}},
  ::Type{T}
) where {N,T<:Base.BitInteger,S} = promote_rule(S, T)
Base.promote_rule(
  ::Type{UpperBoundedInteger{N,T}},
  ::Type{T}
) where {N,T<:Base.BitInteger} = T
Base.convert(::Type{T}, i::UpperBoundedInteger) where {T<:Integer} =
  convert(T, i.i)
Base.convert(
  ::Type{UpperBoundedInteger{N,T}},
  i::UpperBoundedInteger{N,T}
) where {N,T<:Base.BitInteger} = i
upper_bound(_) = typemax(Int)
upper_bound(
  ::Type{CO}
) where {T,N,S,CO<:AbstractCloseOpen{T,UpperBoundedInteger{N,S}}} = N - 1

@inline Base.last(r::AbstractCloseOpen{<:Integer,<:UpperBoundedInteger}) =
  getfield(getfield(r, :upper), :i) - One()
@inline ArrayInterface.static_last(
  r::CloseOpen{<:Integer,<:UpperBoundedInteger}
) = getfield(getfield(r, :upper), :i) - One()
@inline Base.length(r::AbstractCloseOpen{<:Integer,<:UpperBoundedInteger}) =
  getfield(getfield(r, :upper), :i) - getfield(r, :start)
@inline Base.length(r::AbstractCloseOpen{Zero,<:UpperBoundedInteger}) =
  getfield(getfield(r, :upper), :i)

function Loop(ls::LoopSet, ex::Expr, sym::Symbol, f, s, l, ub::Int)
  if (f !== nothing) && (s !== nothing) && (l !== nothing)
    return static_loop(sym, f, s, l)
  end
  ssym = String(sym)
  rangesym = gensym(ssym * "_loop")
  lensym = gensym(ssym * "_looplen")
  pushpreamble!(ls, Expr(:(=), rangesym, ex))
  pushpreamble!(
    ls,
    Expr(
      :(=),
      lensym,
      Expr(:call, GlobalRef(ArrayInterface, :static_length), rangesym)
    )
  )
  F = if f === nothing
    start = gensym(ssym * "_loopstart")
    pushpreamble!(
      ls,
      Expr(:(=), start, Expr(:call, %, Expr(:call, lv(:first), rangesym), Int))
    )
    MaybeKnown(start, 1)
  else
    MaybeKnown(f)
  end
  S = if s === nothing
    step = gensym(ssym * "_loopstep")
    pushpreamble!(
      ls,
      Expr(:(=), step, Expr(:call, %, Expr(:call, lv(:step), rangesym), Int))
    )
    MaybeKnown(step, 1)
  else
    MaybeKnown(s)
  end
  L = if l === nothing
    stop = gensym(ssym * "_loopstop")
    pushpreamble!(
      ls,
      Expr(:(=), stop, Expr(:call, %, Expr(:call, lv(:last), rangesym), Int))
    )
    MaybeKnown(stop, min(ub, 1024))
  else
    MaybeKnown(l)
  end
  loopiteratesatleastonce!(ls, Loop(sym, F, L, S, rangesym, lensym))
end
function Loop(
  ls::LoopSet,
  ex::Expr,
  sym::Symbol,
  ::Type{R}
) where {R<:AbstractRange}
  f = ArrayInterface.known_first(R)
  s = ArrayInterface.known_step(R)
  l = ArrayInterface.known_last(R)
  ub = upper_bound(R)
  Loop(ls, ex, sym, f, s, l, ub)
end

function static_loop(sym::Symbol, L::Int, S::Int, U::Int)
  Loop(
    sym,
    MaybeKnown(L, 0),
    MaybeKnown(U, 0),
    MaybeKnown(S, 0),
    Symbol(""),
    Symbol("")
  )
end
function Loop(
  ::LoopSet,
  ::Expr,
  sym::Symbol,
  ::Type{OptionallyStaticUnitRange{StaticInt{L},StaticInt{U}}}
) where {L,U}
  static_loop(sym, L, 1, U)
end
function Loop(
  ::LoopSet,
  ::Expr,
  sym::Symbol,
  ::Type{
    ArrayInterface.OptionallyStaticStepRange{
      StaticInt{L},
      StaticInt{S},
      StaticInt{U}
    }
  }
) where {L,S,U}
  static_loop(sym, L, S, U)
end
function Loop(
  ::LoopSet,
  ::Expr,
  sym::Symbol,
  ::Type{CO}
) where {L,U,CO<:AbstractCloseOpen{StaticInt{L},StaticInt{U}}}
  static_loop(sym, L, 1, U - 1)
end

extract_loop(l) = Expr(:call, getfield, Symbol("#loop#bounds#"), l)

function add_loops!(ls::LoopSet, LPSYM, LB)
  n = max(length(LPSYM), length(LB))
  for i = 1:n
    sym, l = LPSYM[i], LB[i]
    if l <: CartesianIndices
      add_loops!(ls, i, sym, l)
    else
      add_loop!(ls, Loop(ls, extract_loop(i), sym, l)::Loop)
      push!(ls.loopsymbol_offsets, ls.loopsymbol_offsets[end] + 1)
    end
  end
end
function add_loops!(
  ls::LoopSet,
  i::Int,
  sym::Symbol,
  @nospecialize(l::Type{<:CartesianIndices})
)
  N, T = l.parameters
  ssym = String(sym)
  for k = N:-1:1
    axisexpr =
      :($getfield($getfield($getfield(var"#loop#bounds#", $i), :indices), $k))
    add_loop!(
      ls,
      Loop(
        ls,
        axisexpr,
        Symbol(ssym * '#' * string(k) * '#'),
        T.parameters[k]
      )::Loop
    )
  end
  push!(ls.loopsymbol_offsets, ls.loopsymbol_offsets[end] + N)
end

function ArrayReferenceMeta(
  ls::LoopSet,
  @nospecialize(ar::ArrayRefStruct),
  arraysymbolinds::Vector{Symbol},
  opsymbols::Vector{Symbol},
  nopsv::Vector{NOpsType},
  expandedv::Vector{Bool}
)
  # unpack the `ArrayRefStruct`
  # we don't want to specialize on it, as it is typed on symbols.
  index_types = (ar.index_types)::UInt128
  indices = (ar.indices)::UInt128
  offsets = (ar.offsets)::UInt128
  strides = (ar.strides)::UInt128
  arrayar, ptrar = array_and_ptr(ar)::Tuple{Symbol,Symbol}
  # ptrar = ptr(ar)::Symbol
  # TODO, check if this matters at all. The compiler still knows it is an `::ArrayRefStruct`, just not `arrayar` or `ptrar`?
  ArrayReferenceMeta(
    ls,
    index_types,
    indices,
    offsets,
    strides,
    arrayar,
    ptrar,
    arraysymbolinds,
    opsymbols,
    nopsv,
    expandedv
  )
end
function ArrayReferenceMeta(
  ls::LoopSet,
  index_types::UInt128,
  indices::UInt128,
  offsets::UInt128,
  strides::UInt128,
  arrayar::Symbol,
  ptrar::Symbol,
  arraysymbolinds::Vector{Symbol},
  opsymbols::Vector{Symbol},
  nopsv::Vector{NOpsType},
  expandedv::Vector{Bool}
)
  ni = filled_8byte_chunks(index_types)
  index_vec = Symbol[]
  offset_vec = Int8[]
  stride_vec = Int8[]
  loopedindex = Bool[]
  while index_types != zero(UInt128)
    ind = indices % UInt8
    offsetᵢ = offsets % Int8
    strideᵢ = strides % Int8
    if index_types == LoopIndex
      if ind == zero(Int8) # CONSTANTZEROINDEX
        pushfirst!(index_vec, CONSTANTZEROINDEX)
        pushfirst!(offset_vec, offsetᵢ)
        pushfirst!(stride_vec, strideᵢ)
        pushfirst!(loopedindex, true)
      else
        for inda = ls.loopsymbol_offsets[ind]+1:ls.loopsymbol_offsets[ind+1]
          pushfirst!(index_vec, ls.loopsymbols[inda])
          pushfirst!(offset_vec, offsetᵢ)
          pushfirst!(stride_vec, strideᵢ)
          pushfirst!(loopedindex, true)
        end
      end
    else#if index_types == ComputedIndex
      @assert index_types == ComputedIndex
      opsym = opsymbols[ind]
      if expandedv[ind]
        nops = nopsv[ind]
        for j ∈ 0:nops-1
          pushfirst!(index_vec, expandedopname(opsym, j))
          pushfirst!(offset_vec, offsetᵢ)
          pushfirst!(stride_vec, strideᵢ)
          pushfirst!(loopedindex, false)
        end
      else
        pushfirst!(index_vec, opsym)
        pushfirst!(offset_vec, offsetᵢ)
        pushfirst!(stride_vec, strideᵢ)
        pushfirst!(loopedindex, false)
      end
      # else
      # @assert index_types == SymbolicIndex
      # pushfirst!(index_vec, arraysymbolinds[ind])
      # pushfirst!(offset_vec, offset)
      # pushfirst!(loopedindex, false)
    end
    index_types >>>= 8
    indices >>>= 8
    offsets >>>= 8
    strides >>>= 8
    ni -= 1
  end
  ArrayReferenceMeta(
    ArrayReference(arrayar, index_vec, offset_vec, stride_vec),
    loopedindex,
    ptrar
  )
end

extract_varg(i) = :($getfield(var"#vargs#", $i))
# _extract(::Type{StaticInt{N}}) where {N} = N
extract_gsp!(sptrs::Expr, name::Symbol) = (push!(sptrs.args, name); nothing)
tupleranks(R::NTuple{8,Int}) = ntuple(n -> sum(R[n] .≥ R), Val{8}())
function rank_to_sortperm((R, N)::Tuple{NTuple{8,Int},Int})::Vector{Int}
  r = tupleranks(R)
  sp = Vector{Int}(undef, N)
  @inbounds for n = 1:N
    sp[r[n]] = n
  end
  sp
end
function loop_indexes_bit!(ls::LoopSet, ar::ArrayReferenceMeta)
  li = ar.loopedindex
  ind = first(getindices(ar))
  ind === DISCONTIGUOUS && return
  first(li) || throw(
    LoopError(
      "The contiguous index of a `BitArray` shouldn't be a complex function."
    )ind
  )
  ls.loopindexesbit[getloopid(ls, ind)] = true
  nothing
end
function add_mref!(
  sptrs::Expr,
  ls::LoopSet,
  ar::ArrayReferenceMeta,
  @nospecialize(_::Type{Ptr{T}}),
  C::Int,
  B::Int,
  sp::Vector{Int},
  name::Symbol
) where {T}
  @assert B ≤ 0 "Batched arrays not supported yet."
  _add_mref!(sptrs, ls, ar, typetosym(T), C, B, sp, name)
  sizeof(T)
end
typetosym(::Type{T}) where {T<:NativeTypes} =
  (VectorizationBase.JULIA_TYPES[T])::Symbol
typetosym(T) = T
function _add_mref!(
  sptrs::Expr,
  ls::LoopSet,
  ar::ArrayReferenceMeta,
  T_sym,
  C::Int,
  B::Int,
  sp::Vector{Int},
  name::Symbol
)
  # maybe no change needed? -- optimize common case
  li = ar.loopedindex
  if sp == eachindex(sp) || isone(length(li))
    # don't set `bit` to true if our vector width is ≥ 8
    ((T_sym === :Bit) && (ls.vector_width < 8)) && loop_indexes_bit!(ls, ar)
    return extract_gsp!(sptrs, name)
  end
  permute_mref!(ar, C, sp)
  # must now sort array's inds, and stack pointer's
  tmpsp = gensym(name)
  extract_gsp!(sptrs, tmpsp)
  strd_tup = Expr(:tuple)
  offsets_tup = Expr(:tuple)
  gf = getfield
  offsets = gensym(:offsets)
  strides = gensym(:strides)
  pushpreamble!(ls, Expr(:(=), offsets, Expr(:call, lv(:offsets), tmpsp)))
  pushpreamble!(
    ls,
    Expr(:(=), strides, Expr(:call, lv(:static_strides), tmpsp))
  )
  for (i, p) ∈ enumerate(sp)
    push!(strd_tup.args, Expr(:call, gf, strides, p, false))
    push!(offsets_tup.args, Expr(:call, gf, offsets, p, false))
  end
  #TODO: fix for `T === Bit`.
  column_major = Expr(:tuple)
  for n ∈ eachindex(sp)
    push!(column_major.args, n)
  end
  sitype =
    Expr(:curly, lv(:StrideIndex), length(sp), column_major, (C == -1 ? -1 : 1))
  siexpr = Expr(:call, sitype, strd_tup, offsets_tup)
  sptr = Expr(
    :call,
    lv(:stridedpointer),
    Expr(:call, lv(:pointer), tmpsp),
    siexpr,
    staticexpr(B)
  )

  pushpreamble!(ls, Expr(:(=), name, sptr))
  nothing
end
function permute_mref!(ar::ArrayReferenceMeta, C::Int, sp::Vector{Int})
  sp == eachindex(sp) && return nothing
  li = ar.loopedindex
  lic = copy(li)
  inds = getindices(ar)
  indsc = copy(inds)
  offsets = ar.ref.offsets
  offsetsc = copy(offsets)
  strides = ar.ref.strides
  stridesc = copy(strides)
  for (i, p) ∈ enumerate(sp)
    li[i] = lic[p]
    inds[i] = indsc[p]
    offsets[i] = offsetsc[p]
    strides[i] = stridesc[p]
  end
  C == -1 && makediscontiguous!(getindices(ar))
  return nothing
end
function add_mref!(
  sptrs::Expr,
  ::LoopSet,
  ::ArrayReferenceMeta,
  @nospecialize(_::Type{VectorizationBase.FastRange{T,F,S,O}}),
  ::Int,
  ::Int,
  sp::Vector{Int},
  name::Symbol
) where {T,F,S,O}
  extract_gsp!(sptrs, name)
  sizeof(T)
end
function create_mrefs!(
  ls::LoopSet,
  arf::Vector{ArrayRefStruct},
  as::Vector{Symbol},
  os::Vector{Symbol},
  nopsv::Vector{NOpsType},
  expanded::Vector{Bool},
  ::Type{Tuple{}}
)
  length(arf) == 0 || throw(
    ArgumentError(
      "Length of array ref vector should be 0 if there are no stridedpointers."
    )
  )
  Vector{ArrayReferenceMeta}(undef, length(arf)), Int[]
end
function stabilize_grouped_stridedpointer_type(C, B, R)
  N = (length(C))::Int
  Cv = Vector{Int}(undef, N)
  Bv = Vector{Int}(undef, N)
  Rv = Vector{Tuple{NTuple{8,Int},Int}}(undef, N)
  for n ∈ 1:N
    Cv[n] = C[n]
    Bv[n] = B[n]
    Rₙ = R[n]
    let L::Int = length(Rₙ)
      Rv[n] = (
        ntuple(i -> i > L ? typemax(Int) : (Rₙ[i])::Int, Val(8))::NTuple{8,Int},
        L
      )
    end
  end
  Cv, Bv, Rv
end
function create_mrefs!(
  ls::LoopSet,
  arf::Vector{ArrayRefStruct},
  as::Vector{Symbol},
  os::Vector{Symbol},
  nopsv::Vector{NOpsType},
  expanded::Vector{Bool},
  @nospecialize(_::Type{GroupedStridedPointers{P,C,B,R,I,X,O}})
) where {P,C,B,R,I,X,O}
  Cv, Bv, Rv = stabilize_grouped_stridedpointer_type(C, B, R)
  _create_mrefs!(ls, arf, as, os, nopsv, expanded, P.parameters, Cv, Bv, Rv)
end
function _create_mrefs!(
  ls::LoopSet,
  arf::Vector{ArrayRefStruct},
  as::Vector{Symbol},
  os::Vector{Symbol},
  nopsv::Vector{NOpsType},
  expanded::Vector{Bool},
  P::Core.SimpleVector,
  C::Vector{Int},
  B::Vector{Int},
  R::Vector{Tuple{NTuple{8,Int},Int}}
)
  mrefs::Vector{ArrayReferenceMeta} =
    Vector{ArrayReferenceMeta}(undef, length(arf))
  elementbytes::Vector{Int} = Vector{Int}(undef, length(arf))
  sptrs = Expr(:tuple)
  # pushpreamble!(ls, Expr(:(=), sptrs, :(VectorizationBase.stridedpointers(getfield(vargs, 1, false)))))
  pushpreamble!(
    ls,
    Expr(
      :(=),
      sptrs,
      :(VectorizationBase.stridedpointers(getfield(var"#vargs#", 1, false)))
    )
  )
  j = 0
  rank_to_sps = Vector{Tuple{Int,Vector{Int}}}(undef, length(arf))
  for i ∈ eachindex(arf)
    ar = ArrayReferenceMeta(ls, arf[i], as, os, nopsv, expanded)
    duplicate = false
    vptrar = vptr(ar)
    for k ∈ 1:i-1
      if vptr(mrefs[k]) === vptrar
        duplicate = true
        # if isassigned(rank_to_sps, k)
        Cₖ, sp = rank_to_sps[k]
        permute_mref!(ar, Cₖ, sp)
        elementbytes[i] = elementbytes[k]
        # end
        break
      end
    end
    if !duplicate
      j += 1
      sp = rank_to_sortperm(R[j])::Vector{Int}
      rank_to_sps[i] = (C[j], sp)
      elementbytes[i] = add_mref!(sptrs, ls, ar, P[j], C[j], B[j], sp, vptr(ar))
    end
    mrefs[i] = ar
  end
  mrefs, elementbytes
end

function num_parameters(AM)
  num_param::Int = AM[1]
  # num_param += length(AM[2].parameters)
  num_param + length(AM[3])
end
function gen_array_syminds(AM)
  Symbol[Symbol("##arraysymbolind##" * i * '#') for i ∈ 1:(AM[1])::Int]
end
function process_metadata!(ls::LoopSet, AM, extractind::Int)
  opoffsets = ls.operation_offsets
  expandbyoffset!(ls.outer_reductions, AM[2], opoffsets)
  for (i, si) ∈ enumerate(AM[3])
    sii = si::Int
    opid = opoffsets[sii] + 1
    if instruction(operations(ls)[opid]) ≠ DROPPEDCONSTANT
      s = gensym(:symlicm)
      push!(ls.preamble_symsym, (opid, s))
      pushpreamble!(ls, Expr(:(=), s, extract_varg((extractind += 1))))
    end
  end
  expandbyoffset!(ls.preamble_symint, AM[4], opoffsets)
  expandbyoffset!(ls.preamble_symfloat, AM[5], opoffsets)
  expandbyoffset!(ls.preamble_zeros, AM[6], opoffsets)
  expandbyoffset!(ls.preamble_funcofeltypes, AM[7], opoffsets)
  return extractind
end
function expandbyoffset!(
  indexpand::Vector{T},
  inds,
  offsets::Vector{Int},
  expand::Bool = true
) where {T<:Union{Int,Tuple{Int,<:Any}}}
  for _ind ∈ inds
    ind = T === Int ? _ind : first(_ind)
    base = offsets[ind] + 1
    for inda ∈ base:(expand ? offsets[ind+1] : base)
      if T === Int
        push!(indexpand, inda)
      elseif T === Tuple{Int,Tuple{Int,Int32,Bool}}
        li = last(_ind)
        push!(indexpand, (inda, (li[1], li[2], li[3])))
      else
        push!(indexpand, (inda, last(_ind)))
      end
    end
  end
  indexpand
end
expandbyoffset(inds::Vector{Int}, offsets::Vector{Int}, expand::Bool) =
  expandbyoffset!(Int[], inds, offsets, expand)
function loopindex!(
  idxs::Vector{Int},
  ls::LoopSet,
  u::Unsigned,
  shift::Unsigned
)
  mask = (one(shift) << shift) - one(shift) # mask to zero out all but shift-bits
  while u != zero(u)
    pushfirst!(idxs, (u % typeof(shift)) & mask)
    u >>= shift
  end
  idxs
end
loopindex(ls::LoopSet, u::Unsigned, shift::Unsigned) =
  reverse!(loopindex!(Int[], ls, u, shift))
function loopindexoffset(
  ls::LoopSet,
  u::Unsigned,
  li::Bool,
  expand::Bool = false
)
  if li
    shift = 0x04
    offsets = ls.loopsymbol_offsets
  else
    shift = 0x08
    offsets = ls.operation_offsets
  end
  idxs = loopindex(ls, u, shift)
  expandbyoffset(idxs, offsets, expand)
end
function parents_symvec(ls::LoopSet, u::Unsigned, expand, offset)
  idxs = loopindexoffset(ls, u, true, expand)   # TODO DRY  (undesirable that this gets hard-coded in multiple places)
  return Symbol[getloopsym(ls, i + offset) for i ∈ idxs]
end
loopdependencies(ls::LoopSet, os::OperationStruct, expand = false, offset = 0) =
  parents_symvec(ls, os.loopdeps, expand, offset)
reduceddependencies(
  ls::LoopSet,
  os::OperationStruct,
  expand = false,
  offset = 0
) = parents_symvec(ls, os.reduceddeps, expand, offset)
childdependencies(
  ls::LoopSet,
  os::OperationStruct,
  expand = false,
  offset = 0
) = parents_symvec(ls, os.childdeps, expand, offset)

# parents(ls::LoopSet, u::UInt128) = loopindexoffset(ls, u, false)
function parents(
  ls::LoopSet,
  u₀::UInt128,
  u₁::UInt128,
  u₂::UInt128,
  u₃::UInt128
)
  idxs = Int[]
  u₃ == zero(u₃) || loopindex!(idxs, ls, u₃, 0x0010)
  u₂ == zero(u₂) || loopindex!(idxs, ls, u₂, 0x0010)
  u₁ == zero(u₁) || loopindex!(idxs, ls, u₁, 0x0010)
  loopindex!(idxs, ls, u₀, 0x0010)
  reverse!(idxs)
end
parents(ls::LoopSet, os::OperationStruct) =
  parents(ls, os.parents₀, os.parents₁, os.parents₂, os.parents₃)

expandedopname(opsymbol::Symbol, offset::Integer) =
  Symbol(String(opsymbol) * '#' * string(offset + 1) * '#')
function calcnops(ls::LoopSet, os::OperationStruct)
  optyp = optype(os)
  if (optyp != loopvalue) && (optyp != compute)
    return 1
  end
  offsets = ls.loopsymbol_offsets
  idxs = loopindex(ls, os.loopdeps, 0x04)  # TODO DRY
  iszero(length(idxs)) && return 1
  return maximum(i -> offsets[i+1] - offsets[i], idxs)
end
function isexpanded(
  ls::LoopSet,
  ops::Vector{OperationStruct},
  nopsv::Vector{NOpsType},
  i::Int
)
  nops = nopsv[i]
  # nops isa Vector{Int} only if accesses_memory(os), which means isexpanded must be false
  (nops === 1 || isa(nops, Vector{Int})) && return false
  os = ops[i]
  optyp = optype(os)
  if optyp == compute
    any(j -> isexpanded(ls, ops, nopsv, j), parents(ls, os))
  elseif optyp == loopvalue
    true
  else
    false
  end
end
function mref_elbytes(
  os::OperationStruct,
  mrefs::Vector{ArrayReferenceMeta},
  elementbytes::Vector{Int}
)
  if isload(os) | isstore(os)
    mrefs[os.array], elementbytes[os.array]
  else
    NOTAREFERENCE, 4
  end
end
function add_op!(
  ls::LoopSet,
  instr::Instruction,
  ops::Vector{OperationStruct},
  nopsv::Vector{NOpsType},
  expandedv::Vector{Bool},
  i::Int,
  mrefs::Vector{ArrayReferenceMeta},
  opsymbol,
  elementbytes::Vector{Int}
)
  os = ops[i]
  mref, elbytes = mref_elbytes(os, mrefs, elementbytes)
  # opsymbol = (isconstant(os) && instr != LOOPCONSTANT) ? instr.instr : opsymbol
  # If it's a CartesianIndex add or subtract, we may have to add multiple operations
  expanded = expandedv[i]# isexpanded(ls, ops, nopsv, i)
  opoffsets = ls.operation_offsets
  # offsets = ls.loopsymbol_offsets
  optyp = optype(os)
  if !expanded
    op = Operation(
      length(operations(ls)),
      opsymbol,
      elbytes,
      instr,
      optyp,
      loopdependencies(ls, os, true),
      reduceddependencies(ls, os, true),
      Operation[],
      mref,
      childdependencies(ls, os, true)
    )
    push!(ls.operations, op)
    push!(opoffsets, opoffsets[end] + 1)
    return
  end
  nops = (nopsv[i])::Int # if it were a vector, it would have to have been expanded
  # if expanded, optyp must be either loopvalue, or compute (with loopvalues in its ancestry, not cutoff by loads)
  for offset = 0:nops-1
    sym = nops === 1 ? opsymbol : expandedopname(opsymbol, offset)
    op = Operation(
      length(operations(ls)),
      sym,
      elbytes,
      instr,
      optyp,
      loopdependencies(ls, os, false, offset),
      reduceddependencies(ls, os, false, offset),
      Operation[],
      mref,
      childdependencies(ls, os, false, offset)
    )
    push!(ls.operations, op)
  end
  push!(opoffsets, opoffsets[end] + nops)
  nothing
end
function add_parents_to_op!(
  ls::LoopSet,
  op::Operation,
  up₀::UInt128,
  up₁::UInt128,
  up₂::UInt128,
  up₃::UInt128,
  k::Int,
  Δ::Int
)
  vparents = parents(op)
  ops = operations(ls)
  offsets = ls.operation_offsets
  if isone(Δ) # not expanded
    @assert isone(k)
    for i ∈ parents(ls, up₀, up₁, up₂, up₃)
      # FIXME; children also filled in cacheunrolled
      for j ∈ offsets[i]+1:offsets[i+1] # if parents are expanded, add them all
        opp = ops[j]
        pushfirst!(vparents, opp)
        push!(children(opp), op)
      end
    end
  else#if isexpanded
    # Do we want to require that all Δidxs are equal?
    # Because `CartesianIndex((2,3)) - 1` results in a methoderorr, I think this is reasonable for now
    # FIXME; children also filled in cacheunrolled
    for i ∈ parents(ls, up₀, up₁, up₂, up₃)
      opp = ops[offsets[i]+k]
      pushfirst!(vparents, opp)
      push!(children(opp), op)
    end
  end
end
function add_parents_to_ops!(
  ls::LoopSet,
  ops::Vector{OperationStruct},
  constoffset
)
  offsets = ls.operation_offsets
  for i = 1:length(offsets)-1
    pos = offsets[i]
    Δ = offsets[i+1] - pos
    for k ∈ 1:Δ
      op = ls.operations[pos+k]
      if isconstant(op)
        instr = instruction(op)
        if !skip_constant(instr)
          constoffset += 1
          pushpreamble!(ls, Expr(:(=), instr.instr, extract_varg(constoffset)))
        end
      elseif !isloopvalue(op)
        add_parents_to_op!(
          ls,
          op,
          ops[i].parents₀,
          ops[i].parents₁,
          ops[i].parents₂,
          ops[i].parents₃,
          k,
          Δ
        )
      end
    end
  end
  constoffset
end
function add_ops!(
  ls::LoopSet,
  instr::Vector{Instruction},
  ops::Vector{OperationStruct},
  mrefs::Vector{ArrayReferenceMeta},
  elementbytes::Vector{Int},
  opsymbols::Vector{Symbol},
  constoffset::Int,
  nopsv::Vector{NOpsType},
  expandedv::Vector{Bool}
)
  # @show ls.loopsymbols ls.loopsymbol_offsets
  for i ∈ eachindex(ops)
    os = ops[i]
    opsymbol = opsymbols[os.symid]
    add_op!(
      ls,
      instr[i],
      ops,
      nopsv,
      expandedv,
      i,
      mrefs,
      opsymbol,
      elementbytes
    )
  end
  add_parents_to_ops!(ls, ops, constoffset)
  # for op ∈ operations(ls)
  #     if isstore(op) && isreduction(op) && iszero(length(loopdependencies(op)))
  #         addreduct_to_outer_reductions!(ls, op)
  #     end
  # end
  # for op in operations(ls)
  # @show op
  # end
end

# elbytes(::VectorizationBase.AbstractPointer{T}) where {T} = sizeof(T)::Int
# typeeltype(::Type{P}) where {T,P<:VectorizationBase.AbstractStridedPointer{T}} = T
typeeltype(::Type{Ptr{T}}) where {T} = T
# typeeltype(::Type{Core.LLVMPtr{T,0}}) where {T} = T
typeeltype(::Type{VectorizationBase.FastRange{T,F,S,O}}) where {T,F,S,O} = T
typeeltype(::Type{T}) where {T<:Real} = T
# typeeltype(::Any) = Int8

function add_array_symbols!(
  ls::LoopSet,
  arraysymbolinds::Vector{Symbol},
  offset::Int
)
  for as ∈ arraysymbolinds
    pushpreamble!(ls, Expr(:(=), as, extract_varg((offset += 1))))
  end
  return offset
end
function extract_external_functions!(ls::LoopSet, offset::Int, vargs)
  for op ∈ operations(ls)
    if iscompute(op)
      instr = instruction(op)
      if instr.mod != :LoopVectorization
        offset += 1
        instr_new = get(FUNCTIONSYMBOLS, vargs[offset], instr)
        if instr_new === instr
          extractf = Expr(
            :call,
            GlobalRef(Core, :getfield),
            Symbol("#vargs#"),
            offset,
            false
          )
          pushpreamble!(ls, Expr(:(=), instr.instr, extractf))
        else
          op.instruction = instr_new
        end
      end
    end
  end
  offset
end
outer_reduct_init_typename(op::Operation) =
  Symbol(mangledvar(op), "#or#init#type#")
function extract_outerreduct_types!(ls::LoopSet, offset::Int, vargs)
  # for op
  for or ∈ ls.outer_reductions
    extractt = Expr(
      :call,
      GlobalRef(Core, :getfield),
      Symbol("#vargs#"),
      (offset += 1),
      false
    )
    op = operations(ls)[or]
    if instruction(op).instr ≢ :ifelse
      pushpreamble!(ls, Expr(:(=), outer_reduct_init_typename(op), extractt))
    else
      opextractbase = Symbol(name(op), "##BASE##EXTRACT##")
      pushpreamble!(ls, Expr(:(=), opextractbase, extractt))
      pushpreamble!(
        ls,
        Expr(
          :(=),
          outer_reduct_init_typename(op),
          Expr(:call, lv(:typeof), opextractbase)
        )
      )
    end
  end
  offset
end
function sizeofeltypes(v)::Int
  num_arrays = length(v)::Int
  if num_arrays == 0
    return 8
  end
  T = typeeltype(v[1])
  sz =
    if (
      VectorizationBase.simd_integer_register_size() !=
      VectorizationBase.register_size()
    ) && T <: Integer # hack
      (
        VectorizationBase.register_size() ÷
        VectorizationBase.simd_integer_register_size()
      ) * sizeof(T)
    else
      sz = sizeof(T)
    end
  for i ∈ 2:num_arrays
    Ttemp = typeeltype(v[i])
    szᵢ =
      if (
        VectorizationBase.simd_integer_register_size() !=
        VectorizationBase.register_size()
      ) && T <: Integer # hack
        (
          VectorizationBase.register_size() ÷
          VectorizationBase.simd_integer_register_size()
        ) * sizeof(T)
      else
        sizeof(Ttemp)
      end
    # if !VectorizationBase.SIMD_NATIVE_INTEGERS && Ttemp <: Integer # hack
    #     return VectorizationBase.register_size()
    # end
    # T = promote_type(T, Ttemp)
    sz = max(szᵢ, sz)
  end
  sz
  # sizeof(T)
end

function avx_loopset!(
  ls::LoopSet,
  instr::Vector{Instruction},
  ops::Vector{OperationStruct},
  arf::Vector{ArrayRefStruct},
  AM::Vector{Any},
  LPSYM::Vector{Any},
  LB::Core.SimpleVector,
  vargs::Core.SimpleVector
)
  pushpreamble!(
    ls,
    :((var"#loop#bounds#", var"#vargs#") = var"#lv#tuple#args#")
  )
  add_loops!(ls, LPSYM, LB)
  resize!(ls.loop_order, ls.loopsymbol_offsets[end])
  arraysymbolinds = gen_array_syminds(AM)
  opsymbols = [gensym("op") for _ ∈ eachindex(ops)]
  nopsv = NOpsType[calcnops(ls, op) for op in ops]
  expandedv = [isexpanded(ls, ops, nopsv, i) for i ∈ eachindex(ops)]

  resize!(ls.loopindexesbit, length(ls.loops))
  fill!(ls.loopindexesbit, false)
  mrefs, elementbytes = create_mrefs!(
    ls,
    arf,
    arraysymbolinds,
    opsymbols,
    nopsv,
    expandedv,
    vargs[1]
  )
  for mref ∈ mrefs
    push!(ls.includedactualarrays, vptr(mref))
  end
  # extra args extraction
  extractind = add_ops!(
    ls,
    instr,
    ops,
    mrefs,
    elementbytes,
    opsymbols,
    1,
    nopsv,
    expandedv
  )
  extractind = process_metadata!(ls, AM, extractind)
  extractind = add_array_symbols!(ls, arraysymbolinds, extractind)
  extractind = extract_external_functions!(ls, extractind, vargs)
  extractind = extract_outerreduct_types!(ls, extractind, vargs)
  ls
end
function avx_body(
  ls::LoopSet,
  UNROLL::Tuple{Bool,Int8,Int8,Int8,Bool,Int,Int,Int,Int,UInt,Int,Bool}
)
  inline, u₁, u₂, v, isbroadcast, W, rs, rc, cls, nt = UNROLL
  q =
    (iszero(u₁) & iszero(v)) ? lower_and_split_loops(ls, inline % Int) :
    lower(ls, u₁ % Int, u₂ % Int, v % Int, inline % Int)
  ls.isbroadcast = isbroadcast
  iszero(length(ls.outer_reductions)) ? push!(q.args, nothing) :
  push!(q.args, loopset_return_value(ls, Val(true)))
  q
end

function _turbo_loopset_debug(
  ::Val{UNROLL},
  ::Val{OPS},
  ::Val{ARF},
  ::Val{AM},
  ::Val{LPSYM},
  _vargs::Tuple{LB,V}
) where {UNROLL,OPS,ARF,AM,LPSYM,LB,V}
  # @show OPS ARF AM LPSYM _vargs
  _turbo_loopset(
    OPS,
    ARF,
    AM,
    LPSYM,
    _vargs[1].parameters,
    V.parameters,
    UNROLL
  )
end
function tovector(@nospecialize(t))
  v = Vector{Any}(undef, length(t))
  for i ∈ eachindex(v)
    tᵢ = t[i]
    if tᵢ isa Tuple # reduce specialization?
      v[i] = tovector(tᵢ)
    else
      v[i] = tᵢ
    end
  end
  v
end
function _turbo_loopset(
  @nospecialize(OPSsv),
  @nospecialize(ARFsv),
  @nospecialize(AMsv),
  @nospecialize(LPSYMsv),
  LBsv::Core.SimpleVector,
  vargs::Core.SimpleVector,
  UNROLL::Tuple{Bool,Int8,Int8,Int8,Bool,Int,Int,Int,Int,UInt,Int,Bool}
)
  nops = length(OPSsv) ÷ 3
  instr = Instruction[Instruction(OPSsv[3i+1], OPSsv[3i+2]) for i ∈ 0:nops-1]
  ops = OperationStruct[OPSsv[3i] for i ∈ 1:nops]
  ls = LoopSet(:LoopVectorization)
  inline, u₁, u₂, v, isbroadcast, W, rs, rc, cls, nt = UNROLL
  set_hw!(ls, rs, rc, cls)
  ls.vector_width = W
  ls.isbroadcast = isbroadcast
  arsv = Vector{ArrayRefStruct}(undef, length(ARFsv))
  for i ∈ eachindex(arsv)
    arsv[i] = ARFsv[i]
  end
  avx_loopset!(
    ls,
    instr,
    ops,
    arsv,
    tovector(AMsv),
    tovector(LPSYMsv),
    LBsv,
    vargs
  )
end

"""
    _turbo_!(unroll, ops, arf, am, lpsym, lb, vargs...)

Execute an `@turbo` block. The block's code is represented via the arguments:

  - `unroll` is `Val((u₁,u₂))` and specifies the loop unrolling factor(s).
    These values may be supplied manually via the `unroll` keyword
    of [`@turbo`](@ref).
  - `ops` is `Tuple{mod1, sym1, op1, mod2, sym2, op2...}` encoding the operations of the loop.
    `mod` and `sym` encode the module and symbol of the called function; `op` is an [`OperationStruct`](@ref)
    encoding the details of the operation.
  - `arf` is `Tuple{arf1, arf2...}`, where each `arfi` is an [`ArrayRefStruct`](@ref) encoding
    an array reference.
  - `am` contains miscellaneous data about the LoopSet (see `process_metadata!`)
  - `lpsym` is `Tuple{:i,:j,...}`, a Tuple of the "loop symbols", i.e. the item variable `i` in `for i ∈ iter`
  - `lb` is `Tuple{RngTypei,RngTypej,...}`, a Tuple encoding syntactically-knowable information about
    the iterators corresponding to `lpsym`. For example, in `for i ∈ 1:n`, the `1:n` would be encoded with
    `StaticLowerUnitRange(1)` because the lower bound of the iterator can be determined to be 1.
  - `vargs...` holds the encoded pointers of all the arrays (see `VectorizationBase`'s various pointer types).
"""
@generated function _turbo_!(
  ::Val{var"#UNROLL#"},
  ::Val{var"#OPS#"},
  ::Val{var"#ARF#"},
  ::Val{var"#AM#"},
  ::Val{var"#LPSYM#"},
  ::Val{Tuple{var"#LB#",var"#V#"}},
  var"#flattened#var#arguments#"::Vararg{Any,var"#num#vargs#"}
) where {
  var"#UNROLL#",
  var"#OPS#",
  var"#ARF#",
  var"#AM#",
  var"#LPSYM#",
  var"#LB#",
  var"#V#",
  var"#num#vargs#"
}
  # 1 + 1 # Irrelevant line you can comment out/in to force recompilation...
  ls = _turbo_loopset(
    var"#OPS#",
    var"#ARF#",
    var"#AM#",
    var"#LPSYM#",
    var"#LB#".parameters,
    var"#V#".parameters,
    var"#UNROLL#"
  )
  pushfirst!(
    ls.preamble.args,
    :(
      var"#lv#tuple#args#" = reassemble_tuple(
        Tuple{var"#LB#",var"#V#"},
        var"#flattened#var#arguments#"
      )
    )
  )
  post = hoist_constant_memory_accesses!(ls)
  # q = @show(avx_body(ls, var"#UNROLL#")); post === ls.preamble ? q : Expr(:block, q, post)
  q = if (var"#UNROLL#"[10] > 1) && length(var"#LPSYM#") == length(ls.loops)
    inline, u₁, u₂, v, isbroadcast, W, rs, rc, cls, nt, wca, safe =
      var"#UNROLL#"
    # wrap in `var"#OPS#", var"#ARF#", var"#AM#", var"#LPSYM#"` in `Expr` to homogenize types
    avx_threads_expr(
      ls,
      (inline, u₁, u₂, v, isbroadcast, W, rs, rc, cls, one(UInt), wca, safe),
      nt,
      :(Val{$(var"#OPS#")}()),
      :(Val{$(var"#ARF#")}()),
      :(Val{$(var"#AM#")}()),
      :(Val{$(var"#LPSYM#")}())
    )
  else
    # Main.BODY[] = avx_body(ls, var"#UNROLL#")
    # return @show avx_body(ls, var"#UNROLL#")
    avx_body(ls, var"#UNROLL#")
  end
  post === ls.preamble ? q : Expr(:block, q, post)
  # @show var"#UNROLL#", var"#OPS#", var"#ARF#", var"#AM#", var"#LPSYM#", var"#LB#"
end
@generated function _turbo_manyarg!(
  ::Val{var"#UNROLL#"},
  ::Val{var"#OPS#"},
  ::Val{var"#ARF#"},
  ::Val{var"#AM#"},
  ::Val{var"#LPSYM#"},
  ::Val{Tuple{var"#LB#",var"#V#"}},
  var"#flattened#var#arguments#"::Tuple{Vararg{Any,var"#num#vargs#"}}
) where {
  var"#UNROLL#",
  var"#OPS#",
  var"#ARF#",
  var"#AM#",
  var"#LPSYM#",
  var"#LB#",
  var"#V#",
  var"#num#vargs#"
}
  1 + 1 # Irrelevant line you can comment out/in to force recompilation...
  ls = _turbo_loopset(
    var"#OPS#",
    var"#ARF#",
    var"#AM#",
    var"#LPSYM#",
    var"#LB#".parameters,
    var"#V#".parameters,
    var"#UNROLL#"
  )
  pushfirst!(
    ls.preamble.args,
    :(
      var"#lv#tuple#args#" = reassemble_tuple(
        Tuple{var"#LB#",var"#V#"},
        var"#flattened#var#arguments#"
      )
    )
  )
  post = hoist_constant_memory_accesses!(ls)
  # q = @show(avx_body(ls, var"#UNROLL#")); post === ls.preamble ? q : Expr(:block, q, post)
  q = if (var"#UNROLL#"[10] > 1) && length(var"#LPSYM#") == length(ls.loops)
    inline, u₁, u₂, v, isbroadcast, W, rs, rc, cls, nt, wca, safe =
      var"#UNROLL#"
    # wrap in `var"#OPS#", var"#ARF#", var"#AM#", var"#LPSYM#"` in `Expr` to homogenize types
    avx_threads_expr(
      ls,
      (inline, u₁, u₂, v, isbroadcast, W, rs, rc, cls, one(UInt), wca, safe),
      nt,
      :(Val{$(var"#OPS#")}()),
      :(Val{$(var"#ARF#")}()),
      :(Val{$(var"#AM#")}()),
      :(Val{$(var"#LPSYM#")}())
    )
  else
    # Main.BODY[] = avx_body(ls, var"#UNROLL#")
    # return @show avx_body(ls, var"#UNROLL#")
    avx_body(ls, var"#UNROLL#")
  end
  post === ls.preamble ? q : Expr(:block, q, post)
  # @show var"#UNROLL#", var"#OPS#", var"#ARF#", var"#AM#", var"#LPSYM#", var"#LB#"
end

module ForwardDiffExt
import ForwardDiff, ChainRulesCore
using LoopVectorization, VectorizationBase, SLEEFPirates, ForwardDiff
using SLEEFPirates: tanh_fast, sigmoid_fast

import IfElse: ifelse
using VectorizationBase: AbstractSIMD, AbstractMask, zero_offsets

using LoopVectorization:
  AbstractSIMD,
  AbstractStridedPointer,
  vmap,
  VectorizationBase,
  vmapt,
  vmapnt,
  vmapntt,
  MM,
  StaticInt,
  vadd_nw,
  vsub_nsw,
  vload,
  mask,
  vfnmadd_fast,
  mul_fast

@generated function Base.abs(
  x::ForwardDiff.Dual{TAG,S,N}
) where {TAG,S<:AbstractSIMD,N}
  quote
    $(Expr(:meta, :inline))
    val = x.value
    p = x.partials
    cmp = val < zero($S)
    absx = $ifelse(cmp, -val, val)
    Base.Cartesian.@nexprs $N n -> p_n = p[n]
    ForwardDiff.Dual{$TAG}(
      absx,
      ForwardDiff.Partials(
        Base.Cartesian.@ntuple $N n -> $ifelse(cmp, -p_n, p_n)
      )
    )
  end
end
@inline function Base.max(
  x::ForwardDiff.Dual{TAG,<:AbstractSIMD,N},
  y::ForwardDiff.Dual{TAG,<:AbstractSIMD,N}
) where {TAG,N}
  vx = ForwardDiff.value(x)
  vy = ForwardDiff.value(y)
  xgy = vx > vy
  z = ifelse(xgy, vx, vy)
  p = VectorizationBase.fmap(
    ifelse,
    xgy,
    ForwardDiff.partials(x).values,
    ForwardDiff.partials(y).values
  )
  ForwardDiff.Dual{TAG}(z, ForwardDiff.Partials(p))
end

@inline Base.max(
  x::T,
  y::Real
) where {N,T<:ForwardDiff.Dual{<:Any,<:AbstractSIMD,N}} = max(x, T(y))
@inline Base.max(
  y::Real,
  x::T
) where {N,T<:ForwardDiff.Dual{<:Any,<:AbstractSIMD,N}} = max(x, T(y))
@inline Base.max(
  x::T,
  y::Int
) where {N,T<:ForwardDiff.Dual{<:Any,<:AbstractSIMD,N}} = max(x, T(y))
@inline Base.max(
  y::Int,
  x::T
) where {N,T<:ForwardDiff.Dual{<:Any,<:AbstractSIMD,N}} = max(x, T(y))

@inline function Base.min(
  x::ForwardDiff.Dual{TAG,<:AbstractSIMD,N},
  y::ForwardDiff.Dual{TAG,<:AbstractSIMD,N}
) where {TAG,N}
  vx = ForwardDiff.value(x)
  vy = ForwardDiff.value(y)
  xgy = vx < vy
  z = ifelse(xgy, vx, vy)
  p = VectorizationBase.fmap(
    ifelse,
    xgy,
    ForwardDiff.partials(x).values,
    ForwardDiff.partials(y).values
  )
  ForwardDiff.Dual{TAG}(z, ForwardDiff.Partials(p))
end
@inline Base.min(
  x::T,
  y::Real
) where {N,T<:ForwardDiff.Dual{<:Any,<:AbstractSIMD,N}} = min(x, T(y))
@inline Base.min(
  y::Real,
  x::T
) where {N,T<:ForwardDiff.Dual{<:Any,<:AbstractSIMD,N}} = min(x, T(y))
@inline Base.min(
  x::T,
  y::Int
) where {N,T<:ForwardDiff.Dual{<:Any,<:AbstractSIMD,N}} = min(x, T(y))
@inline Base.min(
  y::Int,
  x::T
) where {N,T<:ForwardDiff.Dual{<:Any,<:AbstractSIMD,N}} = min(x, T(y))

@generated function SLEEFPirates.tanh_fast(
  x::ForwardDiff.Dual{T,S,N}
) where {T,S,N}
  quote
    $(Expr(:meta, :inline))
    t = tanh_fast(x.value)
    ∂t = $(VectorizationBase.vfnmadd_fast)(t, t, one(S))
    p = x.partials
    ForwardDiff.Dual{T}(
      t,
      ForwardDiff.Partials(
        Base.Cartesian.@ntuple $N n -> $(Base.FastMath.mul_fast)(∂t, p[n])
      )
    )
  end
end
@generated function SLEEFPirates.sigmoid_fast(
  x::ForwardDiff.Dual{T,S,N}
) where {T,S,N}
  quote
    $(Expr(:meta, :inline))
    s = sigmoid_fast(x.value)
    ∂s = $(VectorizationBase.vfnmadd_fast)(s, s, s)
    p = x.partials
    ForwardDiff.Dual{T}(
      s,
      ForwardDiff.Partials(
        Base.Cartesian.@ntuple $N n -> $(Base.FastMath.mul_fast)(∂s, p[n])
      )
    )
  end
end

@generated function _ifelse(
  m::Union{AbstractMask,VecUnroll{<:Any,<:Any,Bit,<:AbstractMask}},
  x::ForwardDiff.Dual{TAG,V,P},
  y::ForwardDiff.Dual{TAG,V,P}
) where {TAG,V,P}
  quote
    $(Expr(:meta, :inline))
    z = $ifelse(m, ForwardDiff.value(x), ForwardDiff.value(y))
    px = ForwardDiff.partials(x)
    py = ForwardDiff.partials(y)
    p = Base.Cartesian.@ntuple $P p -> $ifelse(m, px[p], py[p])
    ForwardDiff.Dual{$TAG}(z, ForwardDiff.Partials(p))
  end
end
@generated function _ifelse(
  m::Union{AbstractMask,VecUnroll{<:Any,<:Any,Bit,<:AbstractMask}},
  x::Number,
  y::ForwardDiff.Dual{TAG,V,P}
) where {TAG,V,P}
  quote
    $(Expr(:meta, :inline))
    z = $ifelse(m, x, ForwardDiff.value(y))
    py = ForwardDiff.partials(y)
    p = Base.Cartesian.@ntuple $P p -> $ifelse(m, zero($V), py[p])
    ForwardDiff.Dual{$TAG}(z, ForwardDiff.Partials(p))
  end
end
@generated function _ifelse(
  m::Union{AbstractMask,VecUnroll{<:Any,<:Any,Bit,<:AbstractMask}},
  x::ForwardDiff.Dual{TAG,V,P},
  y::Number
) where {TAG,V,P}
  quote
    $(Expr(:meta, :inline))
    z = $ifelse(m, ForwardDiff.value(x), y)
    px = ForwardDiff.partials(x)
    p = Base.Cartesian.@ntuple $P p -> $ifelse(m, px[p], zero($V))
    ForwardDiff.Dual{$TAG}(z, ForwardDiff.Partials(p))
  end
end
@inline ifelse(m::AbstractMask, x::ForwardDiff.Dual, y::Number) =
  _ifelse(m, x, y)
@inline ifelse(m::AbstractMask, x::ForwardDiff.Dual, y::ForwardDiff.Dual) =
  _ifelse(m, x, y)
@inline ifelse(m::AbstractMask, y::Number, x::ForwardDiff.Dual) =
  _ifelse(m, y, x)

@inline ifelse(
  m::VecUnroll{<:Any,<:Any,Bit,<:AbstractMask},
  x::ForwardDiff.Dual,
  y::Number
) = _ifelse(m, x, y)
@inline ifelse(
  m::VecUnroll{<:Any,<:Any,Bit,<:AbstractMask},
  x::ForwardDiff.Dual,
  y::ForwardDiff.Dual
) = _ifelse(m, x, y)
@inline ifelse(
  m::VecUnroll{<:Any,<:Any,Bit,<:AbstractMask},
  y::Number,
  x::ForwardDiff.Dual
) = _ifelse(m, y, x)

@inline function SLEEFPirates.softplus(x::ForwardDiff.Dual{TAG}) where {TAG}
  val = ForwardDiff.value(x)
  expx = exp(val)
  vx = log1p(expx)
  px = Base.FastMath.inv_fast(one(val) + Base.FastMath.inv_fast(expx))
  ForwardDiff.Dual{TAG}(vx, Base.FastMath.mul_fast(ForwardDiff.partials(x), px))
end

@generated function init_dual(v::Tuple{Vararg{AbstractSIMD,A}}) where {A}
  res = Expr(:tuple)
  q = Expr(:block, Expr(:meta, :inline))
  for a ∈ 1:A
    v_a = Symbol(:v_, a)
    push!(q.args, Expr(:(=), v_a, Expr(:ref, :v, a)))
    partials = Expr(:tuple)
    for i ∈ 1:A
      push!(partials.args, Expr(:call, i == a ? :one : :zero, v_a))
    end
    push!(res.args, :(ForwardDiff.Dual($v_a, ForwardDiff.Partials($partials))))
  end
  push!(q.args, res)
  q
end
@generated function dual_store!(
  ∂p::Tuple{Vararg{AbstractStridedPointer,A}},
  p::AbstractStridedPointer,
  ∂v,
  im::Vararg{Any,N}
) where {A,N}
  quote
    $(Expr(:meta, :inline))
    v = ∂v.value
    ∂ = ∂v.partials
    Base.Cartesian.@nextract $N im im
    Base.Cartesian.@ncall $N VectorizationBase.vnoaliasstore! p v im  # store
    Base.Cartesian.@nexprs $A a -> begin # for each of `A` partials
      ∂p_a = ∂p[a]
      ∂_a = ∂[a]
      Base.Cartesian.@ncall $N VectorizationBase.vnoaliasstore! ∂p_a ∂_a im # store
    end
    nothing
  end
end

if isdefined(ChainRulesCore, :ZeroTangent)
  const ChainRulesZero = ChainRulesCore.ZeroTangent
else
  const ChainRulesZero = ChainRulesCore.Zero
end

function ChainRulesCore.rrule(::typeof(tanh_fast), x)
  t = tanh_fast(x)
  ∂ = let t = t
    y -> (ChainRulesZero(), mul_fast(vfnmadd_fast(t, t, one(t)), y))
  end
  t, ∂
end
function ChainRulesCore.rrule(::typeof(sigmoid_fast), x)
  s = sigmoid_fast(x)
  ∂ = let s = s
    y -> (ChainRulesZero(), mul_fast(vfnmadd_fast(s, s, s), y))
  end
  s, ∂
end

function ∂vmap_singlethread!(
  f::F,
  ∂y::Tuple{Vararg{DenseArray{T},A}},
  y::DenseArray{T},
  args::Vararg{DenseArray{<:Base.HWReal},A}
) where {F,T<:Base.HWReal,A}
  N = length(y)
  ptry = zero_offsets(stridedpointer(y))
  ptrargs = map(zero_offsets, map(stridedpointer, args))
  ptr∂y = map(zero_offsets, map(stridedpointer, ∂y))
  i = 0
  V = VectorizationBase.pick_vector_width(T)
  W = Int(V)
  while i < vsub_nsw(N, ((W << 2) - 1))
    index = VectorizationBase.Unroll{1,W,4,1,W,zero(UInt)}((i,))
    v = f(init_dual(map(Base.Fix2(vload, index), ptrargs))...)
    dual_store!(ptr∂y, ptry, v, index)
    i = vadd_nw(i, 4W)
  end
  while i < vsub_nsw(N, (W - 1))
    loader = Base.Fix2(vload, (MM{W}(i),))
    vᵣ = f(init_dual(map(loader, ptrargs))...)
    dual_store!(ptr∂y, ptry, vᵣ, (MM{W}(i),))
    i = vadd_nw(i, W)
  end
  if i < N
    m = mask(T, N & (W - 1))
    mloader = let i = i, m = m
      p -> vload(p, (MM{W}(i),), m)
    end
    dual_store!(
      ptr∂y,
      ptry,
      f(init_dual(map(mloader, ptrargs))...),
      (MM{W}(i),),
      m
    )
  end
  nothing
end

struct SIMDMapBack{K,T<:Tuple{Vararg{Any,K}}}
  jacs::T
end
@generated function (b::SIMDMapBack{K,T})(Δ::A) where {K,T,A}
  preloop = Expr(:block, :(jacs = b.jacs))
  loop_body = Expr(:block, :(Δᵢ = Δ[i]))
  ret = Expr(:tuple, ChainRulesZero(), ChainRulesZero())
  for k ∈ 1:K
    jₖ = Symbol(:j_, k)
    push!(preloop.args, :($jₖ = jacs[$k]))
    push!(loop_body.args, :($jₖ[i] *= Δᵢ))
    push!(ret.args, jₖ)
  end
  quote
    $preloop
    @turbo for i ∈ eachindex(Δ)
      $loop_body
    end
    $ret
  end
end

function ChainRulesCore.rrule(
  ::typeof(vmap),
  f::F,
  args::Vararg{Any,K}
) where {F,K}
  out = similar(first(args))
  jacs = map(similar, args)
  ∂vmap_singlethread!(f, jacs, out, args...)
  out, SIMDMapBack(jacs)
end
for f in (:vmapt, :vmapnt, :vmapntt)
  @eval function ChainRulesCore.rrule(
    ::typeof($f),
    f::F,
    args::Vararg{Any,K}
  ) where {F,K}
    ChainRulesCore.rrule(typeof($vmap), f, args...)
  end
end
end

module jitmul

use ISO_C_BINDING
use mkl_service
implicit none

! include "/opt/intel/mkl/include/mkl_direct_call.fi"
include "/home/chriselrod/intel/mkl/include/mkl_direct_call.fi"
! include "/home/chriselrod/intel/mkl/include/mkl_service.fi"
! include "/opt/intel/mkl/include/mkl_service.fi"
! include "/opt/intel/mkl/include/mkl.fi"

contains
  subroutine set_num_threads(N) bind(C, name = "set_num_threads")
    integer(C_int32_t) :: N
    call mkl_set_num_threads(N)
  end subroutine set_num_threads
  
    ! subroutine dgemmjit(C,A,B,M,K,N,alpha,beta) bind(C, name = "dgemmjit")
  subroutine sgemmjit(C,A,B,M,K,N,At,Bt) bind(C, name = "sgemmjit")
    integer(C_int32_t),  intent(in)  :: M, K, N
    integer(C_int8_t),   intent(in) :: At, Bt
    real(C_float), parameter :: alpha = 1.0e0, beta = 0.0e0
    ! real(C_float),                 intent(in)  :: alpha, beta
    real(C_float), dimension(M,K), intent(in)  :: A
    real(C_float), dimension(K,N), intent(in)  :: B
    real(C_float), dimension(M,N), intent(out) :: C
    character :: Atc, Btc
    ! call mkl_set_threading_layer(MKL_THREADING_SEQUENTIAL)
    if (At == 1_C_int8_t) then
       Atc = 'T'
    else
       Atc = 'N'
    end if
    if (Bt == 1_C_int8_t) then
       Btc = 'T'
    else
       Btc = 'N'
    end if
    call sgemm(Atc, Btc, M, N, K, alpha, A, M, B, K, beta, C, M)
  end subroutine sgemmjit
  subroutine dgemmjit(C,A,B,M,K,N,At,Bt) bind(C, name = "dgemmjit")
    integer(C_int32_t),  intent(in)  :: M, K, N
    integer(C_int8_t),   intent(in) :: At, Bt
    real(C_double), parameter :: alpha = 1.0d0, beta = 0.0d0
    ! real(C_double),                 intent(in)  :: alpha, beta
    real(C_double), dimension(M,K), intent(in)  :: A
    real(C_double), dimension(K,N), intent(in)  :: B
    real(C_double), dimension(M,N), intent(out) :: C
    character :: Atc, Btc
    ! call mkl_set_threading_layer(MKL_THREADING_SEQUENTIAL)
    if (At == 1_C_int8_t) then
       Atc = 'T'
    else
       Atc = 'N'
    end if
    if (Bt == 1_C_int8_t) then
       Btc = 'T'
    else
       Btc = 'N'
    end if
    call dgemm(Atc, Btc, M, N, K, alpha, A, M, B, K, beta, C, M)
  end subroutine dgemmjit
  subroutine dgemvjit(y,A,x,M,N,At) bind(C, name = "dgemvjit")
    integer(C_int32_t),  intent(in)  :: M, N
    integer(C_int8_t),   intent(in) :: At
    real(C_double), parameter :: alpha = 1.0d0, beta = 0.0d0
    ! real(C_double),                 intent(in)  :: alpha, beta
    real(C_double), dimension(M,N), intent(in)  :: A
    real(C_double), dimension(M), intent(in)  :: x
    real(C_double), dimension(N), intent(out) :: y
    character :: Atc
    ! call mkl_set_threading_layer(MKL_THREADING_SEQUENTIAL)
    if (At == 1_C_int8_t) then
       Atc = 'T'
    else
       Atc = 'N'
    end if
    call dgemv(Atc, M, N, alpha, A, M, x, 1, beta, y, 1)
  end subroutine dgemvjit

end module jitmul

using LoopVectorization
using Test
# T = Float32
@testset "GEMV" begin
  Unum, Tnum = LoopVectorization.VectorizationBase.register_count() == 16 ? (1, 6) : (1, 8)
  gemvq = :(
    for i ∈ eachindex(y)
      yᵢ = 0.0
      for j ∈ eachindex(x)
        yᵢ += A[i, j] * x[j]
      end
      y[i] = yᵢ
    end
  )
  lsgemv = LoopVectorization.loopset(gemvq)
  if LoopVectorization.register_count() != 8
    @test LoopVectorization.choose_order(lsgemv) == (Symbol[:i, :j], :j, :i, :i, Unum, Tnum)
  end

  function mygemv!(y, A, x)
    @inbounds for i ∈ eachindex(y)
      yᵢ = zero(eltype(y))
      @simd for j ∈ eachindex(x)
        yᵢ += A[i, j] * x[j]
      end
      y[i] = yᵢ
    end
  end
  function mygemvavx!(y, A, x)
    @turbo for i ∈ eachindex(y)
      yᵢ = zero(eltype(y))
      for j ∈ eachindex(x)
        yᵢ += A[i, j] * x[j]
      end
      y[i] += yᵢ
    end
  end
  function mygemvavx_range!(y, A, x)
    rng1, rng2 = axes(A)
    @turbo for i ∈ rng1
      yᵢ = zero(eltype(y))
      for j ∈ rng2
        yᵢ += A[i, j] * x[j]
      end
      y[i] = yᵢ
    end
  end
  # q = :(for i ∈ eachindex(y)
  #       yᵢ = zero(eltype(y))
  #       for j ∈ eachindex(x)
  #       yᵢ += A[i,j] * x[j]
  #       end
  #       y[i] = yᵢ
  #       end);
  # ls = LoopVectorization.loopset(q);
  function mygemv_avx!(y, A, x)
    # Need to test 0s somewhere!
    @_avx for i ∈ eachindex(y)
      yᵢ = 0.0#zero(eltype(y))
      for j ∈ eachindex(x)
        yᵢ += A[i, j] * x[j]
      end
      y[i] = yᵢ
    end
  end
  # q = :(for i ∈ eachindex(y)
  #         yᵢ = 0.0#zero(eltype(y))
  #         for j ∈ eachindex(x)
  #             yᵢ += A[i,j] * x[j]
  #         end
  #         y[i] = yᵢ
  #   end);
  # ls = LoopVectorization.loopset(q);
  # LoopVectorization.lower(ls, 2, 2, 0)


  function AtmulvB!(G, B, κ)
    d = size(G, 1)
    @inbounds for d1 = 1:d
      G[d1, κ] = B[1, d1] * B[1, κ]
      for d2 = 2:d
        G[d1, κ] += B[d2, d1] * B[d2, κ]
      end
    end
  end
  function AtmulvBavx1!(G, B, κ)
    d = size(G, 1)
    δ = 0
    z = zero(eltype(G))
    @turbo for d1 = 1:d
      G[d1, κ-δ] = z
      for d2 = 1:d
        G[d1, κ-δ] += B[d2, d1] * B[d2, κ+δ]
      end
    end
  end
  function AtmulvBavx2!(G, B, κ)
    d = size(G, 1)
    δ = 0
    @turbo for d1 = 1:d
      z = zero(eltype(G))
      for d2 = 1:d
        z += B[d2-δ, d1] * B[d2, κ-δ]
      end
      G[d1, κ] = z
    end
  end
  function AtmulvBavx3!(G, B, κ)
    d = size(G, 1)
    @turbo unroll = (2, 2) for d1 = 1:d
      G[d1, κ] = B[1, d1] * B[1, κ]
      for d2 = 2:d
        G[d1, κ] += B[d2, d1] * B[d2, κ]
      end
    end
  end

  function AtmulvB_avx1!(G, B, κ)
    d = size(G, 1)
    z = zero(eltype(G))
    @_avx for d1 = 1:d
      G[d1, κ] = z
      for d2 = 1:d
        G[d1, κ] += B[d2, d1] * B[d2, κ]
      end
    end
  end
  function AtmulvB_avx2!(G, B, κ)
    d = size(G, 1)
    @_avx for d1 = 1:d
      z = zero(eltype(G))
      for d2 = 1:d
        z += B[d2, d1] * B[d2, κ]
      end
      G[d1, κ] = z
    end
  end
  gemvq = :(
    for d1 = 1:d
      z = zero(eltype(G))
      for d2 = 1:d
        z += B[d2, d1] * B[d2, κ]
      end
      G[d1, κ] = z
    end
  )
  lsgemv = LoopVectorization.loopset(gemvq)
  if LoopVectorization.register_count() != 8
    @test LoopVectorization.choose_order(lsgemv) == ([:d1, :d2], :d2, :d1, :d2, Unum, Tnum)
  end
  function AtmulvB_avx3!(G, B, κ)
    d = size(G, 1)
    @_avx for d1 = 1:d
      G[d1, κ] = B[1, d1] * B[1, κ]
      for d2 = 2:d
        G[d1, κ] += B[d2, d1] * B[d2, κ]
      end
    end
  end
  pq = :(
    for d1 = 1:d
      G[d1, κ] = B[1, d1] * B[1, κ]
      for d2 = 2:d
        G[d1, κ] += B[d2, d1] * B[d2, κ]
      end
    end
  )
  lsp = LoopVectorization.loopset(pq)
  if LoopVectorization.register_count() != 8
    @test LoopVectorization.choose_order(lsp) == ([:d1, :d2], :d2, :d1, :d2, Unum, Tnum)
  end
  # lsp.preamble_symsym

  function hhavx!(A::AbstractVector{T}, B, C, D) where {T}
    L = T(length(axes(B, 2)))
    @turbo for i in axes(A, 1)
      A[i] = A[i] + D[i] * L
      for j in axes(B, 2)
        B[i, j] = B[i, j] + D[i]
        C[j] = C[j] + D[i]
      end
    end
  end
  function hh!(A::AbstractVector{T}, B, C, D) where {T}
    L = T(length(axes(B, 2)))
    @inbounds @fastmath for i in axes(A, 1)
      A[i] = A[i] + D[i] * L
      for j in axes(B, 2)
        B[i, j] = B[i, j] + D[i]
        C[j] = C[j] + D[i]
      end
    end
  end

  function tuplemul!(out::Vector{Tuple{T,T}}, A::Matrix{Tuple{T,T}}, b::Vector{T}) where {T}
    rA, rout = reinterpret(T, A), reinterpret(T, out)
    fill!(rout, 0)
    for j in axes(A, 2), i in axes(A, 1)
      ii = 2 * (i - 1) + 1
      rout[ii] += rA[ii, j] * b[j]
      rout[ii+1] += rA[ii+1, j] * abs(b[j])
    end
    return out
  end
  function tuplemulavx!(
    out::Vector{Tuple{T,T}},
    A::Matrix{Tuple{T,T}},
    b::Vector{T},
  ) where {T}
    rA, rout = reinterpret(T, A), reinterpret(T, out)
    fill!(rout, 0)
    @turbo for j in axes(A, 2), i in axes(A, 1)
      ii = 2 * (i - 1) + 1
      rout[ii] += rA[ii, j] * b[j]
      rout[ii+1] += rA[ii+1, j] * abs(b[j])
    end
    return out
  end


  function multiple_muls!(Y, dY, A, dA, b, db)
    mul!(dY, dA, b)
    # much of the cost is in memory bandwidth for traversing `A`, so we group the two together
    mul!(Y, A, b)
    mul!(dY, A, db, true, true)
    nothing
  end
  function multiple_muls_avx!(Y, dY, A, dA, b, db)
    @turbo for m ∈ axes(A, 1)
      dy = 0.0
      y = 0.0
      for n ∈ axes(A, 2)
        dy += dA[m, n] * b[n] + A[m, n] * db[n]
        y += A[m, n] * b[n]
      end
      dY[m] = dy
      Y[m] = y
    end
  end

  function depchain_with_different_deps!(c1, c2, A, b)
    @turbo for j in axes(A, 1), k in axes(A, 2)
      c1[j] += A[j, k] * b[k]
      c2[j] += A[j, k] * b[k] - 0 * b[j]
    end
  end

  M, K, N = 51, 49, 61
  for T ∈ (Float32, Float64, Int32, Int64)
    @show T, @__LINE__
    TC = sizeof(T) == 4 ? Float32 : Float64
    R = T <: Integer ? (T(-1000):T(1000)) : T
    Afull = fill(T(10^3), 3M, 3K)
    xfull = fill(T(1), 3K)
    y1full = fill(TC(-1000), 3M)
    y2full = copy(y1full)

    A = view(Afull, M .+ (1:M), K .+ (1:K))
    A .= rand.(Ref(R))
    x = view(xfull, K .+ (1:K))
    x .= rand.(Ref(R))
    y1 = view(y1full, M .+ (1:M))
    y2 = view(y2full, M .+ (1:M))

    # A = rand(R, M, K);
    # x = rand(R, K);
    # y1 = Vector{TC}(undef, M); y2 = similar(y1);

    mygemv!(y1, A, x)
    fill!(y2, 0)
    mygemvavx!(y2, A, x)
    @test y1full ≈ y2full
    mygemvavx!(y2, A, x)
    @test y1 .* 2 ≈ y2
    mygemvavx!(y2, A, x)
    @test y1 .* 3 ≈ y2
    fill!(y2, -9999)
    mygemv_avx!(y2, A, x)
    @test y1full ≈ y2full
    fill!(y2, -9999)
    mygemvavx_range!(y2, A, x)
    @test y1full ≈ y2full

    let M = 56
      A = view(Afull, M .+ (1:M), K .+ (1:K))
      A .= rand.(Ref(R))
      y1 = view(y1full, M .+ (1:M))
      y2 = view(y2full, M .+ (1:M))
      Abit = A .> 0.5
      if LoopVectorization.pick_vector_width(T) ≥ 8
        fill!(y2, -9999)
        mygemv_avx!(y2, Abit, x)
        @test y2 ≈ Abit * x
      end
      fill!(y2, 0)
      mygemvavx!(y2, Abit, x)
      @test y2 ≈ Abit * x
      xbit = x .> 0.5
      fill!(y2, -9999)
      mygemv_avx!(y2, A, xbit)
      @test y2 ≈ A * xbit
      fill!(y2, 0)
      mygemvavx!(y2, A, xbit)
      @test y2 ≈ A * xbit
    end

    # Check for out of bounds stores
    fill!(y1, 0)
    fill!(y2, 0)
    @test y1full ≈ y2full

    B = rand(R, N, N)
    G1 = Matrix{TC}(undef, N, 1)
    G2 = similar(G1)
    # G3 = similar(G1);
    AtmulvB!(G1, B, 1)
    AtmulvBavx1!(G2, B, 1)
    @test G1 ≈ G2
    fill!(G2, TC(NaN))
    AtmulvBavx2!(G2, B, 1)

    @test G1 ≈ G2
    fill!(G2, TC(NaN))
    AtmulvBavx3!(G2, B, 1)
    @test G1 ≈ G2
    fill!(G2, TC(NaN))
    AtmulvB_avx1!(G2, B, 1)
    @test G1 ≈ G2
    fill!(G2, TC(NaN))
    AtmulvB_avx2!(G2, B, 1)
    @test G1 ≈ G2
    fill!(G2, TC(NaN))
    AtmulvB_avx3!(G2, B, 1)
    @test G1 ≈ G2

    D = rand(R, M)
    B1 = rand(R, M, N)
    B2 = copy(B1)
    C1 = rand(R, N)
    C2 = copy(C1)
    A1 = rand(R, size(D)...)
    A2 = copy(A1)
    hh!(A1, B1, C1, D)
    hhavx!(A2, B2, C2, D)
    @test B1 ≈ B2
    @test C1 ≈ C2
    @test A1 ≈ A2

    A = [(rand(R), rand(R)) for i = 1:11, j = 1:13]
    b = rand(R, 13)
    out1 = similar(A, 11)
    out2 = similar(out1)
    @test reinterpret(T, tuplemul!(out1, A, b)) ≈ reinterpret(T, tuplemulavx!(out2, A, b))


    A = rand(R, N, N)
    dA = rand(R, N, N)
    b = rand(R, N)
    db = rand(R, N)
    Y0 = Vector{TC}(undef, N)
    Y1 = similar(Y0)
    dY0 = similar(Y0)
    dY1 = similar(Y0)

    multiple_muls!(Y0, dY0, A, dA, b, db)
    multiple_muls_avx!(Y1, dY1, A, dA, b, db)
    @test Y0 ≈ Y1
    @test dY0 ≈ dY1

    Y2 = zeros(TC, N, 2)
    Y3 = zeros(TC, N, 2)
    depchain_with_different_deps!(Y2, Y3, A, b)
    @test view(Y2, :, 1) == view(Y3, :, 1)
    @test view(Y2, :, 1) ≈ A * b
  end
end

@enum IndexType::UInt8 NotAnIndex = 0 LoopIndex = 1 ComputedIndex = 2 SymbolicIndex =
  3

Base.:|(u::Unsigned, it::IndexType) = u | UInt8(it)
Base.:(==)(u::Unsigned, it::IndexType) = (u % UInt8) == UInt8(it)

function _append_fields!(t::Expr, body::Expr, sym::Symbol, ::Type{T}) where {T}
  for f ∈ 1:fieldcount(T)
    TF = fieldtype(T, f)
    Base.issingletontype(TF) && continue
    gfcall = Expr(:call, getfield, sym, f)
    if fieldcount(TF) ≡ 0 || TF <: Array
      push!(t.args, gfcall)
    elseif TF <: DataType
      push!(t.args, Expr(:call, Expr(:curly, lv(:StaticType), gfcall)))
    else
      newsym = gensym(sym)
      push!(body.args, Expr(:(=), newsym, gfcall))
      _append_fields!(t, body, newsym, TF)
    end
  end
  return nothing
end
@generated function flatten_to_tuple(r::T) where {T}
  body = Expr(:block, Expr(:meta, :inline))
  t = Expr(:tuple)
  if Base.issingletontype(T)
    nothing
  elseif fieldcount(T) ≡ 0 || T <: Array
    push!(t.args, :r)
  elseif T <: DataType
    push!(t.args, Expr(:call, Expr(:curly, lv(:StaticType), :r)))
  else
    _append_fields!(t, body, :r, T)
  end
  push!(body.args, t)
  body
end
function rebuild_fields(offset::Int, ::Type{T}) where {T}
  call = (T <: Tuple) ? Expr(:tuple) : Expr(:new, T)
  for f ∈ 1:fieldcount(T)
    TF = fieldtype(T, f)
    if Base.issingletontype(TF)
      push!(call.args, TF.instance)
    elseif fieldcount(TF) ≡ 0 || TF <: Array
      push!(call.args, Expr(:call, getfield, :t, (offset += 1)))
    elseif TF <: DataType
      push!(
        call.args,
        Expr(:call, lv(:gettype), Expr(:call, getfield, :t, (offset += 1)))
      )
    else
      arg, offset = rebuild_fields(offset, TF)
      push!(call.args, arg)
    end
  end
  return call, offset
end
@generated function reassemble_tuple(::Type{T}, t::Tuple) where {T}
  if Base.issingletontype(T)
    return T.instance
  elseif fieldcount(T) ≡ 0 || T <: Array
    call = Expr(:call, getfield, :t, 1)
  elseif T <: DataType
    call = Expr(:call, lv(:gettype), Expr(:call, getfield, :t, 1))
  else
    call, _ = rebuild_fields(0, T)
  end
  Expr(:block, Expr(:meta, :inline), call)
end

"""
    ArrayRefStruct

A condensed representation of an [`ArrayReference`](@ref).
It supports array-references with up to 8 indexes, where the data for each consecutive index is packed into corresponding 8-bit fields
of `index_types` (storing the enum `IndexType`), `indices` (the `id` for each index symbol), and `offsets` (currently unused).
"""
struct ArrayRefStruct{array,ptr}
  index_types::UInt128
  indices::UInt128
  offsets::UInt128
  strides::UInt128
end
array_and_ptr(@nospecialize(ar::ArrayRefStruct{a,p})) where {a,p} =
  (a::Symbol, p::Symbol)
# array(@nospecialize(ar::ArrayRefStruct{a,p})) where {a,p} = a::Symbol
# ptr(@nospecialize(ar::ArrayRefStruct{a,p})) where {a,p}   = p::Symbol

function findindoradd!(v::Vector{T}, s::T) where {T}
  ind = findfirst(==(s), v)
  ind === nothing || return ind
  push!(v, s)
  length(v)
end
function ArrayRefStruct(
  ls::LoopSet,
  mref::ArrayReferenceMeta,
  arraysymbolinds::Vector{Symbol},
  ids::Vector{Int}
)
  index_types = zero(UInt128)
  indices = zero(UInt128)
  offsets = zero(UInt128)
  strides = zero(UInt128)
  @unpack loopedindex, ref = mref
  indv = ref.indices
  offv = ref.offsets
  strv = ref.strides
  # we can discard that the array was considered discontiguous, as it should be recovered from type information
  start = 1 + (first(indv) === DISCONTIGUOUS)
  for (n, ind) ∈ enumerate(@view(indv[start:end]))
    index_types <<= 8
    indices <<= 8
    offsets <<= 8
    offsets |= (offv[n] % UInt8)
    strides <<= 8
    strides |= (strv[n] % UInt8)
    if loopedindex[n]
      index_types |= LoopIndex
      if strv[n] ≠ 0
        indices |= getloopid(ls, ind)
      end
    else
      parent = get(ls.opdict, ind, nothing)
      @assert !(parent === nothing) "Index $ind not found in array."
      # if parent === nothing
      #     index_types |= SymbolicIndex
      #     indices |= findindoradd!(arraysymbolinds, ind)
      # else
      index_types |= ComputedIndex
      indices |= ids[identifier(parent)]
      # end
    end
  end
  ArrayRefStruct{mref.ref.array,mref.ptr}(
    index_types,
    indices,
    offsets,
    strides
  )
end

"""
    OperationStruct

A condensed representation of an [`Operation`](@ref).
"""
struct OperationStruct <: AbstractLoopOperation
  # instruction::Instruction
  loopdeps::UInt128
  reduceddeps::UInt128
  childdeps::UInt128
  parents₀::UInt128
  parents₁::UInt128
  parents₂::UInt128
  parents₃::UInt128
  node_type::OperationType
  symid::UInt16
  array::UInt16
end
optype(os) = os.node_type

function findmatchingarray(ls::LoopSet, mref::ArrayReferenceMeta)
  id = 0x0001
  for r ∈ ls.refs_aliasing_syms
    r == mref && return id
    id += 0x0001
  end
  0x0000
end
filled_8byte_chunks(u::T) where {T<:Unsigned} =
  sizeof(T) - (leading_zeros(u) >>> 3)

function shifted_loopset(ls::LoopSet, loopsyms::Vector{Symbol})
  ld = zero(UInt128) # leading_zeros(ld) >> 2 yields the number of loopdeps
  for d ∈ loopsyms
    ld <<= 4
    ld |= getloopid(ls, d)::Int
  end
  ld
end
loopdeps_uint(ls::LoopSet, op::Operation) =
  shifted_loopset(ls, loopdependencies(op))
reduceddeps_uint(ls::LoopSet, op::Operation) =
  shifted_loopset(ls, reduceddependencies(op))
childdeps_uint(ls::LoopSet, op::Operation) =
  shifted_loopset(ls, reducedchildren(op))
function parents_uint(oppv::AbstractVector{Operation})
  p = zero(UInt128)
  for parent ∈ oppv
    p <<= 16
    p |= identifier(parent)
  end
  p
end
function parents_uint(op::Operation)
  opv = parents(op)
  N = length(opv)
  @assert N ≤ 32
  p0 = parents_uint(view(opv, 1:min(8, N)))
  p1 = N > 8 ? parents_uint(view(opv, 9:min(16, N))) : zero(p0)
  p2 = N > 16 ? parents_uint(view(opv, 17:min(24, N))) : zero(p0)
  p3 = N > 24 ? parents_uint(view(opv, 25:N)) : zero(p0)
  p0, p1, p2, p3
end
function recursively_set_parents_true!(x::Vector{Bool}, op::Operation)
  x[identifier(op)] && return nothing # don't redescend
  x[identifier(op)] = true
  for opp ∈ parents(op)
    recursively_set_parents_true!(x, opp)
  end
  return nothing
end
function getroots(ls::LoopSet)::Vector{Bool}
  rooted = Vector{Bool}(undef, length(operations(ls)))
  getroots!(rooted, ls)
end
function getroots!(rooted::Vector{Bool}, ls::LoopSet)
  fill!(rooted, false)
  ops = operations(ls)
  for or ∈ ls.outer_reductions
    recursively_set_parents_true!(rooted, ops[or])
  end
  for op ∈ ops
    isstore(op) && recursively_set_parents_true!(rooted, op)
  end
  remove_outer_reducts!(rooted, ls)
  return rooted
end
function OperationStruct!(
  varnames::Vector{Symbol},
  ids::Vector{Int},
  ls::LoopSet,
  op::Operation
)
  ld = loopdeps_uint(ls, op)
  rd = reduceddeps_uint(ls, op)
  cd = childdeps_uint(ls, op)
  p0, p1, p2, p3 = parents_uint(op)
  array = accesses_memory(op) ? findmatchingarray(ls, op.ref) : 0x0000
  ids[identifier(op)] = id = findindoradd!(varnames, name(op))
  OperationStruct(ld, rd, cd, p0, p1, p2, p3, op.node_type, id, array)
end
## turn a LoopSet into a type object which can be used to reconstruct the LoopSet.

@inline zerorangestart(r::Base.OneTo) = CloseOpen(maybestaticlast(r))
@inline zerorangestart(r::AbstractCloseOpen) = CloseOpen(length(r))
@inline zerorangestart(r::AbstractCloseOpen{Zero}) = r
@inline zerorangestart(r::AbstractUnitRange) =
  Zero():One():(maybestaticlast(r)-maybestaticfirst(r))
@inline zerorangestart(r::AbstractRange) =
  Zero():static_step(r):(maybestaticlast(r)-maybestaticfirst(r))
@inline zerorangestart(r::CartesianIndices) =
  CartesianIndices(map(zerorangestart, r.indices))
@inline zerorangestart(
  r::ArrayInterface.OptionallyStaticUnitRange{StaticInt{1}}
) = CloseOpen(maybestaticlast(r))

function loop_boundary!(q::Expr, loop::Loop, shouldindbyind::Bool)
  if isstaticloop(loop) || loop.rangesym === Symbol("")
    call = Expr(:call, :(:))
    f = gethint(first(loop))
    s = gethint(step(loop))
    l = gethint(last(loop))
    if !shouldindbyind
      l -= f
      f = 0
    end
    pushexpr!(call, staticexpr(f))
    isone(s) || pushexpr!(call, staticexpr(s))
    pushexpr!(call, staticexpr(l))
    push!(q.args, call)
  elseif shouldindbyind
    push!(q.args, loop.rangesym)
  else
    push!(q.args, Expr(:call, lv(:zerorangestart), loop.rangesym))
  end
end

function loop_boundaries(ls::LoopSet, shouldindbyind::Vector{Bool})
  lbd = Expr(:tuple)
  for (ibi, loop) ∈ zip(shouldindbyind, ls.loops)
    loop_boundary!(lbd, loop, ibi)
  end
  lbd
end

tuple_expr(v) = tuple_expr(identity, v)
function tuple_expr(f, v)
  t = Expr(:tuple)
  for vᵢ ∈ v
    push!(t.args, f(vᵢ))
  end
  t
end

function argmeta_and_consts_description(ls::LoopSet, arraysymbolinds)
  Expr(
    :tuple,
    length(arraysymbolinds),
    tuple_expr(ls.outer_reductions),
    tuple_expr(first, ls.preamble_symsym),
    tuple_expr(ls.preamble_symint),
    tuple_expr(ls.preamble_symfloat),
    tuple_expr(ls.preamble_zeros),
    tuple_expr(ls.preamble_funcofeltypes)
  )
end
@inline vdata(v::Vec) = getfield(v, :data)
@inline vdata(v::VecUnroll) = getfield(v, :data)
@inline vdata(x) = x

function loopset_return_value(ls::LoopSet, ::Val{extract}) where {extract}
  @assert !iszero(length(ls.outer_reductions))
  if isone(length(ls.outer_reductions))
    op = getop(ls, ls.outer_reductions[1])
    if extract
      # if (isu₁unrolled(op) | isu₂unrolled(op))
      Expr(:call, :vdata, Symbol(mangledvar(op), "##onevec##"))
      # else
      # Expr(:call, :data, mangledvar(op))
      # end
    else
      Symbol(mangledvar(op), "##onevec##")
    end
  else#if length(ls.outer_reductions) > 1
    ret = Expr(:tuple)
    ops = operations(ls)
    for or ∈ ls.outer_reductions
      op = ops[or]
      if extract
        push!(
          ret.args,
          Expr(:call, :vdata, Symbol(mangledvar(op), "##onevec##"))
        )
      else
        push!(ret.args, Symbol(mangledvar(ops[or]), "##onevec##"))
      end
    end
    ret
  end
end
const DROPPEDCONSTANT =
  Instruction(Symbol("##DROPPED#CONSTANT##"), Symbol("##DROPPED#CONSTANT##"))
function skip_constant(instr::Instruction)
  (
    ((instr == LOOPCONSTANT) || (instr.mod === :numericconstant)) ||
    (instr == DROPPEDCONSTANT)
  ) || instr.mod === GLOBALCONSTANT
end

function add_reassigned_syms!(q::Expr, ls::LoopSet)
  for op ∈ operations(ls)
    if isconstant(op)
      instr = instruction(op)
      skip_constant(instr) || push!(q.args, instr.instr)
    end
  end
end
function add_external_functions!(q::Expr, ls::LoopSet)
  for op ∈ operations(ls)
    if iscompute(op)
      instr = instruction(op)
      if instr.mod !== :LoopVectorization
        push!(q.args, instr.instr)
      end
    end
  end
end

# _any(f, x::Tuple{}) = false
# _any(f, x::Tuple{T}) where {T} = f(@inbounds x[1])::Bool
# _any(f, x::Tuple{T0,T1,Vararg}) where {T0,T1} = f(@inbounds x[1])::Bool || _any(f,Base.tail(x))::Bool

_any_empty(x::Tuple{}) = false
_any_empty(x::Tuple{T}) where {T} = isempty(@inbounds x[1])::Bool
_any_empty(x::Tuple{T0,T1,Vararg}) where {T0,T1} =
  isempty(@inbounds x[1])::Bool || _any_empty(Base.tail(x))::Bool

function check_if_empty(ls::LoopSet, q::Expr)
  lb = loop_boundaries(ls, fill(false, length(ls.loops)))
  # Expr(:if, Expr(:call, :!, Expr(:call, _any, :isempty, lb)), q)
  Expr(:if, Expr(:call, :!, Expr(:call, _any_empty, lb)), q)
end

val(x) = Expr(:call, Expr(:curly, :Val, x))

@inline gespf1(x, i) = gesp(x, i)
@inline gespf1(
  x::StridedPointer{T,1},
  i::Tuple{I}
) where {T,I<:Union{Integer,StaticInt}} = gesp(x, i)
@inline gespf1(
  x::StridedBitPointer{T,1},
  i::Tuple{I}
) where {T,I<:Union{Integer,StaticInt}} = gesp(x, i)
@inline gespf1(x::StridedPointer{T,1}, i::Tuple{Zero}) where {T} = x
@inline gespf1(x::StridedBitPointer{T,1}, i::Tuple{Zero}) where {T} = x
@generated function gespf1(
  x::AbstractStridedPointer{T,N,C,B,R},
  i::Tuple{I}
) where {T,N,I<:Union{Integer,StaticInt},C,B,R}
  ri = argmin(R)
  quote
    $(Expr(:meta, :inline))
    p, li = VectorizationBase.tdot(
      x,
      (vsub_nsw(getfield(i, 1), one($I)),),
      static_strides(x)
    )
    ptr = gep(p, li)
    si = ArrayInterface.StrideIndex{1,$(R[ri],),$(C === 1 ? 1 : 0)}(
      (getfield(static_strides(x), $ri),),
      (Zero(),)
    )
    stridedpointer(ptr, si, StaticInt{$(B === 1 ? 1 : 0)}())
  end
end
@generated function gespf1(
  x::AbstractStridedPointer{T,N,C,B,R},
  ::Tuple{VectorizationBase.NullStep}
) where {T,N,C,B,R}
  ri = argmin(R)
  quote
    $(Expr(:meta, :inline))
    si = ArrayInterface.StrideIndex{1,$(R[ri],),$(C === 1 ? 1 : 0)}(
      (getfield(static_strides(x), $ri),),
      (getfield(offsets(x), $ri),)
    )
    stridedpointer(pointer(x), si, StaticInt{$(B == 1 ? 1 : 0)}())
  end
end
function findfirstcontaining(ref, ind)
  for (i, indr) ∈ enumerate(getindicesonly(ref))
    ind === indr && return i
  end
  0
end
function should_zerorangestart(
  ls::LoopSet,
  allarrayrefs::Vector{ArrayReferenceMeta},
  name_to_array_map::Vector{Vector{Int}},
  isrooted::Vector{Bool}
)
  loops = ls.loops
  shouldindbyind = fill(false, length(loops))
  for (i, loop) ∈ enumerate(loops)
    ind = loop.itersymbol
    if isloopvalue(ls, ind, isrooted)
      # we don't zero the range if it is used as a loopvalue
      shouldindbyind[i] = true
      continue
    end
    # otherwise, we need
    for namev ∈ name_to_array_map
      baseref = allarrayrefs[first(namev)]
      # firstcontainsind relies on stripping of duplicate inds in parsing
      firstcontainsind = findfirstcontaining(baseref, ind)
      basestride =
        firstcontainsind == 0 ? 0 : getstrides(baseref)[firstcontainsind]
      allsame = true
      # The idea here is that if any ref to the same array doesn't have `ind`,
      # we can't offset that dimension because different inds will clash.
      # Because offsetting the array means counter-offsetting the range, we need
      # to be consistent, and check that all arrays are valid first.
      for j ∈ @view(namev[2:end])
        ref = allarrayrefs[j]
        if (firstcontainsind ≠ findfirstcontaining(ref, ind)) || (
          (firstcontainsind ≠ 0) &&
          (basestride ≠ getstrides(ref)[firstcontainsind])
        )
          allsame = false
          break
        end
      end
      if !allsame
        shouldindbyind[i] = true
        break
      end
    end
  end
  return shouldindbyind
end
function check_shouldindbyind(
  ls::LoopSet,
  ind::Symbol,
  shouldindbyind::Vector{Bool}
)
  for (i, loop) ∈ enumerate(ls.loops)
    loop.itersymbol === ind && return shouldindbyind[i]
  end
  true
end

@inline densewrapper(sp, A) = sp
@inline densewrapper(
  sp::AbstractStridedPointer{T,N},
  A::AbstractArray{T,N}
) where {T,N} = _densewrapper(sp, VectorizationBase.val_dense_dims(A))
@inline _densewrapper(sp, ::Nothing) = sp
@inline _densewrapper(sp::AbstractStridedPointer, ::Val{D}) where {D} =
  VectorizationBase.DensePointerWrapper{D}(sp)

# write a "check_loops_safe_to_zerorangestart
# that will be used to
# 1) decide whether to zerorangestart
# 2) decide whether to gesp that loopstart inside `add_grouped_strided_pointer`
function add_grouped_strided_pointer!(extra_args::Expr, ls::LoopSet)
  allarrayrefs, name_to_array_map, unique_to_name_and_op_map =
    uniquearrayrefs_csesummary(ls)
  gsp = Expr(:call, lv(:grouped_strided_pointer))
  tgarrays = Expr(:tuple)
  # refs_to_gesp = ArrayReferenceMeta[]
  gespsummaries = Tuple{Int,Vector{Symbol}}[]
  i = 0
  preserve_assignment = Expr(:tuple)
  preserve = Symbol[]
  @unpack equalarraydims, refs_aliasing_syms = ls
  # duplicate_map = collect(1:length(refs_aliasing_syms))
  duplicate_map = Vector{Int}(undef, length(refs_aliasing_syms))

  # for (i,j) ∈ enumerate(array_refs_with_same_name) # iterate over unique names
  #   ar = allarrayrefs[j]
  #   gespinds = cse_constant_offsets!(ls, allarrayrefs, j, array_refs_with_same_name, arrayref_to_name_op_collection)
  # end
  for (j, ref) ∈ enumerate(refs_aliasing_syms)
    vpref = vptr(ref)
    duplicate = false
    for k ∈ 1:j-1 # quadratic, but should be short enough so that this is faster than O(1) algs
      if vptr(refs_aliasing_syms[k]) === vpref
        duplicate = true
        break
      end
    end
    duplicate && continue
    duplicate_map[j] = (i += 1)
    found = false
    for k ∈ eachindex(allarrayrefs)
      if sameref(allarrayrefs[k], ref)
        gespindsummary = cse_constant_offsets!(
          ls,
          allarrayrefs,
          k,
          name_to_array_map,
          unique_to_name_and_op_map
        )
        push!(gespsummaries, (k, gespindsummary))
        found = true
        break
      end
    end
    @assert found
    push!(preserve, presbufsym(ref.ref.array))
  end
  roots = getroots(ls)
  shouldindbyind =
    should_zerorangestart(ls, allarrayrefs, name_to_array_map, roots)
  for (k, gespindsummary) ∈ gespsummaries
    ref = allarrayrefs[k]
    gespinds = calcgespinds(
      ls,
      ref,
      gespindsummary,
      shouldindbyind,
      name_to_array_map[first(first(unique_to_name_and_op_map[k]))],
      unique_to_name_and_op_map
    )
    push!(
      tgarrays.args,
      Expr(
        :call,
        lv(:densewrapper),
        Expr(:call, lv(:gespf1), vptr(ref), gespinds),
        name(ref)
      )
    )
  end
  push!(gsp.args, tgarrays)
  matcheddims = Expr(:tuple)
  for (vptrs, dims) ∈ equalarraydims
    t = Expr(:tuple)
    for (vp, d) ∈ zip(vptrs, dims)
      _id = findfirst(Base.Fix2(===, vp) ∘ vptr, refs_aliasing_syms)
      _id === nothing && continue
      push!(t.args, Expr(:tuple, duplicate_map[_id], d))
    end
    length(t.args) > 1 && push!(matcheddims.args, t)
  end
  push!(gsp.args, val(matcheddims))
  gsps = gensym!(ls, "#grouped#strided#pointer#")
  push!(extra_args.args, gsps)
  pushpreamble!(ls, Expr(:(=), gsps, Expr(:call, getfield, gsp, 1)))
  preserve, shouldindbyind, roots
end

@generated function _turbo_config_val(
  ::Val{CNFARG},
  ::StaticInt{W},
  ::StaticInt{RS},
  ::StaticInt{AR},
  ::StaticInt{NT},
  ::StaticInt{CLS}
) where {CNFARG,W,RS,AR,CLS,NT}
  inline, u₁, u₂, v, BROADCAST, thread, warncheckarg, safe = CNFARG
  nt = min(thread % UInt, NT % UInt)
  t = Expr(
    :tuple,
    inline,
    u₁,
    u₂,
    v,
    BROADCAST,
    W,
    RS,
    AR,
    CLS,
    nt,
    warncheckarg,
    safe
  )
  length(CNFARG) == 7 && push!(t.args, CNFARG[7])
  Expr(:call, Expr(:curly, :Val, t))
end
@inline function avx_config_val(::Val{CNFARG}, ::StaticInt{W}) where {CNFARG,W}
  _turbo_config_val(
    Val{CNFARG}(),
    StaticInt{W}(),
    register_size(),
    available_registers(),
    num_cores(), #FIXME
    cache_linesize()
  )
end
function find_samename_constparent(op::Operation, opname::Symbol)
  for opp ∈ parents(op)
    ((
      (isconstant(opp) && instruction(opp) == LOOPCONSTANT) &&
      (name(opp) === opname)
    )) && return opp
    opptemp = find_samename_constparent(opp, opname)
    opptemp === opp || return opptemp
  end
  op
end
function remove_outer_reducts!(roots::Vector{Bool}, ls::LoopSet)
  ops = operations(ls)
  for or ∈ ls.outer_reductions
    op = ops[or]
    optemp = find_samename_constparent(op, name(op))
    if optemp ≢ op
      roots[identifier(optemp)] = false
    end
  end
end

function split_ifelse!(
  ls::LoopSet,
  preserve::Vector{Symbol},
  shouldindbyind::Vector{Bool},
  roots::Vector{Bool},
  extra_args::Expr,
  k::Int,
  inlineu₁u₂::Tuple{Bool,Int8,Int8,Int8},
  thread::UInt,
  warncheckarg::Int,
  safe::Bool,
  debug::Bool
)
  roots[k] = false
  op = operations(ls)[k]
  op.instruction = DROPPEDCONSTANT
  op.node_type = constant
  # we want to eliminate
  parents_op = parents(op)
  condop = first(parents_op)
  # create one loop where `opp` is true, and a second where it is `false`
  prepre = ls.prepreamble
  append!(prepre.args, ls.preamble.args)
  ls.prepreamble = Expr(:block)
  ls.preamble = Expr(:block)
  ls_true = deepcopy(ls)
  lsfalse = ls
  true_ops = operations(ls_true)
  falseops = operations(lsfalse)
  true_op = parents(true_ops[k])[2]
  falseop = parents_op[3]
  true_op.dependencies = loopdependencies(op)
  falseop.dependencies = loopdependencies(op)
  true_op.reduced_children = reducedchildren(op)
  falseop.reduced_children = reducedchildren(op)
  condop_count = 0
  for i ∈ eachindex(falseops)
    fop = falseops[i]
    parents_false = parents(fop)
    for (j, opp) ∈ enumerate(parents_false)
      if opp === op # then ops[i]'s jth parent is the ifelse
        # These reduction to scalar instructions are added for non-outer reductions initialized with non-constant ops
        # So we check if now 
        # if (j == 2) && (Base.sym_in(instruction(fop).instr, (:reduced_add, :reduced_prod, :reduced_max, :reduced_min, :reduced_all, :reduced_any)))
        # if isconstantop(true_op)
        #   (true_ops[i]).instruction = Instruction(:identity)
        # end
        # if isconstantop(falseop)
        #   fop.instruction = Instruction(:identity)
        # end
        # end
        parents(true_ops[i])[j] = true_op
        parents_false[j] = falseop
      end
      condop_count += roots[i] & (condop === opp)
    end
  end
  roots[identifier(condop)] &= condop_count > 0
  q = :(
    if $(name(condop))
      $(generate_call_split(
        ls_true,
        preserve,
        shouldindbyind,
        roots,
        copy(extra_args),
        inlineu₁u₂,
        thread,
        warncheckarg,
        safe,
        debug
      ))
    else
      $(generate_call_split(
        lsfalse,
        preserve,
        shouldindbyind,
        roots,
        extra_args,
        inlineu₁u₂,
        thread,
        warncheckarg,
        safe,
        debug
      ))
    end
  )
  push!(prepre.args, q)
  prepre
end

function generate_call(
  ls::LoopSet,
  inlineu₁u₂::Tuple{Bool,Int8,Int8,Int8},
  thread::UInt,
  warncheckarg::Int,
  safe::Bool,
  debug::Bool
)
  extra_args = Expr(:tuple)
  fill_children!(ls)
  preserve, shouldindbyind, roots = add_grouped_strided_pointer!(extra_args, ls)
  generate_call_split(
    ls,
    preserve,
    shouldindbyind,
    roots,
    extra_args,
    inlineu₁u₂,
    thread,
    warncheckarg,
    safe,
    debug
  )
end
function generate_call_split(
  ls::LoopSet,
  preserve::Vector{Symbol},
  shouldindbyind::Vector{Bool},
  roots::Vector{Bool},
  extra_args::Expr,
  inlineu₁u₂::Tuple{Bool,Int8,Int8,Int8},
  thread::UInt,
  warncheckarg::Int,
  safe::Bool,
  debug::Bool
)
  for (k, op) ∈ enumerate(operations(ls))
    parents_op = parents(op)
    if (iscompute(op) && (instruction(op).instr === :ifelse)) &&
       (length(parents_op) == 3) &&
       isconstantop(first(parents_op))
      return split_ifelse!(
        ls,
        preserve,
        shouldindbyind,
        roots,
        extra_args,
        k,
        inlineu₁u₂,
        thread,
        warncheckarg,
        safe,
        debug
      )
    end
  end
  return generate_call_types(
    ls,
    preserve,
    shouldindbyind,
    roots,
    extra_args,
    inlineu₁u₂,
    thread,
    warncheckarg,
    safe,
    debug
  )
end

# Try to condense in type stable manner
function generate_call_types(
  ls::LoopSet,
  preserve::Vector{Symbol},
  shouldindbyind::Vector{Bool},
  roots::Vector{Bool},
  extra_args::Expr,
  (inline, u₁, u₂, v)::Tuple{Bool,Int8,Int8,Int8},
  thread::UInt,
  warncheckarg::Int,
  safe::Bool,
  debug::Bool
)
  # good place to check for split  
  operation_descriptions = Expr(:tuple)
  varnames = Symbol[]
  ids = Vector{Int}(undef, length(operations(ls)))
  ops = operations(ls)
  for op ∈ ops
    instr::Instruction = instruction(op)
    if (!roots[identifier(op)])
      if (isconstant(op) && (instr == LOOPCONSTANT)) || !isconstant(op)
        instr = op.instruction = DROPPEDCONSTANT
        op.node_type = constant
      end
    end
    push!(operation_descriptions.args, QuoteNode(instr.mod))
    push!(operation_descriptions.args, QuoteNode(instr.instr))
    push!(operation_descriptions.args, OperationStruct!(varnames, ids, ls, op))
  end
  arraysymbolinds = Symbol[]
  arrayref_descriptions = Expr(:tuple)
  duplicate_ref = fill(false, length(ls.refs_aliasing_syms))
  for (j, ref) ∈ enumerate(ls.refs_aliasing_syms)
    # duplicate_ref[j] ≠ 0 && continue
    duplicate_ref[j] && continue
    push!(
      arrayref_descriptions.args,
      ArrayRefStruct(ls, ref, arraysymbolinds, ids)
    )
  end
  argmeta = argmeta_and_consts_description(ls, arraysymbolinds)
  loop_bounds = loop_boundaries(ls, shouldindbyind)
  loop_syms = tuple_expr(QuoteNode, ls.loopsymbols)
  lbarg = debug ? Expr(:call, :typeof, loop_bounds) : loop_bounds
  configarg = (inline, u₁, u₂, v, ls.isbroadcast, thread, warncheckarg, safe)
  unroll_param_tup =
    Expr(:call, lv(:avx_config_val), :(Val{$configarg}()), VECTORWIDTHSYMBOL)
  add_reassigned_syms!(extra_args, ls) # counterpart to `add_ops!` constants
  for (opid, sym) ∈ ls.preamble_symsym # counterpart to process_metadata! symsym extraction
    if instruction(ops[opid]) ≠ DROPPEDCONSTANT
      push!(extra_args.args, sym)
    end
  end
  append!(extra_args.args, arraysymbolinds) # add_array_symbols!
  add_external_functions!(extra_args, ls) # extract_external_functions!
  add_outerreduct_types!(extra_args, ls) # extract_outerreduct_types!
  argcestimate = length(extra_args.args) - 1
  for ref in ls.refs_aliasing_syms
    argcestimate += length(ref.loopedindex)
  end
  manyarg = !debug && (argcestimate > 16)
  func =
    debug ? lv(:_turbo_loopset_debug) :
    (manyarg ? lv(:_turbo_manyarg!) : lv(:_turbo_!))
  q = Expr(
    :call,
    func,
    unroll_param_tup,
    val(operation_descriptions),
    val(arrayref_descriptions),
    val(argmeta),
    val(loop_syms)
  )
  vecwidthdefq = if debug
    push!(q.args, Expr(:tuple, lbarg, extra_args))
    Expr(:block)
  else
    vargsym = gensym(:vargsym)
    push!(
      q.args,
      Expr(
        :call,
        GlobalRef(Base, :Val),
        Expr(:call, GlobalRef(Base, :typeof), vargsym)
      )
    )
    if manyarg
      push!(q.args, Expr(:call, lv(:flatten_to_tuple), vargsym))
    else
      push!(q.args, Expr(:(...), Expr(:call, lv(:flatten_to_tuple), vargsym)))
    end
    Expr(:block, Expr(:(=), vargsym, Expr(:tuple, lbarg, extra_args)))
  end
  define_eltype_vec_width!(vecwidthdefq, ls, nothing, true)
  push!(vecwidthdefq.args, q)
  if debug
    pushpreamble!(ls, vecwidthdefq)
    Expr(:block, ls.prepreamble, ls.preamble)
  else
    setup_call_final(ls, setup_outerreduct_preserve(ls, vecwidthdefq, preserve))
  end
end
# @inline reductinittype(::T) where {T} = StaticType{T}()
typeof_expr(op::Operation) = Expr(:call, GlobalRef(Base, :typeof), name(op))
eltype_expr(op::Operation) = Expr(:call, GlobalRef(Base, :eltype), name(op))
function add_outerreduct_types!(extra_args::Expr, ls::LoopSet) # extract_outerreduct_types!
  for or ∈ ls.outer_reductions
    op = operations(ls)[or]
    if instruction(op).instr ≢ :ifelse
      push!(extra_args.args, eltype_expr(op))
    else
      push!(extra_args.args, name(op))
    end
  end
end
"""
    check_args(::Vararg{AbstractArray})

LoopVectorization will optimize an `@turbo` loop if `check_args` on each on the indexed abstract arrays returns true.
It returns true for `AbstractArray{T}`s when `check_type(T) == true` and the array or its parent is a `StridedArray` or `AbstractRange`.

To provide support for a custom array type, ensure that `check_args` returns true, either through overloading it or subtyping `DenseArray`.
Additionally, define `pointer` and `stride` methods.
"""
@inline function check_args(A::AbstractArray{T}) where {T}
  check_type(T) && check_device(ArrayInterface.device(A))
end
@inline check_args(A::BitVector) = true
@inline check_args(A::BitArray) = iszero(size(A, 1) & 7)
@inline check_args(::VectorizationBase.AbstractStridedPointer) = true
@inline function check_args(x)
  # @info "`LoopVectorization.check_args(::$(typeof(x))) == false`, therefore compiling a probably slow `@inbounds @fastmath` fallback loop." maxlog=1
  # DEBUG: @show @__LINE__, typeof(x)
  false
end
@inline check_args(A, B, C::Vararg{Any,K}) where {K} =
  check_args(A) && check_args(B, C...)
@inline check_args(::AbstractRange{T}) where {T} = check_type(T)
@inline check_args(::UpTri) = false
@inline check_args(::LoTri) = false
@inline check_args(::Diagonal) = false
@inline check_args(::Type{T}) where {T} = check_type(T)
@inline check_args(::Tuple{T,Vararg{T,K}}) where {T,K} = check_type(T)
"""
    check_type(::Type{T}) where {T}

Returns true if the element type is supported.
"""
@inline check_type(::Type{T}) where {T<:NativeTypes} = true
@inline function check_type(::Type{T}) where {T}
  # DEBUG: @show @__LINE__, T
  false
end
@inline check_type(::Type{T}) where {T<:AbstractSIMD} = true
@inline check_device(::ArrayInterface.CPUPointer) = true
@inline check_device(::ArrayInterface.CPUTuple) = true
@inline function check_device(x)
  # DEBUG: @show @__LINE__, typeof(x)
  false
end

function check_args_call(ls::LoopSet)
  q = Expr(:call, lv(:check_args))
  append!(q.args, ls.includedactualarrays)
  for r ∈ ls.outer_reductions
    push!(q.args, Expr(:call, :typeof, name(ls.operations[r])))
  end
  q
end
struct RetVec2Int end
(::RetVec2Int)(_) = Vec{2,Int}
"""
can_turbo(f::Function, ::Val{NARGS})

Check whether a given function with a specified number of arguments
can be used inside a `@turbo` loop.
"""
function can_turbo(f::F, ::Val{NARGS})::Bool where {F,NARGS}
  promoted_op = Base.promote_op(f, ntuple(RetVec2Int(), Val(NARGS))...)
  # DEBUG: promoted_op === Union{} && @show f, NARGS
  return promoted_op !== Union{}
end
can_turbo(::typeof(vfmaddsub), ::Val{3}) = true
can_turbo(::typeof(vfmsubadd), ::Val{3}) = true
can_turbo(::typeof(ifelse), ::Val{3}) = true
can_turbo(::typeof(!), ::Val{1}) = true
can_turbo(::typeof(^), ::Val{2}) = true
can_turbo(::typeof(Base.literal_pow), ::Val{3}) = true
can_turbo(::typeof(Base.FastMath.pow_fast), ::Val{2}) = true

for f ∈ (convert, reinterpret, trunc, unsafe_trunc, round, ceil, floor)
  @eval can_turbo(::typeof($f), ::Val{2}) = true
end

# @inline function _can_turbo(f::F, t::Vararg{Any,K}) where {F,K}
#   Base.promote_op(f, t...) !== Union{}
# end

"""
    check_turbo_safe(ls::LoopSet)

Returns an expression of the form `true && can_turbo(op1) && can_turbo(op2) && ...`
"""
function check_turbo_safe(ls::LoopSet)
  q = Expr(:&&, true)
  last = q
  for op in operations(ls)
    iscompute(op) || continue
    c = callexpr(op.instruction)
    nargs = length(parents(op))
    push!(c.args, Val(nargs))
    pushfirst!(c.args, can_turbo)
    new_last = Expr(:&&, c)
    push!(last.args, new_last)
    last = new_last
  end
  q
end

make_fast(q) = Expr(
  :macrocall,
  Symbol("@fastmath"),
  LineNumberNode(@__LINE__, Symbol(@__FILE__)),
  q
)
make_crashy(q) = Expr(
  :macrocall,
  Symbol("@inbounds"),
  LineNumberNode(@__LINE__, Symbol(@__FILE__)),
  q
)

@inline vecmemaybe(x::NativeTypes) = x
@inline vecmemaybe(x::VectorizationBase._Vec) = Vec(x)
@inline vecmemaybe(x::VectorizationBase.Vec) = x
@inline vecmemaybe(x::Tuple) = VectorizationBase.VecUnroll(x)
@inline vecmemaybe(x::Mask) = x

function gc_preserve(call::Expr, preserve::Vector{Symbol})
  q = Expr(:gc_preserve, call)
  append!(q.args, preserve)
  q
end

# @generated function ifelse_reduce(f::F, x::Vec{W,T}) where {F,T,W}
#   Wt = W >>> 1
#   # uw = Symbol(:x_, Wt)
#   # lw = Symbol(:x_, Wt)
#   xw = Symbol(:x_, Wt)
#   q = Expr(:block, Expr(:meta,:inline), :($xw = f($(VectorizationBase.uppervector)(x), $(VectorizationBase.lowervector)(x))))
#   while Wt > 2
#     Wt >>>= 1
#     ex = :(f($(VectorizationBase.uppervector)($xw), $(VectorizationBase.lowervector)($xw)))
#     xw = Symbol(:x_, Wt)
#     push!(q.args, :($xw = $ex))
#   end

# end

# function setup_call_inline(ls::LoopSet, inline::Bool, u₁::Int8, u₂::Int8, thread::Int)
#   call, preserve = generate_call_split(ls, (inline,u₁,u₂), thread % UInt, false)
#   setup_call_ret!(ls, call, preserve)
# end
setup_outerreduct_preserve_mangler(op::Operation) =
  Symbol(mangledvar(op), "##onevec##")

function outer_reduction_to_scalar_reduceq!(
  q::Expr,
  op::Operation,
  var = name(op)
)
  instr = instruction(op)
  out = setup_outerreduct_preserve_mangler(op)
  if instr.instr ≢ :ifelse
    Expr(
      :call,
      reduction_scalar_combine(op),
      Expr(:call, lv(:vecmemaybe), out),
      var
    )
  else
    opinstr = ifelse_reduction(:IfElseReduced, op) do opv
      opvname = name(opv)
      oporig = gensym(opvname)
      pushfirst!(q.args, Expr(:(=), oporig, opvname))
      Expr(:call, lv(:vecmemaybe), setup_outerreduct_preserve_mangler(opv)),
      (oporig,)
    end
    Expr(:call, opinstr, Expr(:call, lv(:vecmemaybe), out), var)
  end
end
function setup_outerreduct_preserve(
  ls::LoopSet,
  call::Expr,
  preserve::Vector{Symbol}
)
  iszero(length(ls.outer_reductions)) && return gc_preserve(call, preserve)
  retv = loopset_return_value(ls, Val(false))
  q = Expr(:block, gc_preserve(Expr(:(=), retv, call), preserve))
  for or ∈ ls.outer_reductions
    op = ls.operations[or]
    # push!(call.args, Symbol("##TYPEOF##", var))
    reducq = outer_reduction_to_scalar_reduceq!(q, op)
    push!(q.args, Expr(:(=), name(op), reducq))
  end
  q
end
function setup_call_final(ls::LoopSet, q::Expr)
  pushpreamble!(ls, q)
  push!(ls.preamble.args, nothing)
  return ls.preamble
end
function setup_call_debug(ls::LoopSet)
  generate_call(
    ls,
    (false, zero(Int8), zero(Int8), zero(Int8)),
    zero(UInt),
    1,
    true,
    true
  )
end
function setup_call(
  ls::LoopSet,
  q::Expr,
  source::LineNumberNode,
  inline::Bool,
  check_empty::Bool,
  u₁::Int8,
  u₂::Int8,
  v::Int8,
  thread::Int,
  warncheckarg::Int,
  safe::Bool
)
  # We outline/inline at the macro level by creating/not creating an anonymous function.
  # The old API instead was based on inlining or not inline the generated function, but
  # the generated function must be inlined into the initial loop preamble for performance reasons.
  # Creating an anonymous function and calling it also achieves the outlining, while still
  # inlining the generated function into the loop preamble.
  lnns = extract_all_lnns(q)
  pushfirst!(lnns, source)
  call = generate_call(ls, (inline, u₁, u₂, v), thread % UInt, 1, true, false)
  call = check_empty ? check_if_empty(ls, call) : call
  argfailure = make_crashy(make_fast(q))
  if warncheckarg ≠ 0
    warnstring = "$(first(lnns)):\n`LoopVectorization.check_args` on your inputs failed; running fallback `@inbounds @fastmath` loop instead.\nUse `warn_check_args=false`, e.g. `@turbo warn_check_args=false ...`, to disable this warning."
    warning = :(@warn $warnstring)
    warncheckarg > 0 && push!(warning.args, :(maxlog = $warncheckarg))
    argfailure = Expr(:block, warning, argfailure)
  end
  call_check = if safe
    Expr(:&&, check_args_call(ls), check_turbo_safe(ls))
  else
    check_args_call(ls)
  end
  pushprepreamble!(ls, Expr(:if, call_check, call, argfailure))
  prepend_lnns!(ls.prepreamble, lnns)
  return quote
    let
      $(ls.prepreamble)
    end
  end
end

# LoopVectorization.jl

This documentation is for 
[`LoopVectorization.jl`](https://github.com/JuliaSIMD/LoopVectorization.jl).
Please [file an issue](https://github.com/JuliaSIMD/LoopVectorization.jl/issues/new) 
if you run into any problems.

## Manual Outline

```@contents
Pages = [
    "getting_started.md",
    "examples/multithreading.md",
    "examples/matrix_multiplication.md",
    "examples/array_interface.md",
    "examples/matrix_vector_ops.md",
    "examples/dot_product.md",
    "examples/datetime_arrays.md",
    "examples/filtering.md",
    "examples/special_functions.md",
    "examples/sum_of_squared_error.md",
    "vectorized_convenience_functions.md",
    "performance_accuracy.md",
    "future_work.md",
    "devdocs/overview.md",
    "devdocs/loopset_structure.md",
    "devdocs/constructing_loopsets.md",
    "devdocs/evaluating_loops.md",
    "devdocs/lowering.md"
]
Depth = 1
```

# Internals reference

## Operation types

```@docs
LoopVectorization.OperationType
LoopVectorization.constant
LoopVectorization.memload
LoopVectorization.compute
LoopVectorization.memstore
LoopVectorization.loopvalue
```

## Operation

```@docs
LoopVectorization.Operation
```

## Instructions and costs

```@docs
LoopVectorization.Instruction
LoopVectorization.InstructionCost
```

## Array references

```@docs
LoopVectorization.ArrayReference
LoopVectorization.ArrayReferenceMeta
```

## Condensed types

These are used when encoding the `@turbo` block as a type parameter for passing through
to the `@generated` function.

```@docs
LoopVectorization.ArrayRefStruct
LoopVectorization.OperationStruct
```

## Future Plans

Future plans for LoopVectorization:
1. Support triangular iteration spaces.
2. Identify obvious loop-carried dependencies like `A[j]` and `A[j-1]`.
3. Be able to generate optimized kernels from simple loop-based implementations of operations like Cholesky decompositions or solving triangular systems of equations.
4. Model memory and CPU-cache to possibly insert extra loops and packing of data when deemed profitable.
5. Track types of individual operations in the loops. Currently, multiple types in loops aren't really handled, so this is a bit brittle at the moment.
6. Handle loops where arrays contain non-primitive types (e.g., Complex numbers) well.

Contributions are more than welcome, and I would be happy to assist if anyone would like to take a stab at any of these.
Otherwise, while LoopVectorization is a core component to much of my work, so that I will continue developing it, I have many other projects that require active development, so it will be a long time before I am able to address these myself.

## Getting Started

To install `LoopVectorization.jl`, simply use the package and `] add LoopVectorization`, or
```julia
using Pkg
Pkg.add("LoopVectorization")
```

Currently LoopVectorization only supports rectangular iteration spaces, although I plan on extending it to triangular and ragged iteration spaces in the future.
This means that if you nest multiple loops, the number of iterations of the inner loops shouldn't be a function of the outer loops. For example,
```julia
using LoopVectorization 

function mvp(P, basis, coeffs::Vector{T}) where {T}
    C = length(coeffs)
    A = size(P, 1)
    p = zero(T)
    @turbo for c ∈ 1:C
        pc = coeffs[c]
        for a = 1:A
            pc *= P[a, basis[a, c]]
        end
        p += pc
    end
    p
end

maxdeg = 20; nbasis = 1_000; dim = 15;
r = 1:maxdeg+1
basis = rand(r, (dim, nbasis));
coeffs = rand(T, nbasis);
P = rand(T, dim, maxdeg+1);

mvp(P, basis, coeffs)
```

Aside from loops, `LoopVectorization.jl` also supports broadcasting.
!!! danger
    Broadcasting an `Array` `A` when `size(A,1) == 1` is NOT SUPPORTED, unless this is known at compile time (e.g., broadcasting a transposed vector is fine). Otherwise, you will probably crash Julia.

Note: `@turbo` does not support passing of kwargs to function calls to which it is applied, e.g:
```julia
julia> @turbo round.(rand(10));

julia> @turbo round.(rand(10); digits = 3);
ERROR: TypeError: in typeassert, expected Expr, got a value of type GlobalRef
```

You can work around this by creating a anonymous function before applying `@turbo` as follows:
```julia
struct KwargCall{F,T}
    f::F
    x::T
end
@inline (f::KwargCall)(args...) = f.f(args...; f.x...)

f = KwargCall(round, (digits = 3,));
@turbo f.(rand(10))
10-element Vector{Float64}:
 0.763
 ⋮
 0.851
```


```julia
julia> using LoopVectorization, BenchmarkTools

julia> M, K, N = 47, 73, 7;

julia> A = rand(M, K);

julia> b = rand(K);

julia> c = rand(M);

julia> d = rand(1,K,N);

julia> #You can use a LowDimArray when you have a leading dimension of size 1.
       ldad = LowDimArray{(false,true,true)}(d);

julia> E1 = Array{Float64}(undef, M, K, N);

julia> E2 = similar(E1);

julia> @benchmark @. $E1 = exp($A - $b' +    $d) * $c
BenchmarkTools.Trial: 
  memory estimate:  112 bytes
  allocs estimate:  5
  --------------
  minimum time:     224.142 μs (0.00% GC)
  median time:      225.773 μs (0.00% GC)
  mean time:        229.146 μs (0.00% GC)
  maximum time:     289.601 μs (0.00% GC)
  --------------
  samples:          10000
  evals/sample:     1

julia> @benchmark @turbo @. $E2 = exp($A - $b' + $ldad) * $c
BenchmarkTools.Trial: 
  memory estimate:  0 bytes
  allocs estimate:  0
  --------------
  minimum time:     19.666 μs (0.00% GC)
  median time:      19.737 μs (0.00% GC)
  mean time:        19.759 μs (0.00% GC)
  maximum time:     29.906 μs (0.00% GC)
  --------------
  samples:          10000
  evals/sample:     1

julia> E1 ≈ E2
true
```

# Constructing LoopSets

## Loop expressions

When applying `@turbo` to a loop expression, it creates a `LoopSet` without awareness to type information, and then [condenses the information](https://github.com/JuliaSIMD/LoopVectorization.jl/blob/master/src/condense_loopset.jl) into a summary which is passed as type information to a generated function.
```julia
julia> @macroexpand @turbo for m ∈ 1:M, n ∈ 1:N
           C[m,n] = zero(eltype(B))
           for k ∈ 1:K
               C[m,n] += A[m,k] * B[k,n]
           end
       end
quote
    var"##vptr##_C" = LoopVectorization.stridedpointer(C)
    var"##vptr##_A" = LoopVectorization.stridedpointer(A)
    var"##vptr##_B" = LoopVectorization.stridedpointer(B)
    begin
        $(Expr(:gc_preserve, :(LoopVectorization._turbo_!(Val{(0, 0)}(), Tuple{:numericconstant, Symbol("##zero#270"), LoopVectorization.OperationStruct(0x0000000000000012, 0x0000000000000000, 0x0000000000000000, 0x0000000000000000, LoopVectorization.constant, 0x00, 0x01), :LoopVectorization, :setindex!, LoopVectorization.OperationStruct(0x0000000000000012, 0x0000000000000000, 0x0000000000000000, 0x0000000000000007, LoopVectorization.memstore, 0x01, 0x02), :LoopVectorization, :getindex, LoopVectorization.OperationStruct(0x0000000000000013, 0x0000000000000000, 0x0000000000000000, 0x0000000000000000, LoopVectorization.memload, 0x02, 0x03), :LoopVectorization, :getindex, LoopVectorization.OperationStruct(0x0000000000000032, 0x0000000000000000, 0x0000000000000000, 0x0000000000000000, LoopVectorization.memload, 0x03, 0x04), :numericconstant, Symbol("##reductzero#274"), LoopVectorization.OperationStruct(0x0000000000000012, 0x0000000000000000, 0x0000000000000003, 0x0000000000000000, LoopVectorization.constant, 0x00, 0x05), :LoopVectorization, :vfmadd_fast, LoopVectorization.OperationStruct(0x0000000000000132, 0x0000000000000003, 0x0000000000000000, 0x0000000000030405, LoopVectorization.compute, 0x00, 0x05), :LoopVectorization, :reduce_to_add, LoopVectorization.OperationStruct(0x0000000000000012, 0x0000000000000003, 0x0000000000000000, 0x0000000000000601, LoopVectorization.compute, 0x00, 0x01)}, Tuple{LoopVectorization.ArrayRefStruct(0x0000000000000101, 0x0000000000000102, 0xffffffffffffe03b), LoopVectorization.ArrayRefStruct(0x0000000000000101, 0x0000000000000103, 0xffffffffffffffd6), LoopVectorization.ArrayRefStruct(0x0000000000000101, 0x0000000000000302, 0xffffffffffffe056), LoopVectorization.ArrayRefStruct(0x0000000000000101, 0x0000000000000102, 0xffffffffffffffd6)}, Tuple{0, Tuple{}, Tuple{}, Tuple{}, Tuple{}, Tuple{(1, LoopVectorization.IntOrFloat), (5, LoopVectorization.IntOrFloat)}, Tuple{}}, (LoopVectorization.StaticLowerUnitRange{0}(M), LoopVectorization.StaticLowerUnitRange{0}(N), LoopVectorization.StaticLowerUnitRange{0}(K)), var"##vptr##_C", var"##vptr##_A", var"##vptr##_B", var"##vptr##_C")), :C, :A, :B))
    end
end
```
When the corresponding method gets compiled for specific type of `A`, `B`, and `C`, the call to the `@generated` function `_turbo_!` get compiled. This causes the summary to be [reconstructed](https://github.com/JuliaSIMD/LoopVectorization.jl/blob/master/src/reconstruct_loopset.jl) using the available type information. This type information can be used, for example, to realize an array has been transposed, and thus correctly identify which axis contains contiguous elements that are efficient to load from. This kind of information cannot be extracted from the raw expression, which is why these decisions are made when the method gets compiled for specific types via the `@generated` function `_turbo_!`.

The three chief components of the summaries are the definitions of operations, e.g.:
```julia
:LoopVectorization, :getindex, LoopVectorization.OperationStruct(0x0000000000000013, 0x0000000000000000, 0x0000000000000000, 0x0000000000000000, LoopVectorization.memload, 0x02, 0x03)
```
the referenced array objects:
```julia
LoopVectorization.ArrayRefStruct(0x0000000000000101, 0x0000000000000102, 0xffffffffffffe03b)
```
and the set of loop bounds:
```julia
(LoopVectorization.StaticLowerUnitRange{0}(M), LoopVectorization.StaticLowerUnitRange{0}(N), LoopVectorization.StaticLowerUnitRange{0}(K))
```

## Broadcasting

When applying the `@turbo` macro to a broadcast expression, there are no explicit loops, and even the dimensionality of the operation is unknown.  Consequently the `LoopSet` object must be constructed at compile time. The function and involved operations are their relationships are straightforward to infer from the structure of nested broadcasts:
```julia
julia> Meta.@lower @. f(g(a,b) + c) / d
:($(Expr(:thunk, CodeInfo(
    @ none within `top-level scope'
1 ─ %1 = Base.broadcasted(g, a, b)
│   %2 = Base.broadcasted(+, %1, c)
│   %3 = Base.broadcasted(f, %2)
│   %4 = Base.broadcasted(/, %3, d)
│   %5 = Base.materialize(%4)
└──      return %5
))))

julia> @macroexpand @turbo @. f(g(a,b) + c) / d
quote
    var"##262" = Base.broadcasted(g, a, b)
    var"##263" = Base.broadcasted(+, var"##262", c)
    var"##264" = Base.broadcasted(f, var"##263")
    var"##265" = Base.broadcasted(/, var"##264", d)
    var"##266" = LoopVectorization.vmaterialize(var"##265", Val{:Main}())
end
```
These nested broadcasted objects already express information very similar to what the `LoopSet` objects hold. The dimensionality of the objects provides the information on the associated loop dependencies, but again this information is available only when the method is compiled for specific types. The `@generated` function `vmaterialize` constructs the LoopSet by recursively evaluating [add_broadcast!](https://github.com/JuliaSIMD/LoopVectorization.jl/blob/master/src/broadcast.jl#L166) on all the fields.

# Developer Overview

Here I will try to explain how the library works for the curious or any would-be contributors.

The library uses a [LoopSet](https://github.com/JuliaSIMD/LoopVectorization.jl/blob/master/src/graphs.jl#L146) object to model loops. The key components of the library can be divided into:
1. Defining the LoopSet objects.
2. Constructing the LoopSet objects.
3. Determining the strategy of how to evaluate loops.
4. Lowering the loopset object into a Julia `Expr` following a strategy.

# LoopSet Structure

The loopsets define loops as a set of operations that depend on one another, and also on loops. Cycles are not allowed, making it a directed acyclic graph.
Let's use a set of nested loops performing matrix multiplication as an example. We can create a naive `LoopSet` from an expression (naive due to being created without access to any type information):
```julia
julia> using LoopVectorization

julia> AmulBq = :(for m ∈ 1:M, n ∈ 1:N
           C[m,n] = zero(eltype(B))
           for k ∈ 1:K
               C[m,n] += A[m,k] * B[k,n]
           end
       end);

julia> lsAmulB = LoopVectorization.LoopSet(AmulBq);
```
This LoopSet consists of seven operations that define the relationships within the loop:
```julia
julia> LoopVectorization.operations(lsAmulB)
7-element Array{LoopVectorization.Operation,1}:
 var"##RHS#256" = var"##zero#257"
 C[m, n] = var"##RHS#256"
 var"##tempload#258" = A[m, k]
 var"##tempload#259" = B[k, n]
 var"##reduction#260" = var"##reductzero#261"
 var"##reduction#260" = LoopVectorization.vfmadd_fast(var"##tempload#258", var"##tempload#259", var"##reduction#260")
 var"##RHS#256" = LoopVectorization.reduce_to_add(var"##reduction#260", var"##RHS#256")
```
The act of performing a "reduction" across a loop introduces a few extra operations that manage creating a "zero" with respect to the reduction, and then combining with the specified value using `reduce_to_add`, which performs any necessary type conversions, such as from an `Vec` vector-type to a scalar, if necessary. This simplifies code generation, by making the functions agnostic with respect to the actual vectorization decisions the library makes.

Each operation is listed as depending on a set of loop iteration symbols:
```julia
julia> LoopVectorization.loopdependencies.(LoopVectorization.operations(lsAmulB))
7-element Array{Array{Symbol,1},1}:
 [:m, :n]
 [:m, :n]
 [:m, :k]
 [:k, :n]
 [:m, :n]
 [:m, :k, :n]
 [:m, :n]
```
We can also see which of the operations each of these operations depend on:
```julia
julia> LoopVectorization.operations(lsAmulB)[6]
var"##reduction#260" = LoopVectorization.vfmadd_fast(var"##tempload#258", var"##tempload#259", var"##reduction#260")

julia> LoopVectorization.parents(ans)
3-element Array{LoopVectorization.Operation,1}:
 var"##tempload#258" = A[m, k]
 var"##tempload#259" = B[k, n]
 var"##reduction#260" = var"##reductzero#261"
```
References to arrays are represented with an `ArrayReferenceMeta` data structure:
```julia
julia> LoopVectorization.operations(lsAmulB)[3].ref
LoopVectorization.ArrayReferenceMeta(LoopVectorization.ArrayReference(:A, [:m, :k], Int8[0, 0]), Bool[1, 1], Symbol("##vptr##_A"))
```
It contains the name of the parent array (`:A`), the indices `[:m,:k]`, and a boolean vector (`Bool[1, 1]`) indicating whether these indices are loop iterables. Note that the optimizer assumes arrays are column-major, and thus that it is efficient to read contiguous elements from the first index. In lower level terms, it means that [high-throughput vmov](https://www.felixcloutier.com/x86/movupd) instructions can be used rather than [low-throughput](https://www.felixcloutier.com/x86/vgatherdpd:vgatherqpd) [gathers](https://www.felixcloutier.com/x86/vgatherqps:vgatherqpd). Similar story for storing elements.
When no axis has unit stride, the first given index will be the dummy `Symbol("##DISCONTIGUOUSSUBARRAY##")`.

!!! warning
    Currently, only single return values are supported (tuple destructuring is not supported in assignments).

# Lowering

The first step to lowering is picking a strategy for lowering the loops. Then a Julia expression is created following that strategy, converting each of the operations into Julia expressions.
This task is made simpler via multiple dispatch making the lowering of the components independent of the larger picture. For example, a load will look like
```julia
vload(vptr_A, (i,j,k))
```
with the behavior of this load determined by the types of the arguments. Vectorization is expressed by making an index a `_MM{W}` type, rather than an integer, and operations with it will either produce another `_MM{W}` when it will still correspond to contiguous loads, or an `Vec{W,<:Integer}` if the resulting loads will be discontiguous, so that a `gather` or `scatter!` will be used. If all indexes are simply integers, then this produces a scalar load or store.

# API reference

```@docs
LoopVectorization
```

## Macros

```@docs
@turbo
@tturbo
```

## `map`-like constructs

```@docs
vmap
vmap!
vmapt
vmapt!
vmapnt
vmapnt!
vmapntt
vmapntt!
```

## `filter`-like constructs

```@docs
vfilter
LoopVectorization.vfilter!
```

## `reduce`-like constructs
```@docs
vsum
vreduce
vmapreduce
```

## Operators
```@docs
*ˡ
```

## Performance-accuracy tradeoff

_`@turbo` performs arithmetic transformations and substitutes standard special functions with implementations that lend themselves better to vectorization but sometimes achieve slightly lower accuracy. The following is a discussion from the Julia slack #performance-helpdesk regarding this tradeoff, how it compares to similar transformations by `@fastmath`, and how to preserve full accuracy while vectorizing. It is included here for the benefit of anyone looking for information about this. PRs welcome to turn this page into a self-contained discussion or FAQ section._

**Daniel Wennberg** _2022-03-30 03:06 UTC_

Does `@turbo` from LoopVectorization, and by extension `@tullio`, have the same accuracy caveats as `@fastmath`, as discussed e.g. here: <https://discourse.julialang.org/t/fastmath-macro-accuracy/38847/7>? Seeing as LoopVectorization's fallback mode is `@inbounds` `@fastmath`

**Chris Elrod**

More often than not, the transforms enabled by `@turbo` and `@fastmath` are going to make results more accurate.

I.e., allowing use of multiple accumulators and fma instructions will help. (edited) 

**Chris Elrod**

`@fastmath` applied globally makes results less accurate on average, because there are some extreme cases, where code was written with IEEE semantics in mind, performing compensated arithmetic/error accumulation and adjustment.

By allowing reassociating this code, errors can become catastrophic.

If you did not write code in such a deliberate manner, you won’t encounter the problem when applying it to your own code.

It is unsafe to apply to other people’s code, unless you happen to know they also did not write the specific sequence of floating point operations in such an intentional way.

Many functions, like `exp` and `sinpi` are written in such an intentional way, and thus experience terrible error when starting julia with --math-mode=fast. But `@fastmath exp(x)` switches `exp` implementations to a less accurate, slightly faster, version, rather than applying `@fastmath` to the contents of the regular exp, so it is not dangerous to do.

I think the fear mongering over fastmath comes from languages like C/C++/Fortran, where you apply it either everywhere or nowhere.

Applying it everywhere is dangerous, because then it gets more and more likely that some code or some library was written in such a way with error tracking, that it causes catastrophic problems.

Applying it locally is the correct approach.

As would be, IMO, allowing at least associative math everywhere, and letting people opt out in the cases where they’re deliberately avoiding it.

**Chris Elrod**

`@fastmath` and `@turbo` also enable less accurate functions, like less accurate implementations of `^`, `sin`, etc.

**Chris Elrod**

But especially in the case of `@turbo`, these versions are way faster. Most of these should still be good to 3 ULP (units in last place)

**Oscar Smith**

does `@turbo` have the no nan parts of fastmath?

**Daniel Wennberg**

Thanks, this is super helpful!

**Daniel Wennberg**

> But especially in the case of `@turbo`, these versions are way faster.

So `@turbo` and `@fastmath` substitute different fast versions of elementary functions? Is this where `@turbo` makes better use of the AVX instruction set?

**Oscar Smith**

yes

**Oscar Smith**

regular `@fastmath` uses slightly faster scalar functions which LLVM may autovectorize, but `@fastmath` isn't a powerful enough macro to tell when when a function is called in a loop

**Chris Elrod**

No, `@turbo` does not have the no nans part.

**Chris Elrod**

Unfortunately, no nans propagates in a way that is at high risk of disabling checks for nans, even when only applying it locally, making no nans basically unusable IMO.

**Chris Elrod**

`@turbo`’s speed gain is mostly from the fact it has versions of special functions that are SIMD-able, not from the lower accuracy.

**Chris Elrod**  2 hours ago

You should be able to manually opt into accurate, but still SIMD-able, versions.

**Alec**

@Chris Elrod you should crosspost that to discourse for posterity's sake

**Daniel Wennberg**

> You should be able to manually opt into accurate, but still SIMD-able, versions.

You mean a user like me can do that currently or are you saying this as a feature request to yourself/Julia/LLVM?

**Daniel Wennberg**

Is this what `VectorizationBase.vadd` etc. enable?

**Oscar Smith**

it's a feature request. The `VectorizationBase.v` versions are the fast but slightly inaccurate ones

**Chris Elrod**

```julia
julia> @inline sincos_simd(x) = SLEEFPirates.sincos(x)
sincos_simd (generic function with 1 method)

julia> function sincos_turbo_accurate!(sc, x)
           @turbo for i ∈ eachindex(x)
               sc[i,1], sc[i,2] = sincos_simd(x[i])
           end
       end
sincos_turbo_accurate! (generic function with 1 method)

julia> function sincos_turbo!(sc, x)
           @turbo for i ∈ eachindex(x)
               sc[i,1], sc[i,2] = sincos(x[i])
           end
       end
sincos_turbo! (generic function with 1 method)

julia> function sincos!(sc, x)
           @inbounds for i ∈ eachindex(x)
               sc[i,1], sc[i,2] = sincos(x[i])
           end
       end
sincos! (generic function with 1 method)

julia> function sincos_fast!(sc, x)
           @inbounds @fastmath for i ∈ eachindex(x)
               sc[i,1], sc[i,2] = sincos(x[i])
           end
       end
sincos_fast! (generic function with 1 method)

julia> x = rand(512); sc = similar(x, length(x), 2);

julia> @btime sincos!($sc,$x)
  3.918 μs (0 allocations: 0 bytes)

julia> @btime sincos_fast!($sc,$x)
  3.906 μs (0 allocations: 0 bytes)

julia> @btime sincos_turbo!($sc,$x)
  614.067 ns (0 allocations: 0 bytes)

julia> @btime sincos_turbo_accurate!($sc,$x)
  1.702 μs (0 allocations: 0 bytes)
```

**Chris Elrod**

The rewrite will probably respect regular fastmath, or have a flag for that.

**Chris Elrod**

Anyway, if you want to use the more accurate versions of functions like `sincos`, you can hide `SLEEFPirates.sincos` from LV behind a function, like in the above example

**Oscar Smith**

Also, have you seen <https://github.com/ARM-software/optimized-routines/tree/master/math>? It's a really good set of elementary implementations that should vectorize pretty well. Their `pow` is of special interest (and their `log` and `exp` are really good too) I'm in the processes of rewriting the `Base` versions to use some of their tricks

**Oscar Smith**

the one downside of them from a vectorizaiton standpoint is they do slightly more math in `UInt` form, but most of that is unnecessary

**Chris Elrod**

It’ll be a while until I get that far on the rewrite!

The ideal would be that I can take your Julia implementations and analyze the LLVM to figure out how to vectorize them, without needing any separate implementations.

That is plan A.

**Chris Elrod**

What’s wrong with `UInt`, that AVX512DQ is needed on x86?

**Chris Elrod**

I’ve at least been seeing more rumors of AVX512 support in Zen4.

**Oscar Smith**

yeah, but Intel is mostly killing it. Also AVX2 is really common...

**Chris Elrod**

What operations, and can they be implemented by splitting into UInt32s? Not ideal, but still a net win if it enables SIMD…

**Chris Elrod**

Intel’s server CPUs still have AVX512

**Chris Elrod**

I’m still optimistic that it’ll return to consumer CPUs. I suspect it was intended for Alder Lake, but some sort of support to make it work with the efficiency cores wasn’t handled yet.

**Chris Elrod**

Maybe the successor to gracemont will support AVX512, in the same way Zen1 supported AVX2.

**Chris Elrod**

`UInt32`s don’t really work well for things like shifts, nor is there any real overflow detection support.

**Chris Elrod**

So I might need some sort of plan B, where I have to substitute `^` and friends for `@llvm.pow` or `@turbo.pow`, and then have my own implementations for these.

**Chris Elrod**

At least for a few critical/special interest functions.

**Daniel Wennberg**

Folks, the effort you're putting into helping people get the most out of their hardware with just some quick annotations and no detailed knowledge of simd and avx and special function implementations is hugely appreciated and I want you to give yourselves a pat on the back

**Chris Elrod**

@alecloudenback The thread is a couple years old, so I'm not eager to revive it. Not sure what the best way to save it for posterity is.

**Daniel Wennberg**

However, @Chris Elrod, your example left me wondering about exactly how `@turbo` (and `@fastmath` for that matter) interacts with function barriers and inlining. For example, how should I think about the behavior and performance of the three versions of f! in the following example?

```julia
const s = 1.2
f(x) = muladd(s, tanh(x), -x)
@inline f_inlined(x) = muladd(s, tanh(x), -x)

function f!(y, x)
    @turbo for i in eachindex(x)
        y[i] = f(x[i])
    end
end

function f_inlined!(y, x)
    @turbo for i in eachindex(x)
        y[i] = f_inlined(x[i])
    end
end

function f_inlined_manual!(y, x)
    @turbo for i in eachindex(x)
        y[i] = muladd(s, tanh(x[i]), -x[i])
    end
end

julia> x = randn(512); y = similar(x);

julia> @btime f!(y, x)
  3.153 μs (0 allocations: 0 bytes)

julia> @btime f_inlined!(y, x)
  2.966 μs (0 allocations: 0 bytes)

julia> @btime f_inlined_manual!(y, x)
  2.696 μs (0 allocations: 0 bytes)
```

**Chris Elrod**

`@fastmath` only works on syntax, replacing functions like `+` with `Base.FastMath.add_fast`, so hiding something behind a function will protect it from `@fastmath`.

**Daniel Wennberg**

> Not sure what the best way to save it for posterity is.

I generally appreciate when documentation includes discussions along these lines. In this case that would include both the LoopVectorization docs for everything that pertains to `@turbo`, as well as the base Julia docs for details about `@fastmath`, especially the difference between `@fastmath exp(x)` and `exp(x)` under `--math-mode=fast`---I think I was simply assuming that `@fastmath` was all about compiler flags and would transform the elementary arithmetic within each special function.

**Chris Elrod**

`@turbo` is similar, which is why the sincos example worked, with a few extra caveats:

1. it can still SIMD things behind a function, because it also uses the type system for vectorization.

2. `@turbo`'s understanding of what code does is based on syntax (with a little help from types), so if you hide a function from it, it will not know what that function does. It currently assumes the function is very expensive, and will not do anything fancy. In the case of `tanh`, that's close enough so you don't see much of a difference.

**Chris Elrod**

Actually, the difference there is probably because there is a separate `tanh` and `tanh_fast`.

Inlining can help a bit, because these functions generally involve polynomials with lots of constants. Inlining lets you avoid reloading these constants on every iteration by hoisting the loads out of the loop.

**Chris Elrod**

You're welcome to make a PR to add documentation based on this discussion.

**Oscar Smith**

I think `--math-mode=fast` should be disabled. It's never actually what you want. <https://github.com/JuliaLang/julia/pull/41638> was going to do it, but we got distracted and forgot.

**Daniel Wennberg**

My general takeaway from this discussion is that both `@fastmath` and `@turbo` are mostly safe to use on your own code unless a) you're knowingly exploiting IEEE semantics in accumulations (in which case you wouldn't dream of using these macros anyway), or b) you depend on the 1 ULP accuracy of the standard implementation of a special function (do you though?). Does that sound about right? What I'm still not quite clear on is the issue of the no nans flag in `@fastmath` being "basically unusable"---is it dangerous or just not helpful?

**Chris Elrod**

```julia
julia> function foo(a,b,c)
           d = @fastmath a + b
           e = @fastmath b * c
           f = d + e
           isnan(f)
       end
foo (generic function with 2 methods)

julia> @code_llvm debuginfo=:none foo(NaN,NaN,NaN)
define i8 @julia_foo_1015(double %0, double %1, double %2) #0 {
top:
  ret i8 0
}
```

Use of `@fastmath` enables the compiler to prove that down stream results also are not `NaN`.

I do not like to lose the ability to check for `NaN`s.

Yet the above function was compiled away to return `false`, i.e. that it is impossible for `f` to be `NaN`.

I wouldn't mind if `@fastmath` allowed optimizing just those functions as though they weren't `NaN`. If the compiler could prove `c` or `b` are `0.0`, this would allow eliminating the multiplication and then writing `f = d`.

But using that some operations are marked nonans to prove that others aren't `NaN` is going too far IMO.

**Chris Elrod**

That is, I do like being able to optimize particular code in a way that would change the answer in the presence of `NaN`s, but I do not actually want to promise the compiler that the values are not `NaN`s, as I'd still like to check for this later.

**Chris Elrod**

Checking arguments still works:

```julia
julia> function foo(a,b,c)
           d = @fastmath a + b
           e = @fastmath b * c
           f = d + e
           isnan(f) | isnan(b)
       end
foo (generic function with 2 methods)

julia> @code_llvm debuginfo=:none foo(NaN,NaN,NaN)
define i8 @julia_foo_1019(double %0, double %1, double %2) #0 {
top:
  %3 = fcmp uno double %1, 0.000000e+00
  %4 = zext i1 %3 to i8
  ret i8 %4
} 
```

But sometimes it is easier to check results, e.g. if the arguments are hidden inside some other function.

**Daniel Wennberg**

Looks dangerous to me. So another heuristic for when to avoid `@fastmath`: c) downstream behavior depends on whether the result was inf or nan (there's a similar flag for inf that's also enabled, right?)

**Chris Elrod**

Yes, there is a similar flag for `Inf`.

**Chris Elrod**

LoopVectorization does not apply that either.

**Daniel Wennberg**

Just one more clarification question if you can be bothered: returning to the function barrier/inlining example, do I understand correctly that:

* `f!` can SIMD
* `f_inlined!` can SIMD and hoist constants within `tanh` out of the loop
* `f_inlined_manual!` can SIMD, replace `tanh` with `tanh_fast`, and hoist constants within `tanh_fast` out of the loop

**Chris Elrod**

Yes

# Convenient Vectorized Functions

## vmap

This is simply a vectorized `map` function.

## vmapnt and vmapntt

These are like `vmap`, but use non-temporal (streaming) stores into the destination, to avoid polluting the cache. Likely to yield a performance increase if you wont be reading the values soon.
```julia
julia> using LoopVectorization, BenchmarkTools

julia> f(x,y) = exp(-0.5abs2(x - y))
f (generic function with 1 method)

julia> x = rand(10^8); y = rand(10^8); z = similar(x);

julia> @benchmark map!(f, $z, $x, $y)
BenchmarkTools.Trial:
  memory estimate:  0 bytes
  allocs estimate:  0
  --------------
  minimum time:     442.614 ms (0.00% GC)
  median time:      443.750 ms (0.00% GC)
  mean time:        443.664 ms (0.00% GC)
  maximum time:     444.730 ms (0.00% GC)
  --------------
  samples:          12
  evals/sample:     1

julia> @benchmark vmap!(f, $z, $x, $y)
BenchmarkTools.Trial:
  memory estimate:  0 bytes
  allocs estimate:  0
  --------------
  minimum time:     177.257 ms (0.00% GC)
  median time:      177.380 ms (0.00% GC)
  mean time:        177.423 ms (0.00% GC)
  maximum time:     177.956 ms (0.00% GC)
  --------------
  samples:          29
  evals/sample:     1

julia> @benchmark vmapnt!(f, $z, $x, $y)
BenchmarkTools.Trial:
  memory estimate:  0 bytes
  allocs estimate:  0
  --------------
  minimum time:     143.521 ms (0.00% GC)
  median time:      143.639 ms (0.00% GC)
  mean time:        143.645 ms (0.00% GC)
  maximum time:     143.821 ms (0.00% GC)
  --------------
  samples:          35
  evals/sample:     1

julia> Threads.nthreads()
36

julia> @benchmark vmapntt!(f, $z, $x, $y)
BenchmarkTools.Trial:
  memory estimate:  25.69 KiB
  allocs estimate:  183
  --------------
  minimum time:     30.065 ms (0.00% GC)
  median time:      30.130 ms (0.00% GC)
  mean time:        30.146 ms (0.00% GC)
  maximum time:     31.277 ms (0.00% GC)
  --------------
  samples:          166
  evals/sample:     1
```

## vfilter

This function requires LLVM 7 or greater, and is only likely to give better performance if your CPU has AVX512. This is because it uses the compressed store intrinsic, which was added in LLVM 7. AVX512 provides a corresponding instruction, making the operation fast, while other instruction sets must emulate it, and thus are likely to get similar performance with `LoopVectorization.vfilter` as they do from `Base.filter`.

```julia
julia> using LoopVectorization, BenchmarkTools

julia> x = rand(997);

julia> y1 = filter(a -> a > 0.7, x);

julia> y2 = vfilter(a -> a > 0.7, x);

julia> y1 == y2
true

julia> @benchmark filter(a -> a > 0.7, $x)
BenchmarkTools.Trial:
  memory estimate:  7.94 KiB
  allocs estimate:  1
  --------------
  minimum time:     955.389 ns (0.00% GC)
  median time:      1.050 μs (0.00% GC)
  mean time:        1.191 μs (9.72% GC)
  maximum time:     82.799 μs (94.92% GC)
  --------------
  samples:          10000
  evals/sample:     18

julia> @benchmark vfilter(a -> a > 0.7, $x)
BenchmarkTools.Trial:
  memory estimate:  7.94 KiB
  allocs estimate:  1
  --------------
  minimum time:     477.487 ns (0.00% GC)
  median time:      575.166 ns (0.00% GC)
  mean time:        711.526 ns (17.87% GC)
  maximum time:     9.257 μs (79.17% GC)
  --------------
  samples:          10000
  evals/sample:     193
```

## vmapreduce

Vectorized version of `mapreduce`. `vmapreduce(f, op, a, b, c)` applies `f(a[i], b[i], c[i])` for `i in eachindex(a,b,c)`, reducing the results to a scalar with `op`.

```julia
julia> using LoopVectorization, BenchmarkTools

julia> x = rand(127); y = rand(127);

julia> @btime vmapreduce(hypot, +, $x, $y)
  191.420 ns (0 allocations: 0 bytes)
96.75538300513509

julia> @btime mapreduce(hypot, +, $x, $y)
  1.777 μs (5 allocations: 1.25 KiB)
96.75538300513509
```

## vsum

Vectorized version of `sum`. `vsum(f, a)` applies `f(a[i])` for `i in eachindex(a)`, then sums the results.

```julia
julia> using LoopVectorization, BenchmarkTools

julia> x = rand(127);

julia> @btime vsum(hypot, $x)
  12.095 ns (0 allocations: 0 bytes)
66.65246070098374

julia> @btime sum(hypot, $x)
  16.992 ns (0 allocations: 0 bytes)
66.65246070098372
```

# Determining the strategy for evaluating loops

The heart of the optimizations performed by LoopVectorization are given in the [determinestrategy.jl](https://github.com/JuliaSIMD/LoopVectorization.jl/blob/master/src/modeling/determinestrategy.jl) file utilizing instruction costs specified in [costs.jl](https://github.com/JuliaSIMD/LoopVectorization.jl/blob/master/src/modeling/costs.jl).
Essentially, it estimates the cost of different means of evaluating the loops. It iterates through the different possible loop orders, as well as considering which loops to unroll, and which to vectorize. It will consider unrolling 1 or 2 loops (but it could settle on unrolling by a factor of 1, i.e. not unrolling), and vectorizing 1.

The cost estimate is based on the costs of individual instructions and the number of times each one needs to be executed for the given strategy. The instruction cost can be broken into several components:

- The `scalar latency` is the minimum delay, in clock cycles, associated with the instruction. Think of it as the delay from turning on the water to when water starts coming out the hose.
- The `reciprocal throughput` is similar to the latency, but it measures the number of cycles per operation when many of the same operation are repeated in sequence.  Continuing our hose analogy, think of it as the inverse of the flow rate at steady-state. It is typically ≤ the `scalar latency`.
- The `register pressure` measures the register consumption by the operation

Data on individual instructions for specific architectures can be found on [Agner Fog's website](https://agner.org/optimize/instruction_tables.pdf). Most of the costs used were those for the Skylake-X architecture.

Examples of how these come into play:
- Vectorizing a loop will result in each instruction evaluating multiple iterations, but the costs of loads and stores will change based on the memory layouts of the accessed arrays.
- Unrolling can help reduce the number of times an operation must be performed, for example if it can allow us to reuse memory multiple times rather than reloading it every time it is needed.
- When there is a reduction, such as performing a sum, there is a dependency chain. Each `+` has to wait for the previous `+` to finish executing before it can begin, thus execution time is bounded by latency rather than the minimum of the throughput of the `+` and load operations. By unrolling the loop, we can create multiple independent dependency chains.

# Matrix-Vector Operations

Here I'll discuss a variety of Matrix-vector operations, naturally starting with matrix-vector multiplication.

```julia
function jgemvavx!(𝐲, 𝐀, 𝐱)
    @turbo for i ∈ eachindex(𝐲)
        𝐲i = zero(eltype(𝐲))
        for j ∈ eachindex(𝐱)
            𝐲i += 𝐀[i,j] * 𝐱[j]
        end
        𝐲[i] = 𝐲i
    end
end
```

Using a square `Size` x `Size` matrix `𝐀`, we find the following results.
![Amulvb](https://github.com/JuliaSIMD/LoopVectorization.jl/raw/docsassets/docs/src/assets/bench_Amulvb_v2.svg)

If `𝐀` is transposed, or equivalently, if we're instead computing `x * 𝐀`:
![Atmulvb](https://github.com/JuliaSIMD/LoopVectorization.jl/raw/docsassets/docs/src/assets/bench_Atmulvb_v2.svg)

Finally, the three-argument dot product `y' * 𝐀 * x`:
![dot3](https://github.com/JuliaSIMD/LoopVectorization.jl/raw/docsassets/docs/src/assets/bench_dot3_v2.svg)

The performance impact of alignment is dramatic here.

# Matrix Multiplication

One of the friendliest problems for vectorization is matrix multiplication. Given `M × K` matrix `𝐀`, and `K × N` matrix `𝐁`, multiplying them is like performing `M * N` dot products of length `K`. We need `M*K + K*N + M*N` total memory, but `M*K*N` multiplications and additions, so there's a lot more arithmetic we can do relative to the memory needed.

LoopVectorization currently doesn't do any memory-modeling or memory-based optimizations, so it will still run into problems as the size of matrices increases. But at smaller sizes, it's capable of achieving a healthy percent of potential GFLOPS.
We can write a single function:
```julia
function A_mul_B!(C, A, B)
    @turbo for n ∈ indices((C,B), 2), m ∈ indices((C,A), 1)
        Cmn = zero(eltype(C))
        for k ∈ indices((A,B), (2,1))
            Cmn += A[m,k] * B[k,n]
        end
        C[m,n] = Cmn
    end
end
```
and this can handle all transposed/not-tranposed permutations. LoopVectorization will change loop orders and strategy as appropriate based on the types of the input matrices. For each of the others, I wrote separate functions to handle each case. 
Letting all three matrices be square and `Size` x `Size`, we attain the following benchmark results:

![AmulB](https://raw.githubusercontent.com/JuliaSIMD/LoopVectorization.jl/docsassets/docs/src/assets/bench_AmulB_v2.svg)
This is classic GEMM, `𝐂 = 𝐀 * 𝐁`. GFortran's intrinsic `matmul` function does fairly well. But all the compilers are well behind LoopVectorization here, which falls behind MKL's `gemm` beyond 70x70 or so. The problem imposed by alignment is also striking: performance is much higher when the sizes are integer multiplies of 8. Padding arrays so that each column is aligned regardless of the number of rows can thus be very profitable. [PaddedMatrices.jl](https://github.com/JuliaSIMD/PaddedMatrices.jl) offers just such arrays in Julia. I believe that is also what the [-pad](https://software.intel.com/en-us/fortran-compiler-developer-guide-and-reference-pad-qpad) compiler flag does when using Intel's compilers.

![AmulBt](https://github.com/JuliaSIMD/LoopVectorization.jl/raw/docsassets/docs/src/assets/bench_AmulBt_v2.svg)
The optimal pattern for `𝐂 = 𝐀 * 𝐁ᵀ` is almost identical to that for `𝐂 = 𝐀 * 𝐁`. Yet, gfortran's `matmul` intrinsic stumbles, surprisingly doing much worse than gfortran + loops, and almost certainly worse than allocating memory for `𝐁ᵀ` and creating the explicit copy.

ifort did equally well whethor or not `𝐁` was transposed, while LoopVectorization's performance degraded slightly faster as a function of size in the transposed case, because strides between memory accesses are larger when `𝐁` is transposed. But it still performed best of all the compiled loops over this size range, losing out to MKL and eventually OpenBLAS.
icc interestingly does better when it is transposed.

GEMM is easiest when the matrix `𝐀` is not tranposed (assuming column-major memory layouts), because then you can sum up columns of `𝐀` to store into `𝐂`. If `𝐀` were transposed, then we cannot efficiently load contiguous elements from `𝐀` that can best stored directly in `𝐂`. So for `𝐂 = 𝐀ᵀ * 𝐁`, contiguous vectors along the `k`-loop have to be reduced, adding some overhead.
![AtmulB](https://github.com/JuliaSIMD/LoopVectorization.jl/raw/docsassets/docs/src/assets/bench_AtmulB_v2.svg)
Packing is critical for performance here. LoopVectorization does not pack, therefore it is well behind MKL and OpenBLAS, which do. Eigen packs, but is poorly optimized for this CPU architecture.

When both `𝐀` and ` 𝐁` are transposed, we now have `𝐂 = 𝐀ᵀ * 𝐁ᵀ = (𝐁 * 𝐀)ᵀ`.
![AtmulBt](https://github.com/JuliaSIMD/LoopVectorization.jl/raw/docsassets/docs/src/assets/bench_AtmulBt_v2.svg)
Julia, Clang, and gfortran all struggled to vectorize this, because none of the matrices share a contiguous access: `M` for `𝐂`, `K` for `𝐀ᵀ`, and `N` for `𝐁ᵀ`. However, LoopVectorization and all the specialized matrix multiplication functions managed to do about as well as normal; transposing while storing the results takes negligible amounts of time relative to the matrix multiplication itself.
The ifort-loop version also did fairly well.

# Dot Products

[Dot products](https://en.wikipedia.org/wiki/Dot_product) are simple the sum of the elementwise products of two vectors. They can be interpreted geometrically as (after normalizing by dividing by the norms of both vectors) yielding the cosine of the angle between them. This makes them useful for, for example, the [No-U-Turn](http://www.stat.columbia.edu/~gelman/research/published/nuts.pdf) sampler to check for u-turns (i.e., to check if the current momentum is no longer in the same direction as the change in position).

```julia
function jdotavx(a, b)
    s = zero(eltype(a))
    @turbo for i ∈ eachindex(a, b)
        s += a[i] * b[i]
    end
    s
end
```
To execute the loop using SIMD (Single Instruction Multiple Data) instructions, you have to unroll the loop. Rather than evaluating the loop as written -- adding element-wise products to a single accumulator one after the other -- you can multiply short vectors loaded from `a` and `b` and add their results to a vector of accumulators. 

Most modern CPUs found in laptops or desktops have the AVX instruction set, which allows them to operate on 256 bit vectors -- meaning the vectors can hold 4 double precision (64 bit) floats. Some have the AVX512 instruction set, which increases the vector size to 512 bits, and also adds many new instructions that make vectorizing easier. To be general across CPUs and data types, I'll refer to the number of elements in the vectors with `W`. I'll also refer to unrolling a loop by a factor of `W` and loading vectors from it as "vectorizing" that loop.

In addition to vectorizing the loop, we'll want to unroll it by an additional factor. Given that we have single or double precision floating point elements, most recent CPU cores have a potential throughput of two fused multiply-add (`fma`) instructions per clock cycle. However, it actually takes about four clock cycles for any of these instructions to execute; a single core is able to work on several in parallel.

This means that if we used a single vector to accumulate a product, we'd only get to perform one fused multiply add every four clock cycles: we'd have to wait for one instruction to complete before starting the next. By using extra accumulation vectors, we can break up this dependency chain.
If we had 8 accumulators, then theoretically we could perform two per clock cycle, and after the 4th cycle, our first operations are done so that we can reuse them.

However, there is another bottle neck: we can only perform 2 aligned loads per clock cycle (or 1 unaligned load). [Alignment here means with respect to a memory address boundary, if your vectors are 256 bits, then a load/store is aligned if it is with respect to a memory address that is an integer multiple of 32 bytes (256 bits = 32 bytes).]
Thus, in 4 clock cycles, we can do up to 8 loads. But each `fma` requires 2 loads, meaning we are limited to 4 of them per 4 clock cyles, and any unrolling beyond 4 gives us no benefit.

Double precision benchmarks pitting Julia's builtin dot product, and code compiled with a variety of compilers:
![dot](https://raw.githubusercontent.com/JuliaSIMD/LoopVectorization.jl/docsassets/docs/src/assets/bench_dot_v2.svg)
What we just described is the core of the approach used by all these compilers. The variation in results is explained mostly by how they handle vectors with lengths that are not an integer multiple of `W`. I ran these on a computer with AVX512 so that `W = 8`. LLVM, the backend compiler of both Julia and Clang, shows rapid performance degradation as `N % 4W` increases, where `N` is the length of the vectors.
This is because, to handle the remainder, it uses a scalar loop that runs as written: multiply and add single elements, one after the other. 

Initially, GCC (gfortran) stumbled in throughput, because it does not use separate accumulation vectors by default except on Power, even with `-funroll-loops`.
I compiled with the flags `-fvariable-expansion-in-unroller --param max-variable-expansions-in-unroller=4` to allow for 4 accumulation vectors, yielding good performance.

The Intel compilers have a secondary vectorized loop without any additional unrolling that masks off excess lanes beyond `N` (for when `N` isn't an integer multiple of `W`).
LoopVectorization uses `if/ifelse` checks to determine how many extra vectors are needed, the last of which is masked.

Neither GCC nor LLVM use masks (without LoopVectorization's assitance).

I am not certain, but I believe Intel and GCC check for the vector's alignment, and align them if necessary. Julia guarantees that the start of arrays beyond a certain size are aligned, so this is not an optimization I have implemented. But it may be worthwhile for handling large matrices with a number of rows that isn't an integer multiple of `W`. For such matrices, the first column may be aligned, but the next will not be.

## Dot-Self

A related problem is taking the dot product of a vector with itself; taking the sum of squares is a common operation, for example when calculating the (log)density of independent normal variates:
```julia
function jselfdotavx(a)
    s = zero(eltype(a))
    @turbo for i ∈ eachindex(a)
        s += a[i] * a[i]
    end
    s
end
```
Because we only need a single load per `fma`-instruction, we can now benefit from having 8 separate accumulators.
For this reason, LoopVectorization now unrolls by 8 -- it decides how much to unroll by comparing the bottlenecks on throughput with latency. The other compilers do not change their behavior, so now LoopVectorization has the advantage:
![selfdot](https://github.com/JuliaSIMD/LoopVectorization.jl/raw/docsassets/docs/src/assets/bench_selfdot_v2.svg)
This algorithm may need refinement, because Julia (without LoopVectorization) only unrolls by 4, yet achieves roughly the same performance as LoopVectorization at multiples of `4W = 32`, although performance declines rapidly from there due to the slow scalar loop. Performance for most is much higher -- more GFLOPS -- than the normal dot product, but still under half of the CPU's potential 131.2 GFLOPS, suggesting that some other bottlenecks are preventing the core from attaining 2 fmas per clock cycle.
Note also that `8W = 64`, so we don't really have enough iterations of the loop to amortize the overhead of performing the reductions of all these vectors into a single scalar.
By the time the vectors are long enough to do this, we'll start running into memory bandwidth bottlenecks.

# Special Functions

`LoopVectorization` supports vectorizing many special functions, for example, to calculate the log determinant of a triangular matrix:
```julia
function logdettriangle(B::Union{LowerTriangular,UpperTriangular})
    A = parent(B) # using a triangular matrix would fall back to the default loop.
    ld = zero(eltype(A))
    @turbo for n ∈ axes(A,1)
        ld += log(A[n,n])
    end
    ld
end
```
![selfdot](https://github.com/JuliaSIMD/LoopVectorization.jl/raw/docsassets/docs/src/assets/bench_logdettriangle_v2.svg)

While Intel's proprietary compilers do the best, LoopVectorization performs very well among open source alternatives. A complicating
factor to the above benchmark is that in accessing the diagonals, we are not accessing contiguous elements. A benchmark
simply exponentiating a vector shows that `gcc` also has efficient special function vectorization, but that the autovectorizer
disagrees with the discontiguous memory accesses:

![selfdot](https://github.com/JuliaSIMD/LoopVectorization.jl/raw/docsassets/docs/src/assets/bench_exp_v2.svg)

The similar performance between `gfortran` and `LoopVectorization` at multiples of 8 is no fluke: on Linux systems with a recent GLIBC, SLEEFPirates.jl --
which LoopVectorization depends on to vectorize these special functions -- looks for the GNU vector library and uses these functions
if available. Otherwise, it will use native Julia implementations that tend to be slower. As the modulus of vector length and vector width (8, on the
host system thanks to AVX512) increases, `gfortran` shows the performance degradation pattern typical of LLVM-vectorized code.

# Composite Types: DateTime Arrays

Currently, loops over *some* types are easier to work with than others.
Here we show: (1) a sequential loop over `Vector{DateTime}` that cannot have
`@turbo` applied directly, and (2) a solution that uses the interpreted
integer representation of `DateTime`.

This may be applicable if you have a composite type that may be represented
with primitive types.

## Setting up the Problem

Here's a simple problem involving timestamps:

**Problem statement**:

- *Given*: a vector of *strictly increasing* timestamps.
- *Output*: a vector of the same length starting at `0.0` and ending at `1.0`.
  Each intermediate element is scaled proportionally to the length of time since
  the beginning.

**Sample Output**:

```julia
using Dates

sample_input = [
    Dates.DateTime(2021, 5, 5, 10, 0, 0),
    Dates.DateTime(2021, 5, 5, 10, 5, 15),
    Dates.DateTime(2021, 5, 6, 10, 0, 0),
    Dates.DateTime(2021, 5, 6, 10, 5, 15),
    Dates.DateTime(2021, 5, 7, 10, 0, 20),
]

expected_output = [
    0.0,
    0.0018227057053581761,
    0.499942136326814,
    0.5017648420321722,
    1.0,
]
```

## First Attempt: Sequential version of the loop

This implementation satisfies the problem statement by iterating over the
examples:

```julia
using Dates

function scale_timeseries_sequential(data::Vector{Dates.DateTime})
  out = similar(data, Float64)
  ϕ = (data[lastindex(data)] - data[1]).value

  @inbounds for i ∈ eachindex(data)
      out[i] = (data[i] - data[1]).value / ϕ
  end

  return out
end
```

## Second Attempt: Turbo Loop

Our `Vector{Dates.DateTime}` has an integer interpretation which we can take
advantage of here. We'll `reinterpret` our vector as `Int`, make the needed
adjustments, then apply the `@turbo` macro to our loop:

```julia
using LoopVectorization, Dates

function scale_timeseries_turbo(data::Vector{Dates.DateTime})

  # Interpret our DateTime vector as Int
  tsi = reinterpret(Int, data)

  out = similar(data, Float64)

  # We've interpreted our data as integers, so we no longer need `.value`
  ϕ = tsi[lastindex(tsi)] - tsi[1]

  @turbo for i ∈ eachindex(tsi)
      out[i] = (tsi[i] - tsi[1]) / ϕ
  end

  return out
end
```

## Benchmarks

We'll benchmark with randomly generated data:

```julia
function generate_timestamps(N::Int64)
    data = Vector{Dates.DateTime}(undef,N)
    v = DateTime(1990, 1, 1, 0, 0, 0)
    for i in 1:N
        v += Second(rand(1:5, 1)[1])
        data[i] =v
    end
    return data
end
```

Briefly, the benchmark suggests that the mean time for the sequential vs.
turbo solution is a ~3x speedup while holding memory requirements constant:

```julia
julia> using BenchmarkTools

julia> data_100000 = generate_timestamps(100000);

julia> data_200000 = generate_timestamps(200000);

julia> @benchmark scale_timeseries_sequential(data_100000)
BenchmarkTools.Trial: 10000 samples with 1 evaluation.
 Range (min … max):  318.864 μs … 967.760 μs  ┊ GC (min … max): 0.00% … 40.41%
 Time  (median):     321.291 μs               ┊ GC (median):    0.00%
 Time  (mean ± σ):   332.503 μs ±  52.040 μs  ┊ GC (mean ± σ):  1.97% ±  6.98%

  █▆▅▂▂▂▁                                                       ▁
  █████████▆▆▆▅▅▅▅▅▄▄▄▄▁▁▄▁▁▃▁▁▄▄▃▃▁▃▄▁▃▁▁▁▃▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▅█▇ █
  319 μs        Histogram: log(frequency) by time        701 μs <

 Memory estimate: 781.33 KiB, allocs estimate: 2.

julia> @benchmark scale_timeseries_turbo(data_100000)
BenchmarkTools.Trial: 10000 samples with 1 evaluation.
 Range (min … max):   71.942 μs … 933.400 μs  ┊ GC (min … max):  0.00% … 71.93%
 Time  (median):      87.926 μs               ┊ GC (median):     0.00%
 Time  (mean ± σ):   100.082 μs ±  89.095 μs  ┊ GC (mean ± σ):  11.63% ± 11.43%

  ▄█▃▁                                                        ▁ ▁
  ████▇▄▁▁▁▁▁▁▁▁▃▄▆▄▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁█ █
  71.9 μs       Histogram: log(frequency) by time        764 μs <

 Memory estimate: 781.33 KiB, allocs estimate: 2.

julia> @benchmark scale_timeseries_sequential(data_200000)
BenchmarkTools.Trial: 7153 samples with 1 evaluation.
 Range (min … max):  637.692 μs …   2.277 ms  ┊ GC (min … max): 0.00% … 65.01%
 Time  (median):     640.729 μs               ┊ GC (median):    0.00%
 Time  (mean ± σ):   694.282 μs ± 184.965 μs  ┊ GC (mean ± σ):  3.69% ±  8.68%

  █▆▅▃▂▁                                                        ▁
  ███████▇▅▆▆▄▄▅▁▁▁▁▁▁▆██▇▅▄▄▁▃▁▃▃▄▁▁▁▁▁▁▁▁▁▁▁▇█▇▇▅▅▄▃▄▄▁▁▁▄▄█▇ █
  638 μs        Histogram: log(frequency) by time       1.71 ms <

 Memory estimate: 1.53 MiB, allocs estimate: 2.

julia> @benchmark scale_timeseries_turbo(data_200000)
BenchmarkTools.Trial: 10000 samples with 1 evaluation.
 Range (min … max):  159.023 μs …   2.092 ms  ┊ GC (min … max):  0.00% … 50.30%
 Time  (median):     176.559 μs               ┊ GC (median):     0.00%
 Time  (mean ± σ):   230.513 μs ± 189.542 μs  ┊ GC (mean ± σ):  11.86% ± 12.80%

  █▇▅▄▄▃▂▂▁          ▁▁                                         ▂
  ██████████▇▅▅▃▁▄▁▃▁██▇▆▄▅▄▄▅▄▅▃▁▁▁▁▁▁▁▁▁▁▁▁▁▁▁███▇▅▅▅▅▄▅▄▅█▇▇ █
  159 μs        Histogram: log(frequency) by time       1.22 ms <

 Memory estimate: 1.53 MiB, allocs estimate: 2.
```

# Array Interface

LoopVectorization uses [ArrayInterface.jl](https://github.com/SciML/ArrayInterface.jl) to describe the memory layout of arrays. By supporting the interface, `LoopVectorization` will be able to support compatible `AbstractArray` types.
[StaticArrays.jl](https://github.com/JuliaArrays/StaticArrays.jl) and [HybridArrays.jl](https://github.com/mateuszbaran/HybridArrays.jl) are two example libraries providing array types supporting the interface.

`StaticArrays.SArray` itself is not compatible, because `LoopVectorization` needs access to a pointer. However,`StaticArrays.MArray`s are compatible. Loops featuring `StaticArrays.StaticArray` will result in a fall-back loop being executed
that wasn't optimized by `LoopVectorization`, but instead simply had `@inbounds @fastmath` applied to the loop. This can often still yield reasonable to good performance, saving you from having to write more than one version of the loop
to get good performance and correct behavior just because the array types happen to be different.

By supporting the interface, using `LoopVectorization` can simplify implementing many operations like matrix multiply while still getting good performance. For example, instead of [a few hundred lines of code](https://github.com/JuliaArrays/StaticArrays.jl/blob/0e431022954f0207eeb2c4f661b9f76936105c8a/src/matrix_multiply.jl#L4) to define matrix multiplication in `StaticArrays`, one could simply write:
```julia
using StaticArrays, LoopVectorization

@inline function AmulB!(C, A, B)
    @turbo for n ∈ axes(C,2), m ∈ axes(C,1)
        Cmn = zero(eltype(C))
        for k ∈ axes(B,1)
            Cmn += A[m,k] * B[k,n]
        end
        C[m,n] = Cmn
    end
    C
end
@inline AmulB(A::MMatrix{M,K,T}, B::MMatrix{K,N,T}) where {M,K,N,T} = AmulB!(MMatrix{M,N,T}(undef), A, B)
@inline AmulB(A::SMatrix, B::SMatrix) = SMatrix(AmulB(MMatrix(A), MMatrix(B)))
```
Through converting back and fourth between `SMatrix` and `MMatrix`, we can still use `LoopVectorization` to implement `SMatrix` multiplication, and in most cases get better performance than the unrolled methods from the library. Unfortunately, it is still suboptimal because the compiler isn't able to elide the copying, but the temporaries are all stack-allocated, making the code
allocateion free. We can benchmark our simple implementation vs the `StaticArrays.SMatrix` and `StaticArrays.MMatrix` methods:
```julia
using BenchmarkTools, LinearAlgebra, DataFrames, VegaLite
BLAS.set_num_threads(1);

matdims(x::Integer) = (x, x, x)
matdims(x::NTuple{3}) = x
matflop(x::Integer) = 2x^3
matflop(x::NTuple{3}) = 2prod(x)

function runbenches(sr, ::Type{T}, fa = identity, fb = identity) where {T}
    bench_results = Matrix{Float64}(undef, length(sr), 4);
    for (i,s) ∈ enumerate(sr)
        M, K, N = matdims(s)
        Am = @MMatrix rand(T, M, K)
        Bm = @MMatrix rand(T, K, N)
        As = Ref(SMatrix(Am));
        Bs = Ref(SMatrix(Bm));
        Css = fa(As[]) * fb(Bs[]);
        Csl = AmulB(fa(As[]), fb(Bs[]))
        Cms = similar(Css); mul!(Cms, fa(Am), fb(Bm));
        Cml = similar(Css); AmulB!(Cml, fa(Am), fb(Bm));
        @assert Array(Css) ≈ Array(Csl) ≈ Array(Cms) ≈ Array(Cml) # Once upon a time Julia crashed on ≈ for large static arrays
        bench_results[i,1] = @belapsed $fa($As[]) * $fb($Bs[])
        bench_results[i,2] = @belapsed AmulB($fa($As[]), $fb($Bs[]))
        bench_results[i,3] = @belapsed mul!($Cms, $fa($Am), $fb($Bm))
        bench_results[i,4] = @belapsed AmulB!($Cml, $fa($Am), $fb($Bm))
        @show s, bench_results[i,:]
    end
    gflops = @. 1e-9 * matflop(sr) / bench_results
    array_type = append!(fill("Static", 2length(sr)), fill("Mutable", 2length(sr)))
    sa = fill("StaticArrays", length(sr)); lv = fill("LoopVectorization", length(sr));
    matmul_lib = vcat(sa, lv, sa, lv);
    sizes = reduce(vcat, (sr for _ ∈ 1:4))
    DataFrame(
        Size = sizes, Time = vec(bench_results), GFLOPS = vec(gflops),
        ArrayType = array_type, MatmulLib = matmul_lib, MulType = array_type .* ' ' .* matmul_lib
    )
end

df = runbenches(1:24, Float64);
df |> @vlplot(:line, x = :Size, y = :GFLOPS, color = :MulType, height=640,width=960) |> save("sarraymatmul.svg")
```
This yields:
![sarray_benchmarks](https://raw.githubusercontent.com/JuliaSIMD/LoopVectorization.jl/docsassets/docs/src/assets/sarraymatmul.svg)
Our `AmulB!` for `MMatrix`es was the fastest at all sizes except `2`x`2`, where it lost out to `AmulB` for `SMatrix`, which in turn was faster than the hundreds of lines of
`StaticArray`s code at all sizes except `3`x`3`,  `5`x`5`, and  `6`x`6`.



Additionally, `HybridArrays.jl` can be used when we have a mix of dynamic and statically sized arrays. Maybe we want to multiply two matrices, where each element is a `3`x`3` matrix:
```julia
using HybridArrays, StaticArrays, LoopVectorization, BenchmarkTools

A_static = [@SMatrix(rand(3,3)) for i in 1:32, j in 1:32];
B_static = [@SMatrix(rand(3,3)) for i in 1:32, j in 1:32];
C_static = similar(A_static);

A_hybrid = HybridArray{Tuple{StaticArrays.Dynamic(),StaticArrays.Dynamic(),3,3}}(permutedims(reshape(reinterpret(Float64, A_static), (3,3,size(A_static)...)), (3,4,1,2)));
B_hybrid = HybridArray{Tuple{StaticArrays.Dynamic(),StaticArrays.Dynamic(),3,3}}(permutedims(reshape(reinterpret(Float64, B_static), (3,3,size(B_static)...)), (3,4,1,2)));
C_hybrid = HybridArray{Tuple{StaticArrays.Dynamic(),StaticArrays.Dynamic(),3,3}}(permutedims(reshape(reinterpret(Float64, C_static), (3,3,size(C_static)...)), (3,4,1,2)));

# C is M x N x I x J
# A is M x K x I x L
# B is K x N x L x J
function bmul!(C, A, B)
    @turbo for n in axes(C,2), m in axes(C,1), j in axes(C,4), i in axes(C,3)
        Cmnji = zero(eltype(C))
        for k in axes(B,1), l in axes(B,3)
            Cmnji += A[m,k,i,l] * B[k,n,l,j]
        end
        C[m,n,i,j] = Cmnji
    end
end
```
This yields
```julia
julia> @benchmark bmul!($C_hybrid, $A_hybrid, $B_hybrid)
BenchmarkTools.Trial:
  memory estimate:  0 bytes
  allocs estimate:  0
  --------------
  minimum time:     15.550 μs (0.00% GC)
  median time:      15.663 μs (0.00% GC)
  mean time:        15.685 μs (0.00% GC)
  maximum time:     50.286 μs (0.00% GC)
  --------------
  samples:          10000
  evals/sample:     1
  
julia> @benchmark mul!($C_static, $A_static, $B_static)
BenchmarkTools.Trial:
  memory estimate:  336 bytes
  allocs estimate:  6
  --------------
  minimum time:     277.736 μs (0.00% GC)
  median time:      278.035 μs (0.00% GC)
  mean time:        278.310 μs (0.00% GC)
  maximum time:     299.259 μs (0.00% GC)
  --------------
  samples:          10000
  evals/sample:     1

julia> all(I -> C_hybrid[Tuple(I)[1],Tuple(I)[2],:,:] ≈ C_static[I], CartesianIndices(C_static))
true

julia> length(C_hybrid) * size(B_hybrid,1) * size(B_hybrid,3) * 2e-9 / 15.55e-6 # GFLOPS loops + hybrid arrays
113.79241157556271

julia> length(C_hybrid) * size(B_hybrid,1) * size(B_hybrid,3) * 2e-9 / 277.736e-6 # GFLOPS LinearAlgebra.mul! + StaticArrays
6.371057407034018
```
When using `LoopVectorization` + `HybridArrays`, you may often find that you often get the best performance when the leading dimensions are either an even multiple of 8, or relatively large.
This will often mean not leading with a small static dimension, which is commonly best practice when not using `LoopVectorization`.

If you happen to like tensor operations such as from this last example, you're also strongly encouraged to check out [Tullio.jl](https://github.com/mcabbott/Tullio.jl) which provides index-notation that is both much more convenient and much less error-prone than writing out loops, and uses both `LoopVectorization` (if you `using LoopVectorization` before `@tullio`) as well as multiple threads to maximize performance.

# Multithreading

LoopVectorization can multithread loops if you pass the argument `@turbo thread=true for ... end` or equivalently use `@tturbo`. By default, `thread = false`, which runs only a single thread.
You can also supply a numerical argument to set an upper bound on the number of threads, e.g. `@turbo thread=8 for ... end` will use up to `min(8,Threads.nthreads(),VectorizationBase.num_cores())` threads. `VectorizationBase.num_cores()` uses [Hwloc.jl](https://github.com/JuliaParallel/Hwloc.jl) to get the number of physical cores.
Currently, this only works for `for` loops, but support for broadcasting will come.

Lets look at a few benchmarks.

Taking the [first example from the ThreadsX.jl README](https://github.com/tkf/ThreadsX.jl/blob/3ff8264f1c4b92318e836a1994a38ffde0433553/README.md):
```julia
function relative_prime_count(x, N)
    c = 0
    @tturbo for i ∈ 1:N
        c += gcd(x, i) == 1
    end
    c
end
```
Benchmarking them:
```julia
julia> @btime ThreadsX.sum(gcd(42, i) == 1 for i in 1:10_000)
  130.928 μs (3097 allocations: 240.39 KiB)
2857

julia> @btime relative_prime_count(42, 10_000)
  3.376 μs (0 allocations: 0 bytes)
2857
```
Note that much of the performance difference here is thanks to SIMD, which requires AVX512 for good performance (`trailing_zeros`, required by `gcd`, needs AVX512 for a SIMD version).
LoopVectorization is a good choice for loops (a) amenable to SIMD (b) where all arrays are dense and (c) a static schedule would work well. Generally, this means loops built up of
relatively primitive arithmetic operations (e.g. `+`, `/`, or `log`), and not, for example, solving differential equations.

I'll make comparisons with OpenMP through the rest of this, starting with a simple dot product to focus on threading overhead:
```julia
function dot_tturbo(a::AbstractArray{T}, b::AbstractArray{T}) where {T <: Real}
    s = zero(T)
    @tturbo for i ∈ eachindex(a,b)
        s += a[i] * b[i]
    end
    s
end
function dotbaseline(a::AbstractArray{T}, b::AbstractArray{T}) where {T}
    s = zero(T)
    @fastmath @inbounds @simd for i ∈ eachindex(a,b)
        s += a[i]' * b[i]
    end
    s
end
```
In `C`:
```C
#include<omp.h>
//  gcc -Ofast -march=native -mprefer-vector-width=512 -fopenmp -shared -fPIC openmp.c -o libomptest.so
double dot(double* a, double* b, long N){
  double s = 0.0;
  #pragma omp parallel for reduction(+: s)
  for(long n = 0; n < N; n++){
    s += a[n]*b[n];
  }
  return s;
}
```
Wrapping it in Julia is straightforward, after compiling:
```julia
using Libdl; const OPENMPTEST = joinpath(pkgdir(LoopVectorization), "benchmark", "libomptest.$(Libdl.dlext)");
cdot(a::AbstractVector{Float64},b::AbstractVector{Float64}) = @ccall OPENMPTEST.dot(a::Ref{Float64}, b::Ref{Float64}, length(a)::Clong)::Float64
```

Trying out one size to give a perspective on scale:
```julia
julia> N = 10_000; x = rand(N); y = rand(N);

julia> @btime dot($x, $y) # LinearAlgebra
  1.114 μs (0 allocations: 0 bytes)
2480.296446711209

julia> @btime dot_turbo($x, $y)
  761.621 ns (0 allocations: 0 bytes)
2480.296446711209

julia> @btime dot_tturbo($x, $y)
  622.723 ns (0 allocations: 0 bytes)
2480.296446711209

julia> @btime dot_baseline($x, $y)
  1.294 μs (0 allocations: 0 bytes)
2480.2964467112097

julia> @btime cdot($x, $y)
  6.109 μs (0 allocations: 0 bytes)
2480.2964467112092
```
All these times are fairly fast; `wait(Threads.@spawn 1+1)` will typically take much longer than even `@cdot` did here.
![realdot](https://github.com/JuliaSIMD/LoopVectorization.jl/raw/docsassets/docs/src/assets/threadeddotproduct.svg)


Now let's look at a more complex example:
```julia
function dot_tturbo(ca::AbstractVector{Complex{T}}, cb::AbstractVector{Complex{T}}) where {T}
    a = reinterpret(reshape, T, ca)
    b = reinterpret(reshape, T, cb)
    re = zero(T); im = zero(T)
    @tturbo for i ∈ axes(a,2) # adjoint(a[i]) * b[i]
        re += a[1,i] * b[1,i] + a[2,i] * b[2,i]
        im += a[1,i] * b[2,i] - a[2,i] * b[1,i]
    end
    Complex(re, im)
end
```
LoopVectorization currently only supports arrays of type `T <: Union{Bool,Base.HWReal}`. So to support `Complex{T}`, we reinterpret the arrays and then write out the corresponding operations.
The plan is to eventually have LoopVectorization do this automatically, but for now we require this workaround.
Corresponding `C`:
```C
void cdot(double* c, double* a, double* b, long N){
  double r = 0.0, i = 0.0;
  #pragma omp parallel for reduction(+: r, i)
  for(long n = 0; n < N; n++){
    r += a[2*n] * b[2*n  ] + a[2*n+1] * b[2*n+1];
    i += a[2*n] * b[2*n+1] - a[2*n+1] * b[2*n  ];
  }
  c[0] = r;
  c[1] = i;
  return;
}
```
The Julia wrapper:
```julia
function cdot(x::AbstractVector{Complex{Float64}}, y::AbstractVector{Complex{Float64}})
    c = Ref{Complex{Float64}}()
    @ccall OPENMPTEST.cdot(c::Ref{Complex{Float64}}, x::Ref{Complex{Float64}}, y::Ref{Complex{Float64}}, length(x)::Clong)::Cvoid
    c[]
end
```

The complex dot product is more compute bound. Given the same number of elements, we require `2x` the memory for complex numbers, `4x` the floating point arithmetic,
and as we have an array of structs rather than structs of arrays, we need additional instructions to shuffle the data.
![complexdot](https://github.com/JuliaSIMD/LoopVectorization.jl/raw/docsassets/docs/src/assets/threadedcomplexdotproduct.svg)


If we take this further to the three-argument dot product, which isn't implemented in BLAS, `@tturbo` now holds a substantial advantage over the competition:
```julia
function dot3(x::AbstractVector{Complex{T}}, A::AbstractMatrix{Complex{T}}, y::AbstractVector{Complex{T}}) where {T}
    xr = reinterpret(reshape, T, x);
    yr = reinterpret(reshape, T, y);
    Ar = reinterpret(reshape, T, A);
    sre = zero(T)
    sim = zero(T)
    @tturbo for n in axes(Ar,3)
        tre = zero(T)
        tim = zero(T)
        for m in axes(Ar,2)
            tre += xr[1,m] * Ar[1,m,n] + xr[2,m] * Ar[2,m,n]
            tim += xr[1,m] * Ar[2,m,n] - xr[2,m] * Ar[1,m,n]
        end
        sre += tre * yr[1,n] - tim * yr[2,n]
        sim += tre * yr[2,n] + tim * yr[1,n]
    end
    Complex(sre, sim)
end
```

```C
void cdot3(double* c, double* x, double* A, double* y, long M, long N){
  double sr = 0.0, si = 0.0;
#pragma omp parallel for reduction(+: sr, si)
  for (long n = 0; n < N; n++){
    double tr = 0.0, ti = 0.0;
    for(long m = 0; m < M; m++){
      tr += x[2*m] * A[2*m   + 2*n*N] + x[2*m+1] * A[2*m+1 + 2*n*N];
      ti += x[2*m] * A[2*m+1 + 2*n*N] - x[2*m+1] * A[2*m   + 2*n*N];
    }
    sr += tr * y[2*n  ] - ti * y[2*n+1];
    si += tr * y[2*n+1] + ti * y[2*n  ];
  }
  c[0] = sr;
  c[1] = si;
  return;
}
```
The wrapper is more or less the same as before:
```julia
function cdot(x::AbstractVector{Complex{Float64}}, A::AbstractMatrix{Complex{Float64}}, y::AbstractVector{Complex{Float64}})
    c = Ref{Complex{Float64}}()
    M, N = size(A)
    @ccall OPENMPTEST.cdot3(c::Ref{Complex{Float64}}, x::Ref{Complex{Float64}}, A::Ref{Complex{Float64}}, y::Ref{Complex{Float64}}, M::Clong, N::Clong)::Cvoid
    c[]
end
```
![complexdot3](https://github.com/JuliaSIMD/LoopVectorization.jl/raw/docsassets/docs/src/assets/threadedcomplexdot3product.svg)

When testing on my laptop, the `C` implementation ultimately won, but I will need to investigate further to tell whether this benchmark benefits from hyperthreading,
or if it's because LoopVectorization's memory access patterns are less friendly.
I plan to work on cache-level blocking to increase memory friendliness eventually, and will likely also allow it to take advantage of hyperthreading/simultaneous multithreading, although I'd prefer a few motivating test problems to look at first. Note that a single core of this CPU is capable of exceeding 100 GFLOPS of double precision compute. The execution units are spending most of their time idle. So the question of whether hypthreading helps may be one of whether or not we are memory-limited.

For a more compute-limited operation, lets look at matrix multiplication, which requires `O(N³)` compute for `O(N²)` memory. Note that it's still easy to be memory-starved in matrix multiplication, especially for larger matrices. While the total memory required may be `O(N²)`, if the memory doesn't fit in the high cache levels, it will have to churn through it. The memory bandwidth requirements are thus `O(N³)`, but cache-level blocking can give it a small enough coefficient that you can make the most of your CPU's theoretical compute.
Unlike all the dot product cases (including the 3-argument dot product), which force you to stream most of the memory through the cores. There is no reuse on `x` and `y` for the 2-arg dot products, or on memory from `A` in the the 3-arg dot product.

Here, I compare against other libraries: Intel MKL, OpenBLAS (Julia's default), and two Julia libraries: [Tullio.jl](https://github.com/mcabbott/Tullio.jl) and [Octavian.jl](https://github.com/JuliaLinearAlgebra/Octavian.jl).
```julia
function A_mul_B!(C, A, B)
    @tturbo for n ∈ indices((C,B), 2), m ∈ indices((C,A), 1)
        Cmn = zero(eltype(C))
        for k ∈ indices((A,B), (2,1))
            Cmn += C[m,k] * B[k,n]
        end
        C[m,n] = Cmn
    end
end
```
Benchmarks over the size range `10:5:300`:
![matmul](https://raw.githubusercontent.com/JuliaSIMD/LoopVectorization.jl/docsassets/docs/src/assets/gemm_Float64_10_500_cascadelake_AVX512__multithreaded.svg)

Because LoopVectorization doesn't do cache optimizations yet, MKL, OpenBLAS, and Octavian will all pull ahead for larger matrices. This CPU has a 1 MiB L2 cache per core and 18 cores:
```julia
julia> doubles_per_l2 = (2 ^ 20) ÷ 8
131072

julia> total_doubles_in_l2 = doubles_per_l2 * (Sys.CPU_THREADS ÷ 2) # doubles_per_l2 * 18
2359296

julia> doubles_per_mat = total_doubles_in_l2 ÷ 3 # divide up among 3 matrices
786432

julia> sqrt(ans)
886.8100134752651
```
Meaning we could fit three 886x886 matrices in our L2 cache by splitting them up among the cores. The largest matrices benchmarked above, at 300x300, fit comfortably.

Aside from the fact that LoopVectorization did much better than OpenBLAS--Julia's default library--over this size range, LoopVectorization's major advantage that it should perform similarly well for a wide variety of comparable operations and not just GEMM (GEneral Matrix-Matrix multiplication) specifically. GEMM has long been a motivating benchmark, as it's one of the best optimized routines available to compare against and get a sense of how well you're doing vs hand-tuned limits optimized in assembly.

Because it is so well optimized, a standard trick for implementing more general optimized routines is to convert them into GEMM calls. For example, this is commonly done for tensor operations (see, e.g., [TensorOperations.jl](https://github.com/Jutho/TensorOperations.jl)) as well as for convolutions, e.g. in [NNlib](https://github.com/FluxML/NNlib.jl/blob/ca82fb23928c7ee7d08afb722718cf93be13f81c/src/impl/conv_im2col.jl#L25)'s `conv_im2col!`, their default optimized convolution function.

Lets take a look at convolutions as our next example. We create a batch of a hundred 256x256 images with 3 input channels, and convolve them with a 5x5 kernel producing 6 output channels.
```julia
using NNlib, LoopVectorization, Static

img = rand(Float32, 260, 260, 3, 100);
kern = rand(Float32, 5, 5, 3, 6);
out1 = Array{Float32}(undef, size(img,1)+1-size(kern,1), size(img,2)+1-size(kern,2), size(kern,4), size(img,4));
out2 = similar(out1);

dcd = NNlib.DenseConvDims(img, kern, flipkernel = true);

function kernaxes(::DenseConvDims{2,K,C_in, C_out}) where {K,C_in, C_out} # LoopVectorization can take advantage of static size information
    K₁ =  StaticInt(1):StaticInt(K[1])
    K₂ =  StaticInt(1):StaticInt(K[2])
    Cᵢₙ =  StaticInt(1):StaticInt(C_in)
    Cₒᵤₜ = StaticInt(1):StaticInt(C_out)
    (K₁, K₂, Cᵢₙ, Cₒᵤₜ)
end

function convlayer!(out::AbstractArray{<:Any,4}, img, kern, dcd::DenseConvDims)
    (K₁, K₂, Cᵢₙ, Cₒᵤₜ) = kernaxes(dcd)
    @tturbo for j₁ ∈ axes(out,1), j₂ ∈ axes(out,2), d ∈ axes(out,4), o ∈ Cₒᵤₜ
        s = zero(eltype(out))
        for k₁ ∈ K₁, k₂ ∈ K₂, i ∈ Cᵢₙ
            s += img[j₁ + k₁ - 1, j₂ + k₂ - 1, i, d] * kern[k₁, k₂, i, o]
        end
        out[j₁, j₂, o, d] = s
    end
    out
end
```
LoopVectorization likes to take advantage of any static size information when available, so we write `kernaxes` to extract them from the `DenseConvDims` object and produce statically sized axes. Otherwise, this code is simply writing the convolutions as a bunch of loops.

This yields:
```julia
julia> NNlib.conv!(out2, img, kern, dcd);

julia> convlayer!(out1, img, kern, dcd);

julia> out1 ≈ out2
true

julia> @benchmark convlayer!($out1, $img, $kern, $dcd)
BenchmarkTools.Trial:
  memory estimate:  0 bytes
  allocs estimate:  0
  --------------
  minimum time:     5.377 ms (0.00% GC)
  median time:      5.432 ms (0.00% GC)
  mean time:        5.433 ms (0.00% GC)
  maximum time:     5.682 ms (0.00% GC)
  --------------
  samples:          920
  evals/sample:     1

julia> @benchmark NNlib.conv!($out2, $img, $kern, $dcd)
BenchmarkTools.Trial:
  memory estimate:  675.02 MiB
  allocs estimate:  195
  --------------
  minimum time:     182.749 ms (0.00% GC)
  median time:      190.472 ms (0.60% GC)
  mean time:        197.527 ms (4.98% GC)
  maximum time:     300.536 ms (35.82% GC)
  --------------
  samples:          26
  evals/sample:     1
```
By default, the BLAS library called uses multiple threads, but `NNlib` also threads over the batches using `Threads.@threads`. This oversubscribes the threads. We thus improve performance by forcing `BLAS` to use just a single thread, favoring the more granular threading across batches:
```julia
julia> using LinearAlgebra

julia> BLAS.set_num_threads(1)

julia> @benchmark NNlib.conv!($out2, $img, $kern, $dcd)
BenchmarkTools.Trial:
  memory estimate:  675.02 MiB
  allocs estimate:  195
  --------------
  minimum time:     124.177 ms (0.00% GC)
  median time:      128.609 ms (0.93% GC)
  mean time:        133.574 ms (5.36% GC)
  maximum time:     235.760 ms (45.17% GC)
  --------------
  samples:          38
  evals/sample:     1
```
This still nets `@tturbo` a 23x advantage on this machine!


## FAQ
#### If I do `@turbo thread=true for ... end`, how many threads will it use? Or if I do `@turbo thread=4 for ... end`, what then?

LoopVectorization will choose how many threads to use based on the length of the loop ranges and how expensive it estimates evaluating the loop to be. It will at most use one thread per physical core of the system.

#### How do I get answers to my questions?

Feel free to ask on [Discourse](https://discourse.julialang.org/), [Zulip](https://julialang.zulipchat.com/#narrow/stream/225542-helpdesk), [Slack](https://julialang.slack.com/), or [GitHub Discussions](https://github.com/JuliaSIMD/LoopVectorization.jl/discussions)! I can also add it to the FAQ here, or one in an appropriate section.

# Sum of squared error

To calculate `(y - X * β)'(y - X * β)`, we can use the following loop.
```julia
function sse_avx(y, X, β)
    lp = zero(eltype(y))
    @turbo for i ∈ eachindex(y)
        δ = y[i]
        for j ∈ eachindex(β)
            δ -= X[i,j] * β[j]
        end
        lp += δ * δ
    end
    lp
end
```

This example demonstrates the importance of (not) modeling memory bandwidth and cache, as the performance quickly drops dramatically.
However, it still does much better than all the compiled loops, with only the BLAS `gemv`-based approach matching (and ultimately beating) it in performance, while the other compilers lagged well behind.

Performance starts to degrade for sizes larger than 60. Letting `N` be the size, `X` was a `3N/2`x `N/2` matrix. Therefore, performance started to suffer
when `X` had more than about 30 columns (performance is much less sensitive to the number of rows).

![sse](https://github.com/JuliaSIMD/LoopVectorization.jl/raw/docsassets/docs/src/assets/bench_sse_v2.svg)

# Image Filtering

Here, we convolve a small matrix `kern` with a larger matrix `A`, storing the results in `out`, using Julia's generic [Cartesian Indexing](https://julialang.org/blog/2016/02/iteration/):
```julia
using LoopVectorization, OffsetArrays, Images
kern = Images.Kernel.gaussian((1, 1), (3, 3))
A = rand(130,130);
out = OffsetArray(similar(A, size(A) .- size(kernel) .+ 1), -1 .- kernel.offsets);
function filter2davx!(out::AbstractMatrix, A::AbstractMatrix, kern)
    @turbo for J in CartesianIndices(out)
        tmp = zero(eltype(out))
        for I ∈ CartesianIndices(kern)
            tmp += A[I + J] * kern[I]
        end
        out[J] = tmp
    end
    out
end
```
These are effectively four nested loops. For all the benchmarks, `kern` was 3 by 3, making it too small for vectorizing these loops to be particularly profitable. By vectorizing an outer loop instead, it can benefit from SIMD and also avoid having to do a reduction (horizontal addition) of a vector before storing in `out`, as the vectors can then be stored directly.
![dynamicfilter](https://github.com/JuliaSIMD/LoopVectorization.jl/raw/docsassets/docs/src/assets/bench_filter2d_dynamic_v2.svg)

LoopVectorization achieved much better performance than all the alternatives, which tried vectorizing the inner loops.
By making the compilers aware that the inner loops are too short to be worth vectorizing, we can get them to vectorize an outer loop instead. By defining the size of `kern` as constant in `C` and `Fortran`, and using size parameters in Julia, we can inform the compilers:
![staticsizefilter](https://github.com/JuliaSIMD/LoopVectorization.jl/raw/docsassets/docs/src/assets/bench_filter2d_3x3_v2.svg)
Now all are doing much better than they were before, although still well shy of the 131.2 GFLOPS theoretical limit for the host CPU cores. While they all improved, two are lagging behind the main group:
- `ifort` lags behind all the others except base Julia. I'll need to do more investigating to find out why.
- Base Julia. While providing static size information was enough for it to realize vectorizing the inner loops was not worth it, base Julia was seemingly the only one that didn't decide to vectorize an outer loop instead.

Manually unrolling the inner loops allows base Julia to vectorize, while the performance of all non-Julia variants was unchanged:
![unrolledfilter](https://github.com/JuliaSIMD/LoopVectorization.jl/raw/docsassets/docs/src/assets/bench_filter2d_unrolled_v2.svg)
LoopVectorization is currently limited to only unrolling two loops (but a third may be vectorized, effectively unrolling it by the length of the vectors). Manually unrolling two of the loops lets up to four loops be unrolled.
